#ifdef __GNUC__
#pragma implementation
#endif

#include "Class.h"
#include "ClassStar.h"
#include "FileObject.h"
#include "FileObjectStar.h"
#include "FileSystemInterface.h"
#include "FileSystemInterfaceStar.h"
#include "FreeRunningTimer.h"
#include "MemoryObjectContainer.h"
#include "MemoryObjectContainerStar.h"
#include "MemoryObjectDictionary.h"
#include "MemoryObjectDictionaryStar.h"
#include "NameServer.h"
#include "OutputStream.h"
#include "PersistentArray.h"
#include "PersistentArrayStar.h"
#include "PersistentMemoryObject.h"
#include "PersistentMemoryObjectStar.h"

// Francis TODO TOFIX
#define O_NCACHE 0

int arActivate(char * path, int hint)
{
	 FreeRunningTimer * SystemTimer  = (FreeRunningTimer *)
		 (ProxiableObject *) StandardNameServer->lookup
			 ("SystemTimer", "FreeRunningTimer" );
	 Assert(SystemTimer != 0);

	 FileSystemInterfaceStar FSI = 
		  (FileSystemInterface*)StandardNameServer->lookup("fileSystemInterface",
					     "FileSystemInterface");
	 Assert(FSI != 0);

	 ClassStar PersistentArrayClass = 
		 (Class*)StandardNameServer->lookup("PersistentArray", "Class");
	 Assert(PersistentArrayClass != 0);

	 ClassStar PersistentMemoryObjectClass = 
		 (Class*)StandardNameServer->lookup("PersistentMemoryObject", "Class");
	 Assert(PersistentMemoryObjectClass != 0);

	 ClassStar MemoryObjectContainerClass = 
		 (Class*)StandardNameServer->lookup("ArContainer", "Class");
	 Assert(MemoryObjectContainerClass != 0);

	 unsigned start = SystemTimer->time();

	 int status = 0;

	 MemoryObjectContainerStar container =
		 (MemoryObjectContainer*)FSI->open(path, MemoryObjectContainerClass, status,
			   hint << 28);
	 Assert(container != 0 && status == 0);
	 
	 int size = container->size();

	 for(int i = 2; i < size; i++) {

		 FileObjectStar fo = 
			 container->open(i, status, O_NCACHE);
		 Assert(fo != 0 && status == 0);
		 fo = 0;

	 }

	 unsigned end = SystemTimer->time();

	 Console() << "Time to activate " << size << " objects " 
		 << " from ar container " << path << ":\n" <<eor;
	 Console() << (end-start) << "msec\n" << eor;

	 return 0;
}

int normalActivate(char * path)
{
	 FreeRunningTimer * SystemTimer  = (FreeRunningTimer *)
		 (ProxiableObject *) StandardNameServer->lookup
			 ("SystemTimer", "FreeRunningTimer" );
	 Assert(SystemTimer != 0);

	 FileSystemInterfaceStar FSI = 
		  (FileSystemInterface*)StandardNameServer->lookup("fileSystemInterface",
					     "FileSystemInterface");
	 Assert(FSI != 0);

	 ClassStar PersistentArrayClass = 
		 (Class*)StandardNameServer->lookup("PersistentArray", "Class");
	 Assert(PersistentArrayClass != 0);

	 ClassStar PersistentMemoryObjectClass = 
		 (Class*)StandardNameServer->lookup("PersistentMemoryObject", "Class");
	 Assert(PersistentMemoryObjectClass != 0);

	 ClassStar MemoryObjectContainerClass = 
		 (Class*)StandardNameServer->lookup("ArContainer", "Class");
	 Assert(MemoryObjectContainerClass != 0);

	 int status = 0;
	 MemoryObjectContainerStar container =
		 (MemoryObjectContainer*)FSI->open(path, MemoryObjectContainerClass, status);
	 Assert(container != 0 && status == 0);

	 int size = container->size();

	 char pathnames[16384];
	 MemoryObjectContainerStar fileContainer = 0;
	 int * idNumbers = new int[size];
	 Assert(idNumbers != 0);
	 
	 MemoryObjectDictionaryStar dict = container->rootDictionary();
	 Assert(dict != 0);
	 int noKeys;
	 status = dict->keys(pathnames, sizeof(pathnames), noKeys);
	 Assert(status == 0);

	 status = FSI->chdir("/usr/Choices/man1");
	 Assert(status == 0);

	 char * currentPath = pathnames;
	 char * p = currentPath;
     int i;
	 for(i = 0; i < noKeys; i++) {
		 while(*p != '\n') p++;
		 *p++ = 0;
		 
		 if (i < 2) {
			 currentPath = p;
			 idNumbers[i] = 0;
			 continue;
		 }

		 Console() << "testing for " << currentPath << "\n" << eor;
		 FileObjectStar fo = (FileObject*)FSI->open(currentPath, 
					       PersistentMemoryObjectClass,
					       status);
		 Assert(fo != 0 && status == 0);
		 MemoryObjectContainerStar foContainer = fo->container();
		 int idNumber = fo->idNumber();
		 idNumbers[i] = idNumber;
		 if (fileContainer == 0) {
			 fileContainer = foContainer;
		 } else {
			 Assert(foContainer == fileContainer);
		 }

		 fo = 0;
		 currentPath = p;
	 }

	 Assert(fileContainer != 0);

	 FSI->synchronize();

	 unsigned start = SystemTimer->time();

	 for(i = 0; i < noKeys; i++) {

		 if (idNumbers[i] == 0)
			 continue;
		 FileObjectStar fo = fileContainer->open(idNumbers[i], 
							 status, O_NCACHE);
		 Assert(fo != 0 && status == 0);
		 fo = 0;

	 }

	 fileContainer = 0;

	 unsigned end = SystemTimer->time();

	 Console() << "Time to activate " << noKeys << " objects " 
		 << " from bsd container :\n" <<eor;
	 Console() << (end-start) << "msec\n" << eor;

	 return 0;
}

int
main(int argc, char *argv[])
{
	Assert(argc == 3);
	char * path = argv[1];
	int hint = *argv[2] - '0';
	int result = arActivate(path, hint);
	if (result != 0)
		return result;
	result = normalActivate(path);
	return result;
}
