#ifdef __GNUC__
#pragma implementation
#endif

#include "OutputStream.h"
#include "Process.h"
#include "ProcessStar.h"
#include "Assert.h"
#include "String.h"
#include "NameServer.h"
#include "DistributedNameServer.h"
#include "MessagePort.h"
#include "Message.h"
#include "ThisProcess.h"
#include "FreeRunningTimer.h"
#include "FreeRunningTimerStar.h"

clientProcess( int, char ** )
{
    StandardOutput->formattedWrite ("In client process \n");
    StandardOutput->flush();
   DistributedNameServer *StandardDistributedNameServer = (DistributedNameServer *)(ProxiableObject *)StandardNameServer-> lookup("StandardDistributedNameServer", "DistributedNameServer");

    MessagePort *Server = StandardDistributedNameServer -> lookup ("Server", "MessagePort");
    Assert (Server != 0);

   ReceiverMessagePort *recport = new ReceiverMessagePort ("Client");

    Assert (recport != 0);

    char * buf = new char[1024];
    RPCMessage rmsg(buf,1024,0);

    rmsg.setReplyPort(recport);
    rmsg.setDestination(Server);

    char programName [] = "RPCdemo";

    strcpy(buf,programName);

    rmsg.setUserData (buf,strlen (programName) + 1);

    StandardOutput->formattedWrite ("Client: About to send message\n");
    StandardOutput->formattedWrite ("message: %s\n",rmsg.data());
    StandardOutput->flush();
    rmsg.rpc();
    Console() << "\n Client Got reply: "
	<< (char *) rmsg.data() << eor;
}


int
main(int, char **) {
	ProcessStar p = new ApplicationProcess (clientProcess);
        Assert( p != 0);
        p->setName( "#clientProcess");
        p->ready();
}

