#ifdef __GNUC__
#pragma implementation
#endif

#include "OutputStream.h"

#define	_U	01
#define	_L	02
#define	_N	04
#define	_S	010
#define _P	020
#define _C	040
#define _X	0100
#define	_B	0200

extern	char	_Ctype_[];

#define	isalpha(c)	((_Ctype_+1)[c]&(_U|_L))
#define	isupper(c)	((_Ctype_+1)[c]&_U)
#define	islower(c)	((_Ctype_+1)[c]&_L)
#define	isdigit(c)	((_Ctype_+1)[c]&_N)
#define	isxdigit(c)	((_Ctype_+1)[c]&(_N|_X))
#define	isspace(c)	((_Ctype_+1)[c]&_S)
#define ispunct(c)	((_Ctype_+1)[c]&_P)
#define isalnum(c)	((_Ctype_+1)[c]&(_U|_L|_N))
#define isprint(c)	((_Ctype_+1)[c]&(_P|_U|_L|_N|_B))
#define isgraph(c)	((_Ctype_+1)[c]&(_P|_U|_L|_N))
#define iscntrl(c)	((_Ctype_+1)[c]&_C)
#define isascii(c)	((unsigned)(c)<=0177)
#define toupper(c)	((c)-'a'+'A')
#define tolower(c)	((c)-'A'+'a')
#define toascii(c)	((c)&0177)

static const int asize = 65536;

static char *
SkipWhite(char * a)
{
	// Avoid null pointers.
	if (a == 0)
		return((char *) 0);

	// Skip white space.
	// Return pointer to first character past white space.
	while (*a && isascii(*a) && isspace(*a))
		a++;
	return(a);
}


/*
 * this only works for bases <= 10
 */
static int
atoi(char * a, int base)
{
	int i = 0;			// Value.
	int sign = 1;			// Sign of value (presume positive).

	// Avoid null pointers.
	if (a == 0)
		return(0);

	// Skip initial blanks.
	a = SkipWhite(a);

	// Handle possible initial sign.
	if (*a == '-') {		// Value is negative.
		sign = -1;
		a++;
	} else if (*a == '+') {		// Value is positive.
		a++;
	}

	// Get value.
	while (*a && isascii(*a) && isdigit(*a)) {
		i = (i * base) + (int) (*a - '0');
		a++;
	}

	// Adjust value for sign.
	i *= sign;

	// Return value.
	return(i);
}

// To be compiled with a heap of 1400,12 in SystemInterface/Portable/_new_All.
int
main( int argc, char **argv )
{
    int num;
    
    StandardOutput->formattedWrite( "hello sailor!\n" );
    
    switch(argc) {
      case 1:
	num = 8;
	break;
      case 2:
	StandardOutput->formattedWrite( "Input is %d\n",atoi(argv[1],10) );
	num = atoi(argv[1],10);
	break;
      default:
	StandardOutput->formattedWrite( "Usage: MemoryHog NumberOf100kBlocks\n");
	return(1);
    }
    
    for( int i = 0; i < num; i++ ) {
	char * c = new char[asize];
	StandardOutput->formattedWrite( "c = %x\n",c);
	for (int j=0; j < asize; j+=1024)
		c[j] = 'a';
	StandardOutput->formattedWrite( "i = %d\n",i);
    }
    
    StandardOutput->formattedWrite( "goodbye sailor!\n" );
    
    return(0);
}
