#ifdef __GNUC__
#pragma implementation
#endif

#include "Byte.h"
#include "Convert.h"
#include "FileSystemInterface.h"
#include "FileSystemInterfaceStar.h"
#include "FreeRunningTimer.h"
#include "NameServer.h"
#include "OutputStream.h"
#include "RecordStream.h"
#include "RecordStreamStar.h"

class Class;
char * infile = "/tmp/infile";

// file buffer
static char buffer[16384];

int
main( int argc, char ** argv )
{
  unsigned int start, end, micros, err;
  int cnt, total, repeats, rate;


// get timer
 FreeRunningTimer * SystemTimer  = (FreeRunningTimer *)(ProxiableObject *)
	StandardNameServer->lookup("SystemTimer", "FreeRunningTimer" );

  Assert (SystemTimer != 0);
  
// get file system
 StandardOutput->formattedWrite( "Getting fileSystemInterface\n");
 FileSystemInterfaceStar FSI = (FileSystemInterface*)StandardNameServer->lookup("fileSystemInterface",
							 "FileSystemInterface");
 Assert (FSI != 0);

// Open it
  ClassStar RFSC = (Class*)StandardNameServer->lookup( "RecordStream", "Class" );

  Assert (RFSC != 0);

  RecordStreamStar infs = (RecordStream*)FSI->open((char *)infile, (Class *)RFSC, (int&)err);

  if(err)  
    {
      StandardOutput->formattedWrite( "*** error %d while opening input file \n", err);
    return 1;
    }

  StandardOutput->formattedWrite( "Begin read test\n");
  //Assert (infs != 0)("%s opened but infs == 0\n", infile);
  
  // begin test


    if (argc == 1) {
	repeats = 1;
    } else {
	repeats = atoi(argv[1]);
    }
    total = 0;

  StandardOutput->formattedWrite( "repeating %d times\n", repeats );
    start = SystemTimer->time();
    for ( ; repeats > 0; repeats--) {
      infs->setRecordNumber(0,0);
	while (1) {
	    cnt = infs->read(buffer, 8192);
	    total += cnt;
	    if (cnt < 8192) 
		    break;
	}
    }
  
    end = SystemTimer->time();
    micros = end - start;
    rate = total/ micros;
    rate *=1000000;
    StandardOutput->formattedWrite("%d bytes read", total);
    StandardOutput->formattedWrite(" at %d bytes/sec.\n", rate);

    return(0);
}

