#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989 The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Aamod Sane (sane@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

// Talk across distributed shared virtual memory

#include "NameServer.h"
#include "VMInterface.h"
#include "VMInterfaceStar.h"
#include "OutputStream.h"
#include "InputStream.h"
#include "Ctype.h"
#include "Convert.h"
#include "String.h"

class Class;
class MemoryObjectCache;

char *
gets( char * str )
{
    int count = StandardInput->read( str, 1024 );
    if( ( count == 1 ) && (str[0] == 4 ) ) return( 0 );
    return( chop( str, '\n' ) );
}

#define printf StandardOutput->formattedWrite

int
main( int argc, char ** argv )
{
    int    size = 16000;
    int    numcopies = 2;
    char * mo   = "ZeroFile";
    int	   self = 0;
    int	   other = 0;
    
    
    switch(argc)
    {
      case 3:
	mo = argv[1];
	self = atoi(argv[2]);
	other = !self;
	printf("%s: file %s, self %d, other %d\n",
	       argv[0], mo, self, other);
	break;
      default:
	printf( "Usage: %s CopyId\n", argv[0]);
	return(1);
	break;
    }
    
    printf( "Getting VMInterface\n" );
    VMInterfaceStar VMI = StandardNameServer->lookup("vmInterface", "VMInterface");
    Assert( VMI != 0 );
    VMI->test("*** Hello this is VMI");
    
    printf( "*** Doing DVM Setup\n" );
    volatile char * address = VMI->openDVM(mo);
    if (0 == address) {
	printf("DVM Setup Failed\n");
	return 1;
    }
    
    char cmdline[1024];
    
    char * message = address+100;
    
    address[self] = 'n';
    
    for(;;) {
	printf("\n\n*** What now: ");
	gets(cmdline);

#define command(c) (strcmp(cmdline,(c)) == 0)

	if (command("q"))
	{
	    address[self] = 'q';
	    break;
	}
	else if (command("r"))
	{
	    address[self] = 'r';
	    while(address[other] != 'd')
		;
	    printf("\n*** What the other guy said: %s\n",message);
	    address[self] = 'n';
	    address[other] = 'n';
	}
	else if (command("x"))
	{
	    while(address[other] == 'n')
		;
	    switch(address[other]) {
	      case 'r':
		printf("\n*** Enter message: ");
		gets(cmdline);
		printf("%s\n",cmdline);
		strcpy(message,cmdline);
		address[self] = 'd';
		break;
	      default:
		Assert(NOTREACHED);
		break;
	    }
		
	}
    }
    
    StandardOutput->formattedWrite("*** %d Closing\n",self);
    VMI->closeDVM(mo);
    
    StandardOutput->formattedWrite("*** %d Done\n",self);
    return 0;
}
