#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989 The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Aamod Sane (sane@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

#include "NameServer.h"
#include "VMInterface.h"
#include "VMInterfaceStar.h"
#include "OutputStream.h"

int
main( int argc, char ** argv )
{
    StandardOutput->formattedWrite( "Getting VMInterface\n" );
    VMInterfaceStar VMI = StandardNameServer->lookup("vmInterface", "VMInterface");
    Assert( VMI != 0 );

    VMI->test("Hello from the VM interface");
    StandardOutput->formattedWrite( "Done\n" );
    return 0;
}
