#ifdef __GNUC__
#pragma implementation
#endif

#include "Byte.h"
#include "Convert.h"
#include "FileSystemInterface.h"
#include "FileSystemInterfaceStar.h"
#include "FreeRunningTimer.h"
#include "NameServer.h"
#include "OutputStream.h"
#include "RecordStream.h"
#include "RecordStreamStar.h"

class Class;

char * outfile = "/tmp/outfile";
const int openOrCreate = 1;
char buffer[16384];

int
main(int argc, char ** argv)
{
  unsigned int start, end, micros, err,i;
  int total, repeats, rate, numK ;

    if (argc < 2) {
	    StandardOutput->formattedWrite("Usage: Write numWrites [repeats]\n");
	    return(1);
    }

    numK = atoi(argv[1]);

    if (argc == 2) {
	repeats = 1;
    } else {
	repeats = atoi(argv[2]);
    }
    total = 0;

// get timer
  FreeRunningTimer * SystemTimer  = (FreeRunningTimer *)(ProxiableObject *)
	 StandardNameServer->lookup("SystemTimer", "FreeRunningTimer" );
  Assert (SystemTimer != 0);
  
// get file system
 FileSystemInterfaceStar FSI = (FileSystemInterface*)StandardNameServer->lookup("fileSystemInterface",
							"FileSystemInterface");
 Assert(FSI != 0);

  ClassStar WFSC = (Class*)StandardNameServer->lookup("RecordStream","Class");
  if (WFSC == 0) {
	StandardOutput->formattedWrite( 
		"No Class RecordStream from StandardNameServer\n");

	return 1;
	}
  Assert (WFSC != 0);

// Open it
  err = 0;
  RecordStreamStar outfs = (RecordStream *)FSI->open((char *)outfile, (Class *)WFSC, (int&)err);

  if(err || (outfs == 0))  
    {
      StandardOutput->formattedWrite( "*** error %d while openning outfile \n",
	err );
    return 1;
    }

  //Assert (outfs != 0)("%s opened but outfs == 0\n", outfile);
    


  StandardOutput->formattedWrite( "repeating %d times\n", repeats );
    start = SystemTimer->time();
    for ( ; repeats > 0; repeats--) {
      outfs->setRecordNumber(0,0);
      for (i = numK; i > 0; ) {
	if (i > 8) {
	  int written = outfs->write(buffer, 8192);
	  total += written;
	  i -= 8;
	} else {
	  int written =outfs->write(buffer, 1024*i - 1);
	  total += written;
	  i = 0;
	}
      }
    }

    end = SystemTimer->time();
    micros = end - start;
    rate = total/micros;
    rate *= 1000000;
    StandardOutput->formattedWrite("%d bytes written", total);
    StandardOutput->formattedWrite("at %d bytes/sec.\n", rate);

    return(0);
}

