#ifdef __GNUC__
#pragma implementation
#endif

// code snarfed from bcopy.c

#include "Byte.h"
#include "Convert.h"
#include "FreeRunningTimer.h"
#include "NameServer.h"
#include "OutputStream.h"

#define NTRIES 100000
#define COUNTS 10000000

class Class;

/*
 * Different amounts to copy at once:
 */

int sizes[] =
	{10, 50, 100, 500, 1000, 5000, 10000, 50000, 100000, -1};

#define MAX_AT_ONCE 500000
char src[MAX_AT_ONCE], dst[MAX_AT_ONCE];

int
main( int argc, char ** argv )
{
  register int *sizePtr;
  int totalBytes, bytesSoFar, count;
  unsigned int start, end, micros;
  int bSec;
  if (argc > 1) {
    totalBytes = 1000000*atoi(argv[1]);
  } else {
    totalBytes = 5000000;
  }
  
  
  FreeRunningTimer * SystemTimer  = (FreeRunningTimer *)(ProxiableObject *)
	 StandardNameServer->lookup("SystemTimer", "FreeRunningTimer" );
  Assert (SystemTimer != 0);
  
  StandardOutput->formattedWrite( "Begin bcopy test\n" );
  
  // begin test
  
  for (sizePtr = sizes; *sizePtr > 0; sizePtr++) {
    start = SystemTimer->time();
    for (bytesSoFar = 0; bytesSoFar < totalBytes; bytesSoFar += count) {
      count = totalBytes - bytesSoFar;
      if (count > *sizePtr) {
	count = *sizePtr;
      }
      ByteCopy(src, dst, count);
    }
    end = SystemTimer->time();
    micros = end - start;
    
    bSec = totalBytes;
    bSec /=  (micros / 1000000);
    StandardOutput->formattedWrite("Transfer size: %d,",*sizePtr);
    StandardOutput->formattedWrite("bytes/sec: %d\n",bSec);
  }

  return(0);
}
