#ifdef __GNUC__
#pragma implementation
#endif

#include "Byte.h"
#include "Convert.h"
#include "FreeRunningTimer.h"
#include "FreeRunningTimerStar.h"
#include "OutputStream.h"
#include "NameServer.h"
#include "Process.h"
#include "ProcessStar.h"
#include "ThisProcess.h"

void theCalls(int depth, int alloc, char *p)
{
	if (depth-- == 0)			// Bottomed out??
		return;
	char *heapBytes = 0;
	if (alloc > 0) {
		heapBytes = new char [alloc];
		if (p != 0)
			for (int i = 0; i < alloc; i+=4096)
				heapBytes[i] = p[i];	// Touch every page
		p = heapBytes;
		}
	theCalls(depth, alloc, p);
	if (heapBytes) delete heapBytes;
}

int allocsize ;
int depth ;
int seconds ;

int
doLotsaCalls(int, char **)
{
	Console() << "Calling for " << seconds << " seconds, depth: "
		<< depth << " allocsize: " << allocsize << "\n" << eor;
	FreeRunningTimerStar timer = (FreeRunningTimer *)
		      StandardNameServer->lookup ("SystemTimer", "FreeRunningTimer");
	Assert (timer != 0);
	unsigned time = timer->time();
	unsigned end = time + (seconds << 20);
	unsigned newtime;
	while ((newtime = timer->time()) < end){
		if ((newtime - time) > (1 << 20)){
			time = newtime;
			Console() << thisProcess() << ": still calling\n" << eor;
			}
		theCalls(depth, allocsize, 0);
		}
	Console() << "Calling done\n" << eor;
	//thisProcess()->die();
}

int
main(int argc, char ** argv)
{
	/*
	 * Defaults
	 */
	allocsize = 0;
	depth = 200;
	seconds = 1;
	int howmany = 1;
	argv++; argc--;
	switch (argc) {
		case 4:
			howmany = atoi(argv[3]);
			// FALLTHROUGH!
		case 3:
			allocsize = atoi(argv[2]);
			// FALLTHROUGH!
		case 2:
			depth = atoi(argv[1]);
			// FALLTHROUGH!
		case 1:
			seconds = atoi(argv[0]);
			// FALLTHROUGH!
		case 0:
			break;
		default:
			Console() << "Usage: lotsaCalls (seconds, maxdepth, allocsize)\n";
			return 0;
			break;
	};

	for (int i = 0; i < howmany; i++ ){
		ProcessStar p = new ApplicationProcess(doLotsaCalls);
		p->ready();
		}
}
