#ifdef __GNUC__
#pragma implementation
#endif

#include "OutputStream.h"
#include "Convert.h"
#include "FaultHandler.h"
#include "ThisProcess.h"

/*
 * Peek/Poke memory locations
 */

class MyFaultHandler : public FaultHandler {
public:
	virtual void fault( const char * address, AccessType attemptedAccess );
};

#define ARRAYSIZE 0x10000
char array[ ARRAYSIZE ];

int
main( int argc, char ** argv )
{
	if ( ( argc < 2 ) || ( argc > 3 ) ) {
		StandardOutput->printf( "Usage: pk hex_addr [write_val]\n" );
		StandardOutput->printf( "  Address of %x byte array is %x\n",
					ARRAYSIZE, array );
		return( 1 );
	}

	int * addr = (int *) atoi( argv[1], 16 );

	int value = -1;

	thisProcess()->setFaultHandler( new MyFaultHandler() );

	if ( argc > 2 ) {
		value = atoi( argv[2], 16 );

		*addr = value;

		value = -1;
	}


	value = *addr;

	StandardOutput->printf( "%x: %x\n", addr, value );

	return(0);
}

void
MyFaultHandler::fault( const char * address, AccessType attemptedAccess )
{
	if ( attemptedAccess == ApplicationRead )
		StandardOutput->printf( "Caught read" );
	else if ( attemptedAccess == ApplicationWrite )
		StandardOutput->printf( "Caught write" );
	else
		StandardOutput->printf( "Caught access type %d",
							attemptedAccess );
	StandardOutput->printf( " at address %x\n", address );
}
