#ifdef __GNUC__
#pragma implementation
#endif

#include "OutputStream.h"
#include "Semaphore.h"
#include "Process.h"
#include "ApplicationProcess.h"
#include "TimeoutTimer.h"
#include "Assert.h"

Semaphore sem(0,1);

int
main2( int, char ** )
{
	StandardOutput->formattedWrite( "hello sailor 2!\n");

	TimeoutTimer *timer = new TimeoutTimer();
	Assert(timer != 0);

	for (int i = 0; i < 5; i++)
	{
	    sem.P();
	    timer->start(400000);
	    timer->await();
	    StandardOutput->formattedWrite(" process 2 signalling 1 #%d\n", i);
	    sem.V();
	}

	StandardOutput->formattedWrite( "goodbye sailor 2!\n" );

	return(0);
}

int
main( int, char ** )
{
	StandardOutput->formattedWrite( "hello sailor!\n" );

	Process *proc = new ApplicationProcess( main2 );
	Assert(proc != 0);
	proc->ready();

	TimeoutTimer *timer = new TimeoutTimer();
	Assert(timer != 0);

	for( int i = 0; i < 5; i++ )
	{
	    timer->start(200000);
	    timer->await();
	    StandardOutput->formattedWrite(" process 1 signalling 2 #%d\n", i);
	    sem.V();
	    sem.P();
	}

	StandardOutput->formattedWrite( "goodbye sailor!\n" );

	return(0);
}

