#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989 The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Ashish Deshpande (deshpan@cs.uiuc.edu)
 * Author: Taed Nelson (nelson@cs.uiuc.edu)
 * Author: Aamod Sane (sane@cs.uiuc.edu)
 * Contributing Author: Lee Lup Yuen (lup@choices.cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * userTest.cc: A simple test of user instrumentaion
 *
 *	$Header: /projects/choices/old/cvsroot/choices/Applications/Examples/userTest.cc,v 1.1 2004/06/03 01:58:29 jcarlyle Exp $
 */

#include "NameServer.h"
#include "OutputStream.h"
#include "FreeRunningTimer.h"

class Class;

#ifdef INSTRUMENT
#define Instrument(exp) exp
#include "InstrumentManager.h"
#include "Eventer.h"
#include "Timer.h"

InstrumentManager *InstrumentManager;
Eventer *iLoopLog;
Timer *iLoopDuration;
#else
#define Instrument(exp)
#endif INSTRUMENT
			    

main ()
{
    	Instrument (InstrumentManager = new InstrumentManager
	    	("ZApplicationUserTest", 1000));
	Instrument (iLoopLog = new Eventer  (InstrumentManager,
	    	"ZLoop Log", TALKING));
	Instrument (iLoopDuration = new Timer (InstrumentManager,
	    	"ZLoop Duration", TALKING, 1));
	static unsigned int getTimeTime = 0;

	const int n = 5;
	const int p = 5;

	unsigned int total;

	Class *FreeRunningTimerClass = 
	      (Class *) StandardNameServer->lookup ("FreeRunningTimer", 0);
	Assert (FreeRunningTimerClass != 0);
	FreeRunningTimer *SystemTimer = (FreeRunningTimer *)
	      StandardNameServer->lookup ("SystemTimer", FreeRunningTimerClass);
	Assert (SystemTimer != 0);

	Instrument (iLoopLog -> event ("ZOuter loop start"));

	Instrument (iLoopDuration -> start ());
	for ( int j = 0; j < p; j++) {
		total = 0;

    	    	Instrument (iLoopLog -> event ("ZInner loop start"));
		
		for ( int i = 0; i < n; i++ ) {
			unsigned int first = SystemTimer->time();
			unsigned int second = SystemTimer->time();
		
			total += second - first;
		}

		Instrument (iLoopLog -> event ("ZInner loop stop"));

		getTimeTime = total / n;

		StandardOutput->formattedWrite
		    	("Time for getting the time : %d\n", getTimeTime);
	}
	Instrument (iLoopDuration -> stop ("ZOuter loop stop"));

    	//  Always delete an instrument before its manager.
	Instrument (delete iLoopLog);
	Instrument (delete iLoopDuration);
    	Instrument (delete InstrumentManager);

	return (getTimeTime);
}
