#ifdef __GNUC__
#pragma implementation
#endif

#include "Object.h"
#include "NameServer.h"
#include "InputStream.h"
#include "OutputStream.h"
#include "NameServerStar.h"
#include "InputStreamStar.h"
#include "OutputStreamStar.h"
#include "String.h"
#include "Tools.h"
#include "FileSystemInterface.h"

extern int exec( char * );


ClassStar VariableRecordStreamClass = 0;
ClassStar VariableRecordFileClass = 0;
ClassStar IndexedRecordFileClass = 0;
ClassStar FixedRecordStreamClass = 0;
ClassStar FixedRecordFileClass = 0;
ClassStar POSHExpressionClass = 0;

FileSystemInterfaceStar	FSI = 0;
InputStreamStar stdin = 0;
OutputStreamStar stdout = 0;

int
StartUp( int argc, char * argv[] )
{
	stdin = StandardInput;
	stdout = StandardOutput;

	FSI = StandardNameServer->lookup( "fileSystemInterface", "FileSystemInterface" );
        VariableRecordStreamClass =
                StandardNameServer->lookup( "VariableRecordStream", "Class" );
        FixedRecordStreamClass =
                StandardNameServer->lookup( "FixedRecordStream", "Class" );
        VariableRecordFileClass =
                StandardNameServer->lookup( "VariableRecordFile", "Class" );
        FixedRecordFileClass =
                StandardNameServer->lookup( "FixedRecordFile", "Class" );
        IndexedRecordFileClass =
                StandardNameServer->lookup( "IndexedRecordFile", "Class" );
        POSHExpressionClass =
                StandardNameServer->lookup( "POSHExpression", "Class" );
	extern ClassStar ClassClass; 
	ClassClass =
                StandardNameServer->lookup( "Class", "Class" );

	for( int i = 1; i < argc; i++ ) exec( argv[i] );

	return( 0 );
}

void
Print( char * format,   formatArgs & a0, formatArgs & a1,
       formatArgs & a2, formatArgs & a3, formatArgs & )
{
	stdout->formattedWrite( format, a0, a1, a2, a3 );
}

extern "C" {
	char *
	gets( char * str )
	{
		int count = stdin->read( str, 1024 );
		if( ( count == 1 ) && (str[0] == 4 ) ) return( 0 );
		return( chop( str, '\n' ) );
	}
}

int
match( char * string, char * pattern )
{
    char   ok;
    char   negate;
    char   left;
    char   right;
    int    stackPtr = 0;
    int    stackSize = 0;
    for( char * p = pattern; *p; p++ ) if( *p == '*' ) stackSize++;

    char ** patternStack = new char * [stackSize];
    char ** stringStack  = new char * [stackSize];

    for(;;) {
        switch( *pattern ) {
    
        case '*':
            if( *++pattern == '\0' ) {
                delete patternStack;
                delete stringStack;
                return( 1 );
            }
            patternStack[stackPtr] = pattern;
            stringStack[stackPtr++] = string + 1;
            continue;
    
        case '[':
            ok = 0;
            left = '\0';
            if( *++pattern == '^' ) {
                negate = 1;
                ++pattern;
            }
            else negate = 0;
            while( ( *pattern != '\0' ) && ( *pattern != ']' ) ) {
                switch( *pattern ) {
                case '-':
                    if( left != '\0' ) {
                        right = *++pattern;
                        ok |= ( left <= *string ) && ( *string <= right );
                        left = '\0';
                        break;
                    }
                default:
                    if( *string == ( left = *pattern ) ) ok = 1;
                }
                ++pattern;
            }
            if( negate ) ok = !ok;
            if( ok ) {
                ++string;
                ++pattern;
                continue;
            }
            else goto BackTrack;
    
        case '\0':
            if( *string == '\0' ) {
                delete patternStack;
                delete stringStack;
                return( 1 );
            }
    
        default:
            if( *pattern != *string ) goto BackTrack;
    
        case '?':
            if( *string != '\0' ) {
                ++string;
                ++pattern;
                continue;
            }
        }
    
BackTrack:
        if( --stackPtr >= 0 ) {
            pattern = patternStack[stackPtr];
            string = stringStack[stackPtr];
            if( *string != '\0' ) {
                patternStack[stackPtr] = pattern;
                stringStack[stackPtr++] = string + 1;
                continue;
            }
        }
    
        delete patternStack;
        delete stringStack;
        return( 0 );
    }
}
