#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Peter W. Madany (madany@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
#include "Assert.h"
#include "FileSystemInterface.h"
#include "FileSystemInterfaceStar.h"
#include "MemoryObject.h"
#include "MultimaxEMCDisk.h"
#include "PersistentMemoryObjectStar.h"
#include "MemoryObjectContainer.h"
#include "MemoryObjectContainerStar.h"
#include "MemoryObjectDictionary.h"
#include "MemoryObjectDictionaryStar.h"

FileSystemInterfaceRef
CreateFSI()
{
	FileSystemInterfaceRef fsi = 0;
{
	int status = 0;

	PersistentMemoryObjectStar disk = new MultimaxEMCDisk( 0, 0, 0 );
	Assert( disk != 0 );

	MemoryObjectContainerStar root = disk->asA( MemoryObjectContainerClass,
						    status );
	Assert( root != 0 );

	PersistentMemoryObjectStar pmo = root->open( 0, status );
	Assert( pmo != 0 );

	MemoryObjectContainerStar oc = pmo->asA( MemoryObjectContainerClass,
						 status );
	Assert( oc != 0 );

	MemoryObjectDictionaryStar od = oc->rootDictionary();
	Assert( od != 0 );

	fsi = new FileSystemInterface( od, root );
	Assert( fsi != 0 );

}
	return( fsi );
}
