/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Peter W. Madany (madany@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

#ifndef LOCK_h
#define LOCK_h

#include "Assert.h"

class LOCK {
	int _count;
public:
	void	acquire();
	void	release();
	int	heldByMe();
		LOCK( );
		~LOCK();
};

void inline
LOCK::acquire()
{
	Assert( _count == 0 );
	++_count;
}

void inline
LOCK::release()
{
	Assert( _count == 1 );
	--_count;
}

int inline
LOCK::heldByMe()
{
	return( _count == 1 );
}

inline
LOCK::LOCK()
{
	_count = 0;
}

inline
LOCK::~LOCK()
{
	Assert( !heldByMe() );
}

#endif LOCK_h
