/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: David W. Dykstra (dykstra@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * SystemInterface.h - class for miscellaneous system calls
 */

#ifndef SystemInterface_h
#define SystemInterface_h
#ifdef __GNUG__
#pragma once
#pragma interface
#endif

#include "ProxiableObject.h"
#include "SystemInterfaceStar.h"
#include "NameServerStar.h"

class Process;
class PersistentMemoryObject;

extern ClassStar SystemInterfaceClass;
class SystemInterface : public ProxiableObject {
public:
	proxiable virtual Process * buildProcessFromObjectFile(
		    PersistentMemoryObject *, int argc, char ** argv );

	Class * classOf();
};

extern SystemInterfaceStar TheSystemInterface;

extern SystemInterface * StandardSystemInterface;

#endif SystemInterface_h
