#ifdef __GNUC__
#pragma implementation
#endif

#include "BitArray.h"
#include "GPInclude.h"
#include "Utils.h"
#ifdef __GNUG__
#include "Stdio.h"
#endif


main()
{
    int dim = 100;
    BitArray b(dim);
    
    forever {
	
	int rval = 0;
	char cmd = '?';
	unsigned int arg1 = 0;
	unsigned int arg2 = 0;
	
	char * tmp = GetCmd();
	if (tmp)
	    sscanf(tmp,"%c%i%i",&cmd,&arg1,&arg2);
	else
	    continue;
	
	Console() << cmd << " " << arg1 << " " << arg2 << "\n" << eor;
	
	switch(cmd) {
	  case 'S':
	    if (arg2) { 
		b.set(arg1);
		rval = 1;
	    }
	    else {
		b.clear(arg1);
		rval = 0;
	    }
	    break;
	  case 'G':
	    rval = b.get(arg1);
	    break;
	  case 'p':
	    b.inspect();
	    Console() << "\n" << eor;
	    break;
	  case 's':
	    b.set(arg1,arg2);
	    rval = 1;
	    break;
	  case 'z':
	    b.clear(arg1,arg2);
	    rval = 0;
	    break;
	  case 'g':
	    rval = b.get(arg1,arg2);
	    break;
	  case 'f': {
	      unsigned s;
	      unsigned t;
	      rval = b.getExtent(arg1,s,t);
	      Console() << "inRange in BitArray " << s << "," << t << "\n";
	  }
	    break;
	  case 'c':
	    rval = b.bitSearch(arg1,arg2,1);
	    break;
	  case 'b':
	    rval = b.bitSearch(arg1,arg2,0);
	    break;
	  case 'x':
	    return 0;
	  default:
	    Console() << "Unknown switch\n";
	    break;
	}
	Console() << "Operation " << cmd << " value " << rval << "\n";
    }
}
