#ifdef __GNUC__
#pragma implementation
#endif

#include "LightList.h"
#include "GPInclude.h"
#include "Utils.h"
#ifdef __GNUG__
#include "Stdio.h"
#endif

class mylink : public SLink {
    int _item;
  public:
    mylink(int i) { _item = i; };
    ~mylink() { Console() << "mylink destroyed " << _item << "\n" << eor;};
    int item() { return _item; };

    void setItem(int i) { _item = i; };
    int compare ( SLink * l ) { return _item == ((mylink*)l)->_item; };
    void inspect() { Console() << _item << eor; };
};

class mycomp : public LightListVirtualiser {
  public:
    virtual int compare( SLink * a, SLink * b )
    { return ((mylink*)a)->compare(b); };
    virtual void inspect( SLink * a)
    { ((mylink *)a)->inspect(); };
    virtual void destroy( SLink * a)
    { delete (mylink *)a; };
};

void
f( SLink * l)
{
    Console() << ((mylink*)l)->item()*2 << " " << eor;
}

main()
{
    LightList t;
    mycomp cmp;
    
    forever {
	
	int rval = 0;
	char cmd = '?';
	unsigned int arg1 = 0;
	unsigned int arg2 = 0;
	
	char * tmp = GetCmd();
	if (tmp)
	    sscanf(tmp,"%c%i%i",&cmd,&arg1,&arg2);
	else
	    continue;
	
	Console() << cmd << " " << arg1 << " " << arg2 << "\n" << eor;
	
	mylink * rptr;
	
	switch(cmd) {
		  case 'i': {
		      mylink * m = new mylink((int)arg1);
		      t.addFirst(m,&cmp);
		      break;
		  }
		  case 'j': {
		      mylink * m = new mylink((int)arg1);
		      mylink n((int)arg2);
		      t.add(m,t.find(&n,&cmp),0);
		  }
		    break;
		  case 'k': {
		      mylink * m = new mylink((int)arg1);
		      t.addLast(m,&cmp);
		      break;
		  }
		  case 'r': {
		      mylink n((int)arg1);
		      rptr = (mylink *)t.remove(&n,0,&cmp);
		      if (rptr)
			  rval = rptr->item();
		      else
			  Console() << "Error return 0\n" << eor;
		  }
		    break;
		  case 's': {
		      mylink n((int)arg1);
		      rptr = (mylink *)t.remove(&n,arg2,&cmp);
		      if (rptr)
			  rval = rptr->item();
		      else
			  Console() << "Error return 0\n" << eor;
		  }
		    break;
		  case 'f': {
		      mylink n((int)arg1);
		      rptr = (mylink*)t.find(&n,&cmp);
		      if (rptr)
			  rval = rptr->item();
		      else
			  Console() << "Error return 0\n" << eor;
		  }
		    break;
		  case 'g': {
		      mylink n((int)arg1);
		      rptr = (mylink*)t.find(&n,arg2,&cmp);
		      if (rptr)
			  rval = rptr->item();
		      else
			  Console() << "Error return 0\n" << eor;
		  }
		  break;
		  case 'm':
		    t.mapcar(f);
		    break;
		  case 'x':
		    return 0;
		    break;
		  case 'd':
		    t.destroy(&cmp);
		    break;
		  case 'p':
		    Console() << "List: " << eor;
		    t.inspect(&cmp);
		    Console() << "\n" << eor;
		    break;
		  default:
		    Console() << "Unknown switch" << "\n" << eor;
		    break;
		}
	Console() << "Operation " << cmd << " value "
	    << (unsigned int)rval << "\n" << eor;
    }
}










