/**********************************************************************
$Id: ParmacsTrace.h 2 2004-06-03 01:58:28Z jcarlyle $

$Source: /projects/choices/old/cvsroot/choices/Applications/Water/ParmacsTrace.h,v $

$Log: ParmacsTrace.h,v $
Revision 1.1  2004/06/03 01:58:30  jcarlyle
Initial revision

Revision 1.1.1.3  1992/01/15  23:17:46  drk
Added procedure/loop trace records

Revision 1.1.1.2  91/10/22  21:09:37  drk
Many changes.

Revision 1.1.1.1  91/10/20  21:05:58  drk
Branch for revisions.

Revision 1.1  91/10/20  21:03:01  drk
Initial revision


Header for PARMACS trace records and functions.  See tracing_parmacs.doc
for details.
**********************************************************************/

#ifndef _ParmacsTrace_h_
#define _ParmacsTrace_h_


typedef enum {
	PTT_Version,
	PTT_ProcEnter,
	PTT_ProcExit,
	PTT_LoopEnter,
	PTT_LoopExit,
	PTT_MainInitEnv,
	PTT_MainEnd,
	PTT_Create,
	PTT_CreateDone,
	PTT_WaitForEnd,
	PTT_WaitForEndDone,
	PTT_ThreadInitEnv,
	PTT_ThreadEnd,
	PTT_BarInit,
	PTT_LockInit,
	PTT_ALockInit,
	PTT_BarEnter,
	PTT_BarExit,
	PTT_BarExitLast,
	PTT_Lock,
	PTT_LockDone,
	PTT_Unlock,
	PTT_ALock,
	PTT_ALockDone,
	PTT_AUnlock,
} ParmacsTraceType;	/* "PTT_" prefix is for ParmacsTraceType */

#define FIRST_ParmacsTraceType (PTT_Version)
#define LAST_ParmacsTraceType (PTT_AUnlock)

#define VALID_ParmacsTraceType(type) \
	((type) >= FIRST_ParmacsTraceType && \
	 (type) <= LAST_ParmacsTraceType)


#define PARMACS_TRACE_VERSION "$Id: ParmacsTrace.h 2 2004-06-03 01:58:28Z jcarlyle $"

typedef struct {
	unsigned type,
		 time,
		 pid,
		 data_id;
	union {
		char *version,
		     *var_name;
	} var_len;	/* Variable-length fields. */
} ParmacsTraceRecord;

/*
Maximum length of variable-length field, in bytes.
*/

#define MaxParmacsVarlenField 256


#ifdef __STDC__
extern const char *PTT_to_str(ParmacsTraceType type);
extern ParmacsTraceRecord *ReadPTRec(ParmacsTraceRecord *r, FILE *f);
extern int PrintPTRec(ParmacsTraceRecord *r, FILE *f);
#else
extern char *PTT_to_str();
extern ParmacsTraceRecord *ReadPTRec();
extern int PrintPTRec();
#endif /* __STDC__ */

#endif /* _ParmacsTrace_h_ */

