#ifdef __GNUC__
#pragma implementation
#endif


/**********************************************************************
$Id: bndry.cc 2 2004-06-03 01:58:28Z jcarlyle $

$Source: /projects/choices/old/cvsroot/choices/Applications/Water/bndry.cc,v $

$Log: bndry.cc,v $
Revision 1.1  2004/06/03 01:58:30  jcarlyle
Initial revision

Revision 2.1  1992/06/03  19:52:23  zhang
Ansified version, initial checkin

Revision 1.2  1991/11/22  14:20:31  zhang
Added EXTERN_ENV and header;


This routine puts the molecules back inside the box if they are  out.
**********************************************************************/




#ifndef BUFSIZ
#include "stdio.h"
#include "stdlib.h"
#endif
#include "Math.h"



				/* Main thread start and end times. */
extern unsigned start_time, end_time;
extern unsigned thread_num;
 


extern char *spinlock_addr;	/* For spinlock macro. */
 




#include "Assert.h"
#include "FreeRunningTimer.h"
#include "NameServer.h"
#include "Process.h"
#include "ThisProcess.h"
#include "UnixApplication.h"

extern FreeRunningTimer* choices_clock;


extern void *shnew(long n);
extern void initializeNewSharedAllocator(void);

#define MAX_NUM_PROCS 128
extern Process* child_procs[MAX_NUM_PROCS];
extern unsigned num_child_procs;
 
 



#include "String.h"


#include "ParmacsTrace.h"

extern char trace_fname[];
extern FILE *trace_file;
#define TRACE_BUFF_SIZE 262144
extern unsigned trace_buff[TRACE_BUFF_SIZE * 4];
extern unsigned *trace_loc;
extern unsigned *final_trace_loc;
unsigned *trace_buff_end;
extern unsigned thread_pid;
extern unsigned num_children;
extern char *ParmacsTrace_version;

extern void trace_io_error(char *func);
extern void trace_overflow_error(void);
 
 

#include "mdvar.h"
#include "parameters.h"
#include "mddata.h"
#include "split.h"
#include "water.h"

/*
This routine puts the molecules back inside the box if they are out.
*/

void
BNDRY(void)
{
    int mol, dir; 
    
    /* for each molecule */
    for (mol = StartMol[ProcID]; mol < StartMol[ProcID+1]; mol++) {
/*
    for (mol = 0; mol < NMOL; mol++) {
*/
	/* for each direction */
  	for ( dir = XDIR; dir <= ZDIR; dir++ ) {
	    /* if the oxygen atom is out of the box */
    	    if (VAR[mol].F[DISP][dir][O] > BOXL) {
		/* move all three atoms back in the box */
		VAR[mol].F[DISP][dir][H1] -= BOXL;
		VAR[mol].F[DISP][dir][O]  -= BOXL;
		VAR[mol].F[DISP][dir][H2] -= BOXL;
            }
     	    else if (VAR[mol].F[DISP][dir][O] < 0.00) {
		VAR[mol].F[DISP][dir][H1] += BOXL;
		VAR[mol].F[DISP][dir][O]  += BOXL;
		VAR[mol].F[DISP][dir][H2] += BOXL;
            } 
    	} /* for dir */
    } /* for mol */
} /* end of subroutine BNDRY */

