#ifdef __GNUC__
#pragma implementation
#endif


/**********************************************************************
$Id: cshift.cc 2 2004-06-03 01:58:28Z jcarlyle $

$Source: /projects/choices/old/cvsroot/choices/Applications/Water/cshift.cc,v $

$Log: cshift.cc,v $
Revision 1.1  2004/06/03 01:58:30  jcarlyle
Initial revision

Revision 2.1  1992/06/03  19:52:23  zhang
Ansified version, initial checkin

Revision 1.2  1991/11/22  14:20:52  zhang
Added EXTERN_ENV and header;


Compute distances between the two input molecules.
**********************************************************************/




#ifndef BUFSIZ
#include "stdio.h"
#include "stdlib.h"
#endif
#include "Math.h"



				/* Main thread start and end times. */
extern unsigned start_time, end_time;
extern unsigned thread_num;
 


extern char *spinlock_addr;	/* For spinlock macro. */
 




#include "Assert.h"
#include "FreeRunningTimer.h"
#include "NameServer.h"
#include "Process.h"
#include "ThisProcess.h"
#include "UnixApplication.h"

extern FreeRunningTimer* choices_clock;


extern void *shnew(long n);
extern void initializeNewSharedAllocator(void);

#define MAX_NUM_PROCS 128
extern Process* child_procs[MAX_NUM_PROCS];
extern unsigned num_child_procs;
 
 



#include "String.h"


#include "ParmacsTrace.h"

extern char trace_fname[];
extern FILE *trace_file;
#define TRACE_BUFF_SIZE 262144
extern unsigned trace_buff[TRACE_BUFF_SIZE * 4];
extern unsigned *trace_loc;
extern unsigned *final_trace_loc;
unsigned *trace_buff_end;
extern unsigned thread_pid;
extern unsigned num_children;
extern char *ParmacsTrace_version;

extern void trace_io_error(char *func);
extern void trace_overflow_error(void);
 
 

#include "water.h"

/* return the value of a with the same sign as b */
#define sign(a,b)  (b < 0 ) ? ( (a < 0) ? a : -a) : ( (a < 0) ? -a : a) 

/*
Compute some relevant distances between the two input molecules to this
routine. if they are greater than the cutoff radius, compute these
distances as if one of the particles were at its mirror image (periodic
boundary conditions). used by the intermolecular interactions routines.
*/

void
CSHIFT(double XA[], double XB[], double XMA, double XMB, double XL[],
       double BOXH, double BOXL)
{

  int I;

  XL[0] = XMA-XMB;
  XL[1] = XMA-XB[0];
  XL[2] = XMA-XB[2];
  XL[3] = XA[0]-XMB;
  XL[4] = XA[2]-XMB;
  XL[5] = XA[0]-XB[0];
  XL[6] = XA[0]-XB[2];
  XL[7] = XA[2]-XB[0];
  XL[8] = XA[2]-XB[2];
  XL[9] = XA[1]-XB[1];
  XL[10] = XA[1]-XB[0];
  XL[11] = XA[1]-XB[2];
  XL[12] = XA[0]-XB[1];
  XL[13] = XA[2]-XB[1];

  /* go through all 14 distances computed */
  for (I = 0; I <  14; I++) {
    /* if the value is greater than the cutoff radius */
    if (fabs(XL[I]) > BOXH) {
	XL[I]  =  XL[I] -(sign(BOXL,XL[I]));
    }
  } /* for */
} /* end of subroutine CSHIFT */

