#ifdef __GNUC__
#pragma implementation
#endif


/**********************************************************************
$Id: initia.cc 2 2004-06-03 01:58:28Z jcarlyle $

$Source: /projects/choices/old/cvsroot/choices/Applications/Water/initia.cc,v $

$Log: initia.cc,v $
Revision 1.1  2004/06/03 01:58:30  jcarlyle
Initial revision

Revision 2.1  1992/06/03  19:52:23  zhang
Ansified version, initial checkin

Revision 1.3  1991/11/22  14:20:56  zhang
*** empty log message ***

Revision 1.2  91/10/30  11:07:24  zhang
*** empty log message ***


This routine initializes positions in a cube and randomizes  velocity of
each atom.
**********************************************************************/





#ifndef BUFSIZ
#include "stdio.h"
#include "stdlib.h"
#endif
#include "Math.h"



				/* Main thread start and end times. */
extern unsigned start_time, end_time;
extern unsigned thread_num;
 


extern char *spinlock_addr;	/* For spinlock macro. */
 




#include "Assert.h"
#include "FreeRunningTimer.h"
#include "NameServer.h"
#include "Process.h"
#include "ThisProcess.h"
#include "UnixApplication.h"

extern FreeRunningTimer* choices_clock;


extern void *shnew(long n);
extern void initializeNewSharedAllocator(void);

#define MAX_NUM_PROCS 128
extern Process* child_procs[MAX_NUM_PROCS];
extern unsigned num_child_procs;
 
 



#include "String.h"


#include "ParmacsTrace.h"

extern char trace_fname[];
extern FILE *trace_file;
#define TRACE_BUFF_SIZE 262144
extern unsigned trace_buff[TRACE_BUFF_SIZE * 4];
extern unsigned *trace_loc;
extern unsigned *final_trace_loc;
unsigned *trace_buff_end;
extern unsigned thread_pid;
extern unsigned num_children;
extern char *ParmacsTrace_version;

extern void trace_io_error(char *func);
extern void trace_overflow_error(void);
 
 

#include "mdvar.h"
#include "water.h"
#include "cnst.h"
#include "fileio.h"
#include "parameters.h"
#include "mddata.h"
#include "split.h"

/*
This routine initializes positions in a cube and randomizes  velocity of
each atom.
*/

void
INITIA(FILE *nfmc)	/* points to LWI12, the input file with the initial
			   displacements  */
{

    static double XMIN = 0;
    static double YMIN = 0;
    static double ZMIN = 0;
    FILE *random_numbers;       /* points to input file containing
                                pseudo-random numbers for initializing
                                velocities */
    double XMAS[4],
	   /* XS, ZERO, WCOS, WSIN, Not used */
	   XT[4], YT[4], Z;
    double SUX, SUY, SUZ, SUMX, SUMY, SUMZ, FAC;
    int mol=0;
    int atom=0;
    
    random_numbers = fopen("random.in","r");
    XMAS[1]=sqrt(OMAS*HMAS);
    XMAS[0]=HMAS;
    XMAS[2]=HMAS;

/* .....ASSIGN POSITIONS */

    if (nfmc != NULL) {  /* i.e. if we are to read displacements from
                            an input file (LWI12) */
        rewind(nfmc);
        fprintf(six, "***** NEW RUN STARTING FROM COORDINATES OF WATERS\n");

        /* read in the displacements for the x-direction */
	{
	if (trace_loc < trace_buff_end) {	/* Test for overflow */
		*trace_loc++ = (unsigned) PTT_LoopEnter;	/* type */
		*trace_loc = choices_clock->time();		/* time */
		trace_loc++;
		*trace_loc++ = thread_pid;	/* pid */


		*trace_loc++ = (unsigned) 10010;	/* data_id */


	} else
		trace_overflow_error();
}  
        for (mol = 0; mol < NMOL; mol++)
	    for ( atom = 0; atom < NATOM; atom++)
	        fscanf(nfmc,"%lf",&VAR[mol].F[DISP][XDIR][atom]);
	{
	if (trace_loc < trace_buff_end) {	/* Test for overflow */
		*trace_loc++ = (unsigned) PTT_LoopExit;	/* type */
		*trace_loc = choices_clock->time();		/* time */
		trace_loc++;
		*trace_loc++ = thread_pid;	/* pid */


		*trace_loc++ = (unsigned) 10010;	/* data_id */


	} else
		trace_overflow_error();
}  

	/* skip numbers in input file until y-direction numbers start */

	{
	if (trace_loc < trace_buff_end) {	/* Test for overflow */
		*trace_loc++ = (unsigned) PTT_LoopEnter;	/* type */
		*trace_loc = choices_clock->time();		/* time */
		trace_loc++;
		*trace_loc++ = thread_pid;	/* pid */


		*trace_loc++ = (unsigned) 10020;	/* data_id */


	} else
		trace_overflow_error();
}  
        for (mol = NMOL; mol < NOMOL; mol++)
	    for ( atom = 0; atom < NATOM; atom++)
	        fscanf(nfmc,"%*lf");
	{
	if (trace_loc < trace_buff_end) {	/* Test for overflow */
		*trace_loc++ = (unsigned) PTT_LoopExit;	/* type */
		*trace_loc = choices_clock->time();		/* time */
		trace_loc++;
		*trace_loc++ = thread_pid;	/* pid */


		*trace_loc++ = (unsigned) 10020;	/* data_id */


	} else
		trace_overflow_error();
}  

        /* read in the displacements for the y-direction */
	{
	if (trace_loc < trace_buff_end) {	/* Test for overflow */
		*trace_loc++ = (unsigned) PTT_LoopEnter;	/* type */
		*trace_loc = choices_clock->time();		/* time */
		trace_loc++;
		*trace_loc++ = thread_pid;	/* pid */


		*trace_loc++ = (unsigned) 10030;	/* data_id */


	} else
		trace_overflow_error();
}  
        for (mol = 0; mol < NMOL; mol++)
	    for ( atom = 0; atom < NATOM; atom++)
	        fscanf(nfmc,"%lf",&VAR[mol].F[DISP][YDIR][atom]);
	{
	if (trace_loc < trace_buff_end) {	/* Test for overflow */
		*trace_loc++ = (unsigned) PTT_LoopExit;	/* type */
		*trace_loc = choices_clock->time();		/* time */
		trace_loc++;
		*trace_loc++ = thread_pid;	/* pid */


		*trace_loc++ = (unsigned) 10030;	/* data_id */


	} else
		trace_overflow_error();
}  

	/* skip numbers in input file until y-direction numbers start */

	{
	if (trace_loc < trace_buff_end) {	/* Test for overflow */
		*trace_loc++ = (unsigned) PTT_LoopEnter;	/* type */
		*trace_loc = choices_clock->time();		/* time */
		trace_loc++;
		*trace_loc++ = thread_pid;	/* pid */


		*trace_loc++ = (unsigned) 10040;	/* data_id */


	} else
		trace_overflow_error();
}  
        for (mol = NMOL; mol < NOMOL; mol++)
	    for ( atom = 0; atom < NATOM; atom++)
	        fscanf(nfmc,"%*lf");
	{
	if (trace_loc < trace_buff_end) {	/* Test for overflow */
		*trace_loc++ = (unsigned) PTT_LoopExit;	/* type */
		*trace_loc = choices_clock->time();		/* time */
		trace_loc++;
		*trace_loc++ = thread_pid;	/* pid */


		*trace_loc++ = (unsigned) 10040;	/* data_id */


	} else
		trace_overflow_error();
}  

        /* read in the displacements for the z-direction */
	{
	if (trace_loc < trace_buff_end) {	/* Test for overflow */
		*trace_loc++ = (unsigned) PTT_LoopEnter;	/* type */
		*trace_loc = choices_clock->time();		/* time */
		trace_loc++;
		*trace_loc++ = thread_pid;	/* pid */


		*trace_loc++ = (unsigned) 10050;	/* data_id */


	} else
		trace_overflow_error();
}  
        for (mol = 0; mol < NMOL; mol++)
	    for ( atom = 0; atom < NATOM; atom++)
	        fscanf(nfmc,"%lf",&VAR[mol].F[DISP][ZDIR][atom]);
	{
	if (trace_loc < trace_buff_end) {	/* Test for overflow */
		*trace_loc++ = (unsigned) PTT_LoopExit;	/* type */
		*trace_loc = choices_clock->time();		/* time */
		trace_loc++;
		*trace_loc++ = thread_pid;	/* pid */


		*trace_loc++ = (unsigned) 10050;	/* data_id */


	} else
		trace_overflow_error();
}  

        rewind(nfmc);

        /* loop through the values we just read in and determine the
            min. for each direction */
	{
	if (trace_loc < trace_buff_end) {	/* Test for overflow */
		*trace_loc++ = (unsigned) PTT_LoopEnter;	/* type */
		*trace_loc = choices_clock->time();		/* time */
		trace_loc++;
		*trace_loc++ = thread_pid;	/* pid */


		*trace_loc++ = (unsigned) 10060;	/* data_id */


	} else
		trace_overflow_error();
}  
        for (mol = 0; mol < NMOL; mol++) {
     	    for (atom = 0; atom < NATOM; atom++) {
                XMIN=min(XMIN,VAR[mol].F[DISP][XDIR][atom]);
                YMIN=min(YMIN,VAR[mol].F[DISP][YDIR][atom]);
                ZMIN=min(ZMIN,VAR[mol].F[DISP][ZDIR][atom]);
            }
        }
	{
	if (trace_loc < trace_buff_end) {	/* Test for overflow */
		*trace_loc++ = (unsigned) PTT_LoopExit;	/* type */
		*trace_loc = choices_clock->time();		/* time */
		trace_loc++;
		*trace_loc++ = thread_pid;	/* pid */


		*trace_loc++ = (unsigned) 10060;	/* data_id */


	} else
		trace_overflow_error();
}  
    
        /* subtract the MINs from every atom's displacements; 
           shifts the origin of the system to a corner of the 
           computational box */

	{
	if (trace_loc < trace_buff_end) {	/* Test for overflow */
		*trace_loc++ = (unsigned) PTT_LoopEnter;	/* type */
		*trace_loc = choices_clock->time();		/* time */
		trace_loc++;
		*trace_loc++ = thread_pid;	/* pid */


		*trace_loc++ = (unsigned) 10070;	/* data_id */


	} else
		trace_overflow_error();
}  
        for (mol = 0; mol < NMOL; mol++) {
 	    for (atom = 0; atom < NATOM; atom++) {
                VAR[mol].F[DISP][XDIR][atom] -= XMIN;
                VAR[mol].F[DISP][YDIR][atom] -= YMIN;
                VAR[mol].F[DISP][ZDIR][atom] -= ZMIN;
            }
        }
	{
	if (trace_loc < trace_buff_end) {	/* Test for overflow */
		*trace_loc++ = (unsigned) PTT_LoopExit;	/* type */
		*trace_loc = choices_clock->time();		/* time */
		trace_loc++;
		*trace_loc++ = thread_pid;	/* pid */


		*trace_loc++ = (unsigned) 10070;	/* data_id */


	} else
		trace_overflow_error();
}  
    } else {  /* do not use input file for displacements; use a
                regular lattice; only the case if the NFMC input in
                the file LWI5 is 0               */ 
	double NS = pow((double) NMOL, 1.0/3.0) - 0.00001;
	double XS = BOXL/NS;
	double ZERO = XS * 0.50;
	double WCOS = ROH * cos(ANGLE * 0.5);
	double WSIN = ROH * sin(ANGLE * 0.5);
	int i,j,k;
        fprintf(six, "***** NEW RUN STARTING FROM REGULAR LATTICE *****\n");
	fflush(six);
	XT[2] = ZERO;
	mol = 0;
	{
	if (trace_loc < trace_buff_end) {	/* Test for overflow */
		*trace_loc++ = (unsigned) PTT_LoopEnter;	/* type */
		*trace_loc = choices_clock->time();		/* time */
		trace_loc++;
		*trace_loc++ = thread_pid;	/* pid */


		*trace_loc++ = (unsigned) 10080;	/* data_id */


	} else
		trace_overflow_error();
}  
        for (i=0; i < NS; i+=1) {
	    XT[1]=XT[2]+WCOS;
	    XT[3]=XT[1];
	    YT[2]=ZERO;
	    for (j=0; j < NS; j+=1) {
		YT[1]=YT[2]+WSIN;
		YT[3]=YT[2]-WSIN;
		Z=ZERO;
		for (k = 0; k < NS; k++) {
		    for (atom = 0; atom < NATOMS; atom +=1) {
	        	VAR[mol].F[DISP][XDIR][atom] = XT[atom+1];
	        	VAR[mol].F[DISP][YDIR][atom] = YT[atom+1];
	        	VAR[mol].F[DISP][ZDIR][atom] = Z;
		    }
		    mol += 1;
      		    Z=Z+XS;
	         }
	         YT[2]=YT[2]+XS;
 	    }
            XT[2]=XT[2]+XS;
        }
	{
	if (trace_loc < trace_buff_end) {	/* Test for overflow */
		*trace_loc++ = (unsigned) PTT_LoopExit;	/* type */
		*trace_loc = choices_clock->time();		/* time */
		trace_loc++;
		*trace_loc++ = thread_pid;	/* pid */


		*trace_loc++ = (unsigned) 10080;	/* data_id */


	} else
		trace_overflow_error();
}  
        if (NMOL != mol) {
	 printf("Lattice init error: total mol %d != NMOL %d\n", mol, NMOL);
	 exit(-1);
        }
    }
     
    /* ASSIGN RANDOM MOMENTA */
    fscanf(random_numbers,"%lf",&SUX);

    SUMX=0.0;
    SUMY=0.0;
    SUMZ=0.0;
    /*   read pseudo-random numbers from input file random.in */
    {
	if (trace_loc < trace_buff_end) {	/* Test for overflow */
		*trace_loc++ = (unsigned) PTT_LoopEnter;	/* type */
		*trace_loc = choices_clock->time();		/* time */
		trace_loc++;
		*trace_loc++ = thread_pid;	/* pid */


		*trace_loc++ = (unsigned) 10090;	/* data_id */


	} else
		trace_overflow_error();
}  
    for (mol = 0; mol < NMOL; mol++) {
   	for (atom = 0; atom < NATOMS; atom++) {
            fscanf(random_numbers,"%lf",&VAR[mol].F[VEL][XDIR][atom]);
            fscanf(random_numbers,"%lf",&VAR[mol].F[VEL][YDIR][atom]);
            fscanf(random_numbers,"%lf",&VAR[mol].F[VEL][ZDIR][atom]);
     	    SUMX = SUMX + VAR[mol].F[VEL][XDIR][atom];
            SUMY = SUMY + VAR[mol].F[VEL][YDIR][atom];
     	    SUMZ = SUMZ + VAR[mol].F[VEL][ZDIR][atom];
        } /* atoms */
    } /* molecules */
    {
	if (trace_loc < trace_buff_end) {	/* Test for overflow */
		*trace_loc++ = (unsigned) PTT_LoopExit;	/* type */
		*trace_loc = choices_clock->time();		/* time */
		trace_loc++;
		*trace_loc++ = thread_pid;	/* pid */


		*trace_loc++ = (unsigned) 10090;	/* data_id */


	} else
		trace_overflow_error();
}  

    /* find average momenta per atom */
    SUMX=SUMX/(NATOMS*NMOL);
    SUMY=SUMY/(NATOMS*NMOL);
    SUMZ=SUMZ/(NATOMS*NMOL);

    /*  find normalization factor so that <k.e.>=KT/2  */
    SUX=0.0;
    SUY=0.0;
    SUZ=0.0;
    {
	if (trace_loc < trace_buff_end) {	/* Test for overflow */
		*trace_loc++ = (unsigned) PTT_LoopEnter;	/* type */
		*trace_loc = choices_clock->time();		/* time */
		trace_loc++;
		*trace_loc++ = thread_pid;	/* pid */


		*trace_loc++ = (unsigned) 10100;	/* data_id */


	} else
		trace_overflow_error();
}  
    for (mol = 0; mol < NMOL; mol++) {
    	SUX = SUX + (pow( (VAR[mol].F[VEL][XDIR][H1] - SUMX),2.0)
	       +pow( (VAR[mol].F[VEL][XDIR][H2] - SUMX),2.0))/HMAS
	       +pow( (VAR[mol].F[VEL][XDIR][O]  - SUMX),2.0)/OMAS;

    	SUY = SUY + (pow( (VAR[mol].F[VEL][YDIR][H1] - SUMY),2.0)
	       +pow( (VAR[mol].F[VEL][YDIR][H2] - SUMY),2.0))/HMAS
	       +pow( (VAR[mol].F[VEL][YDIR][O]  - SUMY),2.0)/OMAS;

    	SUZ = SUZ + (pow( (VAR[mol].F[VEL][ZDIR][H1] - SUMZ),2.0)
	       +pow( (VAR[mol].F[VEL][ZDIR][H2] - SUMZ),2.0))/HMAS
	       +pow( (VAR[mol].F[VEL][ZDIR][O]  - SUMZ),2.0)/OMAS;
    }
    {
	if (trace_loc < trace_buff_end) {	/* Test for overflow */
		*trace_loc++ = (unsigned) PTT_LoopExit;	/* type */
		*trace_loc = choices_clock->time();		/* time */
		trace_loc++;
		*trace_loc++ = thread_pid;	/* pid */


		*trace_loc++ = (unsigned) 10100;	/* data_id */


	} else
		trace_overflow_error();
}  
    FAC=BOLTZ*TEMP*NATMO/UNITM * pow((UNITT*TSTEP/UNITL),2.0);
    SUX=sqrt(FAC/SUX);
    SUY=sqrt(FAC/SUY);
    SUZ=sqrt(FAC/SUZ);

    /* normalize individual velocities so that there are no bulk
        momenta  */
    XMAS[1]=OMAS;
    {
	if (trace_loc < trace_buff_end) {	/* Test for overflow */
		*trace_loc++ = (unsigned) PTT_LoopEnter;	/* type */
		*trace_loc = choices_clock->time();		/* time */
		trace_loc++;
		*trace_loc++ = thread_pid;	/* pid */


		*trace_loc++ = (unsigned) 10110;	/* data_id */


	} else
		trace_overflow_error();
}  
    for (mol = 0; mol < NMOL; mol++) {
      	for (atom = 0; atom < NATOMS; atom++) {
	    VAR[mol].F[VEL][XDIR][atom] = ( VAR[mol].F[VEL][XDIR][atom] -
		SUMX) * SUX/XMAS[atom];
	    VAR[mol].F[VEL][YDIR][atom] = ( VAR[mol].F[VEL][YDIR][atom] -
		SUMY) * SUY/XMAS[atom];
	    VAR[mol].F[VEL][ZDIR][atom] = ( VAR[mol].F[VEL][ZDIR][atom] -
		SUMZ) * SUZ/XMAS[atom];
        } /* for atom */
    } /* for mol */
    {
	if (trace_loc < trace_buff_end) {	/* Test for overflow */
		*trace_loc++ = (unsigned) PTT_LoopExit;	/* type */
		*trace_loc = choices_clock->time();		/* time */
		trace_loc++;
		*trace_loc++ = thread_pid;	/* pid */


		*trace_loc++ = (unsigned) 10110;	/* data_id */


	} else
		trace_overflow_error();
}  
    if (nfmc != NULL)
	fclose(nfmc);   /* close input file LWI12 */
} /* end of subroutine INITIA */
