divert(-1)

/**********************************************************************
$Id: parmacs.m4 2 2004-06-03 01:58:28Z jcarlyle $

$Source: /projects/choices/old/cvsroot/choices/Applications/Water/parmacs.m4,v $

$Log: parmacs.m4,v $
Revision 1.1  2004/06/03 01:58:30  jcarlyle
Initial revision

# Revision 1.1  1993/02/25  06:16:08  sblim
# Initial revision
#
Revision 1.12  1993/02/17  00:13:57  drk
Print buffer-dumping time.

Revision 1.11  1993/01/19  07:18:30  drk
Fixed bugs, removed FS-locking stuff, removed debugging statements.

Revision 1.10  1993/01/18  06:48:04  drk
Add `PRINT_STATS' flag; this version still has some bugs!

Revision 1.9  1992/04/07  20:46:10  drk
Many changes: use UnixApplication.h again; lock concurrent FS
accesses (due to Choices bug); use Process::wakeUpWaiter() to
return properly to Bash after exit(); fix bug with num_children
in simple instrumentation; use Process::waitForProcess() again
(since Choices bug has been fixed).

Revision 1.8  1992/03/26  23:52:18  drk
Fix assorted bugs, put in hack for declaration of unixApplicationInit().

Revision 1.7  1992/03/23  07:52:20  drk
Add Choices trace record for process creation; fix stdlib.h
multiple inclusion problem.

Revision 1.6  1992/03/17  22:30:50  drk
Touch all elements of trace_buff[] in "simple" instr. to avoid
page faults during trace logging.

Revision 1.5  1992/03/02  21:53:31  drk
Fix up UMax shared-mem. function declarations.

Revision 1.4  1992/03/02  06:13:28  drk
Massive changes to merge the old UMax, Choices, and null versions
into a single version with all the same features (selected by
command-line definitions to gnum4).

Revision 1.3.1.20  1992/01/28  20:22:49  drk
Change `LOG_PARMACS_EVENT' to keep execution time more even when data
ID is and is not present.

Revision 1.3.1.19  1992/01/22  19:53:58  drk
Many changes to get "simple" instrumentation running under Choices.

Revision 1.3.1.18  1992/01/21  16:39:38  zhang
Increased simple instrumentation buffer size;

Revision 1.3.1.17  92/01/20  20:02:44  drk
Make `LOCKDEC' declare an array instead of scalar.

Revision 1.3.1.16  1992/01/20  07:10:52  drk
Fix problem with `DO_INST' of `MAIN_ENV_TRACE_DEFS', etc., by using
`ifelse' instead.

Revision 1.3.1.15  1992/01/18  23:33:09  drk
Added unixApplicationInit__Fv() call to MAIN_INITENV in Choices
version

Revision 1.3.1.14  1992/01/17  22:40:25  drk
Do not expand tracing init macros when not tracing.

Revision 1.3.1.13  1992/01/16  22:12:51  zhang
Fixed a bug in loop tracing for Choices;

Revision 1.3.1.12  92/01/16  16:31:59  zhang
Another bug

Revision 1.3.1.11  92/01/16  14:41:23  zhang
Fixed a bug with loop instrumentation call

Revision 1.3.1.10  92/01/15  23:21:15  drk
Fix problem with address-type data_id fields in simple instrumentation

Revision 1.3.1.9  92/01/15  18:16:14  zhang
Added Choices instrumentation calls and corrected some minor bugs;

Revision 1.3.1.8  92/01/15  01:17:07  drk
Added "simple" and Choices trace support, procedure and loop
tracing.

Revision 1.3.1.7  91/11/25  19:56:31  drk
Fix problem with malloc() and calloc().

Revision 1.3.1.6  91/11/24  16:27:20  drk
Many fixes for VARARGS_HACK

Revision 1.3.1.5  91/11/21  17:45:32  drk
More functions added to `VARARGS_HACK'

Revision 1.3.1.4  91/11/21  17:07:12  drk
Use GNU M4; put in `VARARGS_HACK' flag and workaround.

Revision 1.3.1.3  91/10/24  17:13:12  drk
Turn CLOCK into simple counter.

Revision 1.3.1.2  91/10/14  16:06:55  drk
First real version of null macros.


Parmacs macro package for the Encore Multimax.  This version supports
either Choices or UMax, running in either a uniprocessor or multiprocessor
mode under either OS.  Under Choices, the following types of
instrumentation are supported: native Choices, "simple", and none.  Under
UMax, both "simple" and no instrumentation are supported.

This version was developed from a merger of the older, separate Choices,
UMax, and "null" (uniprocessor) versions of this file.
**********************************************************************/

/**********************************************************************
Check flags for OS and instrumentation.
**********************************************************************/

/*
One of the flags `CHOICES' or `UMAX' should be defined to indicate which OS
we're compiling for.

If uniprocessor rather than multiprocessor mode is desired, `UNIPROC' must
be defined.

If `CHOICES' is set, either `SIMPLE_INST' or `CHOICES_INST' may be set, to
select Choices or "simple" instrumentation.  If `UMAX' is set,
`SIMPLE_INST' may be set.  If no instrumentation flag is set, no
instrumentation is performed.

Also, if PRINT_STATS is defined, initialization and cleanup messages will
be printed out indicating the status of the "simple" instrumentation (if it
is in use) and the total number of traces logged, as well as the the total
running time (regardless of what instrumentation is being used).
*/

/*
Since nested `ifdef's do not seem to work, I use temporary macros as flags
in combination with `ifelse' macros instead.
*/

ifdef(`CHOICES', `define(choices_set, 1)', `define(choices_set, 0)' )
ifdef(`UMAX', `define(umax_set, 2)', `define(umax_set, 0)' )
define(`os_flag', eval(choices_set + umax_set))
ifelse(os_flag, 0, `errprint(`Error: No OS flag set
') m4exit(1)' )
ifelse(os_flag, 3, `errprint(`Error: Both OS flags set
') m4exit(1)' )

ifdef(`CHOICES_INST', `define(choices_inst_set, 1)',
		      `define(choices_inst_set, 0)' )
ifdef(`SIMPLE_INST', `define(simple_inst_set, 2)',
		     `define(simple_inst_set, 0)' )
define(`inst_flag', eval(choices_inst_set + simple_inst_set))

ifelse(inst_flag, 3, `errprint(`Error: Both instrumentation flags set
') m4exit(1)' )
ifelse(eval(umax_set && choices_inst_set), 1,
       `errprint(`Error: Using Choices instrumentation under UMax
') m4exit(1)' )

/*
Undefine unneeded flags; keep around definition of `inst_flag' because it's
needed in certain other macros.
*/

undefine(`choices_set')
undefine(`umax_set')
undefine(`os_flag')
undefine(`choices_inst_set')
undefine(`umax_inst_set')


/**********************************************************************
Work-arounds for Choices library deficiencies.
**********************************************************************/

/*
Extra stuff that's not in the Choices Unix Compatibility libraries.
*/

ifdef(`CHOICES', `

define(cfree, `free($1)')

define(getpid, `0')

define(perror, `fprintf(stderr, "%s: (some kind of error)\n", $1)')
' )


/**********************************************************************
Macros for handling procedure and loop trace points.
**********************************************************************/

/*
Generate the name of the macro used to store the ID number of particular
trace points.  For both proc. and looop entry/exit trace points, `$1' is 
the module name (.U file), and `$2' is the procedure name.  For loop trace
points only, `$3' is the loop label.  Note that the text of these macro
definitions is packed tightly, to prevent spaces in the output names they
generate.
*/

define(PROC_TRACE_POINT_NAME, `patsubst($1, `\.', `_')`_'$2')

define(LOOP_TRACE_POINT_NAME, `patsubst($1, `\.', `_')`_'$2`_'$3')

/*
For Choices style instrumentation, let x be a procedure id number, then
2*x-1 denotes procedure x entry, and 2*x denotes its exit, e.g. procedure 5
would have entry and exit event id 9 and 10 respectively.
*/

define(ENTRY_CAL,`eval(($1)*2-1)')

define(EXIT_CAL,`eval(($1)*2)')

/*
Define a proc. or loop trace point and its ID number in instrumentation
records.  For both proc. and loop trace points, `$1' is  the module name
(.U file), and `$2' is the procedure name.  For loops only, `$3' is the
loop label.  For both procs. and loops, the last parameter (`$3' and `$4',
respectively) is the ID number for the trace point.
*/

define(TRACE_PROC, `
        define(PROC_TRACE_POINT_NAME($1, $2), $3)
' )

define(TRACE_LOOP, `
        define(LOOP_TRACE_POINT_NAME($1, $2, $3), $4)
' )


/*
Get the proc. and loop trace points defined for the program being compiled.
They are defined using `TRACE_PROC' and `TRACE_LOOP', above.
*/

include(`trace_points.m4')


/*
If `CHOICES_INST' is defined, insert the text for Choices instrumentation
which is contained in `$1'.  If `SIMPLE_INST' is defined, insert the text
for "simple" instrumentation which is in `$2'.  Otherwise, insert a null
statement (";").

This macro does not seem to work reliably when the text in `$1' or `$2' is
long and complex; use inline `ifelse' tests on `inst_flag' in those cases. 
It does work fine for Choices and "simple"-style logging statements
(`LOG_CHOICES_EVENT' and `LOG_SIMPLE_EVENT').
*/

define(DO_INST, `ifelse(inst_flag, 1, `$1', inst_flag, 2, `$2', `;')' )


/*
Trace entry to or exit from a procedure.  `$1' is the procedure's module,
`$2' is the procedure name.  This macro is inserted directly into the C
source code before and after the point of call.

These macros first determine if the procedure in question has had a trace
point defined for it (by `TRACE_PROC') using `ifdef'.  If so, `DO_INST' is
used to insert the appropriate type of instrumentation code (Choices-style
or "simple"-style) into the C source.  Their definitions are tightly packed
to avoid introducing lots of empty lines into the final C source (this
makes it hard to check if the macro is working right).
*/

define(TRACE_PROC_ENTER,
       `ifdef(patsubst($1, `\.', `_')`_$2', DO_INST(
`LOG_CHOICES_EVENT(ENTRY_CAL(PROC_TRACE_POINT_NAME($1, $2)),
		   "PROC_TRACE_POINT_NAME($1,$2)_enter");',
LOG_SIMPLE_EVENT(PTT_ProcEnter, PROC_TRACE_POINT_NAME($1, $2))))')

define(TRACE_PROC_EXIT,
       `ifdef(patsubst($1, `\.', `_')`_$2', DO_INST(
`LOG_CHOICES_EVENT(EXIT_CAL(PROC_TRACE_POINT_NAME($1, $2)),
		   "PROC_TRACE_POINT_NAME($1,$2)_exit");',
LOG_SIMPLE_EVENT(PTT_ProcExit, PROC_TRACE_POINT_NAME($1, $2))))')

/*
Trace entry to or exit from a loop.  `$1' is the name of the procedure the
loop appears within, `$2' is the loop ID number.  (The module the procedure
appears in is obtained using the M4 built-in `__file__'.)  This macro is
inserted directly into the C source code before and after the loop.

These macros work basically the same way as `TRACE_PROC_ENTER' and
`TRACE_PROC_EXIT', above.
*/

define(TRACE_LOOP_ENTER,
	`ifdef(patsubst(__file__, `\.', `_')`_$1_$2', DO_INST(
`LOG_CHOICES_EVENT(ENTRY_CAL(LOOP_TRACE_POINT_NAME(__file__,$1, $2)),
		   "LOOP_TRACE_POINT_NAME(__file__,$1,$2)_enter");',
LOG_SIMPLE_EVENT(PTT_LoopEnter, LOOP_TRACE_POINT_NAME(__file__,$1,$2))))')

define(TRACE_LOOP_EXIT,
	`ifdef(patsubst(__file__, `\.', `_')`_$1_$2', DO_INST(
`LOG_CHOICES_EVENT(EXIT_CAL(LOOP_TRACE_POINT_NAME(__file__,$1, $2)),
		   "LOOP_TRACE_POINT_NAME(__file__,$1,$2)_exit");',
LOG_SIMPLE_EVENT(PTT_LoopExit, LOOP_TRACE_POINT_NAME(__file__,$1,$2))))')


/**********************************************************************
Macros for PARMACS primitives, including instrumentation code.
**********************************************************************/

/*
Global declarations and their initialization and cleanup.
*/

define(MAIN_ENV, `

ifdef(`CHOICES', `
#ifndef BUFSIZ
#include "stdio.h"
#include "stdlib.h"
#endif
', `
#ifndef BUFSIZ
#include <stdio.h>
#include <stdlib.h>
#endif
' )

ifdef(`PRINT_STATS', `
unsigned start_time, end_time;	/* Main thread start and end times. */
unsigned thread_num;	/* Number of threads created before this process (0
			   for main, 1 for first child, etc.). */
' )

ifdef(`UNIPROC', `', `
char *spinlock_addr;		/* For `spinlock' macro. */
' )

ifdef(`UMAX', `
extern "C" {
#include <parallel.h>
}

unsigned *m4_timer;

ifdef(`UNIPROC', `', `
extern "C" {
#include <sys/types.h>
#include <sys/gang.h>
#include <sys/wait.h>

/*
Prototypes for UMax multiprocessing library functions.
*/

extern int gang_create(int, int);
extern int gang_destroy(int);
extern int share_malloc_init(int);
extern char *share_malloc(int);
extern void share_free(char *);
extern int gang_enter(int);
extern int gang_exit(int);
}

#define SHARED_MEM_SIZE 12000000
int gang_id, gang_size;

/*
Function to replace gang_maxsize(2), which the man pages claim UMax should
have (but it does not).  This naive implementation just creates gangs of
successively larger sizes until it fails.

Returns maximum number of processors which can be allocated to a gang
(which is >= 1), or -1 on errors (errno will also be set on errors).
*/

static int gang_maxsize(void)
{
	int i = 0, gang_id = 1;

	do {
		i++;
			/* create gang without waiting for processors */
		switch (gang_id = gang_create(i, 0)) {
		case 0:
			return -1;
		default:
			if (gang_destroy(gang_id) == -1)
				return -1;
		case -1:
			break;
		}
	} while (gang_id > 0);

	if (i == 1)	/* Should be able to make single-processor gang */
		return -1;
	else
		return i - 1;
}	/* gang_maxsize() */
' )
' )

ifdef(`CHOICES', `
#include "Assert.h"
#include "FreeRunningTimer.h"
#include "NameServer.h"
#include "Process.h"
#include "ThisProcess.h"
#include "UnixApplication.h"

FreeRunningTimer *choices_clock;

ifdef(`UNIPROC', `', `
/*
Choices shared-memory allocator; ought to be in a header somewhere.
*/

extern void *shnew(long n);	/* Allocate n shared bytes */
extern void initializeNewSharedAllocator(void);

#define MAX_NUM_PROCS 128	/* Maximum number of child processes. */
Process* child_procs[MAX_NUM_PROCS];	/* Set of child procs. */
unsigned num_child_procs = 0;	/* Count of child procs. */
' )
' )

ifelse(inst_flag, 0, `', `MAIN_ENV_TRACE_DEFS')
' )

define(EXTERN_ENV, `

ifdef(`CHOICES', `
#ifndef BUFSIZ
#include "stdio.h"
#include "stdlib.h"
#endif
#include "Math.h"
', `
#ifndef BUFSIZ
#include <stdio.h>
#include <stdlib.h>
#endif
#include "math.h"
' )

ifdef(`PRINT_STATS', `
				/* Main thread start and end times. */
extern unsigned start_time, end_time;
extern unsigned thread_num;
' )

ifdef(`UNIPROC', `', `
extern char *spinlock_addr;	/* For `spinlock' macro. */
' )

ifdef(`UMAX', `
extern "C" {
#include <parallel.h>
}

extern unsigned *m4_timer;

ifdef(`UNIPROC', `', `
extern "C" {
#include <sys/types.h>
#include <sys/gang.h>
#include <sys/wait.h>

/*
Prototypes for UMax multiprocessing library functions.
*/

extern int gang_create(int, int);
extern int gang_destroy(int);
extern int share_malloc_init(int);
extern char *share_malloc(int);
extern void share_free(char *);
extern int gang_enter(int);
extern int gang_exit(int);
}

#define SHARED_MEM_SIZE 12000000
extern int gang_id, gang_size;
' )
' )

ifdef(`CHOICES', `
#include "Assert.h"
#include "FreeRunningTimer.h"
#include "NameServer.h"
#include "Process.h"
#include "ThisProcess.h"
#include "UnixApplication.h"

extern FreeRunningTimer* choices_clock;

ifdef(`UNIPROC', `', `
extern void *shnew(long n);
extern void initializeNewSharedAllocator(void);

#define MAX_NUM_PROCS 128
extern Process* child_procs[MAX_NUM_PROCS];
extern unsigned num_child_procs;
' )
' )

ifelse(inst_flag, 0, `', `EXTERN_ENV_TRACE_DEFS')
' )

define(MAIN_INITENV, `{

ifdef(`CHOICES', `
	unixApplicationInit();	/* Choices Unix compatibility library
				   initialization. */

ifdef(`UNIPROC', `', `
	initializeNewSharedAllocator();
' )

				/* Set up clock. */
	choices_clock = (FreeRunningTimer *) (ProxiableObject *)
			StandardNameServer->lookup("SystemTimer",
						   "FreeRunningTimer");
	if (!choices_clock) {
		fprintf(stderr,
"StandardNameServer->lookup(\"SystemTimer\", \"FreeRunningTimer\") \
failed\n");
		exit(1);
	}
' )

ifdef(`UMAX', `
	m4_timer = timer_init();

ifdef(`UNIPROC', `', `
	if (share_malloc_init(SHARED_MEM_SIZE)) {
		perror("share_malloc_init() failed");
		exit(1);
	}

	if ((gang_size = gang_maxsize()) == -1) {
		perror("gang_maxsize() failed");
		exit(1);
	}

/*
GANG_RMIDSIG causes all gang members to exit when gang_destroy(2) is called
(see gang(2)).
*/

	if ((gang_id = gang_create(gang_size, GANG_RMIDSIG)) <= 0) {
		perror("gang_create() failed");
		exit(1);
	}

		/* Add main process to gang immediately */
	if (gang_enter(gang_id) == -1) {
		perror("gang_enter() failed for main process");
		exit(1);
	}
' )
' )

	ifelse(inst_flag, 0, `', `INIT_TRACING')

ifdef(`PRINT_STATS', `
	CLOCK(start_time);
	CLOCK(start_time);
' )

	DO_INST(`LOG_CHOICES_EVENT(EID_MAIN_INITENV, "in_MAIN_INITENV");',
		LOG_SIMPLE_EVENT(PTT_MainInitEnv))
}' )

/*
Parameter `$1' to this macro is the exit status.
*/

define(MAIN_END, `{
	DO_INST(`LOG_CHOICES_EVENT(EID_MAIN_END, "in_MAIN_END");',
		LOG_SIMPLE_EVENT(PTT_MainEnd))

ifdef(`PRINT_STATS', `
	CLOCK(end_time);
	CLOCK(end_time);
	printf("Thread %d: start %u, end %u, duration %u.\n", thread_num,
	       start_time, end_time, end_time - start_time);
	fflush(stdout);
' )


	{

ifdef(`PRINT_STATS', `
				/* Buffer dump start and end. */
		unsigned bd_start, bd_end;

		CLOCK(bd_start);
		CLOCK(bd_start);
' )

		ifelse(inst_flag, 0, `', `END_TRACING')

ifdef(`PRINT_STATS', `
		CLOCK(bd_end);
		CLOCK(bd_end);
		printf(
"Thread %d buffer dump: start %u, end %u, duration %u.\n", thread_num,
		       bd_start, bd_end, bd_end - bd_start);
		fflush(stdout);
' )

	}

ifdef(`CHOICES', `
ifdef(`UNIPROC', `', `
	thisProcess()->wakeUpWaiter();
' )
' )

	exit($1);
}' )

/*
Process creation and control, thread startup and cleanup.
*/

ifdef(`CHOICES', `
define(CREATE, `{
	Process *proc;	/* The new process forked off. */

ifdef(`CHOICES_INST', `
	LOG_CHOICES_EVENT(EID_CREATE_entry, "in_CREATE_entry")
' )

ifdef(`SIMPLE_INST', `
	LOG_SIMPLE_EVENT(PTT_Create)
	FLUSH_TRACEFILE
	num_children++;
' )

	fflush(stdout);

			/* cloneThisProcess() is a lot like fork(2). */
	if (!(proc = (Process *) cloneThisProcess())) {
			/* Running as child process here. */
		THREAD_INITENV
		$1();
		THREAD_END
		exit(0);
	} else
			/* Running as parent process here. */
		child_procs[num_child_procs++] = proc;

ifdef(`CHOICES_INST', `
	LOG_CHOICES_EVENT(EID_CREATE_exit, "in_CREATE_exit")
' )

ifdef(`SIMPLE_INST', `
	LOG_SIMPLE_EVENT(PTT_CreateDone)
' )

}' )

/*
This version waits for all children, no matter what its argument is.  This
is because there appears to be no easy way to wait for just any child to
complete (you have to wait for a specific one).
*/

define(WAIT_FOR_END, `{
	DO_INST(`LOG_CHOICES_EVENT(EID_WAIT_FOR_END_entry,
				   "in_WAIT_FOR_END_entry");',
	        LOG_SIMPLE_EVENT(PTT_WaitForEnd))

				/* Wait for all children. */
	for (int i = 0; i < num_child_procs; i++)
		thisProcess()->waitForProcess(child_procs[i]);
	num_child_procs = 0;

	DO_INST(`LOG_CHOICES_EVENT(EID_WAIT_FOR_END_exit,
				   "in_WAIT_FOR_END_exit");',
	        LOG_SIMPLE_EVENT(PTT_WaitForEndDone))
}' )
' )

ifdef(`UMAX', `
define(CREATE, `{
	int rc;

ifdef(`SIMPLE_INST', `
	LOG_SIMPLE_EVENT(PTT_Create)
	FLUSH_TRACEFILE
	num_children++;
' )

	fflush(stdout);

	if ((rc = fork()) == 0) {
		if (gang_enter(gang_id) != -1) {
			THREAD_INITENV
			$1();
			THREAD_END
			gang_exit(0);
			exit(0);
		} else {
			perror("gang_enter() failed for child proc");
			exit(1);
		}
	} else if (rc == -1) {
		perror("fork() of child proc failed");
		exit(1);
	}

ifdef(`SIMPLE_INST', `
	LOG_SIMPLE_EVENT(PTT_CreateDone)
' )
}' )

/*
This version waits for `$1' children to complete.
*/

define(WAIT_FOR_END, `{
	int i;

ifdef(`SIMPLE_INST', `
	LOG_SIMPLE_EVENT(PTT_WaitForEnd)
' )

	for(i = 0; i < $1; i++)
		if (wait(NULL) == -1) {
			perror("wait() failed");
			exit(1);
		}

ifdef(`SIMPLE_INST', `
	LOG_SIMPLE_EVENT(PTT_WaitForEndDone)
' )
}' )
' )

/*
If using uniprocessor mode, fix up previous definitions.
*/

ifdef(`UNIPROC', `
undefine(`CREATE')
undefine(`WAIT_FOR_END')

define(CREATE, `{
	fprintf(stderr,
		"No more processors -- this is a uniprocessor version!\n");
	exit(-1);
}' )

define(WAIT_FOR_END, `{
	DO_INST(`LOG_CHOICES_EVENT(EID_WAIT_FOR_END_entry,
				   "in_WAIT_FOR_END_entry");',
	        LOG_SIMPLE_EVENT(PTT_WaitForEnd))
	DO_INST(`LOG_CHOICES_EVENT(EID_WAIT_FOR_END_exit,
				   "in_WAIT_FOR_END_exit");',
	        LOG_SIMPLE_EVENT(PTT_WaitForEndDone))
}' )

', `

define(THREAD_INITENV, `{
ifdef(`SIMPLE_INST', `
	INIT_TRACING

ifdef(`PRINT_STATS', `
	CLOCK(start_time);
	CLOCK(start_time);
' )

	LOG_SIMPLE_EVENT(PTT_ThreadInitEnv)
' )
}' )

define(THREAD_END, `{ 
ifdef(`SIMPLE_INST', `
	LOG_SIMPLE_EVENT(PTT_ThreadEnd)

ifdef(`PRINT_STATS', `
	CLOCK(end_time);
	CLOCK(end_time);
	printf("Thread %d: start %u, end %u, duration %u.\n", thread_num,
	       start_time, end_time, end_time - start_time);
	fflush(stdout);
' )

	END_TRACING
' )

ifdef(`CHOICES', `thisProcess()->wakeUpWaiter();' )
}' )

' )


/*
Shared memory allocation and de-allocation; not traced yet.
*/

ifdef(`UNIPROC', `
define(G_MALLOC, `malloc($1);')
define(G_FREE, `free($1);')

', `

ifdef(`CHOICES', `
define(G_MALLOC, `shnew($1);')
define(G_FREE, `;')
' )

ifdef(`UMAX', `
define(G_MALLOC, `(void *) share_malloc($1);')
define(G_FREE, `share_free((void *) $1);')
' )
' )


/*
Execution timing: Use UMax microsec. resolution clock, if available.  Under
UMax, just dereference the pointer to it; under Choices, call the
appropriate method for the FreeRunningTimer.

The clock under Choices will soon become a memory-mapped hardware register.

This macro must not return any 0 values, since the StopSegment() function
in timer.U in the LocusRoute Splash program gets freaked out by this.

Used to be: `define(CLOCK, `{long time(); ($1) = time(0);}')'
*/

ifdef(`CHOICES', `
define(CLOCK, `$1 = choices_clock->time();')
' )

ifdef(`UMAX', `
define(CLOCK, `$1 = *m4_timer;')
' )


/*
Synchronization object declaration and initialization.
*/

ifdef(`UNIPROC', `
define(BARDEC, `int ($1);')

define(LOCKDEC, `int ($1);')

define(ALOCKDEC, `int ($1) [$2];')

' , `

define(BARDEC, `DECVAR($1, 1, 1)')

define(LOCKDEC, `DECVAR($1, 0, 1)')

define(ALOCKDEC, `DECVAR($1, 0, $2)')

define(DECVAR, `
	struct $1TYP {
		char lock;

ifelse(eval($2 > 0), 1, `
		int count[$2];
		char queue[$2];
' )

		$4
	} $1[$3];
' )

' )

define(BARINIT, `{
	char *barrier_name = "$1";

	ifdef(`UNIPROC', `', `MONINIT($1, 1, 1)')

	DO_INST(`LOG_CHOICES_EVENT(EID_BARINIT, "in_BARINIT");',
		`LOG_SIMPLE_VARLEN_EVENT(PTT_BarInit, barrier_name, &$1)')
}' )

define(LOCKINIT, `{
	char *lock_name = "$1";

	ifdef(`UNIPROC', `', `MONINIT($1, 0, 1)')

	DO_INST(`LOG_CHOICES_EVENT(EID_LOCKINIT, "in_LOCKINIT");',
		`LOG_SIMPLE_VARLEN_EVENT(PTT_LockInit, lock_name, &$1)')
}' )

define(ALOCKINIT, `{
	int i;
	char lock_name[256];

	ifdef(`UNIPROC', `', `MONINIT($1, 0, $2)')

	for (i = 0; i < $2; i++) {
		sprintf(lock_name, "%s[%d]", "$1", i);
		DO_INST(
`LOG_CHOICES_EVENT(EID_ALOCKINIT, "in_ALOCKINIT");',
`LOG_SIMPLE_VARLEN_EVENT(PTT_ALockInit, lock_name, &$1[i])')
	}
}' )

ifdef(`UNIPROC', `', `
define(MONINIT, `{
	int mon_dum1;

ifelse(eval($2 > 0), 1, `
	int mon_dum2;

	for (mon_dum1 = 0; mon_dum1 < $3; mon_dum1++)
		for (mon_dum2 = 0; mon_dum2 < $2; mon_dum2++) {
			$1[mon_dum1].count[mon_dum2] = 0;
			$1[mon_dum1].queue[mon_dum2] = 0;
			spinlock(($1[mon_dum1].queue[mon_dum2]));
		}
' )

	for (mon_dum1 = 0; mon_dum1 < $3; mon_dum1++)
		$1[mon_dum1].lock = 0;
}' )
' )


/*
Synchronization object operations.
*/

define(BARRIER, `{
	DO_INST(`LOG_CHOICES_EVENT(EID_BARRIER_entry,
				   "in_BARRIER_entry");',
		LOG_SIMPLE_EVENT(PTT_BarEnter, &$1))

	ifdef(`UNIPROC', `
DO_INST(`LOG_CHOICES_EVENT(EID_BARRIER_exit, "in_BARRIER_exit");',
	LOG_SIMPLE_EVENT(PTT_BarExitLast, &$1))

', `

	spinlock(($1[0].lock));

	if ($1[0].count[0] < ($2 - 1)) {
		$1[0].count[0]++;
		releaselock(($1[0].lock));
		spinlock(($1[0].queue[0]));
	}

	if ($1[0].count[0] == 0) {
		DO_INST(`LOG_CHOICES_EVENT(EID_BARRIER_exit,
					   "in_BARRIER_exit");',
			LOG_SIMPLE_EVENT(PTT_BarExitLast, &$1))
		releaselock(($1[0].lock));
	} else {
		($1[0].count[0])--;
		DO_INST(`LOG_CHOICES_EVENT(EID_BARRIER_exit,
					   "in_BARRIER_exit");',
			LOG_SIMPLE_EVENT(PTT_BarExit, &$1))
		releaselock(($1[0].queue[0]));
	}
' )
}' )

define(LOCK, `{
	DO_INST(`LOG_CHOICES_EVENT(EID_LOCK_entry, "in_LOCK_entry");',
		LOG_SIMPLE_EVENT(PTT_Lock, &$1))
	ifdef(`UNIPROC', `', `MENTER($1, 0)')
	DO_INST(`LOG_CHOICES_EVENT(EID_LOCK_exit, "in_LOCK_exit");',
		LOG_SIMPLE_EVENT(PTT_LockDone, &$1))
}' )

define(UNLOCK, `{
	ifdef(`UNIPROC', `', `MEXIT($1, 0)')
	DO_INST(`LOG_CHOICES_EVENT(EID_UNLOCK, "in_UNLOCK");',
		LOG_SIMPLE_EVENT(PTT_Unlock, &$1))
}')

define(ALOCK, `{
	DO_INST(`LOG_CHOICES_EVENT(EID_ALOCK_entry, "in_ALOCK_entry");',
		LOG_SIMPLE_EVENT(PTT_ALock, &$1[$2]))
	ifdef(`UNIPROC', `', `MENTER($1, $2)')
	DO_INST(`LOG_CHOICES_EVENT(EID_ALOCK_exit, "in_ALOCK_exit");',
		LOG_SIMPLE_EVENT(PTT_ALockDone, &$1[$2]))
}' )

define(AULOCK, `{
	ifdef(`UNIPROC', `', `MEXIT($1, $2)')
	DO_INST(`LOG_CHOICES_EVENT(EID_AULOCK, "in_AULOCK");',
		LOG_SIMPLE_EVENT(PTT_AUnlock, &$1[$2]))
}' )

ifdef(`UNIPROC', `', `
define(MENTER, `{
	spinlock(($1[$2].lock));
}' )

define(MEXIT, `{
	$1[$2].lock = 0;
}' )

define(SPINLAB,2222) dnl
define(spinlock, `{
#ifdef SPARC
	unsigned status;
	do {
		register unsigned regvar;
		asm volatile ("ldstub %1,%0" : "=r" (regvar) : "m" ($1) ); 
		status = regvar;
		if ( status ) thisProcess()->relinquishProcessor();
	} while( status );
/*
#define LOAD_REG_FROM_MEM(reg, var) \
({	register unsigned fake_register_variable asm(#reg); \
	asm volatile ("ld %1,%0" : "=r" (fake_register_variable) : "m" (var) ); })
*/
#endif
#ifdef MULTIMAX
	spinlock_addr = (&($1));
	asm("`L'SPINLAB:");
	asm("cmpqb	`$'0, 0(_spinlock_addr)");
	asm("bne 	`L'SPINLAB");
	asm("sbitib	`$'0, 0(_spinlock_addr)");
	asm("bfs 	`L'SPINLAB"); 
	define(`SPINLAB',eval(SPINLAB+1))
#endif
}' )

define(releaselock, `{
#ifdef SPARC
	$1 = 0;
#endif
#ifdef MULTIMAX
	spinlock_addr = (&($1));
	asm("movqb	`$'0, 0(_spinlock_addr)");
#endif
}' )
' )


/**********************************************************************
Definitions for Choices-style instrumentation.
**********************************************************************/

ifdef(`CHOICES_INST', `

define(`MAIN_ENV_TRACE_DEFS', `
#include "Instrument.h"
#include "UserInstrumentManager.h"

UserInstrumentManager *userInstMgr;
EventerInstrument *eventerInstr;
' )

define(`EXTERN_ENV_TRACE_DEFS', `
#include "Instrument.h"
#include "UserInstrumentManager.h"

extern UserInstrumentManager *userInstMgr;
extern EventerInstrument *eventerInstr;
' )

define(`INIT_TRACING', `

	userInstMgr = new UserInstrumentManager("An iMgr(C)", 16);
	if (!userInstMgr) {
		fprintf(stderr, "new UserInstrumentManager() failed\n");
		exit(1);
	}

	eventerInstr = new EventerInstrument(userInstMgr, "An eventer(C)",
					     TALKING);
	if (!eventerInstr) {
		fprintf(stderr, "new EventerInstrument() failed\n");
		exit(1);
	}
' )

define(`END_TRACING', `
	delete eventerInstr;
	delete userInstMgr;
' )

/*
Log event using Choices Instrumentation facilities.  `$1' is the eventID
(see below), `$2' is a character string for the message field.
*/

define(LOG_CHOICES_EVENT, `eventerInstr->event($1, $2, 0);')

/*
Event ID definitions.  These may change someday, and probably ought to be
in a header file in any case.
*/

define(`EID_MAIN_INITENV',1)
define(`EID_MAIN_END',2)
define(`EID_WAIT_FOR_END_entry',3)
define(`EID_WAIT_FOR_END_exit',4)
define(`EID_BARINIT',5)
define(`EID_LOCKINIT',6)
define(`EID_BARRIER_entry',7)
define(`EID_BARRIER_exit',8)
define(`EID_LOCK_entry',9)
define(`EID_LOCK_exit',10)
define(`EID_ALOCK_entry',11)
define(`EID_ALOCK_exit',12)
define(`EID_UNLOCK',13)
define(`EID_AULOCK',14)
define(`EID_ALOCKINIT',15)
define(`EID_CREATE_entry',16)
define(`EID_CREATE_exit',17)
')


/**********************************************************************
Definitions for "simple"-style instrumentation.  Split into multiple pieces
because GNU M4 dies otherwise.
**********************************************************************/

ifdef(`SIMPLE_INST', `

define(MAIN_ENV_TRACE_DEFS, `
ifdef(`CHOICES', `
#include "String.h"
', `
#include <string.h>
' )

#include "ParmacsTrace.h"

char trace_fname[256];	/* Output trace file name. */
FILE *trace_file;	/* Output trace file. */
#define TRACE_BUFF_SIZE 262144	/* Max. records in trace buffer, 16 bytes
				   per element. */
unsigned trace_buff[TRACE_BUFF_SIZE * 4];	/* The trace buffer. */
unsigned *trace_loc;	/* Current location in trace_buff; next field goes
			   here. */
			/* Location in trace_buff at end of tracing. */
unsigned *final_trace_loc;
			/* Trace buffer has overflowed when trace_loc
			   reaches this value. */
unsigned *trace_buff_end = trace_buff + (TRACE_BUFF_SIZE * 4);

unsigned thread_pid;	/* Process ID of this thread. */
unsigned num_children = 0;	/* Number of children of this process; not
				   meaningful for any but main process. */

char *ParmacsTrace_version = PARMACS_TRACE_VERSION;
char parmacs_rcsid[] = "$Header: /projects/choices/old/cvsroot/choices/Applications/Water/parmacs.m4,v 1.1 2004/06/03 01:58:30 jcarlyle Exp $";

/*
Report I/O errors on trace file and exit.
*/

void trace_io_error(char *func)
{
	char err_msg[256];

	sprintf(err_msg,
"%s() failed for \"%s\" for process %d [child #%d]", func, trace_fname,
		thread_pid, thread_num);
	perror(err_msg);
	exit(1);
}	/* trace_io_error() */

/*
Report trace overflow error and exit.
*/

void trace_overflow_error(void)
{
	fprintf(stderr,
"trace buffer overflow in process %d [child #%d]\n", thread_pid,
		thread_num);
	exit(1);
}	/* trace_overflow_error() */
' )

define(EXTERN_ENV_TRACE_DEFS, `
ifdef(`CHOICES', `
#include "String.h"
', `
#include <string.h>
' )

#include "ParmacsTrace.h"

extern char trace_fname[];
extern FILE *trace_file;
#define TRACE_BUFF_SIZE 262144
extern unsigned trace_buff[TRACE_BUFF_SIZE * 4];
extern unsigned *trace_loc;
extern unsigned *final_trace_loc;
unsigned *trace_buff_end;
extern unsigned thread_pid;
extern unsigned num_children;
extern char *ParmacsTrace_version;

extern void trace_io_error(char *func);
extern void trace_overflow_error(void);
' )

' )


ifdef(`SIMPLE_INST', `

/*
Initialize trace variables; also enters initial PTT_Version trace record
for this thread.

Note that every element of trace_buff is "touched" to avoid causing
page-faults as trace records are logged (this adds a lot to the overhead
for instrumentation).
*/

define(INIT_TRACING, `{
	trace_loc = trace_buff;
	thread_pid = (unsigned) getpid();
	thread_num = num_children;
				/* "Touch" all elements of trace_buff[]. */
	for (int i = 0; i < TRACE_BUFF_SIZE * 4; i++)
		trace_buff[i] = i;

	sprintf(trace_fname, "parmacs.%d.trace", thread_num);
	if ((trace_file = fopen(trace_fname, "w")) == NULL)
		trace_io_error("fopen");
	LOG_SIMPLE_VARLEN_EVENT(PTT_Version, ParmacsTrace_version)
}' )

/*
Return 0 if $1 is the null string, 1 otherwise.
*/

define(non_null, `ifelse(len($1), 0, 0, 1)')

/*
Enter fixed-length trace record of type $1 (with optional data_id in $2:
must be an address or procedure or loop ID) into trace buffer.
*/

define(LOG_SIMPLE_EVENT, `{
	if (trace_loc < trace_buff_end) {	/* Test for overflow */
		*trace_loc++ = (unsigned) $1;	/* type */
		CLOCK(*trace_loc)		/* time */
		trace_loc++;
		*trace_loc++ = thread_pid;	/* pid */

ifelse(non_null($2), 1, `
		*trace_loc++ = (unsigned) $2;	/* data_id */
', `
				/* Not a meaningful value; this assignment
				   keeps execution time more even. */
		*trace_loc++ = (unsigned) &thread_pid;
' )

	} else
		trace_overflow_error();
}' )


/*
Write variable-length trace record of type $1, with string field $2 (and
optional data_id in $3: must be an address) directly to trace file (don't
buffer record).
*/

define(LOG_SIMPLE_VARLEN_EVENT, `{
	unsigned type = (unsigned) $1;
	unsigned time;
	int slen = strlen($2) + 1;

ifelse(non_null($3), 1, `
	unsigned data_id = (unsigned) $3;
', `
	unsigned data_id;	/* random garbage */
' )

	CLOCK(time)
	if (!fwrite((char *) &type, sizeof(unsigned), 1, trace_file) ||
	    !fwrite((char *) &time, sizeof(unsigned), 1, trace_file) ||
	    !fwrite((char *) &thread_pid, sizeof(unsigned), 1,
		    trace_file) ||
	    !fwrite((char *) &data_id, sizeof(unsigned), 1, trace_file) ||
	    !fwrite($2, sizeof(char), slen, trace_file))
		trace_io_error("fwrite");
}' )

/*
Flush trace file: must do this before creating any child processes,
otherwise multiple copies of unflushed data appear in the trace file.
*/

define(FLUSH_TRACEFILE, ` {
	if (fflush(trace_file) == EOF)
		trace_io_error("fflush");
}' )

/*
Dump trace buffer to file; can't enter new records into trace buffer after
this.
*/

define(END_TRACING, `{
	if (!fwrite((char *) trace_buff, sizeof(unsigned),
		    trace_loc - trace_buff, trace_file))
		trace_io_error("final fwrite");
	if (fclose(trace_file) == EOF)
		trace_io_error("fclose");
	final_trace_loc = trace_loc;
	trace_loc = trace_buff_end;	/* Prohibit subsequent logging */

ifdef(`PRINT_STATS', `
	printf("Total of %u logs for thread %u.\n",
	       (final_trace_loc - trace_buff) / 4, thread_num);
	fflush(stdout);
' )
}' )

' )


divert(0)
