#ifdef __GNUC__
#pragma implementation
#endif


/**********************************************************************
$Id: syscns.cc 2 2004-06-03 01:58:28Z jcarlyle $

$Source: /projects/choices/old/cvsroot/choices/Applications/Water/syscns.cc,v $

$Log: syscns.cc,v $
Revision 1.1  2004/06/03 01:58:30  jcarlyle
Initial revision

Revision 2.1  1992/06/03  19:52:23  zhang
Ansified version, initial checkin

Revision 1.3  1991/11/22  14:21:41  zhang
*** empty log message ***

Revision 1.2  91/10/30  11:10:39  zhang
Added log message


Sets up some system constants.
**********************************************************************/





#ifndef BUFSIZ
#include "stdio.h"
#include "stdlib.h"
#endif
#include "Math.h"



				/* Main thread start and end times. */
extern unsigned start_time, end_time;
extern unsigned thread_num;
 


extern char *spinlock_addr;	/* For spinlock macro. */
 




#include "Assert.h"
#include "FreeRunningTimer.h"
#include "NameServer.h"
#include "Process.h"
#include "ThisProcess.h"
#include "UnixApplication.h"

extern FreeRunningTimer* choices_clock;


extern void *shnew(long n);
extern void initializeNewSharedAllocator(void);

#define MAX_NUM_PROCS 128
extern Process* child_procs[MAX_NUM_PROCS];
extern unsigned num_child_procs;
 
 



#include "String.h"


#include "ParmacsTrace.h"

extern char trace_fname[];
extern FILE *trace_file;
#define TRACE_BUFF_SIZE 262144
extern unsigned trace_buff[TRACE_BUFF_SIZE * 4];
extern unsigned *trace_loc;
extern unsigned *final_trace_loc;
unsigned *trace_buff_end;
extern unsigned thread_pid;
extern unsigned num_children;
extern char *ParmacsTrace_version;

extern void trace_io_error(char *func);
extern void trace_overflow_error(void);
 
 

#define extern
#include "parameters.h"
#include "mdvar.h"
#include "water.h"
#include "wwpot.h"
#include "cnst.h"
#include "mddata.h"
#undef extern

void
SYSCNS(void)		/* sets up some system constants */
{
      TSTEP=TSTEP/UNITT;        /* time between steps */
      NATMO=NATOMS*NMOL;        /* total number of atoms in system */
      NATMO3=NATMO*3; /* number of atoms * number of spatial dimensions */
      FPOT= UNITM * pow((UNITL/UNITT),2.0) / (BOLTZ*TEMP*NATMO);
      FKIN=FPOT*0.50/(TSTEP*TSTEP);
      BOXL= pow( (NMOL*WTMOL*UNITM/RHO),(1.00/3.00));  /* computed
                length of the cubical "box".  Note that box size is
                computed as being large enough to handle the input
                number of water molecules */

      BOXL=BOXL/UNITL;    /* normalized length of computational box */

      BOXH=BOXL*0.50; /* half the box length, used in 
                          computing cutoff radius */

      CUTOFF=max(BOXH,CUTOFF); /* sqrt of cutoff radius; max of BOXH 
                                  and default (= 0); i.e. CUTOFF
                                  radius is set to half the normalized
                                  box length */

      REF1= -QQ/(CUTOFF*CUTOFF*CUTOFF);
      REF2=2.00*REF1;
      REF4=2.00*REF2;
      CUT2=CUTOFF*CUTOFF;       /* square of cutoff radius,  used 
                                    to actually decide whether an 
                                    interaction should be computed in 
                                    INTERF and POTENG */
      FHM=(TSTEP*TSTEP*0.50)/HMAS;
      FOM=(TSTEP*TSTEP*0.50)/OMAS;
      NMOL1=NMOL-1;
}       /* end of subroutine SYSCNS */
