#ifdef __GNUC__
#pragma implementation
#endif


/**********************************************************************
$Id: water.cc 2 2004-06-03 01:58:28Z jcarlyle $

$Source: /projects/choices/old/cvsroot/choices/Applications/Water/water.cc,v $

$Log: water.cc,v $
Revision 1.1  2004/06/03 01:58:30  jcarlyle
Initial revision

Revision 2.1  1992/06/03  19:52:23  zhang
Ansified version, initial checkin

Revision 1.10  1992/01/19  00:20:50  zhang
Stupid! Shouldn't have used the exact name of the macro in the previous
comment.

Revision 1.9  1992/01/18  23:35:56  zhang
Moved MAIN_INITENV in front of the first function call, and it now
contains the necessary lib init calls for Choices;

Revision 1.8  1992/01/14  20:16:43  zhang
Moved MAININIT_ENV in front of the first procedure tracing macro,
and added a function required for Choices applications.

Revision 1.7  91/12/06  17:42:06  zhang
Added trace macros calls to procedure entry and exit

Revision 1.6  91/11/22  14:21:48  zhang
*** empty log message ***

Revision 1.5  91/11/21  17:21:49  zhang
Added quotes to the word include in comments to surpress a m4 warning

Revision 1.4  91/10/30  11:11:16  zhang
*** empty log message ***

Revision 1.3  91/10/10  14:53:45  zhang
Added fclose for output files

Revision 1.2  91/10/04  15:17:03  zhang
Corrected include files; Initialized VIR to 0 to prevent a floating point
exception


Main module for WATER.
**********************************************************************/


#include "comments.h"	/* moves leading comments to another file */
#include "split.h"

/*  include files for declarations  */
#define extern
#include "parameters.h"
#include "mdvar.h"
#include "water.h"
#include "wwpot.h"
#include "cnst.h"
#include "mddata.h"
#include "fileio.h"
#include "frcnst.h"
#include "randno.h"
#include "global.h"
#undef extern




#ifndef BUFSIZ
#include "stdio.h"
#include "stdlib.h"
#endif



unsigned start_time, end_time;	/* Main thread start and end times. */
unsigned thread_num;	/* Number of threads created before this process (0
			   for main, 1 for first child, etc.). */
 


char *spinlock_addr;		/* For spinlock macro. */
 




#include "Assert.h"
#include "FreeRunningTimer.h"
#include "NameServer.h"
#include "Process.h"
#include "ThisProcess.h"
#include "UnixApplication.h"

FreeRunningTimer *choices_clock;


/*
Choices shared-memory allocator; ought to be in a header somewhere.
*/

extern void *shnew(long n);	/* Allocate n shared bytes */
extern void initializeNewSharedAllocator(void);

#define MAX_NUM_PROCS 128	/* Maximum number of child processes. */
Process* child_procs[MAX_NUM_PROCS];	/* Set of child procs. */
unsigned num_child_procs = 0;	/* Count of child procs. */
 
 



#include "String.h"


#include "ParmacsTrace.h"

char trace_fname[256];	/* Output trace file name. */
FILE *trace_file;	/* Output trace file. */
#define TRACE_BUFF_SIZE 262144	/* Max. records in trace buffer, 16 bytes
				   per element. */
unsigned trace_buff[TRACE_BUFF_SIZE * 4];	/* The trace buffer. */
unsigned *trace_loc;	/* Current location in trace_buff; next field goes
			   here. */
			/* Location in trace_buff at end of tracing. */
unsigned *final_trace_loc;
			/* Trace buffer has overflowed when trace_loc
			   reaches this value. */
unsigned *trace_buff_end = trace_buff + (TRACE_BUFF_SIZE * 4);

unsigned thread_pid;	/* Process ID of this thread. */
unsigned num_children = 0;	/* Number of children of this process; not
				   meaningful for any but main process. */

char *ParmacsTrace_version = PARMACS_TRACE_VERSION;
char parmacs_rcsid[] = "$Header: /projects/choices/old/cvsroot/choices/Applications/Water/water.cc,v 1.1 2004/06/03 01:58:30 jcarlyle Exp $";

/*
Report I/O errors on trace file and exit.
*/

void trace_io_error(char *func)
{
	char err_msg[256];

	sprintf(err_msg,
"%s() failed for \"%s\" for process %d [child #%d]", func, trace_fname,
		thread_pid, thread_num);
	fprintf(stderr, "%s: (some kind of error)\n", err_msg);
	exit(1);
}	/* trace_io_error() */

/*
Report trace overflow error and exit.
*/

void trace_overflow_error(void)
{
	fprintf(stderr,
"trace buffer overflow in process %d [child #%d]\n", thread_pid,
		thread_num);
	exit(1);
}	/* trace_overflow_error() */
 
 

struct GlobalMemory *gl;        /* pointer to the Global Memory
                                structure, which contains the lock,
                                barrier, and some scalar variables */
                                

int NSTEP, NSAVE, NRST, NPRINT,NFMC;
int NORD1;
int II;                         /*  variables explained in common.h */
int i;
int NDATA;
int   NFRST=11;
int  NFSV=10;
int  LKT=0;

int ProcID;                     /* process id; one per process */
int StartMol[MAXPROCS+1];       /* number of the first molecule
                                   to be handled by this process; used
                                   for static scheduling     */ 
int MolsPerProc;                /* number of mols per processor */ 
int NumProcs;                   /* number of processors being used; 
                                   run-time input           */

static void WorkStart(void);

int main(int argc, char **argv)
{
/*     int mol, func, dir, atom; Not used. */
    double XTT;
    double VIR = 0.0;

    /* default values for the control parameters of the driver */
    /* are in parameters.h */

	{


	unixApplicationInit();	/* Choices Unix compatibility library
				   initialization. */


	initializeNewSharedAllocator();
 

				/* Set up clock. */
	choices_clock = (FreeRunningTimer *) (ProxiableObject *)
			StandardNameServer->lookup("SystemTimer",
						   "FreeRunningTimer");
	if (!choices_clock) {
		fprintf(stderr,
"StandardNameServer->lookup(\"SystemTimer\", \"FreeRunningTimer\") \
failed\n");
		exit(1);
	}
 



	{
	trace_loc = trace_buff;
	thread_pid = (unsigned) 0;
	thread_num = num_children;
				/* "Touch" all elements of trace_buff[]. */
	for (int i = 0; i < TRACE_BUFF_SIZE * 4; i++)
		trace_buff[i] = i;

	sprintf(trace_fname, "parmacs.%d.trace", thread_num);
	if ((trace_file = fopen(trace_fname, "w")) == NULL)
		trace_io_error("fopen");
	{
	unsigned type = (unsigned) PTT_Version;
	unsigned time;
	int slen = strlen(ParmacsTrace_version) + 1;


	unsigned data_id;	/* random garbage */
 

	time = choices_clock->time();
	if (!fwrite((char *) &type, sizeof(unsigned), 1, trace_file) ||
	    !fwrite((char *) &time, sizeof(unsigned), 1, trace_file) ||
	    !fwrite((char *) &thread_pid, sizeof(unsigned), 1,
		    trace_file) ||
	    !fwrite((char *) &data_id, sizeof(unsigned), 1, trace_file) ||
	    !fwrite(ParmacsTrace_version, sizeof(char), slen, trace_file))
		trace_io_error("fwrite");
} 
} 


	start_time = choices_clock->time();;
	start_time = choices_clock->time();;
 

	{
	if (trace_loc < trace_buff_end) {	/* Test for overflow */
		*trace_loc++ = (unsigned) PTT_MainInitEnv;	/* type */
		*trace_loc = choices_clock->time();		/* time */
		trace_loc++;
		*trace_loc++ = thread_pid;	/* pid */


				/* Not a meaningful value; this assignment
				   keeps execution time more even. */
		*trace_loc++ = (unsigned) &thread_pid;
 

	} else
		trace_overflow_error();
}  
} ; 
    six = fopen("LWO6","w");  /* output file */
    nfmc = fopen("LWI12","r"); /* input file for particle
                                  displacements */

    TEMP  =298.0;
    RHO   =0.9980;
    CUTOFF=0.0;

   /* READ INPUT */

    scanf("%lf%d%d%d%d%d%d%d%d",&TSTEP, &NMOL, &NSTEP, &NORDER, 
	   &NSAVE, &NRST, &NPRINT, &NFMC,&NumProcs);
    if (NMOL > MAXMOLS) {
	fprintf(stderr, "Lock array in global.H has size %d < %d (NMOL)\n",
							MAXMOLS, NMOL);
	exit(-1);
    }

    printf("Using %d procs on %d steps of %d mols\n", NumProcs, NSTEP, NMOL);
    fflush(stdout);

    /* SET UP SCALING FACTORS AND CONSTANTS */

    NORD1=NORDER+1;

    {
	if (trace_loc < trace_buff_end) {	/* Test for overflow */
		*trace_loc++ = (unsigned) PTT_ProcEnter;	/* type */
		*trace_loc = choices_clock->time();		/* time */
		trace_loc++;
		*trace_loc++ = thread_pid;	/* pid */


		*trace_loc++ = (unsigned) 12;	/* data_id */


	} else
		trace_overflow_error();
}  
    CNSTNT(NORD1,TLC);  /* sub. call to set up constants */
    {
	if (trace_loc < trace_buff_end) {	/* Test for overflow */
		*trace_loc++ = (unsigned) PTT_ProcExit;	/* type */
		*trace_loc = choices_clock->time();		/* time */
		trace_loc++;
		*trace_loc++ = thread_pid;	/* pid */


		*trace_loc++ = (unsigned) 12;	/* data_id */


	} else
		trace_overflow_error();
}  

    fprintf(six,"\nTEMPERATURE                = %8.2f K\n",TEMP);
    fprintf(six,"DENSITY                    = %8.5f G/C.C.\n",RHO);
    fprintf(six,"NUMBER OF MOLECULES        = %8d\n",NMOL);
    fprintf(six,"NUMBER OF PROCESSORS       = %8d\n",NumProcs);
    fprintf(six,"TIME STEP                  = %8.2e SEC\n",TSTEP);
    fprintf(six,"ORDER USED TO SOLVE F=MA   = %8d \n",NORDER);
    fprintf(six,"NO. OF TIME STEPS          = %8d \n",NSTEP);
    fprintf(six,"FREQUENCY OF DATA SAVING   = %8d \n",NSAVE);
    fprintf(six,"FREQUENCY TO WRITE RST FILE= %8d \n",NRST);

    { /* Do memory initializations */
	int pid;
	unsigned mol_size = sizeof(molecule_type) * NMOL;
	unsigned gmem_size = sizeof(struct GlobalMemory);
	/*
	 * macro call to initialize shared memory etc.
	 * Added an argument for Umax to initialize gang schduling
	 */
      /* allocate space for main (VAR) data structure as well as
           synchronization variables */
	VAR = (molecule_type *) shnew(mol_size);;
	gl = (struct GlobalMemory *) shnew(gmem_size);;

             /* macro calls to initialize synch varibles  */

	{
	char *barrier_name = "gl->start";

	{
	int mon_dum1;


	int mon_dum2;

	for (mon_dum1 = 0; mon_dum1 < 1; mon_dum1++)
		for (mon_dum2 = 0; mon_dum2 < 1; mon_dum2++) {
			gl->start[mon_dum1].count[mon_dum2] = 0;
			gl->start[mon_dum1].queue[mon_dum2] = 0;
			{
#ifdef SPARC
	unsigned status;
	do {
		register unsigned regvar;
		asm volatile ("ldstub %1,%0" : "=r" (regvar) : "m" ((gl->start[mon_dum1].queue[mon_dum2])) ); 
		status = regvar;
		if ( status ) thisProcess()->relinquishProcessor();
	} while( status );
/*
#define LOAD_REG_FROM_MEM(reg, var) \
({	register unsigned fake_register_variable asm(#reg); \
	asm volatile ("ld %1,%0" : "=r" (fake_register_variable) : "m" (var) ); })
*/
#endif
#ifdef MULTIMAX
	spinlock_addr = (&((gl->start[mon_dum1].queue[mon_dum2])));
	asm("L2222:");
	asm("cmpqb	$0, 0(_spinlock_addr)");
	asm("bne 	L2222");
	asm("sbitib	$0, 0(_spinlock_addr)");
	asm("bfs 	L2222"); 
	
#endif
} ;
		}
 

	for (mon_dum1 = 0; mon_dum1 < 1; mon_dum1++)
		gl->start[mon_dum1].lock = 0;
} 

	{
	unsigned type = (unsigned) PTT_BarInit;
	unsigned time;
	int slen = strlen(barrier_name) + 1;


	unsigned data_id = (unsigned) &gl->start;


	time = choices_clock->time();
	if (!fwrite((char *) &type, sizeof(unsigned), 1, trace_file) ||
	    !fwrite((char *) &time, sizeof(unsigned), 1, trace_file) ||
	    !fwrite((char *) &thread_pid, sizeof(unsigned), 1,
		    trace_file) ||
	    !fwrite((char *) &data_id, sizeof(unsigned), 1, trace_file) ||
	    !fwrite(barrier_name, sizeof(char), slen, trace_file))
		trace_io_error("fwrite");
}  
} 
	{
	char *barrier_name = "gl->InterfBar";

	{
	int mon_dum1;


	int mon_dum2;

	for (mon_dum1 = 0; mon_dum1 < 1; mon_dum1++)
		for (mon_dum2 = 0; mon_dum2 < 1; mon_dum2++) {
			gl->InterfBar[mon_dum1].count[mon_dum2] = 0;
			gl->InterfBar[mon_dum1].queue[mon_dum2] = 0;
			{
#ifdef SPARC
	unsigned status;
	do {
		register unsigned regvar;
		asm volatile ("ldstub %1,%0" : "=r" (regvar) : "m" ((gl->InterfBar[mon_dum1].queue[mon_dum2])) ); 
		status = regvar;
		if ( status ) thisProcess()->relinquishProcessor();
	} while( status );
/*
#define LOAD_REG_FROM_MEM(reg, var) \
({	register unsigned fake_register_variable asm(#reg); \
	asm volatile ("ld %1,%0" : "=r" (fake_register_variable) : "m" (var) ); })
*/
#endif
#ifdef MULTIMAX
	spinlock_addr = (&((gl->InterfBar[mon_dum1].queue[mon_dum2])));
	asm("L2223:");
	asm("cmpqb	$0, 0(_spinlock_addr)");
	asm("bne 	L2223");
	asm("sbitib	$0, 0(_spinlock_addr)");
	asm("bfs 	L2223"); 
	
#endif
} ;
		}
 

	for (mon_dum1 = 0; mon_dum1 < 1; mon_dum1++)
		gl->InterfBar[mon_dum1].lock = 0;
} 

	{
	unsigned type = (unsigned) PTT_BarInit;
	unsigned time;
	int slen = strlen(barrier_name) + 1;


	unsigned data_id = (unsigned) &gl->InterfBar;


	time = choices_clock->time();
	if (!fwrite((char *) &type, sizeof(unsigned), 1, trace_file) ||
	    !fwrite((char *) &time, sizeof(unsigned), 1, trace_file) ||
	    !fwrite((char *) &thread_pid, sizeof(unsigned), 1,
		    trace_file) ||
	    !fwrite((char *) &data_id, sizeof(unsigned), 1, trace_file) ||
	    !fwrite(barrier_name, sizeof(char), slen, trace_file))
		trace_io_error("fwrite");
}  
} 
	{
	char *barrier_name = "gl->PotengBar";

	{
	int mon_dum1;


	int mon_dum2;

	for (mon_dum1 = 0; mon_dum1 < 1; mon_dum1++)
		for (mon_dum2 = 0; mon_dum2 < 1; mon_dum2++) {
			gl->PotengBar[mon_dum1].count[mon_dum2] = 0;
			gl->PotengBar[mon_dum1].queue[mon_dum2] = 0;
			{
#ifdef SPARC
	unsigned status;
	do {
		register unsigned regvar;
		asm volatile ("ldstub %1,%0" : "=r" (regvar) : "m" ((gl->PotengBar[mon_dum1].queue[mon_dum2])) ); 
		status = regvar;
		if ( status ) thisProcess()->relinquishProcessor();
	} while( status );
/*
#define LOAD_REG_FROM_MEM(reg, var) \
({	register unsigned fake_register_variable asm(#reg); \
	asm volatile ("ld %1,%0" : "=r" (fake_register_variable) : "m" (var) ); })
*/
#endif
#ifdef MULTIMAX
	spinlock_addr = (&((gl->PotengBar[mon_dum1].queue[mon_dum2])));
	asm("L2224:");
	asm("cmpqb	$0, 0(_spinlock_addr)");
	asm("bne 	L2224");
	asm("sbitib	$0, 0(_spinlock_addr)");
	asm("bfs 	L2224"); 
	
#endif
} ;
		}
 

	for (mon_dum1 = 0; mon_dum1 < 1; mon_dum1++)
		gl->PotengBar[mon_dum1].lock = 0;
} 

	{
	unsigned type = (unsigned) PTT_BarInit;
	unsigned time;
	int slen = strlen(barrier_name) + 1;


	unsigned data_id = (unsigned) &gl->PotengBar;


	time = choices_clock->time();
	if (!fwrite((char *) &type, sizeof(unsigned), 1, trace_file) ||
	    !fwrite((char *) &time, sizeof(unsigned), 1, trace_file) ||
	    !fwrite((char *) &thread_pid, sizeof(unsigned), 1,
		    trace_file) ||
	    !fwrite((char *) &data_id, sizeof(unsigned), 1, trace_file) ||
	    !fwrite(barrier_name, sizeof(char), slen, trace_file))
		trace_io_error("fwrite");
}  
} 
        {
	char *lock_name = "gl->IntrafVirLock";

	{
	int mon_dum1;



	for (mon_dum1 = 0; mon_dum1 < 1; mon_dum1++)
		gl->IntrafVirLock[mon_dum1].lock = 0;
} 

	{
	unsigned type = (unsigned) PTT_LockInit;
	unsigned time;
	int slen = strlen(lock_name) + 1;


	unsigned data_id = (unsigned) &gl->IntrafVirLock;


	time = choices_clock->time();
	if (!fwrite((char *) &type, sizeof(unsigned), 1, trace_file) ||
	    !fwrite((char *) &time, sizeof(unsigned), 1, trace_file) ||
	    !fwrite((char *) &thread_pid, sizeof(unsigned), 1,
		    trace_file) ||
	    !fwrite((char *) &data_id, sizeof(unsigned), 1, trace_file) ||
	    !fwrite(lock_name, sizeof(char), slen, trace_file))
		trace_io_error("fwrite");
}  
} 
        {
	char *lock_name = "gl->InterfVirLock";

	{
	int mon_dum1;



	for (mon_dum1 = 0; mon_dum1 < 1; mon_dum1++)
		gl->InterfVirLock[mon_dum1].lock = 0;
} 

	{
	unsigned type = (unsigned) PTT_LockInit;
	unsigned time;
	int slen = strlen(lock_name) + 1;


	unsigned data_id = (unsigned) &gl->InterfVirLock;


	time = choices_clock->time();
	if (!fwrite((char *) &type, sizeof(unsigned), 1, trace_file) ||
	    !fwrite((char *) &time, sizeof(unsigned), 1, trace_file) ||
	    !fwrite((char *) &thread_pid, sizeof(unsigned), 1,
		    trace_file) ||
	    !fwrite((char *) &data_id, sizeof(unsigned), 1, trace_file) ||
	    !fwrite(lock_name, sizeof(char), slen, trace_file))
		trace_io_error("fwrite");
}  
} 
        {
	char *lock_name = "gl->FXLock";

	{
	int mon_dum1;



	for (mon_dum1 = 0; mon_dum1 < 1; mon_dum1++)
		gl->FXLock[mon_dum1].lock = 0;
} 

	{
	unsigned type = (unsigned) PTT_LockInit;
	unsigned time;
	int slen = strlen(lock_name) + 1;


	unsigned data_id = (unsigned) &gl->FXLock;


	time = choices_clock->time();
	if (!fwrite((char *) &type, sizeof(unsigned), 1, trace_file) ||
	    !fwrite((char *) &time, sizeof(unsigned), 1, trace_file) ||
	    !fwrite((char *) &thread_pid, sizeof(unsigned), 1,
		    trace_file) ||
	    !fwrite((char *) &data_id, sizeof(unsigned), 1, trace_file) ||
	    !fwrite(lock_name, sizeof(char), slen, trace_file))
		trace_io_error("fwrite");
}  
} 
        {
	char *lock_name = "gl->FYLock";

	{
	int mon_dum1;



	for (mon_dum1 = 0; mon_dum1 < 1; mon_dum1++)
		gl->FYLock[mon_dum1].lock = 0;
} 

	{
	unsigned type = (unsigned) PTT_LockInit;
	unsigned time;
	int slen = strlen(lock_name) + 1;


	unsigned data_id = (unsigned) &gl->FYLock;


	time = choices_clock->time();
	if (!fwrite((char *) &type, sizeof(unsigned), 1, trace_file) ||
	    !fwrite((char *) &time, sizeof(unsigned), 1, trace_file) ||
	    !fwrite((char *) &thread_pid, sizeof(unsigned), 1,
		    trace_file) ||
	    !fwrite((char *) &data_id, sizeof(unsigned), 1, trace_file) ||
	    !fwrite(lock_name, sizeof(char), slen, trace_file))
		trace_io_error("fwrite");
}  
} 
        {
	char *lock_name = "gl->FZLock";

	{
	int mon_dum1;



	for (mon_dum1 = 0; mon_dum1 < 1; mon_dum1++)
		gl->FZLock[mon_dum1].lock = 0;
} 

	{
	unsigned type = (unsigned) PTT_LockInit;
	unsigned time;
	int slen = strlen(lock_name) + 1;


	unsigned data_id = (unsigned) &gl->FZLock;


	time = choices_clock->time();
	if (!fwrite((char *) &type, sizeof(unsigned), 1, trace_file) ||
	    !fwrite((char *) &time, sizeof(unsigned), 1, trace_file) ||
	    !fwrite((char *) &thread_pid, sizeof(unsigned), 1,
		    trace_file) ||
	    !fwrite((char *) &data_id, sizeof(unsigned), 1, trace_file) ||
	    !fwrite(lock_name, sizeof(char), slen, trace_file))
		trace_io_error("fwrite");
}  
} 
	{
	int i;
	char lock_name[256];

	{
	int mon_dum1;



	for (mon_dum1 = 0; mon_dum1 < NMOL; mon_dum1++)
		gl->MolLock[mon_dum1].lock = 0;
} 

	for (i = 0; i < NMOL; i++) {
		sprintf(lock_name, "%s[%d]", "gl->MolLock", i);
		{
	unsigned type = (unsigned) PTT_ALockInit;
	unsigned time;
	int slen = strlen(lock_name) + 1;


	unsigned data_id = (unsigned) &gl->MolLock[i];


	time = choices_clock->time();
	if (!fwrite((char *) &type, sizeof(unsigned), 1, trace_file) ||
	    !fwrite((char *) &time, sizeof(unsigned), 1, trace_file) ||
	    !fwrite((char *) &thread_pid, sizeof(unsigned), 1,
		    trace_file) ||
	    !fwrite((char *) &data_id, sizeof(unsigned), 1, trace_file) ||
	    !fwrite(lock_name, sizeof(char), slen, trace_file))
		trace_io_error("fwrite");
}  
	}
} 
	{
	char *lock_name = "gl->KinetiSumLock";

	{
	int mon_dum1;



	for (mon_dum1 = 0; mon_dum1 < 1; mon_dum1++)
		gl->KinetiSumLock[mon_dum1].lock = 0;
} 

	{
	unsigned type = (unsigned) PTT_LockInit;
	unsigned time;
	int slen = strlen(lock_name) + 1;


	unsigned data_id = (unsigned) &gl->KinetiSumLock;


	time = choices_clock->time();
	if (!fwrite((char *) &type, sizeof(unsigned), 1, trace_file) ||
	    !fwrite((char *) &time, sizeof(unsigned), 1, trace_file) ||
	    !fwrite((char *) &thread_pid, sizeof(unsigned), 1,
		    trace_file) ||
	    !fwrite((char *) &data_id, sizeof(unsigned), 1, trace_file) ||
	    !fwrite(lock_name, sizeof(char), slen, trace_file))
		trace_io_error("fwrite");
}  
} 
	{
	char *lock_name = "gl->PotengSumLock";

	{
	int mon_dum1;



	for (mon_dum1 = 0; mon_dum1 < 1; mon_dum1++)
		gl->PotengSumLock[mon_dum1].lock = 0;
} 

	{
	unsigned type = (unsigned) PTT_LockInit;
	unsigned time;
	int slen = strlen(lock_name) + 1;


	unsigned data_id = (unsigned) &gl->PotengSumLock;


	time = choices_clock->time();
	if (!fwrite((char *) &type, sizeof(unsigned), 1, trace_file) ||
	    !fwrite((char *) &time, sizeof(unsigned), 1, trace_file) ||
	    !fwrite((char *) &thread_pid, sizeof(unsigned), 1,
		    trace_file) ||
	    !fwrite((char *) &data_id, sizeof(unsigned), 1, trace_file) ||
	    !fwrite(lock_name, sizeof(char), slen, trace_file))
		trace_io_error("fwrite");
}  
} 

            /* set up control for static scheduling */

	MolsPerProc = NMOL/NumProcs;
	StartMol[0] = 0;
	for (pid = 1; pid < NumProcs; pid += 1) {
          StartMol[pid] = StartMol[pid-1] + MolsPerProc;
        }
	StartMol[NumProcs] = NMOL;
      }

    {
	if (trace_loc < trace_buff_end) {	/* Test for overflow */
		*trace_loc++ = (unsigned) PTT_ProcEnter;	/* type */
		*trace_loc = choices_clock->time();		/* time */
		trace_loc++;
		*trace_loc++ = thread_pid;	/* pid */


		*trace_loc++ = (unsigned) 13;	/* data_id */


	} else
		trace_overflow_error();
}  
    SYSCNS();    /* sub. call to initialize system constants  */
    {
	if (trace_loc < trace_buff_end) {	/* Test for overflow */
		*trace_loc++ = (unsigned) PTT_ProcExit;	/* type */
		*trace_loc = choices_clock->time();		/* time */
		trace_loc++;
		*trace_loc++ = thread_pid;	/* pid */


		*trace_loc++ = (unsigned) 13;	/* data_id */


	} else
		trace_overflow_error();
}  

    fprintf(six,"SPHERICAL CUTOFF RADIUS    = %8.4f ANGSTROM\n",CUTOFF);
    fflush(six);

    IRST=0;

            /* if there is no input displacement file, and we are to
               initialize to a regular lattice */
    if (NFMC == 0) {
	fclose(nfmc);
	nfmc = NULL;
    }

            /* initialization routine; also reads displacements and
             sets up random velocities*/
    {
	if (trace_loc < trace_buff_end) {	/* Test for overflow */
		*trace_loc++ = (unsigned) PTT_ProcEnter;	/* type */
		*trace_loc = choices_clock->time();		/* time */
		trace_loc++;
		*trace_loc++ = thread_pid;	/* pid */


		*trace_loc++ = (unsigned) 14;	/* data_id */


	} else
		trace_overflow_error();
}  
    INITIA(nfmc);
    {
	if (trace_loc < trace_buff_end) {	/* Test for overflow */
		*trace_loc++ = (unsigned) PTT_ProcExit;	/* type */
		*trace_loc = choices_clock->time();		/* time */
		trace_loc++;
		*trace_loc++ = thread_pid;	/* pid */


		*trace_loc++ = (unsigned) 14;	/* data_id */


	} else
		trace_overflow_error();
}  

    /*.......ESTIMATE ACCELERATION FROM F/M */
    {       
            /* note that these initial calls to the force-computing 
               routines  (INTRAF and INTERF) use only 1 process since 
               others haven't been created yet */
    int tmp_procs = NumProcs;
    int tmp_smol = StartMol[1];
    ProcID = 0;
    StartMol[0] = 0;
    StartMol[1] = NMOL;
    NumProcs = 1;

    {
	if (trace_loc < trace_buff_end) {	/* Test for overflow */
		*trace_loc++ = (unsigned) PTT_ProcEnter;	/* type */
		*trace_loc = choices_clock->time();		/* time */
		trace_loc++;
		*trace_loc++ = thread_pid;	/* pid */


		*trace_loc++ = (unsigned) 22;	/* data_id */


	} else
		trace_overflow_error();
}  
    INTRAF(&VIR);
    {
	if (trace_loc < trace_buff_end) {	/* Test for overflow */
		*trace_loc++ = (unsigned) PTT_ProcExit;	/* type */
		*trace_loc = choices_clock->time();		/* time */
		trace_loc++;
		*trace_loc++ = thread_pid;	/* pid */


		*trace_loc++ = (unsigned) 22;	/* data_id */


	} else
		trace_overflow_error();
}  

    {
	if (trace_loc < trace_buff_end) {	/* Test for overflow */
		*trace_loc++ = (unsigned) PTT_ProcEnter;	/* type */
		*trace_loc = choices_clock->time();		/* time */
		trace_loc++;
		*trace_loc++ = thread_pid;	/* pid */


		*trace_loc++ = (unsigned) 23;	/* data_id */


	} else
		trace_overflow_error();
}  
    INTERF(ACC,&VIR);
    {
	if (trace_loc < trace_buff_end) {	/* Test for overflow */
		*trace_loc++ = (unsigned) PTT_ProcExit;	/* type */
		*trace_loc = choices_clock->time();		/* time */
		trace_loc++;
		*trace_loc++ = thread_pid;	/* pid */


		*trace_loc++ = (unsigned) 23;	/* data_id */


	} else
		trace_overflow_error();
}  

    StartMol[1] = tmp_smol;
    NumProcs = tmp_procs;
    }  /* Acclerations estimated */

    NFMC= -1;

    /*.....START MOLECULAR DYNAMIC LOOP */
    if (NFMC < 0) {
  	ELPST=0.00;
        TKIN=0.00;
        TVIR=0.00;
        TTMV=0.00;
    };

       /* spawn helper processes, each getting its unique process id */
    for (ProcID = 1; ProcID < NumProcs; ProcID += 1) {
	{
	Process *proc;	/* The new process forked off. */




	{
	if (trace_loc < trace_buff_end) {	/* Test for overflow */
		*trace_loc++ = (unsigned) PTT_Create;	/* type */
		*trace_loc = choices_clock->time();		/* time */
		trace_loc++;
		*trace_loc++ = thread_pid;	/* pid */


				/* Not a meaningful value; this assignment
				   keeps execution time more even. */
		*trace_loc++ = (unsigned) &thread_pid;
 

	} else
		trace_overflow_error();
} 
	 {
	if (fflush(trace_file) == EOF)
		trace_io_error("fflush");
} 
	num_children++;
 

	fflush(stdout);

			/* cloneThisProcess() is a lot like fork(2). */
	if (!(proc = (Process *) cloneThisProcess())) {
			/* Running as child process here. */
		{

	{
	trace_loc = trace_buff;
	thread_pid = (unsigned) 0;
	thread_num = num_children;
				/* "Touch" all elements of trace_buff[]. */
	for (int i = 0; i < TRACE_BUFF_SIZE * 4; i++)
		trace_buff[i] = i;

	sprintf(trace_fname, "parmacs.%d.trace", thread_num);
	if ((trace_file = fopen(trace_fname, "w")) == NULL)
		trace_io_error("fopen");
	{
	unsigned type = (unsigned) PTT_Version;
	unsigned time;
	int slen = strlen(ParmacsTrace_version) + 1;


	unsigned data_id;	/* random garbage */
 

	time = choices_clock->time();
	if (!fwrite((char *) &type, sizeof(unsigned), 1, trace_file) ||
	    !fwrite((char *) &time, sizeof(unsigned), 1, trace_file) ||
	    !fwrite((char *) &thread_pid, sizeof(unsigned), 1,
		    trace_file) ||
	    !fwrite((char *) &data_id, sizeof(unsigned), 1, trace_file) ||
	    !fwrite(ParmacsTrace_version, sizeof(char), slen, trace_file))
		trace_io_error("fwrite");
} 
} 


	start_time = choices_clock->time();;
	start_time = choices_clock->time();;
 

	{
	if (trace_loc < trace_buff_end) {	/* Test for overflow */
		*trace_loc++ = (unsigned) PTT_ThreadInitEnv;	/* type */
		*trace_loc = choices_clock->time();		/* time */
		trace_loc++;
		*trace_loc++ = thread_pid;	/* pid */


				/* Not a meaningful value; this assignment
				   keeps execution time more even. */
		*trace_loc++ = (unsigned) &thread_pid;
 

	} else
		trace_overflow_error();
} 
 
} 
		WorkStart();
		{ 

	{
	if (trace_loc < trace_buff_end) {	/* Test for overflow */
		*trace_loc++ = (unsigned) PTT_ThreadEnd;	/* type */
		*trace_loc = choices_clock->time();		/* time */
		trace_loc++;
		*trace_loc++ = thread_pid;	/* pid */


				/* Not a meaningful value; this assignment
				   keeps execution time more even. */
		*trace_loc++ = (unsigned) &thread_pid;
 

	} else
		trace_overflow_error();
} 


	end_time = choices_clock->time();;
	end_time = choices_clock->time();;
	printf("Thread %d: start %u, end %u, duration %u.\n", thread_num,
	       start_time, end_time, end_time - start_time);
	fflush(stdout);
 

	{
	if (!fwrite((char *) trace_buff, sizeof(unsigned),
		    trace_loc - trace_buff, trace_file))
		trace_io_error("final fwrite");
	if (fclose(trace_file) == EOF)
		trace_io_error("fclose");
	final_trace_loc = trace_loc;
	trace_loc = trace_buff_end;	/* Prohibit subsequent logging */


	printf("Total of %u logs for thread %u.\n",
	       (final_trace_loc - trace_buff) / 4, thread_num);
	fflush(stdout);
 
} 
 

thisProcess()->wakeUpWaiter(); 
} 
		exit(0);
	} else
			/* Running as parent process here. */
		child_procs[num_child_procs++] = proc;




	{
	if (trace_loc < trace_buff_end) {	/* Test for overflow */
		*trace_loc++ = (unsigned) PTT_CreateDone;	/* type */
		*trace_loc = choices_clock->time();		/* time */
		trace_loc++;
		*trace_loc++ = thread_pid;	/* pid */


				/* Not a meaningful value; this assignment
				   keeps execution time more even. */
		*trace_loc++ = (unsigned) &thread_pid;
 

	} else
		trace_overflow_error();
} 
 

} ;
    }

    ProcID = 0; /* process id of main process */

    if (NSAVE > 0)  /* not true for input decks provided */
      fprintf(six,"COLLECTING X AND V DATA AT EVERY %4d TIME STEPS \n",NSAVE);

            /* call routine to do the timesteps */

    {
	if (trace_loc < trace_buff_end) {	/* Test for overflow */
		*trace_loc++ = (unsigned) PTT_ProcEnter;	/* type */
		*trace_loc = choices_clock->time();		/* time */
		trace_loc++;
		*trace_loc++ = thread_pid;	/* pid */


		*trace_loc++ = (unsigned) 16;	/* data_id */


	} else
		trace_overflow_error();
}  
    XTT = MDMAIN(NFSV,NFRST,NSTEP,NRST,NPRINT,NSAVE,LKT,NORD1); 
    {
	if (trace_loc < trace_buff_end) {	/* Test for overflow */
		*trace_loc++ = (unsigned) PTT_ProcExit;	/* type */
		*trace_loc = choices_clock->time();		/* time */
		trace_loc++;
		*trace_loc++ = thread_pid;	/* pid */


		*trace_loc++ = (unsigned) 16;	/* data_id */


	} else
		trace_overflow_error();
}  

            /* macro to make main process wait for all others to finish */
    {
	{
	if (trace_loc < trace_buff_end) {	/* Test for overflow */
		*trace_loc++ = (unsigned) PTT_WaitForEnd;	/* type */
		*trace_loc = choices_clock->time();		/* time */
		trace_loc++;
		*trace_loc++ = thread_pid;	/* pid */


				/* Not a meaningful value; this assignment
				   keeps execution time more even. */
		*trace_loc++ = (unsigned) &thread_pid;
 

	} else
		trace_overflow_error();
}  

				/* Wait for all children. */
	for (int i = 0; i < num_child_procs; i++)
		thisProcess()->waitForProcess(child_procs[i]);
	num_child_procs = 0;

	{
	if (trace_loc < trace_buff_end) {	/* Test for overflow */
		*trace_loc++ = (unsigned) PTT_WaitForEndDone;	/* type */
		*trace_loc = choices_clock->time();		/* time */
		trace_loc++;
		*trace_loc++ = thread_pid;	/* pid */


				/* Not a meaningful value; this assignment
				   keeps execution time more even. */
		*trace_loc++ = (unsigned) &thread_pid;
 

	} else
		trace_overflow_error();
}  
} 

            /* signal completion to verification output file LWV */
    one = fopen("LWV","w");
    fprintf(one, "\nExited Happily with XTT %g\n", XTT);
    fclose(one);
    fclose(six);

    {
	{
	if (trace_loc < trace_buff_end) {	/* Test for overflow */
		*trace_loc++ = (unsigned) PTT_MainEnd;	/* type */
		*trace_loc = choices_clock->time();		/* time */
		trace_loc++;
		*trace_loc++ = thread_pid;	/* pid */


				/* Not a meaningful value; this assignment
				   keeps execution time more even. */
		*trace_loc++ = (unsigned) &thread_pid;
 

	} else
		trace_overflow_error();
}  


	end_time = choices_clock->time();;
	end_time = choices_clock->time();;
	printf("Thread %d: start %u, end %u, duration %u.\n", thread_num,
	       start_time, end_time, end_time - start_time);
	fflush(stdout);
 


	{


				/* Buffer dump start and end. */
		unsigned bd_start, bd_end;

		bd_start = choices_clock->time();;
		bd_start = choices_clock->time();;
 

		{
	if (!fwrite((char *) trace_buff, sizeof(unsigned),
		    trace_loc - trace_buff, trace_file))
		trace_io_error("final fwrite");
	if (fclose(trace_file) == EOF)
		trace_io_error("fclose");
	final_trace_loc = trace_loc;
	trace_loc = trace_buff_end;	/* Prohibit subsequent logging */


	printf("Total of %u logs for thread %u.\n",
	       (final_trace_loc - trace_buff) / 4, thread_num);
	fflush(stdout);
 
} 


		bd_end = choices_clock->time();;
		bd_end = choices_clock->time();;
		printf(
"Thread %d buffer dump: start %u, end %u, duration %u.\n", thread_num,
		       bd_start, bd_end, bd_end - bd_start);
		fflush(stdout);
 

	}



	thisProcess()->wakeUpWaiter();
 
 

	exit(0);
} 
} /* main.c */

/*
Routine that each created process starts at; it simply calls the timestep
routine.
*/

static void WorkStart(void)
{
    (void) MDMAIN(NFSV,NFRST,NSTEP,NRST,NPRINT,NSAVE,LKT,NORD1);
}
