
#ifdef __GNUC__
#pragma implementation
#endif


#include "Class.h"
#include "ClassStar.h"
#include "Socket.h"
#include "SocketKernel.h"
#include "SocketStar.h"

Socket::Socket( int domain, int type, int protocol )
	: _fd( -1 )
{
	int errno;
	_fd = socket( domain, type, protocol, errno );
}

Socket::Socket( int fd )
	: _fd( fd )
{
}

Socket::~Socket()
{
	if ( _fd >= -1 )
		::close( _fd );
	_fd = -1;
}

SocketRef 
Socket::accept( sockaddr * addr, int * len, int & errno )
{
	SocketRef ret;
	int fd = ::accept( _fd, addr, len, errno );
	if ( fd < 0 )
		return 0;
	ret = new Socket( fd );
	return ret;
}

int
Socket::open( int domain, int type, int protocol, int & errno )
{
	if ( _fd >= 0 ) {
		int ret = ::close( _fd, errno );
		if ( ret != 0 ) 
			return ret;
	}
	_fd = ::socket( domain, type, protocol, errno );
	return ( _fd >= 0 ? _fd : -1 );
}

int
Socket::bind( sockaddr * addr, int len, int & errno )
{
	return ::bind( _fd, addr, len, errno );
}

int
Socket::connect( sockaddr * addr, int len, int & errno )
{
	return ::connect( _fd, addr, len, errno );
}

int 
Socket::listen( int backlog, int & errno )
{
	return ::listen( _fd, backlog, errno );
}

int
Socket::recv( char * buf, int len, int flags, sockaddr * addr, int * addrlen,
	      int & errno )
{
	return ::recvfrom( _fd, buf, len, flags, addr, addrlen, errno );
}

int
Socket::recv( char * buf, int len, int flags, int & errno )
{
	return ::recvfrom( _fd, buf, len, flags, 0, 0, errno );
}

int
Socket::recv( msghdr * msg, int flags, int & errno )
{
	return ::recvmsg( _fd, msg, flags, errno );
}

int 
Socket::send( char * buf, int len, int flags, sockaddr * addr, int addrlen,
	      int & errno )
{
	return ::sendto( _fd, buf, len, flags, addr, addrlen, errno );
}

int 
Socket::send( char * buf, int len, int flags, int & errno )
{
	return ::sendto( _fd, buf, len, flags, 0, 0, errno );
}

int
Socket::send( msghdr * msg, int flags, int & errno )
{
	return ::sendmsg( _fd, msg, flags, errno );
}

int 
Socket::shutdown( int how, int & errno )
{
	return ::shutdown( _fd, how, errno );
}

int
Socket::setsockopt( int level, int name, char * val, int valsize, int & errno )
{
	return ::setsockopt( _fd, level, name, val, valsize, errno );
}

int
Socket::getsockopt( int level, int name, char * val, int * valsize, int & errno )
{
	return ::getsockopt( _fd, level, name, val, valsize, errno );
}

int
Socket::getsockname( sockaddr * addr, int * len, int & errno )
{
	return ::getsockname( _fd, addr, len, errno );
}

int
Socket::getpeername( sockaddr * addr, int * len, int & errno )
{
	return ::getpeername( _fd, addr, len, errno );
}

#include "ClassInstaller.h"
DEFINECLASS("Socket",Socket,ProxiableObject,0,0)

