#ifndef SocketInterface_h
#define SocketInterface_h

#ifdef __GNUC__
#pragma interface
#endif

#include "ProxiableObject.h"
#include "SocketStar.h"

struct sockaddr;
struct msghdr;

extern ClassStar SocketClass;

class Socket : public ProxiableObject {
protected:
	int _fd;
	Socket( int fd );
public:
	Class * classOf();
	~Socket();
	proxiable Socket( int domain, int type, int protocol );
	proxiable virtual SocketRef accept( sockaddr * addr, int * len, 
					    int & errno );
	proxiable virtual int open( int domain, int type, int protocol, 
				    int & errno );
	proxiable virtual int bind( sockaddr * addr, int len, int & errno );
	proxiable virtual int connect( sockaddr * addr, int len, int & errno );
	proxiable virtual int listen( int backlog, int & errno );
	proxiable virtual int recv( char * buf, int len, int flags,
			    sockaddr * addr, int * addrlen, int & errno  );
	proxiable virtual int recv( char * buf, int len, int flags, 
				    int & errno  );
	proxiable virtual int recv( msghdr * msg, int flags, int & errno );
	proxiable virtual int send( char * buf, int len, int flags,
			    	    sockaddr * addr, int addrlen, int & errno );
	proxiable virtual int send( char * buf, int len, int flags, 
				    int & errno );
	proxiable virtual int send( msghdr * msg, int flags, int & errno );
	proxiable virtual int shutdown( int how, int & errno );
	proxiable virtual int setsockopt( int level, int name, char * val, 
				  int valsize, int & errno );
	proxiable virtual int getsockopt( int level, int name, char * val, 
				  int * valsize, int & errno );
	proxiable virtual int getsockname( sockaddr * addr, int * len, 
					   int & errno );
	proxiable virtual int getpeername( sockaddr * addr, int * len, 
					   int & errno );
};

#endif SocketInterface_h
