#ifdef CHOICES

#include "Convert.h"
#include "OutputStream.h"
#include "SocketDef.h"
#include "SocketKernel.h"
#include "FreeRunningTimer.h"
#include "FreeRunningTimerStar.h"

extern "C" {
int bzero(void *, int);
unsigned systemtime();
}

inline 
unsigned systemtime() 
{
	return SystemTimer->time();
}

#endif /* CHOICES */
#ifdef UNIX

#include <stream.h>
#include <netdb.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <netinet/in.h>

#define Console() cout
const char * eor = "";

extern "C" {
int errno;

int socket(int, int, int);
int bind(int, struct sockaddr *, int);
int connect(int, struct sockaddr *, int);
int listen(int, int);
int accept(int, struct sockaddr * , int *);
int recvfrom(int, caddr_t, int, int, struct sockaddr *, int *);
int recv(int, caddr_t, int, int);
int recvmsg(int, struct msghdr *, int);
int sendto(int, caddr_t, int, int, struct sockaddr *, int);
int send(int, caddr_t, int, int);
int sendmsg(int, struct msghdr *, int);
int shutdown(int, int);
int setsockopt(int, int, int, caddr_t, int);
int getsockopt(int, int, int, caddr_t, int *);
int getsockname(int, struct sockaddr *, int *);
int getpeername(int, struct sockaddr *, int *);
int close(int);

int bzero(void *, int);
int gettimeofday(struct timeval *, struct timezone *);
int sprintf();
int atoi(char *);
int inet_addr(char *);
int gethostname(char *, int);
int exit(int);
int printf();
unsigned systemtime();
}

inline 
unsigned systemtime()
{
	struct timeval t;
	struct timezone tz;
	int result = gettimeofday(&t, &tz);
	long long val = (long long) t.tv_sec * 1000000 +
			(long long) t.tv_usec;
	return (unsigned) val;
}

#endif /* UNIX */
