#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989 The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: David W. Dykstra (dykstra@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * ClassConstructor.cc - The purpose of this class is to ensure that
 *     the constructors called via Class::constructor() are called in
 *     the correct ring of protection.
 *
 *	$Header: /projects/choices/old/cvsroot/choices/Common/ClassConstructor.cc,v 1.1 2004/06/03 01:58:31 jcarlyle Exp $
 */
#include "ClassConstructor.h"


#ifdef __GNUC__
#pragma implementation
#endif


ClassConstructor::ClassConstructor( POFPO ctor )
{
	_ctor = ctor;
}

ProxiableObject *
ClassConstructor::construct( ProxiableObject * arg )
{
	if ( _ctor != 0 )
		return( (* _ctor )( arg ) );
	else
		return( 0 );
}

#include "ClassInstaller.h"
DEFINECLASS("ClassConstructor",ClassConstructor,ProxiableObject,0,0);
