#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: David W. Dykstra (dykstra@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * ConstructorInstaller.cc
 */



#ifdef __GNUC__
// #pragma implementation "ConstructorDescriptor.h"
#endif

#include "Assert.h"
#include "ConstructorInstaller.h"
#include "ConstructorDescriptor.h"
#include "ConstructorDescriptorStar.h"

#ifdef __GNUC__
#pragma implementation
#endif

static ConstructorInstaller *head = 0;
static ConstructorInstaller *tail = 0;

ConstructorInstaller::ConstructorInstaller(
	char * nam, PConstructor ctr, char * cls, int num )
{
	name = nam;
	ctor = ctr;
	clss = cls;
	number = num;

	next = 0;
	if (head == 0)
	{
		head = this;
		tail = this;
	}
	else
	{
		tail->next = this;
		tail = this;
	}
}

void
ConstructorInstaller::install()
{
	ConstructorInstaller *p;

	for (p = head; p != 0; p = p->next) {
		ConstructorDescriptorStar d = new ConstructorDescriptor(
				    p->name, p->clss, p->number, p->ctor );
		Assert( d != 0 );
	}
}
