#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 *
 * Copyright (c) 2006
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author(s): Jeffrey C. Carlyle (jcarlyle@uiuc.edu)
 *            Francis David (fdavid@uiuc.edu)
 *            Ellick Chan (emchan@uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 */
/*
 * Exception.cc: exception class stubs.
 */

#include "Assert.h"
#include "Raid.h"
#include "Exception.h"
#include "ClassStar.h"
#include "String.h"


#ifdef __GNUC__
#pragma implementation
#endif

Exception::Exception()
{
  _msg = NULL;
}

/**
 * Create an exception with the given message.
 *
 * @param msg Message to describe the exception.
 */
Exception::Exception(const char *msg)
{
  _msg = new char[strlen(msg)+1];
  strcpy(_msg, msg);
}

/**
 * Destroy the exception including the message.
 */
Exception::~Exception()
{
  if(_msg)
    delete[] _msg;
}

/**
 * Get the message describing this exception.
 *
 * @return A message describing the error that occured.
 */
const char *Exception::getMessage(void) const
{
  return _msg;
}

#include "ClassInstaller.h"
DEFINECLASS("Exception",Exception,Object,0,0);
