#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801-2910
 *
 * Copyright (c) 1991 The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 *
 * Author: Amit Parghi (parghi@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

//
//	HexDump.cc
//
//	Class similar to asHex to provide a hex dump of any given
//	string of bytes.
//
// $Id: HexDump.cc 610 2006-06-12 23:21:35Z jcarlyle $
//
// $Log: HexDump.cc,v $
// Revision 1.1  2004/06/03 01:58:31  jcarlyle
// Initial revision
//
//

//DD SYSIN *

#include "HexDump.h"
#include "OutputStream.h"


#ifdef __GNUC__
#pragma implementation
#endif

static char hexDigits[] = "0123456789abcdef";

    OutputStream &
operator << (OutputStream &stream, HexString &string)
{
    unsigned char *p = string._pointer;

    stream << hexDigits[*p >> 4] << hexDigits[*p & 0xF];
    p++;

    for ( unsigned i = 1 ; i < string._length ; i++ ) {
	stream << string._separator
	       << hexDigits[*p >> 4] << hexDigits[*p & 0xf];
	p++;
    }

    return stream;
}

    OutputStream &		// similar, but in 'od' format with 'address'
operator << (OutputStream &stream, HexDump &dump)
{
    unsigned char *p = dump._pointer;
    static const unsigned int lineLength = 16;

    for ( unsigned i = 0 ; i < dump._length ; i += lineLength ) {

	    // Find min(max #bytes per line, # of bytes left in dump).
	unsigned int lengthRemaining = ((dump._length - i) < lineLength) ?
					(dump._length - i) : lineLength;

	    // Print 'address' in packet of this row, as a hex word.
	stream  << '\t' << hexDigits[ i >> 12]
			<< hexDigits[(i >>  8) & 0xf]
			<< hexDigits[(i >>  4) & 0xf]
			<< hexDigits[ i        & 0xf]
		<< '\t';
	HexString s(p, lengthRemaining);
	stream << s << '\n';
	
	p += lineLength;
    }

    stream << eor;
    return stream;
}
