#ifdef __GNUC__
#pragma implementation
#endif

#include "Message.h"
#include "ContainerRepresentative.h"
#include "MessageContainer.h"
#include "Byte.h"
#include "OutputStream.h"


#ifdef __GNUC__
#pragma implementation
#endif

Message::Message( char* initData, int initSize,int delData)
{
   maxDataSize = dataSize = initSize;
   dataPtr = initData;
   destinationMessagePort = 0;
   receiverMessagePort = 0;
   deleteData = delData;
   ctype = 0;
}

Message::Message(int delData)
{
   dataSize = 0;
   dataPtr = 0;
   destinationMessagePort = 0;
   receiverMessagePort = 0;
   deleteData = delData;
}

Message::~Message()
{
	if (dataPtr && deleteData)
		delete dataPtr;
}

void Message::print()
{
	Console() << "Message::print "
		<< " \n this is  " << this
		<< "\n dataSize " << dataSize
		<< "\n data " << (char *)dataPtr
		<< "\n ctype " << ctype
		<< "\n destinationMessagePort" << destinationMessagePort
		<< "\n receiverMessagePort"  << receiverMessagePort
		<< "\n deleteData" << deleteData << eor;
}

int 
Message::getcType()
{
	return ctype;
}

unsigned int 
Message::getTime()
{
	 return _time  ;
}

void 
Message::setTime (unsigned int t)
{
	_time = t;
}

void 
Message::setcType (int t)
{
	ctype = t;
}

void Message::setReceivePort (MessageContainer *rport)
{
receiverMessagePort = rport;
}

void Message::setDestination (ContainerRepresentative *sport)
{

destinationMessagePort = sport;
}



/*
 * Allocate internal storage to hold
 * message data 
 */

void 
Message::setMaxSize (void* data, unsigned int size)
{
 if(dataPtr) delete dataPtr;
 maxDataSize = dataSize = size;
 if(data) dataPtr = (char*)data;
}

void Message::setSize (unsigned int size)
{
if(dataPtr) delete dataPtr;
dataSize = size;
dataPtr = new char[dataSize];
}


void 
Message::setUserData (void *inData,int size)
{
	dataPtr = (char*)inData;
	dataSize = size;

}

void Message::setData (void *inData)
/* Must be called after setSize */
{

  /* Make sure setSize has been called */
  Assert (dataSize > 0) ("Message::setData - data <= 0!");
    
  ByteCopy(inData,dataPtr,dataSize);
}

ContainerRepresentative *Message::destination()
{

  return (destinationMessagePort);
}

MessageContainer *Message::receiverPort()
{

  return (receiverMessagePort);
}

long Message::maxSize()
{

  return(maxDataSize);
}
long Message::size()
{

  return(dataSize);
}

void *Message::data()
{

  return((void *)dataPtr);
}

void Message::send() 
{
 ContainerRepresentative *saveDestinationMessagePort = destinationMessagePort; 
  destinationMessagePort->send(this);
 destinationMessagePort = saveDestinationMessagePort;
}

/* 
 * Preserve the proxies
 */

void Message::receive()
{
 MessageContainer *saveReceiverMessagePort = receiverMessagePort; 
 receiverMessagePort->get(this);
 receiverMessagePort = saveReceiverMessagePort;
}

RPCMessage::RPCMessage( char* initData, int initSize,int delData) : Message(initData, initSize, delData)
{
replyMessagePort = 0;
replyToMessagePort = 0;
ctype = 1;
}

RPCMessage :: RPCMessage () : Message (0)
{
replyMessagePort = 0;
replyToMessagePort = 0;
ctype = 1;
}

void RPCMessage :: rpc ()
{
 	ContainerRepresentative *saveDestinationMessagePort = destinationMessagePort; 
 	MessageContainer *saveReply = replyMessagePort; 
	Assert(destinationMessagePort != 0)("Destination MessagePort not set");
 	destinationMessagePort->rpcSend(this,replyMessagePort);
 	destinationMessagePort = saveDestinationMessagePort;
 	replyMessagePort = saveReply;

}

MessageContainer*
 RPCMessage :: getReplyPort ()
{
return replyMessagePort;
}

void 
RPCMessage :: setReplyPort (MessageContainer *mp)
{
	Assert( mp != 0);
	replyMessagePort = mp;
}

ContainerRepresentative *
RPCMessage :: getReplyToPort ()
{
        return replyToMessagePort;
}
void
RPCMessage :: setReplyToPort (ContainerRepresentative *mp)
{
	Assert( mp != 0);
        replyToMessagePort = mp;
}



void RPCMessage :: print ()
{
Message::print();
Console() << "\n" << "ReplyPort" << replyMessagePort << eor;
}
void RPCMessage :: reply ()
{
	ctype = 2; // setting response to 2
	destinationMessagePort = replyToMessagePort;
	Assert(replyToMessagePort != 0);
	replyToMessagePort->send(this);
//delete replyMessagePort; // make a 
//kernel call to delete
// gross hack
}

void RPCMessage::rpcReceive()
{
	replyToMessagePort = receiverMessagePort->rpcGet(this);
	Assert(replyToMessagePort != 0);
}

MessageContainer* RPCMessage::getServer ( )
{
return server;
}
void RPCMessage::setServer ( MessageContainer *mp)
{
	server = mp;
}
/*
#include "ClassInstaller.h"
DEFINECLASS("Message",Message,0,0, 0);
DEFINECLASS("RPCMessage",RPCMessage,Message,0,0);
*/
