#ifdef __GNUC__
#pragma implementation
#endif

#include "Message.h"
#include "MessageList.h"
#include "MultiRPCMessage.h"
#include "MessageContainer.h"
#include "ContainerRepresentative.h"
#include "MultiRecMessContainer.h"
#include "ContainerGroup.h"
#include "OutputStream.h"
#include "MLink.h"
#include "IteratingList.h"

#ifdef __GNUC__
#pragma implementation
#endif

// #define MRPC_DEBUG 1


MultiRPCMessage::MultiRPCMessage()
{
ml = new MessageList;
ctype = 6;
}

MultiRPCMessage::~MultiRPCMessage() {}

int 
MultiRPCMessage::isEmpty()
{
return ml->isEmpty();
}
int 
MultiRPCMessage::number()
{
return ml->number();
}
void 
MultiRPCMessage :: add (Message *msg )
{
ml->add(msg);
}

Message*
MultiRPCMessage:: remove( )
{
return ml->remove();
}

Message*
MultiRPCMessage:: remove( Message* msg)
{
return ml->remove(msg);
}

void
MultiRPCMessage:: reset()
{
        ml->reset();
}

Message*
MultiRPCMessage:: nextMessage()
{
return ml->nextMessage();
}

void
MultiRPCMessage:: rpc ()
{ 

/* 
 * can only use this if send and receive buffers
 * are of the same length 
 */
	send();
	receive();
}

void
MultiRPCMessage:: send ()
{
ContainerRepresentative *saveDestinationMessagePort = destinationMessagePort;
 MessageContainer *saveReply = replyMessagePort;

// this does not wait... so maybe it should be renamed
// this should be ContianerGroup rpcSend

 destinationMessagePort->rpcSend(this,replyMessagePort);
 destinationMessagePort = saveDestinationMessagePort;
 replyMessagePort = saveReply;
}

int
MultiRPCMessage ::getNumMesg()
{
	return numMesg ;
}
void
MultiRPCMessage ::setNumMesg(int N)
{
	numMesg = N;
}

void
MultiRPCMessage ::setMesgSize(int N)
{
	mesgSize = N;
}

// getting replies and recieves confused here?

void 
MultiRPCMessage :: receive ()
{
#ifdef MRPC_DEBUG
	Console() << "MultiRPCMessage:: receive " <<
		numMesg << "\n" << eor;
#endif
 	for( int i=0;i< numMesg ; i++) {
// what type should you actually provide
		char *b = new char[mesgSize];
 		RPCMessage *message = new RPCMessage(b,mesgSize,0);

#ifdef MRPC_DEBUG
	Console()<< " about to rpcGet " << eor;
#endif
		((MultiRecMessContainer *)replyMessagePort)->get(message);
		add(message);
	}
}

/*
#include "ClassInstaller.h"
DEFINECLASS("Message",Message,0,0, 0);
DEFINECLASS("RPCMessage",RPCMessage,Message,0,0);
*/
