#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991, 1992
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Swee Boon Lim (sblim@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * PipeOutputStream.cc
 */

#include "Pipe.h"
#include "PipeOutputStream.h"
#include "Raid.h"


#ifdef __GNUC__
#pragma implementation
#endif

PipeOutputStream::PipeOutputStream( Pipe * pipe )
{
	_pipe = pipe;
	_pipe->reference();
}

PipeOutputStream::~PipeOutputStream()
{
	_pipe->unreference();
}

int PipeOutputStream::write( const char * buf, int size )
{
	return _pipe->write( (char *) buf, size, 1 );
}

#include "ClassInstaller.h"
DEFINECLASS("PipeOutputStream",PipeOutputStream,OutputStream,0,0);

