#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Peter W. Madany (madany@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * ProxiableObjectStar.cc
 */

#include "ProxiableObjectStar.h"
#include "ProxiableObject.h"

#ifdef __GNUC__
#pragma implementation
#endif

ProxiableObjectStar::ProxiableObjectStar( ProxiableObject *const  po )
{
	_pointer = po;
	if( _pointer != 0 ) _pointer->reference();
}

ProxiableObjectStar::ProxiableObjectStar( const ProxiableObjectStar & pos )
{
	_pointer = pos._pointer;
	if( _pointer != 0 ) _pointer->reference();
}

ProxiableObjectStar & 
ProxiableObjectStar::operator=( ProxiableObject *const  po )
{
    if( _pointer != po ) {
	if( _pointer != 0 ) _pointer->unreference();
	_pointer = po;
	if( _pointer != 0 ) _pointer->reference();
    }
    return( *this );
}

ProxiableObjectStar & 
ProxiableObjectStar::operator=( const ProxiableObjectRef & po )
{
	if( _pointer != 0 ) _pointer->unreference();
	_pointer = po._pointer;
	return( *this );
}

ProxiableObjectStar & 
ProxiableObjectStar::operator=( const ProxiableObjectStar & po )
{
    if( _pointer != po._pointer ) {
	if( _pointer != 0 ) _pointer->unreference();
	_pointer = po._pointer;
	if( _pointer != 0 ) _pointer->reference();
    }
    return( *this );
}

ProxiableObjectStar::~ProxiableObjectStar()
{
	if( _pointer != 0 ) _pointer->unreference();
	_pointer = 0;
}


ProxiableObjectRef::ProxiableObjectRef( ProxiableObject *const  po )
{
	_pointer = po;
	if( _pointer != 0 ) _pointer->reference();
}

ProxiableObjectRef::ProxiableObjectRef( const ProxiableObjectStar & pos )
{
	_pointer = pos._pointer;
	if( _pointer != 0 ) _pointer->reference();
}

ProxiableObjectRef & 
ProxiableObjectRef::operator=( ProxiableObject *const po )
{
    if( _pointer != po ) {
	if( _pointer != 0 ) _pointer->unreference();
	_pointer = po;
	if( _pointer != 0 ) _pointer->reference();
    }
    return( *this );
}

ProxiableObjectRef & 
ProxiableObjectRef::operator=( const ProxiableObjectRef & po )
{
	if( _pointer != 0 ) _pointer->unreference();
	_pointer = po._pointer;
	return( *this );
}

ProxiableObjectRef & 
ProxiableObjectRef::operator=( const ProxiableObjectStar & po )
{
    if( _pointer != po._pointer ) {
	if( _pointer != 0 ) _pointer->unreference();
	_pointer = po._pointer;
	if( _pointer != 0 ) _pointer->reference();
    }
    return( *this );
}
