#ifdef __GNUC__
#pragma implementation
#endif

/* #define PROXYDEBUG */
/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: David W. Dykstra (dykstra@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * ProxyTable.cc
 */

#ifdef __GNUC__
//#pragma implementation "ProxyTableCopy.h"
#endif

#include "Assert.h"
#include "ProxyTable.h"
#include "ProxyTableCopy.h"
#include "ProxyTableCopyStar.h"


#ifdef __GNUC__
#pragma implementation
#endif

static ProxyTableInstaller *head = 0;
static ProxyTableInstaller *tail = 0;

ProxyTableInstaller::ProxyTableInstaller( ProxyTable *tab )
{
    table = tab;
    next = 0;
    if (head == 0)
    {
	head = this;
	tail = this;
    }
    else
    {
	tail->next = this;
	tail = this;
    }
}

void
ProxyTableInstaller::install()
{
    ProxyTableInstaller *t;
    ProxyTableCopyStar copy;

    for (t = head; t != 0; t = t->next) {
	copy = new ProxyTableCopy( t->table );

	Assert( copy != 0 );
    }
}
