#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1990, 1991 The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Peter W. Madany (madany@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
#include "Star.h"

Star & const
Star::operator=( T *const po )
{
    if( _pointer != (ProxiableObject *)po ) {
	if( _pointer != 0 ) _pointer->unreference();
	_pointer = (ProxiableObject *)po;
	if( _pointer != 0 ) _pointer->reference();
    }
    return( *this );
}

Star & const
Star::operator=( ProxiableObject *const  po )
{
    if( _pointer != po ) {
	if( _pointer != 0 ) _pointer->unreference();
	_pointer = po;
	if( _pointer != 0 ) _pointer->reference();
    }
    return( *this );
}

Star & const
Star::operator=( const ProxiableObjectRef & po )
{
	if( _pointer != 0 ) _pointer->unreference();
	_pointer = po._pointer;
	return( *this );
}

Star & const
Star::operator=( const ProxiableObjectStar & po )
{
    if( _pointer != po._pointer ) {
	if( _pointer != 0 ) _pointer->unreference();
	_pointer = po._pointer;
	if( _pointer != 0 ) _pointer->reference();
    }
    return( *this );
}

Ref & const
Ref::operator=( <T> * po )
{
    if( _pointer != (ProxiableObject *)po ) {
	if( _pointer != 0 ) _pointer->unreference();
	_pointer = (ProxiableObject *)po;
	if( _pointer != 0 ) _pointer->reference();
    }
    return( *this );
}

Ref & const
Ref::operator=( ProxiableObject *const po )
{
    if( _pointer != po ) {
	if( _pointer != 0 ) _pointer->unreference();
	_pointer = po;
	if( _pointer != 0 ) _pointer->reference();
    }
    return( *this );
}

Ref & const
Ref::operator=( const ProxiableObjectRef & po )
{
	if( _pointer != 0 ) _pointer->unreference();
	_pointer = po._pointer;
	return( *this );
}

Ref & const
Ref::operator=( const ProxiableObjectStar & po )
{
    if( _pointer != po._pointer ) {
	if( _pointer != 0 ) _pointer->unreference();
	_pointer = po._pointer;
	if( _pointer != 0 ) _pointer->reference();
    }
    return( *this );
}

