#
# This file is part of the Choices Operating System
# Developed by: The TAPESTRY Parallel Computing Laboratory
#		 University of Illinois at Urbana-Champaign
#		 Department of Computer Science
#		 1304 W. Springfield Ave.
#		 Urbana, IL	61801
#
# Copyright (c) 1987, 1988, 1989 The University of Illinois Board of Trustees.
#	All Rights Reserved.
# CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
#
# Author: David W. Dykstra (dykstra@cs.uiuc.edu)
# Contributing Author: Nayeem Islam (nislam@cs.uiuc.edu)
# Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
#
# Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
#   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
#
#
# Common makefile to make all applications for Choices systems
# This should not be invoked directly, but included in other makefiles.
#
#	$Header: /projects/choices/old/cvsroot/choices/Configure/Applications/ApplicationsCommon.mk,v 1.1 2004/06/03 01:58:32 jcarlyle Exp $
#


DEPFILES2 = $(PROXYDEPFILES)
ALLINCLUDES = $(INCLUDES)

ifndef UNIX
INTERFACE = SystemInterface

ifdef CHOICESNODE
COMMONHVPATH = \
#	$(CHOICESNODE)/Includes/Libraries/$(INTERFACE)/Portable \
	$(CHOICESNODE)/Includes/Libraries/$(INTERFACE)/$(PROCESSOR) \
	$(CHOICESNODE)/Includes/System/$(MACHINE) 
else
COMMONHVPATH = \
#	../../../../Includes/Libraries/$(INTERFACE)/Portable \
	../../../../Includes/Libraries/$(INTERFACE)/$(PROCESSOR) \
	../../../../Includes/System/$(MACHINE)
endif # CHOICESNODE
else
COMMONHVPATH =  ../../../../Includes/System/$(MACHINE)

endif

ifdef CHOICESNODE
include $(CHOICESNODE)/Configure/ChoicesCommon.mk
TOP = $(CHOICESNODE)
else
include ../../../ChoicesCommon.mk
TOP = ../../../..
endif # CHOICESNODE

OBJECTS = $(addsuffix .o, $(basename $(SOURCES)))

DEPFILES = $(EXTRADEPFILES) $(SOURCES)

#
# Everything that cant somehow be remade.
#
EVERYTHING = Makefile $(SOURCES) $(INCLUDES)

#



ifdef CHOICESNODE
SYSTEM = $(CHOICESNODE)/Configure/System/$(MACHINE)
CONFLIBRARIES = $(CHOICESNODE)/Configure/Libraries
else
SYSTEM = ../../../System/$(MACHINE)
CONFLIBRARIES = ../../../Libraries
endif # CHOICESNODE
INTLIB = $(CONFLIBRARIES)/$(INTERFACE)/$(MACHINE)
GENLIB = $(CONFLIBRARIES)/GeneralPurpose/$(ARCH)

ifndef UNIX
#
# The LoaderOptions.mk file should set $(EXTRALDFLAGS),  $(EXTRASTARTS)
# $(EXTRALIBS)
# This is needed because some linkers need to specify command line options
#   and some need to specify the options in a file. Others also need
#   special libraries
# The application's makefile should set $(APPLIBS) to the list of extra
# libraries it requires.
#
#include $(INTLIB)/LoaderOptions.mk
endif

STARTS = $(EXTRASTARTS)
#$(INTLIB)/crt0.o
STDLIBS = $(INTLIB)/libC.a $(GENLIB)/libG.a $(GCCLIB)
LIBS =  $(APPLIBS) $(STDLIBS) $(EXTRALIBS)

LIBGCCDIR=`$(CC) -print-file-name=libgcc.a | head -c -9`
LIBCDIR=`$(CC) -print-file-name=libc.a | head -c -7`
LD =   $(CROSS)ld
LDFLAGS=-static -Ttext E0000000 -L$(TOP)/Configure/System/GenericARM/ -L$(TOP)/Configure/Libraries/SystemInterface/GenericARM/ -L$(LIBGCCDIR) -L$(LIBCDIR) --start-group -lC -lStar -lstdc++ -lc -lgcc --end-group

%: %.o
ifndef NODEPENDENCIES
	@echo "$@: $@.o $(STARTS) $(EXTRAOBJECTS) $(LIBS)" >>D/$*.dep
ifdef COLLECT
	@echo "Collecting $*.o"; \
	$(RM) _$@_ctdt.[cso]; \
	$(COLLECT) -o _$@_ctdt.s $*.o $(LIBS); \
	touch _$@_ctdt.s; \
	$(AS) -o _$@_ctdt.o _$@_ctdt.s
	@echo "Linking $@"; \
	$(RM) $@; \
	$(LD) -o $@ $(LDFLAGS) $(STARTS) $*.o _$@_ctdt.o $(EXTRAOBJECTS) $(LIBS)
	@$(RM) _$@_ctdt.[cso]
else
	@echo "Linking $@"; \
	$(LD) -o $@ $*.o $(EXTRALDFLAGS) $(STARTS) $(EXTRAOBJECTS) $(LIBS) $(LDFLAGS) 
endif

else

%: %.o
	@echo "Linking $^"; \
	$(C++) -o $@ $^ $(LIBS)

endif
