#
# This file is part of the Choices Operating System
# Developed by: The TAPESTRY Parallel Computing Laboratory
#		 University of Illinois at Urbana-Champaign
#		 Department of Computer Science
#		 1304 W. Springfield Ave.
#		 Urbana, IL	61801
#
# Copyright (c) 1987, 1988, 1989 The University of Illinois Board of Trustees.
#	All Rights Reserved.
# CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
#
# Author: David W. Dykstra (dykstra@cs.uiuc.edu)
# Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
#
# Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
#   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
#
#
# makefile for example applications under Choices
# This should not be invoked directly, but included in other makefiles.
#
#	$Header: /projects/choices/old/cvsroot/choices/Configure/Applications/Examples/ExamplesCommon.mk,v 1.1 2004/06/03 01:58:32 jcarlyle Exp $

SRCDIR = $(TOP)/Applications/Examples
INCLUDES =
BASESOURCES = Echo.cc Read.cc Write.cc PrintLoop.cc \
	bcopy.cc hello.cc lloops.cc timings.cc \
	timeslice.cc MemoryHog.cc ArActivate.cc Recurse.cc \

# Francis TODO TOFIX
NOTWORKING = twoproc.cc bench.cc

DVMSOURCES :=  VMITest.cc MmapRead.cc MmapWrite.cc \
	DVMTest.cc recursion.cc TalkTest.cc

DISTSOURCES =  Server.cc Client.cc Ser.cc Cli.cc

SOURCES := $(BASESOURCES)
ifdef DVM
SOURCES := $(SOURCES) $(DVMSOURCES)
endif
ifdef Distributed
SOURCES := $(SOURCES) $(DISTSOURCES) 
endif

ALLSOURCES := $(DVMSOURCES) $(DISTSOURCES) $(BASESOURCES)

include ../../../../Configure/System/$(MACHINE)/Config.mk

EXTRADEFINES = -DASSERT
EXTRAHVPATH = $(SRCDIR) ../../../../Includes/Libraries/$(INTERFACE)/$(PROCESSOR) \
				../../../../Includes/System/$(MACHINE) \
				../../../../Configure/System/$(MACHINE)
EXTRAVPATH = $(SRCDIR)

EXES = $(subst .cc,,$(SOURCES))
ALLEXES = $(subst .cc,,$(ALLSOURCES))

all: $(EXES)

$(EXES): %: %.o


clobber: localClobber

localClobber:
	$(RM) $(ALLEXES)

include ../../ApplicationsCommon.mk
