#
# This file is part of the Choices Operating System
# Developed by: The TAPESTRY Parallel Computing Laboratory
#		 University of Illinois at Urbana-Champaign
#		 Department of Computer Science
#		 1304 W. Springfield Ave.
#		 Urbana, IL	61801
#
# Copyright (c) 1987, 1988, 1989 The University of Illinois Board of Trustees.
#	All Rights Reserved.
# CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
#
# Author: David W. Dykstra (dykstra@cs.uiuc.edu)
# Author: Peter W. Madany (madany@cs.uiuc.edu)
# Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
#
# Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
#   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
#
#
# makefile for FiSh under Choices
# This should not be invoked directly, but included in other makefiles.
#
#	$Header: /projects/choices/old/cvsroot/choices/Configure/Applications/FiSh/FiShCommon.mk,v 1.1 2004/06/03 01:58:32 jcarlyle Exp $

all: FiSh 

FISH = $(TOP)/Applications/FiSh

EXTRADEFINES = -DASSERT
EXTRAHVPATH = $(FISH) ../../../../Includes/Libraries/$(INTERFACE)/$(PROCESSOR) \
                ../../../../Includes/System/$(MACHINE) \
                ../../../../Configure/System/$(MACHINE)
EXTRAVPATH = $(FISH)

INCLUDES=	Object.h ProxiableObject.h Class.h NameServer.h \
	FileSystem.h StoredObject.h \
	MemoryRange.h MemoryObject.h PersistentMemoryObject.h FileObject.h \
	MemoryObjectDictionary.h FileSystemInterface.h \
	FileStream.h ReadFileStream.h WriteFileStream.h SymbolicLink.h \
	DiagnosticConsole.h Domain.h Kernel.h PhysicalMemoryChain.h Process.h \
	REFERENCE_COUNT.h stdio.h Tools.h \
	ObjectProxy.h ObjectProxyManager.h OutputStream.h AOut.h COFF.h Ar.h \
	Reference.h RefThing.h PersistentObject.h Thing.h

SOURCES=	Choices.cc Tools.cc Shell.cc

include ../../ApplicationsCommon.mk


FiSh: $(STARTS) $(OBJECTS) $(LIBS)
ifdef COLLECT
	@echo "Collecting $(OBJECTS)"; \
	$(RM) _FiSh_ctdt.[sco];
	$(COLLECT) -o _FiSh_ctdt.s $(OBJECTS) $(LIBS); \
	$(AS) -o _FiSh_ctdt.o _FiSh_ctdt.s
endif
	@echo "Linking FiSh"; \
	$(RM) FiSh; 
ifdef COLLECT
	$(LD) $(STARTS) -o FiSh $(LDFLAGS) $(STARTS) $(OBJECTS) _FiSh_ctdt.o $(LIBS)
else
	 $(LD) -o FiSh $(LDFLAGS) $(STARTS) $(OBJECTS) $(LIBS)
endif


clobber: clobberFiSh
clobberFiSh:
	$(RM) FiSh
