#
# This file is part of the Choices Operating System
# Developed by: The TAPESTRY Parallel Computing Laboratory
#		 University of Illinois at Urbana-Champaign
#		 Department of Computer Science
#		 1304 W. Springfield Ave.
#		 Urbana, IL	61801
#
# Copyright (c) 1987, 1988, 1989 The University of Illinois Board of Trustees.
#	All Rights Reserved.
# CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
#
# Author: Aamod Sane (sane@cs.uiuc.edu)
# Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
#
# Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
#   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
#
#
# makefile for GP under UNIX
# This should not be invoked directly, but included in other makefiles.
#

ifndef $(PROG)
PROG=GP
endif

EXTRACOPTS := $(EXTRACOPTS) -g


all: $(PROG)

UGP = $(TOP)/Applications/UNIXGP
UGPI = $(TOP)/Applications/UNIXGP/Interface
LIBS = $(TOP)/Configure/Libraries/UNIXGP/$(MACHINE)/libG.a

EXTRADEFINES = -DASSERT -DRAID -DUNIX_GP
EXTRAVPATH = $(UGP) $(UGPI) $(TOP)/MachineDependent/Multimax
EXTRAHVPATH = $(UGP) $(UGPI) $(TOP)/Includes/MachineDependent/Multimax \
	$(TOP)/Includes \
	$(TOP)/Includes/Common \
	$(TOP)/Includes/FileSystems \
	$(TOP)/Includes/Memory

EXTRAVPATH = $(UGP) $(UGPI) $(TOP)/MachineDependent/Multimax \
	$(TOP)/Kernel \
	$(TOP)/Memory \
	$(TOP)/Common

# Unixification include files

INCLUDEU = Stdio.h

# Kernel include files (Includes/)

INCLUDEK=	Object.h Class.h ClassInstaller.h NameServer.h \
	ProxiableObject.h ObjectProxy.h ObjectProxyManager.h Process.h \
	InputStream.h OutputStream.h ClassStar.h OutputStreamStar.h \
	NameServerStar.h ProxiableObjectStar.h

# Portable include files (Includes/Libraries/GeneralPurpose/)

INCLUDEP = Link.h LinkIterator.h List.h LightList.h HashTable.h \
	MultiHashTable.h

COMMONINCLUDES = $(INCLUDEU) $(INCLUDEK) $(INCLUDEP)

INCLUDES= $(COMMONINCLUDES)



# Special unixification files

SOURCEU = Utils.cc

# Kernel source files ()

SOURCEK=	Object.cc Class.cc ClassInstaller.cc NameServer.cc \
	ProxiableObject.cc InputStream.cc ClassStar.cc OutputStreamStar.cc \
	NameServerStar.cc ProxiableObjectStar.cc \


COMMONSOURCES = $(SOURCEU)

include ../../ApplicationsCommon.mk

SOURCES = $(COMMONSOURCES)

OBJECTS = $(addsuffix .o, $(basename $(SOURCES)))

DEPFILES = $(EXTRADEPFILES) $(SOURCES) ClassInstantiation.cc

%.o: %.cc
	@echo "Compiling $<"; \
	$(RM) D/$*.dep $*.o; \
	> D/$*.dep; \
	DEPENDENCIES_OUTPUT="D/$*.dep $*.o";\
	export DEPENDENCIES_OUTPUT; \
	$(C++) -I- $(C++FLAGS) -c $< 

%.s: %.cc
	@echo "Compiling $<"; \
	$(C++) -I- $(C++FLAGS) -S $< 

# C++ is used (instead of LD) so that it automatically links in the appropriate 
# libraries for the new and other crt routines etc.

$(PROG): $(PROG).o $(OBJECTS) $(LIBS)
	@echo Linking $(PROG); \
	$(RM) $(PROG); \
	$(C++) -o $(PROG) $(PROG).o $(OBJECTS) $(LIBS)

clobber: clobberGP
clobberGP:
	$(RM) GP


clobber: clobberLocal
clobberLocal: clean
	$(RM) D/*

clean: localClean

localClean:
	$(RM) $(SRCTEST)


