#
# This file is part of the Choices Operating System
# Developed by: The TAPESTRY Parallel Computing Laboratory
#		 University of Illinois at Urbana-Champaign
#		 Department of Computer Science
#		 1304 W. Springfield Ave.
#		 Urbana, IL	61801
#
# Copyright (c) 1987, 1988, 1989 The University of Illinois Board of Trustees.
#	All Rights Reserved.
# CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
#
# Author: Swee Boon Lim (sblim@cs.uiuc.edu)
# Author: Lee Lup Yuen (lup@cs.uiuc.edu)
# Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
#
# Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
#   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
#
#
# makefile for Choices applications
# Revision 1.0
#
# This is really a template that should be tailored for each Choices
# application.  The "CHANGE:" tag indicates which variables are customizable.
# Use gnumake to run this file.

all: water

WATER = $(TOP)/Applications/Water

EXTRADEFINES = -DASSERT -DCHOICES 
EXTRAHVPATH = $(TOP)/Includes/Libraries/UnixApplication \
	$(TOP)/Includes/Libraries/Math $(WATER)
EXTRAVPATH = $(WATER)

APPLIBS = $(CONFLIBRARIES)/UnixApplication/$(MACHINE)/libUA.a \
	$(CONFLIBRARIES)/Math/$(MACHINE)/libM.a

SOURCES = bndry.cc cnstnt.cc cshift.cc initia.cc interf.cc intraf.cc \
	kineti.cc poteng.cc predcor.cc redsync.cc syscns.cc water.cc \

include ../../ApplicationsCommon.mk

water : $(STARTS) $(OBJECTS) $(LIBS)
ifdef COLLECT
	@echo "Collecting $(OBJECTS)"
	$(RM) $@_ctdt.[sco]
	$(COLLECT) -o $@_ctdt.s $(OBJECTS) $(LIBS)
	$(AS) -o $@_ctdt.o $@_ctdt.s
	@echo "Linking $@"
	$(RM) $@
	$(LD) $(LDFLAGS) -o $@ $(STARTS) $(OBJECTS) $@_ctdt.o $(LIBS)
	$(RM) $@_ctdt.[cso]
else
	@echo "Linking $@"
	$(RM) $@
	$(LD) $(LDFLAGS) -o $@ $(STARTS) $(OBJECTS) $(LIBS)
endif

clobber: clobberApp

clobberApp:
	$(RM) water $(OBJECTS)


