#
# This file is part of the Choices Operating System
# Developed by: The TAPESTRY Parallel Computing Laboratory
#		 University of Illinois at Urbana-Champaign
#		 Department of Computer Science
#		 1304 W. Springfield Ave.
#		 Urbana, IL	61801
#
# Copyright (c) 1987, 1988, 1989 The University of Illinois Board of Trustees.
#	All Rights Reserved.
# CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
#
# Author: David W. Dykstra (dykstra@cs.uiuc.edu)
# Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
#
# Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
#   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
#
#
# makefile for the GeneralPurpose library
# This should not be invoked directly, but included in other makefiles.
#
#	$Header: /projects/choices/old/cvsroot/choices/Configure/Libraries/GeneralPurpose/GeneralPurposeCommon.mk,v 1.2 2004/08/18 08:02:02 jcarlyle Exp $

all:	libG.a

TOP = ../../../..


EXTRADEFINES = -DGPLIBS -DCHOICES -DASSERT


SRCDIR = $(TOP)/Libraries/GeneralPurpose
INCDIR = $(TOP)/Includes/Libraries/GeneralPurpose

EXTRAVPATH = $(SRCDIR)/$(ARCH) $(SRCDIR)/Portable 
EXTRAHVPATH = $(INCDIR)

#
# List all includes in the $(INCDIR) directory here
#
PUBINCLUDES = GPInclude.h Byte.h Convert.h Ctype.h Random.h Ran.h String.h setjmp.h \
	BitRanges.h \
	BitArray.h \
	LightHashTable.h \
	AssocTable.h \
	MultiHashTable.h \
	MultiLevelTable.h \
	HashTable.h NVList.h LightList.h \
	List.h LinkIterator.h Link.h IteratingList.h \
	StringInputStream.h \
	Log2.h

#
# List all sources in the $(SRCDIR)/Portable directory here
#
PORTSOURCES = Assert.cc Byte.cc Convert.cc Ctype.cc String.cc Random.cc Ran.cc \
	BitRanges.cc \
	BitArray.cc \
	LightHashTable.cc \
	AssocTable.cc \
	MultiHashTable.cc \
	MultiLevelTable.cc \
	HashTable.cc NVList.cc LightList.cc \
	List.cc LinkIterator.cc Link.cc \
	IteratingList.cc StringInputStream.cc 

SOURCES = $(PORTSOURCES) $(EXTRASOURCES)

include ../../LibrariesCommon.mk

#
# Make up the library from all the other objects
#

libG.a: $(OBJECTS)
	$(RM) libG.a
	$(AR) cr libG.a $(OBJECTS)
ifdef RANLIB
	$(RANLIB) libG.a
endif
