#
# This file is part of the Choices Operating System
# Developed by: The TAPESTRY Parallel Computing Laboratory
#		 University of Illinois at Urbana-Champaign
#		 Department of Computer Science
#		 1304 W. Springfield Ave.
#		 Urbana, IL	61801
#
# Copyright (c) 1987, 1988, 1989, 1990, 1991
# The University of Illinois Board of Trustees.
#	All Rights Reserved.
# CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
#
# Author: David W. Dykstra (dykstra@cs.uiuc.edu)
# Contributing Author: Lee Lup Yuen (lup@cs.uiuc.edu)
# Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
#
# Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
#   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
#
#
# makefile for the Math library
# This should not be invoked directly, but included in other makefiles.
#

all:	libM.a


EXTRADEFINES = -DUNK

SRCDIR = $(TOP)/Libraries/Math
INCDIR = $(TOP)/Includes/Libraries/Math \
    $(TOP)/Includes/Libraries/SystemInterface
#CONFSYSTEM = $(TOP)/Configure/System/$(MACHINE)
INCSYSTEM = $(TOP)/Includes/System/$(MACHINE)

#EXTRAVPATH = $(SRCDIR)/$(PROCESSOR) $(SRCDIR)/Portable $(COMDIR) \
#        $(TOP)/FileSystems
#EXTRAHVPATH = $(INCDIR) $(INCSYSTEM) $(TOP)/Includes/FileSystems \
#        $(TOP)/Includes/Libraries/SystemInterface/$(PROCESSOR)



EXTRAVPATH = $(SRCDIR)
EXTRAHVPATH = $(INCDIR) $(INCSYSTEM)

#
# List all includes in the $(INCDIR) directory here
#
PUBINCLUDES = Math.h Nan.h Values.h

#
# List all sources in the $(SRCDIR) directory here
#
SOURCES = pow.cc log.cc log10.cc misc.cc sqrt.cc sin.cc mthutl.cc tan.cc \
    atan.cc asin.cc exp.cc frexp.cc ldexp.cc $(EXTRASOURCES)

DEPFILES = $(SOURCES)

include ../../LibrariesCommon.mk

#
# Make up the library from all the other objects
#

libM.a: $(OBJECTS)
	$(RM) libM.a
	$(AR) cr libM.a $(OBJECTS)
ifdef RANLIB
	$(RANLIB) libM.a
endif

clobber: localClobber

localClobber:
	$(RM) libM.a $(OBJECTS)
