#
# This file is part of the Choices Operating System
# Developed by: The TAPESTRY Parallel Computing Laboratory
#		 University of Illinois at Urbana-Champaign
#		 Department of Computer Science
#		 1304 W. Springfield Ave.
#		 Urbana, IL	61801
#
# Copyright (c) 1987-1992
# The University of Illinois Board of Trustees.
#	All Rights Reserved.
# CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
#
# Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
#
# Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
#   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
#
#
# makefile for the ProxyInterface library
# This should not be invoked directly, but included in other makefiles.
#

#all:	crt0.o libC.a
all:	libC.a
TOP := ../../../..

include ../../../System/$(MACHINE)/Config.mk
include ../../../System/DistributedCommon.mk
include ../../../System/CommonSources.mk

SRCDIR := $(TOP)/Libraries/SystemInterface
#INCDIR := $(TOP)/Includes/Libraries/SystemInterface/Portable
COMDIR := $(TOP)/Common
CONFSYSTEM := $(TOP)/Configure/System/$(MACHINE)
INCSYSTEM := $(TOP)/Includes/System/$(MACHINE)

#EXTRAVPATH := $(SRCDIR)/$(ARCH) $(SRCDIR)/$(PROCESSOR) $(SRCDIR)/Portable $(COMDIR) \
#	$(TOP)/FileSystems
EXTRAVPATH := $(SRCDIR)/$(ARCH) $(SRCDIR)/$(PROCESSOR) $(COMDIR) \
	$(TOP)/FileSystems
#EXTRAHVPATH := $(INCDIR) $(INCSYSTEM) $(TOP)/Includes/FileSystems \
#	$(TOP)/Includes/Libraries/SystemInterface/$(PROCESSOR)
EXTRAHVPATH := $(INCDIR) $(INCSYSTEM) $(TOP)/Includes/Libraries/SystemInterface/$(PROCESSOR)


#
# List includes from the $(INCDIR) directory here
#
PORTINCLUDES := Allocator.h BufferedOutputStream.h \
	Print.h ThisProcess.h _new_allocator.h Lock.h \
	REFERENCE_COUNT.h

INCLUDES := $(PORTINCLUDES) $(COMMONINCLUDES)

#
# List sources from the $(SRCDIR)/Portable directory here
#
#PORTSOURCES := \
#	Allocator.cc \
#	Assert.cc \
#	BufferedOutputStream.cc \
#	CloneProcess.cc \
#	_main.cc \
#	_Start.cc \
#	_delete.cc \
#	_handler.cc \
#	_new.cc \
#	_new_allocator.cc \
#	exit.cc \
#	Lock.cc \
#	ProcessArgs.cc

PORTSOURCES := \
	Lock.cc

ifndef VCHOICES
PORTSOURCES:= $(PORTSOURCES) \
	_ctor.cc \
	_dtor.cc
endif

#
# List full path of sources copied from system here
#

SOURCES := $(PORTSOURCES) $(EXTRASOURCES) $(COMMONSOURCES)

DEPFILES = $(SOURCES)

include ../../LibrariesCommon.mk

#libC.a: $(OBJECTS)
#	$(RM) libC.a
#	$(AR) cr libC.a $(OBJECTS)
#ifdef RANLIB
#	$(RANLIB) libC.a
#endif

objects := Allocator.o              FileObject.o           MemoryObject.o            PersistentObject.o  Thread.o \
ApplicationProcess.o     FileObjectView.o       MemoryObjectContainer.o   Pipe.o              TimeOfDay.o \
BinarySemaphore.o        FileSystemInterface.o  MemoryObjectDictionary.o  print.o             TimeoutTimer.o \
CharacterInputStream.o   FreeRunningTimer.o     MemoryRange.o             Process.o           Timer.o \
Class.o                  InputStream.o          NameServer.o              ProxiableObject.o   TimingInterface.o \
ClassConstructor.o       Interface.o            new.o                     RaidOutputStream.o  VersionInstaller.o \
ConstructorDescriptor.o  OutputStream.o            RecordStream.o      VMInterface.o \
PeriodicTimer.o           Semaphore.o \
Disk.o                   PersistentArray.o         SymbolicLink.o \
Domain.o                 PersistentClass.o         SystemInterface.o \
exception.o              MemoryObjectCache.o    PersistentMemoryObject.o  SystemTime.o entry.o Assert.o ClassInstaller.o

includes := $(wildcard $(TOP)/Includes/Libraries/SystemInterface/$(PROCESSOR)/*.h)

libC.a:	$(objects)
	$(AR) rcs $@ $(objects)

$(objects):	$(includes)
