#
# This file is part of the Choices Operating System
# Developed by: The TAPESTRY Parallel Computing Laboratory
#		 University of Illinois at Urbana-Champaign
#		 Department of Computer Science
#		 1304 W. Springfield Ave.
#		 Urbana, IL	61801
#
# Copyright (c) 1987, 1988, 1989 The University of Illinois Board of Trustees.
#	All Rights Reserved.
# CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
#
# Author: Aamod Sane (sane@cs.uiuc.edu)
# Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
#
# Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
#   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
#
#
# makefile for the GeneralPurpose/Unix library
# This should not be invoked directly, but included in other makefiles.
# This is actually a copy of GeneralPurposeCommon.mk. These libraries
# intended to be tested on Unix, so I have separated the compilation


all:	libG.a


UNIX=Yes
EXTRADEFINES = -DASSERT -DUNIX_GP

SRCDIR = $(TOP)/Libraries/GeneralPurpose
INCDIR = $(TOP)/Includes/Libraries/GeneralPurpose

UGP = $(TOP)/Applications/UNIXGP
UGPI = $(TOP)/Applications/UNIXGP/Interface

EXTRAVPATH = $(SRCDIR)/$(PROCESSOR) $(SRCDIR)/Portable 
EXTRAHVPATH = $(INCDIR) $(UGP) $(UGPI) \
	     $(TOP)/Includes/MachineDependent/Multimax \
	     $(TOP)/Includes \
	     $(TOP)/Includes/Common


#
# List all includes in the $(INCDIR) directory here
#
PUBINCLUDES = GPInclude.h Byte.h Convert.h Ctype.h Random.h String.h \
	BitRanges.h \
	BitArray.h \
	LightHashTable.h \
	AssocTable.h \
	MultiHashTable.h \
	HashTable.h IteratingList.h NVList.h LightList.h \
	List.h LinkIterator.h Link.h

#
# List all sources in the $(SRCDIR)/Portable directory here
#
PORTSOURCES = Assert.cc Byte.cc Convert.cc Ctype.cc String.cc Random.cc \
	BitRanges.cc \
	BitArray.cc \
	LightHashTable.cc \
	AssocTable.cc \
	MultiHashTable.cc \
	HashTable.cc IteratingList.cc NVList.cc LightList.cc \
	List.cc LinkIterator.cc Link.cc


SOURCES = $(PORTSOURCES) $(EXTRASOURCES)

include ../../LibrariesCommon.mk

#
# Make up the library from all the other objects
#

libG.a: $(OBJECTS)
	$(RM) libG.a
	$(AR) cr libG.a $(OBJECTS)
	$(RANLIB) libG.a

