#
# This file is part of the Choices Operating System
# Developed by: The TAPESTRY Parallel Computing Laboratory
#		 University of Illinois at Urbana-Champaign
#		 Department of Computer Science
#		 1304 W. Springfield Ave.
#		 Urbana, IL	61801
#
# Copyright (c) 1987, 1988, 1989 The University of Illinois Board of Trustees.
#	All Rights Reserved.
# CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
#
# Author: David W. Dykstra (dykstra@cs.uiuc.edu)
# Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
#
# Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICASS Grant 
#   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
#
#
# Common makefile for Multimax-based Choices products
# This should not be invoked directly, but included in other makefiles.
#
#	$Header: /projects/choices/old/cvsroot/choices/Configure/MultimaxCommon.mk,v 1.1 2004/06/03 01:58:32 jcarlyle Exp $
#

GCC_VERS =	2.5.6
PROCESSOR =	NS32332
ifdef UNIX
MACHINE =	Multimax.Gnu
else
MACHINE =	Multimax
endif
HOST =		Multimax
REMOTE=		$(TOP)/Configure/Tools/Misc/Multimax/remote

CPP =		$(TOP)/Configure/Tools/gcc-cpp-1.40/umax-4.3/cpp -+ -undef -D__GNUC__
#CPP =		$(TOP)/Configure/Tools/gcc-cpp-1.40/SunOS/cpp -+ -undef -D__GNUC__
CC =		/usr/local/Gnu/$(GCC_VERS)/bin/umax-gcc
C++ =		/usr/local/Gnu/$(GCC_VERS)/bin/umax-g++
NM =		/bin/nm
SIZE =		/bin/size
COLLECT =	/usr/local/Gnu/lib/gcc-collect
CONSTCOLLECT = 	NM=$(NM) $(TOP)/Configure/Tools/Misc/$(HOST)/Constcollect
MAKHEAD = 	CPLUSPLUS=$(C++) $(TOP)/Tools/Misc/makhead
#AS =		/usr/local/Gnu/$(GCC_VERS)/umax/bin/as
AS =		/bin/as
#LD =		$(C++) -v -Wl,-debug
#LD =		$(REMOTE) babym $(C++)
LD =		/usr/local/Gnu/2.5.6/bin/g++
# AR =		$(REMOTE) babym ar
AR =		ar
FLEX =		/usr/local/Gnu/flex
YACC =		/usr/local/Gnu/bison -y
PROXIFY =	CPP="$(CPP)" $(TOP)/Configure/Tools/Proxify++/SunOS/Proxify++ \
		-h`/mnt/tapestry/Tools/Bin/rhost sparc`
ifdef UNIX
GNULIBOPT =	-L/usr/local/Gnu/lib
endif


#
# Various flags for cpp, c++, and cc.
#
DEFINES =	$(OPTIONALDEFINES) $(DEBUG) $(EXTRADEFINES) -Dn16 -Dns32000 -DMULTIMAX
CPPFLAGS =	$(DEFINES) $(patsubst %,-I%,$(HVPATH)) -I- $(patsubst %,-I%,$(SPECIALHVPATH))
ifdef UNIX
COPTS =	-Wall -Wpointer-arith -pipe
else
COPTS =	-Wall -O -g -pipe
endif

ifdef VERBOSE
VERBOSEFLAG = -v
endif
CFLAGS =	$(COMMANDCFLAGS) $(CPPFLAGS) $(COPTS) $(VERBOSEFLAG)
C++FLAGS =	$(COMMANDCFLAGS) $(CPPFLAGS) $(COPTS) $(GNULIBOPT) $(VERBOSEFLAG)
LDFLAGS =	$(EXTRALDFLAGS)

#
# Make a .o from C++ source.
#
%.o: %.cc
ifdef C++BUG
	@echo "Compiling $<"; \
	$(RM) D/$*.dep $*.o; \
	> D/$*.dep; \
	DEPENDENCIES_OUTPUT="D/$*.dep $*.o";\
	export DEPENDENCIES_OUTPUT; \
	$(C++) $(C++FLAGS) $(CPPDEBUGDEFINE) -S -o $*.S $< ; \
	sed '//d' < $*.S > $*.s ; \
	$(AS) $*.s
else
	@echo "Compiling $<"; \
	$(RM) D/$*.dep $*.o; \
	> D/$*.dep; \
	DEPENDENCIES_OUTPUT="D/$*.dep $*.o";\
	export DEPENDENCIES_OUTPUT; \
	$(C++) $(C++FLAGS) $(CPPDEBUGDEFINE) -c $<
endif

#
# Make a .o from C source.
#
%.o: %.c
	@echo "Compiling $<"; \
	$(RM) D/$*.dep $*.o; \
	> D/$*.dep; \
	DEPENDENCIES_OUTPUT="D/$*.dep $*.o";\
	export DEPENDENCIES_OUTPUT; \
	$(CC) $(CFLAGS) $(CPPDEBUGDEFINE) -c $<

#
# Make a .o from assembler source.
#
%.o: %.s
	@echo "Assembling $<"; \
	$(RM) D/$*.dep $*..s $*.o; \
	> D/$*.dep; \
	DEPENDENCIES_OUTPUT="D/$*.dep $*.o"; \
	export DEPENDENCIES_OUTPUT; \
#	$(CPP) $(CPPFLAGS) -DASM $< >$*..s
	@$(AS) -P $(CPPFLAGS) -DASM $*..s -o $*.o
#	@$(RM) $*..s

.PHONY: ALWAYS

# Pre-process a C++ source
#
%.cpp: %.cc ALWAYS
	@echo "Pre-processing $<";  \
	$(C++) -E $(C++FLAGS) -c $< > $*.cpp

#
# assemble a c++ file
#
%.s: %.cc ALWAYS
	@echo "Making $*.s from $<";  \
	$(C++) -S $(C++FLAGS) $< 

#
# assemble a c file
#
%.s: %.c ALWAYS
	@echo "Making $*.s from $<";  \
	$(CC) -S $(CFLAGS) $< 

#
# Make a .cc from lex source.
#
%.lex.cc: %.l
	@echo "Flexing $<"; \
	$(RM) D/$*.dep; \
	(echo "$*.lex.cc: $<";echo "$*.lex.o: $*.lex.cc") >D/$*.dep; \
	$(FLEX) $<
	@$(MV) lex.yy.c $*.lex.cc

#
# Make a .cc from yacc source.
#
%.tab.cc: %.y
	@echo "Yaccing $<"; \
	$(RM) D/$*.dep; \
	(echo "$*.tab.cc: $<";echo "$*.tab.o: $*.tab.cc") >D/$*.dep; \
	$(YACC) -dl $<
	@mv y.tab.h $*.tab.h;
	mv y.tab.c $*.tab.cc

