#
# This file is part of the Choices Operating System
# Developed by: The TAPESTRY Parallel Computing Laboratory
#		 University of Illinois at Urbana-Champaign
#		 Department of Computer Science
#		 1304 W. Springfield Ave.
#		 Urbana, IL	61801
#
# Copyright (c) 1987, 1988, 1989, 1990, 1991 The University of Illinois 
# Board of Trustees.  All Rights Reserved.
#
# CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
#
# Author: David K. Raila (raila@cs.uiuc.edu)
# Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
#
# Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
#   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
#
# Common makefile for PC-based Choices products
# This should not be invoked directly, but included in other makefiles.
#
#
GCC_VERS =	3.2

PROCESSOR =	i586
ARCH =	i586
MACHINE =	PCi586
HOST	= 	PCi586
CPP =           cpp
CC =            gcc
C++ =           g++
#LD =            $(C++) $(DEBUG_LD) -static -Xlinker -assert -Xlinker nosymbolic -Xlinker -assert -Xlinker pure-text
LD =            ld
LDFLAGS = 	$(EXTRALDFLAGS)
NM =		nm
SIZE =		size
AS =		as 
ASDEFINES = -DASM -D_ASM -DGAS $(DEFINES)
ASFLAGS = #-P $(patsubst %,-I%,$(HVPATH)) -I- $(patsubst %,-I%,$(SPECIALHVPATH))
AR =		ar
CONSTCOLLECT =  NM=$(NM) $(TOP)/Configure/Tools/Misc/$(HOST)/Constcollect
RANLIB =        ranlib
ALLCLASSES =	/mnt/tapestry/Tools/Bin/allClasses9
#PROXIFY =       CPP="$(CPP)" $(TOP)/Configure/Tools/Proxify++/SunOS/Proxify++
SED =		sed
FLEX =		flex
YACC =		yacc
INSTALL = 	/bin/install -c -s -m 775
GENCLASS = 	./genclass

MAKHEAD = 	$(TOP)/Tools/Misc/readdwarf.pl -hfile
#
# Various flags for cpp, c++, cc, and ld.
#
DEFINES =	$(OPTIONALDEFINES) $(DEBUG) $(EXTRADEFINES) -Di386 -Di586
CPPFLAGS =	$(DEFINES) $(patsubst %,-I%,$(HVPATH)) -I- $(patsubst %,-I%,$(SPECIALHVPATH))
ifdef VERBOSE
VERBOSEFLAG = -v
endif
COPTS =	-Wall -pipe -O2 $(VERBOSEFLAG)

NOLIB = 
#-nostdlib -nostdinc -nostdinc++ -L /usr/lib/gcc-lib/i386-redhat-linux/3.2.2/ 

###-lsupc++

LCFLAGS =	$(CPPFLAGS) $(COPTS) -DI586SYM 
CFLAGS =	$(CPPFLAGS) $(COPTS) -ffreestanding -DJAMES_HACK -march=i586
C++FLAGS =	$(CPPFLAGS) $(COPTS) -ffreestanding -fno-use-cxa-atexit -DJAMES_HACK -march=i586

#
# Make a .o from C++ source.
#
ifdef NODEPENDENCIES
%.o: %.cc
	@echo "Compiling $<";  \
	$(RM) $*.o; \
	 $(C++) $(C++FLAGS) $(CPPDEBUGDEFINE) -c $<
else
%.o: %.cc
	@echo "Compiling $<";  \
	$(RM) D/$*.dep $*.o; \
	 > D/$*.dep; \
	 DEPENDENCIES_OUTPUT="D/$*.dep $*.o";\
	 export DEPENDENCIES_OUTPUT; \
	 $(C++) $(C++FLAGS) $(CPPDEBUGDEFINE) -c $<
endif # NODEPENDENCIES

.PHONY: ALWAYS
#
# Pre-process a C++ source
#
%.cpp: %.cc ALWAYS
	@echo "Pre-processing $<";  \
	 $(C++) -E $(C++FLAGS) -c $< > $*.cpp

#
# assemble a c++ file
#
%.s: %.cc ALWAYS
	@echo "Making $*.s from $<";  \
	 $(C++) -S $(C++FLAGS) $< 

#
# assemble a c file
#
%.s: %.c ALWAYS
	@echo "Making $*.s from $<";  \
	 $(CC) -S $(CFLAGS) $< 

#
# Make a .o from C source.
#
%.o: %.c
	@echo "Compiling $<"; \
	$(RM) D/$*.dep $*.o; \
	> D/$*.dep; \
	DEPENDENCIES_OUTPUT="D/$*.dep $*.o";\
	export DEPENDENCIES_OUTPUT; \
	$(CC) $(CFLAGS) $(CPPDEBUGDEFINE) -c $<

#
# Make a .o from assembler source.
#
%.o: %.s
	@echo "Assembling $<";  \
	$(RM) D/$*.dep $*..s $*.o; \
	> D/$*.dep; \
	DEPENDENCIES_OUTPUT="D/$*.dep $*.o"; \
	export DEPENDENCIES_OUTPUT; \
	#$(AS) $(ASFLAGS) $(ASDEFINES) $< -o $*.o 
	$(CPP) $(CFLAGS) $(ASDEFINES) $< | $(AS) $(ASFLAGS) -o $*.o 
	#$(CPP) $(CFLAGS) $(ASDEFINES) -o $*.o $ <
	###-Wa,$(ASFLAGS)

#
# Make a .cpp from assembler source.
#
%.cpp: %.s ALWAYS
	@echo "Pre-processing $< to $*.cpp";  \
	$(RM) $*.cpp
	> D/$*.dep; \
	DEPENDENCIES_OUTPUT="D/$*.dep $*.o"; \
	export DEPENDENCIES_OUTPUT; \
	$(CPP) $(CPPFLAGS) -DASM $< > $*.cpp

#
# Make a .cc from lex source.
#
%.lex.cc: %.l
	@echo "Flexing $<"; \
	$(RM) D/$*.dep; \
	(echo "$*.lex.cc: $<";echo "$*.lex.o: $*.lex.cc") >D/$*.dep; \
	$(FLEX) $<
	@mv lex.yy.c $*.lex.cc
#
# Make a .cc from yacc source.
#
%.tab.cc: %.y
	@echo "Yaccing $<"; \
	$(RM) D/$*.dep; \
	(echo "$*.tab.cc: $<";echo "$*.tab.o: $*.tab.cc") >D/$*.dep; \
	$(YACC) -dl $<
	mv y.tab.h $*.tab.h;
	mv y.tab.c $*.tab.cc
