#
# This file is part of the Choices Operating System
# Developed by: The TAPESTRY Parallel Computing Laboratory
#		 University of Illinois at Urbana-Champaign
#		 Department of Computer Science
#		 1304 W. Springfield Ave.
#		 Urbana, IL	61801
#
# Copyright (c) 1987, 1988, 1989 The University of Illinois Board of Trustees.
#	All Rights Reserved.
# CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
#
# Author: David W. Dykstra (dykstra@cs.uiuc.edu)
# Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
#
# Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
#   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
#
#
# Common makefile for Att6386-based Choices products
# This should not be invoked directly, but included in other makefiles.
#
#	$Header: /projects/choices/old/cvsroot/choices/Configure/Sparc.Att.mk,v 1.1 2004/06/03 01:58:32 jcarlyle Exp $
#

PROCESSOR =	SPARC
MACHINE =	Sparc.Att
HOST =		sparc

CPP =		/usr/local/Gnu/lib/gcc-cpp
CC =		cc -pipe
NM =		nm
SIZE =		size
C++ =		/usr/local/bin/CC -pipe
AS =		as
LD =		ld
AR =		ar
MV =		mv
RM =		rm -f
RANLIB =	ranlib
FLEX =		/mnt/tapestry/Tools/Bin.sparc/flex
YACC =		/mnt/tapestry/Tools/Bin.sparc/Byacc.c++
COLLECT =	:

#
# Various flags for cpp, c++, and cc.
#
DEFINES =	$(DEBUG) $(EXTRADEFINES) -DSPARC -DSUN -DCFRONT -DUNIX
CPPFLAGS =	$(DEFINES) $(patsubst %,-I%,$(HVPATH))
COPTS = -g

CFLAGS =	$(CPPFLAGS) $(COPTS)
C++FLAGS =	$(CPPFLAGS) $(COPTS)
LDFLAGS =	$(EXTRALDFLAGS)

#
# Make a .o from C++ source.
#
%.o: %.cc
	@echo "Compiling $<"; \
	$(RM) D/$*.dep $*.o; \
	> D/$*.dep; \
	DEPENDENCIES_OUTPUT="D/$*.dep $*.o";\
	export DEPENDENCIES_OUTPUT;
	$(C++) -I- $(C++FLAGS) -c $<

#
# Make a .o from assembler source.
#
%.o: %.s
	@echo "Assembling $<"; \
	$(RM) D/$*.dep $*..s $*.o; \
	> D/$*.dep; \
	DEPENDENCIES_OUTPUT="D/$*.dep $*.o"; \
	export DEPENDENCIES_OUTPUT; \
	$(CPP) $(CPPFLAGS) -DASM $< >$*..s
	@$(AS) $*..s -o $*.o
	@$(RM) $*..s

#
# Make a .cc from lex source.
#
%.lex.cc: %.l
	@echo "Flexing $<"; \
	$(RM) D/$*.dep; \
	(echo "$*.lex.cc: $<";echo "$*.lex.o: $*.lex.cc") >D/$*.dep; \
	$(FLEX) $<
	@$(MV) lex.yy.c $*.lex.cc

#
# Make a .cc from yacc source.
#
%.tab.cc: %.y
	@echo "Yaccing $<"; \
	$(RM) D/$*.dep; \
	(echo "$*.tab.cc: $<";echo "$*.tab.o: $*.tab.cc") >D/$*.dep; \
	$(YACC) -dl $<
	@mv y.tab.h $*.tab.h;
	mv y.tab.c $*.tab.cc
