#
# This file is part of the Choices Operating System
# Developed by: The TAPESTRY Parallel Computing Laboratory
#		 University of Illinois at Urbana-Champaign
#		 Department of Computer Science
#		 1304 W. Springfield Ave.
#		 Urbana, IL	61801
#
# Copyright (c) 1987, 1988, 1989 The University of Illinois Board of Trustees.
#	All Rights Reserved.
# CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
#
# Author: David W. Dykstra (dykstra@cs.uiuc.edu)
# Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
#
# Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
#   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
#
#
# This should not be invoked directly, but included in other makefiles.
#
#	$Header: /projects/choices/old/cvsroot/choices/Configure/System/CommonSources.mk,v 1.1 2004/06/03 01:58:32 jcarlyle Exp $

#
# List all includes in the $(TOP)/Includes/Common directory here
#
COMMONPROXYINCLUDES = \
	Object.h ProxiableObject.h OutputStream.h InputStream.h \
	PipeInputStream.h PipeOutputStream.h \
	ClassConstructor.h

TABLEONLYPROXYINCLUDES = $(COMMONPROXYINCLUDES)

ifdef EXTRATABLEONLYPROXYINCLUDES
$(EXTRATABLEONLYPROXYINCLUDES):
	@echo "$(EXTRATABLEONLYPROXYINCLUDES" var removed;
	fail_miserably
endif

COMMONINCLUDES = Assert.h Exception.h ConstructorInstaller.h DataSink.h \
	FormatAssists.h HexDump.h NewAndDelete.h ProxyTable.h \
	Raid.h VersionInstaller.h ClassInstaller.h UserSessionInfo.h \
	Types.h UnixTime.h Time.h Address.h

COMMONSTARINCLUDES = BlockAllocatorStar.h CharacterInputStreamStar.h \
	ClassStar.h ClassConstructorStar.h ConstructorDescriptorStar.h \
	DomainStar.h \
	FreeRunningTimerStar.h \
	InputStreamStar.h MemoryObjectCacheStar.h \
	MemoryObjectStar.h MemoryObjectViewStar.h MemoryRangeStar.h \
	NameServerStar.h ObjectProxyManagerStar.h OutputStreamStar.h \
	PhysicalMemoryRangeStar.h ProcessStar.h \
	ProxyTableCopyStar.h SemaphoreStar.h \
	SystemInterfaceStar.h \
	TimerStar.h TimingInterfaceStar.h VersionObjectStar.h \
	VMInterfaceStar.h 
#
# List all sources in the $(TOP)/Common directory here
#
COMMONSOURCES = \
	$(DISTRIBUTEDCOMMON) \
	ClassConstructor.cc \
	ConstructorInstaller.cc HexDump.cc InputStream.cc Match.cc Object.cc \
	OutputStream.cc ProxyTable.cc ProxiableObject.cc VersionInstaller.cc \
	FileSystem.cc ClassInstaller.cc Raid.cc \
	PipeInputStream.cc PipeOutputStream.cc \
	ReferenceCount.cc Exception.cc

COMMONSTARSOURCES = BlockAllocatorStar.cc CharacterInputStreamStar.cc \
	ClassStar.cc ClassConstructorStar.cc ConstructorDescriptorStar.cc \
	DomainStar.cc \
	FreeRunningTimerStar.cc InputStreamStar.cc \
	MemoryObjectCacheStar.cc \
	MemoryObjectStar.cc MemoryObjectViewStar.cc MemoryRangeStar.cc \
	NameServerStar.cc OutputStreamStar.cc ObjectProxyManagerStar.cc \
	PhysicalMemoryRangeStar.cc ProcessStar.cc \
	ProxyTableCopyStar.cc SemaphoreStar.cc \
	SymbolicLinkStar.cc SystemInterfaceStar.cc \
	TimerStar.cc TimingInterfaceStar.cc VersionObjectStar.cc \
	VMInterfaceStar.cc 
