#
# This file is part of the Choices Operating System
# Developed by: The TAPESTRY Parallel Computing Laboratory
#		 University of Illinois at Urbana-Champaign
#		 Department of Computer Science
#		 1304 W. Springfield Ave.
#		 Urbana, IL	61801
#
# Copyright (c) 1987, 1988, 1989, 1990, 1991, 1992
# The University of Illinois Board of Trustees.
#	All Rights Reserved.
# CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
#
# Author: Nayeem Islam (nislam@cs.uiuc.edu)
# Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
#
# Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
#   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
#
#
# Common Makefile for Distributed and Parallel 
# Processing Support for Choices
#

ifdef Distributed
DISTRIBUTEDVPATH = $(TOP)/Distributed/Message \
		$(TOP)/Distributed/NameServer \
		$(TOP)/Distributed/Tests

DISTRIBUTEDHVPATH = $(TOP)/Includes/Distributed/Message \
	$(TOP)/Includes/Distributed/NameServer

DISTRIBUTEDSTARINCLUDES = MessageContainerStar.h ContainerRepresentativeStar.h UniRepresentativeStar.h TransportStar.h

DISTRIBUTEDSTARSOURCES = MessageContainerStar.cc ContainerRepresentativeStar.cc UniRepresentativeStar.cc TransportStar.cc

DISTRIBUTEDINCLUDES = Transport.h \
	EthernetTransfer.h DistEthernet.h \
	LocalTransport.h AdmInterface.h \
	ContainerManager.h CGLink.h Manager.h \
	Container.h NetworkTable.h ATable.h CSR.h \
	RemoteCSR.h MultiCCSR.h ClientCSR.h \
	AtLeastOnce.h ExactlyOnce.h Reliability.h \
	UnReliable.h RecevingTransport.h AsyncMessageContainer.h \
	SendingTransport.h DispatchMessage.h \
	MultiRecMessContainer.h Node.h HypercubeMessageCContainer.h

DISTRIBUTEDPROXYINCLUDES = DistributedNameServer.h NetworkNameServer.h \
	ContainerRepresentative.h MessageContainer.h UniRepresentative.h SendGroupRepresentative.h GroupRepresentative.h ContainerGroup.h Container.h

# Distributed source files (Distributed/NameServer, Distributed/Message)

DISTRIBUTEDSOURCES = $(DISTSOURCES) $(NAMESERVERSOURCES) $(TESTSOURCES)

TESTSOURCES = Ser.cc Cli.cc Server.cc Client.cc

NAMESERVERSOURCES = NetworkNameServer.cc DistributedNameServer.cc ATable.cc NetworkTable.cc Node.cc

DISTSOURCES = ContainerRepresentative.cc \
	MessageContainer.cc UniRepresentative.cc \
	GroupRepresentative.cc SendGroupRepresentative.cc \
	ContainerGroup.cc  Transport.cc \
	EthernetTransfer.cc Dump.cc LocalTransport.cc \
	AdmInterface.cc ContainerManager.cc CGLink.cc \
	Manager.cc \
	CSR.cc RemoteCSR.cc MultiCCSR.cc ClientCSR.cc \
	AtLeastOnce.cc Reliability.cc ExactlyOnce.cc \
	ReceivingTransport.cc SendingTransport.cc \
	DispatchMessage.cc AsyncMessageContainer.cc \
	Container.cc MultiRecMessContainer.cc HypercubeMessageContainer.cc

DISTRIBUTEDCOMMONINCLUDES = Message.h AsyncMessage.h MultiRPCMessage.h MessageList.h MLink.h iPSCMessage.h

DISTRIBUTEDCOMMON = Message.cc AsyncMessage.cc MultiRPCMessage.cc MessageList.cc MLink.cc iPSCMessage.cc 

DISTRIBUTEDDEFINES = -DDISTRIBUTED
endif
