OUTPUT_FORMAT("elf32-littlearm", "elf32-littlearm", "elf32-littlearm")
OUTPUT_ARCH(arm)
ENTRY(_choicesstart)
SECTIONS
{
    . = 0x00000000;
    . = ALIGN(4);
    .text : {
        boot.o (.text)
        AsmBridge.o (.text)
        *(.text)
    }

    . = ALIGN(4);
    .rodata : { *(.rodata) }

    . = ALIGN(4);
    .data : { 
        __CTOR_LIST__ = .;
        *(.ctors)
        KEEP (*(SORT(.init_array.*)))
        KEEP (*(.init_array))
        __CTOR_END__ = .;

        __DTOR_LIST__ = .;
        *(.dtors)
        __DTOR_END__ = .;

        *(.data) 
    }
    . = ALIGN(4);
    .got : { *(.got) }

    . = ALIGN(4);
    .vdisk : {
        *(.vdisk)
    }

    . = ALIGN(4);
    __bss_start__ = .;
    .bss : { *(.bss) }
    __bss_end__ = .;

    . = ALIGN(4);
    __preinit_array_start = .;
    .preinit_array : { *(.preinit_array) }
    __preinit_array_end = .;

    . = ALIGN(4);
    __init_array_start = .;
    .init_array : { *(.init_array) }
    __init_array_end = .;

    . = ALIGN(4);
    __fini_array_start = .;
    .fini_array : { *(.fini_array) }
    __fini_array_end = .;

    .ARM.extab   : { *(.ARM.extab* .gnu.linkonce.armextab.*) }
     __exidx_start = .;
    .ARM.exidx   : { *(.ARM.exidx* .gnu.linkonce.armexidx.*) }
     __exidx_end = .;

    .eh_frame_hdr : { *(.eh_frame_hdr) }
    .eh_frame       : ONLY_IF_RO { KEEP (*(.eh_frame)) }
    .gcc_except_table   : ONLY_IF_RO { *(.gcc_except_table .gcc_except_table.*) }
    . = ALIGN(256) + (. & (256 - 1));
    .eh_frame       : ONLY_IF_RW { KEEP (*(.eh_frame)) }
    .gcc_except_table   : ONLY_IF_RW { *(.gcc_except_table .gcc_except_table.*) }

    end = .;
}

