
################################################################################
#	Optional UnixCompatibility
#
# First set the machinedependent stuff, then add it to the MI stuff
################################################################################

ifdef SunOSUnixCompatibility
UnixCompatibility=Yes
MACHINEUNIXCOMPATDEFINES = -DSUNOS
MACHINEUNIXCOMPATINCLUDES =
MACHINEUNIXCOMPATSOURCES =
endif

ifdef UmaxUnixCompatibility
UnixCompatibility=Yes
MACHINEUNIXCOMPATDEFINES = -DUMAX
MACHINEUNIXCOMPATINCLUDES = UMAXProcess.h UMAXSystem.h UMAXSVCs.h \
	UMAXProcessStar.h 

MACHINEUNIXCOMPATSOURCES = UMAXProcess.cc UMAXSystem.cc \
	UMAXMultimaxDependent.cc ConduitStream.cc \
	ConduitStreamStar.cc UMAXProcessStar.cc UMAXSystemStar.cc

endif

# Global UnixCompatibility stuff
ifdef UnixCompatibility

UNIXCOMPATIBILITYDEFINES = -DUNIXCOMPATIBILITY $(MACHINEUNIXCOMPATDEFINES)

UNIXCOMPATINCLUDES = $(MACHINEUNIXCOMPATINCLUDES) \
	BSDProcess.h UnixProcess.h UPFileSystem.h UnixSystem.h \
	DeadProcess.h DeadProcessFIFO.h ProcessForward.h \
	SignalEntry.h SignalQueue.h \
	ConduitStream.h ConsoleStream.h IOStream.h NullStream.h \
	PipeBuffer.h PipeStream.h RWFileStream.h

UNIXSTARINCLUDES = BSDProcessStar.h UnixProcessStar.h UnixSystemStar.h \
	DeadProcessStar.h ProcessForwardStar.h SignalEntryStar.h \
	SignalQueueStar.h \
	ConduitStreamStar.h ConsoleStreamStar.h IOStreamStar.h \
	NullStreamStar.h PipeBufferStar.h PipeStreamStar.h \
	RWFileStreamStar.h

UNIXCOMPATSOURCE = $(MACHINEUNIXCOMPATSOURCES) \
	BSDProcess.cc UnixProcess.cc UPFileSystem.cc UnixSystem.cc \
	DeadProcess.cc DeadProcessFIFO.cc ProcessForward.cc Signal.cc \
	ConsoleStream.cc IOStream.cc NullStream.cc \
	PipeBuffer.cc PipeStream.cc RWFileStream.cc

UNIXCOMPATSTARSOURCE = BSDProcessStar.cc UnixProcessStar.cc UnixSystemStar.cc \
	DeadProcessStar.cc ProcessForwardStar.cc SignalEntryStar.cc \
	SignalQueueStar.cc \
	ConsoleStreamStar.cc IOStreamStar.cc \
	NullStreamStar.cc PipeBufferStar.cc PipeStreamStar.cc \
	RWFileStreamStar.cc

UNIXCOMPATVPATH = $(TOP)/UnixCompatibility

UNIXCOMPATHVPATH = $(TOP)/Includes/UnixCompatibility

endif


