#
# This file is part of the Choices Operating System
# Developed by: The TAPESTRY Parallel Computing Laboratory
#		 University of Illinois at Urbana-Champaign
#		 Department of Computer Science
#		 1304 W. Springfield Ave.
#		 Urbana, IL	61801
#
# Copyright (c) 1987, 1988, 1989 The University of Illinois Board of Trustees.
#	All Rights Reserved.
# CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
#
# Author: David W. Dykstra (dykstra@cs.uiuc.edu)
# Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
#
# Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
#   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
#
#
# This should not be invoked directly, but included in other makefiles.
#
#	$Header: /projects/choices/old/cvsroot/choices/Configure/Tools/Proxify++/Proxify++Common.mk,v 1.1 2004/06/03 01:58:33 jcarlyle Exp $

all: doall

SRCDIR = $(TOP)/Tools/Proxify++

EXTRAHVPATH = $(SRCDIR) $(TOP)/Includes
EXTRAVPATH = $(SRCDIR)

INCLUDES =
CSOURCES = proxify.cc error.cc main.cc symbol_table.cc \
	  syntax_tree.cc print.cc declarations.cc types.cc fdstream.cc
NONCSOURCES = parser.y lexer.l
SOURCES = $(CSOURCES) $(NONCSOURCES)
EXTRADEPFILES = parser.tab.cc lexer.lex.cc

include ../../ToolsCommon.mk

COBJECTS = $(addsuffix .o, $(basename $(CSOURCES)))
OBJECTS = $(COBJECTS) parser.tab.o lexer.lex.o

lexer.lex.o: parser.tab.cc lexer.lex.cc

$(COBJECTS): parser.tab.o lexer.lex.o

doall: Proxify++ proxify

clobber: clobberproxify
clobberproxify:
	$(RM) Proxify++ proxify $(OBJECTS) $(EXTRADEPFILES) parser.tab.h 

EXTRADEFINES = -DPROXIFY \
	-DDEBUG_LEXER -DDEBUG_PARSER -DDEBUG_PRINT -DDEBUG_PROXIFY -DYYDEBUG

$(COBJECTS) lexer.lex.o: parser.tab.h

proxify: $(OBJECTS)
	@echo "Linking proxify"; \
	$(RM) proxify; \
	$(C++) $(C++FLAGS) -o proxify $(OBJECTS) $(LIBS)

Proxify++:
	cp $(SRCDIR)/Proxify++.sh Proxify++
