#
# This file is part of the Choices Operating System
# Developed by: The TAPESTRY Parallel Computing Laboratory
#		 University of Illinois at Urbana-Champaign
#		 Department of Computer Science
#		 1304 W. Springfield Ave.
#		 Urbana, IL	61801
#
# Copyright (c) 1987, 1988, 1989 The University of Illinois Board of Trustees.
#	All Rights Reserved.
# CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
#
# Author: David W. Dykstra (dykstra@cs.uiuc.edu)
# Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
#
# Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
#   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
#
#
#	$Header: /projects/choices/old/cvsroot/choices/Configure/VChoices.mk,v 1.3 2004/07/19 08:51:57 jcarlyle Exp $
#
#DEBUG_LD = -Wl,-debug

PROCESSOR =	VChoices
MACHINE =	VChoices
VCHOICES =	Yes
SPARC =		Yes

ifndef OS_CPP
  OS_CPP = cpp
endif
ifndef OS_CC
  OS_CC = gcc
endif
ifndef OS_C++
  OS_C++ = g++
endif
ifndef OS_NM
  OS_NM = nm
endif
ifndef OS_AS
  OS_AS = as
endif

CPP =		$(OS_CPP)  -undef -D__GNUC__ -D_POSIX_C_SOURCE $(OS_DEFINES)
CC =		$(OS_CC) -pipe 
C++ =		$(OS_C++) -pipe
NM =		$(OS_NM)
SIZE =		size
AS =		$(OS_AS)
LD =		$(C++) $(CPPFLAGS) $(DEBUG_LD) 
AR =		ar
MV =		mv
RM =		rm -f
#RANLIB =	ranlib
FLEX =		flex
YACC =		bison -y

CONSTCOLLECT = NM=$(NM) $(TOP)/Configure/Tools/Misc/SS1/Constcollect
PROXIFY =	CPP="$(CPP)" $(TOP)/Configure/Tools/Proxify++/SunOS/Proxify++
MAKHEAD = 	CPLUSPLUS=$(CPLUSPLUS) ccC=$(CC) $(TOP)/Tools/Misc/makhead
BOOTLOC =	./bootloc
BOOTLOCFILE =	bootlocinfo

#
# Various flags for cpp, c++, and cc.
#
DEFINES =	$(OPTIONALDEFINES)  $(EXTRADEFINES)  $(OS_DEFINES)
CPPFLAGS =	$(OS_CPPFLAGS) -g $(DEFINES) $(patsubst %,-I%,$(HVPATH)) -I- $(patsubst %,-I%,$(SPECIALHVPATH))
COPTS =	 -Wall $(COMMANDCFLAGS)

CFLAGS =	$(CPPFLAGS) $(COPTS)
C++FLAGS =	$(CPPFLAGS) $(COPTS) 
LDFLAGS =	$(EXTRALDFLAGS)

#
# Make a .o from C++ source.
#
%.o: %.cc
	@echo "Compiling $<"; \
	$(RM) D/$*.dep $*.o; \
	> D/$*.dep; \
	DEPENDENCIES_OUTPUT="D/$*.dep $*.o";\
	export DEPENDENCIES_OUTPUT; \
	$(C++) $(CCDEBUG) $(CCPROFILE) $(C++FLAGS) -c $<

#
# Make a .o from C source.
#
%.o: %.c
	@echo "Compiling $<"; \
	$(RM) D/$*.dep $*.o; \
	> D/$*.dep; \
	DEPENDENCIES_OUTPUT="D/$*.dep $*.o";\
	export DEPENDENCIES_OUTPUT; \
	$(CC) $(CCDEBUG) $(CCPROFILE) $(CFLAGS) -c $<

#
# Make a .s from C++ source.
#
%.s: %.cc
	@echo "Making $*.s from $<"; \
	$(C++) $(C++FLAGS) -S $<

#
# Pre-process a C++ source
#
%.cpp: %.cc
	@echo "Pre-processing $<";  \
	$(C++) -E $(C++FLAGS) -c $< > $*.cpp


#
# Make a .o from assembler source.
#
%.o: %.s
	@echo "Assembling $<"; \
	$(RM) D/$*.dep $*..s $*.o; \
	> D/$*.dep; \
	DEPENDENCIES_OUTPUT="D/$*.dep $*.o"; \
	export DEPENDENCIES_OUTPUT; \
	$(CPP) $(CPPFLAGS) -DASM $< | $(AS) - -o $*.o;

#
# Make a .S from assembler source.
#
%.S: %.s
	@echo "Preprocessing $<"; \
	$(RM) D/$*.dep $*..s $*.o; \
	> D/$*.dep; \
	DEPENDENCIES_OUTPUT="D/$*.dep $*.o"; \
	export DEPENDENCIES_OUTPUT; \
	$(CPP) $(CPPFLAGS) -DASM $< > $*.S;


#
# Make a .cc from lex source.
#
%.lex.cc: %.l
	@echo "Flexing $<"; \
	$(RM) D/$*.dep; \
	(echo "$*.lex.cc: $<";echo "$*.lex.o: $*.lex.cc") >D/$*.dep; \
	$(FLEX) $<
	@$(MV) lex.yy.c $*.lex.cc

#
# Make a .cc from yacc source.
#
%.tab.cc: %.y
	@echo "Yaccing $<"; \
	$(RM) D/$*.dep; \
	(echo "$*.tab.cc: $<";echo "$*.tab.o: $*.tab.cc") >D/$*.dep; \
	$(YACC) -dl $<
	@mv y.tab.h $*.tab.h;
	mv y.tab.c $*.tab.cc
