#ifdef __GNUC__
#pragma implementation
#endif

/* 
 * All VMTP client managemnet routines are 
 * handled in this module.
 */
#include "CSR.h"
#include "Address.h"
#include "Header.h"
#include "Message.h"
#include "ReceivingTransport.h"
#include "TimeoutTimer.h"
#include "EthernetTransfer.h"
#include "BitArray.h"
#include "NetworkBuffer.h"
#include "NameServer.h"

#ifdef __GNUC__
#pragma implementation
#endif

extern EthernetTransfer* NetTransfer;

CSR::CSR () {
timer = new TimeoutTimer;
tm = new IntBitArray(transmission_mask);
time_limit = 10000000;
netFree = StandardNameServer->lookup("nbfl","NetworkBufferFreeList");
Assert(netFree !=0);
transfer = NetTransfer;

numPackets = 0;
trans_id= 0; retrans_count = 0; transmission_mask = 0;
first_packet = 0;
MaxNumTimeouts = 100;
numTimeOuts = 0;
}

void
CSR::probe(int mask)
{
        //Unused! int time = timer->stop();
	transmission_mask = mask;
}

void
CSR::putMessage(Message *mesg)
{
	message = mesg;
}

Message*
CSR::getMessage()
{
	return message;
}

NetworkBuffer**
CSR::getNblist()
{
	return nblist;
}
void CSR::incr_packets()
{
        num_pack_recv++;
}

void CSR::endTrans() {};
void CSR::setFrag(int f) 
{
	tm->set(f); // set the appropriate bit 
}

char** CSR::getChain() {return chain;}

