#ifdef __GNUC__
#pragma implementation
#endif

#include "OutputStream.h"
#include "MessageContainer.h"
#include "ContainerRepresentative.h"
#include "GroupRepresentative.h"
#include "UniRepresentative.h"
#include "SendGroupRepresentative.h"
#include "Reliability.h"
#include "AtLeastOnce.h"
#include "AsyncMessage.h"
#include "Message.h"
#include "ContainerManager.h"
#include "Assert.h"
#include "Byte.h"
#include "Header.h"
#include "NetworkBuffer.h"
#include "DispatchMessage.h"
#include "DistributedNameServer.h"
#include "EthernetTransfer.h"
#include "Reliability.h"
#include "Semaphore.h"
#include "ContainerGroup.h"
#include "RemoteCSR.h"

#ifdef __GNUC__
#pragma implementation
#endif

CSRManager::CSRManager() 
{
        clSem = new Lock;
        cl2Sem = new Lock;
        remSem = new Lock;
        rem2Sem = new Lock;
        for(int i=0;i<tempBufferSize;i++) {
                RemoteCSRArray[i] = 0;
                ClientCSRArray[i] = 0;
        }
}

ClientCSR*
CSRManager::findClientCSR(Container* mp,Address*
 etherAddr,int type)
{
cl2Sem->acquire();
int i;
for(i=0;i<tempBufferSize;i++){
        if(ClientCSRArray[i] && !ByteCompare((ClientCSRA
rray[i]->etherAddr)->bytes(), etherAddr->bytes(),6) && C
lientCSRArray[i]->client_id == mp)
        {
#ifdef TF_MESSAGE_DEBUG
                Console() << " found temp mess  " << eor
;
#endif
                cl2Sem->release();
                return ClientCSRArray[i];
        }
}
        //Console() << " Creating new CCSR\n" << eor;
        ClientCSR *ccsr;
        if (type ==0) ccsr = new ClientCSR(mp,etherAddr)
;
        else ccsr = new MultiCCSR(mp,etherAddr,type);
        saveClientCSR(ccsr);
        cl2Sem->release();
        return ccsr;
 
}
ClientCSR*
CSRManager::findClientCSR(Container* mp,Address*
 etherAddr,int type)
{
cl2Sem->acquire();
int i;
for(i=0;i<tempBufferSize;i++){
        if(ClientCSRArray[i] && !ByteCompare((ClientCSRA
rray[i]->etherAddr)->bytes(), etherAddr->bytes(),6) && C
lientCSRArray[i]->client_id == mp)
        {
#ifdef TF_MESSAGE_DEBUG
                Console() << " found temp mess  " << eor
;
#endif
                cl2Sem->release();
                return ClientCSRArray[i];
        }
}
        //Console() << " Creating new CCSR\n" << eor;
        ClientCSR *ccsr;
        if (type ==0) ccsr = new ClientCSR(mp,etherAddr)
;
        else ccsr = new MultiCCSR(mp,etherAddr,type);
        saveClientCSR(ccsr);
        cl2Sem->release();
        return ccsr;
}
