#ifdef __GNUC__
#pragma implementation
#endif

#include "Message.h"
#include "SendGroupRepresentative.h"
#include "ContainerGroup.h"
#include "MessageContainer.h"
#include "IteratingList.h"
#include "DistributedNameServer.h"
#include "Transport.h"
#include "ContainerManager.h"
#include "CGLink.h"
#include "Address.h"

// #define CG_DEBUG 1

#ifdef __GNUC__
#pragma implementation
#endif

extern Address * LocalAddress;
extern int dumpHex(unsigned char *c, int len);

// created remotely by the DNS to locate reemote port groups

ContainerGroup:: ContainerGroup (char *name, Address *mAddress)
{
#ifdef CG_DEBUG
	Console() << "ContainerGroup:: ContainerGroup" << eor;
#endif
	Id = mAddress;
	localList = new IteratingList;

        MP =  StandardNameServer->lookup("containerManager","ContainerManager");
	if(MP == 0) Console() << "\n AHHH \n " << eor;
	Assert( MP != 0);
	
#ifndef MULTIMAX

	if(mAddress == 0) mAddress = MP->newGroupAddress();
        MP->fixAddress(mAddress);
#endif
        MP->add(this);

#ifdef CG_DEBUG
	Console() << " set address\n" << eor; 
#endif
    if (name != 0) {
        sgr = StandardDistributedNameServer->lookup(name,ContainerRepresentativeClass);
		if (!sgr) {
        	sgr = new SendGroupRepresentative(LocalAddress,0,this);
        	StandardDistributedNameServer -> bind (name, this);
		} else	StandardDistributedNameServer -> bind (name, this);
	}

#ifdef CG_DEBUG
	Console() << "ContainerGroup:: ContainerGroup" << 
			"address" << eor ;
	dumpHex((unsigned char*)getAddress()->bytes(),6);
#endif

}
ContainerRepresentative*
ContainerGroup::cachedCR () {return sgr;}

Address*
ContainerGroup::getAddress() {return Id;}

MessageContainer*
ContainerGroup:: next()
{
	CGLink* pg = (CGLink*) localList->next();
	if(pg) return pg->mp();
	else return (MessageContainer*)0;
}

void
ContainerGroup:: reset()
{
	localList->rewind();
}

void
ContainerGroup::listMembers()
{
 Link *l;
while( l = (CGLink*) localList->next())
                Console() << ((CGLink*) l)->mp()->getName();
	reset();
}

void
ContainerGroup :: put ( Message *message)
{
	Console() << "ContainerGroup::put" << eor;
     	Link *l;
	reset();
        while( l = localList->next()) {
#ifdef CG_DEBUG
		Console() << "ContainerGroup::put, " << name << ((CGLink*)l)->mp()->getName() << eor;
#endif
 		((MessageContainer*) (((CGLink*) l)->mp()))->put(message);
	}
	reset();
}
void
ContainerGroup:: add( char* str)
{
	MessageContainer* mp = StandardDistributedNameServer-> lookup(str,MessageContainerClass);
	add(mp);
}

void
ContainerGroup:: add( MessageContainer *mp)
{
	CGLink* lk = new CGLink(mp);

	localList->addFirst(lk);
	notifyAdd(lk);
}

void
ContainerGroup:: remove( char* str)
{
	MessageContainer* mp = StandardDistributedNameServer-> lookup(str,MessageContainerClass);
	remove(mp);
}
void
ContainerGroup:: remove( MessageContainer * mp)
{
	CGLink lk = CGLink(mp);

	CGLink *rptr = (CGLink*) localList->remove(&lk);
	delete rptr;
	notifyRemove(&lk);
	MP->unfixAddress(Id);
}

int
ContainerGroup:: isMember(MessageContainer *mp)
{
	CGLink lk(mp);	
        CGLink* rptr = (CGLink*)localList->find(&lk);
	if(rptr) return 1;
	else return 0;
/*
	else {
//	find on the net;
	} else { // nowhere to be found 
	return 0;
	} 
*/
}

void 
ContainerGroup::notifyRemove(Link *lk) 
{
}

void 
ContainerGroup::notifyAdd(Link *lk) {
}

#include "ClassInstaller.h"
DEFINECLASS("ContainerGroup",ContainerGroup,ProxiableObject,0,0);
