#ifdef __GNUC__
#pragma implementation
#endif

#include "Manager.h"
#include "ContainerManager.h"
#include "MessageContainer.h"
#include "OutputStream.h"
#include "ThisProcess.h"
#include "Byte.h"
#include "DistEthernet.h"
#include "EthernetDriver.h"
#include "Link.h"
#include "HashTable.h"
#include "ContainerGroup.h"
#include "Container.h"
#include "ContainerRepresentative.h"
#include "ThisProcess.h"
#include "Process.h"
#include "NameServer.h"
#include "Ran.h"

#ifdef __GNUC__
#pragma implementation
#endif

// handlers for group communication

extern MessageContainer* StandardDNSMessagePort;
extern ethernetAddress( DistEthernetAddress );
Address* LocalAddress;
extern int dumpHex(unsigned char *c, int len);

PGDispatch::PGDispatch(ContainerGroup* newpg)
{
	pg = newpg;	
}

int
PGDispatch::hash(int n) 
{
        return ((unsigned int)  (maddr[0] + maddr[5])) % n;

}

int
PGDispatch::compare(Link *l) 
{
	return (!ByteCompare(((PGDispatch*)l)->maddr,maddr,6));
}

ContainerManager::ContainerManager() : Manager() {
        driver= StandardNameServer->lookup("ethernetDriver", "EthernetDriver");
	Assert(driver != 0 );

	unsigned char enet[6];
        ethernetAddress(enet);
        LocalAddress = makeAddress(enet);
        Console() << "ContainerManager Local Address " << *(EthernetAddress*) LocalAddress << eor;

}

ContainerManager::~ContainerManager() {}

/* 
 * the two functions used to be different 
 */
MessageContainer*
ContainerManager::manage(MessageContainer* objectToManage) 
{
/*

	if (objectToManage == (MessageContainer*) NAMESERVERPORT) { 
				// well know address for NameServer
		return (MessageContainer *) StandardDNSMessagePort;
	}
	 if (ByteCompare (objectToManage->location, LocalAddress->bytes(), 6)
    == 0) {

    if (objectToManage->domain != thisProcess()->domain()) {
      return (objectToManage);
    }
    else {
      return (objectToManage);
    }
  }
  else {
	// Console() << "ContainerManager::manage" << "different"; 
    return (objectToManage);
  }
*/
	
}

MessageContainer*
ContainerManager::check(MessageContainer* objectToManage) 
{

	if (objectToManage == (MessageContainer*) NAMESERVERPORT) { 
				// well know address for NameServer
		return (MessageContainer *) StandardDNSMessagePort;
	}
	else return (objectToManage);
}

void
ContainerManager::remove(ContainerGroup *pg)
{
	PGDispatch r;
	r.pg = pg;
	ByteCopy(pg->getAddress()->bytes(),r.maddr,6);
	Link *l = hash->remove(&r);
}

void
ContainerManager::add(ContainerGroup* pg)
{
		PGDispatch* entry = new PGDispatch(pg);	
		ByteCopy(pg->getAddress()->bytes(),entry->maddr,6);
#ifdef MPM_DEBUG
		 Console() << "ContainerManager::add\n" 
			<< "adding address \n" 
			<<  pg->getAddress()->bytes() << eor;
#endif
		entry->pg = pg;
	//	Assert(!hash->find(entry));
			hash->insert(entry);
		//Console() << " ContainerManager::add done\n" << eor;
}

ContainerGroup*
ContainerManager::find(unsigned char*addr)
{
	PGDispatch key;
	ByteCopy(addr,key.maddr,6);
	PGDispatch* rpg = (PGDispatch *)hash->find(&key);
	return rpg->pg;
}


Address*
ContainerManager::makeAddress(unsigned char * nm)
{
return new EthernetAddress(nm);
}

void
ContainerManager::fixAddress(Address* loc)
{
driver->addMulticast((EthernetAddress *)loc);
}

void
ContainerManager::unfixAddress(Address* loc)
{
driver->removeMulticast((EthernetAddress *)loc);
}

Address*
ContainerManager::newGroupAddress()
{
        int result = random();

	// Console() << " result " << result << eor;
        char * mad =  new char[6];
        mad[0] = mad[1] = 0;
        mad[2] = mad[3] = 0;
        mad[4] = mad[5] = 0;
        ByteCopy(&result,mad+2,4);
	Address* n = makeAddress(mad);
	n->makeGroup();
	return n;
}
#include "ClassInstaller.h"
DEFINECLASS("ContainerManager",ContainerManager,Manager,0, 0);
