#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Labora ory
 *               University of Illinois at Urbana-Champaign
 *               Department of Computer Science
 *               1304 W. Springfield Ave.
 *               Urbana, IL     61801
 *
 * Copyright (c) 1992
 * The University of Illinois Board of Trustees.
 *      All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Nayeem Islam (nislam@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

#include "OutputStream.h"
#include "DistEthernet.h"
#include "Assert.h"
#include "Byte.h"

#ifdef __GNUC__
#pragma implementation
#endif

void 
dumpHex(unsigned char *c, int len)
{
	char * buf = new char[2*len+1];
	static char map[] = "0123456789ABCDEF";

	char *bufp = buf;
	for (int i = 0; i < len; i++) {
	    *bufp++ = map[c[i] / 16];
	    *bufp++ = map[c[i] % 16];
	}
	*bufp = 0;
	Console() << buf;
	delete buf;
}

void
dumpBuf(unsigned char *c, int offset, int len)
{
	unsigned char *p = c + offset;

	while (len > 0) {
	  	dumpHex((unsigned char *) &offset, sizeof(int));
		Console() << ":";
		int todump = len > 16 ? 16 : len;
		int todumpsave = todump;
		unsigned char *psave = p;
		while (todump > 0) {
			Console() << " ";
			int newdump = todump > 4 ? 4 : todump;
			dumpHex(p, newdump);
			todump -= newdump;
			p += newdump;
			for (; newdump < 4; newdump++)
				Console() << "  ";
		}
		Console() << "   ";
		while (todumpsave > 0) {
			unsigned char c = *psave++;
			if (c < 0x20 || c > 0x7f) c = '.';
			Console() << c;
			todumpsave --;
		}
		Console() << "\n";
		offset += 16;
		len -= 16;
	}
}

#ifdef NEVER
void
Checksum(char *buf , int s) {
int sum;
for ( int i = 0; i < s; i++ ) {
                sum += *buf++; 
}
       Console()  << "checksum = " << sum << eor;
}
#endif
