#ifdef __GNUC__
#pragma implementation
#endif

#ifdef __GNUC__
#pragma implementation "Transfer.h"
#pragma implementation "EthernetTransfer.h"
#endif
#include "OutputStream.h"
#include "EthernetTransfer.h"
#include "DistEthernet.h"
#include "Reliability.h"
#include "AtLeastOnce.h"
#include "Assert.h"
#include "Byte.h"
// for the new Network Administrator
#include "NetworkBuffer.h"
#include "EthernetAdministrator.h"
#include "AdmInterface.h"
#include "NameServer.h"

#ifdef __GNUC__
#pragma implementation
#endif

// #define E_MESSAGE_DEBUG 1

extern EthernetAdministrator * _THE_EthernetAdministrator;
const EthernetProtocolID ETHERNET_HEADER_TYPE = 0xacdc;

extern ethernetAddress(octet* );

extern int dumpHex(unsigned char *c, int len);
extern int dumpBuf(unsigned char *c, int offset, int len);

NetworkWalker *TheMessageWalker;
EthernetTransfer *NetTransfer=0;

EthernetTransfer::EthernetTransfer(Reliability *rel)
{
	NetTransfer = this;
	reliability = rel;
	TheMessageWalker = new MessageWalker(this);
        Assert( 0 != _THE_EthernetAdministrator );
       _THE_EthernetAdministrator->registerType( 
(EthernetProtocolID ) ETHERNET_HEADER_TYPE, TheMessageWalker );
#ifdef E_MESSAGE_DEBUG
	Console() << "Created EthernetTransfer::EthernetTransfer" << eor;
#endif
}

/*
 * the routines below are for 
 * data transfer
 */

void
EthernetTransfer::receive(char *packet, int len,NetworkBuffer *nb)
{
#ifdef E_MESSAGE_DEBUG
Console() << "In EthernetTransfer::receive" << eor;
#endif
	EthernetHeader *etherHeader = (EthernetHeader *) packet;

#ifdef E_MESSAGE_DEBUG
		inspect(packet); 
#endif

	/* strip out ethernet header */

	char *newpos = packet + sizeof(EthernetHeader);

// I do not like this

	EthernetAddress *source = new EthernetAddress((octet*) etherHeader->source);
        EthernetAddress *destination = new EthernetAddress((octet*) etherHeader->dest);

	reliability->receive( newpos, source,destination,nb);
#ifdef E_MESSAGE_DEBUG
	Console() << "\n In EthernetTransfer::receive DONE\n" << eor;
#endif
}

int
EthernetTransfer::send(char *base, char *prev,Address *destEtherAddress, int len, NetworkBuffer *nbuf)
{
	char* etherPkt = prev - sizeof(EthernetHeader);
#ifdef ADD_CHECK
	Assert(etherPkt == base ) (" EthernetTransfer::offset error");
#endif
	EthernetHeader *etherHeader = (EthernetHeader *) etherPkt;
	ByteCopy(destEtherAddress->bytes(), etherHeader->dest,6); 

// OPTIMIZE in network buffer

	ethernetAddress(etherHeader->source);
	ByteCopy((void*)&ETHERNET_HEADER_TYPE, etherHeader->type, 2);
#ifdef E_MESSAGE_DEBUG
		inspect(etherPkt); 
#endif
		
/*
 * Create A new NetworkBuffer and ask the 
 * administrator to 
 * send it.
 */
 //       NetworkBuffer * buff = new NetworkBuffer( (octet *)base,len ) ;
        _THE_EthernetAdministrator->transmit( nbuf );
// NAYEEM check later
	//nbuf->release(); 
		// if retaining cannot release.

#ifdef E_MESSAGE_DEBUG

	Console() << "ET done transmitting" << eor;
#endif

}

void EthernetTransfer::inspect(char *packet)
{
        Console() << "EthernetTransfer::::dumpPacket" << "\n" << eor;
        EthernetHeader *etherHeader = (EthernetHeader *) packet; 
        Console() << "    dest    : ";
        dumpHex(etherHeader->dest,sizeof(etherHeader->dest));
        Console() << "    source    : ";
        dumpHex(etherHeader->source,sizeof(etherHeader->source));
        Console() << "\n  type      : ";
        dumpHex(etherHeader->type,sizeof(etherHeader->type));
        Console() << "    pack     : ";
        dumpHex(etherHeader->pack,sizeof(etherHeader->pack));
        Console() << "\n" << eor;

}
