#ifdef __GNUC__
#pragma implementation
#endif

/* 
 * All VMTP client managemnet routines are 
 * handled in this module.
 */
#include "MultiCCSR.h"
#include "Address.h"
#include "Header.h"
#include "Message.h"
#include "MessageContainer.h"
#include "ReceivingTransport.h"
#include "TimeoutTimer.h"
#include "EthernetTransfer.h"
#include "BitArray.h"
#include "NetworkBuffer.h"
#include "NameServer.h"

#ifdef __GNUC__
#pragma implementation
#endif

MultiCCSR::MultiCCSR ( Container* loc, Address* e,int n) : ClientCSR(loc,e) 
{
	time_limit = 1000;
	expectedResponse = n;
	collectedResponses = 0;
	Console () << "new MultiCCSR created" << eor;
}

/*
 * We have a chain of data pointers and 
 * a chain of pointers to network buffers.
 * 3 things may happen
 *
 * 1) if time_limit expires --> resend packets.
 * 2) if receive a probe --> resend unreceived packets
 * 3) if receive a response --> done. return
 *
 */

void
MultiCCSR::await_response(Address *dest,int np)
{
Console() << "in await_response \n\n" << eor;
/*
numPackets = np;
numTimeOuts = 0;
response = 0;
state = AWAIT_RESPONSE;
*csr_host = *dest;
Console() << "about to enter looop" << eor;
while((numTimeOuts < MaxNumTimeouts) && !response ){
        timer->start (time_limit);// 1 millisecond
        timer->await();
        numTimeOuts++;
        collectedResponses=0;
	if(timer->residual() && !response && (numTimeOuts < MaxNumTimeouts) ) // send unsent packets
		{
		Console() << "Reseding " << eor;
            send(); // Means we timed our or got a 
		}
			// probe. 
}
*/
}

/*
 * For now search for any N
 * Eventually look for N distinct recipeints.
 */

void
MultiCCSR::responseDone()
{
	Console() << " got response " << eor;
	collectedResponses++;
	if(collectedResponses == expectedResponse) { 
/*
        	int time = timer->stop();
*/
		response = 1;
// free all the network buffers
		for ( int j=0; j< numPackets; j++)
        		nblist[j]->release();
	}
}

void MultiCCSR::setResponses(int responses) 
{
expectedResponse = responses;
}
