#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989 The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Nayeem Islam (nislam@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
#include "Node.h"
#include "Address.h"
#include "ATable.h"
#include "String.h"

#ifdef __GNUC__
#pragma implementation
#endif


extern ATable* StandardNetworkTable;

Node::Node(Address *Addr, char* string, int snum)
{
	_address = Addr;
	 name = new char[strlen(string)+1];
    	(void)strcpy(name,string);

	for(int i=0;i < BufSize; i++) {
		seqNum [i] = snum;	
	}
}

char*
Node::getName()
{
	return name;
}

void
Node:: setSeqNum(int index,int seq) 
{
	seqNum[index] = seq;
}

int
Node:: getSeqNum(int i) 
{
	return seqNum[i];
}

long 
Node::id()
{
return	StandardNetworkTable->localIndex();
}

#include "ClassInstaller.h"
DEFINECLASS("Node",Node,ProxiableObject,0,0);
