#ifdef __GNUC__
#pragma implementation
#endif

#include "OutputStream.h"
#include "Assert.h"
#include "Reliability.h"
#include "Header.h"
#include "Transport.h"
#include "EthernetTransfer.h"
#include "NetworkBuffer.h"

#ifdef __GNUC__
#pragma implementation
#endif

// #define R_DEBUG 1

Reliability::Reliability(Transport*trans) 
{
transport = trans;
transfer = new EthernetTransfer(this);
}

void
Reliability::setMaxNumTimeout( int num ) 
{
MaxNumTimeouts = num;
}

void 
Reliability::setTimeout( int time )
{
timeout = time;
}

int
Reliability::send(char* base,char *prev,Address *dest,int len,NetworkBuffer *nb)
{
char* temPkt = prev - sizeof(ReliabilityHeader);
ReliabilityHeader* relPkt =(ReliabilityHeader*) temPkt;
#ifdef R_DEBUG
	inspect(relPkt);
#endif
  transfer->send(base, (char* )relPkt,dest,len,nb);
// return 0;
}

void
Reliability::receive( char *packet, Address *etherAddr,Address *dest,NetworkBuffer *nb)
{
  // Unused! ReliabilityHeader *ato =  (ReliabilityHeader *)packet;
#ifdef R_DEBUG
	inspect(ato);
#endif

        char * newpos = packet + sizeof(ReliabilityHeader);
        transport->receive(newpos,etherAddr,dest,nb);
}
void
Reliability::inspect(ReliabilityHeader *reliabilityHeader)
{
        Console() << "\n  ack      : " << reliabilityHeader->ack;
        Console() << "    sequenceNum      : " << reliabilityHeader->sequenceNum;
        Console() << "    delmask      : " << reliabilityHeader-> delmask;
        Console() << "\n" << eor;
}
