#ifdef __GNUC__
#pragma implementation
#endif

#include "Message.h"
#include "MessageContainer.h"
#include "ContainerGroup.h"
#include "ContainerRepresentative.h"
#include "DistributedNameServer.h"
#include "SendGroupRepresentative.h"
#include "Transport.h"
#include "Address.h"

#ifdef __GNUC__
#pragma implementation
#endif

// #define SGR_DEBUG 1

extern Address * LocalAddress;

// created remotely by the DNS to locate reemote port groups

SendGroupRepresentative:: SendGroupRepresentative ( Address* location, Transport *transport, ContainerGroup* cg) : ContainerRepresentative(location, transport )
{
#ifdef SGR_DEBUG
	Console() << " set address" << eor; 
#endif
 	_localCG = cg;
#ifdef SGR_DEBUG
	Console() << "SendGroupRepresentative:: SendGroupRepresentative" << 
			"address" << eor ;
	dumpHex((unsigned char*)getAddress()->bytes(),6);
#endif
}

Container *
SendGroupRepresentative :: localContainer ()
{
  Assert(_localCG != 0);
  return _localCG;
}

Container *
SendGroupRepresentative :: remoteContainer ()
{
  return 0;
// needs fixing
}

/*
 * Distributed creation of port groups
 */

void
SendGroupRepresentative:: localSend( Message *message )
{
#ifdef SGR_DEBUG
	Console() << "SendGroupRepresentative::localSend" << eor;
#endif
	_localCG->put(message);
}
void
SendGroupRepresentative :: send ( Message *message)
{
  message -> setDestination ( this ) ;
#ifdef SGR_DEBUG
	Console() << "    SendGroupRepresentative::send     : \n";
	Console() << "    SendGroupRepresentative::name     : \n"
	<< getName() << "\n" << eor;
	dumpHex(location->bytes(),6);
#endif

localSend(message);
remoteSend(message);
}

int
SendGroupRepresentative :: rpcSend (RPCMessage *msg, MessageContainer * mp)
{
    Assert(transport != 0)("No transport for this MessagePort");
    msg -> setDestination ( this ) ;
    ((RPCMessage*)msg) -> setReplyPort ( mp ) ;
// NAYEEM ALERT DO SOMETHING
   return 0;
}

void 
SendGroupRepresentative::remoteSend( Message *message)
{
	ContainerRepresentative::send(message);
} 

#include "ClassInstaller.h"
DEFINECLASS("SendGroupRepresentative",SendGroupRepresentative,ContainerRepresentative,0,0);
