#ifdef __GNUC__
#pragma implementation
#endif

#include "DistributedNameServer.h"
#include "ContainerRepresentative.h"
#include "SingleRepresentative.h"
#include "Message.h"
#include "Domain.h"
#include "Process.h"
#include "ThisProcess.h"
#include "Semaphore.h"
#include "Transport.h"
#include "Address.h"
#include "FreeRunningTimer.h"
#include "FreeRunningTimerStar.h"
#include "String.h"

#ifdef __GNUC__
#pragma implementation
#endif

extern Transport *NetTransport ;
extern Address *LocalAddress ;

// #define MP_DEBUG 1

// for port groups
SingleRepresentative :: SingleRepresentative (char *string)
{
	transport = NetTransport;
} 

// for sending remotely 

SingleRepresentative :: SingleRepresentative (Address *addr, SingleRepresentative* b, Transport *trans, ReceiverSingleRepresentative *mport)
{
    location = addr;
    transport = trans;
    SingleRepresentativeAddress = (SingleRepresentative*) b; 
    localSingleRepresentative = mport;
    domain = 0;
    rpcMsg = 0;
#ifdef MP_DEBUG
	Console() << " MP Done " << eor;
#endif
}

// to accompany receiver message ports

SingleRepresentative :: SingleRepresentative (Transport* localTransport)
{
#ifdef MP_DEBUG
Console() << "SingleRepresentative with no args" << eor;
#endif
    location = LocalAddress; 
    SingleRepresentativeAddress = this;

    if(localTransport == 0) {
	transport =  StandardNameServer->lookup("LocalTransport","Transport");
   Assert(transport !=0)(" local transport not found in the distributed name server") ;
	} else { transport = localTransport; }


    domain = thisProcess () -> domain ();

 // register with the PortManager
 // and the name server

    localSingleRepresentative = (ReceiverSingleRepresentative *) this;
}

/* 
 * Contact the appropriate Transport object
 * to send the message
 */

void 
SingleRepresentative::send (Message *msg)
{
#ifdef MP_DEBUG
  Console() << "SingleRepresentative :: send" << eor;
#endif
    	Assert(transport != 0)("No transport for this SingleRepresentative");
// put in the right proxy in the destination field.
   	Assert( msg != 0);
    	msg -> setDestination ( this) ;
    	transport -> send (msg);
}

/*
 * used for RPCs
 */

int 
SingleRepresentative :: rpcSend (RPCMessage *msg, ReceiverSingleRepresentative *mp)
{
#ifdef MP_DEBUG
Console() << (char*)msg->data() << eor;
#endif
    	Assert(transport != 0)("No transport for this SingleRepresentative");
// put in the right proxy in the destination field.
    	msg -> setDestination ( this ) ;
    	msg -> setReplyPort ( mp ) ;

//        int start = SystemTimer->time();
    	transport -> send (msg);
 //       int end = SystemTimer->time();
//	Console() <<  "send time = %d us\n"<< end - start;

    	mp->wait(msg); // wait for the reply.
	return 0; // fine termination
}

#include "ClassInstaller.h"
DEFINECLASS("SingleRepresentative",SingleRepresentative,ContainerRepresentative,0,0);
