#ifdef __GNUC__
#pragma implementation
#endif

#include "OutputStream.h"
#include "ThisProcess.h"
#include "Process.h"
#include "ProcessStar.h"
#include "Assert.h"
#include "String.h"
#include "NameServer.h"
#include "DistributedNameServer.h"
#include "MessageContainer.h"
#include "ContainerRepresentative.h"
#include "Message.h"
#include "ThisProcess.h"
#include "FreeRunningTimer.h"
#include "FreeRunningTimerStar.h"

#ifdef __GNUC__
#pragma implementation
#endif


static int
checksum(char *buf , int s) 
{
	int sum = 0;
	for ( int i = 0; i < s; i++ ) {
			sum += *buf++; 
	}
	return sum;
}

static void
clientProcess( int, char ** )
{
    int bsize = 4096;
//   Console() << "In client process \n";
   DistributedNameServer *StandardDistributedNameServer = StandardNameServer-> lookup("StandardDistributedNameServer", "DistributedNameServer");

    ContainerRepresentative *Server = StandardDistributedNameServer -> lookup ("Server", "ContainerRepresentative");
    Assert (Server != 0);

   MessageContainer *recport = new MessageContainer (0);

    Assert (recport != 0);
    char * buf = new char[bsize];
    RPCMessage rmsg(buf,bsize,0);

    rmsg.setReplyPort(recport);
    rmsg.setDestination(Server);
    //buf[0] = 55;	
  for(int j=0;j<bsize/2;j++)
                buf[j] = 'b'; 
        for(j=bsize/2;j<bsize-1;j++)
                buf[j] = 'c';
        buf[bsize -1] = '\0';


    int times = 10;
    rmsg.setUserData ((char*)buf,bsize);
	Console() << "\nsending " << times << " messages of size " 
		<< rmsg.size() << "\n" << eor;
    unsigned total = 0;
    for(int i=0;i<times;i++) {
	checksum((char*)rmsg.data(),rmsg.size());
	int start = SystemTimer->time();
	rmsg.rpc();
	int end = SystemTimer->time();
	total += (end - start);
	checksum((char*)rmsg.data(),rmsg.size());
	//Console() << "Data is " << eor;
	//		buf[0] << eor;
	}
	buf[0] = '\0';
	rmsg.setUserData ((char*)buf,bsize);
	rmsg.rpc();
	Console() << "\n\nClient: round trip for " << times << 
		" messages = " << (total/times)
		<< " for recv size " << rmsg.size() << "\n" << eor;
}

void
startRPCClient() {
 Process *p = new SystemProcess( (PFV) clientProcess, thisProcess()->domain(), huge, 0);
        Assert( p != 0);
        p->setName( "#clientProcess");
        p->ready();
        thisProcess()->relinquishProcessor();

}

