#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *               University of Illinois at Urbana-Champaign
 *               Department of Computer Science
 *               1304 W. Springfield Ave.
 *               Urbana, IL     61801
 *
 * Copyright (c) 1992
 * The University of Illinois Board of Trustees.
 *      All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Nayeem Islam (nislam@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant
 * No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

#include "OutputStream.h"
#include "Assert.h"
#include "String.h"
#include "DistributedNameServer.h"
#include "ContainerRepresentative.h"
#include "MessageContainer.h"
#include "Message.h"
#include "Process.h"
#include "ThisProcess.h"

#ifdef __GNUC__
#pragma implementation
#endif

void
clientProcess ()
{
    Console() << "in client\n" << eor;

    ContainerRepresentative *myServer = StandardDistributedNameServer->lookup ("Server",ContainerRepresentativeClass);
    Assert (myServer != 0);
    Console() << "\n clientProces::Lookup successful\n" << eor;

    //  Send the string "choices/demo" to the run server, so that it will
    //  execute that program.
    char *demoName; 
    demoName = new char[32];
    strcpy(demoName,"Async Demo");
    Message msg;
    msg.setDestination (myServer);
    msg.setSize (strlen (demoName) + 1);
    msg.setData (demoName);
    Console() << "About to send message 1" << eor;
    msg.send ();
    Console() << "About to send message 2" << eor;
    msg.send ();
    Console() << "About to send message 3" << eor;
    msg.send ();
}


void
startClient() {
        Process *p = new SystemProcess( (PFV) clientProcess,
                thisProcess()->domain(), large, 0);
        Assert( p != 0);
        p->setName( "#clientProcess");
        p->ready();
        thisProcess()->relinquishProcessor();
}
