#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *               University of Illinois at Urbana-Champaign
 *               Department of Computer Science
 *               1304 W. Springfield Ave.
 *               Urbana, IL     61801
 *
 * Copyright (c) 1992
 * The University of Illinois Board of Trustees.
 *      All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Nayeem Islam (nislam@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant
 * No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

#include "SystemInterface.h"
#include "FileSystemInterface.h"
#include "FileSystemInterfaceStar.h"
#include "PersistentMemoryObjectStar.h"
#include "Process.h"
#include "ProcessStar.h"
#include "ThisProcess.h"
#include "ClassStar.h"
#include "OutputStream.h"
#include "Assert.h"
#include "String.h"
#include "MessageContainer.h"
#include "ContainerRepresentative.h"
#include "Message.h"
#include "String.h"

#ifdef __GNUC__
#pragma implementation
#endif

extern void startClient();
extern void clientProcess();

void
serverProcess()
{
	Console() << " Starting server\n" << eor;
	MessageContainer *mport = new MessageContainer ("Server");
	Console().printf (" servers message port for  receiving messages %x\n",
		 mport);
	char * buf = new char[1024];

	Message msg(buf,1024,1);
	msg.setReceivePort(mport);

	for (int processNumber = 0; ; processNumber++)
	{
		Console() << "serverProcess -- wait for a message \n\n" << eor;
		Console().printf (" On port %x \n", mport);
		Console().flush();
		msg.setReceivePort(mport);
		msg.setUserData(buf,1024);
		msg.receive();
		Console().printf("Executing %s size %d \n",msg.data(),msg.size());
	}

}

void
startServer() {
        Process *p = new SystemProcess( (PFV) serverProcess,
                thisProcess()->domain(), large, 0);
        Assert( p != 0);
        p->setName( "#serverProcess");
        p->ready();
      //  thisProcess()->relinquishProcessor();
//	startClient();
}
