#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Peter W. Madany (madany@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * FixedRecordStream.c - 
 */
#include "Assert.h"
#include "FileSystem.h"
#include "Raid.h"
#include "FixedRecordStream.h"
#include "FixedRecordFile.h"
#include "PersistentMemoryObject.h"

#ifdef __GNUC__
#pragma implementation
#endif

FixedRecordStream::FixedRecordStream( PersistentObject * po )
: RecordStream( po )
{
    initDebug();
    Raids( RaidConstructor ) << this <<  "::FixedRecordStream( "
			     << po << " )\n" << eor;

    // UNUSED !!! int status = 0;

    _file = po;
}

FixedRecordStream::~FixedRecordStream()
{
    Raids( RaidConstructor ) << this << "::~FixedRecordStream()\n" << eor;
}

int
FixedRecordStream::read( char * buffer, int size, int & status )
{
    Raids( RaidMethod ) << this << "::read( , " << size << " , )\n" << eor;

    return( _file->read( _recordNumber++, buffer, size, status ) );
}

int
FixedRecordStream::write( char * buffer, int size, int & status )
{
    Raids( RaidMethod ) << this << "::write( , " << size << " )\n" << eor;

    return( _file->write( _recordNumber++, buffer, size, status ) );
}

int
FixedRecordStream::recordSize()
{
    Raids( RaidMethod ) << this << "::recordSize() "
			<< _file->recordSize() << "\n" << eor;

    return( _file->recordSize() );
}

ProxiableObject *
FixedRecordStreamConstructor( ProxiableObject * source )
{
	if( source->isKindOf( FixedRecordFileClass ) ) {
		return( new FixedRecordStream( (PersistentObject *)source ) );
	}
	else return( 0 );
}

/*
int
sizeOfFixedRecordStream()
{
	return( sizeof( FixedRecordStream ) );
}

Class *
FixedRecordStream::classOf()
{
	return( FixedRecordStreamClass );
}
*/


#include "ClassInstaller.h"
DEFINECLASS("FixedRecordStream",FixedRecordStream,RecordStream,&FixedRecordStreamConstructor,0);
