#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Peter W. Madany (madany@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * POSHExpression.c - 
 */
#include "POSHExpression.h"

#ifdef __GNUC__
#pragma implementation
#endif

POSHExpression::~POSHExpression() { Raids( RaidConstructor ) << this << "::~POSHExpression()\n" << eor; }

/*
int sizeOfPOSHExpression() { return( sizeof( POSHExpression ) ); }

Class * POSHExpression::classOf() { return( POSHExpressionClass ); }
*/
/*************************************************************************/

POSHExpression::POSHExpression( PersistentMemoryObject * source )
: ( source )
{
	initDebug();
	Raids( RaidConstructor ) << this << "::POSHExpression( "
				 << source << " )\n" << eor;

	_modified = 0;
}

void
POSHExpression::flush()
{
}

POSHExpressionRef
POSHExpression::eval( FileSystemInterface * fsi, int & status )
{
	Raids( RaidMethod ) << this << "::eval( " << fsi << ", "
			    << status << " )\n" << eor;

	return( this );
}

void
POSHExpression::printOn( OutputStream * os )
{
	Raids( RaidMethod ) << this << "::printOn( " << os << " )\n" << eor;
	*os << this << eor;
}

int
POSHExpression::asInt()
{
	Raids( RaidMethod ) << this << "::asInt() 0\n" << eor;
	return( 0 );
}

int
POSHExpression::isTrue()
{
	Raids( RaidMethod ) << this << "::isTrue() 1\n" << eor;
	return( 1 );
}

char * POSHErrorCodeStrings[13] = {
        "Success",
	"ApplyNotInitialized",
	"ApplyArgumentEvaluationFailed",
	"IfNotInitialized",
	"NewObjectFailed",
	"ObjectOpenFailed",
	"SubclassResponsibility",
	"TooFewArguments",
	"TooManyArguments",
	"UnknownBuiltinFunction0",
	"UnknownBuiltinFunction1",
	"UnknownBuiltinFunction2",
	"UnknownBuiltinFunction"
};

int
POSHExpression::execute()
{
	Raids( RaidMethod ) << this << "::execute()\n" << eor;

	int status = 0;

	extern FileSystemInterface * FSI;
	extern OutputStream * stdout;

	FileSystemInterfaceStar fsi = new FileSystemInterface( FSI, 1 );
	POSHExpressionStar p = eval( fsi, status );
	if( status != Success ) {
		if( ( status > Success ) &&
		    ( status <= UnknownBuiltinFunction ) ) {
			*stdout << POSHErrorCodeStrings[status] << "\n" << eor;
		}
		else {
			*stdout << status << "\n" << eor;
		}
	}
	else if( p != 0 ) {
		p->printOn( stdout );
		*stdout << "\n" << eor;
	}
	p = 0;
	fsi = 0;

	return( 0 );
}

int
POSHExpression::init( int argc, char *argv[], FileSystemInterface * )
{
	Raids( RaidMethod ) << this << "::init( " << argc << ", "
			    << argv[0] << " )\n" << eor;
	return( SubclassResponsibility );
}

POSHExpressionRef
POSHExpression::convertArg( int argn, char *argv[], int & status,
			    FileSystemInterface * fsi )
{
	Raids( RaidMethod ) << this << "::convertArg( " << argv[argn] << ", "
			    << fsi << " )\n" << eor;

	POSHExpressionRef p = fsi->open( argv[argn], POSHExpressionClass,
					 status );
        if( ( status == 0 ) && ( p == 0 ) ) status = ObjectOpenFailed;

	return( p );
}
 
#include "ClassInstaller.h"
DEFINEPERSISTENTCLASS("POSHExpression",POSHExpression,AutoloadPersistentObject,0,0);
