#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Peter W. Madany (madany@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * POSHExpressionList.c - 
 */
#include "POSHExpressionList.h"

#ifdef __GNUC__
#pragma implementation
#endif

POSHExpressionList::~POSHExpressionList() { Raids( RaidConstructor ) << this << "::~POSHExpressionList()\n" << eor; }

ProxiableObject * POSHExpressionListConstructor( ProxiableObject * source )
{ if( source->isKindOf( PersistentMemoryObjectClass ) ) {
		return( new POSHExpressionList( (PersistentMemoryObject *)source ) );
  }
  else return( 0 );
}

/*
int sizeOfPOSHExpressionList() { return( sizeof( POSHExpressionList ) ); }

Class * POSHExpressionList::classOf() { return( POSHExpressionListClass ); }
*/
/*************************************************************************/

POSHExpressionList::POSHExpressionList( PersistentMemoryObject * source )
: ( source )
{
	initDebug();
	Raids( RaidConstructor ) << this << "::POSHExpressionList( "
				 << source << " )\n" << eor;
}

void
POSHExpressionList::flush()
{
	Raids( RaidReference ) << this << "::flush()\n" << eor;
	_car.flushStar();
	_cdr.flushStar();
}

void
POSHExpressionList::printOn( OutputStream * os )
{
	Raids( RaidMethod ) << this << "::printOn( " << os << " )\n" << eor;
	*os << this << eor;
}

POSHExpressionRef
POSHExpressionList::eval( FileSystemInterface * fsi, int & status )
{
	Raids( RaidMethod ) << this << "::eval( " << fsi << ", "
			    << status << " )\n" << eor;

	POSHExpressionRef p = 0;

	if( status != Success ) return( p );

	if( _car != 0 ) {
		p = _car->eval( fsi, status );
		if( ( status == Success ) && ( _cdr != 0 ) ) {
			p = _cdr->eval( fsi, status );
		}
	}
	return( p );
}

int
POSHExpressionList::init( int argc, char *argv[], FileSystemInterface * fsi )
{
	Raids( RaidMethod ) << this << "::init( " << argc << ", "
			    << argv[0] << " )\n" << eor;
	_modified = 1;

	int status = Success;

	if( argc > 0 ) {
		_car = convertArg( 0, argv, status, fsi );
		if( ( status == Success ) && ( argc > 1 ) ) {
			_cdr = convertArg( 1, argv, status, fsi );
			if( ( status != Success ) && ( argc > 2 ) ) {
				status = TooManyArguments;
			}
		}
	}
	return( status );
}


#include "ClassInstaller.h"
DEFINEPERSISTENTCLASS("POSHExpressionList",POSHExpressionList,POSHExpression,&POSHExpressionListConstructor,0);
