#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Peter W. Madany (madany@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * POSHIfStatement.c - 
 */
#include "POSHIfStatement.h"

#ifdef __GNUC__
#pragma implementation
#endif

POSHIfStatement::~POSHIfStatement() { Raids( RaidConstructor ) << this << "::~POSHIfStatement()\n" << eor; }

ProxiableObject * POSHIfStatementConstructor( ProxiableObject * source )
{ if( source->isKindOf( PersistentMemoryObjectClass ) ) {
		return( new POSHIfStatement( (PersistentMemoryObject *)source ) );
  }
  else return( 0 );
}

/*
int sizeOfPOSHIfStatement() { return( sizeof( POSHIfStatement ) ); }

Class * POSHIfStatement::classOf() { return( POSHIfStatementClass ); }
*/
/*************************************************************************/

POSHIfStatement::POSHIfStatement( PersistentMemoryObject * source )
: ( source )
{
	initDebug();
	Raids( RaidConstructor ) << this << "::POSHIfStatement( "
				 << source << " )\n" << eor;
}

void
POSHIfStatement::flush()
{
	Raids( RaidReference ) << this << "::flush()\n" << eor;
	_condition.flushStar();
	_true.flushStar();
	_false.flushStar();
}

POSHExpressionRef
POSHIfStatement::eval( FileSystemInterface * fsi, int & status )
{
	Raids( RaidMethod ) << this << "::eval( " << fsi << ", "
			    << status << " )\n" << eor;

	POSHExpressionRef p = 0;

	if( status != Success ) return( p );

	if( ( _condition == 0 ) || ( _true == 0 ) ) status = IfNotInitialized;
	else {
		p = _condition->eval( fsi, status );
		if( status == Success ) {
			Assert( p != 0 );
			if( p->isTrue() ) p = _true->eval( fsi, status );
			else if( _false != 0 ) p = _false->eval( fsi, status );
		}
	}
	return( p );
}

void
POSHIfStatement::printOn( OutputStream * os )
{
	Raids( RaidMethod ) << this << "::printOn( " << os << " )\n" << eor;
	*os << this << "<" << _condition << _true << _false << ">" << eor;
}

int
POSHIfStatement::init( int argc, char *argv[], FileSystemInterface * fsi )
{
	Raids( RaidMethod ) << this << "::init( " << argc << ", "
			    << argv[0] << " )\n" << eor;
	_modified = 1;

	int status = Success;

	if( argc < 2 ) status = TooFewArguments;
	else {
		_condition = convertArg( 0, argv, status, fsi );
		if( status == Success ) {
			_true = convertArg( 1, argv, status, fsi );
			if( ( status == Success ) && ( argc > 2 ) ) {
				_false = convertArg( 2, argv, status, fsi );
				if( ( status == Success ) && ( argc > 3 ) ) {
					status = TooManyArguments;
				}
			}
		}
	}
	return( status );
}


#include "ClassInstaller.h"
DEFINEPERSISTENTCLASS("POSHIfStatement",POSHIfStatement,POSHExpression,&POSHIfStatementConstructor,0);
