#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Peter W. Madany (madany@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * POSHInteger.c - 
 */
#include "POSHInteger.h"

#ifdef __GNUC__
#pragma implementation
#endif

POSHInteger::~POSHInteger() { Raids( RaidConstructor ) << this << "::~POSHInteger()\n" << eor; }

ProxiableObject * POSHIntegerConstructor( ProxiableObject * source )
{ if( source->isKindOf( PersistentMemoryObjectClass ) ) {
		return( new POSHInteger( (PersistentMemoryObject *)source ) );
  }
  else return( 0 );
}

/*
int sizeOfPOSHInteger() { return( sizeof( POSHInteger ) ); }

Class * POSHInteger::classOf() { return( POSHIntegerClass ); }
*/
/*************************************************************************/

POSHInteger::POSHInteger( PersistentMemoryObject * source )
: ( source )
{
	initDebug();
	Raids( RaidConstructor ) << this << "::POSHInteger( "
				 << source << " )\n" << eor;
}

void
POSHInteger::setValue( int value )
{
	Raids( RaidMethod ) << this << "::setValue( "
			    << value << " )\n" << eor;
	_value = value;
	_modified = 1;
}

void
POSHInteger::printOn( OutputStream * os )
{
	Raids( RaidMethod ) << this << "::printOn( " << os << " )\n" << eor;
	*os << _value << eor;
}

int
POSHInteger::isTrue()
{
	Raids( RaidMethod ) << this << "::isTrue() " << _value << "\n" << eor;
	return( _value );
}

int
POSHInteger::asInt()
{
	Raids( RaidMethod ) << this << "::asInt() " << _value << "\n" << eor;
	return( _value );
}

int
POSHInteger::init( int argc, char *argv[], FileSystemInterface * )
{
	Raids( RaidMethod ) << this << "::init( " << argc << ", "
			    << argv[0] << " )\n" << eor;
	int status = Success;

	if ( argc == 0 ) status = TooFewArguments;
	else {
		_value = atoi( argv[0] );
		if( argc > 1 ) status = TooManyArguments;
		_modified = 1;
	}

	return( status );
}


#include "ClassInstaller.h"
DEFINEPERSISTENTCLASS("POSHInteger",POSHInteger,POSHExpression,&POSHIntegerConstructor,0);
