#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Peter W. Madany (madany@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * POSHLambda.c - 
 */
#include "POSHLambda.h"

#ifdef __GNUC__
#pragma implementation
#endif

POSHLambda::~POSHLambda() { Raids( RaidConstructor ) << this << "::~POSHLambda()\n" << eor; }

ProxiableObject * POSHLambdaConstructor( ProxiableObject * source )
{ if( source->isKindOf( PersistentMemoryObjectClass ) ) {
		return( new POSHLambda( (PersistentMemoryObject *)source ) );
  }
  else return( 0 );
}

/*
int sizeOfPOSHLambda() { return( sizeof( POSHLambda ) ); }

Class * POSHLambda::classOf() { return( POSHLambdaClass ); }
*/
/*************************************************************************/

POSHLambda::POSHLambda( PersistentMemoryObject * source )
: ( source )
{
	initDebug();
	Raids( RaidConstructor ) << this << "::POSHLambda( "
				 << source << " )\n" << eor;
	_argc = 0;
}

void
POSHLambda::flush()
{
	Raids( RaidReference ) << this << "::flush()\n" << eor;
	_code.flushStar();
}

void
POSHLambda::printOn( OutputStream * os )
{
	Raids( RaidMethod ) << this << "::printOn( " << os << " )\n" << eor;
	*os << this << eor;
}

POSHExpressionRef
POSHLambda::eval( FileSystemInterface * fsi, int & status )
{
	Raids( RaidMethod ) << this << "::eval( " << fsi << ", "
			    << status << " )\n" << eor;

	POSHExpressionRef p = 0;

	if( status != Success ) return( p );

	char name[2];
	name[1] = '\0';
	for( int i = 0; i < _argc; i ++ ) {
		name[0] = i + '0';
		fsi->link( name, _argv[i] );
	}
	p = _code->eval( fsi, status );
	for( i = 0; i < _argc; i ++ ) {
		name[0] = i + '0';
		fsi->unlink( _argv[i] );
	}

	return( p );
}

int
POSHLambda::init( int argc, char *argv[], FileSystemInterface * fsi )
{
	Raids( RaidMethod ) << this << "::init( " << argc << ", "
			    << argv[0] << " )\n" << eor;
	_modified = 1;

	int status = Success;

	_argc = argc - 1;
	if( _argc > 7 ) {
		_argc = 7;
		status = TooManyArguments;
	}
	if( argc < 1 ) status = TooFewArguments;
	else {
		_code = convertArg( 0, argv, status, fsi );
		if( status == Success ) {
                	for( int i = 1; i < argc; i++ ) {
				strcpy( _argv[i-1], argv[i] ); // FIX check len
			}
		}
	}
	return( status );
}


#include "ClassInstaller.h"
DEFINEPERSISTENTCLASS("POSHLambda",POSHLambda,POSHExpression,&POSHLambdaConstructor,0);
