#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Peter W. Madany (madany@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * POSHString.c - 
 */
#include "POSHString.h"

#ifdef __GNUC__
#pragma implementation
#endif

POSHString::~POSHString() { Raids( RaidConstructor ) << this << "::~POSHString()\n" << eor; }

ProxiableObject * POSHStringConstructor( ProxiableObject * source )
{ if( source->isKindOf( PersistentMemoryObjectClass ) ) {
		return( new POSHString( (PersistentMemoryObject *)source ) );
  }
  else return( 0 );
}

/*
int sizeOfPOSHString() { return( sizeof( POSHString ) ); }

Class * POSHString::classOf() { return( POSHStringClass ); }
*/
/*************************************************************************/

POSHString::POSHString( PersistentMemoryObject * source )
: ( source )
{
	initDebug();
	Raids( RaidConstructor ) << this << "::POSHString( "
				 << source << " )\n" << eor;
}

void
POSHString::printOn( OutputStream * os )
{
	Raids( RaidMethod ) << this << "::printOn( " << os << " )\n" << eor;
	*os << _value << eor;
}

int
POSHString::init( int argc, char *argv[], FileSystemInterface * )
{
	Raids( RaidMethod ) << this << "::init( " << argc << ", "
			    << argv[0] << " )\n" << eor;
	_modified = 1;

	int status = Success;

	if ( argc == 0 ) status = TooFewArguments;
	else {
		strcpy( _value, &argv[0][1] ); // FIX, check size
		if( argc > 1 ) status = TooManyArguments;
	}

	return( status );
}


#include "ClassInstaller.h"
DEFINEPERSISTENTCLASS("POSHString",POSHString,POSHExpression,&POSHStringConstructor,0);
