#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Peter W. Madany (madany@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * POSHVariable.c - 
 */
#include "POSHVariable.h"

#ifdef __GNUC__
#pragma implementation
#endif

POSHVariable::~POSHVariable() { Raids( RaidConstructor ) << this << "::~POSHVariable()\n" << eor; }

ProxiableObject * POSHVariableConstructor( ProxiableObject * source )
{ if( source->isKindOf( PersistentMemoryObjectClass ) ) {
		return( new POSHVariable( (PersistentMemoryObject *)source ) );
  }
  else return( 0 );
}

/*
int sizeOfPOSHVariable() { return( sizeof( POSHVariable ) ); }

Class * POSHVariable::classOf() { return( POSHVariableClass ); }
*/
/*************************************************************************/

POSHVariable::POSHVariable( PersistentMemoryObject * source )
: ( source )
{
	initDebug();
	Raids( RaidConstructor ) << this << "::POSHVariable( "
				 << source << " )\n" << eor;
}

POSHExpressionRef
POSHVariable::eval( FileSystemInterface * fsi, int & status )
{
	Raids( RaidMethod ) << this << "::eval( " << fsi << ", "
			    << status << " )\n" << eor;

	POSHExpressionRef p = 0;

	if( status != Success ) return( p );

	Raids( RaidMethod ) << this << "::eval " << _value << "\n" << eor;

	MemoryObjectDictionaryStar d = fsi->open( ".",
					MemoryObjectDictionaryClass, status );
	Assert( d != 0 );
	PersistentMemoryObjectStar pmo = d->open( _value, status );

	while( pmo == 0 ) {
		Raids( RaidDetail ) << this << "::eval ..\n" << eor;

		pmo = d->open( "..", status );
		if( pmo == 0 ) break;

		MemoryObjectDictionaryStar od = d;
		d = pmo->asA( MemoryObjectDictionaryClass, status );
		pmo = 0;

		Raids( RaidDetail ) << this << "::eval " << d << "\n" << eor;

		if( ( d == (MemoryObjectDictionary *)od ) ||
		    ( d == (MemoryObjectDictionary *)0 ) ) break;

		pmo = d->open( _value, status );
	}
	d = 0;

	if( pmo == 0 ) status = ObjectOpenFailed;
	else {
		p = pmo->asA( POSHExpressionClass, status );
		pmo = 0;
		if( p == 0 ) status = ObjectOpenFailed;
		else p = p->eval( fsi, status );
	}

	return( p );
}

void
POSHVariable::printOn( OutputStream * os )
{
	Raids( RaidMethod ) << this << "::printOn( " << os << " )\n" << eor;
	*os << "<" << _value << ">" << eor;
}

int
POSHVariable::init( int argc, char *argv[], FileSystemInterface * )
{
	Raids( RaidMethod ) << this << "::init( " << argc << ", "
			    << argv[0] << " )\n" << eor;
	_modified = 1;

	int status = Success;

	if ( argc == 0 ) status = TooFewArguments;
	else {
		strcpy( _value, argv[0] ); // FIX, check size
		if( argc > 1 ) status = TooManyArguments;
	}

	return( status );
}


#include "ClassInstaller.h"
DEFINEPERSISTENTCLASS("POSHVariable",POSHVariable,POSHExpression,&POSHVariableConstructor,0);
