#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Peter W. Madany (madany@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * RecordFile.c - 
 */
#include "Assert.h"
#include "Raid.h"
#include "RecordFile.h"
#include "PersistentMemoryObject.h"
#include "Byte.h"
#include "PersistentClass.h"
#include "PersistentIntArray.h"
#include "PersistentArray.h"
#include "FileSystem.h"

#ifdef __GNUC__
#pragma implementation
#endif

class FileSystemInterface;

RecordFile::RecordFile( PersistentMemoryObject * source )
: AutoloadPersistentObject( source )
{
	initDebug();

	Raids( RaidConstructor ) << this << "::RecordFile( "
				 << source << " )\n" << eor;
}

RecordFile::~RecordFile()
{
	Raids( RaidConstructor ) << this << "::~RecordFile()\n" << eor;
}

void
RecordFile::flush()
{
	Raids( RaidReference ) << this << "::flush()\n" << eor;
	_data.flushStar();
}

int
RecordFile::init( int , char *[], FileSystemInterface * )
{
	Assert( NOTREACHED );
	return( 0 );
}

int
RecordFile::read( unsigned int, char *, unsigned int, int & )
{
	Assert( NOTREACHED );
	return( 0 );
}

int
RecordFile::write( unsigned int, char *, unsigned int, int & )
{
	Assert( NOTREACHED );
	return( 0 );
}

unsigned 
RecordFile::numberOfRecords()
{
	Assert( NOTREACHED );
	return( 0 );
}

unsigned 
RecordFile::minimumRecordSize()
{
	Raid( RaidMethod )( "%N::minimumRecordSize() %d\n",
			    this, _minRecordSize );

	return( _minRecordSize );
}

unsigned 
RecordFile::maximumRecordSize()
{
	Raid( RaidMethod )( "%N::maximumRecordSize() %d\n",
			    this, _maxRecordSize );

	return( _maxRecordSize );
}

/*
int
sizeOfRecordFile()
{
	return( sizeof( RecordFile ) );
}

Class *
RecordFile::classOf()
{
	return( RecordFileClass );
}
*/


#include "ClassInstaller.h"
DEFINEPERSISTENTCLASS("RecordFile",RecordFile,AutoloadPersistentObject,0,0);
