#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana", IL	61801
 *
 * Copyright (c) 1987", 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035", NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * RemoteFileSystemMessage.cc
 */

#include "OutputStream.h"
#include "RemoteFileSystemMessages.h"

#ifdef __GNUC__
#pragma implementation
#endif

static char * messageType[] = {
	"Mount",
        "ContainerOpen",
        "ContainerCreate",
        "Open",
        "Create",
        "Keys",
        "Remove",
        "Add",
        "Read",
        "Write",
        "Sync",
        "MountReply",
        "ContainerOpenReply",
        "ContainerCreateReply",
        "OpenReply",
        "CreateReply",
        "KeysReply",
        "RemoveReply",
        "AddReply",
        "ReadReply",
        "WriteReply",
        "SyncReply"
};

OutputStream & operator<< ( OutputStream & s, RFSMessage & msg )
{
	s << "Header: seq no " << msg._sequenceNumber 
	  << " header size " << msg._headerSize
	  << " data size " << msg._dataSize 
	  << " msg type " << messageType[ (int) msg._messageType ]
	  << "\n" << eor;
	return s;
}
