#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Peter W. Madany (madany@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * SymbolicLink.c - 
 */
#include "SymbolicLink.h"
#include "PersistentMemoryObject.h"
#include "Raid.h"

#ifdef __GNUC__
#pragma implementation
#endif

SymbolicLink::SymbolicLink( PersistentMemoryObject * source )
: PersistentArray( source )
{
    initDebug();
}

ProxiableObject * 
SymbolicLinkConstructor( ProxiableObject * source )
{
	if( source->isKindOf( PersistentMemoryObjectClass ) ) {
		return( new SymbolicLink( (PersistentMemoryObject *)source ) );
	}
	else return( 0 );
}


#include "ClassInstaller.h"
DEFINEPERSISTENTCLASS("SymbolicLink",SymbolicLink,PersistentArray,&SymbolicLinkConstructor,0);
//DEFINECLASS("SymbolicLink",SymbolicLink,PersistentArray,&SymbolicLinkConstructor,0);
