#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Lun Xiao (xiao@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * TarRootEntry.c - Tar Root Directory Entry (inode) code
 */
#include "TarRootEntry.h"
#include "Raid.h"

#ifdef __GNUC__
#pragma implementation
#endif

extern ClassStar TarDictionaryClass;

TarRootEntry::TarRootEntry( int inumber,
			  MemoryObjectContainer * container,
			  PersistentMemoryObject * source )
: ( source->numberOfUnits(), 9, inumber, container,
    source, TarDictionaryClass, 0 )
{
	initDebug();
	Raid( RaidConstructor )( "%N::TarRootEntry()\n", this );
}


#include "ClassInstaller.h"
DEFINECLASS("TarRootEntry",TarRootEntry,RootEntry,0,0);
