#ifdef __GNUC__
#pragma implementation
#endif

#include "DumbConduit.h"
#include "TtyBuffer.h"


#ifdef __GNUC__
#pragma implementation
#endif

DumbConduit::DumbConduit(TtyBuffer *t)
{
  myTtyBuffer = t;
}
   

Return_Code  
DumbConduit::insertFromBelow( ConduitMessage * msg )
{
  Assert( msg != 0 );
  Assert( myTtyBuffer != 0 );

  Assert( ! (myTtyBuffer->lock).heldByMe() );
  (myTtyBuffer->lock).acquire();
  myTtyBuffer->chars_left_input += msg->length();
  (myTtyBuffer->lock).release();
  (myTtyBuffer->rawInput)->add( msg );
  return( OK );
}

Return_Code
DumbConduit::insertFromAbove(int len, octet *s) {
  Assert( belowMeConduit != 0 );
  return(belowMeConduit->insertFromAbove(len, s));
}

void
DumbConduit::expandWindow(int n) {
  Assert( belowMeConduit != 0 );
  belowMeConduit->expandWindow(n);
}

Return_Code
DumbConduit::connectTo(AdapterConduit * c) {
  Assert( c != 0 );
  belowMeConduit = c;
  Return_Code ret = c->connectFromAbove( this );
  if( ret != OK ) belowMeConduit = 0;
  return( ret );
}

