#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Panagiotis Kougiouris (kougiour@cs.uiuc.edu) 
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

#include "Assert.h"
#include "CharacterQueue.h"
#include "OutputStream.h"
#include "InputLogicalDevice.h"


#ifdef __GNUC__
#pragma implementation
#endif

InputLogicalDevice::InputLogicalDevice( SerialDevice * aSerialDevice)
{
//	Debug.printf("Obj<%x>::InputLogicalDevice::InputLogicalDevice( SerialDevice = %x )\n", this, aSerialDevice);
	device = aSerialDevice;
}

char
InputLogicalDevice::getChar(){

	return (device->getChar());

}

void
InputLogicalDevice::setAttributes( int type ){
	
	type = type; // to supress the compiler warnings
}	

unsigned short
InputLogicalDevice::charPending(){

	return device->charPending();

}

int InputLogicalDevice::read( char * buffer, int size )
{

	int actualSize = 0;
	char c;

	Debug.printf("Obj<%x>::InputLogicalDevice::read( buffer=%x, size=%d )\n", this, buffer, size );
	while( actualSize < size ){
		while( !charPending() );
		c = getChar();
		actualSize++;
		*(buffer++) = c;
	}
	return actualSize;
}


void 
InputLogicalDevice::inputInterruptHandle(){

	Assert( NOTREACHED );

}
