#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Panagiotis Kougiouris (kougiour@cs.uiuc.edu) 
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */



#include "Assert.h"
#include "OutputStream.h"
#include "OutputLogicalDevice.h"


#ifdef __GNUC__
#pragma implementation
#endif

OutputLogicalDevice::OutputLogicalDevice( SerialDevice * aSerialDevice)
{
	device = aSerialDevice;
}


void
OutputLogicalDevice::putChar( char c )
{
	device->putChar( c );
	if( c == '\n' ) 
		device->putChar( '\r');
}

void
OutputLogicalDevice::outputInterruptHandle()
{

	Assert( NOTREACHED );   // This is just a copy of the device.

}
