#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Panagiotis Kougiouris (kougiour@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

/*
 * SerialDevice.cc:.
 */


#include "Assert.h"
#include "SerialDevice.h"


#ifdef __GNUC__
#pragma implementation
#endif


extern void gnuasmv (...);

SerialDevice::SerialDevice( int inputVector, int outputVector )
{

	inputInterruptVectorNumber = inputVector;
	outputInterruptVectorNumber = outputVector;
}

void
SerialDevice::reset()
{
	Assert( NOTREACHED );   // Subclass Responsibility
}

void
SerialDevice::putChar( char c )
{
	Assert( NOTREACHED );   // Subclass Responsibility
	char r = c;		// To stop the compiler complaining

}

char
SerialDevice::getChar()
{

	Assert( NOTREACHED );   // Subclass Responsibility
	return 0;   		// To stop the compiler complaining
}

unsigned short
SerialDevice::charPending()
{

	Assert( NOTREACHED );   // Subclass Responsibility
	return 0;   		// To stop the compiler complaining
}

void
SerialDevice::enableInputInterrupt()
{

	Assert( NOTREACHED ); // Subclass Responsibility
}

void
SerialDevice::enableOutputInterrupt()
{

	Assert( NOTREACHED ); // Subclass Responsibility
}
