/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Vincent F. Russo (russo@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * Allocator.h: definition of a generic heap class.
 */

#ifndef Allocator_h
#define Allocator_h


#ifdef __GNUC__
#pragma interface
#endif

#include "Object.h"	/* the parent class */
#include "NewAndDelete.h"

/*
 * The generic allocator class.
 */
extern ClassStar AllocatorClass;
class Allocator : public Object {
public:
	Class * classOf();

	Allocator(){}
	~Allocator();
	virtual void * allocate( unsigned nbytes ) = 0;
	virtual void free( void * cp ) = 0;
	virtual int pagesUsed(){return 0;}
	virtual int sizeInPages(){return 0;}
	virtual int reclaimSpace();
};

#endif /*Allocator_h*/
