/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *     University of Illinois at Urbana-Champaign
 *     Department of Computer Science
 *     1304 W. Springfield Ave.
 *     Urbana, IL 61801
 *
 * Copyright (c) 1987-2005
 * The University of Illinois Board of Trustees.
 *  All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 */

#ifndef BootConsole_h
#define BootConsole_h

#ifdef __GNUC__
#pragma interface
#endif

class BootConsole {
 public:
    void run();
    virtual int readBuffer(unsigned len, char* buf, unsigned timeout);
    virtual int readBuffer(unsigned len, char* buf) { return readBuffer(len, buf, 0); }
    virtual bool doDefault() { return false; }
    virtual ~BootConsole();
    bool doCommand(char *cmd);
 protected:
    virtual void printMenu();
 private:
    virtual char getChar() = 0;
    virtual int getRawChar(char* c) = 0;
};

#endif
