
/* 
 *
 * This file defines a set of struictures that can 
 * used for distributed communication. 
 * The base message class is a
 *
 */

#ifndef AsyncMessage_h
#define AsyncMessage_h

#ifdef __GNUC__
#pragma interface
#endif

#include "Message.h"

class MessageContainer;
class EthernetTransport;
class EthernetTransfer;
class AsyncMessageContainer;

/* 
 * This receives an asynchronous message through the system
 */

/* the maximum number of 
 * outstanding asynchronous receives.
 */
class AsyncMessage : public Message {
protected:
	AsyncMessageContainer *asyncMessageContainer;
	int messageId;
	int type;
public:
	int getType();
	void setType(int);

	AsyncMessage(char*,int,int);
	AsyncMessage();
        virtual void receive(); 

	virtual int ireceive();
	virtual int iprobe();
        virtual void cprobe();

	virtual void iwait();
	virtual int idone();

        virtual void cancel();
 	virtual int messid();
        virtual void setMessId(int);

};


#endif AsyncMessage_h

