/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989 The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: David W. Dykstra (dykstra@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * ConstructorInstaller.h -
 *
 */
#ifndef ConstructorInstaller_h
#define	ConstructorInstaller_h


#ifdef __GNUC__
#pragma interface
#endif

class ProxiableObject;

typedef ProxiableObject *(*PConstructor)(char *, unsigned int, unsigned int,
						unsigned int, unsigned int);

class ConstructorInstaller {
	ConstructorInstaller *next;

	char *name;
	PConstructor ctor;
	char *clss;
	int number;

public:
	ConstructorInstaller( char *, PConstructor, char *, int );

	static void install();
};

#define CONSTRUCT( SYM, NAME, CLASS, NUMBER, LEN ) \
	extern "C" void SYM(); \
	ConstructorInstaller CLASS##Constructor##NUMBER##Installer \
		( NAME, (PConstructor) &SYM, #CLASS, NUMBER );

#endif	/*ConstructorInstaller_h*/
