/*
 * This file is part of the Choices Operating System
 *
 * Copyright (c) 2006
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author(s): Jeffrey C. Carlyle (jcarlyle@uiuc.edu)
 *            Francis David (fdavid@uiuc.edu)
 *            Ellick Chan (emchan@uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 */
/*
 * Exception.h: event class description.
 */

#ifndef Exception_h
#define Exception_h


#ifdef __GNUC__
#pragma interface
#endif

#include "Object.h"	/* parent class */

extern ClassStar ExceptionClass;
class Exception : public Object {
  protected:
    char *_msg;

  public:
    Exception();
    Exception(const char *msg);

    virtual ~Exception();
    
    Class * classOf();

    const char *getMessage(void) const;
};

#endif /* Exception_h */
