/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801-2910
 *
 * Copyright (c) 1991 The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 *
 * Author: Amit Parghi (parghi@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

#ifndef HexDump_h
#define HexDump_h


#ifdef __GNUC__
#pragma interface
#endif

class OutputStream;

class HexDump {
    friend OutputStream & operator << (OutputStream &, HexDump &);
protected:
    unsigned char *_pointer;		// pointer to start of dump buffer
    unsigned int _length;		// length of dump buffer
    char _separator;			// visual separator between bytes
public:
    HexDump(unsigned char *ptr, unsigned int len, char separator = ' ');
    //HexDump(char *ptr, unsigned int len, char separator = ' ');
};


class HexString : public HexDump {
    friend OutputStream & operator << (OutputStream &, HexString &);
public:
    HexString(unsigned char *ptr, unsigned int len, char separator = ' ');
    //HexString(char *ptr, unsigned int, len char separator = ' ');
};


    inline
HexDump::HexDump(unsigned char *ptr, unsigned int length, char separator)
{
    _pointer = ptr;
    _length = length;
    _separator = separator;
}

/*
    inline
HexDump::HexDump(char *ptr, unsigned int length, char separator)
{
    _pointer = (unsigned char *) ptr;
    _length = length;
    _separator = separator;
}
*/

    inline
HexString::HexString(unsigned char *ptr, unsigned int len, char separator)
	: HexDump(ptr, len, separator)
{}

/*
    inline
HexString::HexString(char *ptr, unsigned int len, char separator)
	: HexDump(ptr, len, separator)
{}
*/

#endif /* HexDump_h */
