/*
 * HypercubeMessageContainer.h -  hypercube NX/2 semantics 
 */

#ifndef HypercubeMessageContainer_h
#define HypercubeMessageContainer_h

#ifdef __GNUC__
#pragma interface
#endif

#include "Assert.h"
#include "AsyncMessageContainer.h"
#include "AsyncMessage.h"

extern ClassStar HypercubeMessageContainerClass;

class Message;
class AsyncMessage;
class ROQMessage;

/*
 * This class adds the following functionality to
 * ReceiverAsyncMessagePort class.
 * It receives to be outstanding, and then
 * later satisfied. It allows asynchrnous 
 * receives.
 */

class HypercubeMessageContainer : public AsyncMessageContainer {
protected:
	enum {requestStorageSize = 32};

	virtual void nextMessageId(int *index);
	int ROQtail, ROQhead;
//        int RsQtail, RsQhead;
	ROQMessage ROQ[requestStorageSize]; // store upto requestStorageSize requests outstanding
/* NO LONGER needed *
        void int addToRsQ( long type, long len, long from, long req_id );
        void updateRsQ(int i);
        long anyRequestsOutStanding();
	long handleRequests();
        long testInRsQ(long req_id);
        long removeFromRsQ(long req_id, Mesg* LastM) ;
        // req rsQ[requestStorageSize]; // store upto  requestStorageSizE satisfied
*/
public:
	proxiable HypercubeMessageContainer(char*);
	virtual int addToROQ(Message *message); 

 	Class *classOf ();
        void updateROQ(int i);
        int ROQprobe(long typemask);
	proxiable virtual int wait (int messageId); // block
	proxiable virtual int done (int messageId); // ret if not there
        proxiable virtual void cancel (int messageId); //

	proxiable virtual void put (Message*);
        virtual void validROQEntries();
        virtual void validBufferEntries();


};

#endif HypercubeMessageContainer_h
