/* 
 *
 * This file defines a set of struictures that can 
 * used for distributed communication. 
 * The base message class is a
 *
 */
#ifndef MultiRPCMessage_h
#define MultiRPCMessage_h

#ifdef __GNUC__
#pragma interface
#endif

#include "Message.h"

class MessageList;
class MLink;

/* 
 * This sends an asynchronous message through the system
 */

class MultiRPCMessage : public RPCMessage {
protected:
    int numMesg;
    int mesgSize;
    MessageList *ml; /* list of messages */
public:
      MultiRPCMessage(); /* default is to delete related data */
    virtual ~MultiRPCMessage();


// list manipulation member functions

    virtual int isEmpty();
    virtual int number();

    virtual void add(Message*);
    virtual Message* remove(Message*);
    virtual Message* remove();

    virtual void reset();
    virtual Message *nextMessage();

    virtual int getNumMesg( );
    virtual void setNumMesg( int );
    virtual void setMesgSize( int );

// communication member functions

    virtual void rpc(); // redefined
    virtual void send();// redefined
    virtual void receive(); // redefined
};

#endif MultiRPCMessage
