/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *               University of Illinois at Urbana-Champaign
 *               Department of Computer Science
 *               1304 W. Springfield Ave.
 *               Urbana, IL     61801
 *
 * Copyright (c) 1987, 1988, 1989 The University of Illinois Board of Trustees.
 *      All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Nayeem Islam (nislam@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * MultiRecMessPort.h - user access to the message system
 *
 *      $Header: /mnt/tapestry/Choices/nislam.9.29.1990/Includes/MultiRecMessPort
 *      /RCS/MultiRecMessPort.h,v 1.2 90/08/18 13:02:47 nislam Exp $
 */

/* 
 * This is the inteface for the MultiRecMessPort.
 * This is used for receiving multiple replies to 
 * request. to be used with RPCRContainerGroups or 
 * ContainerGroups.
 */	

#ifndef MultiRecMessContainer_h
#define MultiRecMessContainer_h

#ifdef __GNUC__
#pragma interface
#endif

#include "MessageContainer.h"

class Message;
class Transport;
// This is used primarily for receiving 

extern ClassStar MultiRecMessContainerClass;

class MultiRecMessContainer : public MessageContainer {
public:
    proxiable MultiRecMessContainer (char *str);
    proxiable virtual void put (Message *);
    Class *classOf ();
};
#endif MultiRecMessContainer_h
