/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Peter W. Madany (madany@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * PersistentObjectStar.h -
 */

#ifndef	PersistentObjectStar_h
#define	PersistentObjectStar_h

#ifdef __GNUC__
#pragma interface
#endif

#include "ProxiableObjectStar.h"
class PersistentClass;
class PersistentObject;
class PersistentObjectRef;

class PersistentObjectStar : public ProxiableObjectStar {
protected:
	void stash( ProxiableObject *, int ref = 0 );
	void cache( PersistentClass * );
public:
        void flushStar();

	PersistentObjectStar( ProxiableObject *const  ) ;
	PersistentObjectStar( const ProxiableObjectRef & );
	PersistentObjectStar( const ProxiableObjectStar & );

	PersistentObjectStar& operator=( ProxiableObject *const  );
	PersistentObjectStar& operator=( const ProxiableObjectRef & );
	PersistentObjectStar& operator=( const ProxiableObjectStar & );

	PersistentObjectStar( PersistentObject *const = 0 );
	PersistentObjectStar( const PersistentObjectRef & );
	PersistentObjectStar( const PersistentObjectStar & );

	PersistentObjectStar& operator=( PersistentObject *const  );
	PersistentObjectStar& operator=( const PersistentObjectRef & );
	PersistentObjectStar& operator=( const PersistentObjectStar & );


        operator PersistentObject *() ;
	operator PersistentObjectRef() const;
        PersistentObject * operator->();
};

class PersistentObjectRef : public ProxiableObjectRef {
protected:
	void stash( ProxiableObject *, int ref = 0 );
	void cache( PersistentClass * );

public:

	PersistentObjectRef( ProxiableObject  *const  );
	PersistentObjectRef( const ProxiableObjectRef & );
	PersistentObjectRef( const ProxiableObjectStar & );

	PersistentObjectRef& operator=( ProxiableObject *const  );
	PersistentObjectRef& operator=( const ProxiableObjectRef & );
	PersistentObjectRef& operator=( const ProxiableObjectStar & );

	PersistentObjectRef( PersistentObject *const  = 0 );
	PersistentObjectRef( const PersistentObjectRef & );
	PersistentObjectRef( const PersistentObjectStar & );

	PersistentObjectRef& operator=( PersistentObject *const  );
	PersistentObjectRef& operator=( const PersistentObjectRef & );
	PersistentObjectRef& operator=( const PersistentObjectStar & );

        operator PersistentObject *();
        operator PersistentObjectStar () const;
        PersistentObject * operator->();
};

#endif /*PersistentObjectStar_h*/
