/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: David W. Dykstra (dykstra@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * ProxyTable.h
 */

#ifndef ProxyTable_h
#define ProxyTable_h


#ifdef __GNUC__
#pragma interface
#endif

#define MAXMETHODS	128		/* maximum methods per class */
#define MAXPARAMS	12		/* maximum parameters per method */

#ifndef ASM	/* this is included in assembly files for above defines */

class ProxiableObject;

class MethodTableEntry {
public:
	char *returnClass;
	char returnModifier;
	int realMethodNumber;
	int numParams;
	char **paramClasses;
};

class ProxyTable {
public:
	char *tableClass;
	char isProxiable;
	int numMethods;
	MethodTableEntry **methods;
	int numConstructors;
	MethodTableEntry **constructors;
};

class ProxyTableInstaller {
	ProxyTable *table;
	ProxyTableInstaller *next;

public:
	static void install();
	ProxyTableInstaller( ProxyTable * );
};

#endif

#endif /*ProxyTable_h*/
