/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801-2910
 *
 * Copyright (c) 1992 The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 *
 * Author: Amit Parghi (parghi@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

/*
 *	Types.h
 *
 *	Machine-independent portion of the basic type definitions.
 *
 * $Id: Types.h 286 2005-10-12 00:35:31Z jcarlyle $
 *
 */

#include "Object.h"

#ifndef Types_h
#define Types_h


#ifdef __GNUC__
#pragma interface
#endif

enum Boolean {
    FALSE = 0,
    TRUE = 1
};

#ifndef NULL
#define NULL 0
#endif

typedef unsigned char octet;

typedef void (*PFV)();		// pointer to function returning void
typedef void (Object::*OPFV)();	// ptr to object function some Object::void()
typedef int  (*PFI)();		// pointer to function returning int
typedef int (* PFUNC) (unsigned, unsigned, unsigned);
//typedef void (* OFUNC) (OPFV, int); // for trampoline in Process.cc


#include "MachineTypes.h"


#endif /* Types_h */
