/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Peter W. Madany (madany@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * UNIXFile.h - misc UNIX file system constants
 */

#ifndef UNIXFile_h
#define UNIXFile_h


#ifdef __GNUC__
#pragma interface
#endif

const int UNIXTypeShift	= 12;
const int UNIXOwnerShift	= 6;
const int UNIXGroupShift	= 3;
const int UNIXPublicShift = 0;
const int UNIXWierdMask	= 07000;
const int UNIXOwnerMask	= 0700;
const int UNIXGroupMask	= 070;
const int UNIXPublicMask	= 07;
const int UNIXAccessMask	= UNIXOwnerMask|UNIXGroupMask|UNIXPublicMask;
const int UNIXReadMask	= 0444;
const int UNIXWriteMask	= 0222;
const int UNIXExecuteMask = 0111;
const int UNIXSetUserId	= 04000;
const int UNIXSetGroupId	= 02000;
const int UNIXSticky	= 01000;

const int UNIXTypeMask         = 0170000;
const int UNIXTypePipe         = 0010000;
const int UNIXTypeCharacter    = 0020000;
const int UNIXTypeDirectory    = 0040000;
const int UNIXTypeBlock        = 0060000;
const int UNIXTypeRegular      = 0100000;
const int UNIXTypeSymbolicLink = 0120000;
const int UNIXTypeSocket       = 0140000;
const int UNIXTypeBad          = 0170000;

class UNIXFileInfo {
public:
	int	device;
	int	inumber;
	short	mode;
	short	links;
	short	uid;
	short	gid;
	int	rdevice;
	int	size;
	int	atime;
	int	aspare;
	int	mtime;
	int	mspare;
	int	ctime;
	int	cspare;
	int	blockSize;
	int	blocks;
	int	flags;
};

#endif /*UNIXFile_h*/
