/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *               University of Illinois at Urbana-Champaign
 *               Department of Computer Science
 *               1304 W. Springfield Ave.
 *               Urbana, IL     61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *      All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Lee Lup Yuen (lup@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

/*
 * UserSessionInfo.h
 */
 
#ifndef UserSessionInfo_h
#define UserSessionInfo_h


#ifdef __GNUC__
#pragma interface
#endif

const int maxUserNameLength = 8;

struct UserSessionInfo
{
    /* The UserSessionInfo struct is used for obtaining user session
     * information from the UserSessionManager.
     */
    char userName [maxUserNameLength];  //  Name of user.
    unsigned long creationTime;         //  Time at which user logged in.
    unsigned char remoteAddress [4];    //  IP address of user.
    int sessionType;                    //  User's session type (see enum).
    int status;                         //  Status of session.
    enum { TelnetSession, FTPSession, RemoteShellSession,
        ObjectDealerSession, FractalGeneratorSession };  //  Session types.
};

#endif
