/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989 The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: David W. Dykstra (dykstra@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * VersionInstaller.h -
 *
 */
#ifndef VersionInstaller_h
#define	VersionInstaller_h

class VersionInstaller {
	friend class VersionObject;

	char *name;
	char *version;
	char visited;

public:
	VersionInstaller( char *, char * );
};

class ProvidedVersionInstaller {
	friend class VersionObject;

	ProvidedVersionInstaller *next;
	VersionInstaller *versionPtr;

public:
	ProvidedVersionInstaller( VersionInstaller * );

	static ProvidedVersionInstaller * list();
};

class RequiredVersionInstaller {
	friend class VersionObject;

	RequiredVersionInstaller *next;
	VersionInstaller *versionPtr;

public:
	RequiredVersionInstaller( VersionInstaller * );

	static RequiredVersionInstaller * list();
};

#define VERSION( FILE, NAME, VERS ) \
	VersionInstaller FILE##VersionInstaller( NAME, VERS ); \

#define PROVIDEDVERSION( FILE, NAME, VERS ) \
	VERSION( FILE, NAME, VERS ); \
	static ProvidedVersionInstaller FILE##ProvidedVersionInstaller( \
						&FILE##VersionInstaller )

#ifdef DONTREQUIREVERSION

#define REQUIREDVERSION( FILE )

#else

#define REQUIREDVERSION( FILE ) \
	extern VersionInstaller FILE##VersionInstaller; \
	static RequiredVersionInstaller FILE##RequiredVersionInstaller( \
						&FILE##VersionInstaller )

#endif

#endif	/*VersionInstaller_h*/
