/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: David W. Dykstra (dykstra@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * ConstructorDescriptor.h: a descriptor of a proxiable constructor
 */

#ifndef ConstructorDescriptor_h
#define ConstructorDescriptor_h


#ifdef __GNUC__
#pragma interface
#endif

#include "ProxiableObject.h"
#include "ConstructorDescriptorStar.h"
#include "ConstructorInstaller.h"

class ProxiableObject;
class MethodTableEntryCopy;
class Domain;

extern ClassStar ConstructorDescriptorClass;
class ConstructorDescriptor : public ProxiableObject {
public:
	PConstructor ctor;
	MethodTableEntryCopy * meth;
	Domain * domain;
	int size;

	proxiable ConstructorDescriptor( char * name, char * clss, unsigned  num,
						PConstructor);

	Class * classOf();
};

#endif /* ConstructorDescriptor_h */
