#ifndef DOMAIN_SWITCHER_H
#define DOMAIN_SWITCHER_H

#ifdef __GNUC__
#pragma interface
#endif

#include "Domain.h"
#include "Kernel.h"

class DDriver {
public:
  DDriver();
  virtual ~DDriver();
  void init();

  virtual void basicInit() = 0;

  void switchToDriverDomain();
  
  void switchToKernelDomain();
  
  //  inline const stackPages(StackSize);
  void allocateStack();

  void allocateHeap();

  // return the currently active driver who's domain we are executing in
  static DDriver *curDriver();
  
    
protected:
  char * newStackPointer_;

  char * stackBase;
  unsigned stackPages;
  MemoryObjectStar  stackMemoryObject;
  
  char * heapBase;
  MemoryObjectStar heapMemoryObject;
  unsigned heapPages;
  Allocator* heap_;
  Allocator* oldHeap_;

  MemoryObjectStar allocMemoryObject_;
  char* allocAddress_;
  unsigned int allocPages_;

  Domain* domain_;
  Domain* oldDomain_;

  static DDriver * currentDriver_;
};

 
#endif /* DOMAIN_SWITCHER_H */
