/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *               University of Illinois at Urbana-Champaign
 *               Department of Computer Science
 *               1304 W. Springfield Ave.
 *               Urbana, IL     61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991, 1992
 * The University of Illinois Board of Trustees.
 *      All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted und
er license agreement.
 *
 * Author: Nayeem Islam (nislam@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant
 * No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

#ifndef AtLeastOnce_h
#define AtLeastOnce_h

#include "Reliability.h"

class Transport;
class Semaphore;
class MutexSemaphore;
class TimeoutTimer;
class BitArray;
class ReliabilityHeader;
class Address;
class NetworkBuffer;

class AtLeastOnce : public Reliability {
protected:
	int sequenceId;
	enum {window = 8};

	BitArray *ind;

	Semaphore* gate;
	MutexSemaphore* mutex;

	int Ack[window];
	TimeoutTimer * timer[window];
public:
	AtLeastOnce(Transport*);
     	virtual void receive(char*,Address*,Address*,NetworkBuffer*);
       	virtual int send(char*,char*,Address*, int);
       	virtual void inspect(ReliabilityHeader*);

};

#endif AtLeastOnce_h
