/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *               University of Illinois at Urbana-Champaign
 *               Department of Computer Science
 *               1304 W. Springfield Ave.
 *               Urbana, IL     61801
 *
 * Copyright (c) 1987, 1988, 1989 The University of Illinois Board of Trustees.
 *      All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Nayeem Islam (nislam@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * Container.h - user access to the message system
 *
 *      $Header: /mnt/tapestry/Choices/nislam.9.29.1990/Includes/Container
 *      /RCS/Container.h,v 1.2 90/08/18 13:02:47 nislam Exp $
 */

/* 
 * This is the inteface for the eContainer.
 * This is the main communication entity in the 
 * Choices operating sytem.  It is named and it
 * buffers messages.
 * ContainerRepresentatives server as representatives 
 * for ontainers.
 */	

#ifndef Container_h
#define Container_h

#ifdef __GNUC__
#pragma interface
#endif

#include "Lock.h"
#include "Assert.h"
#include "ProxiableObject.h"

class Message;
class ContainerRepresentative;

// This is used primarily for receiving 

extern ClassStar ContainerClass;


class Container : public ProxiableObject
{
protected:
	char *name;
public:
    char * getName();
    void setName(char*);

    virtual ContainerRepresentative* cachedCR()=0;
    proxiable virtual void put (Message *)=0;
    proxiable virtual int wait (Message*)=0;
    Class *classOf ();
};

#endif Container_h
