#ifndef ContainerManager_h
#define ContainerManager_h

#ifdef __GNUC__
#pragma interface
#endif

/*
 * This object manages message ports 
 */

#include "Manager.h"
#include "Link.h"

extern ClassStar ContainerManagerClass;

class MessageContainer;
class ContainerGroup;
class HashTable;
class Address;
class EthernetDriver;
class Container;

class ContainerManager : public Manager {
	EthernetDriver * driver;
public:
	ContainerManager();
	~ContainerManager();
	virtual MessageContainer* manage(MessageContainer*);
	virtual MessageContainer* check(MessageContainer*);
	virtual Address* makeAddress(unsigned char*);
	virtual void fixAddress(Address*);
	virtual void unfixAddress(Address* );
	virtual void add(ContainerGroup*);
	virtual void remove(ContainerGroup*);
	virtual ContainerGroup* find(unsigned char*);
	virtual Address *newGroupAddress();
        Class *classOf ();
	
};

class PGDispatch : public Link {
  public:
    PGDispatch(){}
    PGDispatch(ContainerGroup*);
    ContainerGroup* pg;	    // multicast group object
    unsigned char maddr[6]; // multicast address

    virtual int compare(Link * l);      // compare pointers to self
    virtual int hash(int);              // hash pointerto self.
};

#endif
