/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *               University of Illinois at Urbana-Champaign
 *               Department of Computer Science
 *               1304 W. Springfield Ave.
 *               Urbana, IL     61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991, 1992
 * The University of Illinois Board of Trustees.
 *      All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted und
er license agreement.
 *
 * Author: Nayeem Islam (nislam@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant
 * No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

#ifndef DispatchMessage_h
#define DispatchMessage_h

#ifdef __GNUC__
#pragma interface
#endif

/* 
 * The transfor class knows about the 
 * various methods for flow control
 * and reliability
 */

#include "Transport.h"

extern ClassStar DispatchMessageClass;

class Message;
class MessageContainer;
class Container;
class ContainerManager;
class Address;
class NetworkBuffer;
class TransportHeader;
class ProxiableObject;
class Reliability ;
class EthernetTransfer ;
class RemoteCSR;

class DispatchMessage : public Transport {
	
protected:
        ContainerManager* MPManager;
        Reliability  *reliability;
        EthernetTransfer  *transfer;
        virtual RemoteCSR*      findRemoteCSR(Container*,Address*,Container*)=0;

	Message* 	makeMessage(  char*, Container*, TransportHeader* ,Address*, int ,NetworkBuffer*);
	Message* getMessage(TransportHeader*,Address*);

	void dispatch(Message* ,Address *, ProxiableObject* );
	void dispatch(char *,TransportHeader *,Address *,Address *,NetworkBuffer*);
public:
	DispatchMessage();
	Class *classOf ();
};

#endif DispatchMessage_h
