/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *               University of Illinois at Urbana-Champaign
 *               Department of Computer Science
 *               1304 W. Springfield Ave.
 *               Urbana, IL     61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991, 1992
 * The University of Illinois Board of Trustees.
 *      All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted und
er license agreement.
 *
 * Author: Nayeem Islam (nislam@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant
 * No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

#ifndef DistEthernet_h
#define DistEthernet_h

#ifdef __GNUC__
#pragma interface
#endif

#include "Ethernet.h"
#include "Header.h"

typedef unsigned char DistEthernetAddress[6];

const EthernetAddress broadcastAddress(255, 255, 255, 255,255,255);

const int RunLength = 32;

class EthernetHeader {
        friend class    EthernetTransfer;

        unsigned char dest[6];
        unsigned char source[6];
        unsigned char   type[2];
        unsigned char   pack[2];       
};

class Header{
public:
	EthernetHeader transferHeader;
	ReliabilityHeader reliabilityHeader;
	TransportHeader transportHeader;
};

class AckHeader{
public:
	EthernetHeader transferHeader;
	ReliabilityHeader reliabilityHeader;
};
#endif DistEthernet_h
