
/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *               University of Illinois at Urbana-Champaign
 *               Department of Computer Science
 *               1304 W. Springfield Ave.
 *               Urbana, IL     61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991, 1992
 * The University of Illinois Board of Trustees.
 *      All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted und
er license agreement.
 *
 * Author: Nayeem Islam (nislam@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant
 * No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

#ifndef EthernetTransfer_h
#define EthernetTransfer_h

#ifdef __GNUC__
#pragma interface
#endif

#include "Transfer.h"
//#include "EthernetTransport.h"

extern Class * TransferClass;
class TransportHeader;
class EthernetTransport;
class Reliability;
class AtLeastOnce;
class Address;
class NetworkBuffer;

/* 
 * Pure Data Transfer twiddling
 */

class EthernetTransfer : public Transfer {
//	EthernetTransport  *transport;
	Reliability  *reliability;
public:
	EthernetTransfer(Reliability*);
  	virtual int send(char *base, char *prev,Address *eaddr, int len, NetworkBuffer* = 0);
	virtual void receive(char *packet, int len,NetworkBuffer*);
	void inspect(char *packet);
};


extern Address *LocalAddress;

#endif EthernetTransfer_h
