/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *               University of Illinois at Urbana-Champaign
 *               Department of Computer Science
 *               1304 W. Springfield Ave.
 *               Urbana, IL     61801
 *
 * Copyright (c) 1992
 * The University of Illinois Board of Trustees.
 *      All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Nayeem Islam (nislam@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant
 * No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

/*
 * This file has the definitions ofr 
 * Local transport of the type
 * Buffered and Process
 */
#ifndef LocalTransport_h
#define LocalTransport_h

#ifdef __GNUC__
#pragma interface
#endif

#include "Transport.h"

extern ClassStar BufferedTransportClass;

class Message;

class BufferedTransport : public Transport {
	void wait(){}
public:
	BufferedTransport();
	Class *classOf ();
	virtual int send(Message*);
};

#endif LocalTransport_h
