#ifndef Manager_h
#define Manager_h

#ifdef __GNUC__
#pragma interface
#endif

/*
 * This object manages message ports 
 */

#include "ProxiableObject.h"
#include "Link.h"

extern ClassStar ManagerClass;

class MessageContainer;
class ContainerGroup;
class HashTable;
class Address;

class Manager : public ProxiableObject {
protected:
	enum {MaxGroups = 64 };
	HashTable *hash;
public:
	Manager();
	virtual MessageContainer* manage(MessageContainer*)=0;
	virtual MessageContainer* check(MessageContainer*)=0;
	virtual Address* makeAddress(unsigned char*)=0;
	virtual void fixAddress(Address*)=0;
	virtual void unfixAddress(Address* )=0;
	virtual void add(ContainerGroup*)=0;
	virtual void remove(ContainerGroup*)=0;
	virtual ContainerGroup* find(unsigned char*)=0;
        Class *classOf ();
	
};

#endif
