/* 
 * There is only one per process.
 * This is used for remote communication.
 */

/*
 *States of the client state record.
 */


#ifndef MultiCCSR_h
#define MultiCCSR_h

#ifdef __GNUC__
#pragma interface
#endif


#include "DistEthernet.h"
#include "Lock.h"

class Address;
class TimeoutTimer;
class Message;
class NetworkBuffer;
class IntBitArray;
class NetworkBufferFreeList;

#include "ClientCSR.h"

/*
 * This class 1-M send collect N, reliably 
 *
 */

class MultiCCSR : public ClientCSR {
protected:
	enum {MaxGroup = 32};
	Container* resp[MaxGroup];
public:
	MultiCCSR(Container*,Address*,int n=0);
	int expectedResponse;// number expected
	int collectedResponses; // collectedResponses

	void setResponses(int);
	virtual void responseDone();
	virtual void await_response(Address *dest, int numPackets);
};


#endif MultiCCSR_h
