/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *               University of Illinois at Urbana-Champaign
 *               Department of Computer Science
 *               1304 W. Springfield Ave.
 *               Urbana, IL     61801
 *
 * Copyright (c) 1987, 1988, 1989 The University of Illinois Board of Trustees.
 *      All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Nayeem Islam (nislam@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * SendGroupRepresentative.h - grouping of ports 
 *
 */

/* 
 * This file contains the interface for port groups.
 *
 */	

#ifndef SendGroupRepresentative_h
#define SendGroupRepresentative_h

#ifdef __GNUC__
#pragma interface
#endif

#include "Byte.h"
#include "String.h"
#include "Assert.h"
#include "ContainerRepresentative.h"
#include "Address.h"

extern ClassStar SendGroupRepresentativeClass;

class Message;
class MessageContainer;
class ContainerGroup;

/*
 * Reference to a group of MessageContainers. 
 * Some will be remote others will be local.
 */

class SendGroupRepresentative  : public ContainerRepresentative {
protected:
    ContainerGroup *_localCG;
public:
    SendGroupRepresentative (Address*, Transport*, ContainerGroup *cg);
    proxiable virtual void send(Message*);
    proxiable virtual int rpcSend (RPCMessage *,MessageContainer *mp);
    proxiable virtual void localSend(Message*);
    proxiable virtual void remoteSend(Message*);
    virtual Container*  localContainer();
    virtual Container*  remoteContainer();
    Class *classOf ();

};


#endif SendGroupRepresentative_h
