
/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *               University of Illinois at Urbana-Champaign
 *               Department of Computer Science
 *               1304 W. Springfield Ave.
 *               Urbana, IL     61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991, 1992
 * The University of Illinois Board of Trustees.
 *      All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted und
er license agreement.
 *
 * Author: Nayeem Islam (nislam@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant
 * No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

#ifndef SendingTransport_h
#define SendingTransport_h

#ifdef __GNUC__
#pragma interface
#endif

/* 
 * The transfor class knows about the 
 * various methods for flow control
 * and reliability
 */

#include "ReceivingTransport.h"

extern ClassStar SendingTransportClass;
class NetworkBufferFreeList;

class SendingTransport : public ReceivingTransport {
protected:
	NetworkBufferFreeList *nbfl;
	void    fragment( Message*);
	void    fragmentAsync( Message*);
public:
	void initTransportHeader(TransportHeader*, Message *message);

	SendingTransport();
	Class *classOf ();
        virtual int send(Message *message);
};

#endif SendingTransport_h
