/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *               University of Illinois at Urbana-Champaign
 *               Department of Computer Science
 *               1304 W. Springfield Ave.
 *               Urbana, IL     61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991, 1992
 * The University of Illinois Board of Trustees.
 *      All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted und
er license agreement.
 *
 * Author: Nayeem Islam (nislam@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant
 * No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

#ifndef Reliability_h
#define Reliability_h

#ifdef __GNUC__
#pragma interface
#endif

class EthernetTransport;
class EthernetTransfer;
class Address;

class UnReliable : public Reliability {
protected:
	int MaxNumTimeouts;
	int timeout;
	EthernetTransfer * transfer;
	EthernetTransport * transport;
public:
	virtual void setMaxNumTimeout(int);
	virtual void setTimeout(int);
	virtual void receive(char*,Address*,Address*);
	virtual int send(char*,char*,Address*, int);
};

#endif Reliability_h
