#ifndef DistributedNameServer_h
#define DistributedNameServer_h

#ifdef __GNUC__
#pragma interface
#endif

#include "NetworkNameServer.h"
#include "ClassStar.h"
#include "MessageContainer.h"

class MessageContainer;
class ReceiverMessageContainer;
class ContainerManager;
class NameServer;
class Transport;
class ContainerGroup;
class ContainerRepresentative;
class PortManager;
class ContainerGroup;

struct BroadcastMessage {
        NSMessageType  type;
        ProxiableObject* mport;
        unsigned char  ethernetAddress[6];
};

extern ClassStar DistributedNameServerClass;

class DistributedNameServer : public NetworkNameServer {
protected:
        ContainerRepresentative* broadcastMessageContainer;
        ContainerManager* MPManager;
	ContainerGroup *cg;
        proxiable virtual void multicast( char*,ProxiableObject*,NSMessageType);
  	virtual void checkMessageContainer();
  	virtual void add(ContainerGroup*);
        virtual ProxiableObject* manage(MessageContainer*);
        virtual ProxiableObjectRef check(MessageContainer*);
public:
        DistributedNameServer(NameServer* _parent, Transport*, Transport*);
        Class *classOf ();
};

extern DistributedNameServer * StandardDistributedNameServer;

#endif /* DistributedNameServer_h */
