#ifndef NetworkNameServer_h
#define NetworkNameServer_h

#ifdef __GNUC__
#pragma interface
#endif

#include "ProxiableObject.h"
#include "ProxiableObjectStar.h"
#include "NameServer.h"
#include "ClassStar.h"
#include "MessageContainer.h"

class MesageContainer;
class NameServer;
class Transport;
class ContainerGroup;

const int KERNSIZE = 1024;
const int OSIZE = 256;
enum NSMessageType { RPGBIND, PGBIND, BIND, UNBIND };

extern ClassStar NetworkNameServerClass;

class NetworkNameServer : public NameServer {
protected:
	Transport *aTransport;
        proxiable virtual void multicast( char*,ProxiableObject*,NSMessageType)=0;
  	ProxiableObject* sendToObjectManager(ProxiableObject*);
  	MessageContainer* localContainer;
  	virtual void checkMessageContainer()=0;
	virtual void add(ContainerGroup*)=0;
	virtual ProxiableObject* manage(MessageContainer*)=0;
	virtual ProxiableObjectRef check(MessageContainer*)=0;

public:
       NetworkNameServer(NameServer* _parent, Transport*, Transport*);
        ~NetworkNameServer();
        proxiable virtual void bind( char *name, ProxiableObject *obj );
        proxiable virtual ProxiableObjectRef lookup( ProxiableObject*);
        proxiable virtual ProxiableObjectRef lookup( char *name, char
                *className );
	proxiable virtual ProxiableObjectRef lookup( char * name, Class* );

	proxiable virtual int unbind( char * name );

        Class *classOf ();

};

#endif /* NetworkNameServer_h */
