/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Peter W. Madany (madany@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * ArContainer.h - Ar Inode System Class
 */

#ifndef ArContainer_h
#define ArContainer_h


#ifdef __GNUC__
#pragma interface
#endif

#include "MemoryObjectContainer.h"
#include "Ar.h"

extern ProxiableObject * ArContainerConstructor( ProxiableObject * );
extern PersistentClassStar ArContainerClass;
class ArContainer : public MemoryObjectContainer {
protected:
	FileObjectStar	_byteSource;
	ar_hdr *	 _ar;
	int *		 _lengths;
	int *		 _offsets;
	int		 _valid;

	FileObject * basicOpen( int idNumber, int & status, int flags );

	~ArContainer();
public:
	Class * classOf();

	ArContainer( PersistentMemoryObject * source );
};

#endif ArContainer_h
