/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Douglas E. Leyens (leyens@cs.uiuc.edu)
 * Author: Peter W. Madany (madany@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * ArEntry.h - Ar Directory Entry (inode) class
 */

#ifndef ArEntry_h
#define ArEntry_h


#ifdef __GNUC__
#pragma interface
#endif

#include "FileObject.h"
class ar_hdr;

extern ClassStar ArEntryClass;
class ArEntry : public FileObject {
protected:
	ar_hdr *	_ar;

	int		accessMode();

public:
	Class * classOf();

	ArEntry( unsigned int numberOfUnits,
		 int log2UnitSize,
		 int objectNumber,
		 MemoryObjectContainer * container,
		 PersistentMemoryObject * source,
		 int offset,
		 ar_hdr * ar );

	Class *	supports( Class * );
	int	numberOfBytes();
	int	setMode( int mode );
	int	userId();
	int	groupId();
	void	info( UNIXFileInfo * );
};

#endif	ArEntry_h
