/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *         University of Illinois at Urbana-Champaign
 *         Department of Computer Science
 *         1304 W. Springfield Ave.
 *         Urbana, IL    61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *    All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Peter W. Madany (madany@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * AutoloadPersistentObject.h - User level file class
 */

#ifndef    AutoloadPersistentObject_h
#define    AutoloadPersistentObject_h


#ifdef __GNUC__
#pragma interface
#endif

#include "PersistentObject.h"
#include "AutoloadPersistentObjectStar.h"

extern PersistentClassStar AutoloadPersistentObjectClass;
class AutoloadPersistentObject : public PersistentObject {
protected:
    ~AutoloadPersistentObject();
    void noRemainingReferences();

public:
    Class * classOf();

    AutoloadPersistentObject( PersistentMemoryObject * mo );
};

#endif /*AutoloadPersistentObject_h*/
