/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Peter W. Madany (madany@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * BSDDirectory.h - BSD Directory class
 */

#ifndef	BSDDirectory_h
#define BSDDirectory_h


#ifdef __GNUC__
#pragma interface
#endif

#include "MemoryObjectDictionary.h"
#include "PersistentMemoryObjectStar.h"

const int MaxEntrySize = 255;
const int DirectoryBlockSize = 512;

class direct;

extern ProxiableObject * BSDDirectoryConstructor( ProxiableObject * );
extern PersistentClassStar BSDDirectoryClass;

class BSDDirectory : public MemoryObjectDictionary {
protected:
	int	_previousOffset;
	int	_hint;

	int	findKey( char * key, int neededSize );
 	int	basicKeys( char * buffer, int bufferSize, int & count );
	int	basicAssociations( char * keyBuffer, int bufSize,
					   int & count );
	int	basicAssociations( char * keyBuffer, int bufSize,
					   int & count, int & offset );

	int	insertEntry( char * key, int keyLength, int idNumber );
	int	entrySize( int keyLength );
	int	hint();

	int	clearEntry();

	~BSDDirectory();
public:
	Class * classOf();

	BSDDirectory( PersistentMemoryObject * source );
};

#endif	/*BSDDirectory_h*/
