/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Peter W. Madany (madany@cs.uiuc.edu)
 * Contributing Author: Douglas E. Leyens (leyens@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * BlockAllocator.h - inode system superClass
 */

#ifndef BlockAllocator_h
#define BlockAllocator_h


#ifdef __GNUC__
#pragma interface
#endif

#include "ProxiableObject.h"
#include "MemoryObjectStar.h"
#include "ClassStar.h"
#include "SemaphoreStar.h"

extern ClassStar BlockAllocatorClass;
class BlockAllocator : public ProxiableObject {
protected:
    MemoryObject	* _source;
    SemaphoreStar	_mutex;

    virtual int	basicAllocate( int & blocks, int nearPhysicalUnit, int units );
    virtual void basicFree( int & blocks, int physicalUnit, int units );

public:
    Class * classOf();

    BlockAllocator( MemoryObject * source );
    ~BlockAllocator();

    virtual int	allocate( int & blocks, int nearPhysicalUnit, int units );
    virtual void free( int & blocks, int physicalUnit, int units );
};

#endif /*BlockAllocator_h*/
