/*
 * This file is part of the Choices Operating System
 * Developed by: The Mobile Operating Systems Group
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 201 N. Goodwin Ave.
 *		 Urbana, IL	61801
 *
 * Copyright 2005 University of Illinois Board of Trustees. All Rights Reserved.
 *
 * Author: Jeffrey Carlyle (jcarlyle@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 */
/*
 * CramfsContainer.h - Container for cramfs file system object.
 */

#ifndef CramfsContainer_h
#define CramfsContainer_h

#include "Cramfs.h"
#include "FileObject.h"
#include "MemoryObjectCachingContainer.h"

#ifdef __GNUC__
#pragma interface
#endif

extern ProxiableObject * CramfsContainerConstructor( ProxiableObject * );
extern PersistentClassStar CramfsContainerClass;

class CramfsContainer : public MemoryObjectCachingContainer {
  public:
    CramfsContainer(PersistentMemoryObject *source);
    virtual ~CramfsContainer();

    Class *classOf();

  protected:
    virtual FileObject *basicOpen(int idNumber, int & status, int flags);
    virtual bool IsIdNumberInRange( int idNumber );

    CramfsSuperblock _superBlock;
    FileObject *_byteSource;
};

#endif /* CramfsContainer_h */
