/*
 * This file is part of the Choices Operating System
 * Developed by: The Mobile Operating Systems Group
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 201 N. Goodwin Ave.
 *		 Urbana, IL	61801
 *
 * Copyright 2005 University of Illinois Board of Trustees. All Rights Reserved.
 *
 * Author: Jeffrey Carlyle (jcarlyle@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 */
/*
 * CramfsDictionary.cc - Directory table for cramfs file system.
 */
#ifndef	CramfsDictionary_h
#define CramfsDictionary_h

#ifdef __GNUC__
#pragma interface
#endif

#include "MemoryObjectDictionary.h"
#include "Cramfs.h"

extern ProxiableObject * CramfsDictionaryConstructor( ProxiableObject * );
extern PersistentClassStar CramfsDictionaryClass;

class CramfsDictionary : public MemoryObjectDictionary {
public:
  CramfsDictionary( PersistentMemoryObject * source );

  virtual int findKey( char * key, int );
  virtual Class * classOf();

protected:
  virtual ~CramfsDictionary();

  virtual int basicKeys( char * buffer, int bufferSize, int & count );
  virtual int readEntry(int offset, CramfsInode *pInode,
    char *filename, int nbytes);
};

#endif /* CramfsDictionary_h */
