/*
 * This file is part of the Choices Operating System
 * Developed by: The Mobile Operating Systems Group
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 201 N. Goodwin Ave.
 *		 Urbana, IL	61801
 *
 * Copyright 2005 University of Illinois Board of Trustees. All Rights Reserved.
 *
 * Author: Jeffrey Carlyle (jcarlyle@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 */
/*
 * CramfsEntry.h - Cramfs Directory Entry (inode) class
 */

#ifndef CramfsEntry_h
#define CramfsEntry_h

#ifdef __GNUC__
#pragma interface
#endif

#include "CramfsDirObject.h"
#include "Cramfs.h"
#include "Class.h"

extern ClassStar CramfsFileObjectClass;

class CramfsFileObject : public CramfsDirObject
{
  public:
    Class *classOf();
    
    CramfsFileObject(int idNumber, MemoryObjectContainer *container,
	FileObject *source, CramfsInode *pInode);

    virtual ~CramfsFileObject();

    virtual int isContainer();

  protected:
    virtual int rawRead(unsigned start, unsigned count, char * addr,
	unsigned nbytes, IOAsyncClosure * c);

    Class *supports(Class *aClass);
};

#endif /* CramfsEntry_h */
