/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Peter W. Madany (madany@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * ELFContainer.h - 
 */

#ifndef ELFContainer_h
#define ELFContainer_h


#ifdef __GNUC__
#pragma interface
#endif

#include "MemoryObjectContainer.h"
#include "elF.h"

extern ProxiableObject * ELFContainerConstructor( ProxiableObject * );
extern PersistentClassStar ELFContainerClass;
class ELFContainer : public MemoryObjectContainer {

int getRelocID(int strIndex);

protected:
        typedef llvm::ELF::Elf32_Ehdr filehdr;
        typedef llvm::ELF::Elf32_Shdr scnhdr;

	FileObjectStar	_byteSource;

	filehdr *	_filehdr;
	scnhdr *	_scnhdrs;
  char*     _strTable;
	char      _strName[255];

	int		_valid;

	int		_rootId;
	int		_fileHeaderId;
	int		_aOutHeaderId;
	int		_symbolTableId;
	int		_stringTableId;
	int		_sectionIds;

	FileObject *	basicOpen( int idNumber, int & status, int flags );
	int basicRootId();

	void initializeSymbols();

	~ELFContainer();
public:
	Class * classOf();

	int isValid(void) const;

	ELFContainer( PersistentMemoryObject * source );
};

#endif  /* ELFContainer_h */
