/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Peter W. Madany (madany@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * ELFDictionary.h - ELF Dictionary class
 */

#ifndef	ELFDictionary_h
#define ELFDictionary_h


#ifdef __GNUC__
#pragma interface
#endif

#include "elF.h"
#include "MemoryObjectDictionary.h"

extern ProxiableObject * ELFDictionaryConstructor( ProxiableObject * );
extern PersistentClassStar ELFDictionaryClass;
class ELFDictionary : public MemoryObjectDictionary {

bool isRelocatable(int strIndex);

protected:
	typedef llvm::ELF::Elf32_Ehdr filehdr;
	typedef llvm::ELF::Elf32_Shdr scnhdr;

	scnhdr *_scnhdrs;
	filehdr *_filehdr;
        char    *_strTable;

	int	basicKeys( char * buffer, int bufferSize, int & count );
	~ELFDictionary();
public:
	int	findKey( char * key, int );

	Class * classOf();

	ELFDictionary( PersistentMemoryObject * source );
};

#endif	//ELFDictionary_h




