/*
 * This file is part of the Choices Operating System
 * Author: Yevgeniy Rabinovich <rabinvch@uiuc.edu>,
 *                             <yrabinov+uiuc@cs.uchicago.edu>
 * Using BSDDirectory.h as base for development
 * Copyright (c) 2004
 * The University of Illinois Board of Trustees.
 *      All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 */
/*
 * Ext2Directory.h - Ext2Directory class
 */

#ifndef Ext2Directory_h
#define Ext2Directory_h


#ifdef __GNUC__
#pragma interface
#endif

#include "endian_swap.h"
#include "MemoryObjectDictionary.h"
#include "PersistentMemoryObjectStar.h"
//#include "BSDDirectory.h"
const int MaxEntrySize_e2 = 255;
const int DirectoryBlockSize_e2 = 512;

class direct;

extern ProxiableObject * Ext2DirectoryConstructor( ProxiableObject * );
extern PersistentClassStar Ext2DirectoryClass;

class Ext2Directory : public MemoryObjectDictionary {
 protected:
    int _previousOffset;
    int _hint;

    int findKey( char * key, int neededSize );
    int basicKeys( char * buffer, int bufferSize, int & count );
    int basicAssociations( char * keyBuffer, int bufSize,
                           int & count );
    int basicAssociations( char * keyBuffer, int bufSize,
                           int & count, int & offset );

    int insertEntry( char * key, int keyLength, int idNumber );
    int entrySize( int keyLength );
    int hint();

    int clearEntry();

    ~Ext2Directory();
 public:
    Class * classOf();

    Ext2Directory( PersistentMemoryObject * source );
};

#endif  /*Ext2Directory_h*/
