/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Peter W. Madany (madany@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * FileIndex.h - User level file class
 */

#ifndef	FileIndex_h
#define	FileIndex_h


#ifdef __GNUC__
#pragma interface
#endif

#include "PersistentArray.h"
#include "FileIndexStar.h"

class FileSystemInterface;
extern ProxiableObject * FileIndexConstructor( ProxiableObject * );
extern PersistentClassStar FileIndexClass;
class FileIndex : public PersistentArray {
protected:
	~FileIndex();

	virtual	int findKey( char * index, int & status );
public:
	Class * classOf();

	FileIndex( PersistentMemoryObject * mo );

	int init( int argc, char *argv[], FileSystemInterface * = 0 );

		int at(     char * index, int & status );
		int atPut(  char * index, int value, int & status );
	virtual int atNext( char * index, int & status );
};

#endif /*FileIndex_h*/
