/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *       University of Illinois at Urbana-Champaign
 *       Department of Computer Science
 *       1304 W. Springfield Ave.
 *       Urbana, IL 61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *  All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Peter W. Madany (madany@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * FileSystem.h - file system error condition constants
 */

#ifndef FileSystem_h
#define FileSystem_h


#ifdef __GNUC__
#pragma interface
#endif

enum Status {
    Success = 0,
    BadUnixFilename,
    CantAcceptSocket,
    CantConnectToSocket,
    CantCreateDot,
    ContainerFull,
    DifferentContainers,
    DirectoryBusy,
    DirectoryHasKeys,
    DirectoryInvalid,
    EmptyFd,
    EndOfFile,
    FileAccessViolation,
    FileExists,
    IdNumberOutOfRange,
    InvalidArgument,
    InvalidPath,
    KeyExists,
    KeyNotFound,
    KeyTooSmall,
    KeyTooBig,
    MemoryObjectFull,
    MountPointBusy,
    NotAProgram,
    NoSuchContainer,
    NoSuchFd,
    NoSuchFile,
    NotEndOfFile,
    NotImplemented,
    NotSpecial,
    NumberOfArguments,
    ObjectNotMounted,
    OperationNotSupported,
    OutOfMemory,
    OutOfSpace,
    PartialRecordRead,
    ProtocolMismatch,
    ReadError,
    RecordExists,
    RecordNotFound,
    RecordSizeMismatch,
    SocketReadError,
    SocketWriteError,
    TooManyFiles,
    TooManyKeys,
    TooManySymbolicLinks,
    UnbalancedParentheses,
    UnknownNFSOp,
    UnusedIdNumber,
    WriteError,
    Zz
};

extern const char * StatusCodes[];

const int AccessExecute = 01;
const int AccessWrite = 02;
const int AccessRead  = 04;
const int AccessOwner = 010;
const int AccessMask  = AccessExecute|AccessWrite|AccessRead|AccessOwner;

#endif /*FileSystem_h*/
