/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987-1992
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * FileSystemLocks.h
 */

#ifndef FileSystemLocks_h
#define FileSystemLocks_h


#ifdef __GNUC__
#pragma interface
#endif

#include "Lock.h"
#include "Semaphore.h"

class Process;

class NestedLock {
      protected:
	Semaphore semaphore;
	Process * process;
	Lock lock;
	int nesting;
	int maxNesting;
      public:
	NestedLock( int count, int maxNesting = 32767 );
	void release();
	void acquire();
};

class MRSWLock {
      protected:
	Lock lock;
	int readers;
	int writers;
	int readersWaiting;
	int writersWaiting;
	Semaphore readerSem;
	Semaphore writerSem;
      public:
	MRSWLock();
	void acquireRead();
	void releaseRead();
	void acquireWrite();
	void releaseWrite();
};
 
#endif /*FileSystemLocks_h*/







