/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Peter W. Madany (madany@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * FixedRecordStream.h 
 */

#ifndef	FixedRecordStream_h
#define	FixedRecordStream_h


#ifdef __GNUC__
#pragma interface
#endif

#include "RecordStream.h"
#include "FileObjectStar.h"
#include "FixedRecordFileStar.h"

extern ProxiableObject * FixedRecordStreamConstructor( ProxiableObject * );
extern ClassStar FixedRecordStreamClass;
class FixedRecordStream : public RecordStream {
/*
 * FixedRecordStream defines sequential access to various kinds
 * of record-oriented files.
 */

protected:
	int			_recordSize;
	FixedRecordFileStar	_file;

	/* Method ~FixedRecordStream: destructor */
	~FixedRecordStream();
	
public:
	/* Method classOf: returns the Class of this object */
	Class * classOf();

	/* Method FixedRecordStream: constructor */
	FixedRecordStream( PersistentObject * mo );
	
	/* Method read: read up to size bytes of the next record */
	int read( char * buffer, int size, int & status );

	/* Method write: write a record of size bytes if at end of file */
	int write( char * buffer, int size, int & status );

	int recordSize();
};

#endif /*FixedRecordStream_h*/
