/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Douglas E. Leyens (leyens@cs.uiuc.edu)
 * Author: Peter W. Madany (madany@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * HashedBSDDirectory.h - hashed BSD directory class
 */

#ifndef	HashedBSDDirectory_h
#define HashedBSDDirectory_h


#ifdef __GNUC__
#pragma interface
#endif

#include "BSDDirectory.h"

class DIR_HASHTBL;

extern ProxiableObject * HashedBSDDirectoryConstructor( ProxiableObject * );
extern PersistentClassStar HashedBSDDirectoryClass;
class HashedBSDDirectory : public MemoryObjectDictionary {
protected:
	DIR_HASHTBL *	_hashTable;
	int		_chainNumber;
	int		_backOffset;
	int		_previousOffset;

	int		findKey( char * key, int );
	int		basicKeys( char * keyBuffer, int bufSize, int & count );
	int		basicAssociations( char * keyBuffer, int bufSize,
					   int & count );
	int		basicAssociations( char * keyBuffer, int bufSize,
					   int & count, int & offset );

	int		insertEntry( char * key, int keyLength, int idNumber );
	void		insertInFreeList( int size );
	int		entrySize( int keyLength );
	int		hint();
	int		dirHashName( char * key );
	int 		isSpace( int size );

	int		clearEntry();
	int		writeChanges();

	~HashedBSDDirectory();
public:
	Class * classOf();

	HashedBSDDirectory( PersistentMemoryObject * source );

	int add( char *, PersistentMemoryObject * );
};

#endif	/*HashedBSDDirectory_h*/
