/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Peter W. Madany (madany@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * MadFileNode.h - 
 */

#ifndef MadFileNode_h
#define MadFileNode_h


#ifdef __GNUC__
#pragma interface
#endif

#include "UNIXInode.h"

class MadNode;

extern ClassStar MadFileNodeClass;
class	MadFileNode : public UNIXInode {
protected:
	// Structures and functions that almost could be inherited
	MadNode *	_madNode;
	ClassStar 	_class;

        int     mapUnit( int logicalBlock, int addMapping );
	int	accessMode();

	~MadFileNode();

	Class *	supports( Class * );

	int	basicSetNumberOfBytes( int bytes );
	int	basicSetNumberOfUnits( unsigned int units );
        int     basicSetRecordSize( int recordSize );

public:
	Class * classOf();
	MadFileNode( unsigned int numberOfUnits, int log2UnitSize,
		     int inumber, MemoryObjectContainer *,
		     PersistentMemoryObject * source,
		     MadNode *, Class * );

        int     recordSize();
	int	numberOfBytes();
	int	links( int delta );
	void	info( UNIXFileInfo * );
};

#endif	MadFileNode_h
