#ifndef MadFileSystem_h
#define MadFileSystem_h

#ifdef __GNUC__
#pragma interface
#endif

class MadSuperBlock {
public:
	int	_log2BlockSize;
	int	_blockSize;

	int	_nodeSize;
	int	_nodesPerBlock;

	int	_superBlockStart;
	int	_classNameStart;

	int	_nodeMapStart;
	int	_blockMapStart;

	int	_nodeStart;
	int	_dataBlockStart;

	int	_blocks;
	int	_dataBlocks;
	int	_freeBlocks;

	int	_nodes;
	int	_freeNodes;

	int	_timeModified;
	int	_modified;

	int	_magicNumber;
};

class MadNode {
public:
	int	_size;
	int	_blocksAllocated;

	int	_sequenceNumber;
	int	_references;

	int	_createTime;
	int	_updateTime;
	int	_readTime;
	int	_writeTime;

        int     _ownerAccess;
        int     _updateAccess;
        int     _extendAccess;
        int     _readAccess;
        int     _lookupAccess;
        int     _executeAccess;

        int     _pad;

	char	_persistentStoreClass;
	char	_persistentObjectClass;

        short   _recordSize;
	int	_blocks[16];
};
#define roundup(e1,e2)  ( ( (e1) + (e2)  - 1 ) / (e2) )
const int MadMagic = 0xf106beef;
const int MadNodeMagic = 0xd111feed;
const int SuperBlockOffset = 8192;
const int ClassNameListSize = 8192;
#endif /*MadFileSystem_h*/
