/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *               University of Illinois at Urbana-Champaign
 *               Department of Computer Science
 *               1304 W. Springfield Ave.
 *               Urbana, IL     61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *      All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Peter W. Madany (madany@cs.uiuc.edu)
 * Author: Daniel E. Weber (weber@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * Mail.h - Mail File System Header Class
 */

#ifndef Mail_h
#define Mail_h


#ifdef __GNUC__
#pragma interface
#endif

const char * const MailFromAttrib = "From";
const char * const MailToAttrib = "To";
const char * const MailSubjectAttrib = "Subject";
const char * const MailDateAttrib = "Date";
const int MailFromSize = 4;
const int MailToSize = 2;
const int MailSubjectSize = 7;
const int MailDateSize = 4;

const char * const MailFromInitMagic = "From ";
const char * const MailFromMagic = "\nFrom ";
const char * const MailToMagic = "\nTo: ";
const char * const MailSubjectMagic = "\nSubject: ";
const int MailFromMagicSize = 6;
const int MailToMagicSize = 5;
const int MailSubjectMagicSize = 10;

class MailHeader {
	friend class MailContainer;
	friend class MailRootEntry;
	friend class MailEntry;

	char	*date;			// Received date of mail:
	char	*from;			// Sender of mail:
	char	*subject;		// Subject of mail:
	char	*to;			// Mail addressed to:
	int	position;		// Begining position of mail.
	int	size;			// Size of entire message.
	int	lines;			// Number of lines in message.
};

#endif Mail_h
