/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Peter W. Madany (madany@cs.uiuc.edu)
 * Author: Daniel E. Weber (weber@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * MailRootEntry.h - Mail Directory Entry (inode) class
 */

#ifndef MailRootEntry_h
#define MailRootEntry_h


#ifdef __GNUC__
#pragma interface
#endif

#include "RootEntry.h"

extern ClassStar MailRootEntryClass;


const int DirNameSize = 14;

class direct {
        friend class MailRootEntry;

        short   d_ino;
        char    d_name[DirNameSize];
};

class MailRootEntry : public RootEntry {
protected:
	int		_entries;
	direct *	_mailDirectoryArray;

	~MailRootEntry();
public:
	Class *	classOf();

	MailRootEntry ( int inumber,
			MemoryObjectContainer * container,
			PersistentMemoryObject * source,
			int messages );

	int	read( unsigned int offset, int length, char *, int );
};

#endif	MailRootEntry_h
