/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Peter W. Madany (madany@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * MountTable.h - part of a mount table
 */

#ifndef MountTable_h
#define MountTable_h


#ifdef __GNUC__
#pragma interface
#endif

#include "ProxiableObject.h"
#include "PersistentMemoryObjectStar.h"
#include "MemoryObjectDictionaryStar.h"

class MountItem;
class Class;

extern ClassStar MountTableClass;
class MountTable : public ProxiableObject {
protected:
	MountItem *	_mountItems;
	~MountTable();
public:
	Class *	classOf();

	MountTable();
	MountTable( MountTable * );

	int	synchronize();

	int	addMount( PersistentMemoryObjectRef const mountPoint,
			  PersistentMemoryObjectRef const mountDirectory );
	int	deleteMount( PersistentMemoryObject * );

	void substitute( PersistentMemoryObjectRef  );
	void substituteUp( MemoryObjectDictionaryRef, char * key );
};

#endif /*MountTable_h*/
