/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Peter W. Madany (madany@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * POSHBlockAllocator.h - 
 */

#ifndef POSHBlockAllocator_h
#define POSHBlockAllocator_h


#ifdef __GNUC__
#pragma interface
#endif

#include "BlockAllocator.h"

class MemoryObject;
class POSHSuperBlock;

extern ClassStar POSHBlockAllocatorClass;
class POSHBlockAllocator : public BlockAllocator {
protected:
	POSHSuperBlock * _superBlock;
	unsigned char *	_blockMap;
	int		_log2BlockToSector;

	int		basicAllocate( int &, int, int );
	void		basicFree( int &, int physicalUnit, int );

public:
	Class * classOf();

	POSHBlockAllocator( MemoryObject * source, POSHSuperBlock * superBlock,
			    unsigned char * blockMap, int log2BlockToSector );
};

#endif POSHBlockAllocator_h
