#ifndef POSHFileSystem_h
#define POSHFileSystem_h


#ifdef __GNUC__
#pragma interface
#endif

class POSHSuperBlock {
public:
	int	_log2BlockSize;
	int	_blockSize;

	int	_nodeSize;
	int	_nodesPerBlock;

	int	_superBlockStart;
	int	_classNameStart;

	int	_nodeMapStart;
	int	_blockMapStart;

	int	_nodeStart;
	int	_dataBlockStart;

	int	_blocks;
	int	_dataBlocks;
	int	_freeBlocks;

	int	_nodes;
	int	_freeNodes;

	int	_timeModified;
	int	_modified;

	int	_magicNumber;
};

class POSHNode {
public:
	short	_size;
	short	_persistentObjectClass;
	int	_block;
};
#define roundup(e1,e2)  ( ( (e1) + (e2)  - 1 ) / (e2) )
const int POSHMagic = 0xbeeff106;
const int POSHNodeMagic = 0xd111feed;
const int POSHSuperBlockOffset = 8192;
const int POSHClassNameListSize = 8192;
#endif /*POSHFileSystem_h*/
