/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Peter W. Madany (madany@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * POSHVariable.h - User level file class
 */

#ifndef	POSHVariable_h
#define	POSHVariable_h


#ifdef __GNUC__
#pragma interface
#endif

#include "POSHExpression.h"
#include "POSHVariableStar.h"

extern ProxiableObject * POSHVariableConstructor( ProxiableObject * );
extern PersistentClassStar POSHVariableClass;
class POSHVariable : public POSHExpression {
protected:
	~POSHVariable();
	char _value[232];
public:
	Class * classOf();

	POSHVariable( PersistentMemoryObject * mo );

        int init( int argc, char *argv[], FileSystemInterface * );

	POSHExpressionRef eval( FileSystemInterface *, int & status );
	void printOn( OutputStream * );
};

#endif POSHVariable_h
