/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Lee Lup Yuen (lup@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * PersistentArrayStream.h 
 */

#ifndef	PersistentArrayStream_h
#define	PersistentArrayStream_h


#ifdef __GNUC__
#pragma interface
#endif

#include "RecordStream.h"
#include "FileObjectStar.h"
#include "PersistentArrayStar.h"

extern ProxiableObject * PersistentArrayStreamConstructor( ProxiableObject * );
extern ClassStar PersistentArrayStreamClass;
class PersistentArrayStream : public RecordStream {
/*
 * PersistentArrayStream defines sequential access to various kinds
 * of record-oriented files.
 */

protected:
	/* Method ~PersistentArrayStream: destructor */
	~PersistentArrayStream();
	
	PersistentArrayStar	_file;
public:
	/* Method classOf: returns the Class of this object */
	Class * classOf();

	/* Method PersistentArrayStream: constructor */
	PersistentArrayStream( PersistentArray * );
	
	/* Method read: read up to size bytes of the next record */
	int read( char * buffer, int size, int & status );

	/* Method write: write a record of size bytes if at end of file */
	int write( char * buffer, int size, int & status );
};

#endif /*PersistentArrayStream_h*/
