/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Peter W. Madany (madany@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * PersistentIntArray.h - User level file class
 */

#ifndef	PersistentIntArray_h
#define	PersistentIntArray_h


#ifdef __GNUC__
#pragma interface
#endif

#include "PersistentArray.h"
#include "PersistentIntArrayStar.h"

class FileSystemInterface;
extern ProxiableObject * PersistentIntArrayConstructor( ProxiableObject * );
extern PersistentClassStar PersistentIntArrayClass;
class PersistentIntArray : public PersistentArray {
protected:
	~PersistentIntArray();
public:
	Class * classOf();

	PersistentIntArray( PersistentMemoryObject * mo );

	int init( int argc, char *argv[], FileSystemInterface * = 0 );

	int at(    unsigned int index );
	int atPut( unsigned int index, int value );
};

#endif /*PersistentIntArray_h*/
