/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Peter W. Madany (madany@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * RecordFile.h - User level file class
 */

#ifndef	RecordFile_h
#define	RecordFile_h


#ifdef __GNUC__
#pragma interface
#endif

#include "AutoloadPersistentObject.h"
#include "RecordFileStar.h"
#include "PersistentArrayStar.h"

extern PersistentClassStar RecordFileClass;
class RecordFile : public AutoloadPersistentObject {
protected:
	~RecordFile();

	PersistentArrayStar	_data;

 	unsigned int		_minRecordSize;
 	unsigned int		_maxRecordSize;
public:
	Class * classOf();

	RecordFile( PersistentMemoryObject * mo );

	int init( int argc, char *argv[], FileSystemInterface * = 0);
	void flush();

	virtual int read(  unsigned int record, char * buffer,
			   unsigned int size, int & status );
	virtual int write( unsigned int record, char * buffer,
			   unsigned int size, int & status );

	virtual unsigned numberOfRecords();

	virtual unsigned minimumRecordSize();
	virtual unsigned maximumRecordSize();
};

#endif /*RecordFile_h*/
