/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Swee Boon Lim (sblim@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * RemoteContainer.h - unix inode system abstract Class
 */

#ifndef RemoteContainer_h
#define RemoteContainer_h

#ifdef __GNUC__
#pragma interface
#endif

#include "MemoryObjectCachingContainer.h"
#include "RemoteFileSystem.h"
#include "RemoteTables.h"

extern PersistentClassStar RemoteContainerClass;

class RemoteContainer : public MemoryObjectCachingContainer {
private:
	RFSContainerHandle _handle;
	RemoteContainerRegistryInfo _info;

protected:
	FileObject * basicOpen( int idNumber, int & status, int flags );
	FileObject * basicCreate( int hint, Class *, int & status, int flags );
	void basicClose( FileObject * fo );
	void basicSynchronize();
	void basicSynchronize( int idNumber );
	int basicRootId();
	void noRemainingReferences();	

public:
	Class * classOf();

	RemoteContainer( RFSContainerHandle & handle );
	~RemoteContainer();

	void unreference();

	FileObjectRef fastOpen( RFSHandle & handle, RFSAttributes & attributes,
				int & status, int flags, int create );
	RFSContainerHandle * handle() { return & _handle; }
	RemoteContainerRegistryInfo * registryInfo() { return & _info; }
};

#endif RemoteContainer_h
