/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * RemoteDictionary.h
 */

#ifndef RemoteDictionary_h
#define RemoteDictionary_h

#ifdef __GNUC__
#pragma interface
#endif

#include "MemoryObjectDictionary.h"
#include "RemoteFileObject.h"

class RFSHandle;

extern PersistentClassStar RemoteDictionaryClass;

class RemoteDictionary : public MemoryObjectDictionary {
protected:
    RemoteFileObject * rfo() { return (( RemoteFileObject * ) _source); }
    RFSHandle * handle() { return rfo()->handle(); }

    virtual void reMap();

public:
    Class * classOf();

    RemoteDictionary( PersistentMemoryObject * source );
    ~RemoteDictionary();

    virtual PersistentMemoryObjectRef open( char * key, int & status,
					    int flags );
    virtual PersistentMemoryObjectRef create( char * key, Class *, 
					      int & status, int flags);
    virtual int add( char * key, PersistentMemoryObject * );
    virtual int remove( char * key, int * links = 0 );
    virtual int keys( char * buffer, int bufferSize, int & count );
    virtual int keySize();
    virtual int	associations( char * buffer, int bufferSize,
			      int & count );
    virtual int	associations( char * buffer, int bufferSize,
			      int & count, int & offset );
    virtual int sharesContainer( PersistentMemoryObject * pmo );
};

#endif RemoteDictionary_h
