/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Swee Boon Lim (sblim@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * ResourceLock.h
 */

#ifndef ResourceLock_h
#define ResourceLock_h

#ifdef __GNUC__
#pragma interface
#endif

#include "BlockedInfo.h"
#include "Lock.h"
#include "Object.h"

class Process;
class ProxiableObject;

class ResourceLock : public Object
{
      protected:
	class _WaitInfo : public BlockedInfo {
	      public:
		unsigned amount() { return _buf[0]; }
		void setAmount( unsigned i ) { _buf[0] = i; }
	};

	Lock _lock;
	int _max;
	int _inUse;
	int _active;
	int _waiting;
	int _maxActive;
	int _maxWaiting;
	BlockedInfoList _blocked;

      public:
	ResourceLock( int max );
	void acquire( int amount );
	void release( int amount );
	int waiting() { return _waiting; }
};

#endif ResourceLock_h

