/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Douglas E. Leyens (leyens@cs.uiuc.edu)
 * Author: Peter W. Madany (madany@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * RootEntry.h - Directory Entry (inode) class
 */

#ifndef RootEntry_h
#define RootEntry_h


#ifdef __GNUC__
#pragma interface
#endif

#include "FileObject.h"

extern ClassStar RootEntryClass;
class RootEntry : public FileObject {
protected:
	ClassStar	_supports;

	int		accessMode();

public:
	Class * classOf();

	RootEntry( unsigned int numberOfUnits,
		   int log2UnitSize,
		   int inumber,
		   MemoryObjectContainer * container,
		   PersistentMemoryObject * source,
		   Class * supports,
		   int offset = 0 );

	Class * supports( Class * );
	int	isDictionary();
	void	info( UNIXFileInfo * );
};

#endif	/*RootEntry_h*/
