/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Peter W. Madany (madany@cs.uiuc.edu)
 * Contributing Author: Douglas E. Leyens (leyens@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * SVIDAllocator.h - inode system superClass
 */

#ifndef SVIDAllocator_h
#define SVIDAllocator_h


#ifdef __GNUC__
#pragma interface
#endif

#include "BlockAllocator.h"

class MemoryObject;
class filsys;

extern ClassStar SVIDAllocatorClass;
class SVIDAllocator : public BlockAllocator {
protected:
    filsys * _superBlock;
    int _log2FragmentToSector;

    virtual int	basicAllocate( int &, int, int );
    virtual void basicFree( int &, int physicalUnit, int );

public:
    Class * classOf();

    SVIDAllocator( MemoryObject * source, filsys * superBlock,
		   int log2FragmentToSector );
};

#endif SVIDAllocator_h
