/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Peter W. Madany (madany@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * SVIDVersionedDirectory.h - SVID Versioned Directory class
 */
#ifndef	SVIDVersionedDirectory_h
#define SVIDVersionedDirectory_h


#ifdef __GNUC__
#pragma interface
#endif

#include "SVIDDirectory.h"

extern ProxiableObject * SVIDVersionedDirectoryConstructor( ProxiableObject * );
extern PersistentClassStar SVIDVersionedDirectoryClass;
class SVIDVersionedDirectory : public SVIDDirectory {
protected:
	int	findKey( char * key, int neededSize );
	int     basicKeys( char * buffer, int bufferSize, int & count );
	int	insertEntry( char * key, int keyLength, int idNumber );

	int	getVersion( char * key, int & markPostition );
	int	nthHighestVersion( char * key, int keyLength, int n );
	int	nextHigherVersion( char * key, int version );
	void	insertVersion( int version, short * versions, int & count, int n );

	~SVIDVersionedDirectory();
public:
	Class * classOf();

	SVIDVersionedDirectory( PersistentMemoryObject * source );
};

#endif	SVIDVersionedDirectory_h
