/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Peter W. Madany (madany@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * SymbolicLink.h - symbolic link class.
 */

#ifndef	SymbolicLink_h
#define	SymbolicLink_h


#ifdef __GNUC__
#pragma interface
#endif

#include "SymbolicLinkStar.h"
#include "PersistentArray.h"
#include "PersistentMemoryObjectStar.h"

extern ProxiableObject * SymbolicLinkConstructor( ProxiableObject * );
extern PersistentClassStar SymbolicLinkClass;
class SymbolicLink : public PersistentArray {
/*
 * SymbolicLinks are objects that allow the storage and retrieval of a single
 * path name.  
 */

public:
	/* Method classOf: returns the Class of this object */
	Class * classOf();

	/* Method SymbolicLink: constructor */
	proxiable SymbolicLink( PersistentMemoryObject * mo );
};

#endif /*SymbolicLink_h*/
