/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989 The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Lun Xiao (xiao@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * TarContainer.h - Tar Inode System class
 *
 *	$Header: /projects/choices/old/cvsroot/choices/Includes/FileSystems/Tar.h,v 1.1 2004/06/03 01:58:43 jcarlyle Exp $
 */

#ifndef Tar_h
#define Tar_h


#ifdef __GNUC__
#pragma interface
#endif

#define TBLOCK	512
#define NAMSIZ  100
class tar_hdr {
public:
	char	tar_name[NAMSIZ];
	char	tar_mode[8];
	char	tar_uid[8];
	char	tar_gid[8];
	char	tar_size[12];
	char	tar_mtime[12];
	char	tar_chksum[8];
 	char    linkflag;
	char    linkname[NAMSIZ];
};
class tar_hblock {
	friend class TarContainer;
	friend class TarDictionary;
	friend class TarEntry;
        
	tar_hdr dbuf;
	char   dummy[255];
};

const int TarchiveHeaderSize = TBLOCK;

#endif Tar_h
