/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989 The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Lun Xiao (xiao@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * TarContainer.h - Tar Inode System Class
 *
 *	$Header: /projects/choices/old/cvsroot/choices/Includes/FileSystems/TarContainer.h,v 1.1 2004/06/03 01:58:43 jcarlyle Exp $
 */

#ifndef TarContainer_h
#define TarContainer_h


#ifdef __GNUC__
#pragma interface
#endif

#include "MemoryObjectContainer.h"
#include "Tar.h"

extern ProxiableObject * TarContainerConstructor( ProxiableObject * );
extern PersistentClassStar TarContainerClass;
class TarContainer : public MemoryObjectContainer {
protected:
	FileObjectStar	_byteSource;
	tar_hblock *	_tar;
	int *           _lengths;
	int *		 _offsets;
	int		 _valid;

	FileObject * basicOpen( int idNumber, int & status, int flags );

	~TarContainer();
public:
	Class * classOf();

	TarContainer( PersistentMemoryObject * source );
};

#endif TarContainer_h
