/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987-1992
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * VCDictionary.h - abstract superclass for directories
 */

#ifndef VCDictionary_h
#define VCDictionary_h


#ifdef __GNUC__
#pragma interface
#endif

#include "PersistentObject.h"
#include "MemoryObjectDictionary.h"

class VCFileObject;


extern ClassStar VCDictionaryClass;
class VCDictionary : public MemoryObjectDictionary {
   
    PersistentMemoryObjectRef openOrCreate( char * key, int createNew, 
					    int & status );

	friend class VCFileObject;
protected:

    VCFileObject * _source;

#ifdef NEVER
    VCFileObjectRef _root;		// root of this UNIX mount tree
					// passed around way too much,
					// but that's life without VC
					// containters.
#endif

    void noRemainingReferences();

public:
    Class * classOf();

    VCDictionary( PersistentMemoryObject * source);

    ~VCDictionary();

    virtual PersistentMemoryObjectRef open( char * key, int & status, int
    flags = 0);

    virtual PersistentMemoryObjectRef create( char * key, Class *, int & sts,
    int flags = 0);

    virtual int remove( char * key , int *links);

    virtual int keys( char * buffer, int bufferSize, int & count );

    // virtual int sharesContainer( PersistentMemoryObject * );
    // static void initializeTable(); 
    char * mypath();
};

#endif // VCDictionary_h
