/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Vincent F. Russo (russo@cs.uiuc.edu)
 * Author: Gary M. Johnston (johnston@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * FreeRunningTimer.h: Class to lookup the time in microseconds since Choices
 *		       was started. This is really only useful for debugging
 *		       and timing since the timer rolls every so often.
 *		       This is the machine-independent parent class.
 */

#ifndef FreeRunningTimer_h
#define FreeRunningTimer_h

#ifdef __GNUC__
#pragma interface
#endif


#include "ProxiableObject.h"	/* parent class */
class FreeRunningTimerStar;

extern ClassStar FreeRunningTimerClass;

class FreeRunningTimer : public ProxiableObject {
public:
	Class * classOf();
	/* time() returns time in microseconds */
	/*   and must be redefined by subclass */
	proxiable virtual unsigned int time();
};

extern FreeRunningTimerStar SystemTimer;

#endif /* FreeRunningTimer_h */
