/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Panagiotis Kougiouris (kougiour@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

#ifndef BufferedLogicalDevice_h
#define BufferedLogicalDevice_h


#ifdef __GNUC__
#pragma interface
#endif

#include "CharacterQueue.h"
#include "InputLogicalDevice.h"


class BufferedInputLogicalDevice: public InputLogicalDevice {
protected:

	CharacterQueue * inputCharQueue;

public:
	/* The constructor of a echo logical  device. The SerialDevice is the
	 * actual device passed to the superclass. The type is the type
	 * of the queue.
	 */
	BufferedInputLogicalDevice( SerialDevice *, unsigned short theQueueType = 0 );

	void 
	setAttributes( int type);

	unsigned short
	charPending();

	char
	getChar();

	int
	read( char *, int );

	void
	inputInterruptHandle();

};
#endif	/* BufferedInputLogicalDevice_h */
