/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Bjorn A. Helgaas (helgaas@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 *
 *
 * NullStreams.h: 
 */

#ifndef NullStreams_h
#define NullStreams_h


#ifdef __GNUC__
#pragma interface
#endif

#include "InputStream.h"
#include "OutputStream.h"

class NullInputStream : public InputStream {
public:
	virtual int read( char * buffer, int count );
};

class NullOutputStream : public OutputStream {
public:
	virtual void acquireExclusiveUse();
	virtual void releaseExclusiveUse();
	virtual int write( const char * buffer, int count );
};

extern NullInputStream TheNullInputStream;
extern NullOutputStream TheNullOutputStream;

#endif /* NullStreams_h */
