/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Bjorn A. Helgaas (helgaas@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * SerialLine.h: 
 */

#ifndef SerialLine_h
#define SerialLine_h


#ifdef __GNUC__
#pragma interface
#endif

#include "Assert.h"
#include "ProxiableObject.h"

extern ClassStar SerialLineClass;

class SerialLine : public ProxiableObject  {
public:
	SerialLine();

	virtual unsigned int basicRead( char * buffer, unsigned int length );
	virtual unsigned int basicWrite( const char * string,
		unsigned int length );

	virtual int readBufferFull();
	virtual int writeBufferEmpty();

	virtual int setInterruptVectors( int );
	virtual int disableReadInterrupts();
	virtual int disableWriteInterrupts();
	virtual void enableReadInterrupts();
	virtual void enableWriteInterrupts();

	virtual unsigned int read( char * buffer, unsigned int length );
	virtual unsigned int write( const char * string, unsigned int length );

	Class * classOf();
};

inline
SerialLine::SerialLine()
{
}

inline unsigned int
SerialLine::basicRead( char *, unsigned int )
{
	Assert( NOTREACHED );
	return( 0 );
}

inline unsigned int
SerialLine::basicWrite( const char *, unsigned int )
{
	Assert( NOTREACHED );
	return( 0 );
}

inline int
SerialLine::readBufferFull()
{
	Assert( NOTREACHED );
	return( 1 );
}

inline int
SerialLine::writeBufferEmpty()
{
	Assert( NOTREACHED );
	return( 1 );
}

inline int
SerialLine::setInterruptVectors( int )
{
	Assert( NOTREACHED );
	return( 0 );
}

inline int
SerialLine::disableReadInterrupts()
{
	Assert( NOTREACHED );
	return( 0 );
}

inline int
SerialLine::disableWriteInterrupts()
{
	Assert( NOTREACHED );
	return( 0 );
}

inline void
SerialLine::enableReadInterrupts()
{
	Assert( NOTREACHED );
}

inline void
SerialLine::enableWriteInterrupts()
{
	Assert( NOTREACHED );
}

inline unsigned int
SerialLine::read( char *, unsigned int )
{
	Assert( NOTREACHED );
	return( 0 );
}

inline unsigned int
SerialLine::write( const char *, unsigned int )
{
	Assert( NOTREACHED );
	return( 0 );
}

#endif /* SerialLine_h */
