/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987-1992
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * InstrumentFormat.h: anything which parsing programs might neeed
 *
 */

#ifndef InstrumentFormat_h
#define InstrumentFormat_h


#ifdef __GNUC__
#pragma interface
#endif

#ifdef INSTRUMENT

/* This is the format of the header on all instrument events. */
struct iIdentifierType {

	// Is this the birth or death of an instrument
	// This is a wierd field which may have other meanings
	unsigned int special : 1;

	// Is there a count field
	unsigned int count : 1;

	// Is there a delta time field
	unsigned int time : 1;

	// Is there a message
	unsigned int message : 1;

	// Are we sure this ran only on one cpu
	unsigned int percpu : 1;

	// Are we sure this is data from only one process
	unsigned int perprocess : 1;

	// Is this a system or user level instrument
	unsigned int mode: 1;

	// For some other ideas that I have
	unsigned int unused: 1;

	// Who is the instrument manager
	unsigned int ownerid : 8;

	// Which instrument is this
	unsigned int selfid : 16;

	// The constructor
	iIdentifierType ()  { unused = 0; }
};

#endif INSTRUMENT
#endif InstrumentFormat_h
