/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987-1992
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * InstrumentTranscript.h: InstrumentTranscript class description
 */

#ifndef InstrumentTranscript_h
#define InstrumentTranscript_h


#ifdef __GNUC__
#pragma interface
#endif

#include "Object.h"

extern ClassStar InstrumentTranscriptClass;

class InstrumentTranscript : public Object
{
public:
    virtual void write (const char *str) = 0;
    //  This is an ugly kludge: g++ on the Multimax has a bug with float
    //  parameters in methods, so we have to pass a float as a rational
    //  number.
    virtual void write (int numerator, int denominator) = 0;
    Class *classOf ();
};

// ----------------------------------------------------------------------------

extern ClassStar InstantTranscriptClass;

class InstantTranscript : public InstrumentTranscript
{
public:
    InstantTranscript ();
    void write (const char *str);
    void write (int numerator, int denominator);
    Class *classOf ();
private:
    OutputStream *console;
};

// ----------------------------------------------------------------------------

extern ClassStar DelayedTranscriptClass;

class DelayedTranscript : public InstrumentTranscript
{
public:
    void write (const char *str) {}
    void write (int numerator, int denominator) {}
    Class *classOf ();
};

#endif
