/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987-1992
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * UserInstrumentManager.h: non-OS instrument manager
 */


#ifndef UserInstrumentManager_h
#define UserInstrumentManager_h


#ifdef __GNUC__
#pragma interface
#endif

#ifdef INSTRUMENT

#include "Types.h"
#include "InstrumentManager.h"
#include "SystemInstrumentManager.h"

extern ClassStar UserInstrumentManagerClass;
extern SystemInstrumentManager *TheInstrumentManager;

class UserInstrumentManager : public InstrumentManager {
public:

	/* Method UserInstrumentManager:	The constructor.	*/
	proxiable UserInstrumentManager (char *title, unsigned int instrumentAlloc);

	/* Method ~UserInstrumentManager:	The destructor.		*/
	proxiable ~UserInstrumentManager ();

	/* Method time:			Returns the system time.	*/
	proxiable virtual timeType time ();
	
	/* Method writeLogBuffer:	Write data to the buffer.	*/
	proxiable virtual void writeLogBuffer (unsigned int dataLength, 
			char *data,
		        unsigned int eventID,
			unsigned int messageLength = 0, char *message = NULL);

        Class *classOf ();
};

#endif INSTRUMENT
#endif 
