/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Vincent F. Russo (russo@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * Interrupt.h: event class description.
 */

#ifndef Interrupt_h
#define Interrupt_h


#ifdef __GNUC__
#pragma interface
#endif

#include "Object.h"	/* parent class */

/*
 * The parent interrupt class. Defines what interrupt look like to the
 * rest of the system.
 */
extern ClassStar InterruptClass;
class Interrupt : public Object {
	Interrupt *	_next;
protected:
	virtual void basicRaise( char * info ) = 0;
public:
	Interrupt();
	Class * classOf();

	Interrupt* next() {return _next;}
	void setNext(Interrupt *e) {_next = e;}
	Interrupt * stack(Interrupt *e);

	void raise( char * info = 0 );
};

#endif /* Interrupt_h */
