/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991, 2005
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Ellick Chan (emchan@uiuc.edu)
 * Author: David Raila (raila@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * Kernel.h: Kernel description class.
 */

#ifndef KernelCmdInstaller_h
#define KernelCmdInstaller_h

#ifdef __GNUC__
#pragma interface
#endif

#include "Object.h"
#include "Types.h"
#include <map>
#include <string>
using namespace std;

class OutputStream;
extern OutputStream * ConsoleOutputStream;

class KernelCmd;
extern ClassStar KernelCmdInstallerClass;
class KernelCmdInstaller //: public Object {  (vtable stuff causes problems)
{
public:
	KernelCmdInstaller() { }
	~KernelCmdInstaller(); 

	void printCommands();
	void runWithPrefix(char* prefix);
	void runTests();
	
	KernelCmd* find(string name);

	//static methods
	static KernelCmd* installCmd(KernelCmd* cmd);
	static KernelCmdInstaller* getCmdInstaller() { return self; }
	static KernelCmdInstaller* setCmdInstaller(KernelCmdInstaller* k) { return self = k; }

	Class * classOf();
protected:
	static KernelCmdInstaller* self;
	map<string, KernelCmd*> _kernelCommands;
};

class KernelCmd //: public Object (see above)
{
public:
	KernelCmd(Object* obj, OPFV entry, char* name, char* description);
	KernelCmd(PFV entry, char* name, char* description);

	char* getName() { return myName; }
	char* getDescription() { return myDescription; }
	void execute();

private:
	KernelCmd();
	char* myName;
	char* myDescription;

	Object* object;
	OPFV entryPoint;
	PFV fentry;
};


#endif /* KernelCmdInstaller_h */
