/*
 */

#ifndef Byte_h
#define Byte_h

#ifdef __GNUC__
#pragma interface
#endif

#if defined(SPARC) || defined(ARM)
#include <string.h>

inline 
void
ByteCopy( const void * source, void * destination, int length )
{
	memcpy(destination, source, length);
}

inline 
int
ByteCompare( const void * source, const void * destination, int length )
{
    return (memcmp(destination, source, length));
}

inline 
void
ByteZero(void * destination, int length )
{
	memset(destination, 0, length);
}

#else
extern void ByteCopy( const void * source, void * destination, int length );
extern int  ByteCompare( const void * b1, const void * b2, int length );
extern void ByteZero( void * b, int length );
#endif

#endif
