#ifndef GPInclude_h
#define GPInclude_h

#ifdef __GNUC__
#pragma interface
#endif


#include "FormatAssists.h"


#ifdef UNIX_GP

/*
 * GP libs under UNIX
 */

#include <stream.h>
#define Console() cout
inline void operator << ( ostream &, Flush ){ }

#elif GPLIBS
/*
 * GP libs under choices, no console output, make a sink Console class
 * to suck up the output
 */

#define Console while(0) DataSink



class Object;

/*
 * An OutputStream-like object that *should* compile away to nothing.
 * An instance of this is used for a debugging sink when DEBUG is not
 * defined.
 */
class DataSink {
public:
	DataSink(){}
	inline const DataSink operator << ( const void * ) const{return DataSink();}
	inline const DataSink operator << ( int ) const{return DataSink();}
	inline const DataSink operator << ( unsigned int ) const{return DataSink();}
	inline const DataSink operator << ( Object * ) const{return DataSink();}
	inline const DataSink operator << ( Object & ) const{return DataSink();}
	inline const DataSink operator << ( ProxiableObjectRef & ) const{return DataSink();}
	inline const DataSink operator << ( ProxiableObjectStar & ) const{return DataSink();}
	inline const DataSink operator << ( char ) const{return DataSink();}
	inline void printf ( const char * f,
		const formatArgs & a1 = *(formatArgs *)0,
		const formatArgs & a2 = *(formatArgs *)0,
		const formatArgs & a3 = *(formatArgs *)0,
		const formatArgs & a4 = *(formatArgs *)0 ) const {}

	inline const DataSink operator << ( asHex & )     const { return DataSink(); }
	inline const DataSink operator << ( asAddress & ) const { return DataSink(); }
	inline const DataSink operator << ( asOctal & )   const { return DataSink(); }
	inline const DataSink operator << ( asBits & )    const { return DataSink(); }
	inline void operator << ( Flush )     const {}
};

#endif /* UNIX_GP */

#endif /* GPInclude_h */
