/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989 The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Aamod Sane (sane@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * IteratingList.h - List with a iterator
 *
 *	$Header: /projects/choices/old/cvsroot/choices/Includes/Libraries/GeneralPurpose/IteratingList.h,v 1.1 2004/06/03 01:58:43 jcarlyle Exp $
 */

#ifndef IteratingList_h
#define IteratingList_h

#ifdef __GNUC__
#pragma interface
#endif


#include "List.h"
 
class LinkIterator;
 
class IteratingList : public HintList {
  protected:
    LinkIterator * _iterator;
  public:
    IteratingList();
    IteratingList(Link * l, int existingItems);
    virtual ~IteratingList();
    
    void add( Link* newEntry, Link* oldEntry, int before=0 );
    Link*  remove( Link* newEntry, int nth=0 );
    void destroy();
    
    Link * next(); 
    Link * current();
    void reset();
    void rewind();
};

#endif /* IteratingList_h */
