/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987-1992
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * SPARCasmutil.h: Process context for a SPARC.
 */

#ifndef __LLVAEXECENGINE_asmutil_h
#define __LLVAEXECENGINE_asmutil_h

#ifdef __GNUC__
#pragma interface
#endif


#ifndef ASM

#define BSTRINGIZE(a...) #a
#define STRINGIZE(a...) BSTRINGIZE( a )

#define STORE_X86_PC(var)  \
	asm volatile ("call store_x86_pc; \
                       jmp done_x86_pc; \
                       store_x86_pc: \
		       mov 4(%%esp), %%eax; \
                       ret; \
                       done_x86_pc: \
                       mov %%eax, %0" : "=r"(var) : ); 

#define LOAD_X86_PC(var)  \
	asm volatile ("call load_x86_pc; \
                       load_x86_pc: \
		       mov %0, 4(%%esp); \
                       ret;" : : "r"(var)); 

#define LOAD_REG_FROM_MEM(reg, var, clobber...)  \
	asm volatile ( STRINGIZE(mov %0,%reg) : : "r" (var)); 

#define LOAD_REG_FROM_MEM_DOUBLE(reg1, var) \
	asm volatile ( STRINGIZE(movd %0,%reg1) : : "r" (var) );

#define STORE_REG_TO_MEM(reg, var, clobber...) \
	asm volatile(STRINGIZE(mov %reg,%0) : "=r" (var) : );

#define FORCE_USE(var) \
	asm volatile("mov %0,%%g0" : : "r" (var));

#endif /*ASM*/
#endif /* __LLVAEXECENGINE_asmutil_h  */
