/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Lee Lup Yuen (lup@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * Math.h - Portable math routines.
 */

#ifndef Math_h
#define Math_h
#ifdef __GNUG__
#pragma interface
#endif

//  frexp, ldexp and modf are dependent on floating-point format used.
double frexp (double, int *);
double ldexp (double, int);
double modf (double, double*);

int abs (int);
double floor (double);
double ceil (double);
double fabs (double);

double log (double);
double log10 (double);
double pow (double, double);
double exp (double);
double sqrt (double);

double sin (double);
double cos (double);
double tan (double);
double asin (double);
double acos (double);
double atan (double);

double polevl (double, double [], int);
double p1evl (double, double [], int);
int mtherr (char *, int);

extern double MAXLOG, MINLOG, MAXNUM, PI, PIO2, PIO4, SQRT2, SQRTH, LOG2E,
    SQ2OPI, LOGE2, LOGSQ2, THPIO4, TWOOPI;

enum
{
    DOMAIN = 1,
    SING,
    OVERFLOW,
    UNDERFLOW,
    TLOSS,
    PLOSS,
//  Unix Library
    EDOM,
    ERANGE
};

#endif
