/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Peter W. Madany (madany@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * Allocator.h: definition of a Big Bag-o-Pages heap class.
 * Much of this copied from MadAllocator in the kernel.
 */
/*
 */

#ifndef Allocator_h
#define Allocator_h

#include "new.h"

class Semaphore;

/*
 * The generic allocator class.
 */
/*class Allocator {
protected:
public:
	virtual void * allocate( unsigned int nbytes );
	virtual void free( void * cp );
	Allocator();
	virtual ~Allocator();
};*/

class BucketAllocator {
protected:
	int		_log2PageSize;
	char *		_baseAddress;
	char *		_upperBoundAddress;
	char *		_pageToBucket;
	Semaphore*	_bucketMutex[32];
	char *		_bucketToPage[32];
	char		_sizeToBucket[4100];
	char		_sizeToBuckets[1024];
	Semaphore*	_topMutex;
	int		_top;
	int		_pageSize;
	int		_pageMask;
	int		_numberOfPages;

	unsigned int	findBucket( unsigned int size );
	char *		moreSpace( int bucket );
public:
	BucketAllocator( void * baseAddress, int numberOfPages,
			int log2PageSize, int noMultiProcessing = 1 );
	~BucketAllocator();
	void		enableMultiProcessing();
	void *		allocate( unsigned int size );
	void		free( void * cp );
};

extern BucketAllocator * _new_allocator;
extern new_handler _current_handler;

#endif 
