#ifndef Assert_h
#define Assert_h

#ifdef __GNUC__
#pragma interface
#endif

#include "FormatAssists.h"

const int NOTREACHED = 0;

#ifdef ASSERT

class AssertionFailure {
 public:
    AssertionFailure(const char *exp , char * file, char *baseFile, int line);
    ~AssertionFailure();    // Does the trap
};

#define Assert(exp) if(exp) ; else (void)AssertionFailure( #exp, __FILE__, __BASE_FILE__, __LINE__ )

#else /* !ASSERT */
class
NullAssertion
{
 public:
    ~NullAssertion() {}
    NullAssertion (char *exp , char * file, char *baseFile, int line){}
};

#define Assert(exp) if(exp) ; else (void)NullAssertion( #exp, __FILE__, __BASE_FILE__, __LINE__ )

#endif /* ASSERT */

#endif /* Assert_h */
