#ifndef _Class_H_
#define _Class_H_
#include "common.h"
class ClassConstructor;
class NameServer;
class ProxiableObject;
#include "ProxiableObject.h"

extern ClassStar ClassClass;
class Class :public ProxiableObject
{
  public:
    Class(ProxiableObject* p) :ProxiableObject((void*)0) {kernelObj=p->getKernelObj();}
    virtual Class *classOf();

    Class(Class* parent, int size, char* name, ClassConstructor* ctor); // __attribute((always_inline));

    virtual void cleanup(); // __attribute((always_inline));

    virtual char* name(int arg1, char* arg2); // __attribute((always_inline));

    virtual Class* parent(); // __attribute((always_inline));

    virtual Class* child(); // __attribute((always_inline));

    virtual Class* sibling(); // __attribute((always_inline));

    virtual Class* real(); // __attribute((always_inline));

    virtual int isASubclassOf(Class* arg1); // __attribute((always_inline));

    virtual int isClass(Class* arg1); // __attribute((always_inline));

    virtual int sizeOf(); // __attribute((always_inline));

    virtual void bind(NameServer* arg1); // __attribute((always_inline));

    virtual void unbind(NameServer* arg1); // __attribute((always_inline));

    virtual int initDebugObjects(); // __attribute((always_inline));

    virtual int initDebugMask(); // __attribute((always_inline));

    virtual int initDebugMessages(); // __attribute((always_inline));

    virtual void setInitDebugObjects(int arg1); // __attribute((always_inline));

    virtual void setInitDebugMask(int arg1); // __attribute((always_inline));

    virtual void setInitDebugMessages(int arg1); // __attribute((always_inline));

    virtual int concrete(); // __attribute((always_inline));

    virtual int debugMembers(int mask, int messages); // __attribute((always_inline));

    virtual int debugKindred(int mask, int messages); // __attribute((always_inline));

    virtual int displayMember(ProxiableObject* arg1); // __attribute((always_inline));

    virtual int displayMembers(); // __attribute((always_inline));

    virtual int displayKindred(int leaksOnly); // __attribute((always_inline));

    virtual int applyToMembers(ClassApplicationFunction arg1); // __attribute((always_inline));

    virtual int applyToKindred(ClassApplicationFunction arg1); // __attribute((always_inline));

    virtual ~Class();
    
  protected:
    
    Class(void* k);
    friend class ProxiableObject;
    friend class MemoryObject;
    friend class PersistentMemoryObject;
    friend class PersistentObject;
    friend class MemoryObjectContainer;
    friend class FileSystemInterface;
    friend class MemoryObjectDictionary;
    friend class NameServer;
    friend class RecordStream;
    friend class PersistentClass;

};

#endif
