#ifndef _FileSystemInterface_H_
#define _FileSystemInterface_H_
#include "common.h"
class ProxiableObject;
class Class;
class PersistentObject;
class UNIXFileInfo;
class PersistentMemoryObject;
#include "ProxiableObject.h"

extern ClassStar FileSystemInterfaceClass;
class FileSystemInterface :public ProxiableObject
{
  public:
    FileSystemInterface(ProxiableObject* p) :ProxiableObject((void*)0) {kernelObj=p->getKernelObj();}
    virtual Class *classOf();

    virtual ProxiableObject* open(char* path, Class* interfaceClass, int& status, int flags = 0, int mode = 0, Class* baseClass = 0); // __attribute((always_inline));

    virtual PersistentObject* open(char* path, int& status, int& returnType, int flags, int mode); // __attribute((always_inline));

    virtual int add(char* path, PersistentObject* arg2); // __attribute((always_inline));

    virtual int info(char* dirname, UNIXFileInfo* arg2, int follow, unsigned int* hints); // __attribute((always_inline));

    virtual int link(char* inpath, char* outpath, int overwrite); // __attribute((always_inline));

    virtual int unlink(char* pathname); // __attribute((always_inline));

    virtual int chdir(char* dirname); // __attribute((always_inline));

    virtual int chroot(char* dirname); // __attribute((always_inline));

    virtual int chdir(PersistentMemoryObject* pmo); // __attribute((always_inline));

    virtual int chroot(PersistentMemoryObject* pmo); // __attribute((always_inline));

    virtual int mount(char* special, char* pathname, int rwflag); // __attribute((always_inline));

    virtual int unmount(char* pathname); // __attribute((always_inline));

    virtual int synchronize(); // __attribute((always_inline));

    virtual void openFlagsSetMask(unsigned int mask); // __attribute((always_inline));

    virtual void openFlagsClearMask(unsigned int mask); // __attribute((always_inline));

    virtual unsigned int openFlagsSetMask(); // __attribute((always_inline));

    virtual unsigned int openFlagsClearMask(); // __attribute((always_inline));

    virtual ~FileSystemInterface();
    
  protected:
    
    FileSystemInterface(void* k);
    friend class Interface;
    friend class PersistentObject;

};

#endif
