#ifndef _MemoryObject_H_
#define _MemoryObject_H_
#include "common.h"
class Class;
#include "MemoryRange.h"

extern ClassStar MemoryObjectClass;
class MemoryObject :public MemoryRange
{
  public:
    MemoryObject(ProxiableObject* p) :MemoryRange((void*)0) {kernelObj=p->getKernelObj();}
    virtual Class *classOf();

    virtual int fixedSize(); // __attribute((always_inline));

    virtual int read(unsigned int startUnit, int count, char* addr, int nbytes); // __attribute((always_inline));

    virtual int write(unsigned int startUnit, int count, char* addr, int nbytes); // __attribute((always_inline));

    virtual int writeThrough(unsigned int startUnit, int count, char* addr, int nbytes); // __attribute((always_inline));

    virtual void synchronize(); // __attribute((always_inline));

    virtual void flush(); // __attribute((always_inline));

    virtual int setNumberOfUnits(unsigned int numberOfUnits); // __attribute((always_inline));

    virtual int copy(MemoryObject* dest); // __attribute((always_inline));

    virtual unsigned int cacheLog2UnitSize(); // __attribute((always_inline));

    virtual unsigned int setCacheLog2UnitSize(unsigned int arg1); // __attribute((always_inline));

    virtual Class* cacheClass(); // __attribute((always_inline));

    virtual void setCacheClass(Class* arg1); // __attribute((always_inline));

    virtual Class* replacementPolicyClass(); // __attribute((always_inline));

    virtual void setReplacementPolicyClass(Class* arg1); // __attribute((always_inline));

    virtual unsigned int maxResidentCacheUnits(); // __attribute((always_inline));

    virtual unsigned int setMaxResidentCacheUnits(unsigned int units); // __attribute((always_inline));

    virtual void addCache(Class* cacheClass); // __attribute((always_inline));

    virtual ~MemoryObject();
    
  protected:
    
    MemoryObject(void* k);
    
};

#endif
