#ifndef _MemoryObjectContainer_H_
#define _MemoryObjectContainer_H_
#include "common.h"
class PersistentMemoryObject;
class FileObject;
class Class;
class MemoryObjectDictionary;
#include "PersistentObject.h"

extern PersistentClassStar MemoryObjectContainerClass;
class MemoryObjectContainer :public PersistentObject
{
  public:
    MemoryObjectContainer(ProxiableObject* p) :PersistentObject((void*)0) {kernelObj=p->getKernelObj();}
    virtual Class *classOf();

    MemoryObjectContainer(PersistentMemoryObject* source); // __attribute((always_inline));

    virtual FileObject* open(int id, int& status, int flags); // __attribute((always_inline));

    virtual FileObject* create(int id, Class* arg2, int& sts, int flags); // __attribute((always_inline));

    virtual void close(FileObject* fo); // __attribute((always_inline));

    virtual int allocate(int& blocks, int nearPhysicalUnit, int units); // __attribute((always_inline));

    virtual void free(int& blocks, int physicalUnit, int units); // __attribute((always_inline));

    virtual void synchronize(); // __attribute((always_inline));

    virtual void synchronize(int idNumber); // __attribute((always_inline));

    virtual MemoryObjectDictionary* rootDictionary(); // __attribute((always_inline));

    virtual int size(); // __attribute((always_inline));

    virtual int rootIdNumber(); // __attribute((always_inline));

    virtual void acquire(); // __attribute((always_inline));

    virtual void release(); // __attribute((always_inline));

    virtual void acquire(int idNumber); // __attribute((always_inline));

    virtual void release(int idNumber); // __attribute((always_inline));

    virtual ~MemoryObjectContainer();
    
  protected:
    
    MemoryObjectContainer(void* k);
    friend class PersistentMemoryObject;
    friend class FileObject;
    friend class FileObjectView;

};

#endif
