#ifndef _MemoryObjectDictionary_H_
#define _MemoryObjectDictionary_H_
#include "common.h"
class PersistentMemoryObject;
class Class;
#include "PersistentObject.h"

extern PersistentClassStar MemoryObjectDictionaryClass;
class MemoryObjectDictionary :public PersistentObject
{
  public:
    MemoryObjectDictionary(ProxiableObject* p) :PersistentObject((void*)0) {kernelObj=p->getKernelObj();}
    virtual Class *classOf();

    MemoryObjectDictionary(PersistentMemoryObject* source); // __attribute((always_inline));

    virtual PersistentMemoryObject* open(char* key, int& status, int flags); // __attribute((always_inline));

    virtual PersistentMemoryObject* create(char* key, Class* arg2, int& sts, int flags); // __attribute((always_inline));

    virtual int add(char* key, PersistentMemoryObject* arg2); // __attribute((always_inline));

    virtual int remove(char* key, int* links); // __attribute((always_inline));

    virtual int keys(char* buffer, int bufferSize, int& count); // __attribute((always_inline));

    virtual int associations(char* buffer, int bufferSize, int& count); // __attribute((always_inline));

    virtual int associations(char* buffer, int bufferSize, int& count, int& offset); // __attribute((always_inline));

    virtual int keySize(); // __attribute((always_inline));

    virtual int sharesContainer(PersistentMemoryObject* arg1); // __attribute((always_inline));

    virtual int synchronize(); // __attribute((always_inline));

    virtual ~MemoryObjectDictionary();
    
  protected:
    
    MemoryObjectDictionary(void* k);
    friend class MemoryObjectContainer;
    friend class PersistentClass;

};

#endif
