#ifndef _MemoryRange_H_
#define _MemoryRange_H_
#include "common.h"
#include "ProxiableObject.h"

extern ClassStar MemoryRangeClass;
class MemoryRange :public ProxiableObject
{
  public:
    MemoryRange(ProxiableObject* p) :ProxiableObject((void*)0) {kernelObj=p->getKernelObj();}
    virtual Class *classOf();

    MemoryRange(unsigned int numberOfUnits, unsigned int log2UnitSize); // __attribute((always_inline));

    virtual unsigned int unitSize(); // __attribute((always_inline));

    virtual unsigned int log2UnitSize(); // __attribute((always_inline));

    virtual unsigned int numberOfUnits(); // __attribute((always_inline));

    virtual unsigned int offsetToUnit(Offset offset1); // __attribute((always_inline));

    virtual Offset unitToOffset(unsigned int unit); // __attribute((always_inline));

    virtual int isIn(unsigned int unit); // __attribute((always_inline));

    virtual ~MemoryRange();
    
  protected:
    
    MemoryRange(void* k);
    
};

#endif
