#ifndef _OutputStream_H_
#define _OutputStream_H_
#include "common.h"
#include "ProxiableObject.h"

extern ClassStar OutputStreamClass;
class OutputStream :public ProxiableObject
{
  public:
    OutputStream(ProxiableObject* p) :ProxiableObject((void*)0) {kernelObj=p->getKernelObj();}
    virtual Class *classOf();

    enum OutputStreamPadChar { aZero, aSpace };
    enum OutputStreamPadSide { padLeft, padRight };

    void emitChar( char c, int width, OutputStreamPadSide padSide );
    void emitString( const char * string, int width, OutputStreamPadSide );
    void emitSpaces( int spaceCount );
    void emitZeros( int zeroCount );
    void emitNumber( unsigned int arg, int base, int width,
                     OutputStreamPadSide padSide, OutputStreamPadChar padChar);

    OutputStream & operator <<( int );
    OutputStream & operator <<( unsigned int );
    OutputStream & operator <<( long );
    OutputStream & operator <<( unsigned long );
    OutputStream & operator <<( char );
    OutputStream & operator <<( const char * );
    OutputStream & operator <<( const void * );
    OutputStream & operator <<( Flush  fl ) { flush(); return(*this); }

    virtual void acquireExclusiveUse(); // __attribute((always_inline));

    virtual void releaseExclusiveUse(); // __attribute((always_inline));

    virtual int write(const char* buffer, int count); // __attribute((always_inline));

    virtual int formattedWrite(char* format, const formatArgs& a1 = 0); // __attribute((always_inline));

    virtual void flush(); // __attribute((always_inline));

    virtual ~OutputStream();
    
  protected:
    
    OutputStream(void* k);
    friend class ProxiableObject;
    friend class Interface;
    friend class PersistentMemoryObject;
    friend class PersistentObject;
    friend class SystemInterface;
    friend class FileObject;

};

#endif
