#ifndef _PersistentMemoryObject_H_
#define _PersistentMemoryObject_H_
#include "common.h"
class UNIXFileInfo;
class MemoryObjectContainer;
class ProxiableObject;
class Class;
class PersistentObject;
class OutputStream;
#include "MemoryObject.h"

extern ClassStar PersistentMemoryObjectClass;
class PersistentMemoryObject :public MemoryObject
{
  public:
    PersistentMemoryObject(ProxiableObject* p) :MemoryObject((void*)0) {kernelObj=p->getKernelObj();}
    virtual Class *classOf();

    virtual void unreference(); // __attribute((always_inline));

    virtual void synchronize(); // __attribute((always_inline));

    virtual int setNumberOfUnits(unsigned int numberOfUnits); // __attribute((always_inline));

    virtual unsigned int numberOfRecords(); // __attribute((always_inline));

    virtual int setNumberOfRecords(unsigned int numberOfRecords); // __attribute((always_inline));

    virtual unsigned int recordSize(); // __attribute((always_inline));

    virtual int setRecordSize(unsigned int recordSize); // __attribute((always_inline));

    virtual unsigned int numberOfBytes(); // __attribute((always_inline));

    virtual int setNumberOfBytes(unsigned int numberOfBytes); // __attribute((always_inline));

    virtual void info(UNIXFileInfo* arg1); // __attribute((always_inline));

    virtual int isSymbolicLink(); // __attribute((always_inline));

    virtual int isContainer(); // __attribute((always_inline));

    virtual int isDictionary(); // __attribute((always_inline));

    virtual int setUserId(int uid); // __attribute((always_inline));

    virtual int setGroupId(int gid); // __attribute((always_inline));

    virtual int setMode(int mode); // __attribute((always_inline));

    virtual int idNumber(); // __attribute((always_inline));

    virtual int links(int delta); // __attribute((always_inline));

    virtual MemoryObjectContainer* container(); // __attribute((always_inline));

    virtual int access(int mask); // __attribute((always_inline));

    virtual ProxiableObject* asA(Class* arg1, int& status); // __attribute((always_inline));

    virtual PersistentObject* persistentObject(); // __attribute((always_inline));

    virtual void close(PersistentObject* so); // __attribute((always_inline));

    virtual void writeName(OutputStream* arg1); // __attribute((always_inline));

    virtual void writeIdNumber(OutputStream* arg1); // __attribute((always_inline));

    virtual int userId(); // __attribute((always_inline));

    virtual int groupId(); // __attribute((always_inline));

    virtual int alloc(unsigned int startUnit, int count); // __attribute((always_inline));

    virtual int free(unsigned int startUnit, int count); // __attribute((always_inline));

    virtual void setCacheHints(unsigned int userHints); // __attribute((always_inline));

    virtual unsigned int getCacheHints(); // __attribute((always_inline));

    virtual ~PersistentMemoryObject();
    
  protected:
    
    PersistentMemoryObject(void* k);
    friend class PersistentObject;
    friend class PersistentArray;
    friend class MemoryObjectContainer;
    friend class SystemInterface;
    friend class FileSystemInterface;
    friend class MemoryObjectDictionary;
    friend class FileObject;
    friend class FileObjectView;
    friend class SymbolicLink;

};

#endif
