#ifndef _PersistentObject_H_
#define _PersistentObject_H_
#include "common.h"
class PersistentMemoryObject;
class FileSystemInterface;
class OutputStream;
class ProxiableObject;
class Class;
class UNIXFileInfo;
#include "ProxiableObject.h"

extern ClassStar PersistentObjectClass;
class PersistentObject :public ProxiableObject
{
  public:
    PersistentObject(ProxiableObject* p) :ProxiableObject((void*)0) {kernelObj=p->getKernelObj();}
    virtual Class *classOf();

    virtual PersistentMemoryObject* source(); // __attribute((always_inline));

    PersistentObject(PersistentMemoryObject* mo); // __attribute((always_inline));

    virtual int init(int argc, char** argv, FileSystemInterface* arg3); // __attribute((always_inline));

    virtual int execute(); // __attribute((always_inline));

    virtual int persist(); // __attribute((always_inline));

    virtual int desist(); // __attribute((always_inline));

    virtual unsigned int numberOfBytes(); // __attribute((always_inline));

    virtual unsigned int numberOfRecords(); // __attribute((always_inline));

    virtual unsigned int recordSize(); // __attribute((always_inline));

    virtual int copy(PersistentObject* po); // __attribute((always_inline));

    virtual void flush(); // __attribute((always_inline));

    virtual void writeName(OutputStream* arg1); // __attribute((always_inline));

    virtual int executable(); // __attribute((always_inline));

    virtual int idNumber(); // __attribute((always_inline));

    virtual ProxiableObject* asA(Class* arg1, int& status); // __attribute((always_inline));

    virtual int links(); // __attribute((always_inline));

    virtual void info(UNIXFileInfo* arg1); // __attribute((always_inline));

    virtual int setUserId(int uid); // __attribute((always_inline));

    virtual int setGroupId(int gid); // __attribute((always_inline));

    virtual int setMode(int mode); // __attribute((always_inline));

    virtual ~PersistentObject();
    
  protected:
    
    PersistentObject(void* k);
    friend class PersistentMemoryObject;
    friend class FileSystemInterface;
    friend class PersistentClass;

};

#endif
