#ifndef _Process_H_
#define _Process_H_
#include "common.h"
class Domain;
class Semaphore;
class NameServer;
class ProcessResourceUsage;
#include "ProxiableObject.h"

extern ClassStar ProcessClass;
class Process :public ProxiableObject
{
  public:
    Process(ProxiableObject* p) :ProxiableObject((void*)0) {kernelObj=p->getKernelObj();}
    virtual Class *classOf();

    virtual Domain* currentDomain(); // __attribute((always_inline));

    virtual int waitForProcess(Process* other); // __attribute((always_inline));

    virtual void notifyUponCompletion(Semaphore* sem, int* arg2); // __attribute((always_inline));

    virtual void wakeUpWaiter(int status); // __attribute((always_inline));

    virtual int dead(); // __attribute((always_inline));

    virtual int completionStatus(); // __attribute((always_inline));

    virtual void giveProcessorTo(Process* anotherProcess, ProcessState newState); // __attribute((always_inline));

    virtual void die(int status); // __attribute((always_inline));

    virtual void relinquishProcessor(); // __attribute((always_inline));

    virtual void ready(); // __attribute((always_inline));

    virtual NameServer* domainNameServer(); // __attribute((always_inline));

    virtual Process* clone(char* entry, char* stackPointer); // __attribute((always_inline));

    virtual void getResourceUsage(ProcessResourceUsage* buf); // __attribute((always_inline));

    virtual ~Process();
    
  protected:
    
    Process(void* k);
    friend class SystemInterface;

};

#endif
