#ifndef _ProxiableObject_H_
#define _ProxiableObject_H_
#include "common.h"
class OutputStream;
class Class;

extern ClassStar ProxiableObjectClass;
class ProxiableObject 
{
  public:
    virtual Class *classOf();

    void* getKernelObj(){return kernelObj;}

    ProxiableObject(); // __attribute((always_inline));

    virtual void reference(); // __attribute((always_inline));

    virtual void unreference(); // __attribute((always_inline));

    virtual char* objectName(); // __attribute((always_inline));

    virtual void setName(char* str); // __attribute((always_inline));

    virtual void writeName(OutputStream* arg1); // __attribute((always_inline));

    virtual void inspect(OutputStream* arg1); // __attribute((always_inline));

    virtual ProxiableObject* asA(Class* arg1, int& status); // __attribute((always_inline));

    virtual ProxiableObject* asA(char* arg1, int& status); // __attribute((always_inline));

    virtual ~ProxiableObject();
    
  protected:
    void *kernelObj;
    ProxiableObject(void* k);
    friend class PersistentMemoryObject;
    friend class PersistentObject;
    friend class SystemInterface;
    friend class FileSystemInterface;
    friend class NameServer;
    friend class RecordStream;
    friend class Class;
    friend class ClassConstructor;

};

#endif
