#ifndef _RecordStream_H_
#define _RecordStream_H_
#include "common.h"
class UNIXFileInfo;
class ProxiableObject;
class Class;
#include "ProxiableObject.h"

extern ClassStar RecordStreamClass;
class RecordStream :public ProxiableObject
{
  public:
    RecordStream(ProxiableObject* p) :ProxiableObject((void*)0) {kernelObj=p->getKernelObj();}
    virtual Class *classOf();

    virtual int read(char* buffer, int size); // __attribute((always_inline));

    virtual int read(char* buffer, int size, int& status); // __attribute((always_inline));

    virtual int write(char* buffer, int size); // __attribute((always_inline));

    virtual int write(char* buffer, int size, int& status); // __attribute((always_inline));

    virtual int recordNumber(); // __attribute((always_inline));

    virtual int setRecordNumber(int delta, int mode); // __attribute((always_inline));

    virtual int numberOfBytes(); // __attribute((always_inline));

    virtual int numberOfRecords(); // __attribute((always_inline));

    virtual int recordSize(); // __attribute((always_inline));

    virtual int minimumRecordSize(); // __attribute((always_inline));

    virtual int maximumRecordSize(); // __attribute((always_inline));

    virtual int setMode(int mode); // __attribute((always_inline));

    virtual int setUserId(int uid); // __attribute((always_inline));

    virtual int setGroupId(int gid); // __attribute((always_inline));

    virtual void info(UNIXFileInfo* arg1); // __attribute((always_inline));

    virtual int init(int argc, char** argv); // __attribute((always_inline));

    virtual int executable(); // __attribute((always_inline));

    virtual ProxiableObject* asA(Class* arg1, int& status); // __attribute((always_inline));

    virtual int runFile(int argc, char** argv); // __attribute((always_inline));

    virtual ~RecordStream();
    
  protected:
    
    RecordStream(void* k);
    friend class VMInterface;

};

#endif
