#ifndef _SystemInterface_H_
#define _SystemInterface_H_
#include "common.h"
class ProvidedVersionInstaller;
class RequiredVersionInstaller;
class Process;
class PersistentMemoryObject;
class Disk;
class OutputStream;
class ProxiableObject;
class InputStream;
#include "ProxiableObject.h"

extern ClassStar SystemInterfaceClass;
class SystemInterface :public ProxiableObject
{
  public:
    SystemInterface(ProxiableObject* p) :ProxiableObject((void*)0) {kernelObj=p->getKernelObj();}
    virtual Class *classOf();

    virtual void initialCall(void* returnFunct); // __attribute((always_inline));

    virtual void versions(ProvidedVersionInstaller* arg1, RequiredVersionInstaller* arg2); // __attribute((always_inline));

    virtual Process* getThisProcess(); // __attribute((always_inline));

    virtual void killThisProcess(); // __attribute((always_inline));

    virtual Process* buildProcessFromObjectFile(PersistentMemoryObject* arg1, int argc, char** argv); // __attribute((always_inline));

    virtual Disk* rootDisk(); // __attribute((always_inline));

    virtual int isObjectFile(PersistentMemoryObject* arg1); // __attribute((always_inline));

    virtual OutputStream* outputStream(ProxiableObject* arg1); // __attribute((always_inline));

    virtual InputStream* inputStream(ProxiableObject* arg1); // __attribute((always_inline));

    virtual int pageSize(); // __attribute((always_inline));

    virtual void controlSimpleInstruments(int argc, char** argv); // __attribute((always_inline));

    virtual ~SystemInterface();
    
  protected:
    
    SystemInterface(void* k);
    friend class Interface;

};

#endif
