/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: John L. Coolidge (coolidge@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

#ifndef UnixTime_h
#define UnixTime_h


#ifdef __GNUC__
#pragma interface
#endif

#include "MachineTypes.h"

class UnixTime
{
  private:
    int32 _seconds;
    int32 _useconds;
    int32 _minuteswest;
    int32 _dsttime;

  public:
    UnixTime()
      { };
    UnixTime( int32 seconds, int32 useconds, int32 minuteswest, int32 dsttime )
      { _seconds = seconds; _useconds = useconds;
	_minuteswest = minuteswest; _dsttime = dsttime; }

    int32 seconds()
      { return _seconds; }
    int32 useconds()
      { return _useconds; }
    int32 minuteswest()
      { return _minuteswest; }
    int32 dsttime()
      { return _dsttime; }

    void setSeconds( int32 seconds )
      { _seconds = seconds; }
    void setUSeconds( int32 useconds )
      { _useconds = useconds; }
    void setMinuteswest( int32 minuteswest )
      { _minuteswest = minuteswest; }
    void setDsttime( int32 dsttime )
      { _dsttime = dsttime; }
};

#endif /* UnixTime_h */
