#ifndef __EXCEPTION__
#define __EXCEPTION__

class exception 
{
 public:
    exception() throw() { }
    virtual ~exception() throw();
    /** Returns a C-style character string describing the general cause
     *  of the current error.  */
    virtual const char* what() const throw();
};
  
class kernel_exception : public exception
{
 public:
    static const unsigned DONE = 0;
    static const unsigned INVALIDMETHOD = 1;
    static const unsigned INVALIDCLASS = 2;
    static const unsigned INVALIDOBJECT = 3;

    typedef unsigned EXCODE;

    kernel_exception(EXCODE code) throw() : _code(code) { }
    const char* what() const throw();
    EXCODE code() const throw();
    static void throw_exception(EXCODE code);
 protected:
    EXCODE _code;
};
  
class invalid_object : public kernel_exception
{
 public:
    invalid_object() throw() : kernel_exception(INVALIDOBJECT) { }
    const char* what() const throw();
};
  
class invalid_method : public kernel_exception
{
 public:
    invalid_method() throw() : kernel_exception(INVALIDMETHOD) { }
    const char* what() const throw();
};
  
class invalid_class : public kernel_exception
{
 public:
    invalid_class() throw() : kernel_exception(INVALIDCLASS) { }
    const char* what() const throw();
};
  
#endif
