/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: David W. Dykstra (dykstra@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * OutputStream.h: definition of an output stream of characters.
 */

#ifndef BufferedOutputStream_h
#define BufferedOutputStream_h


#ifdef __GNUC__
#pragma interface
#endif

#include "OutputStream.h"
#include "OutputStreamStar.h"

extern ClassStar BufferedOutputStreamClass;
class BufferedOutputStream : public OutputStream {
protected:
	OutputStreamStar _sink;
	char * _flushBuffer;
	int _bufferSize;
	int _bytesInBuffer;
	int _flushOnNewline;

public:
	BufferedOutputStream( OutputStream * sink, int flushOnNewline = 0,
					int bufferSize = 4096 );
	~BufferedOutputStream();

	virtual OutputStream & flush();
	virtual int write( const char * buffer, int charCount );

	Class * classOf();
};

#endif /* BufferedOutputStream_h */
