/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987-1992
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * ThisProcess.h: thisProcess() function for applications
 */

#ifndef ThisProcess_h
#define ThisProcess_h


#ifdef __GNUC__
#pragma interface
#endif

#include "Process.h"
#include "SystemInterface.h"

static inline Process *
thisProcess()
{
	return( StandardSystemInterface->getThisProcess() );
}


//  Create and execute a new process with a copy of the current domain
//  and begin execution in exactly the same environment as the current
//  process.  The current process will return a pointer to the new process
//  when the current process exits this function.  The new process will
//  return 0 when the new process exits this function.  Only the
//  writeable unshared memory objects in the current domain are copied
//  to the new domain.  The other memory objects are directly inserted
//  into the new domain.

Process *cloneThisProcess ();


#endif // ThisProcess_h
