/*
 */

#ifndef _new_allocator_h
#define _new_allocator_h

#ifdef __GNUC__
#pragma interface
#endif


typedef void (* PFV)();
extern PFV _new_handler;

class BucketAllocator;
extern BucketAllocator * _new_allocator;
extern char __new_dataArea[];
extern int __new_pageCount;
extern int __new_log2PageSize;

/*
 * Invoking this (at global scope!) defines parameters for _new to initialize
 * itself with.  That is, it sets the heap size.  The default is in
 * ``_new_allocator.c''.  The user can, however, use NEWALLOCATOR() to set it
 * to whatever is desired.
 *
 * NOTE: log2PageSize does *not* have to be the same as log2(PageSize).
 * Also NOTE: don't use static here because on some compilers that forces
 *    it into .data instead of .bss.
 */
#define NEWALLOCATOR( pageCount, log2PageSize ) \
	char __new_dataArea[ pageCount * ( 1 << log2PageSize ) ]; \
	int __new_pageCount = pageCount; \
	int __new_log2PageSize = log2PageSize; \
	BucketAllocator * _new_allocator

#endif
