/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991, 1992
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Swee Boon Lim (sblim@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * ExecInfo.h
 */

#ifndef ExecInfo_h
#define ExecInfo_h


#ifdef __GNUC__
#pragma interface
#endif

#include "FileDescriptor.h"

#define EXEC_SIGNATURE "\177\177\177\177\012\004\066\000"

struct ExecInfo {
	char signature[8];
	unsigned length;
	int negativePid;
	int lastChild;
	int sigmask;
	int umask;
	int auid;
	int euid;
	int egid;
	int gid;
	int uid;
	int envCount;
	FileDescriptorTable fileDescriptorTable;
	char env[1];
};

extern ExecInfo * UA_ExecInfoEncode(char * envp[]);
extern void UA_ExecInfoDecode(ExecInfo *);

#endif
