#ifndef asmbridge_h
#define asmbridge_h

/*
 * This file is part of the Choices Operating System
 * Developed by:
 *      The Mobile Operating Systems Group
 *      Department of Computer Science
 *      University of Illinois at Urbana-Champaign
 *      201 N. Goodwin Ave.
 *      Urbana, IL 61801
 *
 * Copyright 1987-2006 University of Illinois Board of Trustees. All rights
 * reserved. 
 *
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 */

/*
 * GenericARM/AsmBridge.h: Interface to assembly functions for Generic ARM
 *  machine type.
 */

typedef void VABFuncV(void);
typedef void VABFuncCS(const char *);
typedef void VABFuncB(char);
typedef char BABFuncV(void);
typedef int  NABFuncPC(char *);

extern VABFuncV*    GenericARMSerialInitialize;
extern VABFuncCS*   GenericARMSerialPutS;
extern VABFuncB*    GenericARMSerialPutChar;
extern BABFuncV*    GenericARMSerialGetChar;
extern NABFuncPC*   GenericARMSerialGetRawChar;

#endif /* asmbridge_h */
