/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *     University of Illinois at Urbana-Champaign
 *     Department of Computer Science
 *     1304 W. Springfield Ave.
 *     Urbana, IL 61801
 *
 * Copyright (c) 1987-2005
 * The University of Illinois Board of Trustees.
 *  All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 */

#ifndef GenericARMBootConsole_h
#define GenericARMBootConsole_h

#include "BootConsole.h"

#ifdef __GNUC__
#pragma interface
#endif

class GenericARMBootConsole: public BootConsole {
  public:
    GenericARMBootConsole();
    virtual ~GenericARMBootConsole();
    virtual int readBuffer(unsigned len, char* buf);
    virtual bool doDefault() { return doCommand("c"); }
 private:
    virtual void printMenu();
    virtual char getChar();
    virtual int getRawChar(char* c);
    unsigned timeout;
};

#endif
