/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987-2006
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
#ifndef GenericARMDebug_h
#define GenericARMDebug_h


#ifdef __GNUC__
#pragma interface
#endif

/*
 * GenericARMDebug.h: GenericARM Diagnostic console output routines.
 */

extern unsigned int statbuf0[34];
extern unsigned int statbuf1[34];
extern unsigned int statbuf2[34];
extern unsigned int statbuf3[34];
extern unsigned int statbuf4[34];
extern unsigned int statbuf5[34];
extern unsigned int statbuf6[34];
extern unsigned int statbuf7[34];

extern void printdebug(unsigned int *statbuf);
extern "C" {
extern void processorstat(unsigned int *statbuf);
extern void printnum(unsigned int );
}
extern void test_traps();

#define STAT_PSR 		0
#define STAT_WIM		1
#define STAT_INS		2	
#define STAT_LOCALS		10
#define STAT_OUTS		18
#define STAT_GLOBALS		26

#endif
