/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991, 2006
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Swee Boon Lim (sblim@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
     
#ifndef GenericARMTimeOfDay_h
#define GenericARMTimeOfDay_h


#ifdef __GNUC__
#pragma interface
#endif

#include "Time.h"
#include "TimeOfDay.h"

extern ClassStar GenericARMTimeOfDayClass;
class GenericARMTimeOfDay : public TimeOfDay
{
 protected:
	struct GenericARMTime {
		int sec;
		int min;
		int hour;
		int day;
		int date;
		int month;
		int year;
	};

	volatile unsigned char * reg_sec;    //  = (volatile unsigned int * const) 0xffff87f9;
	volatile unsigned char * reg_min;    //  = (volatile unsigned char * const) 0xffff87fa;
	volatile unsigned char * reg_hour;   //  = (volatile unsigned char * const) 0xffff87fb;
	volatile unsigned char * reg_day;    //  = (volatile unsigned char * const) 0xffff87fc;
	volatile unsigned char * reg_date;   //  = (volatile unsigned char * const) 0xffff87fd;
	volatile unsigned char * reg_month;  //  = (volatile unsigned char * const) 0xffff87fe;
	volatile unsigned char * reg_year;   //  = (volatile unsigned char * const) 0xffff87ff;

	char regValue( volatile unsigned char * const reg );
	void getHardwareTime( GenericARMTime & time );
	unsigned long unixTime( GenericARMTime & time );

	TimeValue _lastTime;

 public:
	Class * classOf();

	GenericARMTimeOfDay();
	
	void systemTimerOverflow();

	virtual void getTime( SystemTime& time );
	virtual void getUnixTime( UnixTime& time );
};

#endif // GenericARMTimeOfDay_h

