/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987-2006
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
#ifndef PROM_h
#define PROM_h

#ifdef __GNUC__
#pragma interface
#endif

#define GenericARM_DIE_ID_BASE  0xfffe1800
#define GenericARM_PROD_ID_BASE 0xfffe2000
#define GenericARM32_ID_BASE    0xfffed400

/*
 * Should the ints be some addr type?
 * Francis <fdavid@uiuc.edu>
 */
struct memlist {
  int address;
  int size;
  struct memlist *next;
};

class GenericARMPROM {
    public:
        GenericARMPROM();

        unsigned char dev_rev;
        unsigned short prod_id;
        unsigned int omap32_id;
};

#endif /* PROM_h */
