/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987-1992
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * IntegratorFreeRunningTimer.h: free running timer for the Integrator
 */

#ifndef IntegratorFreeRunningTimer_h
#define IntegratorFreeRunningTimer_h


#ifdef __GNUC__
#pragma interface
#endif


#include "FreeRunningTimer.h"	/* parent class */
#include "IntegratorTimer.h"
#include "Interrupt.h"
class Lock;

class IntegratorFreeRunningTimerInterrupt : public Interrupt
{
protected:
	void basicRaise(char *);
};

extern ClassStar IntegratorFreeRunningTimerClass;
class IntegratorFreeRunningTimer : public FreeRunningTimer {
friend class IntegratorFreeRunningTimerInterrupt;
	static unsigned timesCalled;
	static unsigned constructed;
	static unsigned interrupts;
	static unsigned prevTime;
	unsigned int lastTime;
	static Lock * FreeRunningTimerLock;
public:
	Class * classOf();
	IntegratorFreeRunningTimer();

	virtual unsigned int time();
	/*
	 * This should be called from the hardware interrupt every
	 *   clock tick.
	 */
	void tick();
};

#endif 
