
#ifndef IntegratorInterruptManager_h
#define IntegratorInterruptManager_h

#include "InterruptManager.h"

#ifdef __GNUC__
#pragma interface
#endif

class IntegratorInterruptManager: public InterruptManager {
 public:
	IntegratorInterruptManager();
	~IntegratorInterruptManager();

  void enableInterrupts();
  void disableInterrupts();
  void enableInterrupt(unsigned number);
  void disableInterrupt(unsigned number);
	
 protected:
  unsigned getInterruptNumber();
  void ackInterrupt(unsigned number);
	void setupInterrupts();

private:
	typedef struct {
		unsigned registers;
		unsigned triggers;
	} IntegratorInterruptBank;

	static const int numInterruptBanks = 4;
	IntegratorInterruptBank interruptBanks[numInterruptBanks];

	static unsigned initialized;
};

#endif
