#ifndef IntegratorInterrupts_h
#define IntegratorInterrupts_h

#define PIC_BASE 0x14000000
#define SIC_BASE 0xca000000

// Primary interrupt controller 
#define PIC_IRQ_STATUS		(PIC_BASE + 0x0) 
#define PIC_IRQ_RAWSTAT 	(PIC_BASE + 0x4)
#define PIC_IRQ_ENABLESET 	(PIC_BASE + 0x8)
#define PIC_IRQ_ENABLECLR	(PIC_BASE + 0xc)
#define PIC_INT_SOFTSET		(PIC_BASE + 0x10)
#define PIC_INT_SOFTCLR		(PIC_BASE + 0x14)
#define PIC_FIQ_STATUS		(PIC_BASE + 0x20)
#define PIC_FIQ_RAWSTAT		(PIC_BASE + 0x24)
#define PIC_FIQ_ENABLESET	(PIC_BASE + 0x28)
#define PIC_FIQ_ENABLECLR	(PIC_BASE + 0x2c)

// Secondary interrupt controller 
#define SIC_INT_STATUS		(SIC_BASE + 0x0)
#define SIC_INT_RAWSTAT		(SIC_BASE + 0x4)
#define SIC_INT_ENABLESET	(SIC_BASE + 0x8)
#define SIC_INT_ENABLECLR	(SIC_BASE + 0xc)
#define SIC_INT_SOFTSET		(SIC_BASE + 0x10)
#define SIC_INT_SOFTCLR		(SIC_BASE + 0x14)

// Secondary interrupt controller bits
#define SIC_SOFTINT		0
#define SIC_R10			1
#define SIC_R11			2
#define SIC_CARDIN		3
#define SIC_LM_INT		4
#define SIC_MAXCNT		5

#define nInterrupts 256

#endif
