#ifndef IntegratorAsmBridge_h
#define IntegratorAsmBridge_h

/*
 * This file is part of the Choices Operating System
 * Developed by:
 *      The Mobile Operating Systems Group
 *      Department of Computer Science
 *      University of Illinois at Urbana-Champaign
 *      201 N. Goodwin Ave.
 *      Urbana, IL 61801
 *
 * Copyright 1987-2006 University of Illinois Board of Trustees. All rights
 * reserved. 
 *
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 */

/*
 * Integrator/MachAsmBridge.h: Interface to assembly functions for Integrator
 *  machine type.
 */

void IntegratorSerialInitialize(void);
void IntegratorSerialPutS(const char *);
void IntegratorSerialPutChar(char outch);
char IntegratorSerialGetChar(void);
int  IntegratorSerialGetRawChar(char *);

#define MACH_SERIALINITIALIZE   IntegratorSerialInitialize
#define MACH_SERIALPUTS         IntegratorSerialPutS
#define MACH_SERIALPUTCHAR      IntegratorSerialPutChar
#define MACH_SERIALGETCHAR      IntegratorSerialGetChar
#define MACH_SERIALGETRAWCHAR   IntegratorSerialGetRawChar

#endif /* IntegratorAsmBridge_h */
