/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Vincent F. Russo (russo@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * MultimaxAPCCPU.h: The NS32332 processor on a multimax APC card.
 */

#ifndef MultimaxAPCCPU_h
#define MultimaxAPCCPU_h


#ifdef __GNUC__
#pragma interface
#endif

#include "MultimaxTimesliceTimer.h"
#include "NS32332CPU.h"
#include "Vectors.h"

class MultimaxAPCCPU : public NS32332CPU {
protected:
	MultimaxTimesliceTimer myTimer;
	unsigned int readESR();
	void initICUs();

	char name[4];	// stores name in <sn> format (s=slot, n=number)

	/*
	 * Overloads of parent methods.
	 */
	void chipInitialize();
	void installInterrupts();

public:
	MultimaxAPCCPU( unsigned long identifier,
		ProcessContainer * initialIdleContainer );
	~MultimaxAPCCPU();

        void sendFlushRequestTo( unsigned long dest );
};

#endif /* MultimaxAPCCPU_h */
