/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Vincent F. Russo (russo@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * MultimaxConsole.h
 */

#ifndef MultimaxConsole_h
#define MultimaxConsole_h


#ifdef __GNUC__
#pragma interface
#endif

#include "CharacterQueue.h"
#include "InputStream.h"
#include "OutputStream.h"
#include "Lock.h"	/* could be a problem since locks use assertions */

static const unsigned int tab = 8;
class MultimaxConsole : public OutputStream {
protected:
	Lock _exclusiveUseLock;
	Lock _mutexLock;
	int currentColumn;

public:
	MultimaxConsole();

	virtual void acquireExclusiveUse();
	virtual void releaseExclusiveUse();

	virtual int write( const char * buffer, int count );
};

class MultimaxConsoleForUserOutput : public MultimaxConsole {
public:
	virtual int write( const char * buffer, int count );
};

#endif	/* MultimaxConsole_h */
