/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Vincent F. Russo (russo@cs.uiuc.edu)
 * Contributing Author: Gary M. Johnston (johnston@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * MultimaxInterrupts.h: interrupt sub-class descriptions for Multimax
 *	specific interrupts.
 */

#ifndef MultimaxInterrupts_h
#define MultimaxInterrupts_h


#ifdef __GNUC__
#pragma interface
#endif

#include "Interrupt.h"

class Semaphore;
class MultimaxEMCDisk;


class VectorBusInterrupt : public Interrupt {
protected:
	void basicRaise( char * );
public:
};

class NanoBusInterrupt : public Interrupt {
protected:
	char * message;
	void basicRaise( char * );
public:
	NanoBusInterrupt( char * msg );
};

inline
NanoBusInterrupt::NanoBusInterrupt( char * msg )
{
	message = msg;
}

class AddressTranslatorFlushInterrupt : public Interrupt {
protected:
	void basicRaise( char * );
public:
};

class MultimaxEMCDiskInterrupt : public Interrupt {
	MultimaxEMCDisk * client;
protected:
	void basicRaise( char * );
public:
	MultimaxEMCDiskInterrupt( MultimaxEMCDisk * client );
};

inline
MultimaxEMCDiskInterrupt::MultimaxEMCDiskInterrupt( MultimaxEMCDisk * disk )
{
	client = disk;
}

#endif /* MultimaxInterrupts_h */
