/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Gary M. Johnston (johnston@cs.uiuc.edu)
 * Contributing Author: Douglas E. Leyens (leyens@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * MultimaxTimeSliceTimer.h - Per-CPU Timeslice timer.
 */

#ifndef MultimaxTimesliceTimer_h
#define MultimaxTimesliceTimer_h


#ifdef __GNUC__
#pragma interface
#endif

#include "Timer.h"	/* parent class */

class MultimaxTimesliceTimer : public Timer {
protected:
	unsigned int vec;
public:
	MultimaxTimesliceTimer( unsigned int vector );
	~MultimaxTimesliceTimer();

	unsigned int start( unsigned int microseconds );
	void set( unsigned int microseconds );
	unsigned int stop();
	unsigned int residual();
	int idle();
};

#endif /* MultimaxTimesliceTimer_h */
