/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Douglas E. Leyens (leyens@cs.uiuc.edu)
 * Author: John L. Coolidge (coolidge@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
     
#ifndef RealTimeClock_h
#define RealTimeClock_h


#ifdef __GNUC__
#pragma interface
#endif

#include "SystemTime.h"
#include "TimeOfDay.h"
#include "TimeOfYear.h"

extern ClassStar MultimaxTimeOfDayClass;
class MultimaxTimeOfDay : public TimeOfDay {
  private:
    SystemTime _baseTime;	// time at which the object was initialized
    int32 _previousFreeTime;	// previous time from the free running timer
    int64 _previousTime;	// previous time returned to the user

    void getHardwareTime( SystemTime& );

    int64 toSystemTime( TOY * toyData );
    unsigned int toVinceSeconds( TOY * toyData ); // Obsolete
    void fromSeconds( TOY * toyData, unsigned int seconds );	// Unsupported

  public:
    Class * classOf();
    MultimaxTimeOfDay();
    virtual void getTime( SystemTime& );
    virtual void setTime( SystemTime& );
};

#endif /* RealTimeClock_h */
