/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Douglas E. Leyens (leyens@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

#ifndef TimeOfYear_h
#define TimeOfYear_h


#ifdef __GNUC__
#pragma interface
#endif

/* The toy structure is used to 'SET' and 'GET' the contents of the
 * real time clock data on the SCC board.  In addition, the SCC uses
 * battery backed up memory to maintain the high two decimal digits of
 * the year and the offset from Greenwich mean.
 */

class TOY {
public:
 	char toy_tenths_sec;   	/* Note that the tenths are not settable */
	char toy_unit_sec;	/* each char toy_contains the digit in the */
        char toy_ten_sec;	/* lower four bits. */
        char toy_unit_min;
        char toy_ten_min;
        char toy_unit_hour;
        char toy_ten_hour;
        char toy_unit_day;
        char toy_ten_day;
        char toy_unit_month;
        char toy_ten_month;
        char toy_unit_year;
        char toy_ten_year;
        char toy_day_of_week;

/* data not present on real time clock chip */

	char toy_hun_year;
	char toy_thou_year;

	short toy_offset;		/* minutes from Greenwich mean */
};

#endif /* TimeOfYear_h */
