#ifndef stat_h
#define stat_h

struct	stat {
	int	st_dev;
	int	st_ino;
	unsigned short st_mode;
	short	st_nlink;
	short	st_uid;
	short	st_gid;
	int	st_rdev;
	int	st_size;
	int	st_atime;
	int	st_spare1;
	int	st_mtime;
	int	st_spare2;
	int	st_ctime;
	int	st_spare3;
	int	st_blksize;
	int	st_blocks;
	union {
		struct	{
			int	stu_flag;	/* Flag word from inode */
#define	S_FASTLINK	0x0001			/* Fast link */
#define	S_HASHED_DIR	0x0002			/* Hashed directory */
			int	stu_spare4;
		} stu_flagu;
		struct	stu_rdpitems {
			int	stu_rdaddr;	/* Inet addr of rem dev */
			short	stu_rdtype;	/* Annex rem dev type */
			short	stu_rdnum;	/* Annex rem dev num */
		} stu_rdp;
	} st_un;
};

#define	st_flag		st_un.stu_flagu.stu_flag
#define	st_spare4	st_un.stu_flagu.stu_spare4
#define st_rdaddr	st_un.stu_rdp.stu_rdaddr
#define st_rdtype	st_un.stu_rdp.stu_rdtype
#define st_rdnum	st_un.stu_rdp.stu_rdnum

#define	S_IFMT	0170000		/* type of file */
#define		S_IFDIR	0040000	/* directory */
#define		S_IFCHR	0020000	/* character special */
#define		S_IFBLK	0060000	/* block special */
#define		S_IFREG	0100000	/* regular */
#define		S_IFLNK	0120000	/* symbolic link */
#define		S_IFSOCK 0140000/* socket */
#define	S_ISUID	0004000		/* set user id on execution */
#define	S_ISGID	0002000		/* set group id on execution */
#define	S_ISVTX	0001000		/* save swapped text even after use */
#define	S_IREAD	0000400		/* read permission, owner */
#define	S_IWRITE 0000200	/* write permission, owner */
#define	S_IEXEC	0000100		/* execute/search permission, owner */

#endif stat_h
