#ifndef OMAPAsmBridge_h
#define OMAPAsmBridge_h

/*
 * This file is part of the Choices Operating System
 * Developed by:
 *      The Mobile Operating Systems Group
 *      Department of Computer Science
 *      University of Illinois at Urbana-Champaign
 *      201 N. Goodwin Ave.
 *      Urbana, IL 61801
 *
 * Copyright 1987-2006 University of Illinois Board of Trustees. All rights
 * reserved. 
 *
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 */

/*
 * OMAP/MachAsmBridge.h: Interface to assembly functions for OMAP machine type.
 */

void OMAPSerialInitialize(void);
void OMAPSerialPutS(const char *);
void OMAPSerialPutChar(char outch);
char OMAPSerialGetChar(void);
int  OMAPSerialGetRawChar(char *);

#define MACH_SERIALINITIALIZE   OMAPSerialInitialize
#define MACH_SERIALPUTS         OMAPSerialPutS
#define MACH_SERIALPUTCHAR      OMAPSerialPutChar
#define MACH_SERIALGETCHAR      OMAPSerialGetChar
#define MACH_SERIALGETRAWCHAR   OMAPSerialGetRawChar

#endif /* OMAPAsmBridge_h */
