
#ifndef OMAPInterruptManager_h
#define OMAPInterruptManager_h

#include "InterruptManager.h"

#ifdef __GNUC__
#pragma interface
#endif

class OMAPInterruptManager: public InterruptManager {
 public:
    OMAPInterruptManager();
    ~OMAPInterruptManager();

    void enableInterrupts();
    void disableInterrupts();
    void enableInterrupt(unsigned number);
    void disableInterrupt(unsigned number);
    int isPending(unsigned number);
    void reinit() { setupInterrupts(); enableInterrupts(); }
    
 protected:
    unsigned getInterruptNumber();
    void ackInterrupt(unsigned number);
    void setupInterrupts();

 private:
    typedef struct {
        unsigned registers;
        unsigned triggers;
    } OMAPInterruptBank;

    static const int numInterruptBanks = 4;
    OMAPInterruptBank interruptBanks[numInterruptBanks];

    static unsigned initialized;
};

#endif
