/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987-2006
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * OMAPKernel.h: Machine description class for the OMAP Kernel.
 */

#ifndef OMAPKernel_h
#define OMAPKernel_h

#ifdef __GNUC__
#pragma interface
#endif

#include "GenericARMKernel.h"

extern ClassStar OMAPKernelClass;
class OMAPKernel : public GenericARMKernel {
 public:
	OMAPKernel();
    
    virtual PhysicalMemoryRange *   physicalMemoryMap();
    virtual const unsigned          kernelHeapSize();

    virtual int tryCommand(int argc, char *argv[], int partnumber);
    
    /* Choices Class support */
	Class *                         classOf();

 protected:
	virtual void                    basicAddMemoryObjects();
	virtual void                    basicInitializeDevicesAndManagers();
};

#endif /* OMAPKernel_h */
