/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Francis David (fdavid@uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * OMAPWatchdogTimer.h - OMAPWatchdogTimer class; just a place holder for subclasses.
 */

#ifndef OMAPWatchdogTimerDD_h
#define OMAPWatchdogTimerDD_h


#ifdef __GNUC__
#pragma interface
#endif

#include "OMAPWatchdogTimer.h"
#include "DDriver.h"

class OMAPWatchdogTimerDD : public OMAPWatchdogTimer, public DDriver {
public:
    OMAPWatchdogTimerDD() : OMAPWatchdogTimer(), DDriver() {}

    void basicInit();

	/*
	 * "start" starts timer and returns actual number of seconds set,
	 *  possibly rounded up to the granularity of the hardware timer.
	 */
	unsigned start( unsigned seconds );
	/*
	 * "stop" returns the residual number of seconds after stopping.
	 */
	unsigned stop();
	/*
	 * "residual" returns the remaining number of seconds.
	 */
	unsigned residual();
    /*
     * Pings resets the timer on the watchdog
     */
    void ping();
};

#endif /* OMAPWatchdogTimerDD_h */
