/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: See-Mong Tan (stan@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * DatakitUnixHost.h -- PCI586 Datakit Unix Host
 */

#ifndef DatakitUnixHost_h
#define DatakitUnixHost_h
#ifdef CFRONT
#define CONST const
#define STATIC static
#else /* must be g++ */
#pragma interface
#if (__GNUG__ >= 2)
#if (!defined CONST)||(!defined STATIC)
#define CONST
#define STATIC
#endif
#else
#pragma once
#define CONST const
#define STATIC static
#endif
#endif

#include "DatakitChannel.h"
#include "Lock.h"
#include "Semaphore.h"

// forward reference to the array of supported channels in the driver
extern DatakitChannel * DatakitChan[];

const int HIGHCHANMARK = 63;
const int LOWCHANMARK = 2;

// A class to manage the URP channels as a host on a Datakit network
extern ClassStar DatakitUnixHostClass;
class DatakitUnixHost : public Object {
protected:
    Lock mutex;
    int channelStatus[HIGHCHANMARK];
    static int initialized;

public:
    DatakitUnixHost();
    
    Class * classOf();

    DatakitURPChannel * open( char * dialstring );
    void close( DatakitURPChannel * chan );
};

const int CHANNELDIALING = 1;
const int CHANNELOPEN = 2;

// The main manager for unix hosts
extern DatakitUnixHost * unixHostManager;

#endif /* DatakitUnixHost_h */
