/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Vincent F. Russo (russo@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * PCi586Console.h
 */

#ifndef PCi586Console_h
#define PCi586Console_h
#ifdef CFRONT
#define CONST const
#define STATIC static
#else /* must be g++ */
//#pragma interface
#if (__GNUG__ >= 2)
#ifndef COSNT
#define CONST
#define STATIC
#endif
#else
#pragma once
#define CONST const
#define STATIC static
#endif
#endif

#include "Lock.h"	/* could be a problem since locks use assertions */
#include "OutputStream.h"
#include "InputStream.h"

class CharacterQueue;

class PCi586Console : public OutputStream {
protected:
	Lock _exclusiveUseLock;
	//Lock _mutexLock;
	int currentColumn;
	int currentRow;
	unsigned char *screenPtr;

	void clearScreen();
	void updateCursor();
	void putScreen( char c );
	void putSerial( char c );

public:
	PCi586Console();

	virtual void acquireExclusiveUse();
	virtual void releaseExclusiveUse();

	virtual int write( const char * buffer, int count );
};

class PCi586ConsoleForUserOutput : public PCi586Console {
public:
	virtual int write( const char * buffer, int count );
};

#endif	/* PCi586Console_h */
