/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Peter W. Madany (madany@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * PCi586DiskStar.h -
 */

#ifndef	PCi586DiskStar_h
#define	PCi586DiskStar_h
#ifdef CFRONT
#define CONST const
#define STATIC static
#else /* must be g++ */
#pragma interface
#if (__GNUG__ >= 2)
#if (!defined CONST)
#define CONST
#define STATIC
#endif
#else
#pragma once
#define CONST const
#define STATIC static
#endif
#endif

#include "PersistentMemoryObjectStar.h"
class PCi586Disk;
class PCi586DiskRef;

class PCi586DiskStar : public PersistentMemoryObjectStar {
public:
	PCi586DiskStar();

	PCi586DiskStar( ProxiableObject * );
	PCi586DiskStar( ProxiableObjectRef &   );
	PCi586DiskStar( ProxiableObjectStar &   );

	PCi586DiskStar( PCi586Disk * );
	PCi586DiskStar( PCi586DiskRef &   );
	PCi586DiskStar( PCi586DiskStar &   );

	PCi586DiskStar& CONST operator=( ProxiableObject * );
	PCi586DiskStar& CONST operator=( ProxiableObjectRef &   );
	PCi586DiskStar& CONST operator=( ProxiableObjectStar &   );

	PCi586DiskStar& CONST operator=( PCi586Disk * );
	PCi586DiskStar&   operator=( PCi586DiskRef &   );
	PCi586DiskStar& CONST operator=( PCi586DiskStar &   );

	operator PCi586Disk *()  ;
	PCi586Disk * operator->()  ;
};

#ifndef PROXIFY
inline PCi586DiskStar::operator PCi586Disk*()     
{
        return( (PCi586Disk*)_pointer );
}
        
inline PCi586Disk*
PCi586DiskStar::operator->()  
{
        return( (PCi586Disk*)_pointer );
}
#endif

class PCi586DiskRef : public PersistentMemoryObjectRef {
public:
	PCi586DiskRef();
	~PCi586DiskRef();

	PCi586DiskRef( ProxiableObject * );
	PCi586DiskRef( ProxiableObjectRef &   );
	PCi586DiskRef( ProxiableObjectStar &   );

	PCi586DiskRef( PCi586Disk * );
	PCi586DiskRef( PCi586DiskRef &   );
	PCi586DiskRef( PCi586DiskStar &   );

	PCi586DiskRef& CONST operator=( ProxiableObject * );
	PCi586DiskRef& CONST operator=( ProxiableObjectRef &   );
	PCi586DiskRef& CONST operator=( ProxiableObjectStar &   );

	PCi586DiskRef& CONST operator=( PCi586Disk * );
	PCi586DiskRef& CONST operator=( PCi586DiskRef &   );
	PCi586DiskRef& CONST operator=( PCi586DiskStar &   );

	operator PCi586Disk *()  ;
	PCi586Disk * operator->()  ;
};

#ifndef PROXIFY
inline PCi586DiskRef::operator PCi586Disk*()     
{
        return( (PCi586Disk*)_pointer );
}
        
inline PCi586Disk*
PCi586DiskRef::operator->()  
{
        return( (PCi586Disk*)_pointer );
}
#endif

#endif //PCi586DiskStar_h
