/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author:  Dave Dykstra (dykstra@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * 	PCi586InterruptController.h - Header file for the programmable
 *	interrupt controller on the AT&T 6586 PC.
 */
#ifndef PCi586InterruptController_h
#define PCi586InterruptController_h
#ifdef CFRONT
#define CONST const
#define STATIC static
#else /* must be g++ */
#pragma interface
#if (__GNUG__ >= 2)
#if (!defined CONST)
#define CONST
#define STATIC
#endif
#else
#pragma once
#define CONST const
#define STATIC static
#endif
#endif

const int PIC_EOI =		0x20;

const int PIC_CTRL_REG =		0x20;
const int PIC_MASK_REG =		0x21;

const int PIC_TIMER_MASK =	0x01;
const int PIC_KEYBOARD_MASK =	0x02;
const int PIC_PIC2_MASK =	0x04;
const int PIC_COM1_MASK =	0x08;
const int PIC_COM0_MASK =	0x10;
const int PIC_ETH_MASK =         0x20;

const int PIC2_CTRL_REG = 	0xa0;
const int PIC2_MASK_REG =	0xa1;

const int PIC2_DK_MASK =		0x80;
const int PIC2_DK_NUM =		0x07; /* binary code of bit position */

#endif
