/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Vincent F. Russo (russo@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * PCi586i586CPU.h: The i586 processor on an AT&T 6586 pc.
 */

#ifndef PCi586i586CPU_h
#define PCi586i586CPU_h
#ifdef CFRONT
#define CONST const
#define STATIC static
#else /* must be g++ */
//#pragma interface
#if (__GNUG__ >= 2)
#if (!defined CONST)
#define CONST
#define STATIC
#endif
#else
#pragma once
#define CONST const
#define STATIC static
#endif
#endif

#include "OutputStream.h"
#include "i586CPU.h"
#include "Vectors.h"


class PCi586i586CPU : public i586CPU {
protected:
	/*
	 * Overloads of parent methods.
	 */
	void chipInitialize();
	void installInterrupts();

public:
	PCi586i586CPU( unsigned long identifier,
		ProcessContainer * initialIdleContainer );
	~PCi586i586CPU();
};

#endif /* PCi586i586CPU_h */
