/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: David W. Dykstra (dykstra@cs.uiuc.edu)
 *	   (adapted from AT&T Datakit VCS DKHOST source file)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * Urp.h: URP level C protocol definitions
 */

#ifndef Urp_h
#define Urp_h
#ifdef CFRONT
#define CONST const
#define STATIC static
#else /* must be g++ */
#pragma interface
#if (__GNUG__ >= 2)
#if (!defined CONST)
#define CONST
#define STATIC
#endif
#else
#pragma once
#define CONST const
#define STATIC static
#endif
#endif

const int SEQ =	0x08;	// 8 sequence numbers to end trailers
const int ECHO =	0x10;	// 8 echoes, data given to host
const int REJ =	0x18;	// 8 rejections, transmission error
const int ACK =	0x20;	// first of 8 acks, correct reception
const int BOT =	0x28;	// normal beginning of trailer
const int BOTM =	0x29;	// trailer with more data to follow
const int BOTS =	0x2A;	// seq update algorithm on this trailer
const int SOI =	0x2B;	// start of interrupt trailer
const int EOU =	0x2C;	// end of interrupt trailer
const int ENQ =	0x2D;	// xmitter request flow/error status
const int CHECK = 0x2E;	// xmitter request error status
const int INITREQ = 0x2F; // request initialization
const int INIT0 = 0x30;	// disable trailer processing
const int INIT1 = 0x31;	// enable trailer processing
const int AINIT = 0x32;	// response to INIT0/INIT1

const int SEQ_NO_MASK = 7; // sequence number mask

#endif     // Urp_h
