/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *               University of Illinois at Urbana-Champaign
 *               Department of Computer Science
 *               1304 W. Springfield Ave.
 *               Urbana, IL     61801
 *
 * Copyright (c) 1987-1992
 * The University of Illinois Board of Trustees.
 *      All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

#ifndef ADriver_h
#define ADriver_h
#ifdef CFRONT
#define CONST const
#define STATIC static
#else /* must be g++ */
#pragma interface
#if (__GNUG__ == 2)
#define CONST
#define STATIC
#else
#pragma once
#define CONST const
#define STATIC static
#endif
#endif

#include "SS1Am7990.h"
class NetworkBufferFreeList;

extern ClassStar ADriverClass;

class ADriver : public SS1Am7990 {
private:
	virtual NetworkBuffer *		getBuffer(unsigned int len) ;
	virtual void			releaseBuffer(NetworkBuffer *);

public:
	ADriver( volatile Am7990Word *rap,  volatile Am7990Word *rdp,
		   unsigned char debugMask = 0, NetworkBufferFreeList* fl=0 );
	~ADriver();

	virtual int transmitPacket(NetworkBuffer *b);
	virtual void 		receivePacket(NetworkBuffer *);
    Class * classOf();

};

#endif /* ADriver_h */
