/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987-1992
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
#ifndef PROM_h
#define PROM_h

#ifdef __GNUC__
#pragma interface
#endif

#ifdef OBMEM
#undef OBMEM
#endif

extern "C" {
#include <sys/promif.h>
};


class SS1PROM
{
public:
	static void setmemlists( struct memlist * &phys_available,
		struct memlist * &virt_available, struct memlist * &phys_total);
	static void exit_to_mon();
	static void getHWInfo();
};

extern struct memlist * getmemlist(char *name, char *prop);


#endif /* PROM_h */
