/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987-1992
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLAss
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

/*
 * SS1Disk.h: SS1 Disk Driver
 */

#ifndef SS1Disk_h
#define SS1Disk_h


#ifdef __GNUC__
#pragma interface
#endif


/* include stuff we need */
#include "Disk.h"
#include "Lock.h"
class ESP;
class SS1DiskPartition;
class PhysicalMemoryChain;              // forward reference

extern ClassStar SS1DiskClass;
class SS1Disk : public Disk {
friend class SS1Kernel;
friend class SS1DiskContainer;
    
    Lock mutex;
    ESP *_myController;
    SS1DiskPartition ** parts;

    // Drive specific information for this drive
    int 		_unit;
    unsigned		_blocks;
    unsigned		_blocksize;

 protected:

 public:
    Class * classOf();
    SS1Disk( ESP *controller, unsigned unit);
    int doio(unsigned start, int count, char *buf, int bufsiz, int direction);
    int basicDoio(unsigned start, char *, int ) { return 0;}
    int reset() {return 0;}
    int partitions(){return 8;}
    int locatePartition(int, int &, int &);
};

#endif  /* SS1Disk_h */
