/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987-1992
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

#ifndef	SS1DiskStar_h
#define	SS1DiskStar_h


#ifdef __GNUC__
#pragma interface
#endif

#include "PersistentMemoryObjectStar.h"
class SS1Disk;
class SS1DiskRef;

class SS1DiskStar : public PersistentMemoryObjectStar {
public:
	SS1DiskStar();

	SS1DiskStar( ProxiableObject * );
	SS1DiskStar( ProxiableObjectRef & const );
	SS1DiskStar( ProxiableObjectStar & const );

	SS1DiskStar( SS1Disk * );
	SS1DiskStar( SS1DiskRef & const );
	SS1DiskStar( SS1DiskStar & const );

	SS1DiskStar& const operator=( ProxiableObject * );
	SS1DiskStar& const operator=( ProxiableObjectRef & const );
	SS1DiskStar& const operator=( ProxiableObjectStar & const );

	SS1DiskStar& const operator=( SS1Disk * );
	SS1DiskStar& const operator=( SS1DiskRef & const );
	SS1DiskStar& const operator=( SS1DiskStar & const );

	operator SS1Disk *() const;
	SS1Disk * operator->() const;
};

class SS1DiskRef : public PersistentMemoryObjectRef {
public:
	SS1DiskRef();
	~SS1DiskRef();

	SS1DiskRef( ProxiableObject * );
	SS1DiskRef( ProxiableObjectRef & const );
	SS1DiskRef( ProxiableObjectStar & const );

	SS1DiskRef( SS1Disk * );
	SS1DiskRef( SS1DiskRef & const );
	SS1DiskRef( SS1DiskStar & const );

	SS1DiskRef& const operator=( ProxiableObject * );
	SS1DiskRef& const operator=( ProxiableObjectRef & const );
	SS1DiskRef& const operator=( ProxiableObjectStar & const );

	SS1DiskRef& const operator=( SS1Disk * );
	SS1DiskRef& const operator=( SS1DiskRef & const );
	SS1DiskRef& const operator=( SS1DiskStar & const );

	operator SS1Disk *() const;
	SS1Disk * operator->() const;
};

#endif SS1DiskStar_h
