/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *               University of Illinois at Urbana-Champaign
 *               Department of Computer Science
 *               1304 W. Springfield Ave.
 *               Urbana, IL     61801
 *
 * Copyright (c) 1987-1992
 * The University of Illinois Board of Trustees.
 *      All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

#ifndef SS1Gdb_h
#define SS1Gdb_h


#ifdef __GNUC__
#pragma interface
#endif

/*
 * This info comes from the gdb sources
 */

const unsigned NUM_REGISTERS	 = 72;
const unsigned NUMREGBYTES  = NUM_REGISTERS * 4;
/* 
 * BUFMAX is  the maximum number of characters in inbound/outbound buffers
 * at least NUMREGBYTES*2 are needed for register I/O packets
 */
const unsigned  BUFMAX  = 3 * NUMREGBYTES;

#ifdef NEVER
enum regnames {
        G0,G1,G2,G3,G4,G5,G6,G7,
        O0,O1,O2,O3,O4,O5,O6,O7,
        L0,L1,L2,L3,L4,L5,L6,L7,
        I0,I1,I2,I3,I4,I5,I6,I7,
        F0,F1,F2,F3,F4,F5,F6,F7,
        F8,F9,F10,F11,F12,F13,F14,F15,
        F16,F17,F18,F19,F20,F21,F22,F23,
        F24,F25,F26,F27,F28,F29,F30,F31,
        Y,PSR,WIM,TBR,PC,NPC,FPSR,CPSR
        };
#endif

void SPARCGdbHandler(int vector, char *trapStack);

inline void TrapToDebugger() {asm volatile ("ta %g0+1");}
// inline void TrapToDebugger() {asm volatile ("ta %g0");}

#endif /*SS1Gdb_h*/
