/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987-1992
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * SS1MMUConstants.h: Machine-dependent SPARC MMU constants
 */

#ifndef SS1MMUConstants_h
#define SS1MMUConstants_h


#ifdef __GNUC__
#pragma interface
#endif


#ifndef ASM
const unsigned NUM_SEGPTRS	= (1 << 12);
const unsigned SEGMENT_SIZE	= ((unsigned)( 1 << 18 ));
const unsigned PAGE_SIZE	= ((unsigned)( 1 << 12 ));


#endif /* ASM */

#endif	/* SS1MMUConstants_h */
