/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987-1992
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * Vectors.h: vector numbers for processor traps/interrupts.
 */

#ifndef Vectors_h
#define Vectors_h


#ifdef __GNUC__
#pragma interface
#endif


/*
 * Interrupt Vectors for this machine
 */

const unsigned VEC_INSN_ACCESS 	= 1;
const unsigned VEC_ILL_INSN 	= 2;
const unsigned VEC_PRIVL_INSN 	= 3;
const unsigned VEC_FP_DISABLED 	= 4;
const unsigned VEC_MEM_ALIGN 	= 7;
const unsigned VEC_FP_EXCEP 	= 8;
const unsigned VEC_DATA_ACCESS 	= 9;
const unsigned VEC_TAG_OVFL 	= 10;

/*
 * Hardware interrupts
 */
const unsigned VEC_SCSI 	= 19;
const unsigned VEC_ETHER 	= 21;
const unsigned VEC_TIMER 	= 26;
const unsigned VEC_UART 	= 28;
const unsigned VEC_FRTIMER 	= 30;
const unsigned VEC_ASYNCH_MEM 	= 31;

const unsigned VEC_PROXY 	= 128+64;
/*
 * Weird things from SunOS
 */
const unsigned VEC_BPT1 	= 128;
const unsigned VEC_BPT2 	= 128+1;
const unsigned VEC_DIV_ZERO 	= 128+2;
const unsigned VEC_FLUSH 	= 128+3;

#endif /* Vectors_h */
