/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *               University of Illinois at Urbana-Champaign
 *               Department of Computer Science
 *               1304 W. Springfield Ave.
 *               Urbana, IL     61801
 *
 * Copyright (c) 1987-1992
 * The University of Illinois Board of Trustees.
 *      All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

#ifndef zs_h
#define zs_h


#ifdef __GNUC__
#pragma interface
#endif


/*
 * A zs serial driver for the sparcstation.
 */

#include "zs_asm.h"

class zs {
	/* 
	 * The address of the control port, the data port is assumed to
	 * be at _myaddr + 2.
	 */
	volatile unsigned char *const _myaddr;

	/*
	 * for debugging 
	 */
	unsigned char rr0;
	unsigned char rr1;
	unsigned char rr2;
	unsigned char rr3;
	unsigned char rr4;
	unsigned char rr5;
	unsigned char rr6;
	unsigned char rr7;
	unsigned char rr8;
	unsigned char rr9;
	unsigned char rr10;
	unsigned char rr11;
	unsigned char rr12;
	unsigned char rr13;
	unsigned char rr14;
	unsigned char rr15;

public:
	void debug();
	zs(volatile unsigned char *const ADDR);
	/* 
	 * Read and write our control registers
	 */
	unsigned char readCTL(unsigned char const);
	void writeCTL(unsigned char const, unsigned char const);
	/*
	 * Read and write our data registers
	 */
	unsigned char readDATA();
	void writeDATA(unsigned char const);
	void enableRint();
};

#endif /* zs_h */
