/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Vincent F. Russo (russo@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * VCStupidAllocator.h: the dumbest way to implement an allocator.
 */

#ifndef VCStupidAllocator_h
#define VCStupidAllocator_h


#ifdef __GNUC__
#pragma interface
#endif

#include "Allocator.h"	/* the parent class */
extern "C" {
#ifdef __APPLE__
#include <sys/malloc.h>
#else
#include <malloc.h>
#endif
};

class VCStupidAllocator : public Allocator {
protected:
public:
	VCStupidAllocator(){}
	~VCStupidAllocator(){}
	void * allocate( unsigned int nbytes )
		{
		return (void*)::malloc(nbytes);
		}
	void free( void * cp ){}
};

#endif /*VCStupidAllocator_h*/
