/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987-1992
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

#ifndef VCTimesliceTimer_h
#define VCTimesliceTimer_h


#ifdef __GNUC__
#pragma interface
#endif

#include "Timer.h"

extern ClassStar VCTimesliceTimerClass;
class VCTimesliceTimer : public Timer {
protected:
	unsigned tickTime;
	unsigned expireTime;
	unsigned running;
public:
    VCTimesliceTimer(){ tickTime = expireTime = running = 0;}
    ~VCTimesliceTimer(){}

    unsigned int start( unsigned int );
    void set (unsigned){}
    unsigned int stop();
    unsigned int residual();
    int idle(){return ( !running );}
    void tick();

    Class * classOf();
};


#endif
