/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *a e Copyright (c) 1987-1992
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * VCHostDisk.h - Memory Object representing a disk connected to
 *		       an EMC on the Multimax.
 */

#ifndef VCHostDisk_h
#define	VCHostDisk_h


#ifdef __GNUC__
#pragma interface
#endif

#include "Disk.h"
#include "Raid.h"
#include "VCFileObject.h"
#include <string.h>



extern ClassStar VCHostDiskClass;
class VCHostDisk : public Disk {
  VCFileObject * _fileObj;
protected:
  //~VCHostDisk();
public:
	Class * classOf();
  //Class * supports( Class * );

  VCHostDisk( VCFileObject *fo);

	int partitions(){return 1;}
	int locatePartition( int idNumber, int &start, int &units )
		{start = 0; units = _numberOfUnits; return 0;}
	int reset(){return 0;}
	int basicDoio( unsigned int, char *, int ){return DiskOperFailed;}
};

#endif /*VCHostDisk_h*/
