/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Gary M. Johnston (johnston@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
#ifndef AddressFlushQueue_h
#define AddressFlushQueue_h


#ifdef __GNUC__
#pragma interface
#endif

static const unsigned AddressFlushQueueMaxSize = 20;

#include "Lock.h"

/*
 * Currently, this is not really a queue.
 */

class AddressFlushQueue {

	Lock lock;
	unsigned long cpuid;

	unsigned queueHead;
	unsigned queueTail;
	unsigned queueLength;

	struct { 
		const char * addr;
		unsigned int length;
	} queue[ AddressFlushQueueMaxSize ];

public:
	AddressFlushQueue( unsigned long identifier );
	void add( const char *, unsigned int length );
	void doFlush();
};

#endif
