/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Swee Boon Lim (sblim@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

/*
 * CheckSum.h
 */

#ifndef CheckSum_h
#define CheckSum_h


#ifdef __GNUC__
#pragma interface
#endif

class Object;

class CheckSum {
	Object * obj;
	int debugMask;
	int unitSize;
	int startUnit;
	int numberOfUnits;
	char * buffer;
	char * message;

public:
	CheckSum() { debugMask = 0; };
	void init( Object * _obj, char * _message,
		   int _startUnit, int _numberOfUnits, char * _buffer,
		   int _actualNoOfUnits = -1 );
        void evaluate( int actualNoOfUnits, int printMsg = 1 );
};

unsigned ByteSum( char * p, int count );

#define initCheckSum CheckSum _checkSum; if ( _debugMask & 64 ) _checkSum.init
#define evaluateCheckSum if ( _debugMask & 64 ) _checkSum.evaluate
#define checkSum CheckSum _checkSum; if ( _debugMask & 64 ) _checkSum.init

#endif /*CheckSum_h*/

