/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989 The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Aamod Sane (sane@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

#ifndef COW_h
#define COW_h


#ifdef __GNUC__
#pragma interface
#endif

#include "SimpleVM.h"

class COW_NPDC: public VM_NPDC {
  public:
    COW_NPDC(StateMachine * machine) : VM_NPDC(machine) {};
    
    virtual State * localRead(MemoryObjectCache * cache, unsigned unit,
			      AddressTranslation * adt);
    virtual State * localWrite(MemoryObjectCache * cache, unsigned unit,
			       AddressTranslation * adt);
};

class COW_P: public VM_P {
  public:
    COW_P(StateMachine * machine) : VM_P(machine) {};
    
    virtual State * localWrite(MemoryObjectCache * cache, unsigned unit,
			       AddressTranslation * adt);
};

class COWVMMachine : public SimpleVMMachine {
  public:
    COWVMMachine();
    
};

extern COWVMMachine * TheCOWVMMachine;

extern SimpleVMState * STATE_COW_P;
extern SimpleVMState * STATE_COW_NPDC;

#endif /* COW_h */
