/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989 The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Aamod Sane (sane@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

#ifndef DVMNetCom_h
#define DVMNetCom_h


#ifdef __GNUC__
#pragma interface
#endif

#include "NetworkBuffer.h"
#include "NetworkWalker.h"
#include "EthernetAdministrator.h"

class EthernetTransfer;
class NetworkBuffer;

class DVMWalker : public NetworkWalker {
    friend EthernetAdministrator;
    NetworkBuffer* _aBuffer;
protected:
public:
    DVMWalker();
    
    void walk(NetworkBuffer * buff);
    void setBuffer(NetworkBuffer * buff);
};


#endif /* DVMNetCom_h */
