/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *               University of Illinois at Urbana-Champaign
 *               Department of Computer Science
 *               1304 W. Springfield Ave.
 *               Urbana, IL     61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991, 1992
 * The University of Illinois Board of Trustees.
 *      All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted und
er license agreement.
 *
 * Author: Nayeem Islam (nislam@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant
 * No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

#ifndef DistEthernet_h
#define DistEthernet_h


#ifdef __GNUC__
#pragma interface
#endif

typedef unsigned char DistEthernetAddress[6];

// #include "Message.h"
// #include "EthernetTransfer.h"
// #include "EthernetTransport.h"
#include "ProxiableObject.h"
#include "Ethernet.h"

class Message;


static DistEthernetAddress broadcastAddress = { 255, 255, 255, 255,255,255 };

#define NAMESERVERPORT 1

static const ASYNC_MESSAGE = 1 ;
static const RPC_MESSAGE = 2 ;
static const BIG_MESSAGE = 3  ; // multi packet;

static EthernetProtocolID ETHERNET_HEADER_TYPE = 0x6969; 

class TransportHeader {
        friend class    EthernetTransfer;
        friend class    EthernetTransport;

        ProxiableObject *destMessagePort;
        unsigned int    type;
        unsigned int    messageId;
        unsigned int    fragment;
        unsigned int    size;
        unsigned int    seqNumbers;

        TransportHeader(Message *);
};
/*
class RCPTransportHeader : public TransportHeader {
        DistEthernetAddress         replyHost;
};
*/

class EthernetHeader {
        friend class    EthernetTransfer;
        friend class    EthernetTransport;

        DistEthernetAddress dest;
        DistEthernetAddress source;
        unsigned char   type[2];
        unsigned char   dummy[2];       /* used to word
alignment */
};

class RPCEthernetHeader : public EthernetHeader {
        DistEthernetAddress returnAddr;
};

#endif DistEthernet_h
