/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987-1992
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Swee Boon Lim (sblim@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * DummyCache.h
 */

#ifndef DummyCache_h
#define DummyCache_h


#ifdef __GNUC__
#pragma interface
#endif

#include "Cache.h"

extern ClassStar DummyCacheClass;

class DummyCache : public Cache {
protected:
	virtual unsigned basicSetNumberOfUnits( unsigned int unit );

	virtual int basicRead ( unsigned int startUnit, unsigned int count, char * addr,
 			        IOAsyncClosure * c );
	virtual int basicWrite( unsigned int startUnit,unsigned int count, char * addr,
				IOAsyncClosure * c );

public:
	Class * classOf();

	DummyCache( MemoryObjectCache * moc );

  
	virtual unsigned int setNumberOfUnits( unsigned int noOfUnits );

	virtual int exists( unsigned unit );

	virtual int read( unsigned int startUnit, unsigned int count, char * addr, 
			  IOAsyncClosure * c );
	virtual int write( unsigned int startUnit, unsigned int count, CacheUnitInfo * info,
			   char * addr, IOAsyncClosure * c );
	virtual int rawWrite( unsigned int startUnit, unsigned int count, CacheUnitInfo * info,
			      char * addr, IOAsyncClosure * c );
  virtual void invalidate( unsigned int startUnit, unsigned int count, int propagate ){}

   virtual void synchronize( unsigned int startUnit, unsigned int count,
                             unsigned &log2BufSize, char * & buffer )
  { Assert(NOTREACHED);}

    virtual void synchronize( unsigned int startUnit, unsigned int count,
				 unsigned  int log2BufSize, char * & buffer,
				  IOAsyncClosure * c )
  { Assert(NOTREACHED);}
	virtual int dirty();
};

#endif /*DummyCache_h*/
