/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Vincent F. Russo (russo@cs.uiuc.edu)
 * Contributing Author: Gary M. Johnston (johnston@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * FaultErrorCode.h: error codes returned from memory fault processing.
 */

#ifndef FaultErrorCode_h
#define FaultErrorCode_h


#ifdef __GNUC__
#pragma interface
#endif

enum FaultErrorCode {
	/*
	 * Fixable.
	 */
	MissingAddressTranslationMapping,
	MissingPhysicalMemory,
	InsufficientProtectionLevel,

	/*
	 *Fatal.
	 */
	AccessOfUnmanagedMemory,
	ReadOfProtectedSystemMemory,
	WriteOfProtectedSystemMemory,
	WriteOfReadOnlyMemory,

	/*
	 * These two are fatal as well be rather ill defined.
	 * They occur when a memory object should have oked the access
	 * but for some unknown reason rejected it.
	 */
	DynamicWriteOfReadOnlyMemory,
	DynamicAccessViolation
};

#endif /* FaultErrorCode_h */
