/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Vincent F. Russo (russo@cs.uiuc.edu)
 * Contributing Author: Peter W. Madany (madany@cs.uiuc.edu)
 * Contributing Author: Gary M. Johnston (johnston@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * PhysicalMemoryObject.h: A MemoryObject to read/write physical memory with.
 */

#ifndef PhysicalMemoryObject_h
#define PhysicalMemoryObject_h


#ifdef __GNUC__
#pragma interface
#endif

#include "MemoryObject.h"	/* parent class */
#include "MemoryObjectStar.h"

extern ClassStar PhysicalMemoryObjectClass;
class PhysicalMemoryObject : public MemoryObject {
protected:
	virtual void copyBlock( const char * psrc, const char * pdst,
		unsigned int count );	/* must be redefined by subclass */

	int rawRead( unsigned int unit, int count, char * dest, int nbytes );
	int rawWrite( unsigned int unit, int count, char * src, int nbytes,
		      int writeThrough );

public:
	Class * classOf();

	PhysicalMemoryObject();
};

inline
PhysicalMemoryObject::PhysicalMemoryObject()
	: MemoryObject( 0xffffffff, 0 )
{
	Assert( this != 0 );
}

extern MemoryObjectStar ThePhysicalMemoryObject;

#endif /* PhysicalMemoryObject_h */
