/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Swee Boon Lim (sblim@cs.uiuc.edu)
 * Author: Vincent F. Russo (russo@cs.uiuc.edu)
 * Author: Peter W. Madany (madany@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * PageOutAsync.h: 
 */

#ifndef PageOutAsync_h
#define PageOutAsync_h

#ifdef __GNUC__
#pragma interface
#endif

#include "MemoryObjectAsync.h"
#include "Semaphore.h"

class PhysicallyAddressableUnit;
class ReplacementPolicy;


enum PostFaultType
{
	PostFaultIndividual,
	PostFaultGroup
};

class PageOutAsyncClosure : public IOAsyncClosure {
protected:
	friend OutputStream & operator<< ( OutputStream & stream, 
					   PageOutAsyncClosure & c );

	ReplacementPolicy * _rp;
	unsigned _from;
	unsigned _to;
	PhysicallyAddressableUnit * _paus;
	PostFaultType _postFaultType;
	int _unitsToStoreCode;
	static void func( PageOutAsyncClosure * c );

public:
	static Semaphore _countSem;
	PageOutAsyncClosure( ReplacementPolicy * rp,
			     unsigned from, unsigned to, 
			     PhysicallyAddressableUnit * paus,
			     PostFaultType postFaultType, int unitsToStoreCode )
		: _rp( rp ), _from( from ), _to( to ), 
		  _paus( paus ), _postFaultType( postFaultType ),
	  //_urgency( 1 ), 
	  _unitsToStoreCode( unitsToStoreCode )
		   {_func = (AsyncFunc)&func;}
};



#endif /*PageOutAsync_h*/
