/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Vincent F. Russo (russo@cs.uiuc.edu)
 * Author: Bjorn A. Helgaas (helgaas@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * PhysicalMemoryManager.h - Physical memory management
 *	(collection of all PAU's).
 */

#ifndef PhysicalMemoryManager_h
#define PhysicalMemoryManager_h


#ifdef __GNUC__
#pragma interface
#endif

#include "Assert.h"
#include "PhysicalMemoryRange.h"
#include "PhysicallyAddressableUnit.h"


/*
 * A collection of PhysicallyAddressableUnits.
 */
extern ClassStar PhysicalMemoryManagerClass;
class PhysicalMemoryManager : public ProxiableObject {
protected:
	PhysicalMemoryRange * map;

	// the array of PhysicallyAddressableUnits.
	PhysicallyAddressableUnit ** theUnits;

public:
	PhysicalMemoryManager( PhysicalMemoryRange * systemMemoryMap );
	~PhysicalMemoryManager();

	PhysicallyAddressableUnit * lookup( const char * paddr );

	Class * classOf();
};

extern PhysicalMemoryManager * MainMemory;

#endif	/* PhysicalMemoryManager_h */
