/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987-1992
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Swee Boon Lim (sblim@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * RealCache.h
 */

#ifndef RealCache_h
#define RealCache_h


#ifdef __GNUC__
#pragma interface
#endif

#include "Cache.h"
#include "CacheUnitInfo.h"

extern ClassStar RealCacheClass;

class RealCache : public Cache {
protected:
	MultiLevelCacheUnitInfoTable _multiLevelCacheUnitInfoTable;

	virtual unsigned int basicSetNumberOfUnits( unsigned int unit );

public:
	Class * classOf();

	RealCache( MemoryObjectCache * moc );
};

#endif /*RealCache_h*/
