/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Aamod Sane (sane@cs.uiuc.edu)
 * Author: Vincent F. Russo (russo@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * RootMemoryObjectCache.h: Cache for the kernel heap.
 */

#ifndef RootMemoryObjectCache_h
#define RootMemoryObjectCache_h


#ifdef __GNUC__
#pragma interface
#endif

#include "SpecialPurposeCache.h"	/* parent class */

extern ClassStar RootMemoryObjectCacheClass;

class RootMemoryObjectCache : public SpecialPurposeCache {
/*
 * RootMemoryObjectCache is used for the kernel heap. All data
 * structures are preallocated in the constructor. Dynamic data
 * structures should not be used for this cache.
 */
      public:
	virtual Class * classOf();
	
	RootMemoryObjectCache( MemoryObject * mo );
	~RootMemoryObjectCache();
};

#endif /* RootMemoryObjectCache_h */
