/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Bjorn A. Helgaas (helgaas@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * SourceOfZerosMemoryObject.h: A MemoryObject to zero-fill a physical buffer
 */

#ifndef SourceOfZerosMemoryObject_h
#define SourceOfZerosMemoryObject_h


#ifdef __GNUC__
#pragma interface
#endif

#include "MemoryObject.h"
#include "RangeLocks.h"

extern ClassStar SourceOfZerosMemoryObjectClass;

class SourceOfZerosMemoryObject : public MemoryObject {
	SpecialRangeLock _specialLock;

protected:
	virtual int rawRead( unsigned startUnit, unsigned count,
			     char * addr, unsigned nbytes, IOAsyncClosure * c );
	virtual int rawWrite( unsigned startUnit, unsigned count,
			      char * addr, unsigned nbytes, int writeThrough,
			      IOAsyncClosure * c );
	
public:
	SourceOfZerosMemoryObject();

	virtual Class * classOf();
	virtual int fixedSize();
};

#endif /* SourceOfZerosMemoryObject_h */
