/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989 The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Aamod Sane (sane@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

#ifndef VMInterface_h
#define VMInterface_h


#ifdef __GNUC__
#pragma interface
#endif

#include "ProxiableObject.h"
#include "ProtectionLevel.h"

class MemoryObject;
class MemoryObjectCache;
class RecordStream;

extern ClassStar VMInterfaceClass;
class VMInterface: public ProxiableObject {
  public:
    Class * classOf();
    
    proxiable virtual void test(char * message);
    proxiable virtual MemoryObjectCache * createCache(RecordStream *,
						      char * cacheType);
    proxiable virtual char * addToDomain(RecordStream *,
					 ProtectionLevel p);
//     proxiable virtual void setupLDVM(RecordStream * origin,
// 				    RecordStream * copy);
//    proxiable virtual char * setupDVM(char * filename);
    proxiable virtual void setupCOW(RecordStream * origin,
				    RecordStream * copy);
    proxiable virtual void networkTest(char * to);
    proxiable virtual char * openDVM(char * filename);
    proxiable virtual void closeDVM(char * filename);
    proxiable virtual char * createSharedRegion( unsigned size );
};


#endif /* VMInterface_h */
