/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1990 The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 *
 * Author: Amit Parghi (parghi@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

/*
 *	NetworkStatistics.h
 *
 *	Misc useful stuff for Network programs
 *
 */

#ifndef NetworkStatistics_h
#define NetworkStatistics_h


#ifdef __GNUC__
#pragma interface
#endif


class NetworkStatistics {
public:
    NetworkStatistics();

    unsigned long transmitPacketCount;
    unsigned long transmitOctetCount;
    unsigned long receivePacketCount;
    unsigned long receiveOctetCount;
    unsigned long droppedPacketCount;
    unsigned long errorCount;
};


#endif /* ! NetworkStatistics_h */
