/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1992 The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 *
 * Author: Amit Parghi (parghi@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

/*
 *	NetworkWalker.h
 *
 *	Walkers used for processing incoming NetworkBuffers.
 *
 * $Id: NetworkWalker.h 2 2004-06-03 01:58:28Z jcarlyle $
 *
 */

#ifndef NetworkWalker_h
#define NetworkWalker_h


#ifdef __GNUC__
#pragma interface
#endif


#include "Object.h"

class NetworkBuffer;				// forward

    //	The NetworkWalker is an abstract superclass for the various
    //  protocol-specific Walker classes.
class NetworkWalker : public Object {
public:
    NetworkWalker();

    virtual ~NetworkWalker();

    virtual void walk(NetworkBuffer *) = 0;	// self subclassResponsibility
};

inline
NetworkWalker::NetworkWalker() {}

inline
NetworkWalker::~NetworkWalker() {}

#endif /* ! NetworkWalker_h */
