/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Johnny Zweig (zweig@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

/*
 * ConduitProtocolIndentifiers.h
 *
 */

#ifndef ConduitProtocolIdentifiers_h
#define ConduitProtocolIdentifiers_h


#ifdef __GNUC__
#pragma interface
#endif

enum ProtocolID {
	Undefined = 0,
	Ethernet = 1, // can't think of a better number... -JZ
	EchoingApplication = 7,
	TCP = 6,
	UDP = 17,
	IP = 0x0800,
	ICMP = 1	// Got this value from PROTO() in IPMessage.h. Need to double check. - dutta2
};

#endif  /* ConduitProtocolIdentifiers_h */
