/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Johnny Zweig (zweig@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 *
 *
 * File: ConduitTypes.h
 *
 */

#ifndef ConduitTypes_h
#define ConduitTypes_h


#ifdef __GNUC__
#pragma interface
#endif

#ifndef NULL
#define NULL 0
#endif
/*****************************************************************************
 *  This is the 1st evil machine-dependent part where we define various
 *  types of integers that have well-known numbers of bits. Needs to be
 *  tailored to suit local machine/compiler conventions.
 *****************************************************************************
 *  Notice that, in point of fact, this stuff is mostly just compiler
 *  dependent and should work for many machines -- so the name of the file is
 *  a little misleading.  Sorry.  -JZ
 *****************************************************************************/
#include "Types.h"

typedef	unsigned short int	int13; 
				/* assumed to contain 13 bits of useful data in
				   bits 0-12 (used by IP packets) */

typedef	unsigned char		nibble;
				/* assumed to contain 4 bits of useful data in
				   bits 0-3 */

//-----------------------------------------------------------------------------
extern void	octetcopy( octet * dest, const octet * src, int len );
			/* copies len octets; like strncpy() but for
			    octets. See code in MachineDependent.cc */
extern void	OctetCopy( const octet * src, octet * dest, int len );
//-----------------------------------------------------------------------------

#endif /* ConduitTypes_h */
