/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Johnny Zweig (zweig@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

/*
 * ZootConfig.h
 *
 */

#ifndef ZootConfig_h
#define ZootConfig_h


#ifdef __GNUC__
#pragma interface
#endif

#define DEFAULT_ARB_SIZE	200
		// Messages -- see Buffer, Conduit, StateMachine
#define ARB_RETRANSMIT_INTERVAL	7500000
		// (measured in 4-uS clock-ticks) -- See Buffer
#define TIME_WAIT_DURATION	500000000
		// Length of time a connection is left in TIME-WAIT state
		//   before being eligible to have its CD reused. Also
		//   measured in 4uS clock-ticks -- so this is 200 seconds.
#define DEFAULT_NUMBER_OF_APPLICATIONS	32
#define DEFAULT_WAIT_BUFFER_SIZE	100
		// Messages -- see Buffer, Conduit, StateMachine
#define DEFAULT_TTL		30
		// Time To Live for IP packets = 30 seconds -- see Conduit
#define	NETWORK_MSL		120
		// Maximum Segment Lifetime of a packet in the internet,
		//   arbitrarily estimated at 2 minutes. See Conduit,
		//   StateMachine
//-----------------------------------------------------------------------------
#endif ZootConfig_h
