/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801-2910
 *
 * Copyright (c) 1991 The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 *
 * Author: Amit Parghi (parghi@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

/*
 *	StubEthernetDriver.h
 *
 *	Definition of pseudo-EthernetDriver used for testing.
 *
 */


#ifndef StubEthernetDriver_h
#define StubEthernetDriver_h


#ifdef __GNUC__
#pragma interface
#endif

#include "EthernetDriver.h"

class NetworkBuffer;
class Process;


class StubEthernetDriver : public EthernetDriver {

private:
    unsigned short _sequenceNumber;
    Process * _dummyProcess;		// ptr to daemon "receiver" process

    virtual void receivePacket(octet *, unsigned int);

    //  daemon() pretends to receive an inbound ethernet packet every so often.
    void daemon();

public:
    StubEthernetDriver(unsigned char debugMask = 0x28);
    ~StubEthernetDriver();

    virtual int transmitPacket(NetworkBuffer *);
};


#endif /* StubEthernetDriver_h */
