/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Johnny Zweig (zweig@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

/*
 * IPChecksum.h
 *
 */
#ifndef IPChecksum_h
#define IPChecksum_h


#ifdef __GNUC__
#pragma interface
#endif

#include "Word.h"
#include "ConduitTypes.h"


extern Word16 IPChecksum( octet * datagram, int length );
	// datagram should point to very first octet to be checksummed,
	//   length should be total number of __octets__ (not 16-bit words)

inline Word16
CombineIPChecksums( Word16 chksum1, Word16 chksum2 )
{
	int32 tmp;
	int16 tmp2;
	tmp = chksum1.val() + chksum2.val();
	while( (tmp & 0xffff0000)  != 0x00000000 ) {
	    // Need while-loop since may overflow upon adding in carry-bits
	    //   (I hope the compiler can optimize away the bit-masking, etc.)
	    tmp = ( (tmp >> 16) & 0x0000ffff ) + ( tmp & 0x0000ffff );
	}
	tmp2 = tmp;
	return( Word16( tmp2 ) );
}

#endif IPChecksum_h
