/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *               University of Illinois at Urbana-Champaign
 *               Department of Computer Science
 *               1304 W. Springfield Ave.
 *               Urbana, IL     61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *      All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Lee Lup Yuen (lup@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

/*
 * AboriginalPing.h
 */
 
#ifndef AboriginalPing_h
#define AboriginalPing_h


#ifdef __GNUC__
#pragma interface
#endif

#include "Conduit.h"
#include "ApplicationConduitStream.h"

// Global variables.  Bad, yes.  Necessary, sometimes.
int AboriginalPingControllerInitialized;

volatile ICMPConduit * myICMPConduit;
volatile EthernetConduit * myEthernetConduit;
volatile IPConduit * myIPConduit;

class Process;
class ClassStar;
class UserSession;

class AboriginalPing : public ApplicationConduitStream
{

public:
  AboriginalPing();
  ~AboriginalPing();

};

#endif

