/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *               University of Illinois at Urbana-Champaign
 *               Department of Computer Science
 *               1304 W. Springfield Ave.
 *               Urbana, IL     61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *      All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Lee Lup Yuen (lup@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

/*
 * AboriginalTelnet.h
 */
 
#ifndef AboriginalTelnet_h
#define AboriginalTelnet_h


#ifdef __GNUC__
#pragma interface
#endif

#include "ApplicationConduitStream.h"

class Process;
class ClassStar;
class UserSession;
extern ClassStar AboriginalTelnetClass;

class AboriginalTelnet : public ApplicationConduitStream
{
    /* An AboriginalTelnet conduit provides Telnet service.  Simple IAC
     * commands are supported.  Runs bash upon connection.
     */
public:
    AboriginalTelnet ();
    ~AboriginalTelnet ();
    Class *classOf ();
protected:
    int passivePort () { return 23; }
    static void aboriginalTelnetDaemon (AboriginalTelnet *client);
    static void startupShell (AboriginalTelnet *client);
    static void userLogin (AboriginalTelnet *client);
    PFV *passiveDaemon () { return (PFV *) aboriginalTelnetDaemon; }
    PFV *activeDaemon () { Assert (0); return 0; }
    char *processIncomingMessage (TCPMessage *msg, int &length);
    char *processOutgoingMessage (const char *buffer, int &count);
    void processIACCommand ();
    unsigned char iacCommand [1000];
    int iacMode, iacCommandIndex;
};

#endif
