/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *               University of Illinois at Urbana-Champaign
 *               Department of Computer Science
 *               1304 W. Springfield Ave.
 *               Urbana, IL     61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *      All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Lee Lup Yuen (lup@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

/*
 * ApplicationConduitInputStream.cc
 */
 
#ifndef ApplicationConduitInputStream_h
#define ApplicationConduitInputStream_h


#ifdef __GNUC__
#pragma interface
#endif

#include "Assert.h"
#include "InputStream.h"
#include "CharacterInputStream.h"

class ApplicationConduitStream;
extern ClassStar ApplicationConduitInputStreamClass;

class ApplicationConduitInputStream : public CharacterInputStream
{
    /* A ConduitInputStream provides a CharacterInputStream interface to
     * an ApplicationConduitStream.
     */
public:
    proxiable ApplicationConduitInputStream (ApplicationConduitStream
    	*conduit);
    ~ApplicationConduitInputStream ();
    //  Not really proxiable, but proxify++ complains about read being
    //  an abstract virtual function.
    proxiable int read (char *buffer, int count);
    void switchCharacterQueue (int type);
    int enqueue (const char *buffer, int count) { Assert (0); return 0; }
    CharacterQueue *queue() { Assert (0); return 0; }
    Class *classOf ();
private:
    ApplicationConduitStream *conduitStream;
};

#endif
