/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *               University of Illinois at Urbana-Champaign
 *               Department of Computer Science
 *               1304 W. Springfield Ave.
 *               Urbana, IL     61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *      All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Lee Lup Yuen (lup@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

/*
 * FTP.h
 */
 
#ifndef FTP_h
#define FTP_h


#ifdef __GNUC__
#pragma interface
#endif

#include "ApplicationConduitStream.h"

class Sempahore;
extern ClassStar FTPClass;

class FTP : public ApplicationConduitStream
{
    /* A FTP conduit waits for incoming FTP connections and runs the
     * FTP server application upon connection.
     */
public:
    FTP ();
    ~FTP ();
    Class *classOf ();
protected:
    int passivePort () { return 21; }
    static void FTPDaemon (FTP *client);
    static void executeCommand (FTP *client);
    PFV *passiveDaemon () { return (PFV *) FTPDaemon; }
    PFV *activeDaemon () { Assert (0); return 0; }
    unsigned long clientAddress;
    unsigned int clientPort;
};

#endif
