/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Douglas E. Leyens (leyens@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

/*
 *  These are system events that may be used by the scheduler.  
 */

#ifndef ProcessEvents_h
#define ProcessEvents_h


#ifdef __GNUC__
#pragma interface
#endif

/*
 * Events used by the VMSSchedulerUSS scheduler to determine 
 * priority increments.
 */
enum ProcessEvent {
	DIRECT_IO,
	BUFFERED_IO,
	UPDATE_SECTION,
	SET_PRIORITY,
	RESOURCE_AVAILABLE,
	WAKE_PROCESS,
	RESUME_PROCESS,
	DELETE_PROCESS,
	TIMER_EXPIRATION,
	PROCESS_CREATION,

/*
 * Events used by the UNIXSchedulerUSS scheduler to determine kernel
 * mode priorities.
 */
	SWAPPER,
	DISK_IO,
	BUFFER,
	INODE,
	CHILD_EXIT,

/*
 * Events used by both the VMSSchedulerUSS and UNIXSchedulerUSS schedulers.
 */
	TTY_INPUT,
	TTY_OUTPUT
};

#endif /* ProcessEvents_h */
