/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987-1992
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * ARMPageTableConstants.h:
 */

#ifndef ARMPageTableConstants_h
#define ARMPageTableConstants_h


#ifdef __GNUC__
#pragma interface
#endif

static const unsigned int Log2PhysicalPageSize     = 12;
static const unsigned int PhysicalPageSize         = 1 << Log2PhysicalPageSize;

/*
 * The following constants are used primarily by the TwoLevelPageTable class.
 */

const int Log2PointerTableEntries  = 12;
const int PointerTableEntries      = 1 << Log2PointerTableEntries;
const int PointerTableSize         = PointerTableEntries * 4;
const int PointerTableAlign        = 16*1024;

const int Log2PageTableEntries     = 8;
const int PageTableEntries         = 1 << Log2PageTableEntries;
const int PageTableSize            = PageTableEntries * 4;
const int PageTableAlign           = 1024;

static const int Pte_PROTECT_LEVELS	 = 4;

enum ARMProtection { 
	SYSTEMRO = 0,
	SYSTEMRW = 1, 
	USERRO = 2,
	USERRW = 3,
	NOACCESS = 0
};

// Valid page is a small page table entry - 4KB
#define L2_V 0x2
#define L2_B 0x4
#define L2_C 0x8

// valid pointer table entry is for a coarse page
#define L1_V 0x11
#define L1_DOMAIN 0x1E0

#endif	/* ARMPageTableConstants_h */
