/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *               University of Illinois at Urbana-Champaign
 *               Department of Computer Science
 *               1304 W. Springfield Ave.
 *               Urbana, IL     61801
 *
 * Copyright (c) 1987-2005
 * The University of Illinois Board of Trustees.
 *      All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Ellick Chan (emchan@uiuc.edu)
 * Author: Francis David (fdavid@uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

#ifndef ARMTRANSLATION_h
#define ARMTRANSLATION_h

#ifdef __GNUC__
#pragma interface
#endif

#include "AddressTranslation.h"	/* parent class */
#include "PAGE_TABLE_ENTRY.h"
#include "PhysicalMemoryRange.h"
#include "TwoLevelPageTable.h"

extern ClassStar ARMTranslationClass;
class ARMTranslation : public TwoLevelPageTable {
		friend void PhysicalMemorySetup();
protected:
	unsigned _enabled;
	
public:
	ARMTranslation(ARMTranslation *);
	~ARMTranslation();

	static void init( unsigned int tableAreaSize,
		VirtualMemoryRange * systemMemoryMap );
		
	virtual PAGE_TABLE_ENTRY *allocatePageTable();
	virtual POINTER_TABLE_ENTRY *allocatePointerTable();

	virtual int basicChangeStatus ( const char * vaddr,
                                    unsigned int nbytes, AddressTranslationStatus clear,
                                    AddressTranslationStatus set);
};

#endif /* ARMTRANSLATION_h */
