/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Bjorn A. Helgaas (helgaas@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * MC68030ContextOffsets.h: Structure offsets for use in assembler files
 */

#ifndef MC68030ContextOffsets_h
#define MC68030ContextOffsets_h


#ifdef __GNUC__
#pragma interface
#endif


/*
 * The following offsets are defined for use in MC68030ContextSwitching.s.
 * They MUST correspond exactly to the layout of MC68030GenericContext
 * and MC68030ApplicationContext, defined in MC68030Context.h.
 *
 * These should be generated automatically, but aren't yet!
 */

#define VECTOR_STACKFRAME		22

#define SUPERVISORSTACKPOINTER_MC68030GENERICCONTEXT		20
#define SUPERVISORSTACKBASE_MC68030GENERICCONTEXT		24
#define SUPERVISORSTACKBOUND_MC68030GENERICCONTEXT		28
#define REGISTERS_MC68030GENERICCONTEXT				32
#define PC_MC68030GENERICCONTEXT				76
#define USERSTACKPOINTER_MC68030APPLICATIONCONTEXT		80

/*
 * The following offsets are based on the CPU and Process structures
 * and are used in MacintoshStart.s.
 */

#define IDLEPROCESS_CPU			20
#define CURRENTPROCESS_CPU		24

#define PROCESSCONTEXT_PROCESS		20

#define OWNER_PROCESSORCONTEXT		16

#endif /* MC68030ContextOffsets_h */
