/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Bjorn A. Helgaas (helgaas@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * MC68030GnuDebugger.h:
 */

#ifndef MC68030GnuDebugger_h
#define	MC68030GnuDebugger_h


#ifdef __GNUC__
#pragma interface
#endif

#include "InputStream.h"
#include "Object.h"
#include "OutputStream.h"


extern ClassStar MC68030GnuDebuggerClass;
class MC68030GnuDebugger : public GnuDebugger {
protected:
	virtual int bufferSize();

	virtual int vectorToSignal( int vector );
	virtual void stepOrContinue( char * inbuffer );
	virtual void resumeExecution();

public:
	MC68030GnuDebugger( InputStream * inputStream,
		OutputStream * outputStream );

	virtual Class * classOf();
};

#endif /* MC68030GnuDebugger_h */
