/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Vincent F. Russo (russo@cs.uiuc.edu)
 * Contributing Author: Gary M. Johnston (johnston@cs.uiuc.edu)
 * Contributing Author: Bjorn A. Helgaas (helgaas@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * MC68030Interrupts.h: hardware interrupt sub-class descriptions for the
 *	MC68030 processor.
 */

#ifndef MC68030Interrupts_h
#define MC68030Interrupts_h


#ifdef __GNUC__
#pragma interface
#endif

#include "Interrupt.h"		/* parent class */


extern ClassStar StrayInterruptClass;
class StrayInterrupt : public Interrupt {
protected:
	char * message;
	virtual void basicRaise( char * );
public:
	StrayInterrupt( char * msg );

	virtual Class * classOf();
};

inline
StrayInterrupt::StrayInterrupt( char * msg )
{
	message = msg;
}

extern ClassStar BusErrorInterruptClass;
class BusErrorInterrupt : public Interrupt {
protected:
	virtual void basicRaise( char * info );
public:
	virtual Class * classOf();
};


extern ClassStar LongjmpInterruptClass;
class LongjmpInterrupt : public Interrupt {
protected:
	int * _buffer;
	virtual void basicRaise( char * );
public:
	LongjmpInterrupt( int * );

	virtual Class * classOf();
};

inline
LongjmpInterrupt::LongjmpInterrupt( int * buffer )
{
	_buffer = buffer;
}


extern ClassStar ProxyGateTrapClass;
class ProxyGateTrap : public Interrupt {
protected:
	virtual void basicRaise( char * );
public:
	virtual Class * classOf();
};

#endif /* MC68030Interrupts_h */
