/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Vincent F. Russo (russo@cs.uiuc.edu)
 * Contributing Author: Gary M. Johnston (johnston@cs.uiuc.edu)
 * Contributing Author: Bjorn A. Helgaas (helgaas@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * AddressTranslator.h: Hardware AddressTranslator class.
 */

#ifndef MC68030MMU_h
#define MC68030MMU_h


#ifdef __GNUC__
#pragma interface
#endif

#include "AddressTranslator.h"	/* parent class */

 
extern ClassStar MC68030MMUClass;
class MC68030MMU : public AddressTranslator {
public:
	MC68030MMU();

	virtual void enable();
	virtual int enabled();

	virtual void basicActivate( AddressTranslation * newTranslation );
	virtual AddressTranslationFailureCode faultType( const char *,
		unsigned int, AddressTranslation *, AccessType & );
	virtual void flushCache( const char * address, unsigned int length );

	virtual Class * classOf();
};

#endif /* MC68030MMU_h */
