/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Bjorn A. Helgaas (helgaas@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * MC68030PageTableConstants.h:
 */

#ifndef MC68030PageTableConstants_h
#define MC68030PageTableConstants_h


#ifdef __GNUC__
#pragma interface
#endif


/*
 * The following constants are used primarily by the TwoLevelPageTable class.
 */

const int Log2PhysicalPageSize     = 12;
const int PhysicalPageSize         = 4096;

const int Log2PointerTableEntries  = 10;
const int PointerTableEntries      = 1024;
const int PointerTableSize         = 4096;

const int Log2PageTableEntries     = 10;
const int PageTableEntries         = 1024;
const int PageTableSize            = 4096;

enum MC68030Protection { READWRITE = 0, READONLY = 1 };

#endif	/* MC68030PageTableConstants_h */
