/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Bjorn A. Helgaas (helgaas@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * MC68030Vectors.h: vector numbers for 68030 processor traps/interrupts.
 */

#ifndef MC68030Vectors_h
#define MC68030Vectors_h


#ifdef __GNUC__
#pragma interface
#endif

/*
 * Processor-specific interrupt vectors (see MC68030 Users Manual).
 */
const int RESET_Vector =			 0;
const int BUS_ERROR_Vector =		 2;
const int ADDRESS_ERROR_Vector =		 3;
const int ILLEGAL_INSTRUCTION_Vector =	 4;
const int DIVIDE_BY_ZERO_Vector =	 5;
const int CHK_Vector =			 6;
const int TRAP_Vector =			 7;
const int PRIVILEGE_VIOLATION_Vector =	 8;
const int TRACE_Vector =			 9;
const int LINE_A_EMULATOR_Vector =	10;
const int LINE_F_EMULATOR_Vector =	11;
const int COPROCESSOR_PROTOCOL_Vector =	13;
const int FORMAT_ERROR_Vector =		14;
const int UNINITIALIZED_Vector =		15;
const int RESERVED_16_Vector =		16;
const int RESERVED_17_Vector =		17;
const int RESERVED_18_Vector =		18;
const int RESERVED_19_Vector =		19;
const int RESERVED_20_Vector =		20;
const int RESERVED_21_Vector =		21;
const int RESERVED_22_Vector =		22;
const int RESERVED_23_Vector =		23;
const int SPURIOUS_Vector =		24;
const int TRAP_0_Vector =		32;
const int MMU_CONFIGURATION_Vector =	56;

#endif /* MC68030Vectors_h */
