/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Bjorn A. Helgaas (helgaas@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 *	Util.h: declarations for assembly-level routines we use with the
 *		MC68030 machines.
 */

#ifndef Util_h
#define Util_h


#ifdef __GNUC__
#pragma interface
#endif

typedef int setjmpBuffer [13];

#define CACHE_DISABLE	0x0
#define CACHE_ENABLE	0x3919
#define CACHE_FLUSH	0x808

extern "C" {
extern int setjmp( setjmpBuffer );
extern void longjmp();
extern int processorCachesEnabled();
extern int disableProcessorCaches();
extern int enableProcessorCaches();
extern void physicalCopy( char * src, char * dst, int cnt );
extern int interruptsEnabled();
extern int disableInterrupts();
extern void enableInterrupts();
};

#endif Util_h
