/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Vincent F. Russo (russo@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * NS32202.h
 */

#ifndef NS32202_h
#define NS32202_h


#ifdef __GNUC__
#pragma interface
#endif

static unsigned char * const MasterHCVT	= (unsigned char *) 0xfffffe00;
static unsigned char * const MasterSVCT = (unsigned char *) 0xfffffe04;
static unsigned char * const MasterELTGL = (unsigned char *) 0xfffffe08;
static unsigned char * const MasterELTGH = (unsigned char *) 0xfffffe0c;
static unsigned char * const MasterTPLL	= (unsigned char *) 0xfffffe10;
static unsigned char * const MasterTPLH	= (unsigned char *) 0xfffffe14;
static unsigned char * const MasterIPNDL = (unsigned char *) 0xfffffe18;
static unsigned char * const MasterIPNDH = (unsigned char *) 0xfffffe1c;
static unsigned char * const MasterISRVL = (unsigned char *) 0xfffffe20;
static unsigned char * const MasterISRVH = (unsigned char *) 0xfffffe24;
static unsigned char * const MasterIMSKL = (unsigned char *) 0xfffffe28;
static unsigned char * const MasterIMSKH = (unsigned char *) 0xfffffe2c;
static unsigned char * const MasterCSRCL = (unsigned char *) 0xfffffe30;
static unsigned char * const MasterCSRCH = (unsigned char *) 0xfffffe34;
static unsigned char * const MasterFPRTL = (unsigned char *) 0xfffffe38;
static unsigned char * const MasterFPRTH = (unsigned char *) 0xfffffe3c;
static unsigned char * const MasterMCTL = (unsigned char *) 0xfffffe40;
static unsigned char * const MasterOCASN = (unsigned char *) 0xfffffe44;
static unsigned char * const MasterCIPTR = (unsigned char *) 0xfffffe48;
static unsigned char * const MasterPDAT = (unsigned char *) 0xfffffe4c;
static unsigned char * const MasterIPS = (unsigned char *) 0xfffffe50;
static unsigned char * const MasterPDIR	= (unsigned char *) 0xfffffe54;
static unsigned char * const MasterCCTL = (unsigned char *) 0xfffffe58;
static unsigned char * const MasterCICTL = (unsigned char *) 0xfffffe5c;
static unsigned char * const MasterLCSVL = (unsigned char *) 0xfffffe60;
static unsigned char * const MasterLCSVH = (unsigned char *) 0xfffffe64;
static unsigned char * const MasterHCSVL = (unsigned char *) 0xfffffe68;
static unsigned char * const MasterHCSVH = (unsigned char *) 0xfffffe6c;
static unsigned char * const MasterLCCVL = (unsigned char *) 0xfffffe70;
static unsigned char * const MasterLCCVH = (unsigned char *) 0xfffffe74;
static unsigned char * const MasterHCCVL = (unsigned char *) 0xfffffe78;
static unsigned char * const MasterHCCVH = (unsigned char *) 0xfffffe7c;

static unsigned char * const SlaveHCVT = (unsigned char *) 0xfffffe80;
static unsigned char * const SlaveSVCT = (unsigned char *) 0xfffffe84;
static unsigned char * const SlaveELTGL = (unsigned char *) 0xfffffe88;
static unsigned char * const SlaveELTGH = (unsigned char *) 0xfffffe8c;
static unsigned char * const SlaveTPLL = (unsigned char *) 0xfffffe90;
static unsigned char * const SlaveTPLH = (unsigned char *) 0xfffffe94;
static unsigned char * const SlaveIPNDL = (unsigned char *) 0xfffffe98;
static unsigned char * const SlaveIPNDH = (unsigned char *) 0xfffffe9c;
static unsigned char * const SlaveISRVL = (unsigned char *) 0xfffffea0;
static unsigned char * const SlaveISRVH = (unsigned char *) 0xfffffea4;
static unsigned char * const SlaveIMSKL = (unsigned char *) 0xfffffea8;
static unsigned char * const SlaveIMSKH = (unsigned char *) 0xfffffeac;
static unsigned char * const SlaveCSRCL = (unsigned char *) 0xfffffeb0;
static unsigned char * const SlaveCSRCH = (unsigned char *) 0xfffffeb4;
static unsigned char * const SlaveFPRTL = (unsigned char *) 0xfffffeb8;
static unsigned char * const SlaveFPRTH	= (unsigned char *) 0xfffffebc;
static unsigned char * const SlaveMCTL = (unsigned char *) 0xfffffec0;
static unsigned char * const SlaveOCASN = (unsigned char *) 0xfffffec4;
static unsigned char * const SlaveCIPTR = (unsigned char *) 0xfffffec8;
static unsigned char * const SlavePDAT = (unsigned char *) 0xfffffecc;
static unsigned char * const SlaveIPS = (unsigned char *) 0xfffffed0;
static unsigned char * const SlavePDIR = (unsigned char *) 0xfffffed4;
static unsigned char * const SlaveCCTL = (unsigned char *) 0xfffffed8;
static unsigned char * const SlaveCICTL = (unsigned char *) 0xfffffedc;
static unsigned char * const SlaveLCSVL = (unsigned char *) 0xfffffee0;
static unsigned char * const SlaveLCSVH	= (unsigned char *) 0xfffffee4;
static unsigned char * const SlaveHCSVL	= (unsigned char *) 0xfffffee8;
static unsigned char * const SlaveHCSVH	= (unsigned char *) 0xfffffeec;
static unsigned char * const SlaveLCCVL	= (unsigned char *) 0xfffffef0;
static unsigned char * const SlaveLCCVH	= (unsigned char *) 0xfffffef4;
static unsigned char * const SlaveHCCVL	= (unsigned char *) 0xfffffef8;
static unsigned char * const SlaveHCCVH	= (unsigned char *) 0xfffffefc;
#undef volatile

#endif /* NS32202_h */
