/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Vincent F. Russo (russo@cs.uiuc.edu)
 * Contributing Author: Gary M. Johnston (johnston@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * NS32332Interrupts.h: hardware interrupt sub-class descriptions for the
 *	NS32332 processor.
 */

#ifndef NS32332Interrupts_h
#define NS32332Interrupts_h


#ifdef __GNUC__
#pragma interface
#endif

#include "Interrupt.h"		/* parent class */

class StrayInterrupt : public Interrupt {
protected:
	char * message;
	void basicRaise( char * );
public:
	StrayInterrupt( char * msg );
};

inline
StrayInterrupt::StrayInterrupt( char * msg )
{
	message = msg;
}

class AbortTrap : public Interrupt {
protected:
	void basicRaise( char * info );
public:
};

class SVCTrap : public Interrupt {
protected:
	void basicRaise( char * info );
public:
};

#endif /* NS32332Interrupts_h */
