/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Vincent F. Russo (russo@cs.uiuc.edu)
 * Contributing Author: Gary M. Johnston (johnston@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * AddressTranslator.h: Hardware AddressTranslator class.
 */

#ifndef NS32382MMU_h
#define NS32382MMU_h


#ifdef __GNUC__
#pragma interface
#endif

#include "AddressTranslator.h"	/* parent class */
#include "ADDRESS_TRANSLATION.h"

extern void FlushMMU();
 
extern ClassStar NS32382MMUClass;
class NS32382MMU : public AddressTranslator {
protected:
public:
	NS32382MMU();

	virtual void enable();
	virtual int enabled();

	virtual void basicActivate( AddressTranslation *); 
	virtual AddressTranslationFailureCode faultType( const char *,
	    unsigned int, AddressTranslation *,  AccessType & );
	virtual void flushCache( const char * address, unsigned int length );

	static void load( AddressTranslation * );

	virtual Class * classOf();
};

inline void
NS32382MMU::load( AddressTranslation * at)
{
	POINTER_TABLE_ENTRY * pointerTable = ( (ADDRESS_TRANSLATION *) at )->pointerTable( );
	asm volatile( "lmr ptb0,%0; lmr ptb1,%0" : : "g" (pointerTable) );
}

#endif /* NS32382MMU_h */
