/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Vincent F. Russo (russo@cs.uiuc.edu)
 * Contributing Author: Peter W. Madany (madany@cs.uiuc.edu)
 * Contributing Author: Gary M. Johnston (johnston@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * NS32332PhysicalMemoryObject.h: A MemoryObject to read/write physical 
 *	memory with.
 */

#ifndef NS32332PhysicalMemoryObject_h
#define NS32332PhysicalMemoryObject_h


#ifdef __GNUC__
#pragma interface
#endif

#include "PhysicalMemoryObject.h"	/* parent class */

extern ClassStar NS32332PhysicalMemoryObjectClass;
class NS32332PhysicalMemoryObject : public PhysicalMemoryObject {
protected:
	void copyBlock( const char * psrc, const char * pdst,
		unsigned int count );
public:
	Class * classOf();

	NS32332PhysicalMemoryObject();
};

inline
NS32332PhysicalMemoryObject::NS32332PhysicalMemoryObject()
{
	Assert( this != 0 );
}

#endif /* NS32332PhysicalMemoryObject_h */
