/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987-1992
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * SPARCPhysicalMemoryObject.h: A MemoryObject to read/write physical 
 *	memory with.
 */

#ifndef SPARCPhysicalMemoryObject_h
#define SPARCPhysicalMemoryObject_h


#ifdef __GNUC__
#pragma interface
#endif


#include "PhysicalMemoryObject.h"	/* parent class */

class PhysicalMemoryChain;	// forward reference...

extern ClassStar SPARCPhysicalMemoryObjectClass;
class SPARCPhysicalMemoryObject : public PhysicalMemoryObject {
protected:
	void copyBlock( const char * psrc, const char * pdst,
		unsigned int count );
public:
	Class * classOf();

	SPARCPhysicalMemoryObject();
};

inline
SPARCPhysicalMemoryObject::SPARCPhysicalMemoryObject()
{
	Assert( this != 0 );
}

#endif /* SPARCPhysicalMemoryObject_h */
