/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987-1992
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

#ifndef SPARCDataTypes_h
#define SPARCDataTypes_h

#ifdef __GNUC__
#pragma interface
#endif

#undef n16 /* in case a multimax defined it */

union byte {
	unsigned all;
	struct {
		unsigned n0	:1 ;
		unsigned n1	:1 ;
		unsigned n2	:1 ;
		unsigned n3	:1 ;
		unsigned n4	:1 ;
		unsigned n5	:1 ;
		unsigned n6	:1 ;
		unsigned n7	:1 ;
	} bit;
};


union word {
	unsigned all;
	struct {
		unsigned n0	:8 ;
		unsigned n1	:8 ;
	} byte;
	struct {
		unsigned n0	:1 ;
		unsigned n1	:1 ;
		unsigned n2	:1 ;
		unsigned n3	:1 ;
		unsigned n4	:1 ;
		unsigned n5	:1 ;
		unsigned n6	:1 ;
		unsigned n7	:1 ;
		unsigned n8	:1 ;
		unsigned n9	:1 ;
		unsigned n10	:1 ;
		unsigned n11	:1 ;
		unsigned n12	:1 ;
		unsigned n13	:1 ;
		unsigned n14	:1 ;
		unsigned n15	:1 ;
	} bit;
};


union doubleword {
	unsigned all;
	struct	{
		unsigned n0	:16;
		unsigned n1	:16;
	} word;
	struct 	{
		unsigned n0	:8 ;
		unsigned n1	:8 ;
		unsigned n2	:8 ;
		unsigned n3	:8 ;
	} byte;
	struct {
		unsigned n0	:1 ;
		unsigned n1	:1 ;
		unsigned n2	:1 ;
		unsigned n3	:1 ;
		unsigned n4	:1 ;
		unsigned n5	:1 ;
		unsigned n6	:1 ;
		unsigned n7	:1 ;
		unsigned n8	:1 ;
		unsigned n9	:1 ;
		unsigned n10	:1 ;
		unsigned n11	:1 ;
		unsigned n12	:1 ;
		unsigned n13	:1 ;
		unsigned n14	:1 ;
		unsigned n15	:1 ;
		unsigned n16	:1 ;
		unsigned n17	:1 ;
		unsigned n18	:1 ;
		unsigned n19	:1 ;
		unsigned n20	:1 ;
		unsigned n21	:1 ;
		unsigned n22	:1 ;
		unsigned n23	:1 ;
		unsigned n24	:1 ;
		unsigned n25	:1 ;
		unsigned n26	:1 ;
		unsigned n27	:1 ;
		unsigned n28	:1 ;
		unsigned n29	:1 ;
		unsigned n30	:1 ;
		unsigned n31	:1 ;
	} bit;
};

#endif SPARCDataTypes_h
