/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *               University of Illinois at Urbana-Champaign
 *               Department of Computer Science
 *               1304 W. Springfield Ave.
 *               Urbana, IL     61801
 *
 * Copyright (c) 1987-1992
 * The University of Illinois Board of Trustees.
 *      All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

#ifndef SPARCMMU_h
#define SPARCMMU_h


#ifdef __GNUC__
#pragma interface
#endif

#include "AddressTranslator.h"	/* parent class */

extern unsigned npmegs;
extern unsigned nctxts;

class SPARCMMU : public AddressTranslator {
protected:
	unsigned _enabled;
public:
	SPARCMMU();
	void basicActivate( AddressTranslation *);
	void enable(){ _enabled = 1;}
	int enabled() {return _enabled;}

	void flushCache( const char* address, unsigned int length){}
};

#endif /* SPARCMMU_h */
