/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1990,1991,1992 The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 *
 * Author: Nayeem Islam (nislam@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

/*
 *	SPARCNetworkBufferFreeList.h
 *
 *	Preallocated Buffers used for data coming in from the network.
 *
 * $Id: SPARCNetworkBufferFreeList.h 2 2004-06-03 01:58:28Z jcarlyle $
 *
 */

#ifndef SPARCNetworkBufferFreeList_h
#define SPARCNetworkBufferFreeList_h


#ifdef __GNUC__
#pragma interface
#endif

#include "Link.h"
#include "HexDump.h"
#include "NetworkBuffer.h"
extern ClassStar SPARCNetworkBufferFreeListClass;

class SPARCNetworkBufferFreeList : public NetworkBufferFreeList {
public:
    SPARCNetworkBufferFreeList( unsigned int bufferSize = 2048, // size per buffer
			  unsigned int listSize = 10);   // num of buffers

    ~SPARCNetworkBufferFreeList();

    virtual void initialize(unsigned int,unsigned int);
    Class *classOf();

};

#endif /* ! SPARCNetworkBufferFreeList */
