/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987-1992
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * SPARCPageTableConstants.h:
 */

#ifndef SPARCPageTableConstants_h
#define SPARCPageTableConstants_h


#ifdef __GNUC__
#pragma interface
#endif


#include <sys/pte.h>

static const unsigned int Log2PhysicalPageSize     = 12;
static const unsigned int PhysicalPageSize         = 1 << Log2PhysicalPageSize;

static const unsigned int Log2PhysicalPages	   = 16;
static const unsigned int PhysicalPages		   = 1 << Log2PhysicalPageSize;

static const unsigned int Log2SegmentTableEntries    = 12;
static const unsigned int SegmentTableEntries        = 1 << Log2SegmentTableEntries;

static const unsigned int Log2SegmentSize            = 18;
static const unsigned int SegmentSize                = 1 << Log2SegmentSize;

static const unsigned int Log2PageTableEntries    = 6;
static const unsigned int PageTableEntries        = 128;
static const unsigned int PageTableSize           = 4096;

static const int Pte_PROTECT_LEVELS	 = 4;

static const unsigned int protectionMask = PG_V|PG_S|PG_W;

enum SPARCProtection { 
		SYSTEMRO = PG_V|PG_S, 
		SYSTEMRW = PG_V|PG_S|PG_W, 
		USERRO = PG_V,
		USERRW = PG_V|PG_W,
		NOACCESS = 0
		};

#endif	/* SPARCPageTableConstants_h */
