/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Ruth A. Aydt (aydt@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 *	Eflags.h:  Header file defining structure for the 80586 
 *	EFLAGS register.  See page 4-2 in the 80383 Programmer's
 *	Reference Manual.
 */

#ifndef EflagsRegister_h
#define EflagsRegister_h
#ifdef CFRONT
#define CONST const
#define STATIC static
#else /* must be g++ */
//#pragma interface
#if (__GNUG__ >= 2)
#define CONST
#define STATIC
#else
#define CONST const
#define STATIC static
#endif
#endif

union EflagsRegister{
	struct {
    	    unsigned int cf		:1;	// carry flag
    	    unsigned int b1		:1;	// must be 1
    	    unsigned int pf		:1;	// parity flag
    	    unsigned int b3		:1;	// must be 0
    	    unsigned int af		:1;	// auxiliary carry
    	    unsigned int b5		:1;	// must be 0
    	    unsigned int zf		:1;	// zero flag
    	    unsigned int sf		:1;	// sign flag
    	    unsigned int tf		:1; 	// trap flag
    	    unsigned int ief		:1; 	// interrupt enable
    	    unsigned int df		:1;	// direction flag
    	    unsigned int of		:1;	// overflow
    	    unsigned int iopl		:2;	// i/o privelge level
    	    unsigned int nt		:1;	// nested task
    	    unsigned int b15		:1;	// must be 0
    	    unsigned int rf		:1;	// resume flag
    	    unsigned int vm		:1;	// virtual 8086 mode
    	    unsigned int b18_31		:14;	// must be 0s
	} flags;
	unsigned long value;
};

#endif //EflagsRegister_h
	    
