/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Ruth A. Aydt (aydt@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 *	Util.h: declarations for assembly-level routines we use with the
 *		80586 machines.
 */

#ifndef Util_h
#define Util_h
#ifdef CFRONT
#define CONST const
#define STATIC static
#else /* must be g++ */
#pragma interface
#if (__GNUG__ >= 2)
#if (!defined STATIC)||(!defined CONST)
#define CONST
#define STATIC
#endif
#else
#pragma once
#define CONST const
#define STATIC static
#endif
#endif

extern "C" {
extern unsigned char In(int port);
extern unsigned short Inw(int port);
extern void Out(int port, int value);
extern void Outw(int port, int value);
extern void _Lmsw(unsigned int msw);
extern unsigned int Smsw();
extern void _Lcr3(unsigned int padrpd);
extern void FlushTLB();
extern void Int3();
extern void JmpStart(unsigned int whereto, unsigned int argument);
extern unsigned short Str();
extern void BreakIt();
extern void CopyBlock(unsigned char *from, unsigned char *to, int nbytes);
extern void CopyBlockBackwards(unsigned char *from, unsigned char *to, int nbytes);
extern void ZeroBlock(char *addr, int nbytes);
}
#endif //Util_h
