/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Vincent F. Russo (russo@cs.uiuc.edu)
 * Contributing Author: Gary M. Johnston (johnston@cs.uiuc.edu)
 * Contributing Author: See-Mong Tan (stan@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * i586Interrupts.h: hardware interrupt sub-class descriptions for the
 *	i586 processor.
 */

#ifndef i586Interrupts_h
#define i586Interrupts_h

#ifdef CFRONT
#define CONST const
#define STATIC static
#else /* must be g++ */
#if (__GNUG__ >= 2)
#define CONST
#define STATIC
#else
#pragma once
#define CONST const
#define STATIC static
#endif
#endif

#include "Interrupt.h"		/* parent class */

class i586PageFaultInterrupt : public Interrupt {
protected:
	void basicRaise( char * info );
public:
};

class i586GeneralProtectionInterrupt : public Interrupt {
protected:
	void basicRaise( char * info );
public:
};

extern ClassStar StrayInterruptClass;
class StrayInterrupt : public Interrupt {
protected:
	void basicRaise( char * );
public:
	StrayInterrupt() {};
	Class * classOf();
};

#endif /* i586Interrupts_h */
