/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Vincent F. Russo (russo@cs.uiuc.edu)
 * Contributing Author: Gary M. Johnston (johnston@cs.uiuc.edu)
 * Contributing Author: Bjorn A. Helgaas (helgaas@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * i586PageTableConstants.h:
 */

#ifndef i586PageTableConstants_h
#define i586PageTableConstants_h
#ifdef CFRONT
#define CONST const
#define STATIC static
#else /* must be g++ */
#pragma interface
#if (__GNUG__ >= 2)
#define CONST
#define STATIC
#else
#pragma once
#define CONST const
#define STATIC static
#endif
#endif


/*
 * The following constants are used primarily by the TwoLevelPageTable class.
 */

/* JMT HACK TBD */

const int Log2PhysicalPageSize     = 12;
const int PhysicalPageSize         = 4096;

const int Log2PointerTableEntries = 10;
const int PointerTableEntries     = 1024;
const int PointerTableSize        = 4096;

const int Log2PageTableEntries    = 10;
const int PageTableEntries        = 1024;
const int PageTableSize           = 4096;

const int Pte_PROTECT_LEVELS	 = 4;

enum i586Protection { SYSTEMRO = 0, SYSTEMRW = 1, USERRO = 2, USERRW = 3 };

#endif	/* i586PageTableConstants_h */
