/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Vincent F. Russo (russo@cs.uiuc.edu)
 * Contributing Author: Peter W. Madany (madany@cs.uiuc.edu)
 * Contributing Author: Gary M. Johnston (johnston@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * i586PhysicalMemoryObject.h: A MemoryObject to read/write physical 
 *	memory with.
 */

#ifndef i586PhysicalMemoryObject_h
#define i586PhysicalMemoryObject_h
#ifdef CFRONT
#define CONST const
#define STATIC static
#else /* must be g++ */
//#pragma interface
#if (__GNUG__ >= 2)
#define CONST
#define STATIC
#else
#pragma once
#define CONST const
#define STATIC static
#endif
#endif

#include "MemoryObject.h"
#include "MemoryObjectStar.h"

//#include "PhysicalMemoryObject.h"	/* parent class */

extern ClassStar i586PhysicalMemoryObjectClass; //JMT HACK TBD
class i586PhysicalMemoryObject : MemoryObject { //: public PhysicalMemoryObject {
protected:
	void copyBlock( const char * psrc, const char * pdst,
		unsigned int count );

	int rawRead( unsigned start, unsigned count,
		     char * addr, unsigned nbytes, IOAsyncClosure * c ) {};
	int rawWrite( unsigned start, unsigned count,
		      char * addr, unsigned nbytes,
		      int writeThrough, IOAsyncClosure * c ) {};
public:
	Class * classOf();

	i586PhysicalMemoryObject();
};

inline
i586PhysicalMemoryObject::i586PhysicalMemoryObject()
  :MemoryObject( 0xffffffff, 0 )
{
	Assert( this != 0 );
}

#endif /* i586PhysicalMemoryObject_h */
