/*
 * This file is part of the Choices Operating System
 *
 * Copyright (c) 2006
 * The University of Illinois Board of Trustees.
 *  All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Francis David (fdavid@uiuc.edu)
 *
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 */
/*
 * ProcessorException.h: event class description.
 */

#ifndef ProcessorException_h
#define ProcessorException_h


#ifdef __GNUC__
#pragma interface
#endif

#include "Exception.h"  /* parent class */

extern ClassStar ProcessorExceptionClass;
class ProcessorException : public Exception {
  public:
    ProcessorException();
    ProcessorException(const char *msg);

    virtual ~ProcessorException();

    virtual void displayContext() = 0;
    virtual void displayStackTrace() = 0;
    
    Class * classOf();
};

#endif /* ProcessorException_h */
