/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: David W. Dykstra (dykstra@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * ProxyTableCopy.h - kernel copy of ProxyTable
 */

#ifndef ProxyTableCopy_h
#define ProxyTableCopy_h


#ifdef __GNUC__
#pragma interface
#endif

#include "ProxiableObject.h"	/* parent class */
#include "ProxyTable.h"

class ProxyTable;
class Class;

class MethodTableEntryCopy {
public:
	Class *returnClass;
	char returnModifier;
	int realMethodNumber;
	int numParams;
	Class **paramClasses;

	MethodTableEntryCopy( MethodTableEntry * );
	~MethodTableEntryCopy();

	void dump();
};

extern ClassStar ProxyTableCopyClass;
class ProxyTableCopy : public ProxiableObject {
protected:
	~ProxyTableCopy();

public:
	Class *tableClass;
	char isProxiable;
	unsigned numMethods;
	MethodTableEntryCopy **methods;
	unsigned numConstructors;
	MethodTableEntryCopy **constructors;

	proxiable ProxyTableCopy( ProxyTable * t );

	void dump();

	Class * classOf();

};

#endif /*ProxyTableCopy_h*/
