/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991, 1992
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Swee Boon Lim (sblim@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * RaidOutputStream.h: definition of an output stream of characters.
 *
 */
 
#ifndef RaidOutputStream_h
#define RaidOutputStream_h


#ifdef __GNUC__
#pragma interface
#endif

#include "OutputStream.h"
#include "Async.h"

class RaidAsyncSupport : public AsyncClosure {
 public:
  int _inUse;
  int _whichHalf;
  static void func( AsyncClosure * c );
  RaidAsyncSupport();
};

extern ClassStar RaidOutputStreamClass;

class RaidOutputStream : public OutputStream {
public:
	Class * classOf();
        RaidOutputStream();
	proxiable virtual int write( const char * buffer, int count );
	void dump();
};

//extern OutputStream & RaidStream();

#endif /* RaidOutputStream_h */
