/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Gary M. Johnston (johnston@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * RRScheduler.h: a Round Robin process container.
 */

#ifndef RRScheduler_h
#define RRScheduler_h


#ifdef __GNUC__
#pragma interface
#endif

#include "FIFOScheduler.h"


/*
 * RRScheduler - a time-slicing round-robin scheduler.
 *		Really just a FIFO Scheduler that overloads remove() to
 *		set a time quantum.
 */
class RRScheduler : public FIFOScheduler {
protected:
	int quantum;
public:
	RRScheduler( int quantum );
	Process * remove();
};

#endif /* RRScheduler_h */
