/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Eric Hsiung
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * Stream related consts, must agree with user versions of 
 * Stream.h and PacketFilter.h
 */

#ifndef Stream_h
#define Stream_h


#ifdef __GNUC__
#pragma interface
#endif

// stream type defines
const int TypePacketFilter = 1;		// Packet Filter channel

// stream commands
const int Open = 1;		// open a stream
const int Close = 2;		// close a stream
const int Receive = 3;		// receive on a stream
const int Send = 4;		// send on a stream
const int Control = 5;		// change a stream parameter/attribute
const int Poll = 6;		// poll the stream

/*
 * PacketFilter parameters/attributes control operations
 */
const int opSetMode = 1;		// Set channel mode
const int opSetPriority = 2;	// Set channel priority
const int opClearFilter = 3;	// Clear channel filter
const int opSetFilter = 4;	// Set channel filter
const int opClearStats = 5;	// Clear channel statistics
const int opGetStats = 6;	// Set channel statistics

#endif /* Stream_h */
