/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Vincent F. Russo (russo@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * StupidAllocator.h: the dumbest way to implement an allocator.
 */

#ifndef StupidAllocator_h
#define StupidAllocator_h


#ifdef __GNUC__
#pragma interface
#endif

#include "Allocator.h"	/* the parent class */

/*
 * An allocator that just bumps up a pointer to allocate memory from
 * a block and never expects any memory to be freed back.
 */
class StupidAllocator : public Allocator {
protected:
	char * top;
public:
	StupidAllocator( void * base );
	~StupidAllocator();
	void * allocate( unsigned int nbytes );
	void free( void * cp );
};

#endif /*StupidAllocator_h*/
