/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Vincent F. Russo (russo@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * ThisCPU.h: class to handle a collection of CPUs. This is used mostly
 *		    to get a pointer to the CPU object representing a
 *		    processor (especially on a multiprocessor).
 */

#ifndef ThisCPU_h
#define ThisCPU_h


#ifdef __GNUC__
#pragma interface
#endif

#include "PROCESSOR.h"

inline CPU *
thisCPU()
{
	unsigned index = PROCESSOR::cpuID();
	Assert (index < MAX_PROCESSORS);
	// Assert (CPU::_cpus[index] != 0);
	return CPU::_cpus[index];
}

#endif /* ThisCPU_h */
