/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: David W. Dykstra (dykstra@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * ThisProcess.h: thisProcess() function
 */

#ifndef ThisProcess_h
#define ThisProcess_h


#ifdef __GNUC__
#pragma interface
#endif

#include "CPU.h"
#include "PROCESSOR.h"

inline Process *
thisProcess()
{
	IntStorage intstate; PROCESSOR::disableInterrupts(intstate);
	Process *p = CPU::_runningProcesses[PROCESSOR::cpuID()];
	PROCESSOR::restoreInterrupts(intstate);
	return( p );
}

#endif /* ThisProcess_h */
