/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: John L. Coolidge (coolidge@cs.uiuc.edu)
 * Contributing Author: Douglas E. Leyens (leyens@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
     
#ifndef TimeOfDay_h
#define TimeOfDay_h

#ifdef __GNUC__
#pragma interface
#endif


#include "ProxiableObject.h"
#include "ClassStar.h"

class SystemTime;
class UnixTime;
extern ClassStar TimeOfDayClass;

class TimeOfDay : public ProxiableObject
{
  public:
    Class * classOf();

    TimeOfDay();

    proxiable virtual void getTime( SystemTime& time );
    proxiable virtual void setTime( SystemTime& time );
    proxiable virtual void getUnixTime( UnixTime& time);
    proxiable virtual void setUnixTime( UnixTime& time);
};

/* FIX: Should be a star. --JLC */
extern TimeOfDay* theSystemClock;

#endif /* TimeOfDay_h */
