/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: David W. Dykstra (dykstra@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * VersionObject.h - class to store version strings
 */

#ifndef VersionObject_h
#define VersionObject_h


#ifdef __GNUC__
#pragma interface
#endif

#include "ProxiableObject.h"

class ProvidedVersionInstaller;
class RequiredVersionInstaller;

extern ClassStar VersionObjectClass;
class VersionObject : public ProxiableObject {
protected:
	char * version;

	~VersionObject();
public:

	VersionObject( char * );

	static void install( ProvidedVersionInstaller * );
	static void check( RequiredVersionInstaller * );

	Class * classOf();
};

#endif /*VersionObject_h*/
