#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987-1992
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * InstrumentTranscript.h: InstrumentTranscript class description
 */

#include "InstrumentTranscript.h"
#include "OutputStream.h"


#ifdef __GNUC__
#pragma implementation
#endif

InstantTranscript::InstantTranscript ()
{
    console = &(Console ());
}

void 
InstantTranscript::write (const char *str)
{
    *console << str;
    console -> flush ();
}

void 
InstantTranscript::write (int numerator, int denominator)
{
    //  Prints rational numbers up to 6 decimal places.
    double d = ((double) numerator) / denominator;

    *console << (int) d << '.';

    if (d < 0) d = -d;

    int fraction = (int) ((d - (int) d) * 1000000);

    char fractionStr [6];

    for (int i = 5; i >= 0; i--)
    {
    	fractionStr [i] = (fraction % 10) + '0';
	fraction = fraction / 10;
    }
    console -> write (fractionStr, 6);
    console -> flush ();
}

#include "ClassInstaller.h"

DEFINECLASS("InstrumentTranscript",InstrumentTranscript,Object,0,0);
DEFINECLASS("InstantTranscript",InstantTranscript,InstrumentTranscript,0,0);
DEFINECLASS("DelayedTranscript",DelayedTranscript,InstrumentTranscript,0,0);
