#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987-1992
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * UserInstrumentManager.cc: non-OS instrument manager
 */

#ifdef INSTRUMENT
	
#include "Assert.h"
#include "UserInstrumentManager.h"
#include "InstrumentEvent.h"


#ifdef __GNUC__
#pragma implementation
#endif

extern SystemInstrumentManager *TheInstrumentManager;

/*
A system call has to be made in order to be assigned a unique instrumentation
identifier.  In a sense, this is like a process identifier.
*/
UserInstrumentManager::UserInstrumentManager
(char *title, unsigned int instrumentAlloc)
    	: (title, instrumentAlloc)
{
	_header.id.mode = USER_INSTRUMENT;
	_header.id.ownerid = TheInstrumentManager->addInstrumentManager (this);
	birthLog (title);
	_suspendNewInstruments = FALSE;
}


UserInstrumentManager::~UserInstrumentManager()
{
	deathLog ();
	
	_header.id.special = TRUE;
	_header.id.message = FALSE;
	writeLogBuffer (sizeof(_header), (char *)&_header,InstrumentDeath);
	_header.id.special = FALSE;

	TheInstrumentManager->removeInstrumentManager (this);
}

void 
UserInstrumentManager :: writeLogBuffer (unsigned int dataLength, char *data, 
	unsigned int eventID, unsigned int messageLength, char *message)
{
    	extern SystemInstrumentManager *TheInstrumentManager;
	TheInstrumentManager->writeLogBuffer 
	        (dataLength, data, eventID, messageLength, message);
}

timeType 
UserInstrumentManager :: time ()
{
    	extern SystemInstrumentManager *TheInstrumentManager;
	return (TheInstrumentManager->time ());
}

#include "ClassInstaller.h"
DEFINECLASS("UserInstrumentManager",UserInstrumentManager,InstrumentManager,0,0)
;
#endif INSTRUMENT
