
#include "UNIXFile.h"
#include "UnixTime.h"
#include "SystemTime.h"
#include "Domain.h"
#include "Disk.h"
#include "Process.h"
#include "Process.h"
#include "MemoryRange.h"
#include "MemoryObject.h"
#include "PersistentMemoryObject.h"
#include "FileObject.h"
#include "FileObjectView.h"
#include "MemoryObjectCache.h"
#include "Semaphore.h"
#include "PersistentObject.h"
#include "PersistentArray.h"
#include "Timer.h"
#include "Semaphore.h"
#include "ConstructorDescriptor.h"
#include "TimeoutTimer.h"
#include "PeriodicTimer.h"
#include "MemoryObjectContainer.h"
#include "TimeOfDay.h"
#include "Pipe.h"
#include "ClassConstructor.h"
#include "VMInterface.h"
#include "Class.h"
#include "PersistentClass.h"
#include "SystemInterface.h"
#include "FileSystemInterface.h"
#include "MemoryObjectDictionary.h"
#include "WatchdogTimer.h"
#include "CharacterInputStream.h"
#include "SymbolicLink.h"
#include "TimingInterface.h"
#include "NameServer.h"
#include "RecordStream.h"
#include "FreeRunningTimer.h"
#include "RaidOutputStream.h"

// This file is automatically generated

inline AppInterface::EXCODE ProxiableObjectDispatcher(HashTable* t, ObjLink* obj, unsigned methodID, void* inputParam, void* outputParam) {
  ProxiableObject* realobj = 0;
  char* ret4;
  char* param5_1;
  OutputStream* param6_1;
  OutputStream* param7_1;
  Class* param8_1;
  int* param8_2;
  ProxiableObject* ret8;
  char* param9_1;
  int* param9_2;
  ProxiableObject* ret9;
  
  if(methodID != 0) {
    realobj = (ProxiableObject*)(obj->getObj());
    if(!realobj->classOf()->isASubclassOf(ProxiableObjectClass))
      return AppInterface::INVALIDCLASS;
  }
  
  switch(methodID) {
    case 0: //ProxiableObject()
    
      realobj = new ProxiableObject();
      t->insert(new ObjLink((void*)realobj, 1, 0, 0));
      *((ProxiableObject**)outputParam) = realobj;
      return AppInterface::DONE;
    case 2: //reference()
    
      realobj->reference();
      return AppInterface::DONE;
    case 3: //unreference()
    
      realobj->unreference();
      return AppInterface::DONE;
    case 4: //objectName()
    
      ret4 = realobj->objectName();
      *((char**)outputParam) = ret4;
      return AppInterface::DONE;
    case 5: //setName()
      param5_1 = *((char**)((char*)inputParam));

      realobj->setName(param5_1);
      return AppInterface::DONE;
    case 6: //writeName()
      param6_1 = *((OutputStream**)((char*)inputParam));

      realobj->writeName(param6_1);
      return AppInterface::DONE;
    case 7: //inspect()
      param7_1 = *((OutputStream**)((char*)inputParam));

      realobj->inspect(param7_1);
      return AppInterface::DONE;
    case 8: //asA()
      param8_1 = *((Class**)((char*)inputParam));
      param8_2 = *((int**)((char*)inputParam+sizeof(param8_1)));

      ret8 = realobj->asA(param8_1, *param8_2);
      t->insert(new ObjLink((void*)ret8, 1, 0, 0));
      *((ProxiableObject**)outputParam) = ret8;
      return AppInterface::DONE;
    case 9: //asA()
      param9_1 = *((char**)((char*)inputParam));
      param9_2 = *((int**)((char*)inputParam+sizeof(param9_1)));

      ret9 = realobj->asA(param9_1, *param9_2);
      t->insert(new ObjLink((void*)ret9, 1, 0, 0));
      *((ProxiableObject**)outputParam) = ret9;
      return AppInterface::DONE;
  }
  
  return AppInterface::INVALIDMETHOD;
}

inline AppInterface::EXCODE DomainDispatcher(HashTable* t, ObjLink* obj, unsigned methodID, void* inputParam, void* outputParam) {
  Domain* realobj = 0;
  
  if(methodID != 0) {
    realobj = (Domain*)(obj->getObj());
    if(!realobj->classOf()->isASubclassOf(DomainClass))
      return AppInterface::INVALIDCLASS;
  }
  
  switch(methodID) {
  }
  
  return AppInterface::INVALIDMETHOD;
}

inline AppInterface::EXCODE DiskDispatcher(HashTable* t, ObjLink* obj, unsigned methodID, void* inputParam, void* outputParam) {
  Disk* realobj = 0;
  
  if(methodID != 0) {
    realobj = (Disk*)(obj->getObj());
    if(!realobj->classOf()->isASubclassOf(DiskClass))
      return AppInterface::INVALIDCLASS;
  }
  
  switch(methodID) {
  }
  
  return AppInterface::INVALIDMETHOD;
}

inline AppInterface::EXCODE MemoryRangeDispatcher(HashTable* t, ObjLink* obj, unsigned methodID, void* inputParam, void* outputParam) {
  MemoryRange* realobj = 0;
  unsigned int param0_1;
  unsigned int param0_2;
  unsigned int ret2;
  unsigned int ret3;
  unsigned int ret4;
  Offset param5_1;
  unsigned int ret5;
  unsigned int param6_1;
  Offset ret6;
  unsigned int param7_1;
  int ret7;
  
  if(methodID != 0) {
    realobj = (MemoryRange*)(obj->getObj());
    if(!realobj->classOf()->isASubclassOf(MemoryRangeClass))
      return AppInterface::INVALIDCLASS;
  }
  
  switch(methodID) {
    case 0: //MemoryRange()
      param0_1 = *((unsigned int*)((char*)inputParam));
      param0_2 = *((unsigned int*)((char*)inputParam+sizeof(param0_1)));

      realobj = new MemoryRange(param0_1, param0_2);
      t->insert(new ObjLink((void*)realobj, 4, 0, 0));
      *((MemoryRange**)outputParam) = realobj;
      return AppInterface::DONE;
    case 2: //unitSize()
    
      ret2 = realobj->unitSize();
      *((unsigned int*)outputParam) = ret2;
      return AppInterface::DONE;
    case 3: //log2UnitSize()
    
      ret3 = realobj->log2UnitSize();
      *((unsigned int*)outputParam) = ret3;
      return AppInterface::DONE;
    case 4: //numberOfUnits()
    
      ret4 = realobj->numberOfUnits();
      *((unsigned int*)outputParam) = ret4;
      return AppInterface::DONE;
    case 5: //offsetToUnit()
      param5_1 = *((Offset*)((char*)inputParam));

      ret5 = realobj->offsetToUnit(param5_1);
      *((unsigned int*)outputParam) = ret5;
      return AppInterface::DONE;
    case 6: //unitToOffset()
      param6_1 = *((unsigned int*)((char*)inputParam));

      ret6 = realobj->unitToOffset(param6_1);
      *((Offset*)outputParam) = ret6;
      return AppInterface::DONE;
    case 7: //isIn()
      param7_1 = *((unsigned int*)((char*)inputParam));

      ret7 = realobj->isIn(param7_1);
      *((int*)outputParam) = ret7;
      return AppInterface::DONE;
  }
  
  return AppInterface::INVALIDMETHOD;
}

inline AppInterface::EXCODE MemoryObjectCacheDispatcher(HashTable* t, ObjLink* obj, unsigned methodID, void* inputParam, void* outputParam) {
  MemoryObjectCache* realobj = 0;
  unsigned short param2_1;
  short param3_1;
  
  if(methodID != 0) {
    realobj = (MemoryObjectCache*)(obj->getObj());
    if(!realobj->classOf()->isASubclassOf(MemoryObjectCacheClass))
      return AppInterface::INVALIDCLASS;
  }
  
  switch(methodID) {
    case 2: //setDebugMask()
      param2_1 = *((unsigned short*)((char*)inputParam));

      realobj->setDebugMask(param2_1);
      return AppInterface::DONE;
    case 3: //setDebugMessages()
      param3_1 = *((short*)((char*)inputParam));

      realobj->setDebugMessages(param3_1);
      return AppInterface::DONE;
  }
  
  return AppInterface::INVALIDMETHOD;
}

inline AppInterface::EXCODE MemoryObjectDispatcher(HashTable* t, ObjLink* obj, unsigned methodID, void* inputParam, void* outputParam) {
  MemoryObject* realobj = 0;
  int ret2;
  unsigned int param3_1;
  int param3_2;
  char* param3_3;
  int param3_4;
  int ret3;
  unsigned int param4_1;
  int param4_2;
  char* param4_3;
  int param4_4;
  int ret4;
  unsigned int param5_1;
  int param5_2;
  char* param5_3;
  int param5_4;
  int ret5;
  unsigned int param8_1;
  int ret8;
  MemoryObject* param9_1;
  int ret9;
  unsigned int ret10;
  unsigned int param11_1;
  unsigned int ret11;
  Class* ret12;
  Class* param13_1;
  Class* ret14;
  Class* param15_1;
  unsigned int ret16;
  unsigned int param17_1;
  unsigned int ret17;
  Class* param18_1;
  
  if(methodID != 0) {
    realobj = (MemoryObject*)(obj->getObj());
    if(!realobj->classOf()->isASubclassOf(MemoryObjectClass))
      return AppInterface::INVALIDCLASS;
  }
  
  switch(methodID) {
    case 2: //fixedSize()
    
      ret2 = realobj->fixedSize();
      *((int*)outputParam) = ret2;
      return AppInterface::DONE;
    case 3: //read()
      param3_1 = *((unsigned int*)((char*)inputParam));
      param3_2 = *((int*)((char*)inputParam+sizeof(param3_1)));
      param3_3 = *((char**)((char*)inputParam+sizeof(param3_1)+sizeof(param3_2)));
      param3_4 = *((int*)((char*)inputParam+sizeof(param3_1)+sizeof(param3_2)+sizeof(param3_3)));

      ret3 = realobj->read(param3_1, param3_2, param3_3, param3_4);
      *((int*)outputParam) = ret3;
      return AppInterface::DONE;
    case 4: //write()
      param4_1 = *((unsigned int*)((char*)inputParam));
      param4_2 = *((int*)((char*)inputParam+sizeof(param4_1)));
      param4_3 = *((char**)((char*)inputParam+sizeof(param4_1)+sizeof(param4_2)));
      param4_4 = *((int*)((char*)inputParam+sizeof(param4_1)+sizeof(param4_2)+sizeof(param4_3)));

      ret4 = realobj->write(param4_1, param4_2, param4_3, param4_4);
      *((int*)outputParam) = ret4;
      return AppInterface::DONE;
    case 5: //writeThrough()
      param5_1 = *((unsigned int*)((char*)inputParam));
      param5_2 = *((int*)((char*)inputParam+sizeof(param5_1)));
      param5_3 = *((char**)((char*)inputParam+sizeof(param5_1)+sizeof(param5_2)));
      param5_4 = *((int*)((char*)inputParam+sizeof(param5_1)+sizeof(param5_2)+sizeof(param5_3)));

      ret5 = realobj->writeThrough(param5_1, param5_2, param5_3, param5_4);
      *((int*)outputParam) = ret5;
      return AppInterface::DONE;
    case 6: //synchronize()
    
      realobj->synchronize();
      return AppInterface::DONE;
    case 7: //flush()
    
      realobj->flush();
      return AppInterface::DONE;
    case 8: //setNumberOfUnits()
      param8_1 = *((unsigned int*)((char*)inputParam));

      ret8 = realobj->setNumberOfUnits(param8_1);
      *((int*)outputParam) = ret8;
      return AppInterface::DONE;
    case 9: //copy()
      param9_1 = *((MemoryObject**)((char*)inputParam));

      ret9 = realobj->copy(param9_1);
      *((int*)outputParam) = ret9;
      return AppInterface::DONE;
    case 10: //cacheLog2UnitSize()
    
      ret10 = realobj->cacheLog2UnitSize();
      *((unsigned int*)outputParam) = ret10;
      return AppInterface::DONE;
    case 11: //setCacheLog2UnitSize()
      param11_1 = *((unsigned int*)((char*)inputParam));

      ret11 = realobj->setCacheLog2UnitSize(param11_1);
      *((unsigned int*)outputParam) = ret11;
      return AppInterface::DONE;
    case 12: //cacheClass()
    
      ret12 = realobj->cacheClass();
      t->insert(new ObjLink((void*)ret12, 24, 0, 0));
      *((Class**)outputParam) = ret12;
      return AppInterface::DONE;
    case 13: //setCacheClass()
      param13_1 = *((Class**)((char*)inputParam));

      realobj->setCacheClass(param13_1);
      return AppInterface::DONE;
    case 14: //replacementPolicyClass()
    
      ret14 = realobj->replacementPolicyClass();
      t->insert(new ObjLink((void*)ret14, 24, 0, 0));
      *((Class**)outputParam) = ret14;
      return AppInterface::DONE;
    case 15: //setReplacementPolicyClass()
      param15_1 = *((Class**)((char*)inputParam));

      realobj->setReplacementPolicyClass(param15_1);
      return AppInterface::DONE;
    case 16: //maxResidentCacheUnits()
    
      ret16 = realobj->maxResidentCacheUnits();
      *((unsigned int*)outputParam) = ret16;
      return AppInterface::DONE;
    case 17: //setMaxResidentCacheUnits()
      param17_1 = *((unsigned int*)((char*)inputParam));

      ret17 = realobj->setMaxResidentCacheUnits(param17_1);
      *((unsigned int*)outputParam) = ret17;
      return AppInterface::DONE;
    case 18: //addCache()
      param18_1 = *((Class**)((char*)inputParam));

      realobj->addCache(param18_1);
      return AppInterface::DONE;
  }
  
  return AppInterface::INVALIDMETHOD;
}

inline AppInterface::EXCODE PersistentMemoryObjectDispatcher(HashTable* t, ObjLink* obj, unsigned methodID, void* inputParam, void* outputParam) {
  PersistentMemoryObject* realobj = 0;
  unsigned int param4_1;
  int ret4;
  unsigned int ret5;
  unsigned int param6_1;
  int ret6;
  unsigned int ret7;
  unsigned int param8_1;
  int ret8;
  unsigned int ret9;
  unsigned int param10_1;
  int ret10;
  UNIXFileInfo* param11_1;
  int ret12;
  int ret13;
  int ret14;
  int param15_1;
  int ret15;
  int param16_1;
  int ret16;
  int param17_1;
  int ret17;
  int ret18;
  int param19_1;
  int ret19;
  MemoryObjectContainer* ret20;
  int param21_1;
  int ret21;
  Class* param22_1;
  int* param22_2;
  ProxiableObject* ret22;
  PersistentObject* ret23;
  PersistentObject* param24_1;
  OutputStream* param25_1;
  OutputStream* param26_1;
  int ret27;
  int ret28;
  unsigned int param29_1;
  int param29_2;
  int ret29;
  unsigned int param30_1;
  int param30_2;
  int ret30;
  unsigned int param31_1;
  unsigned int ret32;
  
  if(methodID != 0) {
    realobj = (PersistentMemoryObject*)(obj->getObj());
    if(!realobj->classOf()->isASubclassOf(PersistentMemoryObjectClass))
      return AppInterface::INVALIDCLASS;
  }
  
  switch(methodID) {
    case 2: //unreference()
    
      realobj->unreference();
      return AppInterface::DONE;
    case 3: //synchronize()
    
      realobj->synchronize();
      return AppInterface::DONE;
    case 4: //setNumberOfUnits()
      param4_1 = *((unsigned int*)((char*)inputParam));

      ret4 = realobj->setNumberOfUnits(param4_1);
      *((int*)outputParam) = ret4;
      return AppInterface::DONE;
    case 5: //numberOfRecords()
    
      ret5 = realobj->numberOfRecords();
      *((unsigned int*)outputParam) = ret5;
      return AppInterface::DONE;
    case 6: //setNumberOfRecords()
      param6_1 = *((unsigned int*)((char*)inputParam));

      ret6 = realobj->setNumberOfRecords(param6_1);
      *((int*)outputParam) = ret6;
      return AppInterface::DONE;
    case 7: //recordSize()
    
      ret7 = realobj->recordSize();
      *((unsigned int*)outputParam) = ret7;
      return AppInterface::DONE;
    case 8: //setRecordSize()
      param8_1 = *((unsigned int*)((char*)inputParam));

      ret8 = realobj->setRecordSize(param8_1);
      *((int*)outputParam) = ret8;
      return AppInterface::DONE;
    case 9: //numberOfBytes()
    
      ret9 = realobj->numberOfBytes();
      *((unsigned int*)outputParam) = ret9;
      return AppInterface::DONE;
    case 10: //setNumberOfBytes()
      param10_1 = *((unsigned int*)((char*)inputParam));

      ret10 = realobj->setNumberOfBytes(param10_1);
      *((int*)outputParam) = ret10;
      return AppInterface::DONE;
    case 11: //info()
      param11_1 = *((UNIXFileInfo**)((char*)inputParam));

      realobj->info(param11_1);
      return AppInterface::DONE;
    case 12: //isSymbolicLink()
    
      ret12 = realobj->isSymbolicLink();
      *((int*)outputParam) = ret12;
      return AppInterface::DONE;
    case 13: //isContainer()
    
      ret13 = realobj->isContainer();
      *((int*)outputParam) = ret13;
      return AppInterface::DONE;
    case 14: //isDictionary()
    
      ret14 = realobj->isDictionary();
      *((int*)outputParam) = ret14;
      return AppInterface::DONE;
    case 15: //setUserId()
      param15_1 = *((int*)((char*)inputParam));

      ret15 = realobj->setUserId(param15_1);
      *((int*)outputParam) = ret15;
      return AppInterface::DONE;
    case 16: //setGroupId()
      param16_1 = *((int*)((char*)inputParam));

      ret16 = realobj->setGroupId(param16_1);
      *((int*)outputParam) = ret16;
      return AppInterface::DONE;
    case 17: //setMode()
      param17_1 = *((int*)((char*)inputParam));

      ret17 = realobj->setMode(param17_1);
      *((int*)outputParam) = ret17;
      return AppInterface::DONE;
    case 18: //idNumber()
    
      ret18 = realobj->idNumber();
      *((int*)outputParam) = ret18;
      return AppInterface::DONE;
    case 19: //links()
      param19_1 = *((int*)((char*)inputParam));

      ret19 = realobj->links(param19_1);
      *((int*)outputParam) = ret19;
      return AppInterface::DONE;
    case 20: //container()
    
      ret20 = realobj->container();
      t->insert(new ObjLink((void*)ret20, 12, 0, 0));
      *((MemoryObjectContainer**)outputParam) = ret20;
      return AppInterface::DONE;
    case 21: //access()
      param21_1 = *((int*)((char*)inputParam));

      ret21 = realobj->access(param21_1);
      *((int*)outputParam) = ret21;
      return AppInterface::DONE;
    case 22: //asA()
      param22_1 = *((Class**)((char*)inputParam));
      param22_2 = *((int**)((char*)inputParam+sizeof(param22_1)));

      ret22 = realobj->asA(param22_1, *param22_2);
      t->insert(new ObjLink((void*)ret22, 1, 0, 0));
      *((ProxiableObject**)outputParam) = ret22;
      return AppInterface::DONE;
    case 23: //persistentObject()
    
      ret23 = realobj->persistentObject();
      t->insert(new ObjLink((void*)ret23, 9, 0, 0));
      *((PersistentObject**)outputParam) = ret23;
      return AppInterface::DONE;
    case 24: //close()
      param24_1 = *((PersistentObject**)((char*)inputParam));

      realobj->close(param24_1);
      return AppInterface::DONE;
    case 25: //writeName()
      param25_1 = *((OutputStream**)((char*)inputParam));

      realobj->writeName(param25_1);
      return AppInterface::DONE;
    case 26: //writeIdNumber()
      param26_1 = *((OutputStream**)((char*)inputParam));

      realobj->writeIdNumber(param26_1);
      return AppInterface::DONE;
    case 27: //userId()
    
      ret27 = realobj->userId();
      *((int*)outputParam) = ret27;
      return AppInterface::DONE;
    case 28: //groupId()
    
      ret28 = realobj->groupId();
      *((int*)outputParam) = ret28;
      return AppInterface::DONE;
    case 29: //alloc()
      param29_1 = *((unsigned int*)((char*)inputParam));
      param29_2 = *((int*)((char*)inputParam+sizeof(param29_1)));

      ret29 = realobj->alloc(param29_1, param29_2);
      *((int*)outputParam) = ret29;
      return AppInterface::DONE;
    case 30: //free()
      param30_1 = *((unsigned int*)((char*)inputParam));
      param30_2 = *((int*)((char*)inputParam+sizeof(param30_1)));

      ret30 = realobj->free(param30_1, param30_2);
      *((int*)outputParam) = ret30;
      return AppInterface::DONE;
    case 31: //setCacheHints()
      param31_1 = *((unsigned int*)((char*)inputParam));

      realobj->setCacheHints(param31_1);
      return AppInterface::DONE;
    case 32: //getCacheHints()
    
      ret32 = realobj->getCacheHints();
      *((unsigned int*)outputParam) = ret32;
      return AppInterface::DONE;
  }
  
  return AppInterface::INVALIDMETHOD;
}

inline AppInterface::EXCODE SemaphoreDispatcher(HashTable* t, ObjLink* obj, unsigned methodID, void* inputParam, void* outputParam) {
  Semaphore* realobj = 0;
  int param0_1;
  int param0_2;
  
  if(methodID != 0) {
    realobj = (Semaphore*)(obj->getObj());
    if(!realobj->classOf()->isASubclassOf(SemaphoreClass))
      return AppInterface::INVALIDCLASS;
  }
  
  switch(methodID) {
    case 0: //Semaphore()
      param0_1 = *((int*)((char*)inputParam));
      param0_2 = *((int*)((char*)inputParam+sizeof(param0_1)));

      realobj = new Semaphore(param0_1, param0_2);
      t->insert(new ObjLink((void*)realobj, 8, thisProcess()));
      *((Semaphore**)outputParam) = realobj;
      return AppInterface::DONE;
    case 1: //~Semaphore()
      if(obj->refs()>0 && obj->redRef(thisProcess())==0) {
        delete realobj;
        t->remove(obj);
        std::multimap<Process*,ObjLink*>::iterator iter;
        iter = TheProcessObjMap.find(thisProcess());
        while(iter != TheProcessObjMap.end()) {
          Assert(iter->first == thisProcess());
          if(iter->second->getObj() == realobj)
            TheProcessObjMap.erase(iter);
          iter++;
        }
      }
      return AppInterface::DONE;
    case 2: //P()
    
      realobj->P();
      return AppInterface::DONE;
    case 3: //V()
    
      realobj->V();
      return AppInterface::DONE;
  }
  
  return AppInterface::INVALIDMETHOD;
}

inline AppInterface::EXCODE PersistentObjectDispatcher(HashTable* t, ObjLink* obj, unsigned methodID, void* inputParam, void* outputParam) {
  PersistentObject* realobj = 0;
  PersistentMemoryObject* ret2;
  PersistentMemoryObject* param0_1;
  int param3_1;
  char** param3_2;
  FileSystemInterface* param3_3;
  int ret3;
  int ret4;
  int ret5;
  int ret6;
  unsigned int ret7;
  unsigned int ret8;
  unsigned int ret9;
  PersistentObject* param10_1;
  int ret10;
  OutputStream* param12_1;
  int ret13;
  int ret14;
  Class* param15_1;
  int* param15_2;
  ProxiableObject* ret15;
  int ret16;
  UNIXFileInfo* param17_1;
  int param18_1;
  int ret18;
  int param19_1;
  int ret19;
  int param20_1;
  int ret20;
  
  if(methodID != 0) {
    realobj = (PersistentObject*)(obj->getObj());
    if(!realobj->classOf()->isASubclassOf(PersistentObjectClass))
      return AppInterface::INVALIDCLASS;
  }
  
  switch(methodID) {
    case 2: //source()
    
      ret2 = realobj->source();
      t->insert(new ObjLink((void*)ret2, 7, 0, 0));
      *((PersistentMemoryObject**)outputParam) = ret2;
      return AppInterface::DONE;
    case 0: //PersistentObject()
      param0_1 = *((PersistentMemoryObject**)((char*)inputParam));

      realobj = new PersistentObject(param0_1);
      t->insert(new ObjLink((void*)realobj, 9, 0, 0));
      *((PersistentObject**)outputParam) = realobj;
      return AppInterface::DONE;
    case 3: //init()
      param3_1 = *((int*)((char*)inputParam));
      param3_2 = *((char***)((char*)inputParam+sizeof(param3_1)));
      param3_3 = *((FileSystemInterface**)((char*)inputParam+sizeof(param3_1)+sizeof(param3_2)));

      ret3 = realobj->init(param3_1, param3_2, param3_3);
      *((int*)outputParam) = ret3;
      return AppInterface::DONE;
    case 4: //execute()
    
      ret4 = realobj->execute();
      *((int*)outputParam) = ret4;
      return AppInterface::DONE;
    case 5: //persist()
    
      ret5 = realobj->persist();
      *((int*)outputParam) = ret5;
      return AppInterface::DONE;
    case 6: //desist()
    
      ret6 = realobj->desist();
      *((int*)outputParam) = ret6;
      return AppInterface::DONE;
    case 7: //numberOfBytes()
    
      ret7 = realobj->numberOfBytes();
      *((unsigned int*)outputParam) = ret7;
      return AppInterface::DONE;
    case 8: //numberOfRecords()
    
      ret8 = realobj->numberOfRecords();
      *((unsigned int*)outputParam) = ret8;
      return AppInterface::DONE;
    case 9: //recordSize()
    
      ret9 = realobj->recordSize();
      *((unsigned int*)outputParam) = ret9;
      return AppInterface::DONE;
    case 10: //copy()
      param10_1 = *((PersistentObject**)((char*)inputParam));

      ret10 = realobj->copy(param10_1);
      *((int*)outputParam) = ret10;
      return AppInterface::DONE;
    case 11: //flush()
    
      realobj->flush();
      return AppInterface::DONE;
    case 12: //writeName()
      param12_1 = *((OutputStream**)((char*)inputParam));

      realobj->writeName(param12_1);
      return AppInterface::DONE;
    case 13: //executable()
    
      ret13 = realobj->executable();
      *((int*)outputParam) = ret13;
      return AppInterface::DONE;
    case 14: //idNumber()
    
      ret14 = realobj->idNumber();
      *((int*)outputParam) = ret14;
      return AppInterface::DONE;
    case 15: //asA()
      param15_1 = *((Class**)((char*)inputParam));
      param15_2 = *((int**)((char*)inputParam+sizeof(param15_1)));

      ret15 = realobj->asA(param15_1, *param15_2);
      t->insert(new ObjLink((void*)ret15, 1, 0, 0));
      *((ProxiableObject**)outputParam) = ret15;
      return AppInterface::DONE;
    case 16: //links()
    
      ret16 = realobj->links();
      *((int*)outputParam) = ret16;
      return AppInterface::DONE;
    case 17: //info()
      param17_1 = *((UNIXFileInfo**)((char*)inputParam));

      realobj->info(param17_1);
      return AppInterface::DONE;
    case 18: //setUserId()
      param18_1 = *((int*)((char*)inputParam));

      ret18 = realobj->setUserId(param18_1);
      *((int*)outputParam) = ret18;
      return AppInterface::DONE;
    case 19: //setGroupId()
      param19_1 = *((int*)((char*)inputParam));

      ret19 = realobj->setGroupId(param19_1);
      *((int*)outputParam) = ret19;
      return AppInterface::DONE;
    case 20: //setMode()
      param20_1 = *((int*)((char*)inputParam));

      ret20 = realobj->setMode(param20_1);
      *((int*)outputParam) = ret20;
      return AppInterface::DONE;
  }
  
  return AppInterface::INVALIDMETHOD;
}

inline AppInterface::EXCODE PersistentArrayDispatcher(HashTable* t, ObjLink* obj, unsigned methodID, void* inputParam, void* outputParam) {
  PersistentArray* realobj = 0;
  PersistentMemoryObject* param0_1;
  unsigned int param2_1;
  int ret2;
  unsigned int param3_1;
  char* param3_2;
  unsigned int param3_3;
  int ret3;
  char* param4_1;
  int* param4_2;
  int ret4;
  unsigned int param5_1;
  int param5_2;
  int ret5;
  unsigned int param6_1;
  char* param6_2;
  unsigned int param6_3;
  int ret6;
  char* param7_1;
  int param7_2;
  int* param7_3;
  int ret7;
  unsigned int ret8;
  
  if(methodID != 0) {
    realobj = (PersistentArray*)(obj->getObj());
    if(!realobj->classOf()->isASubclassOf(PersistentArrayClass))
      return AppInterface::INVALIDCLASS;
  }
  
  switch(methodID) {
    case 0: //PersistentArray()
      param0_1 = *((PersistentMemoryObject**)((char*)inputParam));

      realobj = new PersistentArray(param0_1);
      t->insert(new ObjLink((void*)realobj, 10, 0, 0));
      *((PersistentArray**)outputParam) = realobj;
      return AppInterface::DONE;
    case 2: //at()
      param2_1 = *((unsigned int*)((char*)inputParam));

      ret2 = realobj->at(param2_1);
      *((int*)outputParam) = ret2;
      return AppInterface::DONE;
    case 3: //at()
      param3_1 = *((unsigned int*)((char*)inputParam));
      param3_2 = *((char**)((char*)inputParam+sizeof(param3_1)));
      param3_3 = *((unsigned int*)((char*)inputParam+sizeof(param3_1)+sizeof(param3_2)));

      ret3 = realobj->at(param3_1, param3_2, param3_3);
      *((int*)outputParam) = ret3;
      return AppInterface::DONE;
    case 4: //at()
      param4_1 = *((char**)((char*)inputParam));
      param4_2 = *((int**)((char*)inputParam+sizeof(param4_1)));

      ret4 = realobj->at(param4_1, *param4_2);
      *((int*)outputParam) = ret4;
      return AppInterface::DONE;
    case 5: //atPut()
      param5_1 = *((unsigned int*)((char*)inputParam));
      param5_2 = *((int*)((char*)inputParam+sizeof(param5_1)));

      ret5 = realobj->atPut(param5_1, param5_2);
      *((int*)outputParam) = ret5;
      return AppInterface::DONE;
    case 6: //atPut()
      param6_1 = *((unsigned int*)((char*)inputParam));
      param6_2 = *((char**)((char*)inputParam+sizeof(param6_1)));
      param6_3 = *((unsigned int*)((char*)inputParam+sizeof(param6_1)+sizeof(param6_2)));

      ret6 = realobj->atPut(param6_1, param6_2, param6_3);
      *((int*)outputParam) = ret6;
      return AppInterface::DONE;
    case 7: //atPut()
      param7_1 = *((char**)((char*)inputParam));
      param7_2 = *((int*)((char*)inputParam+sizeof(param7_1)));
      param7_3 = *((int**)((char*)inputParam+sizeof(param7_1)+sizeof(param7_2)));

      ret7 = realobj->atPut(param7_1, param7_2, *param7_3);
      *((int*)outputParam) = ret7;
      return AppInterface::DONE;
    case 8: //size()
    
      ret8 = realobj->size();
      *((unsigned int*)outputParam) = ret8;
      return AppInterface::DONE;
  }
  
  return AppInterface::INVALIDMETHOD;
}

inline AppInterface::EXCODE InputStreamDispatcher(HashTable* t, ObjLink* obj, unsigned methodID, void* inputParam, void* outputParam) {
  InputStream* realobj = 0;
  char* param2_1;
  int param2_2;
  int ret2;
  char* param3_1;
  formatArgs* param3_2;
  int ret3;
  char param4_1;
  int ret4;
  
  if(methodID != 0) {
    realobj = (InputStream*)(obj->getObj());
    if(!realobj->classOf()->isASubclassOf(InputStreamClass))
      return AppInterface::INVALIDCLASS;
  }
  
  switch(methodID) {
    case 2: //read()
      param2_1 = *((char**)((char*)inputParam));
      param2_2 = *((int*)((char*)inputParam+sizeof(param2_1)));

      ret2 = realobj->read(param2_1, param2_2);
      *((int*)outputParam) = ret2;
      return AppInterface::DONE;
    case 3: //formattedRead()
      param3_1 = *((char**)((char*)inputParam));
      param3_2 = *((formatArgs**)((char*)inputParam+sizeof(param3_1)));

      ret3 = realobj->formattedRead(param3_1, *param3_2);
      *((int*)outputParam) = ret3;
      return AppInterface::DONE;
    case 4: //readBackChar()
      param4_1 = *((char*)((char*)inputParam));

      ret4 = realobj->readBackChar(param4_1);
      *((int*)outputParam) = ret4;
      return AppInterface::DONE;
  }
  
  return AppInterface::INVALIDMETHOD;
}

inline AppInterface::EXCODE MemoryObjectContainerDispatcher(HashTable* t, ObjLink* obj, unsigned methodID, void* inputParam, void* outputParam) {
  MemoryObjectContainer* realobj = 0;
  PersistentMemoryObject* param0_1;
  int param2_1;
  int* param2_2;
  int param2_3;
  FileObject* ret2;
  int param3_1;
  Class* param3_2;
  int* param3_3;
  int param3_4;
  FileObject* ret3;
  FileObject* param4_1;
  int* param5_1;
  int param5_2;
  int param5_3;
  int ret5;
  int* param6_1;
  int param6_2;
  int param6_3;
  int param8_1;
  MemoryObjectDictionary* ret9;
  int ret10;
  int ret11;
  int param14_1;
  int param15_1;
  
  if(methodID != 0) {
    realobj = (MemoryObjectContainer*)(obj->getObj());
    if(!realobj->classOf()->isASubclassOf(MemoryObjectContainerClass))
      return AppInterface::INVALIDCLASS;
  }
  
  switch(methodID) {
    case 0: //MemoryObjectContainer()
      param0_1 = *((PersistentMemoryObject**)((char*)inputParam));

      realobj = new MemoryObjectContainer(param0_1);
      t->insert(new ObjLink((void*)realobj, 12, 0, 0));
      *((MemoryObjectContainer**)outputParam) = realobj;
      return AppInterface::DONE;
    case 2: //open()
      param2_1 = *((int*)((char*)inputParam));
      param2_2 = *((int**)((char*)inputParam+sizeof(param2_1)));
      param2_3 = *((int*)((char*)inputParam+sizeof(param2_1)+sizeof(param2_2)));

      ret2 = realobj->open(param2_1, *param2_2, param2_3);
      t->insert(new ObjLink((void*)ret2, 27, 0, 0));
      *((FileObject**)outputParam) = ret2;
      return AppInterface::DONE;
    case 3: //create()
      param3_1 = *((int*)((char*)inputParam));
      param3_2 = *((Class**)((char*)inputParam+sizeof(param3_1)));
      param3_3 = *((int**)((char*)inputParam+sizeof(param3_1)+sizeof(param3_2)));
      param3_4 = *((int*)((char*)inputParam+sizeof(param3_1)+sizeof(param3_2)+sizeof(param3_3)));

      ret3 = realobj->create(param3_1, param3_2, *param3_3, param3_4);
      t->insert(new ObjLink((void*)ret3, 27, 0, 0));
      *((FileObject**)outputParam) = ret3;
      return AppInterface::DONE;
    case 4: //close()
      param4_1 = *((FileObject**)((char*)inputParam));

      realobj->close(param4_1);
      return AppInterface::DONE;
    case 5: //allocate()
      param5_1 = *((int**)((char*)inputParam));
      param5_2 = *((int*)((char*)inputParam+sizeof(param5_1)));
      param5_3 = *((int*)((char*)inputParam+sizeof(param5_1)+sizeof(param5_2)));

      ret5 = realobj->allocate(*param5_1, param5_2, param5_3);
      *((int*)outputParam) = ret5;
      return AppInterface::DONE;
    case 6: //free()
      param6_1 = *((int**)((char*)inputParam));
      param6_2 = *((int*)((char*)inputParam+sizeof(param6_1)));
      param6_3 = *((int*)((char*)inputParam+sizeof(param6_1)+sizeof(param6_2)));

      realobj->free(*param6_1, param6_2, param6_3);
      return AppInterface::DONE;
    case 7: //synchronize()
    
      realobj->synchronize();
      return AppInterface::DONE;
    case 8: //synchronize()
      param8_1 = *((int*)((char*)inputParam));

      realobj->synchronize(param8_1);
      return AppInterface::DONE;
    case 9: //rootDictionary()
    
      ret9 = realobj->rootDictionary();
      t->insert(new ObjLink((void*)ret9, 19, 0, 0));
      *((MemoryObjectDictionary**)outputParam) = ret9;
      return AppInterface::DONE;
    case 10: //size()
    
      ret10 = realobj->size();
      *((int*)outputParam) = ret10;
      return AppInterface::DONE;
    case 11: //rootIdNumber()
    
      ret11 = realobj->rootIdNumber();
      *((int*)outputParam) = ret11;
      return AppInterface::DONE;
    case 12: //acquire()
    
      realobj->acquire();
      return AppInterface::DONE;
    case 13: //release()
    
      realobj->release();
      return AppInterface::DONE;
    case 14: //acquire()
      param14_1 = *((int*)((char*)inputParam));

      realobj->acquire(param14_1);
      return AppInterface::DONE;
    case 15: //release()
      param15_1 = *((int*)((char*)inputParam));

      realobj->release(param15_1);
      return AppInterface::DONE;
  }
  
  return AppInterface::INVALIDMETHOD;
}

inline AppInterface::EXCODE OutputStreamDispatcher(HashTable* t, ObjLink* obj, unsigned methodID, void* inputParam, void* outputParam) {
  OutputStream* realobj = 0;
  char* param4_1;
  int param4_2;
  int ret4;
  char* param5_1;
  formatArgs* param5_2;
  int ret5;
  
  if(methodID != 0) {
    realobj = (OutputStream*)(obj->getObj());
    if(!realobj->classOf()->isASubclassOf(OutputStreamClass))
      return AppInterface::INVALIDCLASS;
  }
  
  switch(methodID) {
    case 2: //acquireExclusiveUse()
    
      realobj->acquireExclusiveUse();
      return AppInterface::DONE;
    case 3: //releaseExclusiveUse()
    
      realobj->releaseExclusiveUse();
      return AppInterface::DONE;
    case 4: //write()
      param4_1 = *((char**)((char*)inputParam));
      param4_2 = *((int*)((char*)inputParam+sizeof(param4_1)));

      ret4 = realobj->write(param4_1, param4_2);
      *((int*)outputParam) = ret4;
      return AppInterface::DONE;
    case 5: //formattedWrite()
      param5_1 = *((char**)((char*)inputParam));
      param5_2 = *((formatArgs**)((char*)inputParam+sizeof(param5_1)));

      ret5 = realobj->formattedWrite(param5_1, *param5_2);
      *((int*)outputParam) = ret5;
      return AppInterface::DONE;
    case 6: //flush()
    
      realobj->flush();
      return AppInterface::DONE;
  }
  
  return AppInterface::INVALIDMETHOD;
}

inline AppInterface::EXCODE TimerDispatcher(HashTable* t, ObjLink* obj, unsigned methodID, void* inputParam, void* outputParam) {
  Timer* realobj = 0;
  unsigned int param2_1;
  unsigned int ret2;
  unsigned int ret3;
  unsigned int ret4;
  
  if(methodID != 0) {
    realobj = (Timer*)(obj->getObj());
    if(!realobj->classOf()->isASubclassOf(TimerClass))
      return AppInterface::INVALIDCLASS;
  }
  
  switch(methodID) {
    case 2: //start()
      param2_1 = *((unsigned int*)((char*)inputParam));

      ret2 = realobj->start(param2_1);
      *((unsigned int*)outputParam) = ret2;
      return AppInterface::DONE;
    case 3: //stop()
    
      ret3 = realobj->stop();
      *((unsigned int*)outputParam) = ret3;
      return AppInterface::DONE;
    case 4: //residual()
    
      ret4 = realobj->residual();
      *((unsigned int*)outputParam) = ret4;
      return AppInterface::DONE;
    case 5: //await()
    
      realobj->await();
      return AppInterface::DONE;
  }
  
  return AppInterface::INVALIDMETHOD;
}

inline AppInterface::EXCODE PeriodicTimerDispatcher(HashTable* t, ObjLink* obj, unsigned methodID, void* inputParam, void* outputParam) {
  PeriodicTimer* realobj = 0;
  unsigned int param2_1;
  unsigned int ret2;
  unsigned int ret3;
  unsigned int ret4;
  
  if(methodID != 0) {
    realobj = (PeriodicTimer*)(obj->getObj());
    if(!realobj->classOf()->isASubclassOf(PeriodicTimerClass))
      return AppInterface::INVALIDCLASS;
  }
  
  switch(methodID) {
    case 0: //PeriodicTimer()
    
      realobj = new PeriodicTimer();
      t->insert(new ObjLink((void*)realobj, 15, thisProcess()));
      *((PeriodicTimer**)outputParam) = realobj;
      return AppInterface::DONE;
    case 1: //~PeriodicTimer()
      if(obj->refs()>0 && obj->redRef(thisProcess())==0) {
        delete realobj;
        t->remove(obj);
        std::multimap<Process*,ObjLink*>::iterator iter;
        iter = TheProcessObjMap.find(thisProcess());
        while(iter != TheProcessObjMap.end()) {
          Assert(iter->first == thisProcess());
          if(iter->second->getObj() == realobj)
            TheProcessObjMap.erase(iter);
          iter++;
        }
      }
      return AppInterface::DONE;
    case 2: //start()
      param2_1 = *((unsigned int*)((char*)inputParam));

      ret2 = realobj->start(param2_1);
      *((unsigned int*)outputParam) = ret2;
      return AppInterface::DONE;
    case 3: //stop()
    
      ret3 = realobj->stop();
      *((unsigned int*)outputParam) = ret3;
      return AppInterface::DONE;
    case 4: //residual()
    
      ret4 = realobj->residual();
      *((unsigned int*)outputParam) = ret4;
      return AppInterface::DONE;
    case 5: //await()
    
      realobj->await();
      return AppInterface::DONE;
  }
  
  return AppInterface::INVALIDMETHOD;
}

inline AppInterface::EXCODE TimeOfDayDispatcher(HashTable* t, ObjLink* obj, unsigned methodID, void* inputParam, void* outputParam) {
  TimeOfDay* realobj = 0;
  SystemTime* param2_1;
  SystemTime* param3_1;
  UnixTime* param4_1;
  UnixTime* param5_1;
  
  if(methodID != 0) {
    realobj = (TimeOfDay*)(obj->getObj());
    if(!realobj->classOf()->isASubclassOf(TimeOfDayClass))
      return AppInterface::INVALIDCLASS;
  }
  
  switch(methodID) {
    case 2: //getTime()
      param2_1 = *((SystemTime**)((char*)inputParam));

      realobj->getTime(*param2_1);
      return AppInterface::DONE;
    case 3: //setTime()
      param3_1 = *((SystemTime**)((char*)inputParam));

      realobj->setTime(*param3_1);
      return AppInterface::DONE;
    case 4: //getUnixTime()
      param4_1 = *((UnixTime**)((char*)inputParam));

      realobj->getUnixTime(*param4_1);
      return AppInterface::DONE;
    case 5: //setUnixTime()
      param5_1 = *((UnixTime**)((char*)inputParam));

      realobj->setUnixTime(*param5_1);
      return AppInterface::DONE;
  }
  
  return AppInterface::INVALIDMETHOD;
}

inline AppInterface::EXCODE SystemInterfaceDispatcher(HashTable* t, ObjLink* obj, unsigned methodID, void* inputParam, void* outputParam) {
  SystemInterface* realobj = 0;
  void* param2_1;
  ProvidedVersionInstaller* param3_1;
  RequiredVersionInstaller* param3_2;
  Process* ret4;
  PersistentMemoryObject* param6_1;
  int param6_2;
  char** param6_3;
  Process* ret6;
  Disk* ret7;
  PersistentMemoryObject* param8_1;
  int ret8;
  ProxiableObject* param9_1;
  OutputStream* ret9;
  ProxiableObject* param10_1;
  InputStream* ret10;
  int ret11;
  int param12_1;
  char** param12_2;
  
  if(methodID != 0) {
    realobj = (SystemInterface*)(obj->getObj());
    if(!realobj->classOf()->isASubclassOf(SystemInterfaceClass))
      return AppInterface::INVALIDCLASS;
  }
  
  switch(methodID) {
    case 2: //initialCall()
      param2_1 = *((void**)((char*)inputParam));

      realobj->initialCall(param2_1);
      return AppInterface::DONE;
    case 3: //versions()
      param3_1 = *((ProvidedVersionInstaller**)((char*)inputParam));
      param3_2 = *((RequiredVersionInstaller**)((char*)inputParam+sizeof(param3_1)));

      realobj->versions(param3_1, param3_2);
      return AppInterface::DONE;
    case 4: //getThisProcess()
    
      ret4 = realobj->getThisProcess();
      t->insert(new ObjLink((void*)ret4, 25, 0, 0));
      *((Process**)outputParam) = ret4;
      return AppInterface::DONE;
    case 5: //killThisProcess()
    
      realobj->killThisProcess();
      return AppInterface::DONE;
    case 6: //buildProcessFromObjectFile()
      param6_1 = *((PersistentMemoryObject**)((char*)inputParam));
      param6_2 = *((int*)((char*)inputParam+sizeof(param6_1)));
      param6_3 = *((char***)((char*)inputParam+sizeof(param6_1)+sizeof(param6_2)));

      ret6 = realobj->buildProcessFromObjectFile(param6_1, param6_2, param6_3);
      t->insert(new ObjLink((void*)ret6, 25, 0, 0));
      *((Process**)outputParam) = ret6;
      return AppInterface::DONE;
    case 7: //rootDisk()
    
      ret7 = realobj->rootDisk();
      t->insert(new ObjLink((void*)ret7, 3, 0, 0));
      *((Disk**)outputParam) = ret7;
      return AppInterface::DONE;
    case 8: //isObjectFile()
      param8_1 = *((PersistentMemoryObject**)((char*)inputParam));

      ret8 = realobj->isObjectFile(param8_1);
      *((int*)outputParam) = ret8;
      return AppInterface::DONE;
    case 9: //outputStream()
      param9_1 = *((ProxiableObject**)((char*)inputParam));

      ret9 = realobj->outputStream(param9_1);
      t->insert(new ObjLink((void*)ret9, 13, 0, 0));
      *((OutputStream**)outputParam) = ret9;
      return AppInterface::DONE;
    case 10: //inputStream()
      param10_1 = *((ProxiableObject**)((char*)inputParam));

      ret10 = realobj->inputStream(param10_1);
      t->insert(new ObjLink((void*)ret10, 11, 0, 0));
      *((InputStream**)outputParam) = ret10;
      return AppInterface::DONE;
    case 11: //pageSize()
    
      ret11 = realobj->pageSize();
      *((int*)outputParam) = ret11;
      return AppInterface::DONE;
    case 12: //controlSimpleInstruments()
      param12_1 = *((int*)((char*)inputParam));
      param12_2 = *((char***)((char*)inputParam+sizeof(param12_1)));

      realobj->controlSimpleInstruments(param12_1, param12_2);
      return AppInterface::DONE;
  }
  
  return AppInterface::INVALIDMETHOD;
}

inline AppInterface::EXCODE FileSystemInterfaceDispatcher(HashTable* t, ObjLink* obj, unsigned methodID, void* inputParam, void* outputParam) {
  FileSystemInterface* realobj = 0;
  char* param2_1;
  Class* param2_2;
  int* param2_3;
  int param2_4;
  int param2_5;
  Class* param2_6;
  ProxiableObject* ret2;
  char* param3_1;
  int* param3_2;
  int* param3_3;
  int param3_4;
  int param3_5;
  PersistentObject* ret3;
  char* param4_1;
  PersistentObject* param4_2;
  int ret4;
  char* param5_1;
  UNIXFileInfo* param5_2;
  int param5_3;
  unsigned int* param5_4;
  int ret5;
  char* param6_1;
  char* param6_2;
  int param6_3;
  int ret6;
  char* param7_1;
  int ret7;
  char* param8_1;
  int ret8;
  char* param9_1;
  int ret9;
  PersistentMemoryObject* param10_1;
  int ret10;
  PersistentMemoryObject* param11_1;
  int ret11;
  char* param12_1;
  char* param12_2;
  int param12_3;
  int ret12;
  char* param13_1;
  int ret13;
  int ret14;
  unsigned int param15_1;
  unsigned int param16_1;
  unsigned int ret17;
  unsigned int ret18;
  
  if(methodID != 0) {
    realobj = (FileSystemInterface*)(obj->getObj());
    if(!realobj->classOf()->isASubclassOf(FileSystemInterfaceClass))
      return AppInterface::INVALIDCLASS;
  }
  
  switch(methodID) {
    case 2: //open()
      param2_1 = *((char**)((char*)inputParam));
      param2_2 = *((Class**)((char*)inputParam+sizeof(param2_1)));
      param2_3 = *((int**)((char*)inputParam+sizeof(param2_1)+sizeof(param2_2)));
      param2_4 = *((int*)((char*)inputParam+sizeof(param2_1)+sizeof(param2_2)+sizeof(param2_3)));
      param2_5 = *((int*)((char*)inputParam+sizeof(param2_1)+sizeof(param2_2)+sizeof(param2_3)+sizeof(param2_4)));
      param2_6 = *((Class**)((char*)inputParam+sizeof(param2_1)+sizeof(param2_2)+sizeof(param2_3)+sizeof(param2_4)+sizeof(param2_5)));

      ret2 = realobj->open(param2_1, param2_2, *param2_3, param2_4, param2_5, param2_6);
      t->insert(new ObjLink((void*)ret2, 1, 0, 0));
      *((ProxiableObject**)outputParam) = ret2;
      return AppInterface::DONE;
    case 3: //open()
      param3_1 = *((char**)((char*)inputParam));
      param3_2 = *((int**)((char*)inputParam+sizeof(param3_1)));
      param3_3 = *((int**)((char*)inputParam+sizeof(param3_1)+sizeof(param3_2)));
      param3_4 = *((int*)((char*)inputParam+sizeof(param3_1)+sizeof(param3_2)+sizeof(param3_3)));
      param3_5 = *((int*)((char*)inputParam+sizeof(param3_1)+sizeof(param3_2)+sizeof(param3_3)+sizeof(param3_4)));

      ret3 = realobj->open(param3_1, *param3_2, *param3_3, param3_4, param3_5);
      t->insert(new ObjLink((void*)ret3, 9, 0, 0));
      *((PersistentObject**)outputParam) = ret3;
      return AppInterface::DONE;
    case 4: //add()
      param4_1 = *((char**)((char*)inputParam));
      param4_2 = *((PersistentObject**)((char*)inputParam+sizeof(param4_1)));

      ret4 = realobj->add(param4_1, param4_2);
      *((int*)outputParam) = ret4;
      return AppInterface::DONE;
    case 5: //info()
      param5_1 = *((char**)((char*)inputParam));
      param5_2 = *((UNIXFileInfo**)((char*)inputParam+sizeof(param5_1)));
      param5_3 = *((int*)((char*)inputParam+sizeof(param5_1)+sizeof(param5_2)));
      param5_4 = *((unsigned int**)((char*)inputParam+sizeof(param5_1)+sizeof(param5_2)+sizeof(param5_3)));

      ret5 = realobj->info(param5_1, param5_2, param5_3, param5_4);
      *((int*)outputParam) = ret5;
      return AppInterface::DONE;
    case 6: //link()
      param6_1 = *((char**)((char*)inputParam));
      param6_2 = *((char**)((char*)inputParam+sizeof(param6_1)));
      param6_3 = *((int*)((char*)inputParam+sizeof(param6_1)+sizeof(param6_2)));

      ret6 = realobj->link(param6_1, param6_2, param6_3);
      *((int*)outputParam) = ret6;
      return AppInterface::DONE;
    case 7: //unlink()
      param7_1 = *((char**)((char*)inputParam));

      ret7 = realobj->unlink(param7_1);
      *((int*)outputParam) = ret7;
      return AppInterface::DONE;
    case 8: //chdir()
      param8_1 = *((char**)((char*)inputParam));

      ret8 = realobj->chdir(param8_1);
      *((int*)outputParam) = ret8;
      return AppInterface::DONE;
    case 9: //chroot()
      param9_1 = *((char**)((char*)inputParam));

      ret9 = realobj->chroot(param9_1);
      *((int*)outputParam) = ret9;
      return AppInterface::DONE;
    case 10: //chdir()
      param10_1 = *((PersistentMemoryObject**)((char*)inputParam));

      ret10 = realobj->chdir(param10_1);
      *((int*)outputParam) = ret10;
      return AppInterface::DONE;
    case 11: //chroot()
      param11_1 = *((PersistentMemoryObject**)((char*)inputParam));

      ret11 = realobj->chroot(param11_1);
      *((int*)outputParam) = ret11;
      return AppInterface::DONE;
    case 12: //mount()
      param12_1 = *((char**)((char*)inputParam));
      param12_2 = *((char**)((char*)inputParam+sizeof(param12_1)));
      param12_3 = *((int*)((char*)inputParam+sizeof(param12_1)+sizeof(param12_2)));

      ret12 = realobj->mount(param12_1, param12_2, param12_3);
      *((int*)outputParam) = ret12;
      return AppInterface::DONE;
    case 13: //unmount()
      param13_1 = *((char**)((char*)inputParam));

      ret13 = realobj->unmount(param13_1);
      *((int*)outputParam) = ret13;
      return AppInterface::DONE;
    case 14: //synchronize()
    
      ret14 = realobj->synchronize();
      *((int*)outputParam) = ret14;
      return AppInterface::DONE;
    case 15: //openFlagsSetMask()
      param15_1 = *((unsigned int*)((char*)inputParam));

      realobj->openFlagsSetMask(param15_1);
      return AppInterface::DONE;
    case 16: //openFlagsClearMask()
      param16_1 = *((unsigned int*)((char*)inputParam));

      realobj->openFlagsClearMask(param16_1);
      return AppInterface::DONE;
    case 17: //openFlagsSetMask()
    
      ret17 = realobj->openFlagsSetMask();
      *((unsigned int*)outputParam) = ret17;
      return AppInterface::DONE;
    case 18: //openFlagsClearMask()
    
      ret18 = realobj->openFlagsClearMask();
      *((unsigned int*)outputParam) = ret18;
      return AppInterface::DONE;
  }
  
  return AppInterface::INVALIDMETHOD;
}

inline AppInterface::EXCODE MemoryObjectDictionaryDispatcher(HashTable* t, ObjLink* obj, unsigned methodID, void* inputParam, void* outputParam) {
  MemoryObjectDictionary* realobj = 0;
  PersistentMemoryObject* param0_1;
  char* param2_1;
  int* param2_2;
  int param2_3;
  PersistentMemoryObject* ret2;
  char* param3_1;
  Class* param3_2;
  int* param3_3;
  int param3_4;
  PersistentMemoryObject* ret3;
  char* param4_1;
  PersistentMemoryObject* param4_2;
  int ret4;
  char* param5_1;
  int* param5_2;
  int ret5;
  char* param6_1;
  int param6_2;
  int* param6_3;
  int ret6;
  char* param7_1;
  int param7_2;
  int* param7_3;
  int ret7;
  char* param8_1;
  int param8_2;
  int* param8_3;
  int* param8_4;
  int ret8;
  int ret9;
  PersistentMemoryObject* param10_1;
  int ret10;
  int ret11;
  
  if(methodID != 0) {
    realobj = (MemoryObjectDictionary*)(obj->getObj());
    if(!realobj->classOf()->isASubclassOf(MemoryObjectDictionaryClass))
      return AppInterface::INVALIDCLASS;
  }
  
  switch(methodID) {
    case 0: //MemoryObjectDictionary()
      param0_1 = *((PersistentMemoryObject**)((char*)inputParam));

      realobj = new MemoryObjectDictionary(param0_1);
      t->insert(new ObjLink((void*)realobj, 19, 0, 0));
      *((MemoryObjectDictionary**)outputParam) = realobj;
      return AppInterface::DONE;
    case 2: //open()
      param2_1 = *((char**)((char*)inputParam));
      param2_2 = *((int**)((char*)inputParam+sizeof(param2_1)));
      param2_3 = *((int*)((char*)inputParam+sizeof(param2_1)+sizeof(param2_2)));

      ret2 = realobj->open(param2_1, *param2_2, param2_3);
      t->insert(new ObjLink((void*)ret2, 7, 0, 0));
      *((PersistentMemoryObject**)outputParam) = ret2;
      return AppInterface::DONE;
    case 3: //create()
      param3_1 = *((char**)((char*)inputParam));
      param3_2 = *((Class**)((char*)inputParam+sizeof(param3_1)));
      param3_3 = *((int**)((char*)inputParam+sizeof(param3_1)+sizeof(param3_2)));
      param3_4 = *((int*)((char*)inputParam+sizeof(param3_1)+sizeof(param3_2)+sizeof(param3_3)));

      ret3 = realobj->create(param3_1, param3_2, *param3_3, param3_4);
      t->insert(new ObjLink((void*)ret3, 7, 0, 0));
      *((PersistentMemoryObject**)outputParam) = ret3;
      return AppInterface::DONE;
    case 4: //add()
      param4_1 = *((char**)((char*)inputParam));
      param4_2 = *((PersistentMemoryObject**)((char*)inputParam+sizeof(param4_1)));

      ret4 = realobj->add(param4_1, param4_2);
      *((int*)outputParam) = ret4;
      return AppInterface::DONE;
    case 5: //remove()
      param5_1 = *((char**)((char*)inputParam));
      param5_2 = *((int**)((char*)inputParam+sizeof(param5_1)));

      ret5 = realobj->remove(param5_1, param5_2);
      *((int*)outputParam) = ret5;
      return AppInterface::DONE;
    case 6: //keys()
      param6_1 = *((char**)((char*)inputParam));
      param6_2 = *((int*)((char*)inputParam+sizeof(param6_1)));
      param6_3 = *((int**)((char*)inputParam+sizeof(param6_1)+sizeof(param6_2)));

      ret6 = realobj->keys(param6_1, param6_2, *param6_3);
      *((int*)outputParam) = ret6;
      return AppInterface::DONE;
    case 7: //associations()
      param7_1 = *((char**)((char*)inputParam));
      param7_2 = *((int*)((char*)inputParam+sizeof(param7_1)));
      param7_3 = *((int**)((char*)inputParam+sizeof(param7_1)+sizeof(param7_2)));

      ret7 = realobj->associations(param7_1, param7_2, *param7_3);
      *((int*)outputParam) = ret7;
      return AppInterface::DONE;
    case 8: //associations()
      param8_1 = *((char**)((char*)inputParam));
      param8_2 = *((int*)((char*)inputParam+sizeof(param8_1)));
      param8_3 = *((int**)((char*)inputParam+sizeof(param8_1)+sizeof(param8_2)));
      param8_4 = *((int**)((char*)inputParam+sizeof(param8_1)+sizeof(param8_2)+sizeof(param8_3)));

      ret8 = realobj->associations(param8_1, param8_2, *param8_3, *param8_4);
      *((int*)outputParam) = ret8;
      return AppInterface::DONE;
    case 9: //keySize()
    
      ret9 = realobj->keySize();
      *((int*)outputParam) = ret9;
      return AppInterface::DONE;
    case 10: //sharesContainer()
      param10_1 = *((PersistentMemoryObject**)((char*)inputParam));

      ret10 = realobj->sharesContainer(param10_1);
      *((int*)outputParam) = ret10;
      return AppInterface::DONE;
    case 11: //synchronize()
    
      ret11 = realobj->synchronize();
      *((int*)outputParam) = ret11;
      return AppInterface::DONE;
  }
  
  return AppInterface::INVALIDMETHOD;
}

inline AppInterface::EXCODE VMInterfaceDispatcher(HashTable* t, ObjLink* obj, unsigned methodID, void* inputParam, void* outputParam) {
  VMInterface* realobj = 0;
  char* param2_1;
  RecordStream* param3_1;
  char* param3_2;
  MemoryObjectCache* ret3;
  RecordStream* param4_1;
  ProtectionLevel param4_2;
  char* ret4;
  RecordStream* param5_1;
  RecordStream* param5_2;
  char* param6_1;
  char* param7_1;
  char* ret7;
  char* param8_1;
  unsigned int param9_1;
  char* ret9;
  
  if(methodID != 0) {
    realobj = (VMInterface*)(obj->getObj());
    if(!realobj->classOf()->isASubclassOf(VMInterfaceClass))
      return AppInterface::INVALIDCLASS;
  }
  
  switch(methodID) {
    case 2: //test()
      param2_1 = *((char**)((char*)inputParam));

      realobj->test(param2_1);
      return AppInterface::DONE;
    case 3: //createCache()
      param3_1 = *((RecordStream**)((char*)inputParam));
      param3_2 = *((char**)((char*)inputParam+sizeof(param3_1)));

      ret3 = realobj->createCache(param3_1, param3_2);
      t->insert(new ObjLink((void*)ret3, 5, 0, 0));
      *((MemoryObjectCache**)outputParam) = ret3;
      return AppInterface::DONE;
    case 4: //addToDomain()
      param4_1 = *((RecordStream**)((char*)inputParam));
      param4_2 = *((ProtectionLevel*)((char*)inputParam+sizeof(param4_1)));

      ret4 = realobj->addToDomain(param4_1, param4_2);
      *((char**)outputParam) = ret4;
      return AppInterface::DONE;
    case 5: //setupCOW()
      param5_1 = *((RecordStream**)((char*)inputParam));
      param5_2 = *((RecordStream**)((char*)inputParam+sizeof(param5_1)));

      realobj->setupCOW(param5_1, param5_2);
      return AppInterface::DONE;
    case 6: //networkTest()
      param6_1 = *((char**)((char*)inputParam));

      realobj->networkTest(param6_1);
      return AppInterface::DONE;
    case 7: //openDVM()
      param7_1 = *((char**)((char*)inputParam));

      ret7 = realobj->openDVM(param7_1);
      *((char**)outputParam) = ret7;
      return AppInterface::DONE;
    case 8: //closeDVM()
      param8_1 = *((char**)((char*)inputParam));

      realobj->closeDVM(param8_1);
      return AppInterface::DONE;
    case 9: //createSharedRegion()
      param9_1 = *((unsigned int*)((char*)inputParam));

      ret9 = realobj->createSharedRegion(param9_1);
      *((char**)outputParam) = ret9;
      return AppInterface::DONE;
  }
  
  return AppInterface::INVALIDMETHOD;
}

inline AppInterface::EXCODE WatchdogTimerDispatcher(HashTable* t, ObjLink* obj, unsigned methodID, void* inputParam, void* outputParam) {
  WatchdogTimer* realobj = 0;
  unsigned int param2_1;
  unsigned int ret2;
  unsigned int ret3;
  unsigned int ret4;
  
  if(methodID != 0) {
    realobj = (WatchdogTimer*)(obj->getObj());
    if(!realobj->classOf()->isASubclassOf(WatchdogTimerClass))
      return AppInterface::INVALIDCLASS;
  }
  
  switch(methodID) {
    case 2: //start()
      param2_1 = *((unsigned int*)((char*)inputParam));

      ret2 = realobj->start(param2_1);
      *((unsigned int*)outputParam) = ret2;
      return AppInterface::DONE;
    case 3: //stop()
    
      ret3 = realobj->stop();
      *((unsigned int*)outputParam) = ret3;
      return AppInterface::DONE;
    case 4: //residual()
    
      ret4 = realobj->residual();
      *((unsigned int*)outputParam) = ret4;
      return AppInterface::DONE;
    case 5: //ping()
    
      realobj->ping();
      return AppInterface::DONE;
  }
  
  return AppInterface::INVALIDMETHOD;
}

inline AppInterface::EXCODE NameServerDispatcher(HashTable* t, ObjLink* obj, unsigned methodID, void* inputParam, void* outputParam) {
  NameServer* realobj = 0;
  char* param2_1;
  ProxiableObject* param2_2;
  char* param3_1;
  Class* param3_2;
  ProxiableObject* ret3;
  char* param4_1;
  char* param4_2;
  ProxiableObject* ret4;
  char* param5_1;
  int ret5;
  NameServer* param6_1;
  
  if(methodID != 0) {
    realobj = (NameServer*)(obj->getObj());
    if(!realobj->classOf()->isASubclassOf(NameServerClass))
      return AppInterface::INVALIDCLASS;
  }
  
  switch(methodID) {
    case 2: //bind()
      param2_1 = *((char**)((char*)inputParam));
      param2_2 = *((ProxiableObject**)((char*)inputParam+sizeof(param2_1)));

      realobj->bind(param2_1, param2_2);
      return AppInterface::DONE;
    case 3: //lookup()
      param3_1 = *((char**)((char*)inputParam));
      param3_2 = *((Class**)((char*)inputParam+sizeof(param3_1)));

      ret3 = realobj->lookup(param3_1, param3_2);
      t->insert(new ObjLink((void*)ret3, 1, 0, 0));
      *((ProxiableObject**)outputParam) = ret3;
      return AppInterface::DONE;
    case 4: //lookup()
      param4_1 = *((char**)((char*)inputParam));
      param4_2 = *((char**)((char*)inputParam+sizeof(param4_1)));

      ret4 = realobj->lookup(param4_1, param4_2);
      t->insert(new ObjLink((void*)ret4, 1, 0, 0));
      *((ProxiableObject**)outputParam) = ret4;
      return AppInterface::DONE;
    case 5: //unbind()
      param5_1 = *((char**)((char*)inputParam));

      ret5 = realobj->unbind(param5_1);
      *((int*)outputParam) = ret5;
      return AppInterface::DONE;
    case 6: //clone()
      param6_1 = *((NameServer**)((char*)inputParam));

      realobj->clone(param6_1);
      return AppInterface::DONE;
  }
  
  return AppInterface::INVALIDMETHOD;
}

inline AppInterface::EXCODE RecordStreamDispatcher(HashTable* t, ObjLink* obj, unsigned methodID, void* inputParam, void* outputParam) {
  RecordStream* realobj = 0;
  char* param2_1;
  int param2_2;
  int ret2;
  char* param3_1;
  int param3_2;
  int* param3_3;
  int ret3;
  char* param4_1;
  int param4_2;
  int ret4;
  char* param5_1;
  int param5_2;
  int* param5_3;
  int ret5;
  int ret6;
  int param7_1;
  int param7_2;
  int ret7;
  int ret8;
  int ret9;
  int ret10;
  int ret11;
  int ret12;
  int param13_1;
  int ret13;
  int param14_1;
  int ret14;
  int param15_1;
  int ret15;
  UNIXFileInfo* param16_1;
  int param17_1;
  char** param17_2;
  int ret17;
  int ret18;
  Class* param19_1;
  int* param19_2;
  ProxiableObject* ret19;
  int param20_1;
  char** param20_2;
  int ret20;
  
  if(methodID != 0) {
    realobj = (RecordStream*)(obj->getObj());
    if(!realobj->classOf()->isASubclassOf(RecordStreamClass))
      return AppInterface::INVALIDCLASS;
  }
  
  switch(methodID) {
    case 2: //read()
      param2_1 = *((char**)((char*)inputParam));
      param2_2 = *((int*)((char*)inputParam+sizeof(param2_1)));

      ret2 = realobj->read(param2_1, param2_2);
      *((int*)outputParam) = ret2;
      return AppInterface::DONE;
    case 3: //read()
      param3_1 = *((char**)((char*)inputParam));
      param3_2 = *((int*)((char*)inputParam+sizeof(param3_1)));
      param3_3 = *((int**)((char*)inputParam+sizeof(param3_1)+sizeof(param3_2)));

      ret3 = realobj->read(param3_1, param3_2, *param3_3);
      *((int*)outputParam) = ret3;
      return AppInterface::DONE;
    case 4: //write()
      param4_1 = *((char**)((char*)inputParam));
      param4_2 = *((int*)((char*)inputParam+sizeof(param4_1)));

      ret4 = realobj->write(param4_1, param4_2);
      *((int*)outputParam) = ret4;
      return AppInterface::DONE;
    case 5: //write()
      param5_1 = *((char**)((char*)inputParam));
      param5_2 = *((int*)((char*)inputParam+sizeof(param5_1)));
      param5_3 = *((int**)((char*)inputParam+sizeof(param5_1)+sizeof(param5_2)));

      ret5 = realobj->write(param5_1, param5_2, *param5_3);
      *((int*)outputParam) = ret5;
      return AppInterface::DONE;
    case 6: //recordNumber()
    
      ret6 = realobj->recordNumber();
      *((int*)outputParam) = ret6;
      return AppInterface::DONE;
    case 7: //setRecordNumber()
      param7_1 = *((int*)((char*)inputParam));
      param7_2 = *((int*)((char*)inputParam+sizeof(param7_1)));

      ret7 = realobj->setRecordNumber(param7_1, param7_2);
      *((int*)outputParam) = ret7;
      return AppInterface::DONE;
    case 8: //numberOfBytes()
    
      ret8 = realobj->numberOfBytes();
      *((int*)outputParam) = ret8;
      return AppInterface::DONE;
    case 9: //numberOfRecords()
    
      ret9 = realobj->numberOfRecords();
      *((int*)outputParam) = ret9;
      return AppInterface::DONE;
    case 10: //recordSize()
    
      ret10 = realobj->recordSize();
      *((int*)outputParam) = ret10;
      return AppInterface::DONE;
    case 11: //minimumRecordSize()
    
      ret11 = realobj->minimumRecordSize();
      *((int*)outputParam) = ret11;
      return AppInterface::DONE;
    case 12: //maximumRecordSize()
    
      ret12 = realobj->maximumRecordSize();
      *((int*)outputParam) = ret12;
      return AppInterface::DONE;
    case 13: //setMode()
      param13_1 = *((int*)((char*)inputParam));

      ret13 = realobj->setMode(param13_1);
      *((int*)outputParam) = ret13;
      return AppInterface::DONE;
    case 14: //setUserId()
      param14_1 = *((int*)((char*)inputParam));

      ret14 = realobj->setUserId(param14_1);
      *((int*)outputParam) = ret14;
      return AppInterface::DONE;
    case 15: //setGroupId()
      param15_1 = *((int*)((char*)inputParam));

      ret15 = realobj->setGroupId(param15_1);
      *((int*)outputParam) = ret15;
      return AppInterface::DONE;
    case 16: //info()
      param16_1 = *((UNIXFileInfo**)((char*)inputParam));

      realobj->info(param16_1);
      return AppInterface::DONE;
    case 17: //init()
      param17_1 = *((int*)((char*)inputParam));
      param17_2 = *((char***)((char*)inputParam+sizeof(param17_1)));

      ret17 = realobj->init(param17_1, param17_2);
      *((int*)outputParam) = ret17;
      return AppInterface::DONE;
    case 18: //executable()
    
      ret18 = realobj->executable();
      *((int*)outputParam) = ret18;
      return AppInterface::DONE;
    case 19: //asA()
      param19_1 = *((Class**)((char*)inputParam));
      param19_2 = *((int**)((char*)inputParam+sizeof(param19_1)));

      ret19 = realobj->asA(param19_1, *param19_2);
      t->insert(new ObjLink((void*)ret19, 1, 0, 0));
      *((ProxiableObject**)outputParam) = ret19;
      return AppInterface::DONE;
    case 20: //runFile()
      param20_1 = *((int*)((char*)inputParam));
      param20_2 = *((char***)((char*)inputParam+sizeof(param20_1)));

      ret20 = realobj->runFile(param20_1, param20_2);
      *((int*)outputParam) = ret20;
      return AppInterface::DONE;
  }
  
  return AppInterface::INVALIDMETHOD;
}

inline AppInterface::EXCODE ClassDispatcher(HashTable* t, ObjLink* obj, unsigned methodID, void* inputParam, void* outputParam) {
  Class* realobj = 0;
  Class* param0_1;
  int param0_2;
  char* param0_3;
  ClassConstructor* param0_4;
  int param3_1;
  char* param3_2;
  char* ret3;
  Class* ret4;
  Class* ret5;
  Class* ret6;
  Class* ret7;
  Class* param8_1;
  int ret8;
  Class* param9_1;
  int ret9;
  int ret10;
  NameServer* param11_1;
  NameServer* param12_1;
  int ret13;
  int ret14;
  int ret15;
  int param16_1;
  int param17_1;
  int param18_1;
  int ret19;
  int param20_1;
  int param20_2;
  int ret20;
  int param21_1;
  int param21_2;
  int ret21;
  ProxiableObject* param22_1;
  int ret22;
  int ret23;
  int param24_1;
  int ret24;
  ClassApplicationFunction param25_1;
  int ret25;
  ClassApplicationFunction param26_1;
  int ret26;
  
  if(methodID != 0) {
    realobj = (Class*)(obj->getObj());
    if(!realobj->classOf()->isASubclassOf(ClassClass))
      return AppInterface::INVALIDCLASS;
  }
  
  switch(methodID) {
    case 0: //Class()
      param0_1 = *((Class**)((char*)inputParam));
      param0_2 = *((int*)((char*)inputParam+sizeof(param0_1)));
      param0_3 = *((char**)((char*)inputParam+sizeof(param0_1)+sizeof(param0_2)));
      param0_4 = *((ClassConstructor**)((char*)inputParam+sizeof(param0_1)+sizeof(param0_2)+sizeof(param0_3)));

      realobj = new Class(param0_1, param0_2, param0_3, param0_4);
      t->insert(new ObjLink((void*)realobj, 24, 0, 0));
      *((Class**)outputParam) = realobj;
      return AppInterface::DONE;
    case 2: //cleanup()
    
      realobj->cleanup();
      return AppInterface::DONE;
    case 3: //name()
      param3_1 = *((int*)((char*)inputParam));
      param3_2 = *((char**)((char*)inputParam+sizeof(param3_1)));

      ret3 = realobj->name(param3_1, param3_2);
      *((char**)outputParam) = ret3;
      return AppInterface::DONE;
    case 4: //parent()
    
      ret4 = realobj->parent();
      t->insert(new ObjLink((void*)ret4, 24, 0, 0));
      *((Class**)outputParam) = ret4;
      return AppInterface::DONE;
    case 5: //child()
    
      ret5 = realobj->child();
      t->insert(new ObjLink((void*)ret5, 24, 0, 0));
      *((Class**)outputParam) = ret5;
      return AppInterface::DONE;
    case 6: //sibling()
    
      ret6 = realobj->sibling();
      t->insert(new ObjLink((void*)ret6, 24, 0, 0));
      *((Class**)outputParam) = ret6;
      return AppInterface::DONE;
    case 7: //real()
    
      ret7 = realobj->real();
      t->insert(new ObjLink((void*)ret7, 24, 0, 0));
      *((Class**)outputParam) = ret7;
      return AppInterface::DONE;
    case 8: //isASubclassOf()
      param8_1 = *((Class**)((char*)inputParam));

      ret8 = realobj->isASubclassOf(param8_1);
      *((int*)outputParam) = ret8;
      return AppInterface::DONE;
    case 9: //isClass()
      param9_1 = *((Class**)((char*)inputParam));

      ret9 = realobj->isClass(param9_1);
      *((int*)outputParam) = ret9;
      return AppInterface::DONE;
    case 10: //sizeOf()
    
      ret10 = realobj->sizeOf();
      *((int*)outputParam) = ret10;
      return AppInterface::DONE;
    case 11: //bind()
      param11_1 = *((NameServer**)((char*)inputParam));

      realobj->bind(param11_1);
      return AppInterface::DONE;
    case 12: //unbind()
      param12_1 = *((NameServer**)((char*)inputParam));

      realobj->unbind(param12_1);
      return AppInterface::DONE;
    case 13: //initDebugObjects()
    
      ret13 = realobj->initDebugObjects();
      *((int*)outputParam) = ret13;
      return AppInterface::DONE;
    case 14: //initDebugMask()
    
      ret14 = realobj->initDebugMask();
      *((int*)outputParam) = ret14;
      return AppInterface::DONE;
    case 15: //initDebugMessages()
    
      ret15 = realobj->initDebugMessages();
      *((int*)outputParam) = ret15;
      return AppInterface::DONE;
    case 16: //setInitDebugObjects()
      param16_1 = *((int*)((char*)inputParam));

      realobj->setInitDebugObjects(param16_1);
      return AppInterface::DONE;
    case 17: //setInitDebugMask()
      param17_1 = *((int*)((char*)inputParam));

      realobj->setInitDebugMask(param17_1);
      return AppInterface::DONE;
    case 18: //setInitDebugMessages()
      param18_1 = *((int*)((char*)inputParam));

      realobj->setInitDebugMessages(param18_1);
      return AppInterface::DONE;
    case 19: //concrete()
    
      ret19 = realobj->concrete();
      *((int*)outputParam) = ret19;
      return AppInterface::DONE;
    case 20: //debugMembers()
      param20_1 = *((int*)((char*)inputParam));
      param20_2 = *((int*)((char*)inputParam+sizeof(param20_1)));

      ret20 = realobj->debugMembers(param20_1, param20_2);
      *((int*)outputParam) = ret20;
      return AppInterface::DONE;
    case 21: //debugKindred()
      param21_1 = *((int*)((char*)inputParam));
      param21_2 = *((int*)((char*)inputParam+sizeof(param21_1)));

      ret21 = realobj->debugKindred(param21_1, param21_2);
      *((int*)outputParam) = ret21;
      return AppInterface::DONE;
    case 22: //displayMember()
      param22_1 = *((ProxiableObject**)((char*)inputParam));

      ret22 = realobj->displayMember(param22_1);
      *((int*)outputParam) = ret22;
      return AppInterface::DONE;
    case 23: //displayMembers()
    
      ret23 = realobj->displayMembers();
      *((int*)outputParam) = ret23;
      return AppInterface::DONE;
    case 24: //displayKindred()
      param24_1 = *((int*)((char*)inputParam));

      ret24 = realobj->displayKindred(param24_1);
      *((int*)outputParam) = ret24;
      return AppInterface::DONE;
    case 25: //applyToMembers()
      param25_1 = *((ClassApplicationFunction*)((char*)inputParam));

      ret25 = realobj->applyToMembers(param25_1);
      *((int*)outputParam) = ret25;
      return AppInterface::DONE;
    case 26: //applyToKindred()
      param26_1 = *((ClassApplicationFunction*)((char*)inputParam));

      ret26 = realobj->applyToKindred(param26_1);
      *((int*)outputParam) = ret26;
      return AppInterface::DONE;
  }
  
  return AppInterface::INVALIDMETHOD;
}

inline AppInterface::EXCODE ProcessDispatcher(HashTable* t, ObjLink* obj, unsigned methodID, void* inputParam, void* outputParam) {
  Process* realobj = 0;
  Domain* ret2;
  Process* param3_1;
  int ret3;
  Semaphore* param4_1;
  int* param4_2;
  int param5_1;
  int ret6;
  int ret7;
  Process* param8_1;
  ProcessState param8_2;
  int param9_1;
  NameServer* ret12;
  char* param13_1;
  char* param13_2;
  Process* ret13;
  ProcessResourceUsage* param14_1;
  
  if(methodID != 0) {
    realobj = (Process*)(obj->getObj());
    if(!realobj->classOf()->isASubclassOf(ProcessClass))
      return AppInterface::INVALIDCLASS;
  }
  
  switch(methodID) {
    case 2: //currentDomain()
    
      ret2 = realobj->currentDomain();
      t->insert(new ObjLink((void*)ret2, 2, 0, 0));
      *((Domain**)outputParam) = ret2;
      return AppInterface::DONE;
    case 3: //waitForProcess()
      param3_1 = *((Process**)((char*)inputParam));

      ret3 = realobj->waitForProcess(param3_1);
      *((int*)outputParam) = ret3;
      return AppInterface::DONE;
    case 4: //notifyUponCompletion()
      param4_1 = *((Semaphore**)((char*)inputParam));
      param4_2 = *((int**)((char*)inputParam+sizeof(param4_1)));

      realobj->notifyUponCompletion(param4_1, param4_2);
      return AppInterface::DONE;
    case 5: //wakeUpWaiter()
      param5_1 = *((int*)((char*)inputParam));

      realobj->wakeUpWaiter(param5_1);
      return AppInterface::DONE;
    case 6: //dead()
    
      ret6 = realobj->dead();
      *((int*)outputParam) = ret6;
      return AppInterface::DONE;
    case 7: //completionStatus()
    
      ret7 = realobj->completionStatus();
      *((int*)outputParam) = ret7;
      return AppInterface::DONE;
    case 8: //giveProcessorTo()
      param8_1 = *((Process**)((char*)inputParam));
      param8_2 = *((ProcessState*)((char*)inputParam+sizeof(param8_1)));

      realobj->giveProcessorTo(param8_1, param8_2);
      return AppInterface::DONE;
    case 9: //die()
      param9_1 = *((int*)((char*)inputParam));

      realobj->die(param9_1);
      return AppInterface::DONE;
    case 10: //relinquishProcessor()
    
      realobj->relinquishProcessor();
      return AppInterface::DONE;
    case 11: //ready()
    
      realobj->ready();
      return AppInterface::DONE;
    case 12: //domainNameServer()
    
      ret12 = realobj->domainNameServer();
      t->insert(new ObjLink((void*)ret12, 22, 0, 0));
      *((NameServer**)outputParam) = ret12;
      return AppInterface::DONE;
    case 13: //clone()
      param13_1 = *((char**)((char*)inputParam));
      param13_2 = *((char**)((char*)inputParam+sizeof(param13_1)));

      ret13 = realobj->clone(param13_1, param13_2);
      t->insert(new ObjLink((void*)ret13, 25, 0, 0));
      *((Process**)outputParam) = ret13;
      return AppInterface::DONE;
    case 14: //getResourceUsage()
      param14_1 = *((ProcessResourceUsage**)((char*)inputParam));

      realobj->getResourceUsage(param14_1);
      return AppInterface::DONE;
  }
  
  return AppInterface::INVALIDMETHOD;
}

inline AppInterface::EXCODE ApplicationProcessDispatcher(HashTable* t, ObjLink* obj, unsigned methodID, void* inputParam, void* outputParam) {
  ApplicationProcess* realobj = 0;
  PFV param0_1;
  Domain* param0_2;
  int param0_3;
  int param0_4;
  StackSize param0_5;
  
  if(methodID != 0) {
    realobj = (ApplicationProcess*)(obj->getObj());
    if(!realobj->classOf()->isASubclassOf(ApplicationProcessClass))
      return AppInterface::INVALIDCLASS;
  }
  
  switch(methodID) {
    case 0: //ApplicationProcess()
      param0_1 = *((PFV*)((char*)inputParam));
      param0_2 = *((Domain**)((char*)inputParam+sizeof(param0_1)));
      param0_3 = *((int*)((char*)inputParam+sizeof(param0_1)+sizeof(param0_2)));
      param0_4 = *((int*)((char*)inputParam+sizeof(param0_1)+sizeof(param0_2)+sizeof(param0_3)));
      param0_5 = *((StackSize*)((char*)inputParam+sizeof(param0_1)+sizeof(param0_2)+sizeof(param0_3)+sizeof(param0_4)));

      realobj = new ApplicationProcess(param0_1, param0_2, param0_3, param0_4, param0_5);
      t->insert(new ObjLink((void*)realobj, 26, 0, 0));
      *((ApplicationProcess**)outputParam) = realobj;
      return AppInterface::DONE;
  }
  
  return AppInterface::INVALIDMETHOD;
}

inline AppInterface::EXCODE FileObjectDispatcher(HashTable* t, ObjLink* obj, unsigned methodID, void* inputParam, void* outputParam) {
  FileObject* realobj = 0;
  unsigned int param0_1;
  int param0_2;
  int param0_3;
  MemoryObjectContainer* param0_4;
  PersistentMemoryObject* param0_5;
  int param0_6;
  OutputStream* param2_1;
  
  if(methodID != 0) {
    realobj = (FileObject*)(obj->getObj());
    if(!realobj->classOf()->isASubclassOf(FileObjectClass))
      return AppInterface::INVALIDCLASS;
  }
  
  switch(methodID) {
    case 0: //FileObject()
      param0_1 = *((unsigned int*)((char*)inputParam));
      param0_2 = *((int*)((char*)inputParam+sizeof(param0_1)));
      param0_3 = *((int*)((char*)inputParam+sizeof(param0_1)+sizeof(param0_2)));
      param0_4 = *((MemoryObjectContainer**)((char*)inputParam+sizeof(param0_1)+sizeof(param0_2)+sizeof(param0_3)));
      param0_5 = *((PersistentMemoryObject**)((char*)inputParam+sizeof(param0_1)+sizeof(param0_2)+sizeof(param0_3)+sizeof(param0_4)));
      param0_6 = *((int*)((char*)inputParam+sizeof(param0_1)+sizeof(param0_2)+sizeof(param0_3)+sizeof(param0_4)+sizeof(param0_5)));

      realobj = new FileObject(param0_1, param0_2, param0_3, param0_4, param0_5, param0_6);
      t->insert(new ObjLink((void*)realobj, 27, 0, 0));
      *((FileObject**)outputParam) = realobj;
      return AppInterface::DONE;
    case 2: //writeIdNumber()
      param2_1 = *((OutputStream**)((char*)inputParam));

      realobj->writeIdNumber(param2_1);
      return AppInterface::DONE;
  }
  
  return AppInterface::INVALIDMETHOD;
}

inline AppInterface::EXCODE FileObjectViewDispatcher(HashTable* t, ObjLink* obj, unsigned methodID, void* inputParam, void* outputParam) {
  FileObjectView* realobj = 0;
  unsigned int param0_1;
  int param0_2;
  int param0_3;
  MemoryObjectContainer* param0_4;
  PersistentMemoryObject* param0_5;
  int param0_6;
  
  if(methodID != 0) {
    realobj = (FileObjectView*)(obj->getObj());
    if(!realobj->classOf()->isASubclassOf(FileObjectViewClass))
      return AppInterface::INVALIDCLASS;
  }
  
  switch(methodID) {
    case 0: //FileObjectView()
      param0_1 = *((unsigned int*)((char*)inputParam));
      param0_2 = *((int*)((char*)inputParam+sizeof(param0_1)));
      param0_3 = *((int*)((char*)inputParam+sizeof(param0_1)+sizeof(param0_2)));
      param0_4 = *((MemoryObjectContainer**)((char*)inputParam+sizeof(param0_1)+sizeof(param0_2)+sizeof(param0_3)));
      param0_5 = *((PersistentMemoryObject**)((char*)inputParam+sizeof(param0_1)+sizeof(param0_2)+sizeof(param0_3)+sizeof(param0_4)));
      param0_6 = *((int*)((char*)inputParam+sizeof(param0_1)+sizeof(param0_2)+sizeof(param0_3)+sizeof(param0_4)+sizeof(param0_5)));

      realobj = new FileObjectView(param0_1, param0_2, param0_3, param0_4, param0_5, param0_6);
      t->insert(new ObjLink((void*)realobj, 28, 0, 0));
      *((FileObjectView**)outputParam) = realobj;
      return AppInterface::DONE;
  }
  
  return AppInterface::INVALIDMETHOD;
}

inline AppInterface::EXCODE PipeDispatcher(HashTable* t, ObjLink* obj, unsigned methodID, void* inputParam, void* outputParam) {
  Pipe* realobj = 0;
  int param0_1;
  char* param2_1;
  int param2_2;
  int param2_3;
  int ret2;
  char* param3_1;
  int param3_2;
  int param3_3;
  int ret3;
  
  if(methodID != 0) {
    realobj = (Pipe*)(obj->getObj());
    if(!realobj->classOf()->isASubclassOf(PipeClass))
      return AppInterface::INVALIDCLASS;
  }
  
  switch(methodID) {
    case 0: //Pipe()
      param0_1 = *((int*)((char*)inputParam));

      realobj = new Pipe(param0_1);
      t->insert(new ObjLink((void*)realobj, 29, thisProcess()));
      *((Pipe**)outputParam) = realobj;
      return AppInterface::DONE;
    case 1: //~Pipe()
      if(obj->refs()>0 && obj->redRef(thisProcess())==0) {
        delete realobj;
        t->remove(obj);
        std::multimap<Process*,ObjLink*>::iterator iter;
        iter = TheProcessObjMap.find(thisProcess());
        while(iter != TheProcessObjMap.end()) {
          Assert(iter->first == thisProcess());
          if(iter->second->getObj() == realobj)
            TheProcessObjMap.erase(iter);
          iter++;
        }
      }
      return AppInterface::DONE;
    case 2: //read()
      param2_1 = *((char**)((char*)inputParam));
      param2_2 = *((int*)((char*)inputParam+sizeof(param2_1)));
      param2_3 = *((int*)((char*)inputParam+sizeof(param2_1)+sizeof(param2_2)));

      ret2 = realobj->read(param2_1, param2_2, param2_3);
      *((int*)outputParam) = ret2;
      return AppInterface::DONE;
    case 3: //write()
      param3_1 = *((char**)((char*)inputParam));
      param3_2 = *((int*)((char*)inputParam+sizeof(param3_1)));
      param3_3 = *((int*)((char*)inputParam+sizeof(param3_1)+sizeof(param3_2)));

      ret3 = realobj->write(param3_1, param3_2, param3_3);
      *((int*)outputParam) = ret3;
      return AppInterface::DONE;
  }
  
  return AppInterface::INVALIDMETHOD;
}

inline AppInterface::EXCODE ConstructorDescriptorDispatcher(HashTable* t, ObjLink* obj, unsigned methodID, void* inputParam, void* outputParam) {
  ConstructorDescriptor* realobj = 0;
  char* param0_1;
  char* param0_2;
  unsigned int param0_3;
  PConstructor param0_4;
  
  if(methodID != 0) {
    realobj = (ConstructorDescriptor*)(obj->getObj());
    if(!realobj->classOf()->isASubclassOf(ConstructorDescriptorClass))
      return AppInterface::INVALIDCLASS;
  }
  
  switch(methodID) {
    case 0: //ConstructorDescriptor()
      param0_1 = *((char**)((char*)inputParam));
      param0_2 = *((char**)((char*)inputParam+sizeof(param0_1)));
      param0_3 = *((unsigned int*)((char*)inputParam+sizeof(param0_1)+sizeof(param0_2)));
      param0_4 = *((PConstructor*)((char*)inputParam+sizeof(param0_1)+sizeof(param0_2)+sizeof(param0_3)));

      realobj = new ConstructorDescriptor(param0_1, param0_2, param0_3, param0_4);
      t->insert(new ObjLink((void*)realobj, 30, 0, 0));
      *((ConstructorDescriptor**)outputParam) = realobj;
      return AppInterface::DONE;
  }
  
  return AppInterface::INVALIDMETHOD;
}

inline AppInterface::EXCODE TimeoutTimerDispatcher(HashTable* t, ObjLink* obj, unsigned methodID, void* inputParam, void* outputParam) {
  TimeoutTimer* realobj = 0;
  unsigned int param2_1;
  unsigned int ret2;
  unsigned int ret3;
  unsigned int ret4;
  
  if(methodID != 0) {
    realobj = (TimeoutTimer*)(obj->getObj());
    if(!realobj->classOf()->isASubclassOf(TimeoutTimerClass))
      return AppInterface::INVALIDCLASS;
  }
  
  switch(methodID) {
    case 0: //TimeoutTimer()
    
      realobj = new TimeoutTimer();
      t->insert(new ObjLink((void*)realobj, 31, thisProcess()));
      *((TimeoutTimer**)outputParam) = realobj;
      return AppInterface::DONE;
    case 1: //~TimeoutTimer()
      if(obj->refs()>0 && obj->redRef(thisProcess())==0) {
        delete realobj;
        t->remove(obj);
        std::multimap<Process*,ObjLink*>::iterator iter;
        iter = TheProcessObjMap.find(thisProcess());
        while(iter != TheProcessObjMap.end()) {
          Assert(iter->first == thisProcess());
          if(iter->second->getObj() == realobj)
            TheProcessObjMap.erase(iter);
          iter++;
        }
      }
      return AppInterface::DONE;
    case 2: //start()
      param2_1 = *((unsigned int*)((char*)inputParam));

      ret2 = realobj->start(param2_1);
      *((unsigned int*)outputParam) = ret2;
      return AppInterface::DONE;
    case 3: //stop()
    
      ret3 = realobj->stop();
      *((unsigned int*)outputParam) = ret3;
      return AppInterface::DONE;
    case 4: //residual()
    
      ret4 = realobj->residual();
      *((unsigned int*)outputParam) = ret4;
      return AppInterface::DONE;
    case 5: //await()
    
      realobj->await();
      return AppInterface::DONE;
  }
  
  return AppInterface::INVALIDMETHOD;
}

inline AppInterface::EXCODE ClassConstructorDispatcher(HashTable* t, ObjLink* obj, unsigned methodID, void* inputParam, void* outputParam) {
  ClassConstructor* realobj = 0;
  POFPO param0_1;
  ProxiableObject* param2_1;
  ProxiableObject* ret2;
  
  if(methodID != 0) {
    realobj = (ClassConstructor*)(obj->getObj());
    if(!realobj->classOf()->isASubclassOf(ClassConstructorClass))
      return AppInterface::INVALIDCLASS;
  }
  
  switch(methodID) {
    case 0: //ClassConstructor()
      param0_1 = *((POFPO*)((char*)inputParam));

      realobj = new ClassConstructor(param0_1);
      t->insert(new ObjLink((void*)realobj, 32, 0, 0));
      *((ClassConstructor**)outputParam) = realobj;
      return AppInterface::DONE;
    case 2: //construct()
      param2_1 = *((ProxiableObject**)((char*)inputParam));

      ret2 = realobj->construct(param2_1);
      t->insert(new ObjLink((void*)ret2, 1, 0, 0));
      *((ProxiableObject**)outputParam) = ret2;
      return AppInterface::DONE;
  }
  
  return AppInterface::INVALIDMETHOD;
}

inline AppInterface::EXCODE CharacterInputStreamDispatcher(HashTable* t, ObjLink* obj, unsigned methodID, void* inputParam, void* outputParam) {
  CharacterInputStream* realobj = 0;
  char* param2_1;
  int param2_2;
  int ret2;
  int param3_1;
  
  if(methodID != 0) {
    realobj = (CharacterInputStream*)(obj->getObj());
    if(!realobj->classOf()->isASubclassOf(CharacterInputStreamClass))
      return AppInterface::INVALIDCLASS;
  }
  
  switch(methodID) {
    case 2: //read()
      param2_1 = *((char**)((char*)inputParam));
      param2_2 = *((int*)((char*)inputParam+sizeof(param2_1)));

      ret2 = realobj->read(param2_1, param2_2);
      *((int*)outputParam) = ret2;
      return AppInterface::DONE;
    case 3: //switchCharacterQueue()
      param3_1 = *((int*)((char*)inputParam));

      realobj->switchCharacterQueue(param3_1);
      return AppInterface::DONE;
  }
  
  return AppInterface::INVALIDMETHOD;
}

inline AppInterface::EXCODE BinarySemaphoreDispatcher(HashTable* t, ObjLink* obj, unsigned methodID, void* inputParam, void* outputParam) {
  BinarySemaphore* realobj = 0;
  int param0_1;
  
  if(methodID != 0) {
    realobj = (BinarySemaphore*)(obj->getObj());
    if(!realobj->classOf()->isASubclassOf(BinarySemaphoreClass))
      return AppInterface::INVALIDCLASS;
  }
  
  switch(methodID) {
    case 0: //BinarySemaphore()
      param0_1 = *((int*)((char*)inputParam));

      realobj = new BinarySemaphore(param0_1);
      t->insert(new ObjLink((void*)realobj, 34, thisProcess()));
      *((BinarySemaphore**)outputParam) = realobj;
      return AppInterface::DONE;
    case 1: //~BinarySemaphore()
      if(obj->refs()>0 && obj->redRef(thisProcess())==0) {
        delete realobj;
        t->remove(obj);
        std::multimap<Process*,ObjLink*>::iterator iter;
        iter = TheProcessObjMap.find(thisProcess());
        while(iter != TheProcessObjMap.end()) {
          Assert(iter->first == thisProcess());
          if(iter->second->getObj() == realobj)
            TheProcessObjMap.erase(iter);
          iter++;
        }
      }
      return AppInterface::DONE;
  }
  
  return AppInterface::INVALIDMETHOD;
}

inline AppInterface::EXCODE PersistentClassDispatcher(HashTable* t, ObjLink* obj, unsigned methodID, void* inputParam, void* outputParam) {
  PersistentClass* realobj = 0;
  Class* param0_1;
  int param0_2;
  char* param0_3;
  ClassConstructor* param0_4;
  MemoryObjectDictionary* ret2;
  PersistentObject* ret3;
  int param4_1;
  PersistentObject* ret4;
  
  if(methodID != 0) {
    realobj = (PersistentClass*)(obj->getObj());
    if(!realobj->classOf()->isASubclassOf(PersistentClassClass))
      return AppInterface::INVALIDCLASS;
  }
  
  switch(methodID) {
    case 0: //PersistentClass()
      param0_1 = *((Class**)((char*)inputParam));
      param0_2 = *((int*)((char*)inputParam+sizeof(param0_1)));
      param0_3 = *((char**)((char*)inputParam+sizeof(param0_1)+sizeof(param0_2)));
      param0_4 = *((ClassConstructor**)((char*)inputParam+sizeof(param0_1)+sizeof(param0_2)+sizeof(param0_3)));

      realobj = new PersistentClass(param0_1, param0_2, param0_3, param0_4);
      t->insert(new ObjLink((void*)realobj, 35, 0, 0));
      *((PersistentClass**)outputParam) = realobj;
      return AppInterface::DONE;
    case 2: //rootDictionary()
    
      ret2 = realobj->rootDictionary();
      t->insert(new ObjLink((void*)ret2, 19, 0, 0));
      *((MemoryObjectDictionary**)outputParam) = ret2;
      return AppInterface::DONE;
    case 3: //newObject()
    
      ret3 = realobj->newObject();
      t->insert(new ObjLink((void*)ret3, 9, 0, 0));
      *((PersistentObject**)outputParam) = ret3;
      return AppInterface::DONE;
    case 4: //retrieveObject()
      param4_1 = *((int*)((char*)inputParam));

      ret4 = realobj->retrieveObject(param4_1);
      t->insert(new ObjLink((void*)ret4, 9, 0, 0));
      *((PersistentObject**)outputParam) = ret4;
      return AppInterface::DONE;
  }
  
  return AppInterface::INVALIDMETHOD;
}

inline AppInterface::EXCODE SymbolicLinkDispatcher(HashTable* t, ObjLink* obj, unsigned methodID, void* inputParam, void* outputParam) {
  SymbolicLink* realobj = 0;
  PersistentMemoryObject* param0_1;
  
  if(methodID != 0) {
    realobj = (SymbolicLink*)(obj->getObj());
    if(!realobj->classOf()->isASubclassOf(SymbolicLinkClass))
      return AppInterface::INVALIDCLASS;
  }
  
  switch(methodID) {
    case 0: //SymbolicLink()
      param0_1 = *((PersistentMemoryObject**)((char*)inputParam));

      realobj = new SymbolicLink(param0_1);
      t->insert(new ObjLink((void*)realobj, 36, 0, 0));
      *((SymbolicLink**)outputParam) = realobj;
      return AppInterface::DONE;
  }
  
  return AppInterface::INVALIDMETHOD;
}

inline AppInterface::EXCODE TimingInterfaceDispatcher(HashTable* t, ObjLink* obj, unsigned methodID, void* inputParam, void* outputParam) {
  TimingInterface* realobj = 0;
  int param3_1;
  int param4_1;
  int param4_2;
  char* param5_1;
  TimingInterface* param6_1;
  TimingInterface* ret7;
  TimingInterface* ret8;
  TimingInterface* ret9;
  TimingInterface* ret10;
  TimingInterface* param11_1;
  TimingInterface* param12_1;
  unsigned int param13_1;
  unsigned int ret13;
  unsigned int param14_1;
  unsigned int ret14;
  unsigned int param15_1;
  unsigned int ret15;
  unsigned int param16_1;
  unsigned int ret16;
  unsigned int param17_1;
  unsigned int param17_2;
  unsigned int ret17;
  unsigned int param18_1;
  unsigned int ret18;
  unsigned int param19_1;
  unsigned int ret19;
  unsigned int param20_1;
  unsigned int ret20;
  
  if(methodID != 0) {
    realobj = (TimingInterface*)(obj->getObj());
    if(!realobj->classOf()->isASubclassOf(TimingInterfaceClass))
      return AppInterface::INVALIDCLASS;
  }
  
  switch(methodID) {
    case 0: //TimingInterface()
    
      realobj = new TimingInterface();
      t->insert(new ObjLink((void*)realobj, 37, thisProcess()));
      *((TimingInterface**)outputParam) = realobj;
      return AppInterface::DONE;
    case 1: //~TimingInterface()
      if(obj->refs()>0 && obj->redRef(thisProcess())==0) {
        delete realobj;
        t->remove(obj);
        std::multimap<Process*,ObjLink*>::iterator iter;
        iter = TheProcessObjMap.find(thisProcess());
        while(iter != TheProcessObjMap.end()) {
          Assert(iter->first == thisProcess());
          if(iter->second->getObj() == realobj)
            TheProcessObjMap.erase(iter);
          iter++;
        }
      }
      return AppInterface::DONE;
    case 2: //nullCall()
    
      realobj->nullCall();
      return AppInterface::DONE;
    case 3: //intParam()
      param3_1 = *((int*)((char*)inputParam));

      realobj->intParam(param3_1);
      return AppInterface::DONE;
    case 4: //twoIntParams()
      param4_1 = *((int*)((char*)inputParam));
      param4_2 = *((int*)((char*)inputParam+sizeof(param4_1)));

      realobj->twoIntParams(param4_1, param4_2);
      return AppInterface::DONE;
    case 5: //ptrParam()
      param5_1 = *((char**)((char*)inputParam));

      realobj->ptrParam(param5_1);
      return AppInterface::DONE;
    case 6: //proxyParam()
      param6_1 = *((TimingInterface**)((char*)inputParam));

      realobj->proxyParam(param6_1);
      return AppInterface::DONE;
    case 7: //returnOldProxy()
    
      ret7 = realobj->returnOldProxy();
      t->insert(new ObjLink((void*)ret7, 37, 0, 0));
      *((TimingInterface**)outputParam) = ret7;
      return AppInterface::DONE;
    case 8: //returnNewProxy()
    
      ret8 = realobj->returnNewProxy();
      t->insert(new ObjLink((void*)ret8, 37, 0, 0));
      *((TimingInterface**)outputParam) = ret8;
      return AppInterface::DONE;
    case 9: //returnOldProxyAsterisk()
    
      ret9 = realobj->returnOldProxyAsterisk();
      t->insert(new ObjLink((void*)ret9, 37, 0, 0));
      *((TimingInterface**)outputParam) = ret9;
      return AppInterface::DONE;
    case 10: //returnNewProxyAsterisk()
    
      ret10 = realobj->returnNewProxyAsterisk();
      t->insert(new ObjLink((void*)ret10, 37, 0, 0));
      *((TimingInterface**)outputParam) = ret10;
      return AppInterface::DONE;
    case 11: //setOutCallInterface()
      param11_1 = *((TimingInterface**)((char*)inputParam));

      realobj->setOutCallInterface(param11_1);
      return AppInterface::DONE;
    case 12: //setOutProxyInterface()
      param12_1 = *((TimingInterface**)((char*)inputParam));

      realobj->setOutProxyInterface(param12_1);
      return AppInterface::DONE;
    case 13: //outNullCalls()
      param13_1 = *((unsigned int*)((char*)inputParam));

      ret13 = realobj->outNullCalls(param13_1);
      *((unsigned int*)outputParam) = ret13;
      return AppInterface::DONE;
    case 14: //outIntParams()
      param14_1 = *((unsigned int*)((char*)inputParam));

      ret14 = realobj->outIntParams(param14_1);
      *((unsigned int*)outputParam) = ret14;
      return AppInterface::DONE;
    case 15: //outTwoIntParams()
      param15_1 = *((unsigned int*)((char*)inputParam));

      ret15 = realobj->outTwoIntParams(param15_1);
      *((unsigned int*)outputParam) = ret15;
      return AppInterface::DONE;
    case 16: //outPtrParams()
      param16_1 = *((unsigned int*)((char*)inputParam));

      ret16 = realobj->outPtrParams(param16_1);
      *((unsigned int*)outputParam) = ret16;
      return AppInterface::DONE;
    case 17: //outProxyParams()
      param17_1 = *((unsigned int*)((char*)inputParam));
      param17_2 = *((unsigned int*)((char*)inputParam+sizeof(param17_1)));

      ret17 = realobj->outProxyParams(param17_1, param17_2);
      *((unsigned int*)outputParam) = ret17;
      return AppInterface::DONE;
    case 18: //outRefUnref()
      param18_1 = *((unsigned int*)((char*)inputParam));

      ret18 = realobj->outRefUnref(param18_1);
      *((unsigned int*)outputParam) = ret18;
      return AppInterface::DONE;
    case 19: //outReturnOldProxyAsterisks()
      param19_1 = *((unsigned int*)((char*)inputParam));

      ret19 = realobj->outReturnOldProxyAsterisks(param19_1);
      *((unsigned int*)outputParam) = ret19;
      return AppInterface::DONE;
    case 20: //outReturnNewProxyAsterisks()
      param20_1 = *((unsigned int*)((char*)inputParam));

      ret20 = realobj->outReturnNewProxyAsterisks(param20_1);
      *((unsigned int*)outputParam) = ret20;
      return AppInterface::DONE;
  }
  
  return AppInterface::INVALIDMETHOD;
}

inline AppInterface::EXCODE FreeRunningTimerDispatcher(HashTable* t, ObjLink* obj, unsigned methodID, void* inputParam, void* outputParam) {
  FreeRunningTimer* realobj = 0;
  unsigned int ret2;
  
  if(methodID != 0) {
    realobj = (FreeRunningTimer*)(obj->getObj());
    if(!realobj->classOf()->isASubclassOf(FreeRunningTimerClass))
      return AppInterface::INVALIDCLASS;
  }
  
  switch(methodID) {
    case 2: //time()
    
      ret2 = realobj->time();
      *((unsigned int*)outputParam) = ret2;
      return AppInterface::DONE;
  }
  
  return AppInterface::INVALIDMETHOD;
}

inline AppInterface::EXCODE RaidOutputStreamDispatcher(HashTable* t, ObjLink* obj, unsigned methodID, void* inputParam, void* outputParam) {
  RaidOutputStream* realobj = 0;
  char* param2_1;
  int param2_2;
  int ret2;
  
  if(methodID != 0) {
    realobj = (RaidOutputStream*)(obj->getObj());
    if(!realobj->classOf()->isASubclassOf(RaidOutputStreamClass))
      return AppInterface::INVALIDCLASS;
  }
  
  switch(methodID) {
    case 2: //write()
      param2_1 = *((char**)((char*)inputParam));
      param2_2 = *((int*)((char*)inputParam+sizeof(param2_1)));

      ret2 = realobj->write(param2_1, param2_2);
      *((int*)outputParam) = ret2;
      return AppInterface::DONE;
  }
  
  return AppInterface::INVALIDMETHOD;
}
