#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Vincent F. Russo (russo@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * AwaitedInterruptInterrupt.cc:
 */

#include "Assert.h"
#include "AwaitedInterruptInterrupt.h"
#include "OutputStream.h"
#include "Semaphore.h"


#ifdef __GNUC__
#pragma implementation
#endif


AwaitedInterruptInterrupt::AwaitedInterruptInterrupt()
{
	Debug << this << "::AwaitedInterruptInterrupt()\n" << eor;
	Assert( this != 0 );

	_rendevous = new GraciousSemaphore( 0 );
	_rendevous->setName("#AwaitedInterruptInterruptSemaphore");
}

AwaitedInterruptInterrupt::~AwaitedInterruptInterrupt()
{
	Assert( NOTREACHED );
}

// If an interrupt process is
// interrupted will it be enqueued?

void
AwaitedInterruptInterrupt::basicRaise( char * )
{
	Debug << this << "::basicRaise()\n" << eor;
	Assert( this != 0 );
	_rendevous->V();
}
