#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Peter W. Madany (madany@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * MemoryBlockRoutines.c: Memory block copy/zero routines. These are in C++
 *	and compile very efficiently using the GNU compiler on most machines.
 *	Your mileage may vary. You might want to replace these with assembler
 *	assists on specific architectures.
 */


#ifdef __GNUC__
#pragma implementation
#endif

void
CopyBlock( const char * src, char * dest, unsigned int size )
{
	const int * source = (int *) src;
	int * destination = (int *) dest;

	while( size >= 128 ) {
		*destination = *source;
		*(destination+1) = *(source+1);
		*(destination+2) = *(source+2);
		*(destination+3) = *(source+3);
		*(destination+4) = *(source+4);
		*(destination+5) = *(source+5);
		*(destination+6) = *(source+6);
		*(destination+7) = *(source+7);
		*(destination+8) = *(source+8);
		*(destination+9) = *(source+9);
		*(destination+10) = *(source+10);
		*(destination+11) = *(source+11);
		*(destination+12) = *(source+12);
		*(destination+13) = *(source+13);
		*(destination+14) = *(source+14);
		*(destination+15) = *(source+15);
		*(destination+16) = *(source+16);
		*(destination+17) = *(source+17);
		*(destination+18) = *(source+18);
		*(destination+19) = *(source+19);
		*(destination+20) = *(source+20);
		*(destination+21) = *(source+21);
		*(destination+22) = *(source+22);
		*(destination+23) = *(source+23);
		*(destination+24) = *(source+24);
		*(destination+25) = *(source+25);
		*(destination+26) = *(source+26);
		*(destination+27) = *(source+27);
		*(destination+28) = *(source+28);
		*(destination+29) = *(source+29);
		*(destination+30) = *(source+30);
		*(destination+31) = *(source+31);
		source += 32;
		destination += 32;
		size -= 128;
	}
	if( size > 0 ) {
		char * s = (char *) source;
		char * d = (char *) destination;
		while( size-- > 0 ) *d++ = *s++;
	}
}

void
ZeroBlock( char * dest, unsigned int size )
{
	int * destination = (int *) dest;

	while( size >= 128 ) {
		*destination = 0;
		*(destination+1) = 0;
		*(destination+2) = 0;
		*(destination+3) = 0;
		*(destination+4) = 0;
		*(destination+5) = 0;
		*(destination+6) = 0;
		*(destination+7) = 0;
		*(destination+8) = 0;
		*(destination+9) = 0;
		*(destination+10) = 0;
		*(destination+11) = 0;
		*(destination+12) = 0;
		*(destination+13) = 0;
		*(destination+14) = 0;
		*(destination+15) = 0;
		*(destination+16) = 0;
		*(destination+17) = 0;
		*(destination+18) = 0;
		*(destination+19) = 0;
		*(destination+20) = 0;
		*(destination+21) = 0;
		*(destination+22) = 0;
		*(destination+23) = 0;
		*(destination+24) = 0;
		*(destination+25) = 0;
		*(destination+26) = 0;
		*(destination+27) = 0;
		*(destination+28) = 0;
		*(destination+29) = 0;
		*(destination+30) = 0;
		*(destination+31) = 0;
		destination += 32;
		size -= 128;
	}
	if( size > 0 ) {
		char * dst = (char *) destination;
		while( size-- > 0 ) *dst++ = 0;
	}
}
