#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Vincent F. Russo (russo@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * NewAndDelete.cc: Stuff to Make C++ happy (operators new and delete)
 */

#include "Allocator.h"

#ifdef __GNUC__
#pragma implementation
#endif

Allocator * ObjectHeap = 0;

Allocator *
SetNewAllocator( Allocator * allocator )
{
    Allocator * oldHeap = ObjectHeap;
    ObjectHeap = allocator;
    return( oldHeap );
}

Allocator *
GetNewAllocator()
{
    return( ObjectHeap );
}


void *
operator new( size_t size )
{
    return( ObjectHeap->allocate( (unsigned int) size ) );
}

void *
operator new[] ( size_t size )
{
    return( ObjectHeap->allocate( (unsigned int) size ) );
}

void 
operator delete( void * p )
{
    ObjectHeap->free( p );
}

void
operator delete[] ( void * p )
{
    ObjectHeap->free( p );
}

extern "C" void *__wrap_malloc(unsigned size) 
{
    return( ObjectHeap->allocate( (unsigned int) size ) );
}

extern "C" void __wrap_free(void *ptr) 
{
    ObjectHeap->free(ptr);
}
