#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Vincent F. Russo (russo@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * ObjectProxyVtable.cc: object proxy interface support.
 */

#ifdef __GNUC__
#pragma implementation "ObjectProxy.h"
#endif

#include "Assert.h"
#include "ObjectProxy.h"
#include "SystemInterface.h"

#ifdef __GNUC__
#pragma implementation
#endif

/*
 * The methods in this file must be in user executable (kernel) memory.
 * The constructor is here to assure that the vtables for all ObjectProxy's
 *   also end up in user readable memory.  cfront generates the vtable
 *   for the first virtual function instead of the constructor, and that
 *   is in here as well.  cfront puts the vtable in .data so both the .text
 *   and .data of this file need to be in user readable memory.
 * ObjectProxy methods that do not need to be in user executable memory
 *   are in the machine independent file ObjectProxy.cc, and the stubs
 *   for proxy calls are in ObjectProxyStubs.cc.
 */

ObjectProxy::ObjectProxy()
{
	key._proxiedObject = 0;
}

/*
 * this guy is the first virtual function in ObjectProxy.h, but is actually
 *   the second function in the vtable.
 */

int
ObjectProxy::isProxy()
{
	return( 1 );
}

