#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 *
 * Copyright (c) 2006
 * The University of Illinois Board of Trustees.
 *  All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Francis David (fdavid@uiuc.edu)
 *
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 */
/*
 * ProcessorException.cc: exception class stubs.
 */

#include "ProcessorException.h"
#include "ClassStar.h"


#ifdef __GNUC__
#pragma implementation
#endif

ProcessorException::ProcessorException()
    : Exception("Generic Processor Exception")
{
}

/**
 * Create an exception with the given message.
 *
 * @param msg Message to describe the exception.
 */
ProcessorException::ProcessorException(const char *msg)
    : Exception(msg)
{
}

/**
 * Destroy the exception including the message.
 */
ProcessorException::~ProcessorException()
{

}

#include "ClassInstaller.h"
DEFINECLASS("ProcessorException",ProcessorException,Object,0,0);
