#ifdef __GNUC__
#pragma implementation
#endif

#include "RecklessDriverDD.h"
#include "ThisCPU.h"

void RecklessDriverDD::runCommand(int cmd)
{
    Exception* ex = 0;
    char *oldStackPointer_;

    // Save current stack
    asm( "mov %0, sp":"=r"(oldStackPointer_) );
    switchToDriverDomain();     
    asm( "mov r13, %0"::"r"(newStackPointer_) );

    try{
        if(cmd==1) {      
            RecklessDriver::accessOutOfBounds();
        } else if (cmd==2) {
            RecklessDriver::accessKernelObjects();
        } else if (cmd==3) {
            RecklessDriver::setKernelObjects();
        } else if (cmd==4) {
            RecklessDriver::invalidPointerDereference();
        } else {
            return ;
        }
    } catch (Exception* e){
        ex = e;
    }
  
    switchToKernelDomain();

    // Restore stack
    asm("mov sp, %0"::"r"(oldStackPointer_));

    if(ex) throw ex;
}

void RecklessDriverDD::accessOutOfBounds()
{
    runCommand(1);
}

void RecklessDriverDD::accessKernelObjects()
{
    runCommand(2);  
}

void RecklessDriverDD::setKernelObjects()
{
    runCommand(3);  
}

void RecklessDriverDD::invalidPointerDereference()
{
    runCommand(4);  
}
