#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Vincent F. Russo (russo@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * StupidAllocator.c: the dumbest allocator...
 */

#include "Assert.h"
#include "OutputStream.h"
#include "StupidAllocator.h"

#ifdef __GNUC__
#pragma implementation
#endif


StupidAllocator::StupidAllocator( void * base )
{
	top = (char *) base;
}

StupidAllocator::~StupidAllocator()
{
	Assert( NOTREACHED );
}

/*
 * Don't ever try to print anything in this function since it is used to
 * allocate the Console with.
 */
void *
StupidAllocator::allocate( unsigned int nbytes )
{
	char * val = top;
	top = (char*)(((unsigned int)top + nbytes + 7) & ~7);
	/* doubleword align that, cleverly, does not assume top was
	   previously already a multiple of 8  */
	return( val );
}

void
StupidAllocator::free( void * p )
{
	if( p != 0 ) {
		Console() << "StupidAllocator::free " << asAddress( p )
			<< "\n" << eor;
		//Assert( NOTREACHED );
	}
}
