#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: John L. Coolidge (coolidge@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * TimeOfDay.cc: definitions for the time of day class
 */

#include "SystemTime.h"
#include "TimeOfDay.h"
#include "UnixTime.h"


#ifdef __GNUC__
#pragma implementation
#endif

TimeOfDay* theSystemClock = 0;

TimeOfDay::TimeOfDay()
{
	// Default is to do nothing
}

// Perhaps these should return an error?

void TimeOfDay::getTime( SystemTime& time )
{
	// Default is to return (0,0)
	time.setTime( 0 );
	time.setTimeZoneOffset( 0 );
}

void TimeOfDay::setTime( SystemTime& time )
{
	// Default is to do nothing
}

void TimeOfDay::getUnixTime( UnixTime& time)
{
	SystemTime stime;
	getTime( stime );
	time = stime.unixTime();
}

void TimeOfDay::setUnixTime( UnixTime& time)
{
	// Default is to do nothing
}

#include "ClassInstaller.h"
DEFINECLASS("TimeOfDay",TimeOfDay,ProxiableObject,0,0);
