/**********************
*Example of using the *
*HelloWorldDevice and *
*LKMAdaptor together  *
*to define the use of *
*a loadable kernel mod*
*as the implementaiton*
*of a Choices device  *
*interface            *
***********************/
//SCOTT KIRCHER

#include "HelloWorldLKM.h"

//"implementation" of HelloWorldLKM
//The real implementation is provided by the loadable
//helloworld module

//call the base class constructors.
HelloWorldLKM::HelloWorldLKM(const char *LKMmodulename) : HelloWorldDevice(), LKMAdaptor()
{
	//here, we would add any additional required functions that must
	//be implemented in the LKMmodule, using
	//addRequiredSymbol(...)
	//but there aren't any for helloworld

	//now we load the module
	int status=loadELF(LKMmodulename);
	Assert(status==0);
}

//helloWorld is implemented simply by calling initModule (which calls init_module in the LKM)
void HelloWorldLKM::helloWorld()
{
	initModule();
}
