#ifdef __GNUC__
#pragma implementation
#endif

#include "Byte.h"

#ifdef __GNUC__
#pragma implementation
#endif

#if (!defined(SPARC) && !defined(ARM))

class WordSize {
public:
	static int log2WordSize;
	static int wordSize;
	static int wordSizeMask;
	WordSize();
};

int WordSize::log2WordSize = 0;
int WordSize::wordSize = 0;
int WordSize::wordSizeMask = 0;

WordSize::WordSize()
{
	wordSize = sizeof(int);
	int tmp = wordSize >> 1;
	log2WordSize = 0;
	while (tmp) {
		tmp = tmp >> 1;
		log2WordSize++;
	}
	wordSizeMask = wordSize - 1;
}

WordSize wordSize;

void
ByteCopy( const void * source, void * destination, int length )
{
	if ( ((int) source & WordSize::wordSizeMask) != 0 || 
	     ((int) destination & WordSize::wordSizeMask) != 0 ||
	     (length & WordSize::wordSizeMask) != 0 ) {
		char * s = (char *) source;
		char * d = (char *) destination;
		while ( length-- )
			*d++ = *s++;
	} else {
		int * s = (int *) source;
		int * d = (int *) destination;
		length >>= WordSize::log2WordSize;
		while ( length-- )
			*d++ = *s++;
	}
}


int
ByteCompare( const void * b1, const void * b2, int length )
{
	char * a = (char *) b1;
	char * b = (char *) b2;
	while ( length-- ) {
		int d = *a++ - *b++;
		if ( d )
			return d;
	}
	return 0;
}

void
ByteZero( void * b, int length )
{
	if ( ((int) b & WordSize::wordSizeMask) != 0 || 
	     (length & WordSize::wordSizeMask) != 0 ) {
		char * p = (char *) b;
		while ( length-- )
			*p++ = '\0';
	} else {
		int * p = (int *) b;
		length >>= WordSize::log2WordSize;
		while ( length -- )
			*p++ = 0;		
	}
}

#endif /* SPARC */
