#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990 The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Aamod Sane (sane@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * IteratingList.cc - List with a iterator
 *
 *	$Header: /projects/choices/old/cvsroot/choices/Libraries/GeneralPurpose/Portable/IteratingList.cc,v 1.1 2004/06/03 01:58:48 jcarlyle Exp $
 */
#include "IteratingList.h"
#include "LinkIterator.h"

#ifdef __GNUC__
#pragma implementation
#endif


IteratingList::IteratingList()
{
    _iterator = new LinkIterator(0);
}


IteratingList::IteratingList(Link * l, int existingItems)
: HintList(l,existingItems)
{
    _iterator = new LinkIterator(l);
}

Link *
IteratingList::current()
{
    return _iterator->current();
}
     

IteratingList::~IteratingList()
{
    Assert( _iterator != 0 );
    delete _iterator;
}

void
IteratingList::add( Link * newEntry, Link * oldEntry, int before )
{
    HintList::add(newEntry,oldEntry,before);
    _iterator->reset( _head );
}

Link *
IteratingList::remove( Link * oldEntry, int nth )
{
    Link * tmp = HintList::remove( oldEntry, nth );
    _iterator->reset( _head );
    return tmp;
}

void
IteratingList::destroy()
{
    HintList::destroy();
    _iterator->reset();
}

Link *
IteratingList::next()
{
    return _iterator->next();
}

void
IteratingList::reset()
{
    _iterator->reset();
}
void
IteratingList::rewind()
{
    _iterator->reset(_head);
}

