#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989 The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: See-Mong Tan (stan@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * LinkIterator.cc:  Iterator over linked lists
 *
 *	$Header: /projects/choices/old/cvsroot/choices/Libraries/GeneralPurpose/Portable/LinkIterator.cc,v 1.1 2004/06/03 01:58:48 jcarlyle Exp $
 */
#include "Assert.h"
#include "Link.h"
#include "LinkIterator.h" 

#ifdef __GNUC__
#pragma implementation
#endif


SLink *
SLinkIterator::next()
{
    if ( isEmpty() )
	return 0;
    if ( atStart() ) {
	currentSLink = initialSLink->next();
	return initialSLink;
    }
    else if ( atEnd() ) 
	return 0; 
    else {
	SLink * link = currentSLink;
	currentSLink = currentSLink->next();
	return link;
    }
}
	
SLink *
SLinkIterator::current()
{
    if (isEmpty())
	return 0;
    else if (atStart())
	return initialSLink;
    else if (atEnd())
	return 0;
    else
	return currentSLink;
}

void
SLinkIterator::destroy(LinkVirtualiser * v)
{
    if ( isEmpty() )
	return;

    SLink * l;
    currentSLink = initialSLink;
    do {
	l = currentSLink->next();
	v->destroy(currentSLink);
	currentSLink = l;
    }
    while ( !atEnd() );
}

// Since we inherit data from SLinkIterator, we still have SLinks.
// Hence a cast

void
LinkIterator::destroy()
{
    if ( isEmpty() )
	return;

    SLink * l;
    currentSLink = initialSLink;
    do {
	l = currentSLink->next();
	delete (Link *)currentSLink;
	currentSLink = l;
    }
    while ( !atEnd() );
}
