#ifdef __GNUC__
#pragma implementation
#endif

/*
 * $Header: /projects/choices/old/cvsroot/choices/Libraries/Math/frexp.cc,v 1.1 2004/06/03 01:58:49 jcarlyle Exp $
 *	replaces: @(#)frexp.c	4.1 (Berkeley) 12/21/80
 *
 * the function call
 *		x = frexp(arg,&exp);
 * returns a double precision floating point quantity x and a corresponding binary
 * exponent exp such that
 *		0.5 <= x < 1.0
 *		arg = x*(2^exp)
 *
 * Implementation notes:
 *	1.  This is a non-portable implementation which works for IEEE floating
 *		point only.
 *	2.  This implementation fixes a bug in the previous implementation.
 *		Previously, the return value met the condition
 *			0.5 <= x <= 1.0
 *		rather than
 *			0.5 <= x < 1.0
 */

#define	BIAS	(1023)		/* exponent bias */
#define	NEWEXP	(-1)		/* new exponent */

#include "Math.h"
#include "Nan.h"
/*#include <nan.h> */

#ifdef __GNUC__
#pragma implementation
#endif


double frexp(double x,int *i)
	{
#ifdef SPARC
	unsigned * dummy = (unsigned *) &x;
	unsigned de = ( * dummy & 0x7ff00000 ) >> 20;
	*i = ( de - BIAS ) - NEWEXP;
	*dummy &= ~0x7ff00000;
	*dummy |= ( ( NEWEXP + BIAS ) & 0x7ff ) << 20;
	return( x );
#else
	union __NaN *px;

	px = (union __NaN *)&x;
	*i = (px->ds.de - BIAS) - NEWEXP;
	px->ds.de = NEWEXP + BIAS;
	return (x);
#endif
	}
