#ifdef __GNUC__
#pragma implementation
#endif

/* %W% */
/* %Q% */
/* %G% */
/*LINTLIBRARY*/
/*
 * $Header: /projects/choices/old/cvsroot/choices/Libraries/Math/ldexp.cc,v 1.1 2004/06/03 01:58:49 jcarlyle Exp $
 *	Replaces System 5.2 version
 *
 * double ldexp (value, exp)
 *	double value;
 *	int exp;
 *
 * ldexp returns
 *	value*(2^exp)	if the result is in range
 *	0.0		if underflow occurs
 *	MAXFLOAT	if overflow occurs and value > 0
 *	-MAXFLOAT	if overflow occurs and value < 0
 *
 * If underflow or overflow occurs, errno is set to ERANGE.
 *	Since errno is not modified if there is no error, a
 *	program which tests errno after calling ldexp should
 *	set it to a value other than ERANGE (like 0) before
 *	calling ldexp.
 *
 * Implementation note:
 *	This is a non-portable implementation which works for IEEE floating
 *		point format only.
 */

#include "Math.h" 
#include "Values.h"
#include "Nan.h"

#ifdef __GNUC__
#pragma implementation
#endif


#define	BIAS	1023

double ldexp(double value, int exp)
	{
	extern int errno;
	register union __NaN *px;
	register int newexp;

	if (exp == 0 || value == 0.0) /* nothing to do for zero */
		return (value);
#ifdef SPARC
	newexp = exp + ( ( *((unsigned *) &value) & 0x7ff00000 ) >> 20 ) - 
		 BIAS;
#else
	px = (union __NaN *)&value;
	newexp = exp + px->ds.de - BIAS;
#endif
	if (newexp > MAXBEXP)		/* overflow */
		{
		errno = 0;
		return (value > 0 ? -MAXFLOAT : MAXFLOAT);
		}
	else if (newexp < MINBEXP)	/* underflow */
		{
		errno = 0;
		return (0.0);
		}
	else				/* just right */
		{
#ifdef SPARC
		unsigned * dummy = ( unsigned * ) & value;
		*dummy &= ~0x7ff00000;
		*dummy |= ( ( newexp + BIAS ) & 0x7ff ) << 20;
#else			
		px->ds.de = newexp + BIAS;
#endif
		return (value);
		}
	}
