#include "Domain.h"

#include "ApplicationProcess.h"
#include "exception.h"

ApplicationProcess::ApplicationProcess(void* k) :Process((void*)0) {kernelObj=k;}

ApplicationProcess::ApplicationProcess(PFV arg3, Domain* arg4, int arg1, int arg2, StackSize arg5) :Process((void*)0)
{
  kernel_exception::EXCODE code;
  char paramBuffer[0+sizeof(arg3)+sizeof(arg4)+sizeof(arg1)+sizeof(arg2)+sizeof(arg5)];
  *(PFV*)(paramBuffer) = arg3;
  *(Domain**)(paramBuffer+sizeof(arg3)) = (Domain*)(arg4->kernelObj);
  *(int*)(paramBuffer+sizeof(arg3)+sizeof(arg4)) = arg1;
  *(int*)(paramBuffer+sizeof(arg3)+sizeof(arg4)+sizeof(arg1)) = arg2;
  *(StackSize*)(paramBuffer+sizeof(arg3)+sizeof(arg4)+sizeof(arg1)+sizeof(arg2)) = arg5;

  asm volatile (
		"mov r0, #0\n\t"
		"mov r2, %1\n\t"
		"mov r3, %2\n\t"
		"swi #3866\n\t"
		"str r0, %0"
		: "=m"(code) : "r" (paramBuffer), "r"(&kernelObj) : "r0", "r1", "r2", "r3" 
		);
  kernel_exception::throw_exception(code);
  
}

ApplicationProcess::~ApplicationProcess() {}
#include "ClassInstaller.h"
DEFINECLASS("ApplicationProcess",ApplicationProcess,Process,0,0);

