
#include "BinarySemaphore.h"
#include "exception.h"

BinarySemaphore::BinarySemaphore(void* k) :Semaphore((void*)0) {kernelObj=k;}

BinarySemaphore::BinarySemaphore(int initialCount) :Semaphore((void*)0)
{
  kernel_exception::EXCODE code;
  char paramBuffer[0+sizeof(initialCount)];
  *(int*)(paramBuffer) = initialCount;

  asm volatile (
		"mov r0, #0\n\t"
		"mov r2, %1\n\t"
		"mov r3, %2\n\t"
		"swi #3874\n\t"
		"str r0, %0"
		: "=m"(code) : "r" (paramBuffer), "r"(&kernelObj) : "r0", "r1", "r2", "r3" 
		);
  kernel_exception::throw_exception(code);
  
}

BinarySemaphore::~BinarySemaphore() 
{
  kernel_exception::EXCODE code;
  asm volatile (
		"mov r0, #1\n\t"
		"mov r1, %1\n\t"
		"swi $3874\n\t"
		"str r0, %0"
		: "=m" (code) :"r" (kernelObj) : "r0", "r1", "r2", "r3"
		);
  kernel_exception::throw_exception(code);
}
#include "ClassInstaller.h"
DEFINECLASS("BinarySemaphore",BinarySemaphore,Semaphore,0,0);

