
#include "CharacterInputStream.h"
#include "exception.h"

CharacterInputStream::CharacterInputStream(void* k) :InputStream((void*)0) {kernelObj=k;}

int CharacterInputStream::read(char* buffer, int bufSize)
{
  int ret;
  kernel_exception::EXCODE code;
  char paramBuffer[0+sizeof(buffer)+sizeof(bufSize)];
  *(char**)(paramBuffer) = buffer;
  *(int*)(paramBuffer+sizeof(buffer)) = bufSize;

  asm volatile ("mov r0, #2\n\t"
		"mov r1, %1\n\t"
		"mov r2, %2\n\t"
		"mov r3, %3\n\t"
		"swi #3873\n\t"
		"str r0, %0"
		: "=m"(code) : "r" (kernelObj), "r" (paramBuffer), "r" (&ret) : "r0", "r1", "r2", "r3" );
  kernel_exception::throw_exception(code);
  
  return ret;
}

void CharacterInputStream::switchCharacterQueue(int type)
{
  kernel_exception::EXCODE code;
  char paramBuffer[0+sizeof(type)];
  *(int*)(paramBuffer) = type;

  asm volatile ("mov r0, #3\n\t"
		"mov r1, %1\n\t"
		"mov r2, %2\n\t"
		"swi #3873\n\t"
		"str r0, %0"
		: "=m"(code) : "r" (kernelObj), "r" (paramBuffer) : "r0", "r1", "r2", "r3" );
  kernel_exception::throw_exception(code);
  
}

CharacterInputStream::~CharacterInputStream() {}
#include "ClassInstaller.h"
DEFINECLASS("CharacterInputStream",CharacterInputStream,InputStream,0,0);

