#include "ProxiableObject.h"

#include "ClassConstructor.h"
#include "exception.h"

ClassConstructor::ClassConstructor(void* k) :ProxiableObject((void*)0) {kernelObj=k;}

ClassConstructor::ClassConstructor(POFPO ctor) :ProxiableObject((void*)0)
{
  kernel_exception::EXCODE code;
  char paramBuffer[0+sizeof(ctor)];
  *(POFPO*)(paramBuffer) = ctor;

  asm volatile (
		"mov r0, #0\n\t"
		"mov r2, %1\n\t"
		"mov r3, %2\n\t"
		"swi #3872\n\t"
		"str r0, %0"
		: "=m"(code) : "r" (paramBuffer), "r"(&kernelObj) : "r0", "r1", "r2", "r3" 
		);
  kernel_exception::throw_exception(code);
  
}

ProxiableObject* ClassConstructor::construct(ProxiableObject* arg1)
{
  ProxiableObject* ret;
  kernel_exception::EXCODE code;
  char paramBuffer[0+sizeof(arg1)];
  *(ProxiableObject**)(paramBuffer) = (ProxiableObject*)(arg1->kernelObj);

  asm volatile ("mov r0, #2\n\t"
		"mov r1, %1\n\t"
		"mov r2, %2\n\t"
		"mov r3, %3\n\t"
		"swi #3872\n\t"
		"str r0, %0"
		: "=m"(code) : "r" (kernelObj), "r" (paramBuffer), "r" (&ret) : "r0", "r1", "r2", "r3" );
  kernel_exception::throw_exception(code);
  ret = new ProxiableObject( (void*)ret );

  return ret;
}

ClassConstructor::~ClassConstructor() {}
#include "ClassInstaller.h"
DEFINECLASS("ClassConstructor",ClassConstructor,ProxiableObject,0,0);

