#include "MemoryObjectContainer.h"
#include "PersistentMemoryObject.h"
#include "OutputStream.h"

#include "FileObject.h"
#include "exception.h"

FileObject::FileObject(void* k) :PersistentMemoryObject((void*)0) {kernelObj=k;}

FileObject::FileObject(unsigned int numberOfUnits, int log2UnitSize, int idNumber, MemoryObjectContainer* container, PersistentMemoryObject* source, int offset) :PersistentMemoryObject((void*)0)
{
  kernel_exception::EXCODE code;
  char paramBuffer[0+sizeof(numberOfUnits)+sizeof(log2UnitSize)+sizeof(idNumber)+sizeof(container)+sizeof(source)+sizeof(offset)];
  *(unsigned int*)(paramBuffer) = numberOfUnits;
  *(int*)(paramBuffer+sizeof(numberOfUnits)) = log2UnitSize;
  *(int*)(paramBuffer+sizeof(numberOfUnits)+sizeof(log2UnitSize)) = idNumber;
  *(MemoryObjectContainer**)(paramBuffer+sizeof(numberOfUnits)+sizeof(log2UnitSize)+sizeof(idNumber)) = (MemoryObjectContainer*)(container->kernelObj);
  *(PersistentMemoryObject**)(paramBuffer+sizeof(numberOfUnits)+sizeof(log2UnitSize)+sizeof(idNumber)+sizeof(container)) = (PersistentMemoryObject*)(source->kernelObj);
  *(int*)(paramBuffer+sizeof(numberOfUnits)+sizeof(log2UnitSize)+sizeof(idNumber)+sizeof(container)+sizeof(source)) = offset;

  asm volatile (
		"mov r0, #0\n\t"
		"mov r2, %1\n\t"
		"mov r3, %2\n\t"
		"swi #3867\n\t"
		"str r0, %0"
		: "=m"(code) : "r" (paramBuffer), "r"(&kernelObj) : "r0", "r1", "r2", "r3" 
		);
  kernel_exception::throw_exception(code);
  
}

void FileObject::writeIdNumber(OutputStream* arg1)
{
  kernel_exception::EXCODE code;
  char paramBuffer[0+sizeof(arg1)];
  *(OutputStream**)(paramBuffer) = (OutputStream*)(arg1->kernelObj);

  asm volatile ("mov r0, #2\n\t"
		"mov r1, %1\n\t"
		"mov r2, %2\n\t"
		"swi #3867\n\t"
		"str r0, %0"
		: "=m"(code) : "r" (kernelObj), "r" (paramBuffer) : "r0", "r1", "r2", "r3" );
  kernel_exception::throw_exception(code);
  
}

FileObject::~FileObject() {}
#include "ClassInstaller.h"
DEFINECLASS("FileObject",FileObject,PersistentMemoryObject,0,0);

