#include "MemoryObjectContainer.h"
#include "PersistentMemoryObject.h"

#include "FileObjectView.h"
#include "exception.h"

FileObjectView::FileObjectView(void* k) :FileObject((void*)0) {kernelObj=k;}

FileObjectView::FileObjectView(unsigned int numberOfUnits, int log2UnitSize, int idNumber, MemoryObjectContainer* container, PersistentMemoryObject* source, int offset) :FileObject((void*)0)
{
  kernel_exception::EXCODE code;
  char paramBuffer[0+sizeof(numberOfUnits)+sizeof(log2UnitSize)+sizeof(idNumber)+sizeof(container)+sizeof(source)+sizeof(offset)];
  *(unsigned int*)(paramBuffer) = numberOfUnits;
  *(int*)(paramBuffer+sizeof(numberOfUnits)) = log2UnitSize;
  *(int*)(paramBuffer+sizeof(numberOfUnits)+sizeof(log2UnitSize)) = idNumber;
  *(MemoryObjectContainer**)(paramBuffer+sizeof(numberOfUnits)+sizeof(log2UnitSize)+sizeof(idNumber)) = (MemoryObjectContainer*)(container->kernelObj);
  *(PersistentMemoryObject**)(paramBuffer+sizeof(numberOfUnits)+sizeof(log2UnitSize)+sizeof(idNumber)+sizeof(container)) = (PersistentMemoryObject*)(source->kernelObj);
  *(int*)(paramBuffer+sizeof(numberOfUnits)+sizeof(log2UnitSize)+sizeof(idNumber)+sizeof(container)+sizeof(source)) = offset;

  asm volatile (
		"mov r0, #0\n\t"
		"mov r2, %1\n\t"
		"mov r3, %2\n\t"
		"swi #3868\n\t"
		"str r0, %0"
		: "=m"(code) : "r" (paramBuffer), "r"(&kernelObj) : "r0", "r1", "r2", "r3" 
		);
  kernel_exception::throw_exception(code);
  
}

FileObjectView::~FileObjectView() {}
#include "ClassInstaller.h"
DEFINECLASS("FileObjectView",FileObjectView,FileObject,0,0);

