
#include "InputStream.h"
#include "exception.h"

InputStream::InputStream(void* k) :ProxiableObject((void*)0) {kernelObj=k;}

int InputStream::read(char* buffer, int bufSize)
{
  int ret;
  kernel_exception::EXCODE code;
  char paramBuffer[0+sizeof(buffer)+sizeof(bufSize)];
  *(char**)(paramBuffer) = buffer;
  *(int*)(paramBuffer+sizeof(buffer)) = bufSize;

  asm volatile ("mov r0, #2\n\t"
		"mov r1, %1\n\t"
		"mov r2, %2\n\t"
		"mov r3, %3\n\t"
		"swi #3851\n\t"
		"str r0, %0"
		: "=m"(code) : "r" (kernelObj), "r" (paramBuffer), "r" (&ret) : "r0", "r1", "r2", "r3" );
  kernel_exception::throw_exception(code);
  
  return ret;
}

int InputStream::formattedRead(char* format, const formatArgs& a1)
{
  int ret;
  kernel_exception::EXCODE code;
  char paramBuffer[0+sizeof(format)+sizeof(void*)];
  *(char**)(paramBuffer) = format;
  *(const formatArgs**)(paramBuffer+sizeof(format)) = &a1;

  asm volatile ("mov r0, #3\n\t"
		"mov r1, %1\n\t"
		"mov r2, %2\n\t"
		"mov r3, %3\n\t"
		"swi #3851\n\t"
		"str r0, %0"
		: "=m"(code) : "r" (kernelObj), "r" (paramBuffer), "r" (&ret) : "r0", "r1", "r2", "r3" );
  kernel_exception::throw_exception(code);
  
  return ret;
}

int InputStream::readBackChar(char c)
{
  int ret;
  kernel_exception::EXCODE code;
  char paramBuffer[0+sizeof(c)];
  *(char*)(paramBuffer) = c;

  asm volatile ("mov r0, #4\n\t"
		"mov r1, %1\n\t"
		"mov r2, %2\n\t"
		"mov r3, %3\n\t"
		"swi #3851\n\t"
		"str r0, %0"
		: "=m"(code) : "r" (kernelObj), "r" (paramBuffer), "r" (&ret) : "r0", "r1", "r2", "r3" );
  kernel_exception::throw_exception(code);
  
  return ret;
}

InputStream::~InputStream() {}
#include "ClassInstaller.h"
DEFINECLASS("InputStream",InputStream,ProxiableObject,0,0);

