#include "Interface.h"
#include "OutputStream.h"
#include "InputStream.h"
#include "FileSystemInterface.h"
#include "SystemInterface.h"
#include "NameServer.h"

OutputStream* Interface::standardOutput()
{
 void* kernelObj;
 asm volatile (
		"mov r0, $1\n\t"
		"mov r3, %0\n\t"
		"swi $0xF00"
		: :"r"(&kernelObj) : "r0", "r1", "r2", "r3" 
		);
 return new OutputStream(kernelObj);
}

InputStream* Interface::standardInput()
{
 void* kernelObj;
 asm volatile (
		"mov r0, $2\n\t"
		"mov r3, %0\n\t"
		"swi $0xF00"
		: :"r"(&kernelObj) : "r0", "r1", "r2", "r3" 
		);
 return new InputStream(kernelObj);
}

FileSystemInterface* Interface::fileSystemInterface()
{
  void* kernelObj;
  asm volatile (
		"mov r0, $5\n\t"
		"mov r3, %0\n\t"
		"swi $0xF00"
		: :"r"(&kernelObj) : "r0", "r1", "r2", "r3" 
		);
 return new FileSystemInterface(kernelObj);
}

SystemInterface* Interface::systemInterface()
{
  void* kernelObj;
  asm volatile (
		"mov r0, $7\n\t"
		"mov r3, %0\n\t"
		"swi $0xF00"
		: :"r"(&kernelObj) : "r0", "r1", "r2", "r3" 
		);
 return new SystemInterface(kernelObj);
}

NameServer* Interface::nameServer()
{
  void* kernelObj;
  asm volatile (
		"mov r0, $8\n\t"
		"mov r3, %0\n\t"
		"swi $0xF00"
		: :"r"(&kernelObj) : "r0", "r1", "r2", "r3" 
		);
 return new NameServer(kernelObj);
}
