
#include "MemoryObjectCache.h"
#include "exception.h"

MemoryObjectCache::MemoryObjectCache(void* k) :MemoryRange((void*)0) {kernelObj=k;}

void MemoryObjectCache::setDebugMask(unsigned short mask)
{
  kernel_exception::EXCODE code;
  char paramBuffer[0+sizeof(mask)];
  *(unsigned short*)(paramBuffer) = mask;

  asm volatile ("mov r0, #2\n\t"
		"mov r1, %1\n\t"
		"mov r2, %2\n\t"
		"swi #3845\n\t"
		"str r0, %0"
		: "=m"(code) : "r" (kernelObj), "r" (paramBuffer) : "r0", "r1", "r2", "r3" );
  kernel_exception::throw_exception(code);
  
}

void MemoryObjectCache::setDebugMessages(short messages)
{
  kernel_exception::EXCODE code;
  char paramBuffer[0+sizeof(messages)];
  *(short*)(paramBuffer) = messages;

  asm volatile ("mov r0, #3\n\t"
		"mov r1, %1\n\t"
		"mov r2, %2\n\t"
		"swi #3845\n\t"
		"str r0, %0"
		: "=m"(code) : "r" (kernelObj), "r" (paramBuffer) : "r0", "r1", "r2", "r3" );
  kernel_exception::throw_exception(code);
  
}

MemoryObjectCache::~MemoryObjectCache() {}
#include "ClassInstaller.h"
DEFINECLASS("MemoryObjectCache",MemoryObjectCache,MemoryRange,0,0);

