#include "ProxiableObject.h"
#include "Class.h"

#include "NameServer.h"
#include "exception.h"

NameServer::NameServer(void* k) :ProxiableObject((void*)0) {kernelObj=k;}

void NameServer::bind(char* name, ProxiableObject* arg2)
{
  kernel_exception::EXCODE code;
  char paramBuffer[0+sizeof(name)+sizeof(arg2)];
  *(char**)(paramBuffer) = name;
  *(ProxiableObject**)(paramBuffer+sizeof(name)) = (ProxiableObject*)(arg2->kernelObj);

  asm volatile ("mov r0, #2\n\t"
		"mov r1, %1\n\t"
		"mov r2, %2\n\t"
		"swi #3862\n\t"
		"str r0, %0"
		: "=m"(code) : "r" (kernelObj), "r" (paramBuffer) : "r0", "r1", "r2", "r3" );
  kernel_exception::throw_exception(code);
  
}

ProxiableObject* NameServer::lookup(char* name, Class* arg2)
{
  ProxiableObject* ret;
  kernel_exception::EXCODE code;
  char paramBuffer[0+sizeof(name)+sizeof(arg2)];
  *(char**)(paramBuffer) = name;
  *(Class**)(paramBuffer+sizeof(name)) = (Class*)(arg2->kernelObj);

  asm volatile ("mov r0, #3\n\t"
		"mov r1, %1\n\t"
		"mov r2, %2\n\t"
		"mov r3, %3\n\t"
		"swi #3862\n\t"
		"str r0, %0"
		: "=m"(code) : "r" (kernelObj), "r" (paramBuffer), "r" (&ret) : "r0", "r1", "r2", "r3" );
  kernel_exception::throw_exception(code);
  ret = new ProxiableObject( (void*)ret );

  return ret;
}

ProxiableObject* NameServer::lookup(char* name, char* arg2)
{
  ProxiableObject* ret;
  kernel_exception::EXCODE code;
  char paramBuffer[0+sizeof(name)+sizeof(arg2)];
  *(char**)(paramBuffer) = name;
  *(char**)(paramBuffer+sizeof(name)) = arg2;

  asm volatile ("mov r0, #4\n\t"
		"mov r1, %1\n\t"
		"mov r2, %2\n\t"
		"mov r3, %3\n\t"
		"swi #3862\n\t"
		"str r0, %0"
		: "=m"(code) : "r" (kernelObj), "r" (paramBuffer), "r" (&ret) : "r0", "r1", "r2", "r3" );
  kernel_exception::throw_exception(code);
  ret = new ProxiableObject( (void*)ret );

  return ret;
}

int NameServer::unbind(char* name)
{
  int ret;
  kernel_exception::EXCODE code;
  char paramBuffer[0+sizeof(name)];
  *(char**)(paramBuffer) = name;

  asm volatile ("mov r0, #5\n\t"
		"mov r1, %1\n\t"
		"mov r2, %2\n\t"
		"mov r3, %3\n\t"
		"swi #3862\n\t"
		"str r0, %0"
		: "=m"(code) : "r" (kernelObj), "r" (paramBuffer), "r" (&ret) : "r0", "r1", "r2", "r3" );
  kernel_exception::throw_exception(code);
  
  return ret;
}

void NameServer::clone(NameServer* nameServer1)
{
  kernel_exception::EXCODE code;
  char paramBuffer[0+sizeof(nameServer1)];
  *(NameServer**)(paramBuffer) = (NameServer*)(nameServer1->kernelObj);

  asm volatile ("mov r0, #6\n\t"
		"mov r1, %1\n\t"
		"mov r2, %2\n\t"
		"swi #3862\n\t"
		"str r0, %0"
		: "=m"(code) : "r" (kernelObj), "r" (paramBuffer) : "r0", "r1", "r2", "r3" );
  kernel_exception::throw_exception(code);
  
}

NameServer::~NameServer() {}
#include "ClassInstaller.h"
DEFINECLASS("NameServer",NameServer,ProxiableObject,0,0);

