
#include "OutputStream.h"
#include "exception.h"

OutputStream::OutputStream(void* k) :ProxiableObject((void*)0) {kernelObj=k;}

void OutputStream::acquireExclusiveUse()
{
  kernel_exception::EXCODE code;
  
  asm volatile ("mov r0, #2\n\t"
		"mov r1, %1\n\t"
		"swi #3853\n\t"
		"str r0, %0"
		: "=m"(code) : "r" (kernelObj) : "r0", "r1", "r2", "r3" );
  kernel_exception::throw_exception(code);
  
}

void OutputStream::releaseExclusiveUse()
{
  kernel_exception::EXCODE code;
  
  asm volatile ("mov r0, #3\n\t"
		"mov r1, %1\n\t"
		"swi #3853\n\t"
		"str r0, %0"
		: "=m"(code) : "r" (kernelObj) : "r0", "r1", "r2", "r3" );
  kernel_exception::throw_exception(code);
  
}

int OutputStream::write(const char* buffer, int count)
{
  int ret;
  kernel_exception::EXCODE code;
  char paramBuffer[0+sizeof(buffer)+sizeof(count)];
  *(const char**)(paramBuffer) = buffer;
  *(int*)(paramBuffer+sizeof(buffer)) = count;

  asm volatile ("mov r0, #4\n\t"
		"mov r1, %1\n\t"
		"mov r2, %2\n\t"
		"mov r3, %3\n\t"
		"swi #3853\n\t"
		"str r0, %0"
		: "=m"(code) : "r" (kernelObj), "r" (paramBuffer), "r" (&ret) : "r0", "r1", "r2", "r3" );
  kernel_exception::throw_exception(code);
  
  return ret;
}

int OutputStream::formattedWrite(char* format, const formatArgs& a1)
{
  int ret;
  kernel_exception::EXCODE code;
  char paramBuffer[0+sizeof(format)+sizeof(void*)];
  *(char**)(paramBuffer) = format;
  *(const formatArgs**)(paramBuffer+sizeof(format)) = &a1;

  asm volatile ("mov r0, #5\n\t"
		"mov r1, %1\n\t"
		"mov r2, %2\n\t"
		"mov r3, %3\n\t"
		"swi #3853\n\t"
		"str r0, %0"
		: "=m"(code) : "r" (kernelObj), "r" (paramBuffer), "r" (&ret) : "r0", "r1", "r2", "r3" );
  kernel_exception::throw_exception(code);
  
  return ret;
}

void OutputStream::flush()
{
  kernel_exception::EXCODE code;
  
  asm volatile ("mov r0, #6\n\t"
		"mov r1, %1\n\t"
		"swi #3853\n\t"
		"str r0, %0"
		: "=m"(code) : "r" (kernelObj) : "r0", "r1", "r2", "r3" );
  kernel_exception::throw_exception(code);
  
}

#include "OutputStreamExtra.cc"

OutputStream::~OutputStream() {}
#include "ClassInstaller.h"
DEFINECLASS("OutputStream",OutputStream,ProxiableObject,0,0);

