
#include "Pipe.h"
#include "exception.h"

Pipe::Pipe(void* k) :ProxiableObject((void*)0) {kernelObj=k;}

Pipe::Pipe(int size) :ProxiableObject((void*)0)
{
  kernel_exception::EXCODE code;
  char paramBuffer[0+sizeof(size)];
  *(int*)(paramBuffer) = size;

  asm volatile (
		"mov r0, #0\n\t"
		"mov r2, %1\n\t"
		"mov r3, %2\n\t"
		"swi #3869\n\t"
		"str r0, %0"
		: "=m"(code) : "r" (paramBuffer), "r"(&kernelObj) : "r0", "r1", "r2", "r3" 
		);
  kernel_exception::throw_exception(code);
  
}

int Pipe::read(char* buf, int count, int block)
{
  int ret;
  kernel_exception::EXCODE code;
  char paramBuffer[0+sizeof(buf)+sizeof(count)+sizeof(block)];
  *(char**)(paramBuffer) = buf;
  *(int*)(paramBuffer+sizeof(buf)) = count;
  *(int*)(paramBuffer+sizeof(buf)+sizeof(count)) = block;

  asm volatile ("mov r0, #2\n\t"
		"mov r1, %1\n\t"
		"mov r2, %2\n\t"
		"mov r3, %3\n\t"
		"swi #3869\n\t"
		"str r0, %0"
		: "=m"(code) : "r" (kernelObj), "r" (paramBuffer), "r" (&ret) : "r0", "r1", "r2", "r3" );
  kernel_exception::throw_exception(code);
  
  return ret;
}

int Pipe::write(char* buf, int count, int block)
{
  int ret;
  kernel_exception::EXCODE code;
  char paramBuffer[0+sizeof(buf)+sizeof(count)+sizeof(block)];
  *(char**)(paramBuffer) = buf;
  *(int*)(paramBuffer+sizeof(buf)) = count;
  *(int*)(paramBuffer+sizeof(buf)+sizeof(count)) = block;

  asm volatile ("mov r0, #3\n\t"
		"mov r1, %1\n\t"
		"mov r2, %2\n\t"
		"mov r3, %3\n\t"
		"swi #3869\n\t"
		"str r0, %0"
		: "=m"(code) : "r" (kernelObj), "r" (paramBuffer), "r" (&ret) : "r0", "r1", "r2", "r3" );
  kernel_exception::throw_exception(code);
  
  return ret;
}

Pipe::~Pipe() 
{
  kernel_exception::EXCODE code;
  asm volatile (
		"mov r0, #1\n\t"
		"mov r1, %1\n\t"
		"swi $3869\n\t"
		"str r0, %0"
		: "=m" (code) :"r" (kernelObj) : "r0", "r1", "r2", "r3"
		);
  kernel_exception::throw_exception(code);
}
#include "ClassInstaller.h"
DEFINECLASS("Pipe",Pipe,ProxiableObject,0,0);

