
#include "Semaphore.h"
#include "exception.h"

Semaphore::Semaphore(void* k) :ProxiableObject((void*)0) {kernelObj=k;}

Semaphore::Semaphore(int initialCount, int maxCount) :ProxiableObject((void*)0)
{
  kernel_exception::EXCODE code;
  char paramBuffer[0+sizeof(initialCount)+sizeof(maxCount)];
  *(int*)(paramBuffer) = initialCount;
  *(int*)(paramBuffer+sizeof(initialCount)) = maxCount;

  asm volatile (
		"mov r0, #0\n\t"
		"mov r2, %1\n\t"
		"mov r3, %2\n\t"
		"swi #3848\n\t"
		"str r0, %0"
		: "=m"(code) : "r" (paramBuffer), "r"(&kernelObj) : "r0", "r1", "r2", "r3" 
		);
  kernel_exception::throw_exception(code);
  
}

void Semaphore::P()
{
  kernel_exception::EXCODE code;
  
  asm volatile ("mov r0, #2\n\t"
		"mov r1, %1\n\t"
		"swi #3848\n\t"
		"str r0, %0"
		: "=m"(code) : "r" (kernelObj) : "r0", "r1", "r2", "r3" );
  kernel_exception::throw_exception(code);
  
}

void Semaphore::V()
{
  kernel_exception::EXCODE code;
  
  asm volatile ("mov r0, #3\n\t"
		"mov r1, %1\n\t"
		"swi #3848\n\t"
		"str r0, %0"
		: "=m"(code) : "r" (kernelObj) : "r0", "r1", "r2", "r3" );
  kernel_exception::throw_exception(code);
  
}

Semaphore::~Semaphore() 
{
  kernel_exception::EXCODE code;
  asm volatile (
		"mov r0, #1\n\t"
		"mov r1, %1\n\t"
		"swi $3848\n\t"
		"str r0, %0"
		: "=m" (code) :"r" (kernelObj) : "r0", "r1", "r2", "r3"
		);
  kernel_exception::throw_exception(code);
}
#include "ClassInstaller.h"
DEFINECLASS("Semaphore",Semaphore,ProxiableObject,0,0);

