#include "PersistentMemoryObject.h"

#include "SymbolicLink.h"
#include "exception.h"

SymbolicLink::SymbolicLink(void* k) :PersistentArray((void*)0) {kernelObj=k;}

SymbolicLink::SymbolicLink(PersistentMemoryObject* mo) :PersistentArray((void*)0)
{
  kernel_exception::EXCODE code;
  char paramBuffer[0+sizeof(mo)];
  *(PersistentMemoryObject**)(paramBuffer) = (PersistentMemoryObject*)(mo->kernelObj);

  asm volatile (
		"mov r0, #0\n\t"
		"mov r2, %1\n\t"
		"mov r3, %2\n\t"
		"swi #3876\n\t"
		"str r0, %0"
		: "=m"(code) : "r" (paramBuffer), "r"(&kernelObj) : "r0", "r1", "r2", "r3" 
		);
  kernel_exception::throw_exception(code);
  
}

SymbolicLink::~SymbolicLink() {}
#include "ClassInstaller.h"
DEFINEPERSISTENTCLASS("SymbolicLink",SymbolicLink,PersistentArray,0,0);

