#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: John L. Coolidge (coolidge@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * SystemTime.cc
 */

#include "SystemTime.h"
#include "UnixTime.h"


#ifdef __GNUC__
#pragma implementation
#endif

// Work around compiler bug
static int64 SecondConversion = SYSTEM_SEC_TO_UNIX_SEC;

UnixTime SystemTime::unixTime()
{
    // Convert the system time to unix time and return

    // First, saw off the seconds

    int32 seconds = (int)((time() / SYSTEM_TO_SECOND) - SecondConversion);

    // Saw off the microseconds
    int32 useconds = (int)((time() % SYSTEM_TO_SECOND)/(int64)10);

    // Convert the time zone offset into unix minutes
    int32 minuteswest = (int)(timeZoneOffset() / TIMEZONE_TO_SYSTEM);

    // And copy the DST handler byte
    int32 dsttime = dst();

    return UnixTime( seconds, useconds, minuteswest, dsttime );
}
