#include "SystemTime.h"
#include "UnixTime.h"

#include "TimeOfDay.h"
#include "exception.h"

TimeOfDay::TimeOfDay(void* k) :ProxiableObject((void*)0) {kernelObj=k;}

void TimeOfDay::getTime(SystemTime& time)
{
  kernel_exception::EXCODE code;
  char paramBuffer[0+sizeof(void*)];
  *(SystemTime**)(paramBuffer) = &time;

  asm volatile ("mov r0, #2\n\t"
		"mov r1, %1\n\t"
		"mov r2, %2\n\t"
		"swi #3856\n\t"
		"str r0, %0"
		: "=m"(code) : "r" (kernelObj), "r" (paramBuffer) : "r0", "r1", "r2", "r3" );
  kernel_exception::throw_exception(code);
  
}

void TimeOfDay::setTime(SystemTime& time)
{
  kernel_exception::EXCODE code;
  char paramBuffer[0+sizeof(void*)];
  *(SystemTime**)(paramBuffer) = &time;

  asm volatile ("mov r0, #3\n\t"
		"mov r1, %1\n\t"
		"mov r2, %2\n\t"
		"swi #3856\n\t"
		"str r0, %0"
		: "=m"(code) : "r" (kernelObj), "r" (paramBuffer) : "r0", "r1", "r2", "r3" );
  kernel_exception::throw_exception(code);
  
}

void TimeOfDay::getUnixTime(UnixTime& time)
{
  kernel_exception::EXCODE code;
  char paramBuffer[0+sizeof(void*)];
  *(UnixTime**)(paramBuffer) = &time;

  asm volatile ("mov r0, #4\n\t"
		"mov r1, %1\n\t"
		"mov r2, %2\n\t"
		"swi #3856\n\t"
		"str r0, %0"
		: "=m"(code) : "r" (kernelObj), "r" (paramBuffer) : "r0", "r1", "r2", "r3" );
  kernel_exception::throw_exception(code);
  
}

void TimeOfDay::setUnixTime(UnixTime& time)
{
  kernel_exception::EXCODE code;
  char paramBuffer[0+sizeof(void*)];
  *(UnixTime**)(paramBuffer) = &time;

  asm volatile ("mov r0, #5\n\t"
		"mov r1, %1\n\t"
		"mov r2, %2\n\t"
		"swi #3856\n\t"
		"str r0, %0"
		: "=m"(code) : "r" (kernelObj), "r" (paramBuffer) : "r0", "r1", "r2", "r3" );
  kernel_exception::throw_exception(code);
  
}

TimeOfDay::~TimeOfDay() {}
#include "ClassInstaller.h"
DEFINECLASS("TimeOfDay",TimeOfDay,ProxiableObject,0,0);

