#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: David W. Dykstra (dykstra@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * VersionInstaller.cc
 */

#include "VersionInstaller.h"


#ifdef __GNUC__
#pragma implementation
#endif

static ProvidedVersionInstaller *providedHead = 0;
static ProvidedVersionInstaller *providedTail = 0;
static RequiredVersionInstaller *requiredHead = 0;
static RequiredVersionInstaller *requiredTail = 0;

VersionInstaller::VersionInstaller( char * nam, char * ver )
{
	name = nam;
	version = ver;
	visited = 0;
}

ProvidedVersionInstaller::ProvidedVersionInstaller( VersionInstaller * ptr )
{
	versionPtr = ptr;

	next = 0;
	if (providedHead == 0)
	{
		providedHead = this;
		providedTail = this;
	}
	else
	{
		providedTail->next = this;
		providedTail = this;
	}
}

ProvidedVersionInstaller *
ProvidedVersionInstaller::list()
{
	return( providedHead );
}

RequiredVersionInstaller::RequiredVersionInstaller( VersionInstaller * ptr )
{
	versionPtr = ptr;

	next = 0;
	if (requiredHead == 0)
	{
		requiredHead = this;
		requiredTail = this;
	}
	else
	{
		requiredTail->next = this;
		requiredTail = this;
	}
}

RequiredVersionInstaller *
RequiredVersionInstaller::list()
{
	return( requiredHead );
}
