#ifdef __GNUC__
#pragma implementation
#endif

/*
 * Entry point of a Process.
 */

	/*
	 * start(u_int arg0, u_int arg1, proxy* defaultProxy))
	 * {
	 *	main(arg0, arg1);
	 * 	Start(defaultProxy);
	 *	exit()
	 * }
	 */

#include "SystemInterface.h"
#include "Assert.h"


#ifdef __GNUC__
#pragma implementation
#endif

extern "C" {
void _Start(SystemInterface *);
unsigned main(int argc, char **argv);
int Exit( int );
typedef int (* exitproc_t)(int);
exitproc_t _exitproc;
void defaultReturn(int retval);
};

extern void ProcessArgs( int & argc, char ** & argv );

/*
 * The kernel sets up debugFromStart to be 0 or 1 if we wish to immediately
 * trap.
 */

inline
void TrapToDebugger()
{
	asm volatile("bkpt");
}

extern "C"
void start(int argc, char **argv, SystemInterface *defaultProxy, unsigned
debugFromStart)
{
	_exitproc = &Exit;

	if (debugFromStart & 0x01) 
		TrapToDebugger();

	_Start(defaultProxy);

	if (debugFromStart & 0x02) 
		TrapToDebugger();

	ProcessArgs(argc, argv);

	unsigned retval = main(argc, argv);

	if (debugFromStart & 0x04) 
		TrapToDebugger();

	/*
	 * THis is the default return spot for application processes
	 * created within other applications.
	 * The first restoreFromInitialContext starts in this function
	 * and sets the domain->initialCall in _Start.   Other
	 * restoreFromInitialContexts read this and get _defaultReturn
	 * as their return point.
	 * The two nops are to skip the (fake) function call and
	 * delay slot.  The SPARC convention is to continue execution
	 * 2 insns after what the caller stuffs in %o7, which is the
	 * PC at the time of the call
	 */
	asm volatile("
		.globl _defaultReturn;
		_defaultReturn:
		nop;
		nop;
		nop;
		");
	_exitproc(retval);
	Assert (NOTREACHED);
}
