#include "Allocator.h"
#include "Interface.h"
#include "print.h"
#include "SystemInterface.h"
#include "Process.h"

#define HEAP_PAGES 4 //16k heap

extern int main();

char* alloc[sizeof(BucketAllocator)];

ClassStar NullClass;
OutputStream * StandardOutput;
InputStream * StandardInput;
SystemInterface * StandardSystemInterface;
NameServer* StandardNameServer;
FileSystemInterface* StandardFileSystemInterface;

void *__dso_handle;

void abort(void) { asm("swi 0xFFC"); }

extern "C" void _start()
{
    char* heap;
    kernel_exception::EXCODE code;
    unsigned int nPages = HEAP_PAGES;
    asm volatile ("mov r0, #3\n\t"
                  "mov r2, %1\n\t"
                  "mov r3, %2\n\t"
                  "swi #0xF00\n\t"
                  "str r0, %0"
                  : "=m"(code) : "r" (&nPages), "r" (&heap) : "r0", "r1", "r2", "r3" );
    if(code!=kernel_exception::DONE){
        print("Can not create heap\n");
        asm("swi 0xFFC");
    }   
    _new_allocator=new(alloc) BucketAllocator(heap, 64,8);
    _current_handler=0;
    int status = 0;
    try{
        StandardSystemInterface = Interface::systemInterface();
        StandardNameServer = Interface::nameServer();
        StandardFileSystemInterface = Interface::fileSystemInterface();
        StandardOutput = Interface::standardOutput();
        StandardInput = Interface::standardInput();
        status = main();
    }
    catch(...)
    {
        print("Uncaught exception\n");
        asm("swi 0xFFC");
    }
    StandardSystemInterface->getThisProcess()->die(status);
}
