#include "exception.h"
#include "Interface.h"
#include "OutputStream.h"

exception::~exception() throw() {}

const char * exception::what() const throw()
{
	return "exception\n";
}

void kernel_exception::throw_exception(kernel_exception::EXCODE code) 
{
	switch(code){
	case DONE: return;
	case INVALIDMETHOD: throw invalid_method();
	case INVALIDCLASS: throw invalid_class();
	case INVALIDOBJECT: throw invalid_object();
	}
}

const char * kernel_exception::what() const throw()
{
	return "exception::kernel_exception\n";
}


kernel_exception::EXCODE kernel_exception::code() const throw()
{
	return _code;
}

const char * invalid_object::what() const throw()
{
	return "exception::kernel_exception::invalid_object\n";
}

const char * invalid_method::what() const throw()
{
	return "exception::kernel_exception::invalid_method\n";
}

const char * invalid_class::what() const throw()
{
	return "exception::kernel_exception::invalid_class\n";
}
