#include "Allocator.h"
#include "new.h"

const char * bad_alloc::what() const throw()
{
	return "exception::bad_alloc\n";
}

new_handler set_new_handler(new_handler new_p) throw()
{
	new_handler old_handler=_current_handler;
	_current_handler=new_p;
	return old_handler;
}

void * operator new (size_t size) throw(bad_alloc)
{
	void * ret = _new_allocator->allocate(size);
	if(ret==0){
	  if(_current_handler!=0) _current_handler();
	  else throw bad_alloc();
	}
	return ret;
}

void operator delete (void * pos) throw()
{
  	_new_allocator->free(pos);
}

void * operator new[] (size_t size) throw(bad_alloc)
{
	void * ret = _new_allocator->allocate(size);
	if(ret==0){
	  if(_current_handler!=0) _current_handler();
	  else throw bad_alloc();
	}
	return ret;
}

void operator delete[] (void * pos) throw()
{
  	_new_allocator->free(pos);
}	

void* operator new(size_t, void* p) throw() {return p;}
void operator delete(void*, void*) throw(){}

void* operator new[](size_t, void* p) throw() {return p;}
void operator delete[](void *, void *) throw(){}
