/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Vincent F. Russo (russo@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

/*
 * crt0.s
 */

/*
 * This is the first thing in the .bss section.
 * It is required by the Multimax linker.
 */
	.comm	p_glbl,1

/*
 * This is the actual entry point of the first Process created in an a.out
 * sourced Domain.
 *
 * r0 and r1 contain the initial arguments to the process and r2 contains
 *   a pointer to the default proxy object.
 */
	.text
	.globl	start
start:
	br .L0
	.align 32
modstart:
	.int	p_glbl
.L0:
	/*
	 * Save the arguments to pass the later.
	 */
	movd    4(sp),r0
	movd    8(sp),r1
	movd    12(sp),r2
	movd	r0,r6
	movd	r1,r7
	movd	r2,r5

	/*
	 * Remeber exit proc
	 */
	addr 	_Exit,__exitproc

	/*
	 * Call _Start to initialize nameserver, etc.
	 */
	movd	r5, r0		/* pointer to default proxy */
	movd    r0, tos
	bsr	?__Start
	adjspb  $-4

	/*
 	 * Call ProcessArgs
	 */

	addr	4(sp),r0
	addr	8(sp),r1
	movd    r1, tos
	movd    r0, tos
	bsr	?_ProcessArgs__FRiRPPc
	adjspb  $-2*4

	/*
	 * Call user's main(arg0, arg1).
	 */
	movd	4(sp),r0
	movd	8(sp),r1
	movd    r1, tos
	movd    r0, tos
	bsr	?_main
	adjspb  $-2*4

__die:
	jsr	0(__exitproc)	/* should NEVER return! */
	br	__die		/* but just in case */

/*
 * default Return code from a process
 */
	.globl	__defaultReturn
__defaultReturn:
	bsr	?__KillThisProcess	/* should NEVER return! */
	br	__defaultReturn		/* but just in case */

/*
 * We don't use ___main, but g++ automatically generates
 *   a call to it.
 */
	.globl	___main
___main:
	ret	$0

/*
 * Local variables
 */

	.comm	__exitproc,4
