#ifdef __GNUC__
#pragma implementation
#endif

#include "FormatAssists.h"
#include "OutputStream.h"
#include "String.h"
#include "ThisProcess.h"
#include "Assert.h"


#ifdef __GNUC__
#pragma implementation
#endif

AssertionFailure &
AssertionFailure::raise()
{
        extern void Halt();

	Console().write("Assert failed\n",14);
	if( ! strcmp( _file, _baseFile ) ) {
	        Console().formattedWrite( "Assertion (%s) failed\n\tin file %s line %d\n" , _exp, _file, _line);
	} else {
	        Console().formattedWrite( "Assertion (%s) failed\n\tin file %s (#include'd from %s) line %d\n", _exp, _file, _baseFile, _line);
	}

	/*
	 * If the process is an application process then kill it and
	 * continue, otherwise we are in trouble.
	 */
	Process *p = thisProcess();
	p->die();
	return *this;
}


void
AssertionFailure::operator()(char * format, const formatArgs & a1,
		const formatArgs & a2, const formatArgs & a3,
		const formatArgs & a4)
{

	Console().write("Assert failed\n",14);
	Console().formattedWrite( format, a1, a2, a3, a4);
	Console() << "\n" << eor;
	raise();
}

