#ifdef __GNUC__
#pragma implementation
#endif

/*
 *	$Header: /projects/choices/old/cvsroot/choices/Libraries/SystemInterface/Portable/Lock.cc,v 1.1 2004/06/03 01:58:49 jcarlyle Exp $
 *
 * A Lock for a user-level application.  Keep in mind that there may be
 *   multiple processes in the application, but we don't want to 
 *   disable interrupts.
 */

#include "Lock.h"
#include "ThisProcess.h"


#ifdef __GNUC__
#pragma implementation
#endif

void
Lock::acquire()
{
    Process *thisproc = 0;

    while (1) {
	while (_state != 0) {
	    if ( thisproc == 0 ) {
		    thisproc = thisProcess();
		    /* 
		     * It can take a while to get thisProcess, check
		     *   state again.
		     */
		    continue;
	    }
	    thisproc->relinquishProcessor();
	}

	/*
	 * Poor-man's test & set.  I'm assuming increment/decrement is atomic.
	 */
	_state++;
	if (_state == 1)
	    /* got it */
	    break;
	_state--;
    }
}
