#ifdef __GNUC__
#pragma implementation
#endif

/*
 */

#include "Assert.h"
#include "Allocator.h"
#include "NameServer.h"
#include "NewAndDelete.h"
#include "OutputStream.h"
#include "VMInterface.h"
#include "VMInterfaceStar.h"
#include "_new_allocator.h"

#ifdef __GNUC__
#pragma implementation
#endif


char BucketAllocatorSpace[ sizeof( BucketAllocator ) ];

void
initializeNewAllocator()
{
	_new_allocator = new
			( (void *) BucketAllocatorSpace )
		BucketAllocator ( (void *) __new_dataArea,
					 __new_pageCount, __new_log2PageSize );
}

#ifdef CFRONT

typedef unsigned int size_t;

void *
operator new( size_t size )

#else
#if (__GNUG__ == 2)
void * __builtin_new(long size)
#else
void *
operator new( long size )
#endif
#endif
{
	void * p = 0;
	Assert( _new_allocator != 0 );
	while ( ( p = _new_allocator->allocate( size ) ) == 0 ) {
		if ( _new_handler != 0 ) {
			(*_new_handler)();
		} else {
			StandardOutput->printf("New (%d) failed.\n", size);
			return( (void *) 0 );
		}
	}
	return p;
}

BucketAllocator * _new_shared_allocator = 0;

char SharedBucketAllocatorSpace[ sizeof( BucketAllocator ) ];

void
initializeNewSharedAllocator()
{
	Assert( _new_allocator != 0 );
	VMInterfaceStar VMI = StandardNameServer->lookup( "vmInterface", 
							  "VMInterface");
	Assert( VMI != 0 );
	char * sharedBaseAddr = VMI->createSharedRegion( __new_pageCount <<
							 __new_log2PageSize );
	Assert( sharedBaseAddr != 0 );

	_new_shared_allocator = new
			( (void *) SharedBucketAllocatorSpace )
		BucketAllocator ( (void *) sharedBaseAddr,
				  __new_pageCount, __new_log2PageSize );
}

extern PFV _new_shared_handler;

#ifdef CFRONT
void *
shnew( size_t size )
#else
void *
shnew( long size )
#endif
{
	void * p = 0;
	Assert( _new_shared_allocator != 0 );
	while ( ( p = _new_shared_allocator->allocate( size ) ) == 0 ) {
		if ( _new_shared_handler != 0 ) {
			(*_new_shared_handler)();
		} else {
			StandardOutput->printf("New shared (%d) failed.\n", 
					       size);
			return( (void *) 0 );
		}
	}
	return p;
}







