#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991, 1992
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Swee Boon Lim (sblim@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

#include "FileDescriptor.h"
#include "MemoryObjectDictionary.h"
#include "OutputStream.h"
#include "SysCalls.h"
#include "UnixApplication.h"
extern "C" {
#include <sys/errno.h>
}

#ifdef __GNUC__
#pragma implementation
#endif


int getdirentries(int fd, const char * buf, int nbytes, long * basep)
{
	UA_Debug << "getdirentries(" << fd << ", " << asHex((int) buf) << ", "
		<< nbytes << ", " << *basep << ")\n" << eor;
	if (!UA_initialized) UA_init();
	FileDescriptor * filedes = UA_FileDescriptorTable->fileDescriptor(fd);
	if (filedes == 0 || !filedes->used()) { 
		errno = EBADF; 
		UA_Debug << "returns -1 errno " << errno << "\n" << eor;
		return -1; 
	}
	FileDescriptorClass cl = filedes->fileDescriptorClass();
	if (cl != DirectoryStreamFileDescriptorClass) {
		errno = ENOTDIR;
		UA_Debug << "returns -1 errno " << errno << "\n" << eor;
		return -1; 
	}
	MemoryObjectDictionary * dict = (MemoryObjectDictionary *)
		((DirectoryStreamFileDescriptor *) filedes)->proxiableObject();
    //Francis TODO FIX
    //Assert(dict->isKindOf(MemoryObjectDictionaryClass));
	int count;
	int offset = filedes->offset();
	*basep = offset;
	int status = dict->associations((char *) buf, nbytes, count, offset);
	filedes->setOffset(offset); 
	UA_Debug << "returns " << count << ", basep " << *basep << "\n" << eor;
	return count;
}
