#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991, 1992
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Swee Boon Lim (sblim@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

#include "OutputStream.h"
#include "Process.h"
#include "SysCalls.h"
#include "ThisProcess.h"
#include "UnixApplication.h"
extern "C" {
#include <sys/errno.h>
}

#ifdef __GNUC__
#pragma implementation
#endif


int getrusage(int who, struct rusage * usage)
{
#ifdef NEVER
	static struct rusage dummy = {
		{ 0, 0 },	/* user time used */
		{ 0, 0 },       /* system time used */
		0,		/* max resident set size */
		0,		/* integral shared memory size */
		0,		/* integral unshared data " */
		0,		/* integral unshared stack " */
		0,		/* page reclaims */
		0,              /* page faults */
		0,		/* swaps */
		0,		/* block input operations */
		0,		/* block output operations */
		0,		/* messages sent */
		0,		/* messages received */
		0,		/* signals received */
		0,		/* voluntary context switches */
		0,		/* involuntary " */
	};
#endif // NEVER

	int result = 0;
	UA_Debug << "getrusage(" << who << ", " << asAddress(usage)
		<< ")\n" << eor;
	switch( who ) {
	    case RUSAGE_SELF:
		thisProcess()->getResourceUsage((ProcessResourceUsage *) usage);
		result = 0;
	    case RUSAGE_CHILDREN:
	    default:
		errno = EINVAL;
		result = -1;
		break;
	}
	UA_Debug << "return " << result << " errno " << errno << "\n" << eor;
	return result;
}
