#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991, 1992
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Swee Boon Lim (sblim@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

#include "FileDescriptor.h"
#include "OutputStream.h"
#include "Pipe.h"
#include "SysCalls.h"
#include "SystemInterface.h"
#include "UnixApplication.h"
#ifndef STAR
#include "InputStream.h"
#endif // STAR


#ifdef __GNUC__
#pragma implementation
#endif

int pipe(int fd[])
{
	UA_Debug << "pipe(" << asHex((int) fd) << ")\n" << eor;
	if (!UA_initialized) UA_init();
	fd[0] = UA_FileDescriptorTable->allocFileDescriptor();
	fd[1] = UA_FileDescriptorTable->allocFileDescriptor();
	Pipe * apipe = new Pipe(0);
	Assert( apipe != 0 );
#ifdef STAR
	OutputStreamStar os = StandardSystemInterface->outputStream(apipe);
	InputStreamStar is = StandardSystemInterface->inputStream(apipe);
	Assert( os != 0 );
	Assert( is != 0 );
#else
	OutputStream * os = StandardSystemInterface->outputStream(apipe);
	InputStream * is = StandardSystemInterface->inputStream(apipe);
	Assert( os != 0 );
	Assert( is != 0 );
	os->reference();
	is->reference();
#endif // STAR
	FileDescriptor * filedes0 = 
		UA_FileDescriptorTable->fileDescriptor(fd[0]);
	filedes0->init( is, 0, InputStreamFileDescriptorClass );
	FileDescriptor * filedes1 = 
		UA_FileDescriptorTable->fileDescriptor(fd[1]);
	filedes1->init( os, 0, OutputStreamFileDescriptorClass );
	return 0;
}
