#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991, 1992
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Swee Boon Lim (sblim@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

#include "FileDescriptor.h"
#include "FileSystemInterface.h"
#include "OutputStream.h"
#include "SymbolicLink.h"
#include "SymbolicLinkStar.h"
#include "SysCalls.h"
#include "UnixApplication.h"


#ifdef __GNUC__
#pragma implementation
#endif

int readlink(const char *path, char * buf, int bufsize)
{
	UA_Debug << "readlink(" << path << "," << asHex((int) buf) << ", " 
		<< bufsize << ")\n" << eor;
	if (!UA_initialized) UA_init();
	SymbolicLinkStar sl = (SymbolicLink *)UA_FileSystemInterface -> open
    ((char *)path, SymbolicLinkClass, UA_errno, 0); //Francis TODO FIX: O_NFOLLOW);
	if (UA_errno || sl == 0) { 
		UA_translateErrno (); 
		UA_Debug << "returns -1 errno " << errno 
			<< " UA_errno " << UA_errno << "\n" << eor;
		return -1; 
	}
	int result = sl->at(0,buf,bufsize);
	UA_Debug << "returns " << result << "\n" << eor;
	return result;
}
