#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991, 1992
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Swee Boon Lim (sblim@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

#include "OutputStream.h"
#include "SysCalls.h"
#include "UnixApplication.h"


#ifdef __GNUC__
#pragma implementation
#endif

int sigprocmask(int how, const sigset_t * set, sigset_t * oset)
{
	UA_Debug << "sigprocmask(" << how << ", " << asAddress(set)
		<< ", " << asAddress(oset) << ")\n" << eor;
	sigset_t oldMask = UA_sigmask;
	if (set != 0) {
		switch (how) {
		      case SIG_BLOCK:
			UA_sigmask |= *set;
			break;
		      case SIG_UNBLOCK:
			UA_sigmask &= ~(*set);
			break;
		      case SIG_SETMASK:
			UA_sigmask = *set;
			break;
		}
	}
	if (oset != 0)
		*oset = oldMask;
	return 0;
}

