#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991, 1992
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Swee Boon Lim (sblim@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

#include "FileSystemInterface.h"
#include "OutputStream.h"
#include "String.h"
#include "SymbolicLink.h"
#include "SymbolicLinkStar.h"
#include "SysCalls.h"
#include "UnixApplication.h"


#ifdef __GNUC__
#pragma implementation
#endif

int symlink(const char *name1, const char *name2)
{
	UA_Debug << "symlink(" << name1 << ", " << name2 << ")\n" << eor;
	if (!UA_initialized) UA_init();
	SymbolicLinkStar sl = (SymbolicLink *)UA_FileSystemInterface->open 
    ((char *) name2, SymbolicLinkClass, UA_errno, 
     O_CREAT|O_EXCL, 0644, SymbolicLinkClass);
	if (UA_errno || sl == 0) { 
		UA_translateErrno (); 
		UA_Debug << "returns -1 errno " << errno 
			<< " UA_errno " << UA_errno << "\n" << eor;
		return -1; 
	}
	sl->atPut(0, (char *) name1, strlen(name1));
	UA_Debug << "returns 0\n" << eor;
	return 0;
}
