#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991, 1992
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Swee Boon Lim (sblim@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

#include "FileDescriptor.h"
#include "OutputStream.h"
#include "SysCalls.h"
#include "UnixApplication.h"
extern "C" {
#include <sys/errno.h>
}

#ifdef __GNUC__
#pragma implementation
#endif


int write(int fd, const char * buf, int nbyte)
{
	UA_Debug << "write(" << fd << ", " << asHex((int) buf) << ", " 
		<< nbyte << ")\n" << eor;
	if (!UA_initialized) UA_init();
	FileDescriptor * filedes = UA_FileDescriptorTable->fileDescriptor(fd);
	if (filedes == 0 || !filedes->used()) {
		errno = EBADF; 
		UA_Debug << "returns -1 errno " << errno << "\n" << eor;
		return -1; 
	}
	int result = filedes->write(buf, nbyte);
	if (result < 0) { 
		UA_Debug << "returns -1 errno " << errno << "\n" << eor;
		return -1; 	
	}
	UA_Debug << "returns " << result << "\n" << eor;
	return result;
}


