#include <ctype.h>

double strtod(str, ptr)
char * str, ** ptr;
{
	char * p;
	double neg;
	double d = 0.0;

	p = str;
	while( isspace( *p ) ) p++;

	if ( *p == 0 )
		return d;

	/* parse sign */

	if ( *p == 0 ) {
		if ( ptr ) *ptr = p;
		return d ;
	} if ( *p == '-' ) {
		neg = -1.0;
		p++;
	} else if ( *p == '+' ) {
		neg = 1.0;
		p++;
	} else {
		neg = 0;
	}
	
	/* parse integers */

	if ( *p == 0 ) {
		if ( ptr ) * ptr = p;
		return d * neg;
	}
	while ( isdigit( *p ) ) {
		d = d * 10.0 + ( *p - '0' );
		p++;
	}

	/* parse decimals */

	if ( *p == 0 ) {
		if ( ptr ) * ptr = p;
		return d * neg;
	}
	if ( *p == '.' ) {
		double power = 10.0;
		p++;
		while ( isdigit( *p ) ) {
			d += ( *p - '0' ) / power;
			power *= 10.0;
			p++;
		}
	}
	d *= neg;

	/* parse exponents */

	if ( *p == 0 ) {
		if ( ptr ) * ptr = p;
		return d;
	}
	if ( *p == 'e' || *p == 'E' ) {
		int expsign;
		int exp = 0;
		p++;
		if ( *p == '-' ) {
			expsign = -1;
			p++;
		} else if ( *p == '+' ) {
			expsign = 1;
			p++;
		} else {
			expsign = 1;
		}
	
		if ( *p == 0 ) {
			if ( ptr ) *ptr = p;
			return d * neg;
		}
		while ( isdigit( *p ) ) {
			exp = ( *p - '0' ) * exp;
			p++;
		}
		if ( expsign == 1 ) {
			int i;
			for ( i = 0; i < exp; i ++ )
				d *= 10.0;
		} else {
			int i;
			for ( i = 0; i < exp; i ++ )
				d /= 10.0;
		}
	}

	if ( ptr ) * ptr = p;
	return d;
}

