#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *     University of Illinois at Urbana-Champaign
 *     Department of Computer Science
 *     1304 W. Springfield Ave.
 *     Urbana, IL 61801
 *
 * Copyright (c) 1987-2005
 * The University of Illinois Board of Trustees.
 *  All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 * Author: Ellick Chan (emchan@cs.uiuc.edu)
 * Author: Jeffrey Carlyle (jcarlyle@cs.uiuc.edu)
 *
 */

#include "CharacterInputStream.h"
#include "GenericARMConsole.h"
#include "GenericARMBootConsole.h"
#include "AsmBridge.h"

GenericARMBootConsole::GenericARMBootConsole() {
    timeout = 1;
}

GenericARMBootConsole::~GenericARMBootConsole() {
}

char GenericARMBootConsole::getChar() {
    return ((GenericARMConsole*) &Console())->getChar();
}

int GenericARMBootConsole::getRawChar(char* c) {
    return GenericARMSerialGetRawChar(c); 
}

int GenericARMBootConsole::readBuffer(unsigned len, char* buf) { 
    int res;
    res = BootConsole::readBuffer(len, buf, timeout); 
    if(!res) {
        // timeout cancelled
        timeout = 0;
    }
    return res;
}

void GenericARMBootConsole::printMenu() {
    if( timeout > 0 )
        Debug << "\nAutoboot in " << timeout/1000000 << " seconds, hit enter to continue, any other key to abort...\r\n";
    else
        BootConsole::printMenu();
}
