#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *       University of Illinois at Urbana-Champaign
 *       Department of Computer Science
 *       1304 W. Springfield Ave.
 *       Urbana, IL 61801
 *
 * Copyright (c) 1987-1992
 * The University of Illinois Board of Trustees.
 *  All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * This is the initial setup code.
 * Main() is called by ALL processors while still in physical memory
 * mode. One processor (the first one to call it Main()) sets up the
 * Kernel via its constructor.
 * All processors join the kernel by invoking the perProcessorEntry() method
 * on it.
 *
 */

#include "Assert.h"
#include "GenericARMGdb.h"
#include "OutputStream.h"
#include "MACHINE_CONFIGURATION.h"
#include "GenericARMConsole.h"
#include "GenericARMDebug.h"
#include "GenericARMSerial.h"
#include "AsmBridge.h"

/*
 * This should only be called by one processor (the first to boot in a
 * multiprocessor).
 */


int consoleInitialized = 0;

int main()
{
}

void
GenericARMMain( int argc, char ** argv )
{
    ConsoleOutputStream =
        new GenericARMConsole(new MACHINESERIAL(MACHINE_UART_BASE));
    Assert( ConsoleOutputStream != 0 );
    consoleInitialized = 1;
    new GenericARMGdb();
}
