#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *       University of Illinois at Urbana-Champaign
 *       Department of Computer Science
 *       1304 W. Springfield Ave.
 *       Urbana, IL 61801
 *
 * Copyright (c) 1987-2006
 * The University of Illinois Board of Trustees.
 *  All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Swee Boon Lim (sblim@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * GenericARMSoftClock.cc
 */

#include "PROCESSOR.h"
#include "GenericARMSoftClock.h"
#include "MACHINE_CONFIGURATION.h"

#ifdef __GNUC__
#pragma interface
#endif

typedef void (*PFV)();

GenericARMSoftwareClockManager::GenericARMSoftwareClockManager()
    : SoftwareClockManager()
{
    IntStorage intState ; PROCESSOR::disableInterrupts(intState);
    _hz = 1000000/TimerManageruSecPerInterrupt;
    _usecsPerTick = TimerManageruSecPerInterrupt;
    start();
    extern PFV GenericARMTickInterruptFunc;
    Assert( GenericARMTickInterruptFunc == 0 );
    GenericARMTickInterruptFunc = (PFV) &hardClockInterrupt;
    PROCESSOR::restoreInterrupts( intState );
}

