#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *               University of Illinois at Urbana-Champaign
 *               Department of Computer Science
 *               1304 W. Springfield Ave.
 *               Urbana, IL     61801
 *
 * Copyright (c) 1987-2006
 * The University of Illinois Board of Trustees.
 *      All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

#include "Assert.h"
#include "Gdb.h"
#include "CPU.h"
#include "ThisCPU.h"
#include "MachPROM.h"
#include "ARMCPU.h"
#include "GenericARMTestDebug.h"
#include "AsmBridge.h"

#ifdef __GNUC__
#pragma implementation
#endif

int debugFromStart = 0;

extern void Main( int argc, char ** argv );

extern "C" {
    void KernelStart(void)
    {
        GenericARMSerialInitialize();
#ifdef RELIABILITY
        GenericARMSerialPutS("\r\nBooting ReliableChoices, please wait...\r\n");
#else
        GenericARMSerialPutS("\r\nBooting Choices, please wait...\r\n");
#endif
        GenericARMSerialPutS("Built on ");
        GenericARMSerialPutS(__DATE__);
        GenericARMSerialPutS(" ");
        GenericARMSerialPutS(__TIME__);
        GenericARMSerialPutS("\r\n");
        Main( 0, 0 );
        CPU::processorStart();
    }
}

