#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *       University of Illinois at Urbana-Champaign
 *       Department of Computer Science
 *       1304 W. Springfield Ave.
 *       Urbana, IL 61801
 *
 * Copyright (c) 1987-2006
 * The University of Illinois Board of Trustees.
 *  All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * IntegratorTimerManager.c - machine dependent portion of timer managing
 */

#include "IntegratorTimer.h"

#ifdef __GNUC__
#pragma implementation
#endif

void StartTimer(void)
{
    // Start the timers
    // TimerManager
    iTimer1->start(TimerManagerTickPeriod);
    // FRT
    // TODO Fix QEMU - Second timer doesn't work correctly
    //iTimer2->start(FRTTickPeriod);
}

void AcknowledgeTimer(void)
{
    // Ack the Timer
    iTimer1->clear();
}

IntegratorTimerManager::IntegratorTimerManager(PFI ptb, PFV ep)
    : GenericARMTimerManager(ptb, ep)
{
}

