#include "IntegratorSerial.h"

int tstChar(void);

void IntegratorSerialInitialize(void)
{
    // ARM Primecell PL011 UART
    volatile unsigned* uart_cr = (unsigned*) UART_CR;
    *uart_cr = 0;
    *uart_cr = UART_RXE | UART_TXE;
    *uart_cr |= UARTEN;           
}

void IntegratorSerialPutChar(char c)
{
    volatile unsigned *uart_dr = (unsigned*) UARTDR;
    volatile unsigned *uart_fr = (unsigned*) UARTFR;
    while(*uart_fr & UART_BUSY);
    *uart_dr = c;
}

int tstChar(void)
{
    volatile unsigned* uartfr = (unsigned*)UARTFR;
    return *uartfr & UART_RXFF;
}

int IntegratorSerialGetRawChar(char* c)
{
    if(tstChar()) {
        volatile unsigned *uart_dr = (unsigned*) UARTDR;
        *c = *uart_dr;       
        return 0;
    }
    return 1;
}

char IntegratorSerialGetChar(void)
{
    while(!tstChar()); 

    volatile unsigned *uart_dr = (unsigned*) UARTDR;
    return (char) *uart_dr;       
}

void IntegratorSerialPutS(const char *s)
{
    while (*s)
        IntegratorSerialPutChar(*s++);
}

extern "C" {
    void platformsetup(void)
    {
    }
}
