#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Bjorn A. Helgaas (helgaas@cs.uiuc.edu)
 * Contributing Author: See-Mong Tan (stan@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * This is the initial setup code.
 * Main() is called by ALL processors while still in physical memory
 * mode. One processor (the first one to call it Main()) sets up the
 * Kernel via its constructor.
 * All processors join the kernel by invoking the perProcessorEntry() method
 * on it.
 */

#include "Assert.h"
#include "CPU.h"
#include "Class.h"
#include "MultimaxEMCDiskStar.h"
#include "MACHINEKERNEL.h"
#include "MultimaxConsole.h"
#include "OutputStream.h"
#include "String.h"


#ifdef __GNUC__
#pragma implementation
#endif

typedef void (* PFV)();

char * nameOfInitialApplication;
int useDebugger = 0;

/*
 * This should only be called by one processor (the first to boot in a
 * multiprocessor).
 */
void
MultimaxMain( int argc, char ** argv )
{
	extern OutputStream * ConsoleOutputStream;
	ConsoleOutputStream = new MultimaxConsole();
	Assert( ConsoleOutputStream != 0 );
	Console() << "Console built\n" << eor;
}

unsigned int *
MultimaxHeapStart()
{
	extern int end;
	return( (unsigned int *) &end );
}
