#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Vincent F. Russo (russo@cs.uiuc.edu)
 * Contributing Author: Gary M. Johnston (johnston@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * RequestorProcess.c: the process that awaits requestor interrupts.
 */
#include "Assert.h"
#include "OutputStream.h"
#include "AwaitedInterruptInterrupt.h"
#include "Vectors.h"
#include "CPU.h"
#include "ThisCPU.h"


#ifdef __GNUC__
#pragma implementation
#endif

volatile int slot4initialized = 0;
volatile int slot12initialized = 0;

void
RequestorInterruptProcessEntry( int slot )
{
	Debug.printf( "RequestorInterruptProcessEntry( slot:%d )\n", slot );
	Assert( slot >= 0 );
	Assert( slot <= 15 );

	extern RequestorInit( int );
	RequestorInit( slot );
	Debug.printf( "RequestorInterruptProcessEntry: Requestor CRQ initialized\n" );

	int vector = SLOT0REQUESTOR_Vector + slot;
	AwaitedInterruptInterrupt * interrupt = new AwaitedInterruptInterrupt();
	thisCPU()->setInterrupt( vector, interrupt );

        if( slot == 4 ) slot4initialized = 1;
        else if( slot == 12 ) slot12initialized = 1;
	else Assert( NOTREACHED );

	/*
	 * Loop forever waiting for an interrupt and then processing it.
	 */
	while( 1 ) {
		interrupt->await();

		/*
		 * Process the input.
		 */
		extern void RequestorInterruptHandler( int );
		RequestorInterruptHandler( slot );
	}
}
