#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Vincent F. Russo (russo@cs.uiuc.edu)
 * Contributing Author: Gary M. Johnston (johnston@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * SCCFreeRunningTimer.cc
 */
#include "Assert.h"
#include "SCCFreeRunningTimer.h"
#include "FreeRunningTimerStar.h"
#include "ClassStar.h"


#ifdef __GNUC__
#pragma implementation
#endif

/*
 * There is only a single instance.
 */
SCCFreeRunningTimer theSystemTimer;
FreeRunningTimerStar SystemTimer = &theSystemTimer;


	/* SCC free-running timer address */
static unsigned int * const SCCFreeRunningTimerRegister
	= (unsigned int *) 0xfffd0200;

SCCFreeRunningTimer::SCCFreeRunningTimer()
{
	// make sure only called once!
	Assert( this == &theSystemTimer );
	start = *SCCFreeRunningTimerRegister;
}

SCCFreeRunningTimer::~SCCFreeRunningTimer()
{
	Assert( NOTREACHED );
}

unsigned int
SCCFreeRunningTimer::time()
{
	unsigned int now = *SCCFreeRunningTimerRegister;
	return( ( now >= start ) ? ( now - start )  :
	 	( ( ( (unsigned int) 0xffffffff - start ) + 1 ) + now ) );
}



#include "ClassInstaller.h"
DEFINECLASS("SCCFreeRunningTimer",SCCFreeRunningTimer,FreeRunningTimer,0,0);
