#include "ns16550.h"
#include "OMAPDevices.h"

#define BAUD_DIVISOR    26  /* 115200 bps */

static NS16550_t serialPort = (NS16550_t) CFG_NS16550_COM1;

void OMAPSerialInitialize(void)
{
    serialPort->ier = 0x00;
    serialPort->lcr = LCR_BKSE | LCRVAL;
    serialPort->dll = BAUD_DIVISOR & 0xff;
    serialPort->dlm = (BAUD_DIVISOR >> 8) & 0xff;
    serialPort->lcr = LCRVAL;
    serialPort->mcr = MCRVAL;
    serialPort->fcr = FCRVAL;
    serialPort->mdr1 = 0;
}

void OMAPSerialPutChar(char c)
{
    while ((serialPort->lsr & LSR_THRE) == 0);
    serialPort->thr = c;
}

int OMAPSerialGetRawChar(char* c)
{
    if ( serialPort->lsr & LSR_DR )
    {
        *c = serialPort->rbr;
        return 0;
    }
    return 1;
}

char OMAPSerialGetChar(void)
{
    while ((serialPort->lsr & LSR_DR) == 0);
    return (serialPort->rbr);
}

void OMAPSerialPutS(const char *s)
{
    while (*s)
        OMAPSerialPutChar(*s++);
}
