#ifdef __GNUC__
#pragma implementation
#endif

/*
 * Routines to get things from the machine.
 */

#include "Assert.h"
#include "OutputStream.h"
#include "MachPROM.h"
#include "String.h"

OMAPPROM::OMAPPROM()
{
}

/*
 * Not known if there is any PROM area on the OMAP we can read this from
 * Hard coding RAM range for now
 * Francis <fdavid@uiuc.edu>
 */
void
OMAPPROM::setmemlists( struct memlist * &phys_available, 
                       struct memlist * &phys_total)
{
    static struct memlist *pmem = 0;

    Debug << "PROM memory areas are hard-coded " << __FILE__ << ":"
        << __LINE__ << "\n" << eor;
    if (pmem == 0) {
        // Francis - TODO CHECK is new ok?
        pmem = new memlist;
        pmem->address = 0x10000000;
        pmem->size = 0x02000000;
        pmem->next = 0;
    }

    phys_available = pmem;
    phys_total = pmem;

    Assert (phys_available != 0);
    Assert (phys_total != 0);
}
