#ifdef __GNUC__
#pragma implementation
#endif

#include "OMAPSerial.h"
#include "ns16550.h"
#include "OMAPDevices.h"

#define BAUD_DIVISOR    26  /* 115200 bps */

OMAPSerial::OMAPSerial(unsigned base) : GenericARMSerial(),base(base)
{
    Initialize();
}

void OMAPSerial::Initialize()
{
    NS16550_t serialPort = (NS16550_t)base;
    serialPort->ier &= 0xF0;
    serialPort->lcr = LCR_BKSE | LCRVAL;
    serialPort->dll = BAUD_DIVISOR & 0xff;
    serialPort->dlm = (BAUD_DIVISOR >> 8) & 0xff;
    serialPort->lcr = LCRVAL;
    serialPort->mcr = MCRVAL;
    serialPort->fcr = FCRVAL;
    serialPort->mdr1 = 0;
}


void OMAPSerial::enableInterrupts()
{
    NS16550_t serialPort = (NS16550_t)base;
    serialPort->ier |= 0x01;
}

void OMAPSerial::disableInterrupts()
{
    NS16550_t serialPort = (NS16550_t)base;
    serialPort->ier &= ~0x01;
}

void OMAPSerial::putChar(char c)
{
    NS16550_t serialPort = (NS16550_t)base;
    while ((serialPort->lsr & LSR_THRE) == 0);
    serialPort->thr = c;
}

char OMAPSerial::getChar()
{
    NS16550_t serialPort = (NS16550_t)base;
    return (serialPort->rbr);
}

int OMAPSerial::tstChar()
{
    NS16550_t serialPort = (NS16550_t)base;
    return (serialPort->lsr & LSR_DR);
}
