#ifdef __GNUC__
#pragma implementation
#endif

#include "OMAPSerialDD.h"
#include "MACHINE_CONFIGURATION.h"
#include "ARMPageTableConstants.h"

void OMAPSerialDD::basicInit() {
    AddressTranslation* translation = domain_->translation();
    translation->changeProtection((char *)MACHINE_UART_BASE, PhysicalPageSize, ReadWrite);
}

char OMAPSerialDD::getChar() {
    Exception* ex = 0;
    char ch = 0;
    char *oldStackPointer_;

    init();

    // Save current stack
    asm( "mov %0, sp":"=r"(oldStackPointer_) );
    switchToDriverDomain();
    asm( "mov r13, %0"::"r"(newStackPointer_) );

    try{
        ch = OMAPSerial::getChar();
    } catch (Exception* e){
        ex = e;
    }

    switchToKernelDomain();

    // Restore stack
    asm("mov sp, %0"::"r"(oldStackPointer_));

    if(ex) throw ex;

    return ch;
}
