/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: See-Mong Tan (stan@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * DatakitChannel.cc:
 */

#include "Assert.h"
#include "DatakitChannel.h"

int
DatakitChannel::channel()
{
	return chan;
}

char
DatakitChannel::ctlCalls()
{
	return ctlcalls;
}

int
DatakitChannel::channelOpened()
{
	return chan != MAXCHAN;
}

void
DatakitChannel::closeChannel()
{
	chan = MAXCHAN;  // this suffices to close it; very bogus
}


int
DatakitChannel::ReceivePacket( DatakitPacket * )
{
    Assert( NOTREACHED );
    return 0;
}

void
DatakitChannel::ReceiveControl( int )
{
    Assert( NOTREACHED );
}



#include "ClassInstaller.h"
DEFINECLASS("DatakitChannel",DatakitChannel,ProxiableObject,0,0);
