/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1990, 1991 The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Peter W. Madany (madany@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * PCi586DiskStar.c - 
 */
#include "PCi586DiskStar.h"
#include "ProxiableObject.h"

extern ClassStar PCi586DiskClass;

PCi586DiskStar::PCi586DiskStar( ProxiableObject * po )
{
	_pointer = po;
	if( _pointer != 0 ) _pointer->reference();
}

PCi586DiskStar::PCi586DiskStar( ProxiableObjectRef &  pos )
{
	_pointer = pos._pointer;
}

PCi586DiskStar::PCi586DiskStar( ProxiableObjectStar &  pos )
{
	_pointer = (ProxiableObject*)pos;
	if( _pointer != 0 ) _pointer->reference();
}

PCi586DiskStar::PCi586DiskStar( PCi586Disk * po )
{
	_pointer = (ProxiableObject *)po;
	if( _pointer != 0 ) _pointer->reference();
}

PCi586DiskStar::PCi586DiskStar( PCi586DiskRef &  pos )
{
	_pointer = pos._pointer;
}

PCi586DiskStar::PCi586DiskStar( PCi586DiskStar &  pos )
{
	_pointer = pos._pointer;
	if( _pointer != 0 ) _pointer->reference();
}

PCi586DiskStar & 
PCi586DiskStar::operator=( ProxiableObject * po )
{
    if( _pointer != po ) {
	if( _pointer != 0 ) _pointer->unreference();
	_pointer = po;
	if( _pointer != 0 ) _pointer->reference();
    }
    return( *this );
}

PCi586DiskStar & CONST
PCi586DiskStar::operator=( ProxiableObjectRef &  po )
{
	if( _pointer != 0 ) _pointer->unreference();
	_pointer = po._pointer;
	return( *this );
}

PCi586DiskStar & CONST
PCi586DiskStar::operator=( ProxiableObjectStar &  po )
{
    if( _pointer != po._pointer ) {
	if( _pointer != 0 ) _pointer->unreference();
	_pointer = po._pointer;
	if( _pointer != 0 ) _pointer->reference();
    }
    return( *this );
}

PCi586DiskStar & CONST
PCi586DiskStar::operator=( PCi586Disk * po )
{
    if( _pointer != (ProxiableObject *)po ) {
	if( _pointer != 0 ) _pointer->unreference();
	_pointer = (ProxiableObject *)po;
	if( _pointer != 0 ) _pointer->reference();
    }
    return( *this );
}

PCi586DiskStar & CONST
PCi586DiskStar::operator=( PCi586DiskRef &  po )
{
	if( _pointer != 0 ) _pointer->unreference();
	_pointer = po._pointer;
	return( *this );
}

PCi586DiskStar & CONST
PCi586DiskStar::operator=( PCi586DiskStar &  po )
{
    if( _pointer != po._pointer ) {
	if( _pointer != 0 ) _pointer->unreference();
	_pointer = (ProxiableObject*)po;
	if( _pointer != 0 ) _pointer->reference();
    }
    return( *this );
}

PCi586DiskStar::PCi586DiskStar()
{
}

PCi586DiskRef::PCi586DiskRef()
{
}

PCi586DiskRef::~PCi586DiskRef()
{
}

PCi586DiskRef::PCi586DiskRef( ProxiableObject * po )
{
	_pointer = po;
	if( _pointer != 0 ) _pointer->reference();
}

PCi586DiskRef::PCi586DiskRef( ProxiableObjectRef &  pos )
{
	_pointer = pos._pointer;
}

PCi586DiskRef::PCi586DiskRef( ProxiableObjectStar &  pos )
{
	_pointer = pos._pointer;
	if( _pointer != 0 ) _pointer->reference();
}

PCi586DiskRef::PCi586DiskRef( PCi586Disk * po )
{
	_pointer = (ProxiableObject *)po;
	if( _pointer != 0 ) _pointer->reference();
}

PCi586DiskRef::PCi586DiskRef( PCi586DiskRef &  pos )
{
	_pointer = pos._pointer;
}

PCi586DiskRef::PCi586DiskRef( PCi586DiskStar &  pos )
{
	_pointer = pos._pointer;
	if( _pointer != 0 ) _pointer->reference();
}

PCi586DiskRef & CONST
PCi586DiskRef::operator=( ProxiableObject * po )
{
    if( _pointer != po ) {
	if( _pointer != 0 ) _pointer->unreference();
	_pointer = po;
	if( _pointer != 0 ) _pointer->reference();
    }
    return( *this );
}

PCi586DiskRef & CONST
PCi586DiskRef::operator=( ProxiableObjectRef &  po )
{
	if( _pointer != 0 ) _pointer->unreference();
	_pointer = po._pointer;
	return( *this );
}

PCi586DiskRef & CONST
PCi586DiskRef::operator=( ProxiableObjectStar &  po )
{
    if( _pointer != po._pointer ) {
	if( _pointer != 0 ) _pointer->unreference();
	_pointer = po._pointer;
	if( _pointer != 0 ) _pointer->reference();
    }
    return( *this );
}

PCi586DiskRef & CONST
PCi586DiskRef::operator=( PCi586Disk * po )
{
    if( _pointer != (ProxiableObject *)po ) {
	if( _pointer != 0 ) _pointer->unreference();
	_pointer = (ProxiableObject *)po;
	if( _pointer != 0 ) _pointer->reference();
    }
    return( *this );
}

PCi586DiskRef & CONST
PCi586DiskRef::operator=( PCi586DiskRef &  po )
{
	if( _pointer != 0 ) _pointer->unreference();
	_pointer = po._pointer;
	return( *this );
}

PCi586DiskRef & CONST
PCi586DiskRef::operator=( PCi586DiskStar &  po )
{
    if( _pointer != po._pointer ) {
	if( _pointer != 0 ) _pointer->unreference();
	_pointer = (ProxiableObject*)po;
	if( _pointer != 0 ) _pointer->reference();
    }
    return( *this );
}
