#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *               University of Illinois at Urbana-Champaign
 *               Department of Computer Science
 *               1304 W. Springfield Ave.
 *               Urbana, IL     61801
 *
 * Copyright (c) 1987-1992
 * The University of Illinois Board of Trustees.
 *      All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Nayeem Islam (nislam@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

#include "NetworkBuffer.h"
#include "ADriver.h"
#include "FreeRunningTimer.h"
#include "FreeRunningTimerStar.h"

ADriver::ADriver(volatile Am7990Word *rap,
		     volatile Am7990Word *rdp,
		     unsigned char debugMask, NetworkBufferFreeList *list) : SS1Am7990(rap, rdp, debugMask,list)
{
}
ADriver::~ADriver(){}

int
ADriver::transmitPacket(NetworkBuffer *buf)
{
	int retval = Am7990::transmitPacket(buf);
	return retval;
}


NetworkBuffer *
ADriver::getBuffer(unsigned int len) 
{
	NetworkBuffer *buf = Am7990::getBuffer(len);
	return buf;
}


void
ADriver::releaseBuffer(NetworkBuffer *buf)
{
  buf->release();
}


void
ADriver::receivePacket(NetworkBuffer *buf) 
{

	buf->setTime(SystemTimer->time());
#ifdef NO_MULTI
	EthernetAddress		to(buf->packet());
	if (isValidAddress(&to))
#endif NO_MULTI
	  NetworkDriver::receivePacket(buf);
#ifdef NO_MULTI
	else
	  buf->release();
#endif NO_MULTI
}

#include "ClassInstaller.h"
DEFINECLASS("ADriver", ADriver, SS1Am7990, 0, 0);
