#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *               University of Illinois at Urbana-Champaign
 *               Department of Computer Science
 *               1304 W. Springfield Ave.
 *               Urbana, IL     61801
 *
 * Copyright (c) 1987-1992
 * The University of Illinois Board of Trustees.
 *      All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */


#include "SCSIData.h"


#ifdef __GNUC__
#pragma implementation
#endif

BlockDescriptor::BlockDescriptor(unsigned char *data):SCSIData(data)
{
  myLength = 8;
}

ModeSenseData::ModeSenseData(unsigned char *data, int allocLength):SCSIData(data)
{
  if (allocLength == 0)
    myLength = 0;
  else
    myLength = MIN (allocLength, byte(0));
  presentDescriptors = 0;
  if (myLength >4) {
    presentDescriptors = byte(3) >> 3;
    for (int i=0; i<presentDescriptors; i++)
      descriptor[i] = new BlockDescriptor( data+4+i*8 );
  }
}

ModeSenseData::~ModeSenseData()
{
}

