#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *               University of Illinois at Urbana-Champaign
 *               Department of Computer Science
 *               1304 W. Springfield Ave.
 *               Urbana, IL     61801
 *
 * Copyright (c) 1987-1992
 * The University of Illinois Board of Trustees.
 *      All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

#include "OutputStream.h"
#include "SS1DMA.h"


#ifdef __GNUC__
#pragma implementation
#endif


void
DMAController::drain(){
   /* Only drain if necessary */
#ifdef DEBUG
if( SS1DMADebug) Debug << "DMA drain\n" << eor;
#endif
   if (myCSRegister->read() & DMA_CS_PACK_CNT) {
           myCSRegister->write(myCSRegister->read() | DMA_CS_DRAIN);
           while (myCSRegister->read() & DMA_CS_DRAIN)
                Debug << "DMA Draining\n" << eor;
        }
}


void
DMAController::setAddress(unsigned char * addr, unsigned len)
{
#ifdef ADDRESS_DEBUG
	Console() << "DMAController::setAddress( " << asAddress(addr)
			<< ", " << asHex(len) << ")\n" << eor;
#endif
	Assert (_dmaAddr == 0);
	_dmaAddr = (char*)addr;
	_dmaLen = len;
	myAddressRegister->write((unsigned )addr);
//	myByteCountRegister->write(len);
}

void
DMAController::release()
{
#ifdef ADDRESS_DEBUG
	Console() << "DMAController::release()\n" << eor;
#endif
	Assert (_dmaAddr != 0);
	_dmaAddr = 0;
}
