#ifdef __GNUC__
#pragma implementation
#endif

#define DEBUG
/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987-1992
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

/*
 * SS1Console.c: SS1 Diagnostic console output routines.
 */

#include "Assert.h"
#include "SPARCasmutil.h"
#include "SS1Console.h"
#include "SS1Debug.h"
#include "SS1util.h"
#include "Util.h"
#include "sun4c/psl.h"
#include "sun4c/asm_linkage.h"


#ifdef __GNUC__
#pragma implementation
#endif

unsigned int statbuf0[34];
unsigned int statbuf1[34];
unsigned int statbuf2[34];
unsigned int statbuf3[34];
unsigned int statbuf4[34];
unsigned int statbuf5[34];
unsigned int statbuf6[34];
unsigned int statbuf7[34];

void
printdebug(unsigned int *statbuf)
{
	int i;

	Debug << "Stat buffer: " << asAddress(statbuf) << "\n" ;
	Console().printf("%%psr: %-8x %%wim: %-8x CWP: %-8x\n", statbuf[STAT_PSR],
		statbuf[STAT_WIM], (statbuf[STAT_PSR] & PSR_CWP) );

	for (i = 0; i < 8; i++) {
		Console().printf("%%g%d %-8x\t", i, statbuf[STAT_GLOBALS + i]);
		Console().printf("%%i%d %-8x\t", i, statbuf[STAT_INS + i]);
		Console().printf("%%l%d %-8x\t", i, statbuf[STAT_LOCALS + i]);
		Console().printf("%%o%d %-8x\n", i, statbuf[STAT_OUTS + i]);
		}
	Console().printf("\n");
}
