#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987-1992
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * SS1DiskStar.c - 
 */
#include "SS1DiskStar.h"


#ifdef __GNUC__
#pragma implementation
#endif

extern ClassStar SS1DiskClass;

SS1DiskStar::SS1DiskStar( ProxiableObject * po )
{
	_pointer = po;
	if( _pointer != 0 ) _pointer->reference();
}

SS1DiskStar::SS1DiskStar( ProxiableObjectRef & const pos )
{
	_pointer = pos._pointer;
}

SS1DiskStar::SS1DiskStar( ProxiableObjectStar & const pos )
{
	_pointer = (ProxiableObject*)pos;
	if( _pointer != 0 ) _pointer->reference();
}

SS1DiskStar::SS1DiskStar( SS1Disk * po )
{
	_pointer = (ProxiableObject *)po;
	if( _pointer != 0 ) _pointer->reference();
}

SS1DiskStar::SS1DiskStar( SS1DiskRef & const pos )
{
	_pointer = pos._pointer;
}

SS1DiskStar::SS1DiskStar( SS1DiskStar & const pos )
{
	_pointer = pos._pointer;
	if( _pointer != 0 ) _pointer->reference();
}

SS1DiskStar & CONST
SS1DiskStar::operator=( ProxiableObject * po )
{
    if( _pointer != po ) {
	if( _pointer != 0 ) _pointer->unreference();
	_pointer = po;
	if( _pointer != 0 ) _pointer->reference();
    }
    return( *this );
}

SS1DiskStar & CONST
SS1DiskStar::operator=( ProxiableObjectRef & const po )
{
	if( _pointer != 0 ) _pointer->unreference();
	_pointer = po._pointer;
	return( *this );
}

SS1DiskStar & CONST
SS1DiskStar::operator=( ProxiableObjectStar & const po )
{
    if( _pointer != po._pointer ) {
	if( _pointer != 0 ) _pointer->unreference();
	_pointer = po._pointer;
	if( _pointer != 0 ) _pointer->reference();
    }
    return( *this );
}

SS1DiskStar & CONST
SS1DiskStar::operator=( SS1Disk * po )
{
    if( _pointer != (ProxiableObject *)po ) {
	if( _pointer != 0 ) _pointer->unreference();
	_pointer = (ProxiableObject *)po;
	if( _pointer != 0 ) _pointer->reference();
    }
    return( *this );
}

SS1DiskStar & CONST
SS1DiskStar::operator=( SS1DiskRef & const po )
{
	if( _pointer != 0 ) _pointer->unreference();
	_pointer = po._pointer;
	return( *this );
}

SS1DiskStar & CONST
SS1DiskStar::operator=( SS1DiskStar & const po )
{
    if( _pointer != po._pointer ) {
	if( _pointer != 0 ) _pointer->unreference();
	_pointer = (ProxiableObject*)po;
	if( _pointer != 0 ) _pointer->reference();
    }
    return( *this );
}

SS1DiskStar::operator SS1Disk*() const
{
	return( (SS1Disk*)_pointer );
}

SS1Disk*
SS1DiskStar::operator->() const
{
	return( (SS1Disk*)_pointer );
}

SS1DiskStar::SS1DiskStar()
{
}

SS1DiskRef::SS1DiskRef()
{
}

SS1DiskRef::~SS1DiskRef()
{
}

SS1DiskRef::SS1DiskRef( ProxiableObject * po )
{
	_pointer = po;
	if( _pointer != 0 ) _pointer->reference();
}

SS1DiskRef::SS1DiskRef( ProxiableObjectRef & const pos )
{
	_pointer = pos._pointer;
}

SS1DiskRef::SS1DiskRef( ProxiableObjectStar & const pos )
{
	_pointer = pos._pointer;
	if( _pointer != 0 ) _pointer->reference();
}

SS1DiskRef::SS1DiskRef( SS1Disk * po )
{
	_pointer = (ProxiableObject *)po;
	if( _pointer != 0 ) _pointer->reference();
}

SS1DiskRef::SS1DiskRef( SS1DiskRef & const pos )
{
	_pointer = pos._pointer;
}

SS1DiskRef::SS1DiskRef( SS1DiskStar & const pos )
{
	_pointer = pos._pointer;
	if( _pointer != 0 ) _pointer->reference();
}

SS1DiskRef & CONST
SS1DiskRef::operator=( ProxiableObject * po )
{
    if( _pointer != po ) {
	if( _pointer != 0 ) _pointer->unreference();
	_pointer = po;
	if( _pointer != 0 ) _pointer->reference();
    }
    return( *this );
}

SS1DiskRef & CONST
SS1DiskRef::operator=( ProxiableObjectRef & const po )
{
	if( _pointer != 0 ) _pointer->unreference();
	_pointer = po._pointer;
	return( *this );
}

SS1DiskRef & CONST
SS1DiskRef::operator=( ProxiableObjectStar & const po )
{
    if( _pointer != po._pointer ) {
	if( _pointer != 0 ) _pointer->unreference();
	_pointer = po._pointer;
	if( _pointer != 0 ) _pointer->reference();
    }
    return( *this );
}

SS1DiskRef & CONST
SS1DiskRef::operator=( SS1Disk * po )
{
    if( _pointer != (ProxiableObject *)po ) {
	if( _pointer != 0 ) _pointer->unreference();
	_pointer = (ProxiableObject *)po;
	if( _pointer != 0 ) _pointer->reference();
    }
    return( *this );
}

SS1DiskRef & CONST
SS1DiskRef::operator=( SS1DiskRef & const po )
{
	if( _pointer != 0 ) _pointer->unreference();
	_pointer = po._pointer;
	return( *this );
}

SS1DiskRef & CONST
SS1DiskRef::operator=( SS1DiskStar & const po )
{
    if( _pointer != po._pointer ) {
	if( _pointer != 0 ) _pointer->unreference();
	_pointer = (ProxiableObject*)po;
	if( _pointer != 0 ) _pointer->reference();
    }
    return( *this );
}

SS1DiskRef::operator SS1Disk*() const
{
	return( (SS1Disk*)_pointer );
}

SS1Disk*
SS1DiskRef::operator->() const
{
	return( (SS1Disk*)_pointer );
}
