#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987-1992
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

#include "ADDRESS_TRANSLATION.h"
#include "Assert.h"
#include "OutputStream.h"
#include "SS1MMU.h"


#ifdef __GNUC__
#pragma implementation
#endif


SS1MMU::SS1MMU()
{
	Debug << "SS1MMU::ctor() " << this << "\n" << eor;
	_enabled = 0;
	extern unsigned npmegs;
	Console() << "SS1MMU::SS1MMU(): " << npmegs << " pmegs\n" 
		<< eor;

}

void
SS1MMU::basicActivate( AddressTranslation * at)
{
	SS1Translation * tr = (SS1Translation *)at;
	tr->basicActivate();
}
