#ifdef __GNUC__
#pragma implementation
#endif

#define DEBUG
/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987-1992
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * This is the initial setup code.
 * Main() is called by ALL processors while still in physical memory
 * mode. One processor (the first one to call it Main()) sets up the
 * Kernel via its constructor.
 * All processors join the kernel by invoking the perProcessorEntry() method
 * on it.
 *
 */

#include "Assert.h"
#include "Gdb.h"
#include "OutputStream.h"
#include "SS1Configuration.h"
#include "SS1Console.h"
#include "SS1Debug.h"
#include "SS1devices.h"


#ifdef __GNUC__
#pragma implementation
#endif


/*
 * This should only be called by one processor (the first to boot in a
 * multiprocessor).
 */


int consoleInitialized = 0;

#ifdef NEVR
extern "C" {
void * __CTOR_LIST__;
void * __DTOR_LIST__;
void
atexit(){}
};
#endif



int main()
{
}

void
SS1Main( int argc, char ** argv )
{
	ConsoleOutputStream = new SS1Console(SERIAL_B_CTL);
	Assert( ConsoleOutputStream != 0 );
	consoleInitialized = 1;
	Console() << "Console built\n" << eor;

#ifdef TEST_TRAPS
	test_traps();
#endif

#ifdef TEST_INTERRUPTS
	TrapToDebugger();
	int orig =DisableInterrupts();
	Assert(! InterruptsEnabled());
	for (int i = 0; i < 16; i++){
		RestoreInterrupts(i);
		int old = DisableInterrupts();
		RestoreInterrupts(old);
		Assert(InterruptLevel() == i);
		Assert(old == i);
		}
	RestoreInterrupts(orig);
#endif
}
