#include <sys/mmu.h>
#include <sys/asm_linkage.h>

#include "SPARCasmutil.h"



#ifdef NEVER
/* reset_system() */
	.text
	.align 4
	.globl _reset_system
_reset_system:
	set 0x40000000, %l7
	set 0x04, %g6
	stba %g6, [%l7]ASI_CTL
	retl
	nop


!*************************************************************************
!
!	Copy a prom trap table entry to our trap table.
!
!*************************************************************************
/*
 *	copytrap(int trapnumber);
 */
	.text
	.align 4
	.globl _copytrap
_copytrap:
	set _traptable, %o1
	mov %tbr, %o2
!bclr 0xfff, %o2			! Strip off the junk
	andn %o2, 0xfff, %o2		! Strip off the junk
	sll %o0, 4, %o0			! multiply number by 16
	add %o1, %o0, %o1
	add %o2, %o0, %o2
	clr %o3
L1:
	ldub [%o2 + %o3], %o4
	stb %o4, [%o1 + %o3]
	cmp %o3, 15
	bnz L1
	inc %o3		!delay
	retl
	nop

/* processorstat(char *stat_buf) */
!*************************************************************************
!
!	Routine to store away useful information about the state of 
!	the processor.  It stores it all into the buffer pointed to by
!	the argument passed.
!
!*************************************************************************
	.globl _processorstat
_processorstat:
		mov %psr, %o1
						! Store %psr
		st %o1, [%o0]
						! Store %wim as a number
		mov %wim, %o2
		set 0, %o1
	wimloop:
		btst 0x01, %o2
		bnz wimout
		nop
		inc %o1
		srl %o2, 1, %o2
		b wimloop
		nop
	wimout:
		st %o1, [%o0 +4]
						! Store ins
		st %i0, [%o0 + 8]
		st %i1, [%o0 + 12]
		st %i2, [%o0 + 16]
		st %i3, [%o0 + 20]
		st %i4, [%o0 + 24]
		st %i5, [%o0 + 28]
		st %i6, [%o0 + 32]
		st %i7, [%o0 + 36]
						! Store locals
		st %l0, [%o0 + 40]
		st %l1, [%o0 + 44]
		st %l2, [%o0 + 48]
		st %l3, [%o0 + 52]
		st %l4, [%o0 + 56]
		st %l5, [%o0 + 60]
		st %l6, [%o0 + 64]
		st %l7, [%o0 + 68]
						! Store outs
		st %o0, [%o0 + 72]
		st %o1, [%o0 + 76]
		st %o2, [%o0 + 80]
		st %o3, [%o0 + 84]
		st %o4, [%o0 + 88]
		st %o5, [%o0 + 92]
		st %o6, [%o0 + 96]
		st %o7, [%o0 + 100]
						! Store globals
		st %g0, [%o0 + 104]
		st %g1, [%o0 + 108]
		st %g2, [%o0 + 112]
		st %g3, [%o0 + 116]
		st %g4, [%o0 + 120]
		st %g5, [%o0 + 124]
		st %g6, [%o0 + 128]
		st %g7, [%o0 + 132]

		retl
		nop

#endif
