#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987-1992
 * The University of Illinois Board of Trustees.  
 *	All Rights Reserved.
 *
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * TYPES.cc: SS1 implementation of machine-dependent types
 */

#include "MachineTypes.h"
#include "Byte.h"


#ifdef __GNUC__
#pragma implementation
#endif

extern "C" {
#define L_ashldi3
#define L_udivdi3
#define L_umoddi3
#define L_udivmoddi4
#define L_muldi3
#include "libgcc2.c"
#undef L_ashldi3
#undef L_udivdi3
#undef L_umoddi3
#undef L_udivmoddi4
#undef L_muldi3

#ifdef NEVER
#if (__GNUG__ == 1)
# define L_adddi3
# include "gnulib2.c"
# undef L_adddi3
#endif
#endif
}
