#include <sys/asm_linkage.h>
#include <sys/param.h>
#include <sys/psw.h>
#include <sys/trap.h>
#include <sys/mmu.h>
#include <sys/pte.h>
#include <sys/reg.h>
#include <sys/buserr.h>
#include <sys/pcb.h>

#include "SPARCasmutil.h"

#define PROBE
/* #define COUNT */

#ifdef COUNT
       .seg "data"
        .align 4
        .globl _numUnderflows
_numUnderflows:
        .word 0
#endif

	! When called:
	! %l0 = %psr
	! %l1 = trapping pc
	! %l2 = trapping npc
	! %l3 = %wim
	! %l6 = NWINDOWS-1
	!
	.seg	"text"
	.align	4
	.global	w_underflow
w_underflow:
#ifdef COUNT
        sethi   %hi(_numUnderflows), %l7
        ld      [%l7 + %lo(_numUnderflows)], %l5
        inc     %l5
        st      %l5, [%l7 + %lo(_numUnderflows)]
#endif
        sll     %l3, 1, %l4             ! next WIM = rol(WIM, 1, NW)
        srl     %l3, %l6, %l6           ! trap vector set %l6 = NW-1
        or      %l6, %l4, %l6
        mov     %l6, %wim               ! install new wim
	mov	%g1, %l5		! save %g1
	nop; nop;
	restore
        restore                         ! get into window to be restored
#ifdef PROBE
	!
	! Check that stack is aligned 8
	!
	btst	0x7, %sp
	bnz _stackAlign
	!
	! Check that the stack base is on a readable page
	!
	lda	[%sp]ASI_PM, %g1
	srl     %g1, 24, %g1
	or      %g1, 0x73, %g1
	subcc   %g1, 0xf3, %g0
	bnz,a 	underflowFault
	mov 	%sp, %g1
	!
	! Check that the end is readable too if on a different page
	!
	and     %sp, 0xfff, %g1
	subcc   %g1, 0x1000-(15*4), %g0
	bl     1f
	add	%sp, 15*4, %g1
	lda	[%g1]ASI_PM, %g1
	srl     %g1, 24, %g1
	or      %g1, 0x73, %g1
	subcc   %g1, 0xf3, %g0
	bnz,a 	underflowFault
	add	%sp, 15*4, %g1
1:
#endif PROBE
noFault:
        RESTORE_WINDOW(%sp)
        save	%g0,%g0,%g0             ! get back to original window
        save	%g0,%g0,%g0
        mov     %l0, %psr               ! reinstall sup PSR_CC
	nop; nop; nop
	mov	%l5, %g1		! restore %g1
        jmpl    %l1, %g0                ! reexecute restore
        rett    %l2

underflowFault:
	bnz _stackPageFaultG1
	nop
