#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *               University of Illinois at Urbana-Champaign
 *               Department of Computer Science
 *               1304 W. Springfield Ave.
 *               Urbana, IL     61801
 *
 * Copyright (c) 1987-1992
 * The University of Illinois Board of Trustees.
 *      All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

#include "zs.h"
#include "zs_asm.h"
#include "OutputStream.h"


#ifdef __GNUC__
#pragma implementation
#endif

void
zs::debug()
{
	/*
	 * debugging:
	 * read out all the registers so we know what state (illinois?) 
	 * we are in.
	 */
	Debug << "rr0 = " << asHex(zsreadreg(_myaddr, 0)) << "\n";
	Debug << "rr1 = " << asHex(zsreadreg(_myaddr, 1)) << "\n";
	Debug << "rr2 = " << asHex(zsreadreg(_myaddr, 2)) << "\n";
	Debug << "rr3 = " << asHex(zsreadreg(_myaddr+4, 3)) << "\n";
	Debug << "rr4 = " << asHex(zsreadreg(_myaddr, 4)) << "\n";
	Debug << "rr5 = " << asHex(zsreadreg(_myaddr, 5)) << "\n";
	Debug << "rr6 = " << asHex(zsreadreg(_myaddr, 6)) << "\n";
	Debug << "rr7 = " << asHex(zsreadreg(_myaddr, 7)) << "\n";
	Debug << "rr8 = " << asHex(zsreadreg(_myaddr, 8)) << "\n";
	Debug << "rr9 = " << asHex(zsreadreg(_myaddr, 9)) << "\n";
	Debug << "rr10 = " << asHex(zsreadreg(_myaddr, 10)) << "\n";
	Debug << "rr11 = " << asHex(zsreadreg(_myaddr, 11)) << "\n";
	Debug << "rr12 = " << asHex(zsreadreg(_myaddr, 12)) << "\n";
	Debug << "rr13 = " << asHex(zsreadreg(_myaddr, 13)) << "\n";
	Debug << "rr14 = " << asHex(zsreadreg(_myaddr, 14)) << "\n";
	Debug << "rr15 = " << asHex(zsreadreg(_myaddr, 15)) << "\n";
}

zs::zs(volatile unsigned char *const ADDR) : _myaddr(ADDR)
{


	zswritereg(_myaddr, 0, 0);
	zswritereg(_myaddr, 1, 0);
	zswritereg(_myaddr, 2, 0);
}

unsigned char
zs::readCTL(unsigned char const reg)
{
	return zsreadreg(_myaddr, reg);
}

void
zs::writeCTL(unsigned char const reg, unsigned char const data)
{
	zswritereg(_myaddr, reg, data);
}

unsigned char
zs::readDATA()
{
	return zsreaddata(_myaddr + 2);
}

void
zs::writeDATA(unsigned char const data)
{
	zswritedata(_myaddr + 2, data);
}

void
zs::enableRint()
{
	zswritereg(_myaddr, 1, 0x11);
	zswritereg(_myaddr, 9, 0x08);
}
