#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987-1992
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

/*
 * VCPhysicalMemoryObject.c - memory object class to access physical memory.
 */
#include "Assert.h"
#include "OutputStream.h"
#include "VCPhysicalMemoryObject.h"
#include "ClassStar.h"


#ifdef __GNUC__
#pragma implementation
#endif

VCPhysicalMemoryObject physicalMemoryObject;
MemoryObjectStar ThePhysicalMemoryObject = &physicalMemoryObject;



void
VCPhysicalMemoryObject::copyBlock( const char * psrc,
				 const char * pdst,
				 unsigned int count )
{
    char * dest = (char *) pdst;
    char * src = (char *) psrc;
    while( count-- > 0 ) {
	*dest++ = *src++;
    }
}


#include "ClassInstaller.h"
DEFINECLASS("VCPhysicalMemoryObject",VCPhysicalMemoryObject,PhysicalMemoryObject,0,0);
