#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *               University of Illinois at Urbana-Champaign
 *               Department of Computer Science
 *               1304 W. Springfield Ave.
 *               Urbana, IL     61801
 *
 * Copyright (c) 1987-1992
 * The University of Illinois Board of Trustees.
 *      All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

#include "UNIXInputStream.h"
#include "ClassStar.h"


#ifdef __GNUC__
#pragma implementation
#endif

extern "C" int read( int, char *, int );

// Make it look like it reads lines, thus the single char reads
// from stdin.  Slow, but harmless.
int
UNIXInputStream::read( char * buf, int bufSize )
{
    int i = 1;
    do {
	::read( 0, buf, 1 );
	i++;
    } while ( *buf++ != '\n' && i < bufSize );
    return i;
}

#include "ClassInstaller.h"
DEFINECLASS("UNIXInputStream",UNIXInputStream,InputStream,0,0);
