#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987-1992
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

/*
 * VCFreeRunningTimer.cc
 */
#include "Assert.h"
#include "VCFreeRunningTimer.h"
#include "FreeRunningTimerStar.h"
#include "ClassStar.h"
extern "C" {
#include <sys/time.h>
//int gettimeofday(struct timeval *, struct timezone *);
};


#ifdef __GNUC__
#pragma implementation
#endif


VCFreeRunningTimer theSystemTimer;
FreeRunningTimerStar SystemTimer = &theSystemTimer;


unsigned int
VCFreeRunningTimer::time()
{
	struct timeval tp;
	Assert (gettimeofday(&tp, 0) == 0);
	return tp.tv_sec * 1000000 + tp.tv_usec;
}

#include "ClassInstaller.h"
DEFINECLASS("VCFreeRunningTimer",VCFreeRunningTimer,FreeRunningTimer,0,0);
