#ifdef __GNUC__
#pragma implementation
#endif

#define DEBUG
/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987-1992
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

/*
 * main for VC
 */
#include "Assert.h"
#include "UNIXOutputStream.h"
// #include "UNIXInputStream.h"
#include "VCConsole.h"
#include "PROCESSOR.h"
#include "Process.h"
#include "VCContext.h"
#include "Convert.h"
extern "C" {
#include <unistd.h>
#include <stdlib.h>
}

/*
 * Virtual Choices starts off here, just like a main() from a Unix program.
 * Unlike a normal UNIX program the static constructors have NOT been called.
 * That will happen in Main
 */
extern void Main( int, char ** );
extern void setUNIXConsoleMode();  // to avoid closing the terminal in VCConsole.cc


extern void maptest();
extern "C"
int
main( int argc, char ** argv )
{

  atexit(setUNIXConsoleMode);
	VCCPU::initSignalStuff();
    extern char * diskUnit ;
    if (argc > 1) {
	diskUnit = argv[1];
	}

    Main( argc, argv );
    //maptest();

    /*
     * Do not use Peter's MadAllocator!
     * Change the allocator to a VC allocator
     * It is statically constructed.
     */

    /*
     * Get process from CPU and switch to it
     */
	CPU::processorStart();
	Assert ( NOTREACHED );
	return 0;
}

/*
 * Main() calls VC main()
 */
void
VCMain( int, char ** )
{
	PROCESSOR::disableInterrupts();	// Disable interrupts, after global ctors for signal allocations.
    /*
     *  initialize the IO streams
     */
    extern OutputStream * ConsoleOutputStream;
    ConsoleOutputStream = new UNIXOutputStream;
    Assert( ConsoleOutputStream != 0 );

    // extern InputStream * ConsoleInputStream;
    // ConsoleInputStream = new UNIXInputStream;
    // Assert( ConsoleInputStream != 0 );

    consoleInputInitialized = 1;
}

//extern "C" { int __main() { return 0; } };
