#ifdef __GNUC__
#pragma implementation
#endif

/* 
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987-1992
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

#include "Assert.h"
#include "ClassStar.h"
#include "TimeSliceInterrupt.h"
#include "VCTimesliceTimer.h"


#ifdef __GNUC__
#pragma implementation
#endif

const unsigned microsecondsPerTick = 0x10000;

TimeSliceInterrupt TSliceInterrupt;

unsigned int
VCTimesliceTimer::start( unsigned microseconds )
{
	unsigned ticks = (microseconds + (microsecondsPerTick - 1)) /
							microsecondsPerTick;
	if (ticks > 0)
		running = 1;
	expireTime = ticks;
	return (ticks * microsecondsPerTick);
}

unsigned int
VCTimesliceTimer::stop()
{
	if (running)
		running = 0;
	else
		expireTime = 0;
	return (expireTime * microsecondsPerTick);
}

unsigned int
VCTimesliceTimer::residual()
{
	if (running)
		return (expireTime * microsecondsPerTick);
	else
		return 0;
}

void
VCTimesliceTimer::tick()
{
    if ((--expireTime == 0) && running) {
	running = 0;
	TSliceInterrupt.raise();
    }
}


#include "ClassInstaller.h"
DEFINECLASS("VCTimesliceTimer",VCTimesliceTimer,Timer,0,0);
