/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987-1992
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

/*
 * VCHostDisk.cc: Virtual Host Disk Access 
 */

#ifdef __GNUC__
#pragma implementation
#endif

#include "Assert.h"
#include "Raid.h"
#include "VCHostDisk.h"
#include "MemoryObjectPartition.h"
#include "Class.h"
#include "ClassStar.h"
#include "CPU.h"
#include "ThisCPU.h"
#include "Process.h"
#include "ThisProcess.h"
#include "Domain.h"


VCHostDisk::VCHostDisk( VCFileObject *fo)
  : Disk( 1 ), _fileObj(fo)
{
	initDebug();
	Raid( RaidConstructor )( "%N::VCHostDisk()\n", this );
}


#include "ClassInstaller.h"
DEFINECLASS("VCHostDisk",VCHostDisk,Disk,0,0);
