#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: See-Mong Tan (stan@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 *	$Header: /projects/choices/old/cvsroot/choices/MachineDependent/VChoices/sparc/VCTimerManager.cc,v 1.1 2004/07/18 09:43:58 jcarlyle Exp $
 */

#include "CPU.h"
#include "ThisCPU.h"
#include "VCTimerManager.h"
#include "TIMESLICE_TIMER.h"
extern "C" {
#include <sys/time.h>
#include <signal.h>
//int setitimer(int, struct itimerval*, struct itimerval*);
};


#ifdef __GNUC__
#pragma implementation
#endif

const int ticksPerSec = 2;
const unsigned TICKS = 1000000 / ticksPerSec;
struct itimerval itvOn = {{0, TICKS}, {0, TICKS}};
struct itimerval itvOff = {{0, 0}, {0, 0}};
const int TIMER_TYPE = ITIMER_REAL;

extern TimerManager *TimeoutManager;
extern TimerManager *PeriodicManager;


void
TimerManagerInterrupt::basicRaise( char * arg )
{
	// Re-schedule the timer
	setitimer(TIMER_TYPE, &itvOn, 0);

	/*
	 * Call the handlers
	 */
	if (TimeoutManager != 0) TimeoutManager->interruptHandler();

	if (PeriodicManager != 0) PeriodicManager->interruptHandler();

	CPU * currentCPU = thisCPU();
	Assert (currentCPU != 0);
	TIMESLICETIMER *ts = currentCPU->timesliceTimer();
	Assert (ts != 0);
	ts->tick();
}

VCTimerManager::VCTimerManager( PFI ptb, PFV ep)
     : TimerManager(ptb, ep)
{

  microsecondsPerTick = TICKS;
	setitimer(TIMER_TYPE, &itvOn, 0);
}
