
#include <stdio.h>
#include <ostream.h>
#include <values.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/mman.h>
#include <sys/types.h>
#include <signal.h>
#include <sys/trap.h>
#include <siginfo.h>
#include <ucontext.h>


#define Debug cout
const int PHYS_MEMORY_SIZE = 0x02000000; // 32 megs
//char * const KSTART = (char * const) 0x10000000;
char * const KSTART = (char * const)0xd0000000;
const int KERNELHEAPSIZE = 0x00800000; // 8 megs 
const int KERNELSIZE = 0x04000000; // 64 megs 
char * const ASTART = (char * const) 0xf0000000;
const int APPLICATIONSIZE = 0x04000000; // 64 megs

static int StoreFD = -1;

const unsigned
kernelHeapSize()
	{return KERNELHEAPSIZE;}

const unsigned
kernelSize()
	{return KERNELSIZE;}

const unsigned
applicationSize()
	{return APPLICATIONSIZE;}

const char *
kernelStart()
	{return KSTART;}

const char *
applicationStart()
	{return ASTART;}

void hardwareInterruptAssist(int vector, siginfo_t *si, void *uc)
{
     ucontext_t *utc = (ucontext_t*)uc;

	caddr_t faddr = (caddr_t)si->si_addr;
	printf("Trap Handler says address is %x\n", faddr);
	exit(0);
}

void
maptest()
{
	/*
	 * Allocate the kernel VM working range
	 */
	int kfd = ::open("KernelVM",  O_RDWR|O_CREAT|O_TRUNC|O_SYNC, 0700);
	//Assert (kfd != -1);
	::unlink("KernelVM");	// so it goes away
	int r =  ::lseek(kfd, kernelSize()-1, SEEK_SET);
	//Assert (r != -1);
	r =  ::write(kfd, " ", 1);
	//Assert (r != -1);
	//char *p = (char*)mmap((char*)kernelStart(), kernelSize(), PROT_NONE, MAP_PRIVATE|MAP_FIXED|MAP_ANON, -1, 0);
	char *p = (char*)mmap((char*)kernelStart(), kernelSize(), PROT_NONE, MAP_PRIVATE|MAP_FIXED|MAP_ANON, -1, 0);
	printf("VM is mapped at %x\n", p);
	//Assert ((int)p != -1);
	mprotect(p, kernelSize(), PROT_NONE);

	/*
	 * Install the handler 
	 */
	int vector = SIGSEGV;
	struct sigaction sa;
	 sa.sa_sigaction = &hardwareInterruptAssist;
	sa.sa_flags = SA_RESTART|SA_SIGINFO;
	//sigset_t &st = sa.sa_mask;
	//sigemptyset(&st);
	//sigaddset(&st, vector);
	// = (int) signal(vector, &VCCPU::hardwareInterruptAssist);
	r = (int) sigaction(vector, &sa, NULL);
	printf("Dereference VM\n");
	char c = *p;
	printf("Char at VM is %c\n", c);
}
