#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989 The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Aamod Sane (sane@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

#include "COW.h"
#include "COWCache.h"
#include "OutputStream.h"


#ifdef __GNUC__
#pragma implementation
#endif

State *
COW_P::localWrite(MemoryObjectCache * cache, unsigned unit,
		  AddressTranslation * adt)
{
    ((COWCache *)cache)->dupPageSelf(unit);
    VM_P::localWrite(cache,unit,adt);
    return STATE_VM_P;
}

static inline
COW_getPage(MemoryObjectCache * _cache_, unsigned unit)
{
    COWCache * cache = (COWCache *)_cache_;
    if (0 == cache->pageFromShadow(unit)) {
	if (cache->isACopy()) {
	    cache->pageFromSource(unit);
	}
	else {
	    cache->pagesFromStore(unit);
	    cache->fromDisk(unit);
	    cache->pageToShadow(unit);
	}
    }
}

State *
COW_NPDC::localRead(MemoryObjectCache * cache, unsigned unit,
		    AddressTranslation * adt)
{
    COW_getPage(cache,unit);
    STATE_VM_P->localRead(cache,unit,adt);
    return returnState(STATE_COW_P);
}

State *
COW_NPDC::localWrite(MemoryObjectCache * cache, unsigned unit,
		     AddressTranslation * adt)
{
    COW_getPage(cache,unit);
    return STATE_COW_P->localWrite(cache,unit,adt);
}


COWVMMachine::COWVMMachine()
: SimpleVMMachine(2)
{
    NEWSTATE( COW_NPDC );
    NEWSTATE( COW_P );
}

COWVMMachine * TheCOWVMMachine = 0;

SimpleVMState * STATE_COW_NPDC = 0;
SimpleVMState * STATE_COW_P = 0;
