#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989 The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Aamod Sane (sane@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

#include "NetworkBuffer.h"
#include "NetworkWalker.h"
#include "EthernetAdministrator.h"
#include "EthernetTransfer.h"
#include "DVMNetCom.h"


#ifdef __GNUC__
#pragma implementation
#endif

extern EthernetAdministrator * _THE_EthernetAdministrator;  //gross
extern EthernetTransfer * TheEthernetTransferObject;  //gross


DVMWalker::DVMWalker()
{
    _aBuffer = 0;
}

void
DVMWalker::setBuffer( NetworkBuffer * buff )
{
    _aBuffer = buff;
}

void
DVMWalker::walk( NetworkBuffer * buff )
{
    TheEthernetTransferObject->networkReceive( buff->packet(),buff->length() ); 
}
