#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989 The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Aamod Sane (sane@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

#include "MachineBuilder.h"
#include "SimpleVM.h"
#include "OneCopyDVM.h"
#include "COW.h"
#include "DVMManager.h"
#include "DVMCommunicator.h"


#ifdef __GNUC__
#pragma implementation
#endif

// SimpleVMMachine * TheSimpleVMMachine = 0;
// 
// SimpleVMState * STATE_VM_NPDC = 0;
// SimpleVMState * STATE_VM_P = 0;
// 
// OneCopyDVMMachine * TheOneCopyDVMMachine = 0;
// 
// OneCopyDVMState * STATE_DVM_NPDC = 0;
// OneCopyDVMState * STATE_DVM_P = 0;
// OneCopyDVMState * STATE_DVM_NPD = 0;
// 
// COWVMMachine * TheCOWVMMachine = 0;
// 
// SimpleVMState * STATE_COW_NPDC = 0;
// SimpleVMState * STATE_COW_P = 0;
	
void
MachineBuilder::build()
{
    Console() << "SimpleVMMachine\n" << eor;
    TheSimpleVMMachine = new SimpleVMMachine();

//     STATE_VM_NPDC = (SimpleVMState *)TheSimpleVMMachine->one();
//     STATE_VM_P = (SimpleVMState *)TheSimpleVMMachine->two();
    
//     TheOneCopyDVMMachine = new OneCopyDVMMachine();
    
//     STATE_DVM_NPDC = (OneCopyDVMState *)TheOneCopyDVMMachine->one();
//     STATE_DVM_P    = (OneCopyDVMState *)TheOneCopyDVMMachine->two();
//     STATE_DVM_NPD  = (OneCopyDVMState *)TheOneCopyDVMMachine->three();
    
    Console() << "COWVMMachine\n" << eor;
    TheCOWVMMachine = new COWVMMachine();

//     STATE_COW_NPDC = (SimpleVMState *)TheCOWVMMachine->one();
//     STATE_COW_P = (SimpleVMState *)TheCOWVMMachine->two();

    Console() << "DVMServiceMachine\n" << eor;
    TheDVMServiceMachine = new DVMServiceMachine();

    Console() << "NCDVMMachine\n" << eor;
    TheNCDVMMachine = new NCDVMMachine();

    Console() << "NCDVMMachine\n" << eor;
    TheRCDVMMachine = new RCDVMMachine();
}

void
MachineBuilder::buildDVM()
{
    Assert(TheDVMCommunicator == 0);
    TheDVMCommunicator = new DVMCommunicator();
    Assert( 0 != TheDVMCommunicator );

    Assert(TheDVMManager == 0);
    TheDVMManager = new DVMManager();
    Assert( 0 != TheDVMManager );
}

MachineBuilder TheMachineBuilder;
