#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Swee Boon Lim (sblim@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * PageOutAsync.cc 
 */

#include "PageOutAsync.h"
#include "ReplacementPolicy.h"

#ifdef __GNUC__
#pragma implementation
#endif

// Semaphore PageOutAsyncClosure::_countSem(48);

void 
PageOutAsyncClosure::func( PageOutAsyncClosure * c )
{
	ReplacementPolicy * rp = c->_rp;
	unsigned from = c->_from;
	unsigned to = c->_to;
	
/*
	Console() << "PageOutAsyncClosure::func() rp " << rp 
		<< " from " << from << " to " << to << " unitsToStore\n" << eor;
 */
	// rp->cacheToCache( from, to, 1, c->_paus, 0 );

	rp->cacheUnitsToStore( from, to, c->_unitsToStoreCode );
/*
	Console() << "PageOutAsyncClosure::func() rp " << rp 
		<< " from " << from << " to " << to << " postFault\n" << eor;
 */
	// _countSem.V();
	if ( c->_postFaultType == PostFaultGroup ) {
		rp->cachePostFault( from, to );
	} else {
		for( unsigned i = from; i <= to; i++ ) { 
			rp->cachePostFault( i, i );
		}
	}
	delete c;
}

OutputStream & operator<< ( OutputStream & stream, PageOutAsyncClosure & c )
{
	stream  << "_rp " << asAddress( c._rp ) << " _from " << c._from
		<< " _to " << c._to << " _paus "
		<< asAddress( c._paus );
	return stream; 
}

