#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987-1992
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Swee Boon Lim (sblim@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

/*
 * RealCache.cc
 */

#include "Assert.h"
#include "CacheUnitInfo.h"
#include "RealCache.h"
#include "Raid.h"


#ifdef __GNUC__
#pragma implementation
#endif

RealCache::RealCache( MemoryObjectCache * moc )
	: Cache( moc ),
	  _multiLevelCacheUnitInfoTable( _numberOfUnits )
{
	initDebug();
	Raids( RaidConstructor ) 
		<< asAddress(this) << "::RealCache( " << asAddress(moc) << " )\n" << eor;

	_unitInfoTable = &_multiLevelCacheUnitInfoTable;
}

unsigned int RealCache::basicSetNumberOfUnits( unsigned int noOfUnits )
{
	_unitInfoTable->setSize( noOfUnits );
	return noOfUnits;
}

#include "ClassInstaller.h"
DEFINECLASS("RealCache",RealCache,Cache,0,0);

