#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989 The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Swee Boon Lim (sblim@cs.uiuc.edu)
 * Author: Aamod Sane (sane@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

#include "Assert.h"
#include "OutputStream.h"
#include "Raid.h"
#include "SpecialPurposeCache.h"
#include "Store.h"
#include "Use.h"
#include "ThisProcess.h"


#ifdef __GNUC__
#pragma implementation
#endif

extern Store * MainStore;

SpecialPurposeCache::SpecialPurposeCache( MemoryObject * mo )
       : MemoryObjectCache( mo )
{
	initDebug();
	Raids( RaidConstructor ) << this << "::SpecialPurposeCache( "
		<< asAddress(mo) << " )\n" << eor;
}

PhysicallyAddressableUnit *
SpecialPurposeCache::storeAlloc( unsigned units )
{
	return MainStore->alloc( units << _log2PauUnitSizeRatio );
}

void
SpecialPurposeCache::storeDealloc( PhysicallyAddressableUnit * pau, 
				   unsigned queued )
{
	Assert( queued == 0 );	
	MainStore->dealloc( pau );
}

void
SpecialPurposeCache::unitsToStoreQueued( unsigned units )
{
	Assert( NOTREACHED );
}

unsigned SpecialPurposeCache::memoryObjectAlloc( unsigned from, unsigned to )
{
	return to - from + 1;
}

void
SpecialPurposeCache::saveModified(unsigned, unsigned, int, IOAsyncClosure * )
{
}

void
SpecialPurposeCache::toNet( unsigned, unsigned )
{
}

void
SpecialPurposeCache::fromNet( unsigned, unsigned )
{
}

int
SpecialPurposeCache::setNumberOfUnits( unsigned size )
{
	Assert( size == numberOfUnits() );
	return size;
}

void
SpecialPurposeCache::setReplacementPolicyClass( Class * )
{
	Assert( NOTREACHED );
	return;
}

unsigned
SpecialPurposeCache::pageOut( unsigned noOfPaus )
{
	Assert( NOTREACHED );
	return 0;
}
void
SpecialPurposeCache::flush()
{
	Assert(NOTREACHED);
}

void
SpecialPurposeCache::flush( unsigned, unsigned )
{
	Assert(NOTREACHED);
}

void
SpecialPurposeCache::synchronize( IOAsyncClosure * )
{
	Assert(NOTREACHED);
}

void
SpecialPurposeCache::synchronize( unsigned, unsigned, IOAsyncClosure * )
{
        Assert(NOTREACHED);
}

void 
SpecialPurposeCache::addCache( Class * cacheClass )
{
	Assert(NOTREACHED);
}

#include "ClassInstaller.h"
DEFINECLASS("SpecialPurposeCache",SpecialPurposeCache,MemoryObjectCache,0,0);
