#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Bjorn A. Helgaas (helgaas@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * VirtualMemoryRange.cc - 
 */

#include "Assert.h"
#include "VirtualMemoryRange.h"
#include "ClassStar.h"


#ifdef __GNUC__
#pragma implementation
#endif

VirtualMemoryRange::VirtualMemoryRange( const char * virtualAddress,
    unsigned int units, int log2UnitSize, char * name, unsigned char myRing )
	: MemoryRange( units, log2UnitSize )
{
	_next = 0;
	_virtualAddress = virtualAddress;

	_objectName = name;
	_ring = myRing;
	setName( (const char *) name );
}

VirtualMemoryRange::~VirtualMemoryRange()
{
	Assert( NOTREACHED );
}

void
VirtualMemoryRange::add( VirtualMemoryRange * newRange )
{
	VirtualMemoryRange * current = this;
	while( current->next() != 0 ) {
		current = current->next();
	}
	current->setNext( newRange );
}

/*
 * This function really should be inline, but is in the .cc file to force
 * Cfront to generate a vtable for the class.
 */



#include "ClassInstaller.h"
DEFINECLASS("VirtualMemoryRange",VirtualMemoryRange,MemoryRange,0,0);
