#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1990,1991 The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 *
 * Author: Amit Parghi (parghi@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

/*
 *	NetworkTest.cc
 *
 *	Misc useful stuff for *testing* Network programs
 *
 * $Id: NetworkTest.cc 2 2004-06-03 01:58:28Z jcarlyle $
 *
 */

//DD SYSIN *


// #define DEBUG 1

#include "OutputStream.h"
#include "Kernel.h"
#include "NameServer.h"
#include "NetworkBuffer.h"
#include "NetworkBufferManager.h"
#include "NetworkTest.h"
#include "Ethernet.h"
#include "EthernetAdministrator.h"



#ifdef __GNUC__
#pragma implementation
#endif

    //	WARNING: Originally, the design of the NetworkWalker was a bit
    //	odd, because I had a mixed-up idea of how the coordination between
    //	the Walker, the EthernetAdministrator, and the WalkerProcesses
    //	worked.  But that's all better now.  So the NetworkWalker has
    //	no Semaphore on its own (although it used to!).
    //
    //	This constructor is supposed to be called by some member of a
    //	higher layer in a protocol stack.   In this specific instance
    //	(i.e. the TestWalker), it will probably end up being called by
    //	some kludged-in test code within the MachineDependent
    //	WhateverKernel.cc file.					// Amit
    //
NetworkTestWalker::NetworkTestWalker()
{
    EthernetAdministrator *admin;

    Debug << "NetworkTestWalker.   Constructing ...\n" << eor;

	//  In order to register our packet type code with the
	//  EthernetAdministrator (see below), we need first to find
	//  where the EthernetAdministrator actually is!
    extern unsigned char DebugGlobalVariable;
    //extern ClassStar EthernetAdministratorClass;
    //Debug << "Attempting to look up administrator (class "
	//  << asHex((unsigned int) EthernetAdministratorClass) << ")\n" << eor;
    DebugGlobalVariable = 1;
    //admin = (EthernetAdministrator *)
	//    TheKernel->nameServer()->lookup("_THE_EthernetAdministrator",
	//				    EthernetAdministratorClass);
    DebugGlobalVariable = 0;
	// THE FOLLOWING IS A GROSS HACK to be used only until the
	// NameServer problem is cleared up ...
	// cf. Att6386Kernel::basicInitializeNetworkProcesses()   // Amit
    extern EthernetAdministrator* _THE_EthernetAdministrator;
    admin = _THE_EthernetAdministrator;

    Debug << "NetworkTestWalker constr: given address "
	  << asHex((unsigned int) admin)
	  << " for EthernetAdministrator.\n" << eor;

	//  Tell the EthernetAdministrator that this walker is
	//  responsible for handling inbound packets of the specified
	//  ethernet type.
    if (admin != NULL) {
	admin->registerType(EthernetSpecialTestType, this);
    }
}


NetworkTestWalker::~NetworkTestWalker()
{}


    void
NetworkTestWalker::walk(NetworkBuffer * buff)
{
	//	Now, we're on our way ... this is where all the code becomes
	//	specific to the protocol stack appropriate to this Walker
	//	subclass.  In our test case, of course, there is no stack,
	//	just a whole shitload of debugging (which, we hope, won't
	//	crash the machine in a Sorceror's-Apprentice-Mode explosion,
	//	he said naively).
    unsigned char *sequence = buff->packet() + 14;

	//	Be sure to use network byte ordering.
    unsigned short number = (*sequence << 8) + *(sequence + 1);

    Debug << "NetworkTestWalker: received NetworkBuffer (length = "
	  << buff->length() << "), seq # = "
	  << asHex((unsigned int) number) << '\n' << eor;

#   if defined(DEBUG2)
	Debug << *buff << eor;
#   endif

    buff->release();
}
