#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Johnny Zweig (zweig@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

/*
 * Conduit.cc 
 *
 */
/*
	See Conduit.h for much better comments about what all this stuff
	does....
 */

#include "OutputStream.h"
#include "ConduitTypes.h"
#include "Word.h"
#include "CPU.h"
#include "Process.h"
#include "Semaphore.h"
#include "ZootConfig.h"
#include "ZootReturnCodes.h"
#include "Assert.h"
#include "ZootAddress.h"
#include "ConduitMessage.h"
#include "ConduitMessageBuffer.h"
#include "MessageFIFO.h"
#include "IPChecksum.h"
#include "ZootStateMachine.h"
#include "Zoot_IP_Output.h"
#include "Conduit.h"


#ifdef __GNUC__
#pragma implementation
#endif

// -------------------- Class Conduit stuff: -------------------
Conduit::Conduit()
{
	my_proto = Undefined;
}
Conduit::~Conduit()
{
}

Return_Code
Conduit::connectTo( Conduit * c )
{
	// Do a double-dispatch with the other Conduit:
	return( c->connectFromAbove( this, my_proto ) );

	// Notice that, in general, connectTo() needs to be able to undo any
	//   effects of the connectFromBelow() that this cFA() will cause,
	//   in the event that cFA() returns non-OK....
}
Return_Code
Conduit::connectFromAbove( Conduit * c, ProtocolID proto )
{
	Assert( NOTREACHED );
	return( Return_Code(0) );
}
Return_Code
Conduit::connectFromBelow( Conduit * c, ProtocolID proto, int his_handy,
				int & my_handy )
{
	Assert( NOTREACHED );
	return( Return_Code(0) );
}
Return_Code
Conduit::disconnectFrom( Conduit * c )
{
	Assert( NOTREACHED );
	return( Return_Code(0) );
}
Return_Code
Conduit::disconnectFromAbove( Conduit * c )
{
	Assert( NOTREACHED );
	return( Return_Code(0) );
}

Return_Code
Conduit::insertFromAbove( ConduitMessage * msg, NetworkAddress * addr )
{
	Assert(NOTREACHED);	// Subclass responsibilty
	return( Return_Code(0) );
}
Return_Code
Conduit::insertFromBelow( ConduitMessage * msg )
{
	Assert(NOTREACHED);	// Subclass responsibilty
	return( Return_Code(0) );
}
void
Conduit::Reset()
{
	// Should return the conduit to a known state. This may involve
	//   deleting connections, resetting states, and all kinds of
	//   gory nonsense. Evil magic.
}


#include "ClassInstaller.h"
DEFINECLASS("Conduit",Conduit,ProxiableObject,0,0);
