#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Johnny Zweig (zweig@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

/*
 * ZootAddress.cc
 *
 */

#include "ConduitTypes.h"
#include "Word.h"
#include "NetworkAddress.h"
#include "ZootAddress.h"

#ifdef __GNUC__
#pragma implementation
#endif


NetworkAddress::~NetworkAddress()
{
}
octet *
NetworkAddress::ptr()
{
	return( 0 );	// Nothing to point to....
}
void
NetworkAddress::copyFrom( octet * source )
{
}
void
NetworkAddress::copyTo( octet * dest )
{
}
//-----------------------------------------------------------------------------

/*** Old stuff:
Frag32
IPAddress::hostaddr()
{
	Frag32	tmp;
	octet	dummy[4];
	for( int i = 0; i < 4; i++ ) dummy[i] = addr[i];
	if( (addr[0] & 0x01) == 0 ) {	// Check bit 0
	  // Class A address, so mask off first 8 bits:
	  dummy[0] = 0;
	  tmp.equals( & dummy[0] );
	  return( tmp );
	}
	else {
	  if( (addr[0] & 0x02) == 0 ) {	// Check bit 1
	    // Class B address, so mask off first 16 bits:
	    dummy[0] = 0;
	    dummy[1] = 0;
	    tmp.equals( & dummy[0] );
	    return( tmp );
	  }
	  else {
	    // Class C address, so mask off first 24 bits:
	    dummy[0] = 0;
	    dummy[1] = 0;
	    dummy[2] = 0;
	    tmp.equals( & dummy[0] );
	    return( tmp );
	  }
	}
}
Frag32
IPAddress::netaddr()
{
	Frag32	tmp;
	octet	dummy[4];
	for( int i = 0; i < 4; i++ ) dummy[i] = addr[i];
	if( (addr[0] & 0x01) == 0 ) {	// Check bit 0
	  // Class A address, so mask off last 24 bits:
	  dummy[1] = 0;
	  dummy[2] = 0;
	  dummy[3] = 0;
	  tmp.equals( & dummy[0] );
	  return( tmp );
	}
	else {
	  if((addr[0] & 0x02) == 0) {	// Check bit 1
	    // Class B address, so mask off last 16 bits:
	    dummy[2] = 0;
	    dummy[3] = 0;
	    tmp.equals( & dummy[0] );
	    return( tmp );
	  }
	  else {
	    // Class C address, so mask off last 8 bits:
	    dummy[3] = 0;
	    tmp.equals( & dummy[0] );
	    return( tmp );
	  }
	}
}
******/

int
IPAddress::addrclass() const
{
	if( (_addr[0] & 0x01) == 0 ) {		// Check bit 0
	  return( 0 );				// Class A address
	}
	else {
	  if( (_addr[0] & 0x02) == 0 ) {	// Check bit 1
	    return( 1 );			// Class B address
	  }
	  else {
	    return( 2 );			// Class C address
	  }
	}
}

int
IPAddress::operator == ( const IPAddress & compareto ) const
{
	if( compareto.val().val() == this->val().val() )
		return( TRUE );
	else 
		return( FALSE );
}

Boolean
IPAddress::compare( const IPAddress & compareto ) const
{
	if( compareto.val().val() == this->val().val() )
		return( TRUE );
	else 
		return( FALSE );
}

