#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Johnny Zweig (zweig@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

/*
 * ZootReturnCodes.cc 
 *
 */

#include "ZootReturnCodes.h"


#ifdef __GNUC__
#pragma implementation
#endif


// This table needs to be kept consistent with ReturnCodes.h!

const char * Return_Code_Table[] = {
	"OK",
	"ERROR",
	"ERROR_IN_SPECIFICATION",
	"NO_SUCH_ADDRESS",
	"NO_SUCH_CONDUIT",
	"NO_SUCH_DESTINATION",
	"NO_SUCH_MESSAGE",
	"NO_SUCH_CONNECTION",
	"PORT_IN_USE",
	"PROTOCOL_IN_USE",
	"ILLEGAL_PORT",
	"ILLEGAL_OPERATION",
	"TOO_MANY_CONNECTIONS",
	"BUFFER_FULL",
	"CHECKSUM_ERROR",
	"CONNECTION_CLOSING",
	"CONNECTION_RESET",
	"CANNOT_SEND",
	"CANNOT_DELIVER",
	"CANNOT_CONNECT",
	"INVALID_PROTOCOL",
	"INVALID_MESSAGE_TYPE",
	"INVALID_ENCAPSULATION",
	"NOT_TRANSMITTED",
	"INCOMPLETE_ADDRESS",
	"NOT_FOUND",
	"END_OF_THE_WORLD"
};
