#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801-2910
 *
 * Copyright (c) 1990,1991 The University of Illinois Board of Trustees.
 * All Rights Reserved.
 *
 * Author: Amit Parghi (parghi@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

/*
 *	Ethernet.cc
 *
 *	Code for handling ethernet: includes mainly EthernetAddress stuff.
 *
 *
 *	$Id: Ethernet.cc 2 2004-06-03 01:58:28Z jcarlyle $
 *
 * $Log: Ethernet.cc,v $
 * Revision 1.1  2004/06/03 01:58:57  jcarlyle
 * Initial revision
 *
 * Revision 1.2  2004/04/21 22:47:49  dthomas1
 * Compiler fixes
 *   Changed the file to add DLPI support
 * Changed the makefile to reflect changes in vcethernetu
 *
 * Revision 1.1.1.1  2004/03/10 23:02:18  kircher
 *
 *
 * Revision 1.2  1991/12/01  06:00:19  parghi
 * Changed EthernetAddress to subsume JZ's class of the same name.
 * Last revision before networking rewrite.
 *
 * Revision 1.1  91/09/25  16:08:37  parghi
 * Initial revision
 *
 */

//DD SYSIN *


/*
 * Because there is no Address.cc file to create the implementation
 */
#ifdef __GNUC__
#pragma implementation "Address.h"
#pragma implementation "Ethernet.h"
#endif
#include "OutputStream.h"
#include "Ethernet.h"
#include "Byte.h"



#ifdef __GNUC__
#pragma implementation
#endif



EthernetAddress::EthernetAddress()		// initialize to zero
{
    for (int i = 0 ; i < EthernetAddressLength ; i++) {
	_addr[i] = 0;
    }
}

	// These are ifdef'd because Cfront is too stupid to handle them as
	// inlines when called by some of the constructors (that are also
	// inlines -- dumb, dumb, dumb).		// Amit
#ifdef CFRONT
//#if 0
void
EthernetAddress::copyFrom(const octet *source)		// copy from a buffer
{
    for (int i = 0 ; i < EthernetAddressLength ; i++) {
	_addr[i] = *source;
	source++;
    }
}

void
EthernetAddress::copyTo(octet *destination) const
{
    for (int i = 0 ; i < EthernetAddressLength ; i++) {
	*destination = _addr[i];
	destination++;
    }
}
#endif /* CFRONT */

int
EthernetAddress::isEqual(const EthernetAddress &addr2) const
{
if (ByteCompare((void *)_addr, (void *)addr2._addr,EthernetAddressLength) == 0)
	return 1;
else return 0;
}


    int
EthernetAddress::isBroadcast() const	// return non-zero if broadcast address
{
    int i;
    int returnCode = 1;

    for (i = 0 ; (i < EthernetAddressLength) && returnCode ; i++) {
	returnCode = (returnCode && (_addr[i] == 0xff));
    }

    return returnCode;
}

