#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *               University of Illinois at Urbana-Champaign
 *               Department of Computer Science
 *               1304 W. Springfield Ave.
 *               Urbana, IL     61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *      All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Lee Lup Yuen (lup@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
 
#include "ApplicationConduitInputStream.h"
#include "InputStream.h"
#include "CharacterInputStream.h"
#include "CharacterInputStreamStar.h"
#include "ApplicationConduitStream.h"


#ifdef __GNUC__
#pragma implementation
#endif

extern OutputStream *ConsoleOutputStream;

ApplicationConduitInputStream :: ApplicationConduitInputStream
    (ApplicationConduitStream *conduit) : CharacterInputStream
    (ConsoleOutputStream)
{
    conduitStream = conduit;
    conduitStream -> reference ();
}

ApplicationConduitInputStream :: ~ApplicationConduitInputStream ()
{
    conduitStream -> unreference ();
}

int ApplicationConduitInputStream :: read (char *buffer, int count)
{
    return conduitStream -> read (buffer, count);
}

void ApplicationConduitInputStream :: switchCharacterQueue (int type)
{
    conduitStream -> switchCharacterQueue (type);
}

#include "ClassInstaller.h"
DEFINECLASS("ApplicationConduitInputStream",ApplicationConduitInputStream,
CharacterInputStream,0,0);
