#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *               University of Illinois at Urbana-Champaign
 *               Department of Computer Science
 *               1304 W. Springfield Ave.
 *               Urbana, IL     61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *      All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Lee Lup Yuen (lup@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

/*
 * ApplicationConduitOutputStream.cc
 */
 
#include "ApplicationConduitOutputStream.h"
#include "OutputStream.h"
#include "ApplicationConduitStream.h"
#include "Process.h"


#ifdef __GNUC__
#pragma implementation
#endif

ApplicationConduitOutputStream :: ApplicationConduitOutputStream
    (ApplicationConduitStream *conduit)
{
    conduitStream = conduit;
    conduitStream -> reference ();
}

ApplicationConduitOutputStream :: ~ApplicationConduitOutputStream ()
{
    conduitStream -> unreference ();
}

int ApplicationConduitOutputStream :: write (const char *buffer, int count)
{
    //  Ignores return code.
    conduitStream -> write (buffer, count);
    return count;
}

OutputStream &ApplicationConduitOutputStream :: flush ()
{
    //  Ignores return code.
    conduitStream -> flush ();
    return *this;
}

#include "ClassInstaller.h"
DEFINECLASS("ApplicationConduitOutputStream",ApplicationConduitOutputStream,
OutputStream,0,0);
