#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *               University of Illinois at Urbana-Champaign
 *               Department of Computer Science
 *               1304 W. Springfield Ave.
 *               Urbana, IL     61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *      All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Lee Lup Yuen (lup@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

#include "UserSession.h"
#include "UserSessionManager.h"
#include "ApplicationConduitStream.h"
#include "String.h"
#ifdef NOTUSED
#include "RealTimeClock.h"
#endif


#ifdef __GNUC__
#pragma implementation
#endif

extern UserSessionManager *TheUserSessionManager;

UserSession :: UserSession (int sessionType2, ApplicationConduitStream
    *sessionStream2, unsigned char *remoteAddress2)
{
    sessionType = sessionType2;
    sessionStream = sessionStream2;
    for (int i = 0; i <= 3; i++)
    	remoteAddress [i] = remoteAddress2 [i];
#ifdef NOTUSED
    TimeOfDay timer;
    creationTime = timer.getRealTime ();
#else
    creationTime = 0;
#endif
    userName = 0;
    TheUserSessionManager -> add (this);
}

UserSession :: ~UserSession ()
{
    TheUserSessionManager -> remove (this);
    if (userName != 0)
    	delete userName;
}

void UserSession :: setUserName (const char *userName2)
{
    userName = new char [strlen (userName2) + 1];
    strcpy (userName, userName2);
}

char *UserSession :: getUserName ()
{
    return userName;
}

int UserSession :: getSessionType ()
{
    return sessionType;
}

unsigned long UserSession :: getCreationTime ()
{
    return creationTime;
}

unsigned char *UserSession :: getRemoteAddress ()
{
    return remoteAddress;
}

ApplicationConduitStream *UserSession :: getSessionStream ()
{
    return sessionStream;
}

void UserSession :: write (const char *buffer, int count)
{
    if (sessionStream != 0)
    {
    	sessionStream -> write (buffer, count);
	sessionStream -> flush ();
    }
}

void UserSession :: spyOn (ApplicationConduitStream *spyStream)
{
    if (sessionStream != 0)
    {
    	const char msg [] = "(Spy On)";
    	sessionStream -> write (msg, strlen (msg));
	sessionStream -> flush ();
    	sessionStream -> setSpyStream (spyStream);
    }
}

void UserSession :: spyOff ()
{
    if (sessionStream != 0)
    {
    	sessionStream -> setSpyStream (0);
    	const char msg [] = "(Spy Off)";
    	sessionStream -> write (msg, strlen (msg));
	sessionStream -> flush ();
    }
}

#include "ClassInstaller.h"
DEFINECLASS("UserSession", UserSession, ProxiableObject, 0, 0);
