#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 *
 * Copyright (c) 2006
 * The University of Illinois Board of Trustees.
 *  All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Francis David (fdavid@uiuc.edu)
 *
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 */
/*
 * ARMException.cc: exception class stubs.
 */

#include "ARMException.h"
#include "ClassStar.h"


#ifdef __GNUC__
#pragma implementation
#endif

ARMException::ARMException(ARMInterruptContext *context)
    : ProcessorException("Generic ARM Exception")
{
    _context = *context;
    _trace = context->getStackTrace();
}

/**
 * Create an exception with the given message.
 *
 * @param msg Message to describe the exception.
 */
ARMException::ARMException(ARMInterruptContext *context, const char *msg)
    : ProcessorException(msg)
{
    _context = *context;
    _trace = context->getStackTrace();
}

/**
 * Destroy the exception including the message.
 */
ARMException::~ARMException()
{

}

void ARMException::displayContext()
{
    _context.dumpRegisters();
}

void ARMException::displayStackTrace()
{
    _trace.display();
}

#include "ClassInstaller.h"
DEFINECLASS("ARMException",ARMException,Object,0,0);
