/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: David W. Dykstra (dykstra@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */

/*
 * ObjectProxyStubs.s: Machine dependent object proxy interface support.
 */

/*
 * IMPORTANT NOTICE: if any virtual functions are added to or moved around
 *   in Object or ProxiableObject, corresponding changes need to be made to
 *   class ObjectProxy and to every Processor-dependent ObjectProxyStubs.s,
 *   and changes may need to be made to the ObjectProxyCatchTable in
 *   ObjectProxy.h.
 */

/*
 * The ObjectProxy methods trap to the kernel via a long-call through
 * a call-gate.
 */



#define ProxyMethod(methodName,methodNumber)		\
	.globl	methodName;				\
methodName:;						\
	trap	\#0

#ifdef NEGATIVEPROXIES
/*
 * killThisProcess() - a special function called if an application process
 *   returns from its 'main'
 */
	ProxyMethod(killThisProcess,-1)
#endif

/*
 * ObjectProxy::~ObjectProxy()
 */
#ifdef CFRONT
	ProxyMethod(__dt__11ObjectProxyFv,0)
#else
	ProxyMethod(_$_ObjectProxy,0)
#endif

/*
 * Method #1 is "isProxy()" in ObjectProxy.cc
 */

/*
 * unsigned int
 * ObjectProxy::identity()
 */
#ifdef CFRONT
	ProxyMethod(identity__11ObjectProxyFv,2)
#else
	ProxyMethod(identity__11ObjectProxy,2)
#endif

/*
 * int
 * ObjectProxy::isKindOf( Class * )
 */
#ifdef CFRONT
	ProxyMethod(isKindOf__11ObjectProxyFP5Class,3)
#else
	ProxyMethod(isKindOf__11ObjectProxyP5Class,3)
#endif

/*
 * int
 * ObjectProxy::isMemberOf( Class * )
 */
#ifdef CFRONT
	ProxyMethod(isMemberOf__11ObjectProxyFP5Class,4)
#else
	ProxyMethod(isMemberOf__11ObjectProxyP5Class,4)
#endif

/*
 * Should this return a proxy of the class?
 */
/*
 * Class *
 * ObjectProxy::classOf()
 */
#ifdef CFRONT
	ProxyMethod(classOf__11ObjectProxyFv,5)
#else
	ProxyMethod(classOf__11ObjectProxy,5)
#endif

/*
 * int
 * ObjectProxy::debugMask()
 */
#ifdef CFRONT
	ProxyMethod(debugMask__11ObjectProxyFv,6)
#else
	ProxyMethod(debugMask__11ObjectProxy,6)
#endif

/*
 * void
 * ObjectProxy::setDebugMask( unsigned short )
 */
#ifdef CFRONT
	ProxyMethod(setDebugMask__11ObjectProxyFUs,7)
#else
	ProxyMethod(setDebugMask__11ObjectProxyUs,7)
#endif

/*
 * void
 * ObjectProxy::setDebugMessages( short )
 */
#ifdef CFRONT
	ProxyMethod(setDebugMessages__11ObjectProxyFs,8)
#else
	ProxyMethod(setDebugMessages__11ObjectProxys,8)
#endif

/*
 * void
 * ObjectProxy::writeName( OutputStream * )
 */
#ifdef CFRONT
	ProxyMethod(writeName__11ObjectProxyFP12OutputStream,9)
#else
	ProxyMethod(writeName__11ObjectProxyP12OutputStream,9)
#endif

/*
 * void
 * ObjectProxy::inspect( OutputStream * )
 */
#ifdef CFRONT
	ProxyMethod(inspect__11ObjectProxyFP12OutputStream,10)
#else
	ProxyMethod(inspect__11ObjectProxyP12OutputStream,10)
#endif

/*
 * void
 * ObjectProxy::noRemainingReferences()
 */
#ifdef CFRONT
	ProxyMethod(noRemainingReferences__11ObjectProxyFv,11)
#else
	ProxyMethod(noRemainingReferences__11ObjectProxy,11)
#endif

/*
 * void
 * ObjectProxy::reference()
 */
#ifdef CFRONT
	ProxyMethod(reference__11ObjectProxyFv,12)
#else
	ProxyMethod(reference__11ObjectProxy,12)
#endif

/*
 * void
 * ObjectProxy::unreference()
 */
#ifdef CFRONT
	ProxyMethod(unreference__11ObjectProxyFv,13)
#else
	ProxyMethod(unreference__11ObjectProxy,13)
#endif

/*
 * void
 * ObjectProxy::f14() etc....
 */
#ifdef CFRONT
#define StubMethod(methodNumber) \
	ProxyMethod(f##methodNumber##__11ObjectProxyFiN41,methodNumber)
#else
#define StubMethod(methodNumber) \
	ProxyMethod(f##methodNumber##__11ObjectProxyiiiii,methodNumber)
#endif

StubMethod(14)
StubMethod(15)
StubMethod(16)
StubMethod(17)
StubMethod(18)
StubMethod(19)
StubMethod(20)
StubMethod(21)
StubMethod(22)
StubMethod(23)
StubMethod(24)
StubMethod(25)
StubMethod(26)
StubMethod(27)
StubMethod(28)
StubMethod(29)
StubMethod(30)
StubMethod(31)
StubMethod(32)
StubMethod(33)
StubMethod(34)
StubMethod(35)
StubMethod(36)
StubMethod(37)
StubMethod(38)
StubMethod(39)
StubMethod(40)
StubMethod(41)
StubMethod(42)
StubMethod(43)
StubMethod(44)
StubMethod(45)
StubMethod(46)
StubMethod(47)
StubMethod(48)
StubMethod(49)
StubMethod(50)
StubMethod(51)
StubMethod(52)
StubMethod(53)
StubMethod(54)
StubMethod(55)
StubMethod(56)
StubMethod(57)
StubMethod(58)
StubMethod(59)
StubMethod(60)
StubMethod(61)
StubMethod(62)
StubMethod(63)
