#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987-1992
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * SVCTrap.cc: SVC handlers
 */

#include "Assert.h"
#include "NS32332Context.h"
#include "NS32332Interrupts.h"
#include "Process.h"
#include "ThisProcess.h"


#ifdef __GNUC__
#pragma implementation
#endif

#ifdef INSTRUMENT_SVCTRAP
#define Instr(exp) exp
#include "InstrumentManagerSystem.h"
#include "InstrumentEvent.h"
extern SystemInstrumentManager *TheInstrumentManager;

PerCpuTimerInstrument *iSVCTrapBasicRaise = NULL;

void 
SVCTrapConstructInstruments ()
{
	iSVCTrapBasicRaise = new PerCpuTimerInstrument
		(TheInstrumentManager, "SVCTrapBasicRaise", TALKING, 1, ALL);
}

void 
SVCTrapDeleteInstruments ()
{
	delete iSVCTrapBasicRaise;
	iSVCTrapBasicRaise = NULL;
}

#else
#define Instr(exp)
void SVCTrapConstructInstruments () {}
void SVCTrapDeleteInstruments () {}
#endif INSTRUMENT_SVCTRAP


typedef void (*HANDLERTYPE)(char*, Process*);

void
SVCTrap::basicRaise( char * isp )
{
	/*
	 * There's no Choices SVC Handler any more, this is only for
	 *   Unix Compatibility.
	 */

        Process* destinationProcess = thisProcess();

	Instr (iSVCTrapBasicRaise->start ());

	stackFrame * frame = (stackFrame *) isp;

	destinationProcess->SVCHandler( frame );

	Instr (iSVCTrapBasicRaise->stop (SVCTrap_Event));
}
