	.file "i586IntrExcp.s"
	.att_syntax
	.data
	.align 4

	.text
	.align 4
/*
 * Default hook
 */
	.globl CallStrayInterrupt
CallStrayInterrupt:
	pusha
	push	32(%esp)	// re-push the interrupt number so appears as arg
#ifdef CFRONT
	call StrayInterrupt__Fi
#else
	call _Z14StrayInterrupti	//it was _SI
#endif
	add $4, %esp		// "pop" the interrupt number from stack
	popa
	add $4, %esp		// "pop" it again
	iret

/*
 * CallStrayInterruptWithErrorCode is the default hook we use for the 80586
 * processor when we get an unexpected interrupt that has pushed an error
 * code on the stack.
 */
	.globl CallStrayInterruptWithErrorCode
CallStrayInterruptWithErrorCode:
	pusha
	push	36(%esp)     // re-push the error code so it appears as arg
	push	36(%esp)     // re-push the interrupt number so it appears as arg
#ifdef CFRONT
	call StrayInterruptWithErrorCode__FiUi
#else
	call _Z27StrayInterruptWithErrorCodeij   // it was_SI_uSI
#endif
	add $8, %esp	     // "pop" interrupt number & error code from stack
	popa
	add $8, %esp	     // "pop" the interrupt number & error code again
	iret


/*
 * These are the interrupt routines called on the 80586 when we get an
 * interrupt.  They are pointed to by entries in the Interrupt Descriptor
 * Table.  When the 80586 does not push an error code on the stack we push
 * a dummy code of 0 so that the stack always looks the same. Each routine
 * then pushes the interrupt number on the stack and using the appropriate
 * offset for that interrupt jumps to the routine pointed to by InterruptHooks
 * entry.
 */

	.globl Interrupt0
Interrupt0:
	push $0		     // dummy error code 
	push $0
	jmp	*InterruptHooks+0

	.globl Interrupt1
Interrupt1:
	push $0
	push $1
	jmp	*InterruptHooks+4

	.globl Interrupt2
Interrupt2:
	push $0
	push $2
	jmp	*InterruptHooks+8

	.globl Interrupt3
Interrupt3:
	push $0
	push $3
	jmp	*InterruptHooks+12

	.globl Interrupt4
Interrupt4:
	push $0
	push $4
	jmp	*InterruptHooks+16

	.globl Interrupt5
Interrupt5:
	push $0
	push $5
	jmp	*InterruptHooks+20

	.globl Interrupt6
Interrupt6:
	push $0
	push $6
	jmp	*InterruptHooks+24

	.globl Interrupt7
Interrupt7:
	push $0
	push $7
	jmp	*InterruptHooks+28

	.globl Interrupt8
Interrupt8:
	push $8
	jmp	*InterruptHooks+32

	.globl Interrupt9
Interrupt9:
	push $0
	push $9
	jmp	*InterruptHooks+36

	.globl Interrupt10
Interrupt10:
	push $10
	jmp	*InterruptHooks+40

	.globl Interrupt11
Interrupt11:
	push $11
	jmp	*InterruptHooks+44

	.globl Interrupt12
Interrupt12:
	push $12
	jmp	*InterruptHooks+48

	.globl Interrupt13
Interrupt13:
	push $13
	jmp	*InterruptHooks+52

	.globl Interrupt14
Interrupt14:
	push $14
	jmp	*InterruptHooks+56

	.globl Interrupt15
Interrupt15:
	push $0
	push $15
	jmp	*InterruptHooks+60

	.globl Interrupt16
Interrupt16:
	push $0
	push $16
	jmp	*InterruptHooks+64

	.globl Interrupt17
Interrupt17:
	push $0
	push $17
	jmp	*InterruptHooks+68

	.globl Interrupt18
Interrupt18:
	push $0
	push $18
	jmp	*InterruptHooks+72

	.globl Interrupt19
Interrupt19:
	push $0
	push $19
	jmp	*InterruptHooks+76

	.globl Interrupt20
Interrupt20:
	push $0
	push $20
	jmp	*InterruptHooks+80

	.globl Interrupt21
Interrupt21:
	push $0
	push $21
	jmp	*InterruptHooks+84

	.globl Interrupt22
Interrupt22:
	push $0
	push $22
	jmp	*InterruptHooks+88

	.globl Interrupt23
Interrupt23:
	push $0
	push $23
	jmp	*InterruptHooks+92

	.globl Interrupt24
Interrupt24:
	push $0
	push $24
	jmp	*InterruptHooks+96

	.globl Interrupt25
Interrupt25:
	push $0
	push $25
	jmp	*InterruptHooks+100

	.globl Interrupt26
Interrupt26:
	push $0
	push $26
	jmp	*InterruptHooks+104

	.globl Interrupt27
Interrupt27:
	push $0
	push $27
	jmp	*InterruptHooks+108

	.globl Interrupt28
Interrupt28:
	push $0
	push $28
	jmp	*InterruptHooks+112

	.globl Interrupt29
Interrupt29:
	push $0
	push $29
	jmp	*InterruptHooks+116

	.globl Interrupt30
Interrupt30:
	push $0
	push $30
	jmp	*InterruptHooks+120

	.globl Interrupt31
Interrupt31:
	push $0
	push $31
	jmp	*InterruptHooks+124

	.globl Interrupt32
Interrupt32:
	push $0
	push $32
	jmp	*InterruptHooks+128

	.globl Interrupt33
Interrupt33:
	push $0
	push $33
	jmp	*InterruptHooks+132

	.globl Interrupt34
Interrupt34:
	push $0
	push $34
	jmp	*InterruptHooks+136

	.globl Interrupt35
Interrupt35:
	push $0
	push $35
	jmp	*InterruptHooks+140

	.globl Interrupt36
Interrupt36:
	push $0
	push $36
	jmp	*InterruptHooks+144

	.globl Interrupt37
Interrupt37:
	push $0
	push $37
	jmp	*InterruptHooks+148

	.globl Interrupt38
Interrupt38:
	push $0
	push $38
	jmp	*InterruptHooks+152

	.globl Interrupt39
Interrupt39:
	push $0
	push $39
	jmp	*InterruptHooks+156

	.globl Interrupt40
Interrupt40:
	push $0
	push $40
	jmp	*InterruptHooks+160

	.globl Interrupt41
Interrupt41:
	push $0
	push $41
	jmp	*InterruptHooks+164

	.globl Interrupt42
Interrupt42:
	push $0
	push $42
	jmp	*InterruptHooks+168

	.globl Interrupt43
Interrupt43:
	push $0
	push $43
	jmp	*InterruptHooks+172

	.globl Interrupt44
Interrupt44:
	push $0
	push $44
	jmp	*InterruptHooks+176

	.globl Interrupt45
Interrupt45:
	push $0
	push $45
	jmp	*InterruptHooks+180

	.globl Interrupt46
Interrupt46:
	push $0
	push $46
	jmp	*InterruptHooks+184

	.globl Interrupt47
Interrupt47:
	push $0
	push $47
	jmp	*InterruptHooks+188

	.globl Interrupt48
Interrupt48:
	push $0
	push $48
	jmp	*InterruptHooks+192

	.globl Interrupt49
Interrupt49:
	push $0
	push $49
	jmp	*InterruptHooks+196

	.globl Interrupt50
Interrupt50:
	push $0
	push $50
	jmp	*InterruptHooks+200

	.globl Interrupt51
Interrupt51:
	push $0
	push $51
	jmp	*InterruptHooks+204

	.globl Interrupt52
Interrupt52:
	push $0
	push $52
	jmp	*InterruptHooks+208

	.globl Interrupt53
Interrupt53:
	push $0
	push $53
	jmp	*InterruptHooks+212

	.globl Interrupt54
Interrupt54:
	push $0
	push $54
	jmp	*InterruptHooks+216

	.globl Interrupt55
Interrupt55:
	push $0
	push $55
	jmp	*InterruptHooks+220

	.globl Interrupt56
Interrupt56:
	push $0
	push $56
	jmp	*InterruptHooks+224

	.globl Interrupt57
Interrupt57:
	push $0
	push $57
	jmp	*InterruptHooks+228

	.globl Interrupt58
Interrupt58:
	push $0
	push $58
	jmp	*InterruptHooks+232

	.globl Interrupt59
Interrupt59:
	push $0
	push $59
	jmp	*InterruptHooks+236

	.globl Interrupt60
Interrupt60:
	push $0
	push $60
	jmp	*InterruptHooks+240

	.globl Interrupt61
Interrupt61:
	push $0
	push $61
	jmp	*InterruptHooks+244

	.globl Interrupt62
Interrupt62:
	push $0
	push $62
	jmp	*InterruptHooks+248

	.globl Interrupt63
Interrupt63:
	push $0
	push $63
	jmp	*InterruptHooks+252

	.globl Interrupt64
Interrupt64:
	push $0
	push $64
	jmp	*InterruptHooks+256

	.globl Interrupt65
Interrupt65:
	push $0
	push $65
	jmp	*InterruptHooks+260

	.globl Interrupt66
Interrupt66:
	push $0
	push $66
	jmp	*InterruptHooks+264

	.globl Interrupt67
Interrupt67:
	push $0
	push $67
	jmp	*InterruptHooks+268

	.globl Interrupt68
Interrupt68:
	push $0
	push $68
	jmp	*InterruptHooks+272

	.globl Interrupt69
Interrupt69:
	push $0
	push $69
	jmp	*InterruptHooks+276

	.globl Interrupt70
Interrupt70:
	push $0
	push $70
	jmp	*InterruptHooks+280

	.globl Interrupt71
Interrupt71:
	push $0
	push $71
	jmp	*InterruptHooks+284

	.globl Interrupt72
Interrupt72:
	push $0
	push $72
	jmp	*InterruptHooks+288

	.globl Interrupt73
Interrupt73:
	push $0
	push $73
	jmp	*InterruptHooks+292

	.globl Interrupt74
Interrupt74:
	push $0
	push $74
	jmp	*InterruptHooks+296

	.globl Interrupt75
Interrupt75:
	push $0
	push $75
	jmp	*InterruptHooks+300

	.globl Interrupt76
Interrupt76:
	push $0
	push $76
	jmp	*InterruptHooks+304

	.globl Interrupt77
Interrupt77:
	push $0
	push $77
	jmp	*InterruptHooks+308

	.globl Interrupt78
Interrupt78:
	push $0
	push $78
	jmp	*InterruptHooks+312

	.globl Interrupt79
Interrupt79:
	push $0
	push $79
	jmp	*InterruptHooks+316

	.globl Interrupt80
Interrupt80:
	push $0
	push $80
	jmp	*InterruptHooks+320

	.globl Interrupt81
Interrupt81:
	push $0
	push $81
	jmp	*InterruptHooks+324

	.globl Interrupt82
Interrupt82:
	push $0
	push $82
	jmp	*InterruptHooks+328

	.globl Interrupt83
Interrupt83:
	push $0
	push $83
	jmp	*InterruptHooks+332

	.globl Interrupt84
Interrupt84:
	push $0
	push $84
	jmp	*InterruptHooks+336

	.globl Interrupt85
Interrupt85:
	push $0
	push $85
	jmp	*InterruptHooks+340

	.globl Interrupt86
Interrupt86:
	push $0
	push $86
	jmp	*InterruptHooks+344

	.globl Interrupt87
Interrupt87:
	push $0
	push $87
	jmp	*InterruptHooks+348

	.globl Interrupt88
Interrupt88:
	push $0
	push $88
	jmp	*InterruptHooks+352

	.globl Interrupt89
Interrupt89:
	push $0
	push $89
	jmp	*InterruptHooks+356

	.globl Interrupt90
Interrupt90:
	push $0
	push $90
	jmp	*InterruptHooks+360

	.globl Interrupt91
Interrupt91:
	push $0
	push $91
	jmp	*InterruptHooks+364

	.globl Interrupt92
Interrupt92:
	push $0
	push $92
	jmp	*InterruptHooks+368

	.globl Interrupt93
Interrupt93:
	push $0
	push $93
	jmp	*InterruptHooks+372

	.globl Interrupt94
Interrupt94:
	push $0
	push $94
	jmp	*InterruptHooks+376

	.globl Interrupt95
Interrupt95:
	push $0
	push $95
	jmp	*InterruptHooks+380

	.globl Interrupt96
Interrupt96:
	push $0
	push $96
	jmp	*InterruptHooks+384

	.globl Interrupt97
Interrupt97:
	push $0
	push $97
	jmp	*InterruptHooks+388

	.globl Interrupt98
Interrupt98:
	push $0
	push $98
	jmp	*InterruptHooks+392

	.globl Interrupt99
Interrupt99:
	push $0
	push $99
	jmp	*InterruptHooks+396

	.globl Interrupt100
Interrupt100:
	push $0
	push $100
	jmp	*InterruptHooks+400

	.globl Interrupt101
Interrupt101:
	push $0
	push $101
	jmp	*InterruptHooks+404

	.globl Interrupt102
Interrupt102:
	push $0
	push $102
	jmp	*InterruptHooks+408

	.globl Interrupt103
Interrupt103:
	push $0
	push $103
	jmp	*InterruptHooks+412

	.globl Interrupt104
Interrupt104:
	push $0
	push $104
	jmp	*InterruptHooks+416

	.globl Interrupt105
Interrupt105:
	push $0
	push $105
	jmp	*InterruptHooks+420

	.globl Interrupt106
Interrupt106:
	push $0
	push $106
	jmp	*InterruptHooks+424

	.globl Interrupt107
Interrupt107:
	push $0
	push $107
	jmp	*InterruptHooks+428

	.globl Interrupt108
Interrupt108:
	push $0
	push $108
	jmp	*InterruptHooks+432

	.globl Interrupt109
Interrupt109:
	push $0
	push $109
	jmp	*InterruptHooks+436

	.globl Interrupt110
Interrupt110:
	push $0
	push $110
	jmp	*InterruptHooks+440

	.globl Interrupt111
Interrupt111:
	push $0
	push $111
	jmp	*InterruptHooks+444

	.globl Interrupt112
Interrupt112:
	push $0
	push $112
	jmp	*InterruptHooks+448

	.globl Interrupt113
Interrupt113:
	push $0
	push $113
	jmp	*InterruptHooks+452

	.globl Interrupt114
Interrupt114:
	push $0
	push $114
	jmp	*InterruptHooks+456

	.globl Interrupt115
Interrupt115:
	push $0
	push $115
	jmp	*InterruptHooks+460

	.globl Interrupt116
Interrupt116:
	push $0
	push $116
	jmp	*InterruptHooks+464

	.globl Interrupt117
Interrupt117:
	push $0
	push $117
	jmp	*InterruptHooks+468

	.globl Interrupt118
Interrupt118:
	push $0
	push $118
	jmp	*InterruptHooks+472

	.globl Interrupt119
Interrupt119:
	push $0
	push $119
	jmp	*InterruptHooks+476

	.globl Interrupt120
Interrupt120:
	push $0
	push $120
	jmp	*InterruptHooks+480

	.globl Interrupt121
Interrupt121:
	push $0
	push $121
	jmp	*InterruptHooks+484

	.globl Interrupt122
Interrupt122:
	push $0
	push $122
	jmp	*InterruptHooks+488

	.globl Interrupt123
Interrupt123:
	push $0
	push $123
	jmp	*InterruptHooks+492

	.globl Interrupt124
Interrupt124:
	push $0
	push $124
	jmp	*InterruptHooks+496

	.globl Interrupt125
Interrupt125:
	push $0
	push $125
	jmp	*InterruptHooks+500

	.globl Interrupt126
Interrupt126:
	push $0
	push $126
	jmp	*InterruptHooks+504

	.globl Interrupt127
Interrupt127:
	push $0
	push $127
	jmp	*InterruptHooks+508

	.globl Interrupt128
Interrupt128:
	push $0
	push $128
	jmp	*InterruptHooks+512

	.globl Interrupt129
Interrupt129:
	push $0
	push $129
	jmp	*InterruptHooks+516

	.globl Interrupt130
Interrupt130:
	push $0
	push $130
	jmp	*InterruptHooks+520

	.globl Interrupt131
Interrupt131:
	push $0
	push $131
	jmp	*InterruptHooks+524

	.globl Interrupt132
Interrupt132:
	push $0
	push $132
	jmp	*InterruptHooks+528

	.globl Interrupt133
Interrupt133:
	push $0
	push $133
	jmp	*InterruptHooks+532

	.globl Interrupt134
Interrupt134:
	push $0
	push $134
	jmp	*InterruptHooks+536

	.globl Interrupt135
Interrupt135:
	push $0
	push $135
	jmp	*InterruptHooks+540

	.globl Interrupt136
Interrupt136:
	push $0
	push $136
	jmp	*InterruptHooks+544

	.globl Interrupt137
Interrupt137:
	push $0
	push $137
	jmp	*InterruptHooks+548

	.globl Interrupt138
Interrupt138:
	push $0
	push $138
	jmp	*InterruptHooks+552

	.globl Interrupt139
Interrupt139:
	push $0
	push $139
	jmp	*InterruptHooks+556

	.globl Interrupt140
Interrupt140:
	push $0
	push $140
	jmp	*InterruptHooks+560

	.globl Interrupt141
Interrupt141:
	push $0
	push $141
	jmp	*InterruptHooks+564

	.globl Interrupt142
Interrupt142:
	push $0
	push $142
	jmp	*InterruptHooks+568

	.globl Interrupt143
Interrupt143:
	push $0
	push $143
	jmp	*InterruptHooks+572

	.globl Interrupt144
Interrupt144:
	push $0
	push $144
	jmp	*InterruptHooks+576

	.globl Interrupt145
Interrupt145:
	push $0
	push $145
	jmp	*InterruptHooks+580

	.globl Interrupt146
Interrupt146:
	push $0
	push $146
	jmp	*InterruptHooks+584

	.globl Interrupt147
Interrupt147:
	push $0
	push $147
	jmp	*InterruptHooks+588

	.globl Interrupt148
Interrupt148:
	push $0
	push $148
	jmp	*InterruptHooks+592

	.globl Interrupt149
Interrupt149:
	push $0
	push $149
	jmp	*InterruptHooks+596

	.globl Interrupt150
Interrupt150:
	push $0
	push $150
	jmp	*InterruptHooks+600

	.globl Interrupt151
Interrupt151:
	push $0
	push $151
	jmp	*InterruptHooks+604

	.globl Interrupt152
Interrupt152:
	push $0
	push $152
	jmp	*InterruptHooks+608

	.globl Interrupt153
Interrupt153:
	push $0
	push $153
	jmp	*InterruptHooks+612

	.globl Interrupt154
Interrupt154:
	push $0
	push $154
	jmp	*InterruptHooks+616

	.globl Interrupt155
Interrupt155:
	push $0
	push $155
	jmp	*InterruptHooks+620

	.globl Interrupt156
Interrupt156:
	push $0
	push $156
	jmp	*InterruptHooks+624

	.globl Interrupt157
Interrupt157:
	push $0
	push $157
	jmp	*InterruptHooks+628

	.globl Interrupt158
Interrupt158:
	push $0
	push $158
	jmp	*InterruptHooks+632

	.globl Interrupt159
Interrupt159:
	push $0
	push $159
	jmp	*InterruptHooks+636

	.globl Interrupt160
Interrupt160:
	push $0
	push $160
	jmp	*InterruptHooks+640

	.globl Interrupt161
Interrupt161:
	push $0
	push $161
	jmp	*InterruptHooks+644

	.globl Interrupt162
Interrupt162:
	push $0
	push $162
	jmp	*InterruptHooks+648

	.globl Interrupt163
Interrupt163:
	push $0
	push $163
	jmp	*InterruptHooks+652

	.globl Interrupt164
Interrupt164:
	push $0
	push $164
	jmp	*InterruptHooks+656

	.globl Interrupt165
Interrupt165:
	push $0
	push $165
	jmp	*InterruptHooks+660

	.globl Interrupt166
Interrupt166:
	push $0
	push $166
	jmp	*InterruptHooks+664

	.globl Interrupt167
Interrupt167:
	push $0
	push $167
	jmp	*InterruptHooks+668

	.globl Interrupt168
Interrupt168:
	push $0
	push $168
	jmp	*InterruptHooks+672

	.globl Interrupt169
Interrupt169:
	push $0
	push $169
	jmp	*InterruptHooks+676

	.globl Interrupt170
Interrupt170:
	push $0
	push $170
	jmp	*InterruptHooks+680

	.globl Interrupt171
Interrupt171:
	push $0
	push $171
	jmp	*InterruptHooks+684

	.globl Interrupt172
Interrupt172:
	push $0
	push $172
	jmp	*InterruptHooks+688

	.globl Interrupt173
Interrupt173:
	push $0
	push $173
	jmp	*InterruptHooks+692

	.globl Interrupt174
Interrupt174:
	push $0
	push $174
	jmp	*InterruptHooks+696

	.globl Interrupt175
Interrupt175:
	push $0
	push $175
	jmp	*InterruptHooks+700

	.globl Interrupt176
Interrupt176:
	push $0
	push $176
	jmp	*InterruptHooks+704

	.globl Interrupt177
Interrupt177:
	push $0
	push $177
	jmp	*InterruptHooks+708

	.globl Interrupt178
Interrupt178:
	push $0
	push $178
	jmp	*InterruptHooks+712

	.globl Interrupt179
Interrupt179:
	push $0
	push $179
	jmp	*InterruptHooks+716

	.globl Interrupt180
Interrupt180:
	push $0
	push $180
	jmp	*InterruptHooks+720

	.globl Interrupt181
Interrupt181:
	push $0
	push $181
	jmp	*InterruptHooks+724

	.globl Interrupt182
Interrupt182:
	push $0
	push $182
	jmp	*InterruptHooks+728

	.globl Interrupt183
Interrupt183:
	push $0
	push $183
	jmp	*InterruptHooks+732

	.globl Interrupt184
Interrupt184:
	push $0
	push $184
	jmp	*InterruptHooks+736

	.globl Interrupt185
Interrupt185:
	push $0
	push $185
	jmp	*InterruptHooks+740

	.globl Interrupt186
Interrupt186:
	push $0
	push $186
	jmp	*InterruptHooks+744

	.globl Interrupt187
Interrupt187:
	push $0
	push $187
	jmp	*InterruptHooks+748

	.globl Interrupt188
Interrupt188:
	push $0
	push $188
	jmp	*InterruptHooks+752

	.globl Interrupt189
Interrupt189:
	push $0
	push $189
	jmp	*InterruptHooks+756

	.globl Interrupt190
Interrupt190:
	push $0
	push $190
	jmp	*InterruptHooks+760

	.globl Interrupt191
Interrupt191:
	push $0
	push $191
	jmp	*InterruptHooks+764

	.globl Interrupt192
Interrupt192:
	push $0
	push $192
	jmp	*InterruptHooks+768

	.globl Interrupt193
Interrupt193:
	push $0
	push $193
	jmp	*InterruptHooks+772

	.globl Interrupt194
Interrupt194:
	push $0
	push $194
	jmp	*InterruptHooks+776

	.globl Interrupt195
Interrupt195:
	push $0
	push $195
	jmp	*InterruptHooks+780

	.globl Interrupt196
Interrupt196:
	push $0
	push $196
	jmp	*InterruptHooks+784

	.globl Interrupt197
Interrupt197:
	push $0
	push $197
	jmp	*InterruptHooks+788

	.globl Interrupt198
Interrupt198:
	push $0
	push $198
	jmp	*InterruptHooks+792

	.globl Interrupt199
Interrupt199:
	push $0
	push $199
	jmp	*InterruptHooks+796

	.globl Interrupt200
Interrupt200:
	push $0
	push $200
	jmp	*InterruptHooks+800

	.globl Interrupt201
Interrupt201:
	push $0
	push $201
	jmp	*InterruptHooks+804

	.globl Interrupt202
Interrupt202:
	push $0
	push $202
	jmp	*InterruptHooks+808

	.globl Interrupt203
Interrupt203:
	push $0
	push $203
	jmp	*InterruptHooks+812

	.globl Interrupt204
Interrupt204:
	push $0
	push $204
	jmp	*InterruptHooks+816

	.globl Interrupt205
Interrupt205:
	push $0
	push $205
	jmp	*InterruptHooks+820

	.globl Interrupt206
Interrupt206:
	push $0
	push $206
	jmp	*InterruptHooks+824

	.globl Interrupt207
Interrupt207:
	push $0
	push $207
	jmp	*InterruptHooks+828

	.globl Interrupt208
Interrupt208:
	push $0
	push $208
	jmp	*InterruptHooks+832

	.globl Interrupt209
Interrupt209:
	push $0
	push $209
	jmp	*InterruptHooks+836

	.globl Interrupt210
Interrupt210:
	push $0
	push $210
	jmp	*InterruptHooks+840

	.globl Interrupt211
Interrupt211:
	push $0
	push $211
	jmp	*InterruptHooks+844

	.globl Interrupt212
Interrupt212:
	push $0
	push $212
	jmp	*InterruptHooks+848

	.globl Interrupt213
Interrupt213:
	push $0
	push $213
	jmp	*InterruptHooks+852

	.globl Interrupt214
Interrupt214:
	push $0
	push $214
	jmp	*InterruptHooks+856

	.globl Interrupt215
Interrupt215:
	push $0
	push $215
	jmp	*InterruptHooks+860

	.globl Interrupt216
Interrupt216:
	push $0
	push $216
	jmp	*InterruptHooks+864

	.globl Interrupt217
Interrupt217:
	push $0
	push $217
	jmp	*InterruptHooks+868

	.globl Interrupt218
Interrupt218:
	push $0
	push $218
	jmp	*InterruptHooks+872

	.globl Interrupt219
Interrupt219:
	push $0
	push $219
	jmp	*InterruptHooks+876

	.globl Interrupt220
Interrupt220:
	push $0
	push $220
	jmp	*InterruptHooks+880

	.globl Interrupt221
Interrupt221:
	push $0
	push $221
	jmp	*InterruptHooks+884

	.globl Interrupt222
Interrupt222:
	push $0
	push $222
	jmp	*InterruptHooks+888

	.globl Interrupt223
Interrupt223:
	push $0
	push $223
	jmp	*InterruptHooks+892

	.globl Interrupt224
Interrupt224:
	push $0
	push $224
	jmp	*InterruptHooks+896

	.globl Interrupt225
Interrupt225:
	push $0
	push $225
	jmp	*InterruptHooks+900

	.globl Interrupt226
Interrupt226:
	push $0
	push $226
	jmp	*InterruptHooks+904

	.globl Interrupt227
Interrupt227:
	push $0
	push $227
	jmp	*InterruptHooks+908

	.globl Interrupt228
Interrupt228:
	push $0
	push $228
	jmp	*InterruptHooks+912

	.globl Interrupt229
Interrupt229:
	push $0
	push $229
	jmp	*InterruptHooks+916

	.globl Interrupt230
Interrupt230:
	push $0
	push $230
	jmp	*InterruptHooks+920

	.globl Interrupt231
Interrupt231:
	push $0
	push $231
	jmp	*InterruptHooks+924

	.globl Interrupt232
Interrupt232:
	push $0
	push $232
	jmp	*InterruptHooks+928

	.globl Interrupt233
Interrupt233:
	push $0
	push $233
	jmp	*InterruptHooks+932

	.globl Interrupt234
Interrupt234:
	push $0
	push $234
	jmp	*InterruptHooks+936

	.globl Interrupt235
Interrupt235:
	push $0
	push $235
	jmp	*InterruptHooks+940

	.globl Interrupt236
Interrupt236:
	push $0
	push $236
	jmp	*InterruptHooks+944

	.globl Interrupt237
Interrupt237:
	push $0
	push $237
	jmp	*InterruptHooks+948

	.globl Interrupt238
Interrupt238:
	push $0
	push $238
	jmp	*InterruptHooks+952

	.globl Interrupt239
Interrupt239:
	push $0
	push $239
	jmp	*InterruptHooks+956

	.globl Interrupt240
Interrupt240:
	push $0
	push $240
	jmp	*InterruptHooks+960

	.globl Interrupt241
Interrupt241:
	push $0
	push $241
	jmp	*InterruptHooks+964

	.globl Interrupt242
Interrupt242:
	push $0
	push $242
	jmp	*InterruptHooks+968

	.globl Interrupt243
Interrupt243:
	push $0
	push $243
	jmp	*InterruptHooks+972

	.globl Interrupt244
Interrupt244:
	push $0
	push $244
	jmp	*InterruptHooks+976

	.globl Interrupt245
Interrupt245:
	push $0
	push $245
	jmp	*InterruptHooks+980

	.globl Interrupt246
Interrupt246:
	push $0
	push $246
	jmp	*InterruptHooks+984

	.globl Interrupt247
Interrupt247:
	push $0
	push $247
	jmp	*InterruptHooks+988

	.globl Interrupt248
Interrupt248:
	push $0
	push $248
	jmp	*InterruptHooks+992

	.globl Interrupt249
Interrupt249:
	push $0
	push $249
	jmp	*InterruptHooks+996

	.globl Interrupt250
Interrupt250:
	push $0
	push $250
	jmp	*InterruptHooks+1000

	.globl Interrupt251
Interrupt251:
	push $0
	push $251
	jmp	*InterruptHooks+1004

	.globl Interrupt252
Interrupt252:
	push $0
	push $252
	jmp	*InterruptHooks+1008

	.globl Interrupt253
Interrupt253:
	push $0
	push $253
	jmp	*InterruptHooks+1012

	.globl Interrupt254
Interrupt254:
	push $0
	push $254
	jmp	*InterruptHooks+1016

	.globl Interrupt255
Interrupt255:
	push $0
	push $255
	jmp	*InterruptHooks+1020

