#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Gary M. Johnston (johnston@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * RRScheduler.c: A time-slicing round-robin scheduler.
 */

#include "Assert.h"
#include "Debug.h"
#include "RRScheduler.h"
#include "Process.h"


#ifdef __GNUC__
#pragma implementation
#endif

RRScheduler::RRScheduler( int q )
{
	Debug << this << "::RRScheduler( " << q << " usec quantum )\n" <<
		eor;
	Assert( this != 0 );
	quantum = q;
}


Process *
RRScheduler::remove()
{
	/*
	 * Get the next process in the queue.
	 * Return 0 if there's nothing to run.
	 * Set Processes timeslice quantum.
	 * Return process.
	 */
	Process * process = FIFOScheduler::remove();
	if ( process == 0 )
		return ( 0 );
	process->setQuantum( this->quantum );
	return ( process );
}
