#ifdef __GNUC__
#pragma implementation
#endif

/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Author: Gary M. Johnston (johnston@cs.uiuc.edu)
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/*
 * SemaphoreRegulatedFIFOScheduler.c: a toy dispatch queue manager.
 */

#include "Assert.h"
#include "OutputStream.h"
#include "Process.h"
#include "Semaphore.h"
#include "SemaphoreRegulatedFIFOScheduler.h"


#ifdef __GNUC__
#pragma implementation
#endif

SemaphoreRegulatedFIFOScheduler::SemaphoreRegulatedFIFOScheduler()
{
	Debug << this << "::SemaphoreRegulatedFIFOScheduler()\n" << eor;
	Assert( this != 0 );
	semaphore = new Semaphore( 0 );
	semaphore->setName("#SemaphoreRegulatedFIFOSchedulerSemaphore");
}

SemaphoreRegulatedFIFOScheduler::~SemaphoreRegulatedFIFOScheduler()
{
}

void
SemaphoreRegulatedFIFOScheduler::add( Process * process )
{
	Debug << this << "::add( " << process << " )\n" << eor;
	FIFOScheduler::add( process );
	semaphore->V();
	Debug << this << "::add: return\n" << eor;
}

Process *
SemaphoreRegulatedFIFOScheduler::remove()
{
	Debug << this << "::remove()\n" << eor;
	semaphore->P();
	Process * process = FIFOScheduler::remove();
	Debug << this << "::remove: " << process << "\n" << eor;
	return( process );
}
