#!/usr/bin/perl

$cross="arm-none-eabi-";
$seed = 34786;
$debug = 0;
$mode = "loads";

if (@ARGV != 2) {
    print "Usage: ./genaddresses.pl exe name\n";
    exit;
}

$file = $ARGV[0];
$func = $ARGV[1];

$objdump = $cross."objdump";
$input = "$file.dump";
$output = "$file.addresses";

system( "[ -f $input ] || $objdump -d $file > $input" );
open(infile, "$input");
open(outfile, ">$output");

@lines = <infile>;

$state = "Searching";

print "Searching for function $func in $input...";
foreach $line (@lines) 
{
    # Search for and find function specified as argument
    if (($state eq "Searching") && ($line =~ /<_Z..$func.*>:/)) {
        print "found!\nGenerating addresses for instructions of type: $mode...";
        if ($debug == 1) { print "\n"; }
        $state = "Found function";
    }

    if (($state eq "Found function") && ($line == "\n")) {
        $state = "End of function";
        last;
    }

    if ($state eq "Found function") {
        # Do our processing on $line
        if ($mode eq "branches") {
            if ($line =~ /\t(b|bl|bx|bxne)\t/) {
                $line =~ m/^([0-9,a-f]*)/;
                print outfile $1;
                print outfile "\n";
                if ($debug == 1) {
                    print $line,"Wrote: $1\n";
                }
            }
        }

        if ($mode eq "loads") {
            if ($line =~ /\t(ldr|ldm)/) {
                $line =~ m/^([0-9,a-f]*)/;
                print outfile $1;
                print outfile "\n";
                if ($debug == 1) {
                    print $line,"Wrote: $1\n";
                }
            }
        }

        if ($mode eq "stores") {
            if ($line =~ /\t(str|stm)/) {
                $line =~ m/^([0-9,a-f]*)/;
                print outfile $1;
                print outfile "\n";
                if ($debug == 1) {
                    print $line,"Wrote: $1\n";
                }
            }
        }
    }
}

if ($state eq "Searching") {
    print "not found!\n";
} else {
#    print "done!\nOutput is in file $output.\nRandomizing output...";
#    system( "[ -f unsort ] || gcc -o unsort unsort.c" );
#    system( "./unsort -s $seed $output > $output.tmp" );
#    system( "mv $output.tmp $output" );
    print "done!\nOutput is in file $output.\n";
}

close(outfile);
exit;
