#!/bin/sh
#
# Print out the constructors in a .o file.
#   Make a macro call to CONSTRUCT(sym, "name", class, N, len) for each
#	sym - long symbol name of constructor
#	"name" - name to use in NameServer of form ClassConstructorN
#	class - class name of constructor
#	N - constructor number starting from 0 for each class
#	len - length of class name
# Also print out a define NUMCONSTRUCTORS with the number of names.
#
# Dave Dykstra, 4/23/91
#
NM=${NM-nm}

for OFILE
do
    $NM $OFILE

done | awk '
{
    gplusconst = "__" 
    cfrontconst = "__ct__"
    if (index($0,"|") == 0) {
	split($0,A," ")
	sym = A[3]
    }
    else {
	if (index($0,".text") == 0)
	    next
	split($0, A, "|")
	sym = A[1]
    }
    if (index(sym,":") != 0)
	next
    if (substr(sym,1,3) == "___")
	sym = substr(sym,2)
    rest = ""
    if (substr(sym, 1, length(cfrontconst)) == cfrontconst)
	rest = substr(sym, length(cfrontconst)+1)
    else if (substr(sym, 1, length(gplusconst)) == gplusconst)
	rest = substr(sym, length(gplusconst)+1)
    class = ""
    secondchar = substr(rest, 2, 1)
    if (secondchar == "0" || (secondchar >= 1 && secondchar <= 9))
	class = substr(rest, 3, substr(rest, 1, 2))
    else
    {
	firstchar = substr(rest, 1, 1)
	if (firstchar != 0)
	    class = substr(rest, 2, firstchar)
    }
    if (class != "")
    {
	for (i = length(sym); (i > 0) && (substr(sym,i,1) == " "); i--)
	    ;
	sym = substr(sym, 1, i)
	if (class != lastclass)
	{
	    classcount = 0
	    lastclass = class
	}
	else
	    classcount = classcount + 1
	printf("CONSTRUCT(%s,\"%sConstructor%d\",%s,%d,%d)\n", \
			sym,class,classcount,class,classcount,length(class))
	num = num + 1
    }
}
END{
    printf("#define NUMCONSTRUCTORS %d\n",num)
}'
