/*
 * This file is part of the Choices Operating System
 * Developed by: The TAPESTRY Parallel Computing Laboratory
 *		 University of Illinois at Urbana-Champaign
 *		 Department of Computer Science
 *		 1304 W. Springfield Ave.
 *		 Urbana, IL	61801
 *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991
 * The University of Illinois Board of Trustees.
 *	All Rights Reserved.
 * CONFIDENTIAL INFORMATION. Distribution restricted under license agreement.
 *
 * Project Manager and Principal Investigator: Roy Campbell (roy@cs.uiuc.edu)
 *
 * Funded by: NSF TAPESTRY Grant No. 1-5-30035, NASA ICLASS Grant 
 *   No. 1-5-25469 and No. NSG1471 and AT&T Metronet Grant No. 1-5-37411.
 */
/******************************************************************************
 *
 * common.h
 *
 *	This file contains general definitions that may be used by any
 * file in the system.  For consistency it should be included in all files.
 *
 * Ed Loyot 7/12/90
 *
 *
 *              Copyright (c) 1990, 1991
 *              University of Virginia
 *              All Rights Reserved
 *
 *		This software is the property of the University of Virginia.
 *		Permission is granted to copy and distribute this software as
 *		long as this notice is intact on all copies.  Derived works 
 *  		must retain this notice.  This software is provided `as is'
 *		and without any express or implied warrenties.
 *
 *              Send problems & suggestions to:
 *		Ed Loyot (ecl2v@virginia.edu) or
 *              Andrew Grimshaw (grimshaw@cs.virginia.edu)
 *
 *****************************************************************************/


#ifndef COMMON
#define COMMON

#ifdef CFRONT
extern "C" void bcopy(char *, char *, int);
extern "C" void exit(int);
#endif

const int max_message_size = 100;

enum p_boolean {FALSE = 0, TRUE = 1};

extern char message_buffer[100];

#ifndef NULL
#define NULL 0
#endif //NULL

extern char *Me;

#define MAX_PROGRAM_NAME 256

class HeaderDescript {
public:
    HeaderDescript();
    int lowest_level;
    p_boolean include_constructor;
    p_boolean include_stub;
    p_boolean include_table;
    int persistentFlag;
};
 
#endif //COMMON
