#include "tools.h"
#include "iod_32.h"
#include "request.h"
#include <stdio.h>
#include <math.h>
#include <limits.h>

char filter[255];

init_params(argc, argv)
int argc;
char *argv[];
{
  int i;
  if (*argv[1] == '?') {
    printf("%s fd1 fd2 fd3...\nfd1 fd2 fd3... will be filtered out\n",argv[0]);
    exit(0);
  }
  for (i = 1; i < argc; i++) {
    filter[atoi(argv[i])] = 1;
  }
}

main(argc, argv)
int argc;
char *argv[];
{
  int fd;

  struct iod_msg *msgp;

  init_params(argc, argv);
  init_files();
  symtable_init();
  while (read_msg(msgp)) {
#ifdef DEBUG
    dump_iod_msg(msgp);
#endif
    if (field_value(msgp, FIELD_FD, &fd) != TYPE_NULL && filter[fd]) 
      continue;
    write_msg(msgp);
  }
}

static FILE *input_file;
static FILE *output_file;

int init_files()
{
  open_input_file();
  open_output_file();
}
int open_input_file()
{
  input_file = stdin;
}

int open_output_file()
{
  output_file = stdout;
}

int read_msg(msgp)
struct iod_msg *msgp;
{
  return fread((char *) msgp, sizeof(struct iod_msg), 1, input_file);
}

int write_msg(msgp)
struct iod_msg *msgp;
{
  return fwrite((char *) msgp, sizeof(struct iod_msg), 1, output_file);
}

