#include "tools.h"
#include "iod_32.h"
#include "request.h"
#include <stdio.h>

int time_scale;

init_params(argc, argv)
int argc;
char *argv[];
{
  int i;
  if (*argv[1] == '?') {
    printf("%s [time_scale (microsecs)]\n",argv[0]);
    exit(0);
  }
  if (argc == 2) 
    time_scale = atoi(argv[1]);
}

main(argc, argv)
int argc;
char *argv[];
{
  time_type time,last_time;
  struct iod_msg msgp;

  last_time = -1;
  init_params(argc, argv);
  init_files();
  symtable_init();
  while (read_msg(&msgp)) {
    field_value(&msgp, FIELD_TIME, &time);
    if (last_time != -1) {
      printf("%d\n", time_region(time-last_time));
    }
    last_time = time;
  }
  fclose(stdout);
}

static FILE *input_file;
static FILE *output_file;

int init_files()
{
  open_input_file();
  open_output_file();
}
int open_input_file()
{
  input_file = stdin;
}

int open_output_file()
{
  output_file = stdout;
}

int read_msg(msgp)
struct iod_msg *msgp;
{
  return fread((char *) msgp, sizeof(struct iod_msg), 1, input_file);
}

int write_msg(msgp)
struct iod_msg *msgp;
{
  return fwrite((char *) msgp, sizeof(struct iod_msg), 1, input_file);
}

