#include "tools.h"
#include "iod_32.h"
#include "request.h"
#include <stdio.h>
#include <math.h>
#include <limits.h>

#define MAX_MERGE 2

int no_merge;
char *infile[MAX_MERGE];
FILE *in[MAX_MERGE];
int status[MAX_MERGE];
time_type t[MAX_MERGE];
struct iod_msg msgp[MAX_MERGE];

init_params(argc, argv)
int argc;
char *argv[];
{
  int i;
  if (*argv[1] == '?') {
    fprintf(stderr,"%s logfile1 logfile2 ...\n",argv[0]);
    exit(0);
  }
  for (i = 1; i < argc; i++) {
    infile[i-1] = argv[i];
    no_merge = i;
  }
  for (i = 0; i < no_merge; i++) {
    in[i] = fopen(infile[i], "r");
    if (in[i] == NULL) {
      fprintf(stderr,"%s cannot be opened\n", infile[i]);
      exit(1);
    }
  }
}

main(argc, argv)
int argc;
char *argv[];
{
  int i;
  int lowest;
  int done;

  init_params(argc, argv);
  symtable_init();
 
  for (i = 0; i < no_merge; i++) 
    read_msg(i);
  while (1) {
    lowest = 0;
    for (i = 0; i < no_merge; i++) {
    /* fprintf(stderr,"%d\t%d\n",i,t[i]); */
      if (t[i] < t[lowest]) lowest = i;
    }
    /* fprintf(stderr,"lowest %d\t%d\n",lowest,t[lowest]); */
    done = 1;
    for (i = 0; i < no_merge; i++) {
      if (status[i] != 0) {
        done = 0;
        break;
      }
    }
    if (done) break;
    write_msg(lowest);
    for (i = 0; i < no_merge; i++) {
     if (i != lowest && status[i] != 0 && 
         bcmp(&msgp[lowest],&msgp[i],sizeof(struct iod_msg)) == 0) 
       read_msg(i);
    }
    read_msg(lowest);
  }
} 

int read_msg(i)
int i;
{
  if (t[i] == INT_MAX) {
    status[i] = 0;
    return;
  } else
    status[i] = fread((char *) &msgp[i], sizeof(struct iod_msg), 1, in[i]);

  if (status[i] != 0) 
    field_value(&msgp[i], FIELD_TIME, &t[i]);
  else {
    t[i] = INT_MAX;
    fclose(in[i]);
  }
}

int write_msg(i)
int i;
{
  return fwrite((char *) &msgp[i], sizeof(struct iod_msg), 1, stdout);
}

