#include "tools.h"
#include "iod_32.h"
#include "request.h"
#include <stdio.h>
#include <math.h>
#include <limits.h>

int opwriteonly = 0;

init_params(argc, argv)
int argc;
char *argv[];
{
  int i;
  if (*argv[1] == '?') {
    fprintf(stderr,"%s \n",argv[0]);
    exit(0);
  }
  if (argc == 2)
    if (strcmp(argv[1],"-w") == 0)
      opwriteonly = 1;
}

main(argc, argv)
int argc;
char *argv[];
{
  int fd,last_fd;
  int cmd,last_cmd;
  int actual,last_actual;
  int offset,last_offset;
  int length,last_length;
  struct iod_msg msg,last_msg;

  init_params(argc, argv);
  init_files();
  symtable_init();
  if (read_msg(&last_msg) == 0) 
    return;
  while (read_msg(&msg)) {

#   ifdef DEBUG
      dump_iod_msg(&msg);
#   endif

#   define OUTPUT \
        write_msg(&last_msg); \
	bcopy(&msg,&last_msg,sizeof(msg)) 

#   define EXTRACT \
	field_value(&last_msg, FIELD_IO_ACTUAL, &last_actual); \
	field_value(&last_msg, FIELD_IO_OFFSET, &last_offset); \
	field_value(&last_msg, FIELD_IO_LENGTH, &last_length); \
	field_value(&last_msg, FIELD_FD, &last_fd); \
	field_value(&msg, FIELD_IO_ACTUAL, &actual); \
	field_value(&msg, FIELD_IO_OFFSET, &offset); \
	field_value(&msg, FIELD_IO_LENGTH, &length); \
	field_value(&msg, FIELD_FD, &fd)

    field_value(&last_msg, FIELD_CMD, &last_cmd);
    switch (last_cmd) { 
      case IOD_READ:
      case IOD_READA:
      case IOD_READL:
      case IOD_READLA:
      case IOD_READV:
      case IOD_RECV:
      case IOD_RECVMSG:
      case IOD_RECVFROM:
        if (opwriteonly) break;
        field_value(&msg, FIELD_CMD, &cmd);
	if (cmd != last_cmd) break;
	EXTRACT;
        if (fd == last_fd && (last_actual + last_offset) == offset) {
	  last_msg.arg.io_arg.actual+=actual; /* SHOULD USE LIBRARY ROUTINES */
	  last_msg.arg.io_arg.length+=length; /* SHOULD USE LIBRARY ROUTINES */
	  continue;
	}
	break;
      case IOD_WRITE:
      case IOD_WRITEA:
      case IOD_WRITEL:
      case IOD_WRITELA:
      case IOD_WRITEV:
      case IOD_SEND:
      case IOD_SENDMSG:
      case IOD_SENDTO:
        field_value(&msg, FIELD_CMD, &cmd);
	if (cmd != last_cmd) break;
	EXTRACT;
        if (fd == last_fd && (last_actual + last_offset) == offset) {
	  msg.arg.io_arg.actual+=last_actual; /* SHOULD USE LIBRARY ROUTINES */
	  msg.arg.io_arg.offset= last_offset; /* SHOULD USE LIBRARY ROUTINES */
	  msg.arg.io_arg.length+=last_length; /* SHOULD USE LIBRARY ROUTINES */
	  bcopy(&msg,&last_msg,sizeof(msg));
	  continue;
	}
	break;
    }
    OUTPUT;	
  }
  OUTPUT;
}

static FILE *input_file;
static FILE *output_file;

int init_files()
{
  open_input_file();
  open_output_file();
}
int open_input_file()
{
  input_file = stdin;
}

int open_output_file()
{
  output_file = stdout;
}

int read_msg(msgp)
struct iod_msg *msgp;
{
  return fread((char *) msgp, sizeof(struct iod_msg), 1, input_file);
}

int write_msg(msgp)
struct iod_msg *msgp;
{
  return fwrite((char *) msgp, sizeof(struct iod_msg), 1, output_file);
}

