#include "tools.h"
#include "iod_32.h"
#include "request.h"
#include <stdio.h>
#include <math.h>
#include <limits.h>

init_params(argc, argv)
int argc;
char *argv[];
{
  int i;
  if (*argv[1] == '?') {
    printf("%s exec1 exec2 ...\nexec1 exec2 ... will be selected\n",argv[0]);
    exit(0);
  }
}

main(argc, argv)
int argc;
char *argv[];
{
  int cmd,type,output,i;
  char name[40];

  struct iod_msg msg;

  output = 0;
  init_params(argc, argv);
  init_files();
  symtable_init();
  while (read_msg(&msg)) {
#ifdef DEBUG
    dump_iod_msg(&msg);
#endif
    type = field_value(&msg, FIELD_CMD, cmd);
    if (cmd == IOD_NINITIATE) {
      output = 0;
      type = field_value(&msg, FIELD_PROGNAME, name);
      for (i = 1; i < argc;i++)
        if (strcmp(name,argv[i]) == 0) output = 1;
    }
    if (output) write_msg(&msg);
  }
}

static FILE *input_file;
static FILE *output_file;

int init_files()
{
  open_input_file();
  open_output_file();
}
int open_input_file()
{
  input_file = stdin;
}

int open_output_file()
{
  output_file = stdout;
}

int read_msg(msgp)
struct iod_msg *msgp;
{
  return fread((char *) msgp, sizeof(struct iod_msg), 1, input_file);
}

int write_msg(msgp)
struct iod_msg *msgp;
{
  return fwrite((char *) msgp, sizeof(struct iod_msg), 1, output_file);
}

