#include "tools.h"
#include "iod_32.h"
#include "request.h"
#include <stdio.h>
#include <math.h>
#include <limits.h>

char select[255];

init_params(argc, argv)
int argc;
char *argv[];
{
  int i;
  if (*argv[1] == '?') {
    printf("%s fd1 fd2 fd3...\nfd1 fd2 fd3... will be selected\n",argv[0]);
    exit(0);
  }
  for (i = 1; i < argc; i++) {
    select[atoi(argv[i])] = 1;
  }
}

main(argc, argv)
int argc;
char *argv[];
{
  int fd,type;

  struct iod_msg msg;

  init_params(argc, argv);
  init_files();
  symtable_init();
  while (read_msg(&msg)) {
#ifdef DEBUG
    dump_iod_msg(&msg);
#endif
    type = field_value(&msg, FIELD_FD, &fd);
    if ((type == TYPE_NULL && select[255]) || (type != TYPE_NULL && select[fd]))
      write_msg(&msg);
  }
}

static FILE *input_file;
static FILE *output_file;

int init_files()
{
  open_input_file();
  open_output_file();
}
int open_input_file()
{
  input_file = stdin;
}

int open_output_file()
{
  output_file = stdout;
}

int read_msg(msgp)
struct iod_msg *msgp;
{
  return fread((char *) msgp, sizeof(struct iod_msg), 1, input_file);
}

int write_msg(msgp)
struct iod_msg *msgp;
{
  return fwrite((char *) msgp, sizeof(struct iod_msg), 1, output_file);
}

