#include "tools.h"
#include "iod_32.h"
#include "request.h"
#include <stdio.h>
#include <math.h>
#include <limits.h>

int wanted_fd = 0;
int wanted_seq = 0;
int current_seq = 0;

char select[255];

init_params(argc, argv)
int argc;
char *argv[];
{
  int i;
  if (argc > 3 || *argv[1] == '?') {
    printf("%s fd1 seq\n",argv[0]);
    exit(0);
  }
  wanted_fd = atoi(argv[1]);
  if (argc == 3)
    wanted_seq = atoi(argv[2]);
  if (wanted_fd < 3) 
    current_seq = 0;
  else
    current_seq = -1;
}

main(argc,argv)
int argc;
char *argv[];
{
  int fd;
  int cmd;

  struct iod_msg msg;

  init_params(argc, argv);
  init_files();
  symtable_init();
  while (read_msg(&msg)) {
    if (field_value(&msg, FIELD_FD, &fd) == TYPE_NULL) 
      continue;
    field_value(&msg, FIELD_CMD, &cmd);
    if ((cmd == IOD_OPEN || cmd == IOD_SOCKET) && fd == wanted_fd)
      current_seq++;
    if (current_seq == wanted_seq && fd == wanted_fd)
      write_msg(&msg);
  }
}

static FILE *input_file;
static FILE *output_file;

int init_files()
{
  open_input_file();
  open_output_file();
}
int open_input_file()
{
  input_file = stdin;
}

int open_output_file()
{
  output_file = stdout;
}

int read_msg(msgp)
struct iod_msg *msgp;
{
  return fread((char *) msgp, sizeof(struct iod_msg), 1, input_file);
}

int write_msg(msgp)
struct iod_msg *msgp;
{
  return fwrite((char *) msgp, sizeof(struct iod_msg), 1, output_file);
}

