#include "tools.h"
#include "iod_32.h"
#include "request.h"
#include <stdio.h>
#include <math.h>
#include <limits.h>

int pid[100];
int no_pids;

init_params(argc, argv)
int argc;
char *argv[];
{
  int i;
  if (argc == 1 || *argv[1] == '?') {
    printf("%s process_id's\n",argv[0]);
    exit(0);
  }
  no_pids = 0;
  for (i = 1; i < argc; i++) {
    pid[i-1] = atoi(argv[i]);
    no_pids++;
  }
}

main(argc, argv)
int argc;
char *argv[];
{
  int curpid,i;

  struct iod_msg msg;

  init_params(argc, argv);
  init_files();
  symtable_init();
  while (read_msg(&msg)) {
#ifdef DEBUG
    dump_iod_msg(&msg);
#endif
    field_value(&msg, FIELD_PID, &curpid);
    for (i = 0; i < no_pids; i++) {
      if (curpid == pid[i]) {
	write_msg(&msg);
        if (msg.cmd == IOD_EXIT) fflush(stdout);
        break;
      }
    }
  }
}

static FILE *input_file;
static FILE *output_file;

int init_files()
{
  open_input_file();
  open_output_file();
}
int open_input_file()
{
  input_file = stdin;
}

int open_output_file()
{
  output_file = stdout;
}

int read_msg(msgp)
struct iod_msg *msgp;
{
  return fread((char *) msgp, sizeof(struct iod_msg), 1, input_file);
}

int write_msg(msgp)
struct iod_msg *msgp;
{
  return fwrite((char *) msgp, sizeof(struct iod_msg), 1, output_file);
}

