#include <stdio.h>

#define INPUT 0 
#define OUTPUT 1

char childMessage[20] = "Hello parent\n";
char parentMessage[20] = "Hello child\n";

int count;
int parentToChild[2];
int childToParent[2];

void child()
{
	int i;
	int bytes;
	char buf[20];

	close(parentToChild[1]);
	close(childToParent[0]);
	for (i = 0; i < count; i++ ) {
		printf("%2d: waiting for parent\n", i);
		bytes = read( parentToChild[0], buf, 20 );
		printf("%2d: message from parent %s (bytes %d)\n", 
		       i, buf, bytes);
		printf("%2d: child sending\n", i);
		bytes = write( childToParent[1], childMessage, 20 );
		printf("%2d: child send %d bytes\n", i, bytes);
	}
	close(parentToChild[0]);
	close(childToParent[1]);
}

void parent()
{
	int i;
	int bytes;
	char buf[20];

	close(parentToChild[0]);
	close(childToParent[1]);
	for (i = 0; i < count; i++ ) {
		printf("%2d: parent sending\n", i);
		bytes = write( parentToChild[1], parentMessage, 20 );
		printf("%2d: parent send %d bytes\n", i, bytes);
		printf("%2d: waiting for child\n", i);
		bytes = read( childToParent[0], buf, 20 );
		printf("%2d: message from child %s (bytes %d)\n", 
		       i, buf, bytes);
	}
	close(parentToChild[1]);
	close(childToParent[0]);
}

int main(int argc, char *argv[])
{
	int forkStatus;
	int status;

	count = 1;
	if (argc >= 2) {
		count = atoi( argv[1] );
		if (count == 0) count = 1;
	}

	pipe( parentToChild );
	pipe( childToParent );

	forkStatus = fork();
	if ( forkStatus == -1 ) {
		fprintf(stderr, "fork error\n");
		exit(1);
	}
	if ( forkStatus == 0 ) {
		child();
	} else {
		parent();
	}
	return 0;
}
