#ifndef tools_h

#define tools_h

/* 
   if field is added,
   (a) update the DEFINES
   (b) sizeof_all_fields
   (c) extern int all_fields (fields.c)
   (d) field_types (fields.c)
*/

#define FIELD_BASE	2000
#define FIELD_PID 	2000
#define FIELD_CMD	2001
#define FIELD_USERNAME  2002
#define FIELD_PROGNAME  2003
#define FIELD_NAME   	2004
#define FIELD_FD	2005
#define FIELD_DUP_FD	2006
#define FIELD_IO_ACTUAL	2007
#define FIELD_IO_LENGTH 2008
#define FIELD_IO_OFFSET 2009
#define FIELD_IOCTL	2010
#define FIELD_SOC_AF	2011
#define FIELD_SOC_PROTO	2012
#define FIELD_SOC_TYPE	2013
#define FIELD_SHUTDOWN	2014
#define FIELD_ACCEPT_FD	2015
#define FIELD_LISTEN	2016
#define FIELD_FORK_PID	2017
#define FIELD_CLASS	2018
#define FIELD_TIME	2019
#define FIELD_STIME	2020
#define FIELD_FCNTL_CMD 2021
#define FIELD_FCNTL_ARG 2022
#define FIELD_FCNTL_STATUS 2023
#define FIELD_WAIT_RESULT 2024
#define FIELD_WAIT_PID 2025
#define FIELD_WAIT_STATUS 2026
#define FIELD_WAIT_OPTIONS 2027

#define sizeof_all_fields 24
extern int all_fields[];

#define CLASS_BASE		3000
#define CLASS_NINIT		3000
#define CLASS_FORK		3001
#define CLASS_FD		3002
#define CLASS_FD_AND_NAME	3003
#define CLASS_EXIT		3004
#define CLASS_DUP		3005
#define CLASS_IOCTL		3006
#define CLASS_SOCKET		3007
#define CLASS_ACCEPT		3008
#define CLASS_LISTEN		3009
#define CLASS_SHUTDOWN		3010
#define CLASS_RESERVED		3011
#define CLASS_IO_ASYNC		3012
#define CLASS_IO_SYNC		3013
#define CLASS_FCNTL		3014
#define CLASS_WAIT		3015

#define TYPE_NULL	0
#define TYPE_INT	4000
#define TYPE_STR	4001
#define TYPE_SYMBOL	4002
#define TYPE_TIME	4003

#endif tools_h
